require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_GENERIC_LOCAL_H)) {
    eval 'sub _ASM_GENERIC_LOCAL_H () {1;}' unless defined(&_ASM_GENERIC_LOCAL_H);
    require 'linux/percpu.ph';
    require 'linux/hardirq.ph';
    require 'asm/atomic.ph';
    require 'asm/types.ph';
    eval 'sub LOCAL_INIT {
        my($i) = @_;
	    eval q({  &ATOMIC_LONG_INIT($i) });
    }' unless defined(&LOCAL_INIT);
    eval 'sub local_read {
        my($l) = @_;
	    eval q( &atomic_long_read(($l)-> &a));
    }' unless defined(&local_read);
    eval 'sub local_set {
        my($l,$i) = @_;
	    eval q( &atomic_long_set((($l)-> &a),($i)));
    }' unless defined(&local_set);
    eval 'sub local_inc {
        my($l) = @_;
	    eval q( &atomic_long_inc(($l)-> &a));
    }' unless defined(&local_inc);
    eval 'sub local_dec {
        my($l) = @_;
	    eval q( &atomic_long_dec(($l)-> &a));
    }' unless defined(&local_dec);
    eval 'sub local_add {
        my($i,$l) = @_;
	    eval q( &atomic_long_add(($i),(($l)-> &a)));
    }' unless defined(&local_add);
    eval 'sub local_sub {
        my($i,$l) = @_;
	    eval q( &atomic_long_sub(($i),(($l)-> &a)));
    }' unless defined(&local_sub);
    eval 'sub local_sub_and_test {
        my($i, $l) = @_;
	    eval q( &atomic_long_sub_and_test(($i), (($l)-> &a)));
    }' unless defined(&local_sub_and_test);
    eval 'sub local_dec_and_test {
        my($l) = @_;
	    eval q( &atomic_long_dec_and_test(($l)-> &a));
    }' unless defined(&local_dec_and_test);
    eval 'sub local_inc_and_test {
        my($l) = @_;
	    eval q( &atomic_long_inc_and_test(($l)-> &a));
    }' unless defined(&local_inc_and_test);
    eval 'sub local_add_negative {
        my($i, $l) = @_;
	    eval q( &atomic_long_add_negative(($i), (($l)-> &a)));
    }' unless defined(&local_add_negative);
    eval 'sub local_add_return {
        my($i, $l) = @_;
	    eval q( &atomic_long_add_return(($i), (($l)-> &a)));
    }' unless defined(&local_add_return);
    eval 'sub local_sub_return {
        my($i, $l) = @_;
	    eval q( &atomic_long_sub_return(($i), (($l)-> &a)));
    }' unless defined(&local_sub_return);
    eval 'sub local_inc_return {
        my($l) = @_;
	    eval q( &atomic_long_inc_return(($l)-> &a));
    }' unless defined(&local_inc_return);
    eval 'sub local_cmpxchg {
        my($l, $o, $n) = @_;
	    eval q( &atomic_long_cmpxchg((($l)-> &a), ($o), ($n)));
    }' unless defined(&local_cmpxchg);
    eval 'sub local_xchg {
        my($l, $n) = @_;
	    eval q( &atomic_long_xchg((($l)-> &a), ($n)));
    }' unless defined(&local_xchg);
    eval 'sub local_add_unless {
        my($l, $a, $u) = @_;
	    eval q( &atomic_long_add_unless((($l)->$a), ($a), ($u)));
    }' unless defined(&local_add_unless);
    eval 'sub local_inc_not_zero {
        my($l) = @_;
	    eval q( &atomic_long_inc_not_zero(($l)-> &a));
    }' unless defined(&local_inc_not_zero);
    eval 'sub __local_inc {
        my($l) = @_;
	    eval q( &local_set(($l),  &local_read($l) + 1));
    }' unless defined(&__local_inc);
    eval 'sub __local_dec {
        my($l) = @_;
	    eval q( &local_set(($l),  &local_read($l) - 1));
    }' unless defined(&__local_dec);
    eval 'sub __local_add {
        my($i,$l) = @_;
	    eval q( &local_set(($l),  &local_read($l) + ($i)));
    }' unless defined(&__local_add);
    eval 'sub __local_sub {
        my($i,$l) = @_;
	    eval q( &local_set(($l),  &local_read($l) - ($i)));
    }' unless defined(&__local_sub);
    eval 'sub cpu_local_read {
        my($l) = @_;
	    eval q( &local_read(& &__get_cpu_var($l)));
    }' unless defined(&cpu_local_read);
    eval 'sub cpu_local_set {
        my($l, $i) = @_;
	    eval q( &local_set(& &__get_cpu_var($l), ($i)));
    }' unless defined(&cpu_local_set);
    eval 'sub cpu_local_inc {
        my($l) = @_;
	    eval q( &local_inc(& &__get_cpu_var($l)));
    }' unless defined(&cpu_local_inc);
    eval 'sub cpu_local_dec {
        my($l) = @_;
	    eval q( &local_dec(& &__get_cpu_var($l)));
    }' unless defined(&cpu_local_dec);
    eval 'sub cpu_local_add {
        my($i, $l) = @_;
	    eval q( &local_add(($i), & &__get_cpu_var($l)));
    }' unless defined(&cpu_local_add);
    eval 'sub cpu_local_sub {
        my($i, $l) = @_;
	    eval q( &local_sub(($i), & &__get_cpu_var($l)));
    }' unless defined(&cpu_local_sub);
    eval 'sub __cpu_local_inc {
        my($l) = @_;
	    eval q( &__local_inc(& &__get_cpu_var($l)));
    }' unless defined(&__cpu_local_inc);
    eval 'sub __cpu_local_dec {
        my($l) = @_;
	    eval q( &__local_dec(& &__get_cpu_var($l)));
    }' unless defined(&__cpu_local_dec);
    eval 'sub __cpu_local_add {
        my($i, $l) = @_;
	    eval q( &__local_add(($i), & &__get_cpu_var($l)));
    }' unless defined(&__cpu_local_add);
    eval 'sub __cpu_local_sub {
        my($i, $l) = @_;
	    eval q( &__local_sub(($i), & &__get_cpu_var($l)));
    }' unless defined(&__cpu_local_sub);
}
1;
