require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_GENERIC_PERCPU_H_)) {
    eval 'sub _ASM_GENERIC_PERCPU_H_ () {1;}' unless defined(&_ASM_GENERIC_PERCPU_H_);
    require 'linux/compiler.ph';
    require 'linux/threads.ph';
    eval 'sub per_cpu_var {
        my($var) = @_;
	    eval q( &per_cpu__$var);
    }' unless defined(&per_cpu_var);
    if(defined(&CONFIG_SMP)) {
	unless(defined(&__per_cpu_offset)) {
	    eval 'sub per_cpu_offset {
	        my($x) = @_;
    		eval q(( $__per_cpu_offset[$x]));
	    }' unless defined(&per_cpu_offset);
	}
	unless(defined(&__my_cpu_offset)) {
	    eval 'sub __my_cpu_offset () { &per_cpu_offset( &raw_smp_processor_id());}' unless defined(&__my_cpu_offset);
	}
	if(defined(&CONFIG_DEBUG_PREEMPT)) {
	    eval 'sub my_cpu_offset () { &per_cpu_offset( &smp_processor_id());}' unless defined(&my_cpu_offset);
	} else {
	    eval 'sub my_cpu_offset () { &__my_cpu_offset;}' unless defined(&my_cpu_offset);
	}
	unless(defined(&SHIFT_PERCPU_PTR)) {
	    eval 'sub SHIFT_PERCPU_PTR {
	        my($__p, $__offset) = @_;
    		eval q( &RELOC_HIDE(($__p), ($__offset)));
	    }' unless defined(&SHIFT_PERCPU_PTR);
	}
	eval 'sub per_cpu {
	    my($var, $cpu) = @_;
    	    eval q((* &SHIFT_PERCPU_PTR( &per_cpu_var($var),  &per_cpu_offset($cpu))));
	}' unless defined(&per_cpu);
	eval 'sub __get_cpu_var {
	    my($var) = @_;
    	    eval q((* &SHIFT_PERCPU_PTR( &per_cpu_var($var),  &my_cpu_offset)));
	}' unless defined(&__get_cpu_var);
	eval 'sub __raw_get_cpu_var {
	    my($var) = @_;
    	    eval q((* &SHIFT_PERCPU_PTR( &per_cpu_var($var),  &__my_cpu_offset)));
	}' unless defined(&__raw_get_cpu_var);
	if(defined(&CONFIG_HAVE_SETUP_PER_CPU_AREA)) {
	}
    } else {
	eval 'sub per_cpu {
	    my($var, $cpu) = @_;
    	    eval q((*(( &void)($cpu),  &per_cpu_var($var))));
	}' unless defined(&per_cpu);
	eval 'sub __get_cpu_var {
	    my($var) = @_;
    	    eval q( &per_cpu_var($var));
	}' unless defined(&__get_cpu_var);
	eval 'sub __raw_get_cpu_var {
	    my($var) = @_;
    	    eval q( &per_cpu_var($var));
	}' unless defined(&__raw_get_cpu_var);
    }
    unless(defined(&PER_CPU_ATTRIBUTES)) {
	eval 'sub PER_CPU_ATTRIBUTES () {1;}' unless defined(&PER_CPU_ATTRIBUTES);
    }
    eval 'sub DECLARE_PER_CPU {
        my($type, $name) = @_;
	    eval q( &extern  &PER_CPU_ATTRIBUTES  &__typeof__($type)  &per_cpu_var($name));
    }' unless defined(&DECLARE_PER_CPU);
}
1;
