require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_APIC_H)) {
    eval 'sub _ASM_X86_APIC_H () {1;}' unless defined(&_ASM_X86_APIC_H);
    require 'linux/pm.ph';
    require 'linux/delay.ph';
    require 'asm/alternative.ph';
    require 'asm/fixmap.ph';
    require 'asm/apicdef.ph';
    require 'asm/processor.ph';
    require 'asm/system.ph';
    eval 'sub ARCH_APICTIMER_STOPS_ON_C3 () {1;}' unless defined(&ARCH_APICTIMER_STOPS_ON_C3);
    eval 'sub APIC_QUIET () {0;}' unless defined(&APIC_QUIET);
    eval 'sub APIC_VERBOSE () {1;}' unless defined(&APIC_VERBOSE);
    eval 'sub APIC_DEBUG () {2;}' unless defined(&APIC_DEBUG);
    eval 'sub apic_printk () {( &v,  &s,  &a...)  &do {  &if (( &v) <=  &apic_verbosity)  &printk( &s,  &a); }  &while (0);}' unless defined(&apic_printk);
    if(defined(&CONFIG_X86_LOCAL_APIC)) {
	if(defined(&CONFIG_PARAVIRT)) {
	    require 'asm/paravirt.ph';
	} else {
	    eval 'sub apic_write () { &native_apic_write;}' unless defined(&apic_write);
	    eval 'sub apic_read () { &native_apic_read;}' unless defined(&apic_read);
	    eval 'sub setup_boot_clock () { &setup_boot_APIC_clock;}' unless defined(&setup_boot_clock);
	    eval 'sub setup_secondary_clock () { &setup_secondary_APIC_clock;}' unless defined(&setup_secondary_clock);
	}
	eval 'sub native_apic_write {
	    my($reg,$v) = @_;
    	    eval q({  &volatile  &u32 * &addr = ( &volatile  &u32 *)( &APIC_BASE + $reg);  &alternative_io(\\"movl %0, %1\\", \\"xchgl %0, %1\\",  &X86_FEATURE_11AP,  &ASM_OUTPUT2(\\"=r\\" ($v), \\"=m\\" (* &addr)),  &ASM_OUTPUT2(\\"0\\" ($v), \\"m\\" (* &addr))); });
	}' unless defined(&native_apic_write);
	eval 'sub native_apic_read {
	    my($reg) = @_;
    	    eval q({ *(( &volatile  &u32 *)( &APIC_BASE + $reg)); });
	}' unless defined(&native_apic_read);
	eval 'sub ack_APIC_irq {
	    my($void) = @_;
    	    eval q({  &apic_write( &APIC_EOI, 0); });
	}' unless defined(&ack_APIC_irq);
	if(defined(&CONFIG_X86_64)) {
	} else {
	    eval 'sub apic_is_clustered_box {
	        my($void) = @_;
    		eval q({ 0; });
	    }' unless defined(&apic_is_clustered_box);
	}
    } else {
	eval 'sub local_apic_timer_c2_ok () {1;}' unless defined(&local_apic_timer_c2_ok);
    }
}
1;
