require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_BITOPS_H)) {
    eval 'sub _ASM_X86_BITOPS_H () {1;}' unless defined(&_ASM_X86_BITOPS_H);
    unless(defined(&_LINUX_BITOPS_H)) {
	die("only\ \<linux\/bitops\.h\>\ can\ be\ included\ directly");
    }
    require 'linux/compiler.ph';
    require 'asm/alternative.ph';
    if((defined(&__GNUC__) ? &__GNUC__ : undef) < 4|| ((defined(&__GNUC__) ? &__GNUC__ : undef) == 4 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) < 1)) {
	eval 'sub BITOP_ADDR {
	    my($x) = @_;
    	    eval q(\\"=m\\" (*( &volatile \'long\' *) ($x)));
	}' unless defined(&BITOP_ADDR);
    } else {
	eval 'sub BITOP_ADDR {
	    my($x) = @_;
    	    eval q(\\"+m\\" (*( &volatile \'long\' *) ($x)));
	}' unless defined(&BITOP_ADDR);
    }
    eval 'sub ADDR () { &BITOP_ADDR( &addr);}' unless defined(&ADDR);
    eval 'sub IS_IMMEDIATE {
        my($nr) = @_;
	    eval q(( &__builtin_constant_p($nr)));
    }' unless defined(&IS_IMMEDIATE);
    eval 'sub CONST_MASK_ADDR {
        my($nr, $addr) = @_;
	    eval q( &BITOP_ADDR(( &void *)($addr) + (($nr)>>3)));
    }' unless defined(&CONST_MASK_ADDR);
    eval 'sub CONST_MASK {
        my($nr) = @_;
	    eval q((1<< (($nr) & 7)));
    }' unless defined(&CONST_MASK);
    eval 'sub __clear_bit {
        my($nr,$addr) = @_;
	    eval q({  &asm  &volatile(\\"btr %1,%0\\" :  &ADDR : \\"Ir\\" ($nr)); });
    }' unless defined(&__clear_bit);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub constant_test_bit {
        my($nr,$addr) = @_;
	    eval q({ ((1 << ($nr %  &BITS_PER_LONG)) & (($addr)[$nr /  &BITS_PER_LONG])) != 0; });
    }' unless defined(&constant_test_bit);
    eval 'sub variable_test_bit {
        my($nr,$addr) = @_;
	    eval q({ \'int\'  &oldbit;  &asm  &volatile(\\"bt %2,%1\\\\n\\\\t\\" \\"sbb %0,%0\\" : \\"=r\\" : \\"m\\" (*$addr), \\"Ir\\" ($nr));  &oldbit; });
    }' unless defined(&variable_test_bit);
    if(0) {
    }
    eval 'sub test_bit {
        my($nr, $addr) = @_;
	    eval q(( &__builtin_constant_p(($nr)) ?  &constant_test_bit(($nr), ($addr)) :  &variable_test_bit(($nr), ($addr))));
    }' unless defined(&test_bit);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_X86_CMOV)) {
	} else {
	}
	if(defined(&CONFIG_X86_CMOV)) {
	} else {
	}
    }
    undef(&ADDR) if defined(&ADDR);
    eval 'sub set_bit_string {
        my($bitmap,$i,$len) = @_;
	    eval q({ my $end = $i + $len;  &while ($i <  $end) {  &__set_bit($i, $bitmap); $i++; } });
    }' unless defined(&set_bit_string);
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/sched.ph';
	eval 'sub ARCH_HAS_FAST_MULTIPLIER () {1;}' unless defined(&ARCH_HAS_FAST_MULTIPLIER);
	require 'asm-generic/bitops/hweight.ph';
    }
    require 'asm-generic/bitops/fls64.ph';
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/ext2-non-atomic.ph';
	eval 'sub ext2_set_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q( &test_and_set_bit(, ($addr)));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q( &test_and_clear_bit(, ($addr)));
	}' unless defined(&ext2_clear_bit_atomic);
	require 'asm-generic/bitops/minix.ph';
    }
}
1;
