require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_DMA_MAPPING_H_)) {
    eval 'sub _ASM_DMA_MAPPING_H_ () {1;}' unless defined(&_ASM_DMA_MAPPING_H_);
    require 'linux/scatterlist.ph';
    require 'asm/io.ph';
    require 'asm/swiotlb.ph';
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub dma_mapping_ops {
        eval q(* &get_dma_ops(\'struct device\' * &dev) { });
    }' unless defined(&dma_mapping_ops);
    if(defined(&CONFIG_X86_32)) {
    } else {
    }
    eval 'sub dma_alloc_noncoherent {
        my($d, $s, $h, $f) = @_;
	    eval q( &dma_alloc_coherent($d, $s, $h, $f));
    }' unless defined(&dma_alloc_noncoherent);
    eval 'sub dma_free_noncoherent {
        my($d, $s, $v, $h) = @_;
	    eval q( &dma_free_coherent($d, $s, $v, $h));
    }' unless defined(&dma_free_noncoherent);
    eval 'sub dma_map_single {
        my($hwdev,$ptr,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  ($ops->{map_single})($hwdev,  &virt_to_phys($ptr), $size, $direction); });
    }' unless defined(&dma_map_single);
    eval 'sub dma_unmap_single {
        my($dev,$addr,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($dev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{unmap_single}))  ($ops->{unmap_single})($dev, $addr, $size, $direction); });
    }' unless defined(&dma_unmap_single);
    eval 'sub dma_map_sg {
        my($hwdev,$sg,$nents,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  ($ops->{map_sg})($hwdev, $sg, $nents, $direction); });
    }' unless defined(&dma_map_sg);
    eval 'sub dma_unmap_sg {
        my($hwdev,$sg,$nents,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{unmap_sg}))  ($ops->{unmap_sg})($hwdev, $sg, $nents, $direction); });
    }' unless defined(&dma_unmap_sg);
    eval 'sub dma_sync_single_for_cpu {
        my($hwdev,$dma_handle,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_single_for_cpu}))  ($ops->{sync_single_for_cpu})($hwdev, $dma_handle, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_for_cpu);
    eval 'sub dma_sync_single_for_device {
        my($hwdev,$dma_handle,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_single_for_device}))  ($ops->{sync_single_for_device})($hwdev, $dma_handle, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_for_device);
    eval 'sub dma_sync_single_range_for_cpu {
        my($hwdev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_single_range_for_cpu}))  ($ops->{sync_single_range_for_cpu})($hwdev, $dma_handle, $offset, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_range_for_cpu);
    eval 'sub dma_sync_single_range_for_device {
        my($hwdev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_single_range_for_device}))  ($ops->{sync_single_range_for_device})($hwdev, $dma_handle, $offset, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_range_for_device);
    eval 'sub dma_sync_sg_for_cpu {
        my($hwdev,$sg,$nelems,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_sg_for_cpu}))  ($ops->{sync_sg_for_cpu})($hwdev, $sg, $nelems, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_sg_for_cpu);
    eval 'sub dma_sync_sg_for_device {
        my($hwdev,$sg,$nelems,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($hwdev);  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($ops->{sync_sg_for_device}))  ($ops->{sync_sg_for_device})($hwdev, $sg, $nelems, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_sg_for_device);
    eval 'sub dma_map_page {
        my($dev,$page,$offset,$size,$direction) = @_;
	    eval q({ \'struct dma_mapping_ops\' * &ops =  &get_dma_ops($dev);  &BUG_ON(! &valid_dma_direction($direction));  ($ops->{map_single})($dev,  &page_to_phys($page) + $offset, $size, $direction); });
    }' unless defined(&dma_map_page);
    eval 'sub dma_unmap_page {
        my($dev,$addr,$size,$direction) = @_;
	    eval q({  &dma_unmap_single($dev, $addr, $size, $direction); });
    }' unless defined(&dma_unmap_page);
    eval 'sub dma_cache_sync {
        my($dev,$vaddr,$size,$dir) = @_;
	    eval q({  &flush_write_buffers(); });
    }' unless defined(&dma_cache_sync);
    eval 'sub dma_get_cache_alignment {
        my($void) = @_;
	    eval q({  ($boot_cpu_data->{x86_clflush_size}); });
    }' unless defined(&dma_get_cache_alignment);
    eval 'sub dma_is_consistent {
        my($d, $h) = @_;
	    eval q((1));
    }' unless defined(&dma_is_consistent);
    require 'asm-generic/dma-coherent.ph';
}
1;
