require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_FIXMAP_H)) {
    eval 'sub _ASM_FIXMAP_H () {1;}' unless defined(&_ASM_FIXMAP_H);
    if(defined(&CONFIG_X86_32)) {
	require 'fixmap_32.ph';
    } else {
	require 'fixmap_64.ph';
    }
    unless(defined(&CONFIG_PARAVIRT)) {
	eval 'sub __set_fixmap {
	    my($idx,$phys,$flags) = @_;
    	    eval q({  &native_set_fixmap($idx, $phys, $flags); });
	}' unless defined(&__set_fixmap);
    }
    eval 'sub set_fixmap {
        my($idx, $phys) = @_;
	    eval q( &__set_fixmap($idx, $phys,  &PAGE_KERNEL));
    }' unless defined(&set_fixmap);
    eval 'sub set_fixmap_nocache {
        my($idx, $phys) = @_;
	    eval q( &__set_fixmap($idx, $phys,  &PAGE_KERNEL_NOCACHE));
    }' unless defined(&set_fixmap_nocache);
    eval 'sub clear_fixmap {
        my($idx) = @_;
	    eval q( &__set_fixmap($idx, 0,  &__pgprot(0)));
    }' unless defined(&clear_fixmap);
    eval 'sub __fix_to_virt {
        my($x) = @_;
	    eval q(( &FIXADDR_TOP - (($x) <<  &PAGE_SHIFT)));
    }' unless defined(&__fix_to_virt);
    eval 'sub __virt_to_fix {
        my($x) = @_;
	    eval q((( &FIXADDR_TOP - (($x) &PAGE_MASK)) >>  &PAGE_SHIFT));
    }' unless defined(&__virt_to_fix);
    eval 'sub virt_to_fix {
        my($vaddr) = @_;
	    eval q({  &BUG_ON($vaddr >=  &FIXADDR_TOP || $vaddr <  &FIXADDR_START);  &__virt_to_fix($vaddr); });
    }' unless defined(&virt_to_fix);
}
1;
