require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_I387_H)) {
    eval 'sub _ASM_X86_I387_H () {1;}' unless defined(&_ASM_X86_I387_H);
    require 'linux/sched.ph';
    require 'linux/kernel_stat.ph';
    require 'linux/regset.ph';
    require 'linux/hardirq.ph';
    require 'asm/asm.ph';
    require 'asm/processor.ph';
    require 'asm/sigcontext.ph';
    require 'asm/user.ph';
    require 'asm/uaccess.ph';
    if(defined(&CONFIG_IA32_EMULATION)) {
    }
    if(defined(&CONFIG_X86_64)) {
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub restore_fpu_checking {
	    my($fx) = @_;
    	    eval q({ \'int\'  &err;  &asm  &volatile(\\"1:  rex64/fxrstor (%[fx])\\\\n\\\\t\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:  movl $-1,%[err]\\\\n\\" \\"    jmp  2b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b, 3 &b) : [ &err] \\"=r\\" ( &err)  &err; });
	}' unless defined(&restore_fpu_checking);
	eval 'sub X87_FSW_ES () {(1<< 7);}' unless defined(&X87_FSW_ES);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub save_i387_checking {
	    my($fx) = @_;
    	    eval q({ \'int\'  &err;  &asm  &volatile(\\"1:  rex64/fxsave (%[fx])\\\\n\\\\t\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:  movl $-1,%[err]\\\\n\\" \\"    jmp  2b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b, 3 &b) : [ &err] \\"=r\\" ( &err), \\"=m\\" (*$fx)  &if ( &unlikely( &err)  &&  &__clear_user($fx, $sizeof{\'struct i387_fxsave_struct\'}))  &err = - &EFAULT;  &err; });
	}' unless defined(&save_i387_checking);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __save_init_fpu {
	    my($tsk) = @_;
    	    eval q({  &clear_fpu_state( ($tsk->{thread}->{xstate}->{fxsave}));  &task_thread_info($tsk)-> &status &= ~ &TS_USEDFPU; });
	}' unless defined(&__save_init_fpu);
    } else {
	eval 'sub tolerant_fwait {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"fnclex ; fwait\\"); });
	}' unless defined(&tolerant_fwait);
	eval 'sub restore_fpu {
	    my($tsk) = @_;
    	    eval q({  &alternative_input( \\"nop ; frstor %1\\", \\"fxrstor %1\\",  &X86_FEATURE_FXSR, \\"m\\" ( ($tsk->{thread}->{xstate}->{fxsave}))); });
	}' unless defined(&restore_fpu);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub safe_address () {( $__per_cpu_offset[0]);}' unless defined(&safe_address);
	} else {
	    eval 'sub safe_address () {( &kstat_cpu(0). ($cpustat->{user}));}' unless defined(&safe_address);
	}
    }
    eval 'sub __unlazy_fpu {
        my($tsk) = @_;
	    eval q({  &if ( &task_thread_info($tsk)-> &status &  &TS_USEDFPU) {  &__save_init_fpu($tsk);  &stts(); }  &else  ($tsk->{fpu_counter}) = 0; });
    }' unless defined(&__unlazy_fpu);
    eval 'sub __clear_fpu {
        my($tsk) = @_;
	    eval q({  &if ( &task_thread_info($tsk)-> &status &  &TS_USEDFPU) {  &tolerant_fwait();  &task_thread_info($tsk)-> &status &= ~ &TS_USEDFPU;  &stts(); } });
    }' unless defined(&__clear_fpu);
    eval 'sub kernel_fpu_begin {
        my($void) = @_;
	    eval q({ \'struct thread_info\' * &me =  &current_thread_info();  &preempt_disable();  &if ( ($me->{status}) &  &TS_USEDFPU)  &__save_init_fpu( ($me->{task}));  &else  &clts(); });
    }' unless defined(&kernel_fpu_begin);
    eval 'sub kernel_fpu_end {
        my($void) = @_;
	    eval q({  &stts();  &preempt_enable(); });
    }' unless defined(&kernel_fpu_end);
    eval 'sub irq_ts_restore {
        my($TS_state) = @_;
	    eval q({  &if ($TS_state)  &stts(); });
    }' unless defined(&irq_ts_restore);
    if(defined(&CONFIG_X86_64)) {
	eval 'sub save_init_fpu {
	    my($tsk) = @_;
    	    eval q({  &__save_init_fpu($tsk);  &stts(); });
	}' unless defined(&save_init_fpu);
	eval 'sub unlazy_fpu () { &__unlazy_fpu;}' unless defined(&unlazy_fpu);
	eval 'sub clear_fpu () { &__clear_fpu;}' unless defined(&clear_fpu);
    } else {
	eval 'sub unlazy_fpu {
	    my($tsk) = @_;
    	    eval q({  &preempt_disable();  &__unlazy_fpu($tsk);  &preempt_enable(); });
	}' unless defined(&unlazy_fpu);
	eval 'sub clear_fpu {
	    my($tsk) = @_;
    	    eval q({  &preempt_disable();  &__clear_fpu($tsk);  &preempt_enable(); });
	}' unless defined(&clear_fpu);
    }
    eval 'sub get_fpu_swd {
        my($tsk) = @_;
	    eval q({  &if {  ($tsk->{thread}->{xstate}->{fxsave}->{swd}); }  &else {  ($tsk->{thread}->{xstate}->{fsave}->{swd}); } });
    }' unless defined(&get_fpu_swd);
    eval 'sub get_fpu_mxcsr {
        my($tsk) = @_;
	    eval q({  &if ( &cpu_has_xmm) {  ($tsk->{thread}->{xstate}->{fxsave}->{mxcsr}); }  &else {  &MXCSR_DEFAULT; } });
    }' unless defined(&get_fpu_mxcsr);
}
1;
