require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PGTABLE_3LEVEL_H)) {
    eval 'sub _I386_PGTABLE_3LEVEL_H () {1;}' unless defined(&_I386_PGTABLE_3LEVEL_H);
    eval 'sub pte_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %p(%08lx%08lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e), ($e). &pte_high, ($e). &pte_low));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub pud_none {
        my($pud) = @_;
	    eval q({  &pud_val($pud) == 0; });
    }' unless defined(&pud_none);
    eval 'sub pud_bad {
        my($pud) = @_;
	    eval q({ ( &pud_val($pud) & ~( &PTE_PFN_MASK |  &_KERNPG_TABLE |  &_PAGE_USER)) != 0; });
    }' unless defined(&pud_bad);
    eval 'sub pud_present {
        my($pud) = @_;
	    eval q({  &pud_val($pud) &  &_PAGE_PRESENT; });
    }' unless defined(&pud_present);
    eval 'sub native_set_pte_atomic {
        my($ptep,$pte) = @_;
	    eval q({  &set_64bit(($ptep),  &native_pte_val($pte)); });
    }' unless defined(&native_set_pte_atomic);
    eval 'sub native_set_pmd {
        my($pmdp,$pmd) = @_;
	    eval q({  &set_64bit(($pmdp),  &native_pmd_val($pmd)); });
    }' unless defined(&native_set_pmd);
    eval 'sub native_set_pud {
        my($pudp,$pud) = @_;
	    eval q({  &set_64bit(($pudp),  &native_pud_val($pud)); });
    }' unless defined(&native_set_pud);
    eval 'sub native_pmd_clear {
        my($pmd) = @_;
	    eval q({  &u32 * &tmp = ( &u32 *)$pmd; * &tmp = 0;  &smp_wmb(); *( &tmp + 1) = 0; });
    }' unless defined(&native_pmd_clear);
    eval 'sub pud_clear {
        my($pudp) = @_;
	    eval q({ my $pgd;  &set_pud($pudp,  &__pud(0));  $pgd =  &read_cr3();  &if ( &__pa($pudp) >=  $pgd  &&  &__pa($pudp) < ( $pgd + $sizeof{ &pgd_t}* &PTRS_PER_PGD))  &write_cr3( $pgd); });
    }' unless defined(&pud_clear);
    eval 'sub pud_page {
        my($pud) = @_;
	    eval q((  &__va( &pud_val($pud) &  &PTE_PFN_MASK)));
    }' unless defined(&pud_page);
    eval 'sub pud_page_vaddr {
        my($pud) = @_;
	    eval q((  &__va( &pud_val($pud) &  &PTE_PFN_MASK)));
    }' unless defined(&pud_page_vaddr);
    eval 'sub pmd_offset {
        my($pud, $address) = @_;
	    eval q((( &pmd_t *) &pud_page(*($pud)) +  &pmd_index($address)));
    }' unless defined(&pmd_offset);
    if(defined(&CONFIG_SMP)) {
	eval 'sub native_ptep_get_and_clear {
	    my($ptep) = @_;
    	    eval q({  &pte_t  &res;  ($res->{pte_low}) =  &xchg( ($ptep->{pte_low}), 0);  ($res->{pte_high}) =  ($ptep->{pte_high});  ($ptep->{pte_high}) = 0;  &res; });
	}' unless defined(&native_ptep_get_and_clear);
    } else {
	eval 'sub native_ptep_get_and_clear {
	    my($xp) = @_;
    	    eval q( &native_local_ptep_get_and_clear($xp));
	}' unless defined(&native_ptep_get_and_clear);
    }
    eval 'sub __HAVE_ARCH_PTE_SAME () {1;}' unless defined(&__HAVE_ARCH_PTE_SAME);
    eval 'sub pte_same {
        my($a,$b) = @_;
	    eval q({  ($a->{pte_low}) ==  ($b->{pte_low})  &&  ($a->{pte_high}) ==  ($b->{pte_high}); });
    }' unless defined(&pte_same);
    eval 'sub pte_page {
        my($x) = @_;
	    eval q( &pfn_to_page( &pte_pfn($x)));
    }' unless defined(&pte_page);
    eval 'sub pte_none {
        my($pte) = @_;
	    eval q({ ! ($pte->{pte_low})  && ! ($pte->{pte_high}); });
    }' unless defined(&pte_none);
    eval 'sub pte_pfn {
        my($pte) = @_;
	    eval q({ ( &pte_val($pte) &  &PTE_PFN_MASK) >>  &PAGE_SHIFT; });
    }' unless defined(&pte_pfn);
    eval 'sub pte_to_pgoff {
        my($pte) = @_;
	    eval q((($pte). &pte_high));
    }' unless defined(&pte_to_pgoff);
    eval 'sub pgoff_to_pte {
        my($off) = @_;
	    eval q((( &pte_t) { { . &pte_low =  &_PAGE_FILE, . &pte_high = ($off) } }));
    }' unless defined(&pgoff_to_pte);
    eval 'sub PTE_FILE_MAX_BITS () {32;}' unless defined(&PTE_FILE_MAX_BITS);
    eval 'sub __swp_type {
        my($x) = @_;
	    eval q(((($x). &val) & 0x1f));
    }' unless defined(&__swp_type);
    eval 'sub __swp_offset {
        my($x) = @_;
	    eval q((($x). &val >> 5));
    }' unless defined(&__swp_offset);
    eval 'sub __swp_entry {
        my($type, $offset) = @_;
	    eval q((( &swp_entry_t){($type) | ($offset) << 5}));
    }' unless defined(&__swp_entry);
    eval 'sub __pte_to_swp_entry {
        my($pte) = @_;
	    eval q((( &swp_entry_t){ ($pte). &pte_high }));
    }' unless defined(&__pte_to_swp_entry);
    eval 'sub __swp_entry_to_pte {
        my($x) = @_;
	    eval q((( &pte_t){ { . &pte_high = ($x). &val } }));
    }' unless defined(&__swp_entry_to_pte);
}
1;
