require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_SPINLOCK_H_)) {
    eval 'sub _X86_SPINLOCK_H_ () {1;}' unless defined(&_X86_SPINLOCK_H_);
    require 'asm/atomic.ph';
    require 'asm/rwlock.ph';
    require 'asm/page.ph';
    require 'asm/processor.ph';
    require 'linux/compiler.ph';
    require 'asm/paravirt.ph';
    if(defined(&CONFIG_X86_32)) {
	eval 'sub LOCK_PTR_REG () {"a";}' unless defined(&LOCK_PTR_REG);
    } else {
	eval 'sub LOCK_PTR_REG () {"D";}' unless defined(&LOCK_PTR_REG);
    }
    if(defined( &CONFIG_X86_32)  && (defined( &CONFIG_X86_OOSTORE) || defined( &CONFIG_X86_PPRO_FENCE))) {
	eval 'sub UNLOCK_LOCK_PREFIX () { &LOCK_PREFIX;}' unless defined(&UNLOCK_LOCK_PREFIX);
    } else {
	eval 'sub UNLOCK_LOCK_PREFIX () {1;}' unless defined(&UNLOCK_LOCK_PREFIX);
    }
    if(((defined(&NR_CPUS) ? &NR_CPUS : undef) < 256)) {
	eval 'sub __ticket_spin_is_locked {
	    my($lock) = @_;
    	    eval q({ \'int\'  &tmp =  &ACCESS_ONCE( ($lock->{s$lock})); ((( &tmp >> 8) & 0xff) != ( &tmp & 0xff)); });
	}' unless defined(&__ticket_spin_is_locked);
	eval 'sub __ticket_spin_is_contended {
	    my($lock) = @_;
    	    eval q({ \'int\'  &tmp =  &ACCESS_ONCE( ($lock->{s$lock})); ((( &tmp >> 8) -  &tmp) & 0xff) > 1; });
	}' unless defined(&__ticket_spin_is_contended);
    } else {
	eval 'sub __ticket_spin_is_locked {
	    my($lock) = @_;
    	    eval q({ \'int\'  &tmp =  &ACCESS_ONCE( ($lock->{s$lock})); ((( &tmp >> 16) & 0xffff) != ( &tmp & 0xffff)); });
	}' unless defined(&__ticket_spin_is_locked);
	eval 'sub __ticket_spin_is_contended {
	    my($lock) = @_;
    	    eval q({ \'int\'  &tmp =  &ACCESS_ONCE( ($lock->{s$lock})); ((( &tmp >> 16) -  &tmp) & 0xffff) > 1; });
	}' unless defined(&__ticket_spin_is_contended);
    }
    eval 'sub __raw_spin_lock_flags {
        my($lock, $flags) = @_;
	    eval q( &__raw_spin_lock($lock));
    }' unless defined(&__raw_spin_lock_flags);
    if(defined(&CONFIG_PARAVIRT)) {
	eval 'sub __byte_spin_is_locked {
	    my($lock) = @_;
    	    eval q({ \'struct __byte_spinlock\' * &bl = $lock;  ($bl->{lock}) != 0; });
	}' unless defined(&__byte_spin_is_locked);
	eval 'sub __byte_spin_is_contended {
	    my($lock) = @_;
    	    eval q({ \'struct __byte_spinlock\' * &bl = $lock;  ($bl->{spinners}) != 0; });
	}' unless defined(&__byte_spin_is_contended);
	eval 'sub __byte_spin_lock {
	    my($lock) = @_;
    	    eval q({ \'struct __byte_spinlock\' * &bl = $lock;  &s8  &val = 1;  &asm(\\"1: xchgb %1, %0\\\\n\\" \\"   test %1,%1\\\\n\\" \\"   jz 3f\\\\n\\" \\"   \\"  &LOCK_PREFIX \\"incb %2\\\\n\\" \\"2: rep;nop\\\\n\\" \\"   cmpb $1, %0\\\\n\\" \\"   je 2b\\\\n\\" \\"   \\"  &LOCK_PREFIX \\"decb %2\\\\n\\" \\"   jmp 1b\\\\n\\" \\"3:\\" : \\"+m\\" ( ($bl->{lock})), \\"+q\\" ( &val), \\"+m\\" ( ($bl->{spinners})): : \\"memory\\"); });
	}' unless defined(&__byte_spin_lock);
	eval 'sub __byte_spin_trylock {
	    my($lock) = @_;
    	    eval q({ \'struct __byte_spinlock\' * &bl = $lock;  &u8  &old = 1;  &asm(\\"xchgb %1,%0\\" : \\"+m\\" ( ($bl->{lock})), \\"+q\\" ( &old) : : \\"memory\\");  &old == 0; });
	}' unless defined(&__byte_spin_trylock);
	eval 'sub __byte_spin_unlock {
	    my($lock) = @_;
    	    eval q({ \'struct __byte_spinlock\' * &bl = $lock;  &smp_wmb();  ($bl->{lock}) = 0; });
	}' unless defined(&__byte_spin_unlock);
    } else {
	eval 'sub __raw_spin_is_locked {
	    my($lock) = @_;
    	    eval q({  &__ticket_spin_is_locked($lock); });
	}' unless defined(&__raw_spin_is_locked);
	eval 'sub __raw_spin_is_contended {
	    my($lock) = @_;
    	    eval q({  &__ticket_spin_is_contended($lock); });
	}' unless defined(&__raw_spin_is_contended);
    }
    eval 'sub __raw_spin_unlock_wait {
        my($lock) = @_;
	    eval q({  &while ( &__raw_spin_is_locked($lock))  &cpu_relax(); });
    }' unless defined(&__raw_spin_unlock_wait);
    eval 'sub __raw_read_lock {
        my($rw) = @_;
	    eval q({  &asm  &volatile( &LOCK_PREFIX \\" subl $1,(%0)\\\\n\\\\t\\" \\"jns 1f\\\\n\\" \\"call __read_lock_failed\\\\n\\\\t\\" \\"1:\\\\n\\" :: &LOCK_PTR_REG ($rw) : \\"memory\\"); });
    }' unless defined(&__raw_read_lock);
    eval 'sub __raw_write_lock {
        my($rw) = @_;
	    eval q({  &asm  &volatile( &LOCK_PREFIX \\" subl %1,(%0)\\\\n\\\\t\\" \\"jz 1f\\\\n\\" \\"call __write_lock_failed\\\\n\\\\t\\" \\"1:\\\\n\\" :: &LOCK_PTR_REG ($rw), \\"i\\" ( &RW_LOCK_BIAS) : \\"memory\\"); });
    }' unless defined(&__raw_write_lock);
    eval 'sub __raw_read_trylock {
        my($lock) = @_;
	    eval q({  &atomic_t * &count = ( &atomic_t *)$lock;  &atomic_dec( &count);  &if ( &atomic_read( &count) >= 0) 1;  &atomic_inc( &count); 0; });
    }' unless defined(&__raw_read_trylock);
    eval 'sub __raw_write_trylock {
        my($lock) = @_;
	    eval q({  &atomic_t * &count = ( &atomic_t *)$lock;  &if ( &atomic_sub_and_test( &RW_LOCK_BIAS,  &count)) 1;  &atomic_add( &RW_LOCK_BIAS,  &count); 0; });
    }' unless defined(&__raw_write_trylock);
    eval 'sub __raw_read_unlock {
        my($rw) = @_;
	    eval q({  &asm  &volatile( &LOCK_PREFIX \\"incl %0\\" :\\"+m\\" ( ($rw->{lock})) : : \\"memory\\"); });
    }' unless defined(&__raw_read_unlock);
    eval 'sub __raw_write_unlock {
        my($rw) = @_;
	    eval q({  &asm  &volatile( &LOCK_PREFIX \\"addl %1, %0\\" : \\"+m\\" ( ($rw->{lock})) : \\"i\\" ( &RW_LOCK_BIAS) : \\"memory\\"); });
    }' unless defined(&__raw_write_unlock);
    eval 'sub _raw_spin_relax {
        my($lock) = @_;
	    eval q( &cpu_relax());
    }' unless defined(&_raw_spin_relax);
    eval 'sub _raw_read_relax {
        my($lock) = @_;
	    eval q( &cpu_relax());
    }' unless defined(&_raw_read_relax);
    eval 'sub _raw_write_relax {
        my($lock) = @_;
	    eval q( &cpu_relax());
    }' unless defined(&_raw_write_relax);
}
1;
