require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_TLBFLUSH_H)) {
    eval 'sub _ASM_X86_TLBFLUSH_H () {1;}' unless defined(&_ASM_X86_TLBFLUSH_H);
    require 'linux/mm.ph';
    require 'linux/sched.ph';
    require 'asm/processor.ph';
    require 'asm/system.ph';
    if(defined(&CONFIG_PARAVIRT)) {
	require 'asm/paravirt.ph';
    } else {
	eval 'sub __flush_tlb () {
	    eval q( &__native_flush_tlb());
	}' unless defined(&__flush_tlb);
	eval 'sub __flush_tlb_global () {
	    eval q( &__native_flush_tlb_global());
	}' unless defined(&__flush_tlb_global);
	eval 'sub __flush_tlb_single {
	    my($addr) = @_;
    	    eval q( &__native_flush_tlb_single($addr));
	}' unless defined(&__flush_tlb_single);
    }
    eval 'sub __native_flush_tlb {
        my($void) = @_;
	    eval q({  &write_cr3( &read_cr3()); });
    }' unless defined(&__native_flush_tlb);
    eval 'sub __native_flush_tlb_global {
        my($void) = @_;
	    eval q({ my $flags; my $cr4;  &raw_local_irq_save( $flags);  $cr4 =  &read_cr4();  &write_cr4( $cr4 & ~ &X86_CR4_PGE);  &write_cr4( $cr4);  &raw_local_irq_restore( $flags); });
    }' unless defined(&__native_flush_tlb_global);
    eval 'sub __native_flush_tlb_single {
        my($addr) = @_;
	    eval q({  &asm  &volatile(\\"invlpg (%0)\\" ::\\"r\\" ($addr) : \\"memory\\"); });
    }' unless defined(&__native_flush_tlb_single);
    eval 'sub __flush_tlb_all {
        my($void) = @_;
	    eval q({  &if ( &cpu_has_pge)  &__flush_tlb_global();  &else  &__flush_tlb(); });
    }' unless defined(&__flush_tlb_all);
    eval 'sub __flush_tlb_one {
        my($addr) = @_;
	    eval q({  &if ( &cpu_has_invlpg)  &__flush_tlb_single($addr);  &else  &__flush_tlb(); });
    }' unless defined(&__flush_tlb_one);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub TLB_FLUSH_ALL () {0xffffffff;}' unless defined(&TLB_FLUSH_ALL);
    } else {
	eval 'sub TLB_FLUSH_ALL () {-1;}' unless defined(&TLB_FLUSH_ALL);
    }
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_tlb () {
	    eval q( &__flush_tlb());
	}' unless defined(&flush_tlb);
	eval 'sub flush_tlb_all () {
	    eval q( &__flush_tlb_all());
	}' unless defined(&flush_tlb_all);
	eval 'sub local_flush_tlb () {
	    eval q( &__flush_tlb());
	}' unless defined(&local_flush_tlb);
	eval 'sub flush_tlb_mm {
	    my($mm) = @_;
    	    eval q({  &if ($mm ==  ($current->{active_mm}))  &__flush_tlb(); });
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_page {
	    my($vma,$addr) = @_;
    	    eval q({  &if ( ($vma->{vm_mm}) ==  ($current->{active_mm}))  &__flush_tlb_one($addr); });
	}' unless defined(&flush_tlb_page);
	eval 'sub flush_tlb_range {
	    my($vma,$start,$end) = @_;
    	    eval q({  &if ( ($vma->{vm_mm}) ==  ($current->{active_mm}))  &__flush_tlb(); });
	}' unless defined(&flush_tlb_range);
	eval 'sub native_flush_tlb_others {
	    my($cpumask,$mm,$va) = @_;
    	    eval q({ });
	}' unless defined(&native_flush_tlb_others);
    } else {
	require 'asm/smp.ph';
	eval 'sub local_flush_tlb () {
	    eval q( &__flush_tlb());
	}' unless defined(&local_flush_tlb);
	eval 'sub flush_tlb () {
	    eval q( &flush_tlb_current_task());
	}' unless defined(&flush_tlb);
	eval 'sub flush_tlb_range {
	    my($vma,$start,$end) = @_;
    	    eval q({  &flush_tlb_mm( ($vma->{vm_mm})); });
	}' unless defined(&flush_tlb_range);
	eval 'sub TLBSTATE_OK () {1;}' unless defined(&TLBSTATE_OK);
	eval 'sub TLBSTATE_LAZY () {2;}' unless defined(&TLBSTATE_LAZY);
	if(defined(&CONFIG_X86_32)) {
	}
    }
    unless(defined(&CONFIG_PARAVIRT)) {
	eval 'sub flush_tlb_others {
	    my($mask, $mm, $va) = @_;
    	    eval q( &native_flush_tlb_others($mask, $mm, $va));
	}' unless defined(&flush_tlb_others);
    }
    eval 'sub flush_tlb_kernel_range {
        my($start,$end) = @_;
	    eval q({  &flush_tlb_all(); });
    }' unless defined(&flush_tlb_kernel_range);
}
1;
