require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_TOPOLOGY_H)) {
    eval 'sub _ASM_X86_TOPOLOGY_H () {1;}' unless defined(&_ASM_X86_TOPOLOGY_H);
    if(defined(&CONFIG_X86_32)) {
	if(defined(&CONFIG_X86_HT)) {
	    eval 'sub ENABLE_TOPO_DEFINES () {1;}' unless defined(&ENABLE_TOPO_DEFINES);
	}
    } else {
	if(defined(&CONFIG_SMP)) {
	    eval 'sub ENABLE_TOPO_DEFINES () {1;}' unless defined(&ENABLE_TOPO_DEFINES);
	}
    }
    eval 'sub NUMA_NO_NODE () {(-1);}' unless defined(&NUMA_NO_NODE);
    if(defined(&CONFIG_NUMA)) {
	require 'linux/cpumask.ph';
	require 'asm/mpspec.ph';
	if(defined(&CONFIG_X86_32)) {
	    eval 'sub early_cpu_to_node {
	        my($cpu) = @_;
    		eval q( &cpu_to_node($cpu));
	    }' unless defined(&early_cpu_to_node);
	} else {
	    eval 'sub numa_node_id () {
	        eval q( &read_pda( &nodenumber));
	    }' unless defined(&numa_node_id);
	    if(defined(&CONFIG_DEBUG_PER_CPU_MAPS)) {
	    } else {
	    }
	    eval 'sub node_to_cpumask_ptr {
	        my($v, $node) = @_;
    		eval q( &const  &cpumask_t *$v =  &_node_to_cpumask_ptr($node));
	    }' unless defined(&node_to_cpumask_ptr);
	    eval 'sub node_to_cpumask_ptr_next {
	        my($v, $node) = @_;
    		eval q($v =  &_node_to_cpumask_ptr($node));
	    }' unless defined(&node_to_cpumask_ptr_next);
	}
	eval 'sub parent_node {
	    my($node) = @_;
    	    eval q(($node));
	}' unless defined(&parent_node);
	eval 'sub pcibus_to_node {
	    my($bus) = @_;
    	    eval q( &__pcibus_to_node($bus));
	}' unless defined(&pcibus_to_node);
	eval 'sub pcibus_to_cpumask {
	    my($bus) = @_;
    	    eval q( &__pcibus_to_cpumask($bus));
	}' unless defined(&pcibus_to_cpumask);
	if(defined(&CONFIG_X86_32)) {
	    eval 'sub node_has_online_mem {
	        my($nid) = @_;
    		eval q(( $node_start_pfn[$nid] !=  $node_end_pfn[$nid]));
	    }' unless defined(&node_has_online_mem);
	    eval 'sub SD_CACHE_NICE_TRIES () {1;}' unless defined(&SD_CACHE_NICE_TRIES);
	    eval 'sub SD_IDLE_IDX () {1;}' unless defined(&SD_IDLE_IDX);
	    eval 'sub SD_NEWIDLE_IDX () {2;}' unless defined(&SD_NEWIDLE_IDX);
	    eval 'sub SD_FORKEXEC_IDX () {0;}' unless defined(&SD_FORKEXEC_IDX);
	} else {
	    eval 'sub SD_CACHE_NICE_TRIES () {2;}' unless defined(&SD_CACHE_NICE_TRIES);
	    eval 'sub SD_IDLE_IDX () {2;}' unless defined(&SD_IDLE_IDX);
	    eval 'sub SD_NEWIDLE_IDX () {2;}' unless defined(&SD_NEWIDLE_IDX);
	    eval 'sub SD_FORKEXEC_IDX () {1;}' unless defined(&SD_FORKEXEC_IDX);
	}
	eval 'sub SD_NODE_INIT () { { . &min_interval = 8, . &max_interval = 32, . &busy_factor = 32, . &imbalance_pct = 125, . &cache_nice_tries =  &SD_CACHE_NICE_TRIES, . &busy_idx = 3, . &idle_idx =  &SD_IDLE_IDX, . &newidle_idx =  &SD_NEWIDLE_IDX, . &wake_idx = 1, . &forkexec_idx =  &SD_FORKEXEC_IDX, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_EXEC |  &SD_BALANCE_FORK |  &SD_SERIALIZE |  &SD_WAKE_BALANCE, . &last_balance =  &jiffies, . &balance_interval = 1, };}' unless defined(&SD_NODE_INIT);
	if(defined(&CONFIG_X86_64_ACPI_NUMA)) {
	    eval 'sub node_distance {
	        my($a, $b) = @_;
    		eval q( &__node_distance($a, $b));
	    }' unless defined(&node_distance);
	}
    } else {
	eval 'sub numa_node_id () {
	    eval q(0);
	}' unless defined(&numa_node_id);
	eval 'sub cpu_to_node {
	    my($cpu) = @_;
    	    eval q(0);
	}' unless defined(&cpu_to_node);
	eval 'sub early_cpu_to_node {
	    my($cpu) = @_;
    	    eval q(0);
	}' unless defined(&early_cpu_to_node);
	eval 'sub cpumask_t {
	    eval q(* &_node_to_cpumask_ptr(\'int\'  &node) {  &cpu_online_map; });
	}' unless defined(&cpumask_t);
	eval 'sub node_to_cpumask {
	    my($node) = @_;
    	    eval q({  &cpu_online_map; });
	}' unless defined(&node_to_cpumask);
	eval 'sub node_to_first_cpu {
	    my($node) = @_;
    	    eval q({  &first_cpu( &cpu_online_map); });
	}' unless defined(&node_to_first_cpu);
	eval 'sub node_to_cpumask_ptr {
	    my($v, $node) = @_;
    	    eval q( &const  &cpumask_t *$v =  &_node_to_cpumask_ptr($node));
	}' unless defined(&node_to_cpumask_ptr);
	eval 'sub node_to_cpumask_ptr_next {
	    my($v, $node) = @_;
    	    eval q($v =  &_node_to_cpumask_ptr($node));
	}' unless defined(&node_to_cpumask_ptr_next);
    }
    require 'asm-generic/topology.ph';
    if(defined(&CONFIG_NUMA)) {
    }
    if(defined(&ENABLE_TOPO_DEFINES)) {
	eval 'sub topology_physical_package_id {
	    my($cpu) = @_;
    	    eval q(( &cpu_data($cpu). &phys_proc_id));
	}' unless defined(&topology_physical_package_id);
	eval 'sub topology_core_id {
	    my($cpu) = @_;
    	    eval q(( &cpu_data($cpu). &cpu_core_id));
	}' unless defined(&topology_core_id);
	eval 'sub topology_core_siblings {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &cpu_core_map, $cpu)));
	}' unless defined(&topology_core_siblings);
	eval 'sub topology_thread_siblings {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &cpu_sibling_map, $cpu)));
	}' unless defined(&topology_thread_siblings);
	eval 'sub arch_provides_topology_pointers () { &yes;}' unless defined(&arch_provides_topology_pointers);
    }
    eval 'sub arch_fix_phys_package_id {
        my($num,$slot) = @_;
	    eval q({ });
    }' unless defined(&arch_fix_phys_package_id);
    if(defined(&CONFIG_SMP)) {
	eval 'sub mc_capable () {
	    eval q(( ($boot_cpu_data->{x86_max_cores}) > 1));
	}' unless defined(&mc_capable);
	eval 'sub smt_capable () {
	    eval q(( &smp_num_siblings > 1));
	}' unless defined(&smt_capable);
    }
    if(defined(&CONFIG_NUMA)) {
    } else {
	eval 'sub get_mp_bus_to_node {
	    my($busnum) = @_;
    	    eval q({ 0; });
	}' unless defined(&get_mp_bus_to_node);
	eval 'sub set_mp_bus_to_node {
	    my($busnum,$node) = @_;
    	    eval q({ });
	}' unless defined(&set_mp_bus_to_node);
    }
}
1;
