require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__AMD_IOMMU_TYPES_H__)) {
    eval 'sub __AMD_IOMMU_TYPES_H__ () {1;}' unless defined(&__AMD_IOMMU_TYPES_H__);
    require 'linux/types.ph';
    require 'linux/list.ph';
    require 'linux/spinlock.ph';
    eval 'sub DEV_TABLE_ENTRY_SIZE () {32;}' unless defined(&DEV_TABLE_ENTRY_SIZE);
    eval 'sub ALIAS_TABLE_ENTRY_SIZE () {2;}' unless defined(&ALIAS_TABLE_ENTRY_SIZE);
    eval 'sub RLOOKUP_TABLE_ENTRY_SIZE () {($sizeof{ &void });}' unless defined(&RLOOKUP_TABLE_ENTRY_SIZE);
    eval 'sub MMIO_REGION_LENGTH () {0x4000;}' unless defined(&MMIO_REGION_LENGTH);
    eval 'sub MMIO_CAP_HDR_OFFSET () {0x;}' unless defined(&MMIO_CAP_HDR_OFFSET);
    eval 'sub MMIO_RANGE_OFFSET () {0xc;}' unless defined(&MMIO_RANGE_OFFSET);
    eval 'sub MMIO_RANGE_LD_MASK () {0xff000000;}' unless defined(&MMIO_RANGE_LD_MASK);
    eval 'sub MMIO_RANGE_FD_MASK () {0xff0000;}' unless defined(&MMIO_RANGE_FD_MASK);
    eval 'sub MMIO_RANGE_BUS_MASK () {0xff00;}' unless defined(&MMIO_RANGE_BUS_MASK);
    eval 'sub MMIO_RANGE_LD_SHIFT () {24;}' unless defined(&MMIO_RANGE_LD_SHIFT);
    eval 'sub MMIO_RANGE_FD_SHIFT () {16;}' unless defined(&MMIO_RANGE_FD_SHIFT);
    eval 'sub MMIO_RANGE_BUS_SHIFT () {8;}' unless defined(&MMIO_RANGE_BUS_SHIFT);
    eval 'sub MMIO_GET_LD {
        my($x) = @_;
	    eval q(((($x) &  &MMIO_RANGE_LD_MASK) >>  &MMIO_RANGE_LD_SHIFT));
    }' unless defined(&MMIO_GET_LD);
    eval 'sub MMIO_GET_FD {
        my($x) = @_;
	    eval q(((($x) &  &MMIO_RANGE_FD_MASK) >>  &MMIO_RANGE_FD_SHIFT));
    }' unless defined(&MMIO_GET_FD);
    eval 'sub MMIO_GET_BUS {
        my($x) = @_;
	    eval q(((($x) &  &MMIO_RANGE_BUS_MASK) >>  &MMIO_RANGE_BUS_SHIFT));
    }' unless defined(&MMIO_GET_BUS);
    eval 'sub MMIO_EXCL_ENABLE_MASK () {0x1;}' unless defined(&MMIO_EXCL_ENABLE_MASK);
    eval 'sub MMIO_EXCL_ALLOW_MASK () {0x2;}' unless defined(&MMIO_EXCL_ALLOW_MASK);
    eval 'sub MMIO_DEV_TABLE_OFFSET () {0x;}' unless defined(&MMIO_DEV_TABLE_OFFSET);
    eval 'sub MMIO_CMD_BUF_OFFSET () {0x8;}' unless defined(&MMIO_CMD_BUF_OFFSET);
    eval 'sub MMIO_EVT_BUF_OFFSET () {0x10;}' unless defined(&MMIO_EVT_BUF_OFFSET);
    eval 'sub MMIO_CONTROL_OFFSET () {0x18;}' unless defined(&MMIO_CONTROL_OFFSET);
    eval 'sub MMIO_EXCL_BASE_OFFSET () {0x20;}' unless defined(&MMIO_EXCL_BASE_OFFSET);
    eval 'sub MMIO_EXCL_LIMIT_OFFSET () {0x28;}' unless defined(&MMIO_EXCL_LIMIT_OFFSET);
    eval 'sub MMIO_CMD_HEAD_OFFSET () {0x2000;}' unless defined(&MMIO_CMD_HEAD_OFFSET);
    eval 'sub MMIO_CMD_TAIL_OFFSET () {0x2008;}' unless defined(&MMIO_CMD_TAIL_OFFSET);
    eval 'sub MMIO_EVT_HEAD_OFFSET () {0x2010;}' unless defined(&MMIO_EVT_HEAD_OFFSET);
    eval 'sub MMIO_EVT_TAIL_OFFSET () {0x2018;}' unless defined(&MMIO_EVT_TAIL_OFFSET);
    eval 'sub MMIO_STATUS_OFFSET () {0x2020;}' unless defined(&MMIO_STATUS_OFFSET);
    eval 'sub MMIO_STATUS_COM_WAIT_INT_MASK () {0x4;}' unless defined(&MMIO_STATUS_COM_WAIT_INT_MASK);
    eval 'sub CONTROL_IOMMU_EN () {0x;}' unless defined(&CONTROL_IOMMU_EN);
    eval 'sub CONTROL_HT_TUN_EN () {0x1;}' unless defined(&CONTROL_HT_TUN_EN);
    eval 'sub CONTROL_EVT_LOG_EN () {0x2;}' unless defined(&CONTROL_EVT_LOG_EN);
    eval 'sub CONTROL_EVT_INT_EN () {0x3;}' unless defined(&CONTROL_EVT_INT_EN);
    eval 'sub CONTROL_COMWAIT_EN () {0x4;}' unless defined(&CONTROL_COMWAIT_EN);
    eval 'sub CONTROL_PASSPW_EN () {0x8;}' unless defined(&CONTROL_PASSPW_EN);
    eval 'sub CONTROL_RESPASSPW_EN () {0x9;}' unless defined(&CONTROL_RESPASSPW_EN);
    eval 'sub CONTROL_COHERENT_EN () {0xa;}' unless defined(&CONTROL_COHERENT_EN);
    eval 'sub CONTROL_ISOC_EN () {0xb;}' unless defined(&CONTROL_ISOC_EN);
    eval 'sub CONTROL_CMDBUF_EN () {0xc;}' unless defined(&CONTROL_CMDBUF_EN);
    eval 'sub CONTROL_PPFLOG_EN () {0xd;}' unless defined(&CONTROL_PPFLOG_EN);
    eval 'sub CONTROL_PPFINT_EN () {0xe;}' unless defined(&CONTROL_PPFINT_EN);
    eval 'sub CMD_COMPL_WAIT () {0x1;}' unless defined(&CMD_COMPL_WAIT);
    eval 'sub CMD_INV_DEV_ENTRY () {0x2;}' unless defined(&CMD_INV_DEV_ENTRY);
    eval 'sub CMD_INV_IOMMU_PAGES () {0x3;}' unless defined(&CMD_INV_IOMMU_PAGES);
    eval 'sub CMD_COMPL_WAIT_STORE_MASK () {0x1;}' unless defined(&CMD_COMPL_WAIT_STORE_MASK);
    eval 'sub CMD_COMPL_WAIT_INT_MASK () {0x2;}' unless defined(&CMD_COMPL_WAIT_INT_MASK);
    eval 'sub CMD_INV_IOMMU_PAGES_SIZE_MASK () {0x1;}' unless defined(&CMD_INV_IOMMU_PAGES_SIZE_MASK);
    eval 'sub CMD_INV_IOMMU_PAGES_PDE_MASK () {0x2;}' unless defined(&CMD_INV_IOMMU_PAGES_PDE_MASK);
    eval 'sub CMD_INV_IOMMU_ALL_PAGES_ADDRESS () {9.22337203685478e+18;}' unless defined(&CMD_INV_IOMMU_ALL_PAGES_ADDRESS);
    eval 'sub DEV_ENTRY_VALID () {0x;}' unless defined(&DEV_ENTRY_VALID);
    eval 'sub DEV_ENTRY_TRANSLATION () {0x1;}' unless defined(&DEV_ENTRY_TRANSLATION);
    eval 'sub DEV_ENTRY_IR () {0x3d;}' unless defined(&DEV_ENTRY_IR);
    eval 'sub DEV_ENTRY_IW () {0x3e;}' unless defined(&DEV_ENTRY_IW);
    eval 'sub DEV_ENTRY_NO_PAGE_FAULT () {0x62;}' unless defined(&DEV_ENTRY_NO_PAGE_FAULT);
    eval 'sub DEV_ENTRY_EX () {0x67;}' unless defined(&DEV_ENTRY_EX);
    eval 'sub DEV_ENTRY_SYSMGT1 () {0x68;}' unless defined(&DEV_ENTRY_SYSMGT1);
    eval 'sub DEV_ENTRY_SYSMGT2 () {0x69;}' unless defined(&DEV_ENTRY_SYSMGT2);
    eval 'sub DEV_ENTRY_INIT_PASS () {0xb8;}' unless defined(&DEV_ENTRY_INIT_PASS);
    eval 'sub DEV_ENTRY_EINT_PASS () {0xb9;}' unless defined(&DEV_ENTRY_EINT_PASS);
    eval 'sub DEV_ENTRY_NMI_PASS () {0xba;}' unless defined(&DEV_ENTRY_NMI_PASS);
    eval 'sub DEV_ENTRY_LINT0_PASS () {0xbe;}' unless defined(&DEV_ENTRY_LINT0_PASS);
    eval 'sub DEV_ENTRY_LINT1_PASS () {0xbf;}' unless defined(&DEV_ENTRY_LINT1_PASS);
    eval 'sub CMD_BUFFER_SIZE () {8192;}' unless defined(&CMD_BUFFER_SIZE);
    eval 'sub CMD_BUFFER_ENTRIES () {512;}' unless defined(&CMD_BUFFER_ENTRIES);
    eval 'sub MMIO_CMD_SIZE_SHIFT () {56;}' unless defined(&MMIO_CMD_SIZE_SHIFT);
    eval 'sub MMIO_CMD_SIZE_512 () {(0x9 <<  &MMIO_CMD_SIZE_SHIFT);}' unless defined(&MMIO_CMD_SIZE_512);
    eval 'sub PAGE_MODE_1_LEVEL () {0x1;}' unless defined(&PAGE_MODE_1_LEVEL);
    eval 'sub PAGE_MODE_2_LEVEL () {0x2;}' unless defined(&PAGE_MODE_2_LEVEL);
    eval 'sub PAGE_MODE_3_LEVEL () {0x3;}' unless defined(&PAGE_MODE_3_LEVEL);
    eval 'sub IOMMU_PDE_NL_0 () {0x;}' unless defined(&IOMMU_PDE_NL_0);
    eval 'sub IOMMU_PDE_NL_1 () {0x200;}' unless defined(&IOMMU_PDE_NL_1);
    eval 'sub IOMMU_PDE_NL_2 () {0x400;}' unless defined(&IOMMU_PDE_NL_2);
    eval 'sub IOMMU_PDE_NL_3 () {0x600;}' unless defined(&IOMMU_PDE_NL_3);
    eval 'sub IOMMU_PTE_L2_INDEX {
        my($address) = @_;
	    eval q(((($address) >> 30) & 0x1ff));
    }' unless defined(&IOMMU_PTE_L2_INDEX);
    eval 'sub IOMMU_PTE_L1_INDEX {
        my($address) = @_;
	    eval q(((($address) >> 21) & 0x1ff));
    }' unless defined(&IOMMU_PTE_L1_INDEX);
    eval 'sub IOMMU_PTE_L0_INDEX {
        my($address) = @_;
	    eval q(((($address) >> 12) & 0x1ff));
    }' unless defined(&IOMMU_PTE_L0_INDEX);
    eval 'sub IOMMU_MAP_SIZE_L1 () {(1 << 21);}' unless defined(&IOMMU_MAP_SIZE_L1);
    eval 'sub IOMMU_MAP_SIZE_L2 () {(1 << 30);}' unless defined(&IOMMU_MAP_SIZE_L2);
    eval 'sub IOMMU_MAP_SIZE_L3 () {(1 << 39);}' unless defined(&IOMMU_MAP_SIZE_L3);
    eval 'sub IOMMU_PTE_P () {(1 << 0);}' unless defined(&IOMMU_PTE_P);
    eval 'sub IOMMU_PTE_U () {(1 << 59);}' unless defined(&IOMMU_PTE_U);
    eval 'sub IOMMU_PTE_FC () {(1 << 60);}' unless defined(&IOMMU_PTE_FC);
    eval 'sub IOMMU_PTE_IR () {(1 << 61);}' unless defined(&IOMMU_PTE_IR);
    eval 'sub IOMMU_PTE_IW () {(1 << 62);}' unless defined(&IOMMU_PTE_IW);
    eval 'sub IOMMU_L1_PDE {
        my($address) = @_;
	    eval q((($address) |  &IOMMU_PDE_NL_1 |  &IOMMU_PTE_P |  &IOMMU_PTE_IR |  &IOMMU_PTE_IW));
    }' unless defined(&IOMMU_L1_PDE);
    eval 'sub IOMMU_L2_PDE {
        my($address) = @_;
	    eval q((($address) |  &IOMMU_PDE_NL_2 |  &IOMMU_PTE_P |  &IOMMU_PTE_IR |  &IOMMU_PTE_IW));
    }' unless defined(&IOMMU_L2_PDE);
    eval 'sub IOMMU_PAGE_MASK () {(((1 << 52) - 1) & ~0xfff);}' unless defined(&IOMMU_PAGE_MASK);
    eval 'sub IOMMU_PTE_PRESENT {
        my($pte) = @_;
	    eval q((($pte) &  &IOMMU_PTE_P));
    }' unless defined(&IOMMU_PTE_PRESENT);
    eval 'sub IOMMU_PTE_PAGE {
        my($pte) = @_;
	    eval q(( &phys_to_virt(($pte) &  &IOMMU_PAGE_MASK)));
    }' unless defined(&IOMMU_PTE_PAGE);
    eval 'sub IOMMU_PTE_MODE {
        my($pte) = @_;
	    eval q(((($pte) >> 9) & 0x7));
    }' unless defined(&IOMMU_PTE_MODE);
    eval 'sub IOMMU_PROT_MASK () {0x3;}' unless defined(&IOMMU_PROT_MASK);
    eval 'sub IOMMU_PROT_IR () {0x1;}' unless defined(&IOMMU_PROT_IR);
    eval 'sub IOMMU_PROT_IW () {0x2;}' unless defined(&IOMMU_PROT_IW);
    eval 'sub IOMMU_CAP_IOTLB () {24;}' unless defined(&IOMMU_CAP_IOTLB);
    eval 'sub IOMMU_CAP_NPCACHE () {26;}' unless defined(&IOMMU_CAP_NPCACHE);
    eval 'sub MAX_DOMAIN_ID () {65536;}' unless defined(&MAX_DOMAIN_ID);
}
1;
