require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_X86_64_ATOMIC__)) {
    eval 'sub __ARCH_X86_64_ATOMIC__ () {1;}' unless defined(&__ARCH_X86_64_ATOMIC__);
    require 'asm/alternative.ph';
    require 'asm/cmpxchg.ph';
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC_INIT);
    eval 'sub atomic_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic_read);
    eval 'sub atomic_set {
        my($v, $i) = @_;
	    eval q(((($v)-> &counter) = ($i)));
    }' unless defined(&atomic_set);
    eval 'sub atomic_sub_return {
        my($i,$v) = @_;
	    eval q({  &atomic_add_return(-$i, $v); });
    }' unless defined(&atomic_sub_return);
    eval 'sub atomic_inc_return {
        my($v) = @_;
	    eval q(( &atomic_add_return(1, $v)));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic_dec_return {
        my($v) = @_;
	    eval q(( &atomic_sub_return(1, $v)));
    }' unless defined(&atomic_dec_return);
    eval 'sub ATOMIC64_INIT {
        my($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC64_INIT);
    eval 'sub atomic64_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic64_read);
    eval 'sub atomic64_set {
        my($v, $i) = @_;
	    eval q(((($v)-> &counter) = ($i)));
    }' unless defined(&atomic64_set);
    eval 'sub atomic64_sub_return {
        my($i,$v) = @_;
	    eval q({  &atomic64_add_return(-$i, $v); });
    }' unless defined(&atomic64_sub_return);
    eval 'sub atomic64_inc_return {
        my($v) = @_;
	    eval q(( &atomic64_add_return(1, ($v))));
    }' unless defined(&atomic64_inc_return);
    eval 'sub atomic64_dec_return {
        my($v) = @_;
	    eval q(( &atomic64_sub_return(1, ($v))));
    }' unless defined(&atomic64_dec_return);
    eval 'sub atomic64_cmpxchg {
        my($v, $old, $new) = @_;
	    eval q(( &cmpxchg((($v)-> &counter), ($old), ($new))));
    }' unless defined(&atomic64_cmpxchg);
    eval 'sub atomic64_xchg {
        my($v, $new) = @_;
	    eval q(( &xchg((($v)-> &counter), $new)));
    }' unless defined(&atomic64_xchg);
    eval 'sub atomic_cmpxchg {
        my($v, $old, $new) = @_;
	    eval q(( &cmpxchg((($v)-> &counter), ($old), ($new))));
    }' unless defined(&atomic_cmpxchg);
    eval 'sub atomic_xchg {
        my($v, $new) = @_;
	    eval q(( &xchg((($v)-> &counter), ($new))));
    }' unless defined(&atomic_xchg);
    eval 'sub atomic_inc_not_zero {
        my($v) = @_;
	    eval q( &atomic_add_unless(($v), 1, 0));
    }' unless defined(&atomic_inc_not_zero);
    eval 'sub atomic64_inc_not_zero {
        my($v) = @_;
	    eval q( &atomic64_add_unless(($v), 1, 0));
    }' unless defined(&atomic64_inc_not_zero);
    eval 'sub atomic_clear_mask {
        my($mask, $addr) = @_;
	    eval q( &asm  &volatile( &LOCK_PREFIX \\"andl %0,%1\\" : : \\"r\\" (~($mask)), \\"m\\" (*($addr)) : \\"memory\\"));
    }' unless defined(&atomic_clear_mask);
    eval 'sub atomic_set_mask {
        my($mask, $addr) = @_;
	    eval q( &asm  &volatile( &LOCK_PREFIX \\"orl %0,%1\\" : : \\"r\\" (($mask)), \\"m\\" (*($addr)) : \\"memory\\"));
    }' unless defined(&atomic_set_mask);
    eval 'sub smp_mb__before_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_dec);
    eval 'sub smp_mb__after_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_dec);
    eval 'sub smp_mb__before_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_inc);
    eval 'sub smp_mb__after_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_inc);
    require 'asm-generic/atomic.ph';
}
1;
