require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_DESC_H_)) {
    eval 'sub _ASM_DESC_H_ () {1;}' unless defined(&_ASM_DESC_H_);
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/desc_defs.ph';
	require 'asm/ldt.ph';
	require 'asm/mmu.ph';
	require 'linux/smp.ph';
	eval 'sub fill_ldt {
	    my($desc,$info) = @_;
    	    eval q({  ($desc->{limit0}) =  ($info->{limit}) & 0xffff;  ($desc->{base0}) =  ($info->{base_addr}) & 0xffff;  ($desc->{base1}) = ( ($info->{base_addr}) & 0xff0000) >> 16;  ($desc->{type}) = ( ($info->{read_exec_only}) ^ 1) << 1;  ($desc->{type}) |=  ($info->{contents}) << 2;  ($desc->{s}) = 1;  ($desc->{dpl}) = 0x3;  ($desc->{p}) =  ($info->{seg_not_present}) ^ 1;  ($desc->{limit}) = ( ($info->{limit}) & 0xf0000) >> 16;  ($desc->{avl}) =  ($info->{useable});  ($desc->{d}) =  ($info->{seg_32bit});  ($desc->{g}) =  ($info->{limit_in_pages});  ($desc->{base2}) = ( ($info->{base_addr}) & 0xff000000) >> 24; });
	}' unless defined(&fill_ldt);
	eval 'sub desc_struct {
	    eval q(* &get_cpu_gdt_table {  &per_cpu( &gdt_page,  &cpu). &gdt; });
	}' unless defined(&desc_struct);
	if(defined(&CONFIG_X86_64)) {
	    eval 'sub pack_gate {
	        my($gate,$type,$func,$dpl,$ist,$seg) = @_;
    		eval q({  ($gate->{offset_low}) =  &PTR_LOW($func);  ($gate->{segment}) =  &__KERNEL_CS;  ($gate->{ist}) = $ist;  ($gate->{p}) = 1;  ($gate->{dpl}) = $dpl;  ($gate->{zero0}) = 0;  ($gate->{zero1}) = 0;  ($gate->{type}) = $type;  ($gate->{offset_middle}) =  &PTR_MIDDLE($func);  ($gate->{offset_high}) =  &PTR_HIGH($func); });
	    }' unless defined(&pack_gate);
	} else {
	    eval 'sub pack_gate {
	        my($gate,$type,$base,$dpl,$flags,$seg) = @_;
    		eval q({  ($gate->{a}) = ($seg << 16) | ($base & 0xffff);  ($gate->{b}) = ($base & 0xffff0000) | (((0x80 | $type | ($dpl << 5)) & 0xff) << 8); });
	    }' unless defined(&pack_gate);
	}
	eval 'sub desc_empty {
	    my($ptr) = @_;
    	    eval q({  &const  &u32 * &desc = $ptr; !( $desc[0] |  $desc[1]); });
	}' unless defined(&desc_empty);
	if(defined(&CONFIG_PARAVIRT)) {
	    require 'asm/paravirt.ph';
	} else {
	    eval 'sub load_TR_desc () {
	        eval q( &native_load_tr_desc());
	    }' unless defined(&load_TR_desc);
	    eval 'sub load_gdt {
	        my($dtr) = @_;
    		eval q( &native_load_gdt($dtr));
	    }' unless defined(&load_gdt);
	    eval 'sub load_idt {
	        my($dtr) = @_;
    		eval q( &native_load_idt($dtr));
	    }' unless defined(&load_idt);
	    eval 'sub load_tr {
	        my($tr) = @_;
    		eval q( &asm  &volatile(\\"ltr %0\\"::\\"m\\" ($tr)));
	    }' unless defined(&load_tr);
	    eval 'sub load_ldt {
	        my($ldt) = @_;
    		eval q( &asm  &volatile(\\"lldt %0\\"::\\"m\\" ($ldt)));
	    }' unless defined(&load_ldt);
	    eval 'sub store_gdt {
	        my($dtr) = @_;
    		eval q( &native_store_gdt($dtr));
	    }' unless defined(&store_gdt);
	    eval 'sub store_idt {
	        my($dtr) = @_;
    		eval q( &native_store_idt($dtr));
	    }' unless defined(&store_idt);
	    eval 'sub store_tr {
	        my($tr) = @_;
    		eval q(($tr =  &native_store_tr()));
	    }' unless defined(&store_tr);
	    eval 'sub store_ldt {
	        my($ldt) = @_;
    		eval q( &asm(\\"sldt %0\\":\\"=m\\" ($ldt)));
	    }' unless defined(&store_ldt);
	    eval 'sub load_TLS {
	        my($t, $cpu) = @_;
    		eval q( &native_load_tls($t, $cpu));
	    }' unless defined(&load_TLS);
	    eval 'sub set_ldt () { &native_set_ldt;}' unless defined(&set_ldt);
	    eval 'sub write_ldt_entry {
	        my($dt, $entry, $desc) = @_;
    		eval q( &native_write_ldt_entry($dt, $entry, $desc));
	    }' unless defined(&write_ldt_entry);
	    eval 'sub write_gdt_entry {
	        my($dt, $entry, $desc, $type) = @_;
    		eval q( &native_write_gdt_entry($dt, $entry, $desc, $type));
	    }' unless defined(&write_gdt_entry);
	    eval 'sub write_idt_entry {
	        my($dt, $entry, $g) = @_;
    		eval q( &native_write_idt_entry($dt, $entry, $g));
	    }' unless defined(&write_idt_entry);
	}
	eval 'sub native_write_idt_entry {
	    my($idt,$entry,$gate) = @_;
    	    eval q({  &memcpy($idt->[$entry], $gate, $sizeof{$gate}); });
	}' unless defined(&native_write_idt_entry);
	eval 'sub native_write_ldt_entry {
	    my($ldt,$entry,$desc) = @_;
    	    eval q({  &memcpy($ldt->[$entry], $desc, 8); });
	}' unless defined(&native_write_ldt_entry);
	eval 'sub native_write_gdt_entry {
	    my($gdt,$entry,$desc,$type) = @_;
    	    eval q({ my $size;  &switch ($type) {  &case  &DESC_TSS:  $size = $sizeof{ &tss_desc};  &break;  &case  &DESC_LDT:  $size = $sizeof{ &ldt_desc};  &break;  &default:  $size = $sizeof{\'struct desc_struct\'};  &break; }  &memcpy($gdt->[$entry], $desc,  $size); });
	}' unless defined(&native_write_gdt_entry);
	eval 'sub pack_descriptor {
	    my($desc,$base,$limit,$type,$flags) = @_;
    	    eval q({  ($desc->{a}) = (($base & 0xffff) << 16) | ($limit & 0xffff);  ($desc->{b}) = ($base & 0xff000000) | (($base & 0xff0000) >> 16) | ($limit & 0xf0000) | (($type & 0xff) << 8) | (($flags & 0xf) << 20);  ($desc->{p}) = 1; });
	}' unless defined(&pack_descriptor);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub set_tssldt_descriptor {
	    my($d,$addr,$type,$size) = @_;
    	    eval q({ });
	}' unless defined(&set_tssldt_descriptor);
	eval 'sub __set_tss_desc {
	    my($cpu,$entry,$addr) = @_;
    	    eval q({ \'struct desc_struct\' * &d =  &get_cpu_gdt_table;  &tss_desc  &tss;  &set_tssldt_descriptor( &tss, $addr,  &DESC_TSS,  &IO_BITMAP_OFFSET +  &IO_BITMAP_BYTES + $sizeof{my $long} - 1);  &write_gdt_entry( &d, $entry,  &tss,  &DESC_TSS); });
	}' unless defined(&__set_tss_desc);
	eval 'sub set_tss_desc {
	    my($cpu, $addr) = @_;
    	    eval q( &__set_tss_desc($cpu,  &GDT_ENTRY_TSS, $addr));
	}' unless defined(&set_tss_desc);
	eval 'sub native_set_ldt {
	    my($addr,$entries) = @_;
    	    eval q({  &if ( &likely($entries == 0))  &asm  &volatile(\\"lldt %w0\\"::\\"q\\" );  &else { my $cpu =  &smp_processor_id();  &ldt_desc  &ldt;  &set_tssldt_descriptor( &ldt, $addr,  &DESC_LDT, $entries *  &LDT_ENTRY_SIZE - 1);  &write_gdt_entry( &get_cpu_gdt_table( $cpu),  &GDT_ENTRY_LDT,  &ldt,  &DESC_LDT);  &asm  &volatile(\\"lldt %w0\\"::\\"q\\" ( &GDT_ENTRY_LDT*8)); } });
	}' unless defined(&native_set_ldt);
	eval 'sub native_load_tr_desc {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"ltr %w0\\"::\\"q\\" ( &GDT_ENTRY_TSS*8)); });
	}' unless defined(&native_load_tr_desc);
	eval 'sub native_load_gdt {
	    my($dtr) = @_;
    	    eval q({  &asm  &volatile(\\"lgdt %0\\"::\\"m\\" (*$dtr)); });
	}' unless defined(&native_load_gdt);
	eval 'sub native_load_idt {
	    my($dtr) = @_;
    	    eval q({  &asm  &volatile(\\"lidt %0\\"::\\"m\\" (*$dtr)); });
	}' unless defined(&native_load_idt);
	eval 'sub native_store_gdt {
	    my($dtr) = @_;
    	    eval q({  &asm  &volatile(\\"sgdt %0\\":\\"=m\\" (*$dtr)); });
	}' unless defined(&native_store_gdt);
	eval 'sub native_store_idt {
	    my($dtr) = @_;
    	    eval q({  &asm  &volatile(\\"sidt %0\\":\\"=m\\" (*$dtr)); });
	}' unless defined(&native_store_idt);
	eval 'sub native_store_tr {
	    my($void) = @_;
    	    eval q({ my $tr;  &asm  &volatile(\\"str %0\\":\\"=r\\" ( $tr));  $tr; });
	}' unless defined(&native_store_tr);
	eval 'sub native_load_tls {
	    my($t,$cpu) = @_;
    	    eval q({ my $i; \'struct desc_struct\' * &gdt =  &get_cpu_gdt_table($cpu);  &for ( $i = 0;  $i <  &GDT_ENTRY_TLS_ENTRIES;  $i++)  $gdt[ &GDT_ENTRY_TLS_MIN +  $i] =  ($t->{tls_array[$i]}); });
	}' unless defined(&native_load_tls);
	eval 'sub _LDT_empty {
	    my($info) = @_;
    	    eval q((($info)-> &base_addr == 0 && ($info)-> &limit == 0 && ($info)-> &contents == 0 && ($info)-> &read_exec_only == 1 && ($info)-> &seg_32bit == 0 && ($info)-> &limit_in_pages == 0 && ($info)-> &seg_not_present == 1 && ($info)-> &useable == 0));
	}' unless defined(&_LDT_empty);
	if(defined(&CONFIG_X86_64)) {
	    eval 'sub LDT_empty {
	        my($info) = @_;
    		eval q(( &_LDT_empty($info)  && (($info)-> &lm == 0)));
	    }' unless defined(&LDT_empty);
	} else {
	    eval 'sub LDT_empty {
	        my($info) = @_;
    		eval q(( &_LDT_empty($info)));
	    }' unless defined(&LDT_empty);
	}
	eval 'sub clear_LDT {
	    my($void) = @_;
    	    eval q({  &set_ldt( &NULL, 0); });
	}' unless defined(&clear_LDT);
	eval 'sub load_LDT {
	    my($pc) = @_;
    	    eval q({  &preempt_disable();  &load_LDT_nolock($pc);  &preempt_enable(); });
	}' unless defined(&load_LDT);
	eval 'sub get_desc_base {
	    my($desc) = @_;
    	    eval q({  ($desc->{base0}) | (( ($desc->{base1})) << 16) | (( ($desc->{base2})) << 24); });
	}' unless defined(&get_desc_base);
	eval 'sub get_desc_limit {
	    my($desc) = @_;
    	    eval q({  ($desc->{limit0}) | ( ($desc->{limit}) << 16); });
	}' unless defined(&get_desc_limit);
	eval 'sub _set_gate {
	    my($gate,$type,$addr,$dpl,$ist,$seg) = @_;
    	    eval q({  &gate_desc  &s;  &pack_gate( &s, $type, $addr, $dpl, $ist, $seg);  &write_idt_entry( &idt_table, $gate,  &s); });
	}' unless defined(&_set_gate);
	eval 'sub SYS_VECTOR_FREE () {0;}' unless defined(&SYS_VECTOR_FREE);
	eval 'sub SYS_VECTOR_ALLOCED () {1;}' unless defined(&SYS_VECTOR_ALLOCED);
	eval 'sub alloc_system_vector {
	    my($vector) = @_;
    	    eval q({  &if ( $system_vectors[$vector] ==  &SYS_VECTOR_FREE) {  $system_vectors[$vector] =  &SYS_VECTOR_ALLOCED;  &if ( &first_system_vector > $vector)  &first_system_vector = $vector; }  &else  &BUG(); });
	}' unless defined(&alloc_system_vector);
	eval 'sub alloc_intr_gate {
	    my($n,$addr) = @_;
    	    eval q({  &alloc_system_vector($n);  &set_intr_gate($n, $addr); });
	}' unless defined(&alloc_intr_gate);
	eval 'sub set_trap_gate {
	    my($n,$addr) = @_;
    	    eval q({  &BUG_ON($n > 0xff);  &_set_gate($n,  &GATE_TRAP, $addr, 0, 0,  &__KERNEL_CS); });
	}' unless defined(&set_trap_gate);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub set_system_gate {
	    my($n,$addr) = @_;
    	    eval q({  &BUG_ON($n > 0xff); });
	}' unless defined(&set_system_gate);
	eval 'sub set_task_gate {
	    my($n,$gdt_entry) = @_;
    	    eval q({  &BUG_ON($n > 0xff);  &_set_gate($n,  &GATE_TASK, ( &void *)0, 0, 0, ($gdt_entry<<3)); });
	}' unless defined(&set_task_gate);
	eval 'sub set_intr_gate_ist {
	    my($n,$addr,$ist) = @_;
    	    eval q({  &BUG_ON($n > 0xff);  &_set_gate($n,  &GATE_INTERRUPT, $addr, 0, $ist,  &__KERNEL_CS); });
	}' unless defined(&set_intr_gate_ist);
	eval 'sub set_system_gate_ist {
	    my($n,$addr,$ist) = @_;
    	    eval q({  &BUG_ON($n > 0xff);  &_set_gate($n,  &GATE_INTERRUPT, $addr, 0x3, $ist,  &__KERNEL_CS); });
	}' unless defined(&set_system_gate_ist);
    } else {
	eval 'sub GET_DESC_BASE {
	    my($idx, $gdt, $base, $lo_w, $lo_b, $hi_b) = @_;
    	    eval q( &movb $idx * 8+ 4($gdt), $lo_b;  &movb $idx * 8+ 7($gdt), $hi_b;  &shll $16, $base;  &movw $idx * 8+ 2($gdt), $lo_w;);
	}' unless defined(&GET_DESC_BASE);
    }
}
1;
