require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_ELF_H)) {
    eval 'sub _ASM_X86_ELF_H () {1;}' unless defined(&_ASM_X86_ELF_H);
    require 'asm/ptrace.ph';
    require 'asm/user.ph';
    require 'asm/auxvec.ph';
    eval 'sub ELF_NGREG () {($sizeof{\'struct user_regs_struct\'} / $sizeof{ &elf_greg_t});}' unless defined(&ELF_NGREG);
    if(defined(&__i386__)) {
	eval 'sub R_386_NONE () {0;}' unless defined(&R_386_NONE);
	eval 'sub R_386_32 () {1;}' unless defined(&R_386_32);
	eval 'sub R_386_PC32 () {2;}' unless defined(&R_386_PC32);
	eval 'sub R_386_GOT32 () {3;}' unless defined(&R_386_GOT32);
	eval 'sub R_386_PLT32 () {4;}' unless defined(&R_386_PLT32);
	eval 'sub R_386_COPY () {5;}' unless defined(&R_386_COPY);
	eval 'sub R_386_GLOB_DAT () {6;}' unless defined(&R_386_GLOB_DAT);
	eval 'sub R_386_JMP_SLOT () {7;}' unless defined(&R_386_JMP_SLOT);
	eval 'sub R_386_RELATIVE () {8;}' unless defined(&R_386_RELATIVE);
	eval 'sub R_386_GOTOFF () {9;}' unless defined(&R_386_GOTOFF);
	eval 'sub R_386_GOTPC () {10;}' unless defined(&R_386_GOTPC);
	eval 'sub R_386_NUM () {11;}' unless defined(&R_386_NUM);
	eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
	eval 'sub ELF_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_DATA);
	eval 'sub ELF_ARCH () { &EM_386;}' unless defined(&ELF_ARCH);
    } else {
	eval 'sub R_X86_64_NONE () {0;}' unless defined(&R_X86_64_NONE);
	eval 'sub R_X86_64_64 () {1;}' unless defined(&R_X86_64_64);
	eval 'sub R_X86_64_PC32 () {2;}' unless defined(&R_X86_64_PC32);
	eval 'sub R_X86_64_GOT32 () {3;}' unless defined(&R_X86_64_GOT32);
	eval 'sub R_X86_64_PLT32 () {4;}' unless defined(&R_X86_64_PLT32);
	eval 'sub R_X86_64_COPY () {5;}' unless defined(&R_X86_64_COPY);
	eval 'sub R_X86_64_GLOB_DAT () {6;}' unless defined(&R_X86_64_GLOB_DAT);
	eval 'sub R_X86_64_JUMP_SLOT () {7;}' unless defined(&R_X86_64_JUMP_SLOT);
	eval 'sub R_X86_64_RELATIVE () {8;}' unless defined(&R_X86_64_RELATIVE);
	eval 'sub R_X86_64_GOTPCREL () {9;}' unless defined(&R_X86_64_GOTPCREL);
	eval 'sub R_X86_64_32 () {10;}' unless defined(&R_X86_64_32);
	eval 'sub R_X86_64_32S () {11;}' unless defined(&R_X86_64_32S);
	eval 'sub R_X86_64_16 () {12;}' unless defined(&R_X86_64_16);
	eval 'sub R_X86_64_PC16 () {13;}' unless defined(&R_X86_64_PC16);
	eval 'sub R_X86_64_8 () {14;}' unless defined(&R_X86_64_8);
	eval 'sub R_X86_64_PC8 () {15;}' unless defined(&R_X86_64_PC8);
	eval 'sub R_X86_64_NUM () {16;}' unless defined(&R_X86_64_NUM);
	eval 'sub ELF_CLASS () { &ELFCLASS64;}' unless defined(&ELF_CLASS);
	eval 'sub ELF_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_DATA);
	eval 'sub ELF_ARCH () { &EM_X86_64;}' unless defined(&ELF_ARCH);
    }
    require 'asm/vdso.ph';
    eval 'sub elf_check_arch_ia32 {
        my($x) = @_;
	    eval q(((($x)-> &e_machine ==  &EM_386) || (($x)-> &e_machine ==  &EM_486)));
    }' unless defined(&elf_check_arch_ia32);
    require 'asm/processor.ph';
    require 'asm/system.ph';
    if(defined(&CONFIG_X86_32)) {
	require 'asm/desc.ph';
	eval 'sub elf_check_arch {
	    my($x) = @_;
    	    eval q( &elf_check_arch_ia32($x));
	}' unless defined(&elf_check_arch);
	eval 'sub ELF_PLAT_INIT {
	    my($_r, $load_addr) = @_;
    	    eval q( &do {  ($_r->{bx}) = 0;  ($_r->{cx}) = 0;  ($_r->{dx}) = 0;  ($_r->{si}) = 0;  ($_r->{di}) = 0;  ($_r->{bp}) = 0;  ($_r->{ax}) = 0; }  &while (0));
	}' unless defined(&ELF_PLAT_INIT);
	eval 'sub ELF_CORE_COPY_REGS {
	    my($pr_reg, $regs) = @_;
    	    eval q( &do { $pr_reg->[0] =  ($regs->{bx}); $pr_reg->[1] =  ($regs->{cx}); $pr_reg->[2] =  ($regs->{dx}); $pr_reg->[3] =  ($regs->{si}); $pr_reg->[4] =  ($regs->{di}); $pr_reg->[5] =  ($regs->{bp}); $pr_reg->[6] =  ($regs->{ax}); $pr_reg->[7] =  ($regs->{ds}) & 0xffff; $pr_reg->[8] =  ($regs->{es}) & 0xffff; $pr_reg->[9] =  ($regs->{fs}) & 0xffff;  &savesegment( &gs, $pr_reg->[10]); $pr_reg->[11] =  ($regs->{orig_ax}); $pr_reg->[12] =  ($regs->{ip}); $pr_reg->[13] =  ($regs->{cs}) & 0xffff; $pr_reg->[14] =  ($regs->{flags}); $pr_reg->[15] =  ($regs->{sp}); $pr_reg->[16] =  ($regs->{ss}) & 0xffff; }  &while (0););
	}' unless defined(&ELF_CORE_COPY_REGS);
	eval 'sub ELF_PLATFORM () {( &utsname()-> &machine);}' unless defined(&ELF_PLATFORM);
	eval 'sub set_personality_64bit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&set_personality_64bit);
    } else {
	eval 'sub elf_check_arch {
	    my($x) = @_;
    	    eval q((($x)-> &e_machine ==  &EM_X86_64));
	}' unless defined(&elf_check_arch);
	eval 'sub compat_elf_check_arch {
	    my($x) = @_;
    	    eval q( &elf_check_arch_ia32($x));
	}' unless defined(&compat_elf_check_arch);
	eval 'sub start_ia32_thread {
	    my($regs,$ip,$sp) = @_;
    	    eval q({  &asm  &volatile(\\"movl %0,%%fs\\" :: \\"r\\" (0));  &asm  &volatile(\\"movl %0,%%es; movl %0,%%ds\\" : : \\"r\\" ( &__USER32_DS));  &load_gs_index(0);  ($regs->{ip}) = $ip;  ($regs->{sp}) = $sp;  ($regs->{flags}) =  &X86_EFLAGS_IF;  ($regs->{cs}) =  &__USER32_CS;  ($regs->{ss}) =  &__USER32_DS; });
	}' unless defined(&start_ia32_thread);
	eval 'sub elf_common_init {
	    my($t,$regs,$ds) = @_;
    	    eval q({  ($regs->{ax}) =  ($regs->{bx}) =  ($regs->{cx}) =  ($regs->{dx}) = 0;  ($regs->{si}) =  ($regs->{di}) =  ($regs->{bp}) = 0;  ($regs->{r8}) =  ($regs->{r9}) =  ($regs->{r10}) =  ($regs->{r11}) = 0;  ($regs->{r12}) =  ($regs->{r13}) =  ($regs->{r14}) =  ($regs->{r15}) = 0;  ($t->{fs}) =  ($t->{gs}) = 0;  ($t->{fsindex}) =  ($t->{gsindex}) = 0;  ($t->{ds}) =  ($t->{es}) = $ds; });
	}' unless defined(&elf_common_init);
	eval 'sub ELF_PLAT_INIT {
	    my($_r, $load_addr) = @_;
    	    eval q( &do {  &elf_common_init( ($current->{thread}), $_r, 0);  &clear_thread_flag( &TIF_IA32); }  &while (0));
	}' unless defined(&ELF_PLAT_INIT);
	eval 'sub COMPAT_ELF_PLAT_INIT {
	    my($regs, $load_addr) = @_;
    	    eval q( &elf_common_init( ($current->{thread}), $regs,  &__USER_DS));
	}' unless defined(&COMPAT_ELF_PLAT_INIT);
	eval 'sub compat_start_thread {
	    my($regs, $ip, $sp) = @_;
    	    eval q( &do {  &start_ia32_thread($regs, $ip, $sp);  &set_fs( &USER_DS); }  &while (0));
	}' unless defined(&compat_start_thread);
	eval 'sub COMPAT_SET_PERSONALITY {
	    my($ex, $ibcs2) = @_;
    	    eval q( &do {  &if ( &test_thread_flag( &TIF_IA32))  &clear_thread_flag( &TIF_ABI_PENDING);  &else  &set_thread_flag( &TIF_ABI_PENDING);  ($current->{personality}) |=  &force_personality32; }  &while (0));
	}' unless defined(&COMPAT_SET_PERSONALITY);
	eval 'sub COMPAT_ELF_PLATFORM () {("i686");}' unless defined(&COMPAT_ELF_PLATFORM);
	eval 'sub ELF_CORE_COPY_REGS {
	    my($pr_reg, $regs) = @_;
    	    eval q( &do { \'unsigned v\'; ($pr_reg)[0] = ($regs)-> &r15; ($pr_reg)[1] = ($regs)-> &r14; ($pr_reg)[2] = ($regs)-> &r13; ($pr_reg)[3] = ($regs)-> &r12; ($pr_reg)[4] = ($regs)-> &bp; ($pr_reg)[5] = ($regs)-> &bx; ($pr_reg)[6] = ($regs)-> &r11; ($pr_reg)[7] = ($regs)-> &r10; ($pr_reg)[8] = ($regs)-> &r9; ($pr_reg)[9] = ($regs)-> &r8; ($pr_reg)[10] = ($regs)-> &ax; ($pr_reg)[11] = ($regs)-> &cx; ($pr_reg)[12] = ($regs)-> &dx; ($pr_reg)[13] = ($regs)-> &si; ($pr_reg)[14] = ($regs)-> &di; ($pr_reg)[15] = ($regs)-> &orig_ax; ($pr_reg)[16] = ($regs)-> &ip; ($pr_reg)[17] = ($regs)-> &cs; ($pr_reg)[18] = ($regs)-> &flags; ($pr_reg)[19] = ($regs)-> &sp; ($pr_reg)[20] = ($regs)-> &ss; ($pr_reg)[21] =  ($current->{thread}->{fs}); ($pr_reg)[22] =  ($current->{thread}->{gs});  &asm(\\"movl %%ds,%0\\" : \\"=r\\" ( &v)); ($pr_reg)[23] =  &v;  &asm(\\"movl %%es,%0\\" : \\"=r\\" ( &v)); ($pr_reg)[24] =  &v;  &asm(\\"movl %%fs,%0\\" : \\"=r\\" ( &v)); ($pr_reg)[25] =  &v;  &asm(\\"movl %%gs,%0\\" : \\"=r\\" ( &v)); ($pr_reg)[26] =  &v; }  &while (0););
	}' unless defined(&ELF_CORE_COPY_REGS);
	eval 'sub ELF_PLATFORM () {("x86_64");}' unless defined(&ELF_PLATFORM);
    }
    eval 'sub CORE_DUMP_USE_REGSET () {1;}' unless defined(&CORE_DUMP_USE_REGSET);
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    eval 'sub ELF_EXEC_PAGESIZE () {4096;}' unless defined(&ELF_EXEC_PAGESIZE);
    eval 'sub ELF_ET_DYN_BASE () {( &TASK_SIZE / 3* 2);}' unless defined(&ELF_ET_DYN_BASE);
    eval 'sub ELF_HWCAP () {( ($boot_cpu_data->{x86_capability[0]}));}' unless defined(&ELF_HWCAP);
    eval 'sub SET_PERSONALITY {
        my($ex, $ibcs2) = @_;
	    eval q( &set_personality_64bit());
    }' unless defined(&SET_PERSONALITY);
    eval 'sub elf_read_implies_exec {
        my($ex, $executable_stack) = @_;
	    eval q(($executable_stack !=  &EXSTACK_DISABLE_X));
    }' unless defined(&elf_read_implies_exec);
    eval 'sub ARCH_DLINFO_IA32 {
        my($vdso_enabled) = @_;
	    eval q( &do {  &if ($vdso_enabled) {  &NEW_AUX_ENT( &AT_SYSINFO,  &VDSO_ENTRY);  &NEW_AUX_ENT( &AT_SYSINFO_EHDR,  &VDSO_CURRENT_BASE); } }  &while (0));
    }' unless defined(&ARCH_DLINFO_IA32);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub VDSO_HIGH_BASE () {( &__fix_to_virt( &FIX_VDSO));}' unless defined(&VDSO_HIGH_BASE);
	eval 'sub ARCH_DLINFO () { &ARCH_DLINFO_IA32( &vdso_enabled);}' unless defined(&ARCH_DLINFO);
    } else {
	eval 'sub VDSO_HIGH_BASE () {0xffffe000;}' unless defined(&VDSO_HIGH_BASE);
	eval 'sub STACK_RND_MASK () {( &test_thread_flag( &TIF_IA32) ? 0x7ff : 0x3fffff);}' unless defined(&STACK_RND_MASK);
	eval 'sub ARCH_DLINFO () { &do {  &if ( &vdso_enabled)  &NEW_AUX_ENT( &AT_SYSINFO_EHDR,  ($current->{mm}->{context}->{vdso})); }  &while (0);}' unless defined(&ARCH_DLINFO);
	eval 'sub AT_SYSINFO () {32;}' unless defined(&AT_SYSINFO);
	eval 'sub COMPAT_ARCH_DLINFO () { &ARCH_DLINFO_IA32( &sysctl_vsyscall32);}' unless defined(&COMPAT_ARCH_DLINFO);
	eval 'sub COMPAT_ELF_ET_DYN_BASE () {( &TASK_UNMAPPED_BASE + 0x1000000);}' unless defined(&COMPAT_ELF_ET_DYN_BASE);
    }
    eval 'sub VDSO_CURRENT_BASE () {( ($current->{mm}->{context}->{vdso}));}' unless defined(&VDSO_CURRENT_BASE);
    eval 'sub VDSO_ENTRY () {( &VDSO32_SYMBOL( &VDSO_CURRENT_BASE,  &vsyscall));}' unless defined(&VDSO_ENTRY);
    eval 'sub ARCH_HAS_SETUP_ADDITIONAL_PAGES () {1;}' unless defined(&ARCH_HAS_SETUP_ADDITIONAL_PAGES);
    eval 'sub compat_arch_setup_additional_pages () { &syscall32_setup_pages;}' unless defined(&compat_arch_setup_additional_pages);
    eval 'sub arch_randomize_brk () { &arch_randomize_brk;}' unless defined(&arch_randomize_brk);
}
1;
