require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_IO_H)) {
    eval 'sub _ASM_X86_IO_H () {1;}' unless defined(&_ASM_X86_IO_H);
    eval 'sub ARCH_HAS_IOREMAP_WC () {1;}' unless defined(&ARCH_HAS_IOREMAP_WC);
    require 'linux/compiler.ph';
    unless(defined(&__ASSEMBLY__)) {
    }
    eval 'sub build_mmio_read {
        my($name, $size, $type, $reg, $barrier) = @_;
	    eval q( &static  &inline $type $name( &const  &volatile  &void  &__iomem * &addr) { $type  &ret;  &asm  &volatile(\\"mov\\" $size \\" %1,%0\\":$reg ( &ret) :\\"m\\" (*( &volatile $type  &__force *) &addr) $barrier);  &return  &ret; });
    }' unless defined(&build_mmio_read);
    eval 'sub build_mmio_write {
        my($name, $size, $type, $reg, $barrier) = @_;
	    eval q( &static  &inline  &void $name($type  &val,  &volatile  &void  &__iomem * &addr) {  &asm  &volatile(\\"mov\\" $size \\" %0,%1\\": :$reg ( &val), \\"m\\" (*( &volatile $type  &__force *) &addr) $barrier); });
    }' unless defined(&build_mmio_write);
    eval 'sub readb_relaxed {
        my($a) = @_;
	    eval q( &__readb($a));
    }' unless defined(&readb_relaxed);
    eval 'sub readw_relaxed {
        my($a) = @_;
	    eval q( &__readw($a));
    }' unless defined(&readw_relaxed);
    eval 'sub readl_relaxed {
        my($a) = @_;
	    eval q( &__readl($a));
    }' unless defined(&readl_relaxed);
    eval 'sub __raw_readb () { &__readb;}' unless defined(&__raw_readb);
    eval 'sub __raw_readw () { &__readw;}' unless defined(&__raw_readw);
    eval 'sub __raw_readl () { &__readl;}' unless defined(&__raw_readl);
    eval 'sub __raw_writeb () { &__writeb;}' unless defined(&__raw_writeb);
    eval 'sub __raw_writew () { &__writew;}' unless defined(&__raw_writew);
    eval 'sub __raw_writel () { &__writel;}' unless defined(&__raw_writel);
    eval 'sub mmiowb () {
        eval q( &barrier());
    }' unless defined(&mmiowb);
    if(defined(&CONFIG_X86_64)) {
	eval 'sub readq_relaxed {
	    my($a) = @_;
    	    eval q( &__readq($a));
	}' unless defined(&readq_relaxed);
	eval 'sub __raw_readq () { &__readq;}' unless defined(&__raw_readq);
	eval 'sub __raw_writeq () { &writeq;}' unless defined(&__raw_writeq);
	eval 'sub readq () { &readq;}' unless defined(&readq);
	eval 'sub writeq () { &writeq;}' unless defined(&writeq);
    }
    if(defined(&CONFIG_X86_32)) {
	require 'io_32.ph';
    } else {
	require 'io_64.ph';
    }
}
1;
