require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IO_H)) {
    eval 'sub _ASM_IO_H () {1;}' unless defined(&_ASM_IO_H);
    require 'linux/string.ph';
    require 'linux/compiler.ph';
    eval 'sub IO_SPACE_LIMIT () {0xffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub XQUAD_PORTIO_BASE () {0xfe400000;}' unless defined(&XQUAD_PORTIO_BASE);
    eval 'sub XQUAD_PORTIO_QUAD () {0x40000;}' unless defined(&XQUAD_PORTIO_QUAD);
    if(defined(&__KERNEL__)) {
	require 'asm-generic/iomap.ph';
	require 'linux/vmalloc.ph';
	eval 'sub xlate_dev_kmem_ptr {
	    my($p) = @_;
    	    eval q($p);
	}' unless defined(&xlate_dev_kmem_ptr);
	eval 'sub page_to_phys {
	    my($page) = @_;
    	    eval q((( &dma_addr_t) &page_to_pfn($page) <<  &PAGE_SHIFT));
	}' unless defined(&page_to_phys);
	eval 'sub isa_virt_to_bus () { &virt_to_phys;}' unless defined(&isa_virt_to_bus);
	eval 'sub isa_page_to_bus () { &page_to_phys;}' unless defined(&isa_page_to_bus);
	eval 'sub isa_bus_to_virt () { &phys_to_virt;}' unless defined(&isa_bus_to_virt);
	eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
	eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
	eval 'sub memset_io {
	    my($addr,$val,$count) = @_;
    	    eval q({  &memset(( &void  &__force *)$addr, $val, $count); });
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    my($dst,$src,$count) = @_;
    	    eval q({  &__memcpy($dst, ( &const  &void  &__force *)$src, $count); });
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    my($dst,$src,$count) = @_;
    	    eval q({  &__memcpy(( &void  &__force *)$dst, $src, $count); });
	}' unless defined(&memcpy_toio);
	eval 'sub __ISA_IO_base () {((\'char\'  &__iomem *)( &PAGE_OFFSET));}' unless defined(&__ISA_IO_base);
	if(defined( &CONFIG_X86_OOSTORE) || defined( &CONFIG_X86_PPRO_FENCE)) {
	    eval 'sub flush_write_buffers {
	        my($void) = @_;
    		eval q({  &asm  &volatile(\\"lock; addl $0,0(%%esp)\\": : :\\"memory\\"); });
	    }' unless defined(&flush_write_buffers);
	} else {
	    eval 'sub flush_write_buffers () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&flush_write_buffers);
	}
    }
    if(defined( &CONFIG_PARAVIRT)) {
	require 'asm/paravirt.ph';
    } else {
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub slow_down_io {
	    my($void) = @_;
    	    eval q({  &native_io_delay(); });
	}' unless defined(&slow_down_io);
    }
    eval 'sub __BUILDIO {
        my($bwl, $bw, $type) = @_;
	    eval q( &static  &inline  &void  &out$bwl(\'unsigned type value\', \'int\'  &port) {  &out$bwl &_local( &value,  &port); }  &static  &inline \'unsigned type in\'$bwl(\'int\'  &port) {  &return  &in$bwl &_local( &port); });
    }' unless defined(&__BUILDIO);
    eval 'sub BUILDIO {
        my($bwl, $bw, $type) = @_;
	    eval q( &static  &inline  &void  &out$bwl &_local(\'unsigned type value\', \'int\'  &port) {  &asm  &volatile(\\"out\\" $bwl \\" %\\" $bw \\"0, %w1\\" : : \\"a\\"( &value), \\"Nd\\"( &port)); }  &static  &inline \'unsigned type in\'$bwl &_local(\'int\'  &port) { \'unsigned type value\';  &asm  &volatile(\\"in\\" $bwl \\" %w1, %\\" $bw \\"0\\" : \\"=a\\"( &value) : \\"Nd\\"( &port));  &return  &value; }  &static  &inline  &void  &out$bwl &_local_p(\'unsigned type value\', \'int\'  &port) {  &out$bwl &_local( &value,  &port);  &slow_down_io(); }  &static  &inline \'unsigned type in\'$bwl &_local_p(\'int\'  &port) { \'unsigned type value\' =  &in$bwl &_local( &port);  &slow_down_io();  &return  &value; }  &__BUILDIO($bwl, $bw, $type)  &static  &inline  &void  &out$bwl &_p(\'unsigned type value\', \'int\'  &port) {  &out$bwl( &value,  &port);  &slow_down_io(); }  &static  &inline \'unsigned type in\'$bwl &_p(\'int\'  &port) { \'unsigned type value\' =  &in$bwl( &port);  &slow_down_io();  &return  &value; }  &static  &inline  &void  &outs$bwl(\'int\'  &port,  &const  &void * &addr, \'unsigned long count\') {  &asm  &volatile(\\"rep; outs\\" $bwl : \\"+S\\"( &addr), \\"+c\\"( &count) : \\"d\\"( &port)); }  &static  &inline  &void  &ins$bwl(\'int\'  &port,  &void * &addr, \'unsigned long count\') {  &asm  &volatile(\\"rep; ins\\" $bwl : \\"+D\\"( &addr), \\"+c\\"( &count) : \\"d\\"( &port)); });
    }' unless defined(&BUILDIO);
}
1;
