require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IRQ_VECTORS_H)) {
    eval 'sub _ASM_IRQ_VECTORS_H () {1;}' unless defined(&_ASM_IRQ_VECTORS_H);
    require 'linux/threads.ph';
    eval 'sub NMI_VECTOR () {0x2;}' unless defined(&NMI_VECTOR);
    eval 'sub FIRST_EXTERNAL_VECTOR () {0x20;}' unless defined(&FIRST_EXTERNAL_VECTOR);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub SYSCALL_VECTOR () {0x80;}' unless defined(&SYSCALL_VECTOR);
    } else {
	eval 'sub IA32_SYSCALL_VECTOR () {0x80;}' unless defined(&IA32_SYSCALL_VECTOR);
    }
    eval 'sub IRQ_MOVE_CLEANUP_VECTOR () { &FIRST_EXTERNAL_VECTOR;}' unless defined(&IRQ_MOVE_CLEANUP_VECTOR);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub IRQ0_VECTOR () {( &FIRST_EXTERNAL_VECTOR);}' unless defined(&IRQ0_VECTOR);
    } else {
	eval 'sub IRQ0_VECTOR () {( &FIRST_EXTERNAL_VECTOR + 0x10);}' unless defined(&IRQ0_VECTOR);
    }
    eval 'sub IRQ1_VECTOR () {( &IRQ0_VECTOR + 1);}' unless defined(&IRQ1_VECTOR);
    eval 'sub IRQ2_VECTOR () {( &IRQ0_VECTOR + 2);}' unless defined(&IRQ2_VECTOR);
    eval 'sub IRQ3_VECTOR () {( &IRQ0_VECTOR + 3);}' unless defined(&IRQ3_VECTOR);
    eval 'sub IRQ4_VECTOR () {( &IRQ0_VECTOR + 4);}' unless defined(&IRQ4_VECTOR);
    eval 'sub IRQ5_VECTOR () {( &IRQ0_VECTOR + 5);}' unless defined(&IRQ5_VECTOR);
    eval 'sub IRQ6_VECTOR () {( &IRQ0_VECTOR + 6);}' unless defined(&IRQ6_VECTOR);
    eval 'sub IRQ7_VECTOR () {( &IRQ0_VECTOR + 7);}' unless defined(&IRQ7_VECTOR);
    eval 'sub IRQ8_VECTOR () {( &IRQ0_VECTOR + 8);}' unless defined(&IRQ8_VECTOR);
    eval 'sub IRQ9_VECTOR () {( &IRQ0_VECTOR + 9);}' unless defined(&IRQ9_VECTOR);
    eval 'sub IRQ10_VECTOR () {( &IRQ0_VECTOR + 10);}' unless defined(&IRQ10_VECTOR);
    eval 'sub IRQ11_VECTOR () {( &IRQ0_VECTOR + 11);}' unless defined(&IRQ11_VECTOR);
    eval 'sub IRQ12_VECTOR () {( &IRQ0_VECTOR + 12);}' unless defined(&IRQ12_VECTOR);
    eval 'sub IRQ13_VECTOR () {( &IRQ0_VECTOR + 13);}' unless defined(&IRQ13_VECTOR);
    eval 'sub IRQ14_VECTOR () {( &IRQ0_VECTOR + 14);}' unless defined(&IRQ14_VECTOR);
    eval 'sub IRQ15_VECTOR () {( &IRQ0_VECTOR + 15);}' unless defined(&IRQ15_VECTOR);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub SPURIOUS_APIC_VECTOR () {0xff;}' unless defined(&SPURIOUS_APIC_VECTOR);
	eval 'sub ERROR_APIC_VECTOR () {0xfe;}' unless defined(&ERROR_APIC_VECTOR);
	eval 'sub INVALIDATE_TLB_VECTOR () {0xfd;}' unless defined(&INVALIDATE_TLB_VECTOR);
	eval 'sub RESCHEDULE_VECTOR () {0xfc;}' unless defined(&RESCHEDULE_VECTOR);
	eval 'sub CALL_FUNCTION_VECTOR () {0xfb;}' unless defined(&CALL_FUNCTION_VECTOR);
	eval 'sub CALL_FUNCTION_SINGLE_VECTOR () {0xfa;}' unless defined(&CALL_FUNCTION_SINGLE_VECTOR);
	eval 'sub THERMAL_APIC_VECTOR () {0xf0;}' unless defined(&THERMAL_APIC_VECTOR);
    } else {
	eval 'sub SPURIOUS_APIC_VECTOR () {0xff;}' unless defined(&SPURIOUS_APIC_VECTOR);
	eval 'sub ERROR_APIC_VECTOR () {0xfe;}' unless defined(&ERROR_APIC_VECTOR);
	eval 'sub RESCHEDULE_VECTOR () {0xfd;}' unless defined(&RESCHEDULE_VECTOR);
	eval 'sub CALL_FUNCTION_VECTOR () {0xfc;}' unless defined(&CALL_FUNCTION_VECTOR);
	eval 'sub CALL_FUNCTION_SINGLE_VECTOR () {0xfb;}' unless defined(&CALL_FUNCTION_SINGLE_VECTOR);
	eval 'sub THERMAL_APIC_VECTOR () {0xfa;}' unless defined(&THERMAL_APIC_VECTOR);
	eval 'sub THRESHOLD_APIC_VECTOR () {0xf9;}' unless defined(&THRESHOLD_APIC_VECTOR);
	eval 'sub UV_BAU_MESSAGE () {0xf8;}' unless defined(&UV_BAU_MESSAGE);
	eval 'sub INVALIDATE_TLB_VECTOR_END () {0xf7;}' unless defined(&INVALIDATE_TLB_VECTOR_END);
	eval 'sub INVALIDATE_TLB_VECTOR_START () {0xf0;}' unless defined(&INVALIDATE_TLB_VECTOR_START);
	eval 'sub NUM_INVALIDATE_TLB_VECTORS () {8;}' unless defined(&NUM_INVALIDATE_TLB_VECTORS);
    }
    eval 'sub LOCAL_TIMER_VECTOR () {0xef;}' unless defined(&LOCAL_TIMER_VECTOR);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub FIRST_DEVICE_VECTOR () {0x31;}' unless defined(&FIRST_DEVICE_VECTOR);
    } else {
	eval 'sub FIRST_DEVICE_VECTOR () {( &IRQ15_VECTOR + 2);}' unless defined(&FIRST_DEVICE_VECTOR);
    }
    eval 'sub NR_VECTORS () {256;}' unless defined(&NR_VECTORS);
    eval 'sub FPU_IRQ () {13;}' unless defined(&FPU_IRQ);
    eval 'sub FIRST_VM86_IRQ () {3;}' unless defined(&FIRST_VM86_IRQ);
    eval 'sub LAST_VM86_IRQ () {15;}' unless defined(&LAST_VM86_IRQ);
    eval 'sub invalid_vm86_irq {
        my($irq) = @_;
	    eval q((($irq) < 3|| ($irq) > 15));
    }' unless defined(&invalid_vm86_irq);
    if(defined(&CONFIG_X86_64)) {
	if((defined(&NR_CPUS) ? &NR_CPUS : undef) < (defined(&MAX_IO_APICS) ? &MAX_IO_APICS : undef)) {
	    eval 'sub NR_IRQS () {( &NR_VECTORS + (32*  &NR_CPUS));}' unless defined(&NR_IRQS);
	} else {
	    eval 'sub NR_IRQS () {( &NR_VECTORS + (32*  &MAX_IO_APICS));}' unless defined(&NR_IRQS);
	}
	eval 'sub NR_IRQ_VECTORS () { &NR_IRQS;}' unless defined(&NR_IRQ_VECTORS);
    }
 elsif(!defined( &CONFIG_X86_VOYAGER)) {
	if(defined( &CONFIG_X86_IO_APIC) || defined( &CONFIG_PARAVIRT) || defined( &CONFIG_X86_VISWS)) {
	    eval 'sub NR_IRQS () {224;}' unless defined(&NR_IRQS);
	    if((224>= 32* (defined(&NR_CPUS) ? &NR_CPUS : undef))) {
		eval 'sub NR_IRQ_VECTORS () { &NR_IRQS;}' unless defined(&NR_IRQ_VECTORS);
	    } else {
		eval 'sub NR_IRQ_VECTORS () {(32*  &NR_CPUS);}' unless defined(&NR_IRQ_VECTORS);
	    }
	} else {
	    eval 'sub NR_IRQS () {16;}' unless defined(&NR_IRQS);
	    eval 'sub NR_IRQ_VECTORS () { &NR_IRQS;}' unless defined(&NR_IRQ_VECTORS);
	}
    } else {
	eval 'sub NR_IRQS () {224;}' unless defined(&NR_IRQS);
	eval 'sub NR_IRQ_VECTORS () { &NR_IRQS;}' unless defined(&NR_IRQ_VECTORS);
    }
    eval 'sub VIC_CPI_LEVEL0 () {0;}' unless defined(&VIC_CPI_LEVEL0);
    eval 'sub VIC_CPI_LEVEL1 () {1;}' unless defined(&VIC_CPI_LEVEL1);
    eval 'sub VIC_TIMER_CPI () {2;}' unless defined(&VIC_TIMER_CPI);
    eval 'sub VIC_INVALIDATE_CPI () {3;}' unless defined(&VIC_INVALIDATE_CPI);
    eval 'sub VIC_RESCHEDULE_CPI () {4;}' unless defined(&VIC_RESCHEDULE_CPI);
    eval 'sub VIC_ENABLE_IRQ_CPI () {5;}' unless defined(&VIC_ENABLE_IRQ_CPI);
    eval 'sub VIC_CALL_FUNCTION_CPI () {6;}' unless defined(&VIC_CALL_FUNCTION_CPI);
    eval 'sub VIC_CALL_FUNCTION_SINGLE_CPI () {7;}' unless defined(&VIC_CALL_FUNCTION_SINGLE_CPI);
    eval 'sub QIC_CPI_OFFSET () {1;}' unless defined(&QIC_CPI_OFFSET);
    eval 'sub QIC_TIMER_CPI () {( &VIC_TIMER_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_TIMER_CPI);
    eval 'sub QIC_INVALIDATE_CPI () {( &VIC_INVALIDATE_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_INVALIDATE_CPI);
    eval 'sub QIC_RESCHEDULE_CPI () {( &VIC_RESCHEDULE_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_RESCHEDULE_CPI);
    eval 'sub QIC_ENABLE_IRQ_CPI () {( &VIC_ENABLE_IRQ_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_ENABLE_IRQ_CPI);
    eval 'sub QIC_CALL_FUNCTION_CPI () {( &VIC_CALL_FUNCTION_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_CALL_FUNCTION_CPI);
    eval 'sub QIC_CALL_FUNCTION_SINGLE_CPI () {( &VIC_CALL_FUNCTION_SINGLE_CPI -  &QIC_CPI_OFFSET);}' unless defined(&QIC_CALL_FUNCTION_SINGLE_CPI);
    eval 'sub VIC_START_FAKE_CPI () { &VIC_TIMER_CPI;}' unless defined(&VIC_START_FAKE_CPI);
    eval 'sub VIC_END_FAKE_CPI () { &VIC_CALL_FUNCTION_SINGLE_CPI;}' unless defined(&VIC_END_FAKE_CPI);
    eval 'sub VIC_SYS_INT () {8;}' unless defined(&VIC_SYS_INT);
    eval 'sub VIC_CMN_INT () {15;}' unless defined(&VIC_CMN_INT);
    eval 'sub VIC_CPU_BOOT_CPI () { &VIC_CPI_LEVEL0;}' unless defined(&VIC_CPU_BOOT_CPI);
    eval 'sub VIC_CPU_BOOT_ERRATA_CPI () {( &VIC_CPI_LEVEL0 + 8);}' unless defined(&VIC_CPU_BOOT_ERRATA_CPI);
}
1;
