require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_IRQFLAGS_H_)) {
    eval 'sub _X86_IRQFLAGS_H_ () {1;}' unless defined(&_X86_IRQFLAGS_H_);
    require 'asm/processor-flags.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub native_restore_fl {
	    my($flags) = @_;
    	    eval q({  &asm  &volatile(\\"push %0 ; popf\\" : :\\"g\\" ($flags) :\\"memory\\", \\"cc\\"); });
	}' unless defined(&native_restore_fl);
	eval 'sub native_irq_disable {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"cli\\": : :\\"memory\\"); });
	}' unless defined(&native_irq_disable);
	eval 'sub native_irq_enable {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"sti\\": : :\\"memory\\"); });
	}' unless defined(&native_irq_enable);
	eval 'sub native_safe_halt {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"sti; hlt\\": : :\\"memory\\"); });
	}' unless defined(&native_safe_halt);
	eval 'sub native_halt {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"hlt\\": : :\\"memory\\"); });
	}' unless defined(&native_halt);
    }
    if(defined(&CONFIG_PARAVIRT)) {
	require 'asm/paravirt.ph';
    } else {
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub __raw_local_save_flags {
	        my($void) = @_;
    		eval q({  &native_save_fl(); });
	    }' unless defined(&__raw_local_save_flags);
	    eval 'sub raw_local_irq_restore {
	        my($flags) = @_;
    		eval q({  &native_restore_fl($flags); });
	    }' unless defined(&raw_local_irq_restore);
	    eval 'sub raw_local_irq_disable {
	        my($void) = @_;
    		eval q({  &native_irq_disable(); });
	    }' unless defined(&raw_local_irq_disable);
	    eval 'sub raw_local_irq_enable {
	        my($void) = @_;
    		eval q({  &native_irq_enable(); });
	    }' unless defined(&raw_local_irq_enable);
	} else {
	    eval 'sub ENABLE_INTERRUPTS {
	        my($x) = @_;
    		eval q( &sti);
	    }' unless defined(&ENABLE_INTERRUPTS);
	    eval 'sub DISABLE_INTERRUPTS {
	        my($x) = @_;
    		eval q( &cli);
	    }' unless defined(&DISABLE_INTERRUPTS);
	    if(defined(&CONFIG_X86_64)) {
		eval 'sub SWAPGS () { &swapgs;}' unless defined(&SWAPGS);
		eval 'sub SWAPGS_UNSAFE_STACK () { &swapgs;}' unless defined(&SWAPGS_UNSAFE_STACK);
		eval 'sub PARAVIRT_ADJUST_EXCEPTION_FRAME () {1;}' unless defined(&PARAVIRT_ADJUST_EXCEPTION_FRAME);
		eval 'sub INTERRUPT_RETURN () { &iretq;}' unless defined(&INTERRUPT_RETURN);
		eval 'sub USERGS_SYSRET64 () { &swapgs;  &sysretq;;}' unless defined(&USERGS_SYSRET64);
		eval 'sub USERGS_SYSRET32 () { &swapgs;  &sysretl;}' unless defined(&USERGS_SYSRET32);
		eval 'sub ENABLE_INTERRUPTS_SYSEXIT32 () { &swapgs;  &sti;  &sysexit;}' unless defined(&ENABLE_INTERRUPTS_SYSEXIT32);
	    } else {
		eval 'sub INTERRUPT_RETURN () { &iret;}' unless defined(&INTERRUPT_RETURN);
		eval 'sub ENABLE_INTERRUPTS_SYSEXIT () { &sti;  &sysexit;}' unless defined(&ENABLE_INTERRUPTS_SYSEXIT);
		eval 'sub GET_CR0_INTO_EAX () { &movl % &cr0, % &eax;}' unless defined(&GET_CR0_INTO_EAX);
	    }
	}
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub raw_local_save_flags {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &__raw_local_save_flags(); }  &while (0));
	}' unless defined(&raw_local_save_flags);
	eval 'sub raw_local_irq_save {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &__raw_local_irq_save(); }  &while (0));
	}' unless defined(&raw_local_irq_save);
	eval 'sub raw_irqs_disabled_flags {
	    my($flags) = @_;
    	    eval q({ !($flags &  &X86_EFLAGS_IF); });
	}' unless defined(&raw_irqs_disabled_flags);
	eval 'sub raw_irqs_disabled {
	    my($void) = @_;
    	    eval q({ my $flags =  &__raw_local_save_flags();  &raw_irqs_disabled_flags( $flags); });
	}' unless defined(&raw_irqs_disabled);
	eval 'sub trace_hardirqs_fixup {
	    my($void) = @_;
    	    eval q({ my $flags =  &__raw_local_save_flags();  &trace_hardirqs_fixup_flags( $flags); });
	}' unless defined(&trace_hardirqs_fixup);
    } else {
	if(defined(&CONFIG_X86_64)) {
	    eval 'sub ARCH_LOCKDEP_SYS_EXIT () { &call  &lockdep_sys_exit_thunk;}' unless defined(&ARCH_LOCKDEP_SYS_EXIT);
	    eval 'sub ARCH_LOCKDEP_SYS_EXIT_IRQ () { &TRACE_IRQS_ON;  &sti;  &SAVE_REST;  &LOCKDEP_SYS_EXIT;  &RESTORE_REST;  &cli;  &TRACE_IRQS_OFF;;}' unless defined(&ARCH_LOCKDEP_SYS_EXIT_IRQ);
	} else {
	    eval 'sub ARCH_LOCKDEP_SYS_EXIT () { &pushl % &eax;  &pushl % &ecx;  &pushl % &edx;  &call  &lockdep_sys_exit;  &popl % &edx;  &popl % &ecx;  &popl % &eax;;}' unless defined(&ARCH_LOCKDEP_SYS_EXIT);
	    eval 'sub ARCH_LOCKDEP_SYS_EXIT_IRQ () {1;}' unless defined(&ARCH_LOCKDEP_SYS_EXIT_IRQ);
	}
	if(defined(&CONFIG_TRACE_IRQFLAGS)) {
	    eval 'sub TRACE_IRQS_ON () { &call  &trace_hardirqs_on_thunk;;}' unless defined(&TRACE_IRQS_ON);
	    eval 'sub TRACE_IRQS_OFF () { &call  &trace_hardirqs_off_thunk;;}' unless defined(&TRACE_IRQS_OFF);
	} else {
	    eval 'sub TRACE_IRQS_ON () {1;}' unless defined(&TRACE_IRQS_ON);
	    eval 'sub TRACE_IRQS_OFF () {1;}' unless defined(&TRACE_IRQS_OFF);
	}
	if(defined(&CONFIG_DEBUG_LOCK_ALLOC)) {
	    eval 'sub LOCKDEP_SYS_EXIT () { &ARCH_LOCKDEP_SYS_EXIT;}' unless defined(&LOCKDEP_SYS_EXIT);
	    eval 'sub LOCKDEP_SYS_EXIT_IRQ () { &ARCH_LOCKDEP_SYS_EXIT_IRQ;}' unless defined(&LOCKDEP_SYS_EXIT_IRQ);
	} else {
	    eval 'sub LOCKDEP_SYS_EXIT () {1;}' unless defined(&LOCKDEP_SYS_EXIT);
	    eval 'sub LOCKDEP_SYS_EXIT_IRQ () {1;}' unless defined(&LOCKDEP_SYS_EXIT_IRQ);
	}
    }
}
1;
