require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ASM_KVM_HOST_H)) {
    eval 'sub ASM_KVM_HOST_H () {1;}' unless defined(&ASM_KVM_HOST_H);
    require 'linux/types.ph';
    require 'linux/mm.ph';
    require 'linux/mmu_notifier.ph';
    require 'linux/kvm.ph';
    require 'linux/kvm_para.ph';
    require 'linux/kvm_types.ph';
    require 'asm/pvclock-abi.ph';
    require 'asm/desc.ph';
    eval 'sub KVM_MAX_VCPUS () {16;}' unless defined(&KVM_MAX_VCPUS);
    eval 'sub KVM_MEMORY_SLOTS () {32;}' unless defined(&KVM_MEMORY_SLOTS);
    eval 'sub KVM_PRIVATE_MEM_SLOTS () {4;}' unless defined(&KVM_PRIVATE_MEM_SLOTS);
    eval 'sub KVM_PIO_PAGE_OFFSET () {1;}' unless defined(&KVM_PIO_PAGE_OFFSET);
    eval 'sub KVM_COALESCED_MMIO_PAGE_OFFSET () {2;}' unless defined(&KVM_COALESCED_MMIO_PAGE_OFFSET);
    eval 'sub CR3_PAE_RESERVED_BITS () {(( &X86_CR3_PWT |  &X86_CR3_PCD) - 1);}' unless defined(&CR3_PAE_RESERVED_BITS);
    eval 'sub CR3_NONPAE_RESERVED_BITS () {(( &PAGE_SIZE-1) & ~( &X86_CR3_PWT |  &X86_CR3_PCD));}' unless defined(&CR3_NONPAE_RESERVED_BITS);
    eval 'sub CR3_L_MODE_RESERVED_BITS () {( &CR3_NONPAE_RESERVED_BITS | 1.84467429741979e+19);}' unless defined(&CR3_L_MODE_RESERVED_BITS);
    eval 'sub KVM_GUEST_CR0_MASK () {( &X86_CR0_PG |  &X86_CR0_PE |  &X86_CR0_WP |  &X86_CR0_NE |  &X86_CR0_NW |  &X86_CR0_CD);}' unless defined(&KVM_GUEST_CR0_MASK);
    eval 'sub KVM_VM_CR0_ALWAYS_ON () {( &X86_CR0_PG |  &X86_CR0_PE |  &X86_CR0_WP |  &X86_CR0_NE |  &X86_CR0_TS |  &X86_CR0_MP);}' unless defined(&KVM_VM_CR0_ALWAYS_ON);
    eval 'sub KVM_GUEST_CR4_MASK () {( &X86_CR4_VME |  &X86_CR4_PSE |  &X86_CR4_PAE |  &X86_CR4_PGE |  &X86_CR4_VMXE);}' unless defined(&KVM_GUEST_CR4_MASK);
    eval 'sub KVM_PMODE_VM_CR4_ALWAYS_ON () {( &X86_CR4_PAE |  &X86_CR4_VMXE);}' unless defined(&KVM_PMODE_VM_CR4_ALWAYS_ON);
    eval 'sub KVM_RMODE_VM_CR4_ALWAYS_ON () {( &X86_CR4_VME |  &X86_CR4_PAE |  &X86_CR4_VMXE);}' unless defined(&KVM_RMODE_VM_CR4_ALWAYS_ON);
    eval 'sub INVALID_PAGE () {(~( &hpa_t)0);}' unless defined(&INVALID_PAGE);
    eval 'sub UNMAPPED_GVA () {(~( &gpa_t)0);}' unless defined(&UNMAPPED_GVA);
    eval 'sub KVM_HPAGE_SHIFT () {21;}' unless defined(&KVM_HPAGE_SHIFT);
    eval 'sub KVM_HPAGE_SIZE () {(1 <<  &KVM_HPAGE_SHIFT);}' unless defined(&KVM_HPAGE_SIZE);
    eval 'sub KVM_HPAGE_MASK () {(~( &KVM_HPAGE_SIZE - 1));}' unless defined(&KVM_HPAGE_MASK);
    eval 'sub KVM_PAGES_PER_HPAGE () {( &KVM_HPAGE_SIZE /  &PAGE_SIZE);}' unless defined(&KVM_PAGES_PER_HPAGE);
    eval 'sub DE_VECTOR () {0;}' unless defined(&DE_VECTOR);
    eval 'sub UD_VECTOR () {6;}' unless defined(&UD_VECTOR);
    eval 'sub NM_VECTOR () {7;}' unless defined(&NM_VECTOR);
    eval 'sub DF_VECTOR () {8;}' unless defined(&DF_VECTOR);
    eval 'sub TS_VECTOR () {10;}' unless defined(&TS_VECTOR);
    eval 'sub NP_VECTOR () {11;}' unless defined(&NP_VECTOR);
    eval 'sub SS_VECTOR () {12;}' unless defined(&SS_VECTOR);
    eval 'sub GP_VECTOR () {13;}' unless defined(&GP_VECTOR);
    eval 'sub PF_VECTOR () {14;}' unless defined(&PF_VECTOR);
    eval 'sub MC_VECTOR () {18;}' unless defined(&MC_VECTOR);
    eval 'sub SELECTOR_TI_MASK () {(1<< 2);}' unless defined(&SELECTOR_TI_MASK);
    eval 'sub SELECTOR_RPL_MASK () {0x3;}' unless defined(&SELECTOR_RPL_MASK);
    eval 'sub IOPL_SHIFT () {12;}' unless defined(&IOPL_SHIFT);
    eval 'sub KVM_ALIAS_SLOTS () {4;}' unless defined(&KVM_ALIAS_SLOTS);
    eval 'sub KVM_PERMILLE_MMU_PAGES () {20;}' unless defined(&KVM_PERMILLE_MMU_PAGES);
    eval 'sub KVM_MIN_ALLOC_MMU_PAGES () {64;}' unless defined(&KVM_MIN_ALLOC_MMU_PAGES);
    eval 'sub KVM_MMU_HASH_SHIFT () {10;}' unless defined(&KVM_MMU_HASH_SHIFT);
    eval 'sub KVM_NUM_MMU_PAGES () {(1<<  &KVM_MMU_HASH_SHIFT);}' unless defined(&KVM_NUM_MMU_PAGES);
    eval 'sub KVM_MIN_FREE_MMU_PAGES () {5;}' unless defined(&KVM_MIN_FREE_MMU_PAGES);
    eval 'sub KVM_REFILL_PAGES () {25;}' unless defined(&KVM_REFILL_PAGES);
    eval 'sub KVM_MAX_CPUID_ENTRIES () {40;}' unless defined(&KVM_MAX_CPUID_ENTRIES);
    eval 'sub KVM_NR_VAR_MTRR () {8;}' unless defined(&KVM_NR_VAR_MTRR);
    eval("sub VCPU_REGS_RAX () { 0; }") unless defined(&VCPU_REGS_RAX);
    eval("sub VCPU_REGS_RCX () { 1; }") unless defined(&VCPU_REGS_RCX);
    eval("sub VCPU_REGS_RDX () { 2; }") unless defined(&VCPU_REGS_RDX);
    eval("sub VCPU_REGS_RBX () { 3; }") unless defined(&VCPU_REGS_RBX);
    eval("sub VCPU_REGS_RSP () { 4; }") unless defined(&VCPU_REGS_RSP);
    eval("sub VCPU_REGS_RBP () { 5; }") unless defined(&VCPU_REGS_RBP);
    eval("sub VCPU_REGS_RSI () { 6; }") unless defined(&VCPU_REGS_RSI);
    eval("sub VCPU_REGS_RDI () { 7; }") unless defined(&VCPU_REGS_RDI);
    eval("sub NR_VCPU_REGS () { 8; }") unless defined(&NR_VCPU_REGS);
    eval("sub VCPU_SREG_ES () { 0; }") unless defined(&VCPU_SREG_ES);
    eval("sub VCPU_SREG_CS () { 1; }") unless defined(&VCPU_SREG_CS);
    eval("sub VCPU_SREG_SS () { 2; }") unless defined(&VCPU_SREG_SS);
    eval("sub VCPU_SREG_DS () { 3; }") unless defined(&VCPU_SREG_DS);
    eval("sub VCPU_SREG_FS () { 4; }") unless defined(&VCPU_SREG_FS);
    eval("sub VCPU_SREG_GS () { 5; }") unless defined(&VCPU_SREG_GS);
    eval("sub VCPU_SREG_TR () { 6; }") unless defined(&VCPU_SREG_TR);
    eval("sub VCPU_SREG_LDTR () { 7; }") unless defined(&VCPU_SREG_LDTR);
    require 'asm/kvm_x86_emulate.ph';
    eval 'sub KVM_NR_MEM_OBJS () {40;}' unless defined(&KVM_NR_MEM_OBJS);
    eval 'sub NR_PTE_CHAIN_ENTRIES () {5;}' unless defined(&NR_PTE_CHAIN_ENTRIES);
    eval("sub EMULATE_DONE () { 0; }") unless defined(&EMULATE_DONE);
    eval("sub EMULATE_DO_MMIO () { 1; }") unless defined(&EMULATE_DO_MMIO);
    eval("sub EMULATE_FAIL () { 2; }") unless defined(&EMULATE_FAIL);
    eval 'sub EMULTYPE_NO_DECODE () {(1<< 0);}' unless defined(&EMULTYPE_NO_DECODE);
    eval 'sub EMULTYPE_TRAP_UD () {(1<< 1);}' unless defined(&EMULTYPE_TRAP_UD);
    eval 'sub kvm_mmu_page {
        eval q(* &page_header( &hpa_t  &shadow_page) { \'struct page\' * &page =  &pfn_to_page( &shadow_page >>  &PAGE_SHIFT);  &page_private( &page); });
    }' unless defined(&kvm_mmu_page);
    eval 'sub kvm_read_fs {
        my($void) = @_;
	    eval q({  &u16  &seg;  &asm(\\"mov %%fs, %0\\" : \\"=g\\"( &seg));  &seg; });
    }' unless defined(&kvm_read_fs);
    eval 'sub kvm_read_gs {
        my($void) = @_;
	    eval q({  &u16  &seg;  &asm(\\"mov %%gs, %0\\" : \\"=g\\"( &seg));  &seg; });
    }' unless defined(&kvm_read_gs);
    eval 'sub kvm_read_ldt {
        my($void) = @_;
	    eval q({  &u16  &ldt;  &asm(\\"sldt %0\\" : \\"=g\\"( &ldt));  &ldt; });
    }' unless defined(&kvm_read_ldt);
    eval 'sub kvm_load_fs {
        my($sel) = @_;
	    eval q({  &asm(\\"mov %0, %%fs\\" : : \\"rm\\"($sel)); });
    }' unless defined(&kvm_load_fs);
    eval 'sub kvm_load_gs {
        my($sel) = @_;
	    eval q({  &asm(\\"mov %0, %%gs\\" : : \\"rm\\"($sel)); });
    }' unless defined(&kvm_load_gs);
    eval 'sub kvm_load_ldt {
        my($sel) = @_;
	    eval q({  &asm(\\"lldt %0\\" : : \\"rm\\"($sel)); });
    }' unless defined(&kvm_load_ldt);
    eval 'sub kvm_get_idt {
        my($table) = @_;
	    eval q({  &asm(\\"sidt %0\\" : \\"=m\\"(*$table)); });
    }' unless defined(&kvm_get_idt);
    eval 'sub kvm_get_gdt {
        my($table) = @_;
	    eval q({  &asm(\\"sgdt %0\\" : \\"=m\\"(*$table)); });
    }' unless defined(&kvm_get_gdt);
    eval 'sub kvm_read_tr_base {
        my($void) = @_;
	    eval q({  &u16  &tr;  &asm(\\"str %0\\" : \\"=g\\"( &tr));  &segment_base( &tr); });
    }' unless defined(&kvm_read_tr_base);
    if(defined(&CONFIG_X86_64)) {
	eval 'sub read_msr {
	    my($msr) = @_;
    	    eval q({  &u64  &value;  &rdmsrl($msr,  &value);  &value; });
	}' unless defined(&read_msr);
    }
    eval 'sub kvm_fx_save {
        my($image) = @_;
	    eval q({  &asm(\\"fxsave (%0)\\":: \\"r\\" ($image)); });
    }' unless defined(&kvm_fx_save);
    eval 'sub kvm_fx_restore {
        my($image) = @_;
	    eval q({  &asm(\\"fxrstor (%0)\\":: \\"r\\" ($image)); });
    }' unless defined(&kvm_fx_restore);
    eval 'sub kvm_fx_finit {
        my($void) = @_;
	    eval q({  &asm(\\"finit\\"); });
    }' unless defined(&kvm_fx_finit);
    eval 'sub get_rdx_init_val {
        my($void) = @_;
	    eval q({ 0x600; });
    }' unless defined(&get_rdx_init_val);
    eval 'sub kvm_inject_gp {
        my($vcpu,$error_code) = @_;
	    eval q({  &kvm_queue_exception_e($vcpu,  &GP_VECTOR, $error_code); });
    }' unless defined(&kvm_inject_gp);
    eval 'sub ASM_VMX_VMCLEAR_RAX () {".byte 0x66, 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMCLEAR_RAX);
    eval 'sub ASM_VMX_VMLAUNCH () {".byte 0x0f, 0x01, 0xc2";}' unless defined(&ASM_VMX_VMLAUNCH);
    eval 'sub ASM_VMX_VMRESUME () {".byte 0x0f, 0x01, 0xc3";}' unless defined(&ASM_VMX_VMRESUME);
    eval 'sub ASM_VMX_VMPTRLD_RAX () {".byte 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMPTRLD_RAX);
    eval 'sub ASM_VMX_VMREAD_RDX_RAX () {".byte 0x0f, 0x78, 0xd0";}' unless defined(&ASM_VMX_VMREAD_RDX_RAX);
    eval 'sub ASM_VMX_VMWRITE_RAX_RDX () {".byte 0x0f, 0x79, 0xd0";}' unless defined(&ASM_VMX_VMWRITE_RAX_RDX);
    eval 'sub ASM_VMX_VMWRITE_RSP_RDX () {".byte 0x0f, 0x79, 0xd4";}' unless defined(&ASM_VMX_VMWRITE_RSP_RDX);
    eval 'sub ASM_VMX_VMXOFF () {".byte 0x0f, 0x01, 0xc4";}' unless defined(&ASM_VMX_VMXOFF);
    eval 'sub ASM_VMX_VMXON_RAX () {".byte 0xf3, 0x0f, 0xc7, 0x30";}' unless defined(&ASM_VMX_VMXON_RAX);
    eval 'sub ASM_VMX_INVEPT () {".byte 0x66, 0x0f, 0x38, 0x80, 0x08";}' unless defined(&ASM_VMX_INVEPT);
    eval 'sub ASM_VMX_INVVPID () {".byte 0x66, 0x0f, 0x38, 0x81, 0x08";}' unless defined(&ASM_VMX_INVVPID);
    eval 'sub MSR_IA32_TIME_STAMP_COUNTER () {0x10;}' unless defined(&MSR_IA32_TIME_STAMP_COUNTER);
    eval 'sub TSS_IOPB_BASE_OFFSET () {0x66;}' unless defined(&TSS_IOPB_BASE_OFFSET);
    eval 'sub TSS_BASE_SIZE () {0x68;}' unless defined(&TSS_BASE_SIZE);
    eval 'sub TSS_IOPB_SIZE () {(65536/ 8);}' unless defined(&TSS_IOPB_SIZE);
    eval 'sub TSS_REDIRECTION_SIZE () {(256/ 8);}' unless defined(&TSS_REDIRECTION_SIZE);
    eval 'sub RMODE_TSS_SIZE () {( &TSS_BASE_SIZE +  &TSS_REDIRECTION_SIZE +  &TSS_IOPB_SIZE + 1);}' unless defined(&RMODE_TSS_SIZE);
    eval("sub TASK_SWITCH_CALL () { 0; }") unless defined(&TASK_SWITCH_CALL);
    eval("sub TASK_SWITCH_IRET () { 1; }") unless defined(&TASK_SWITCH_IRET);
    eval("sub TASK_SWITCH_JMP () { 2; }") unless defined(&TASK_SWITCH_JMP);
    eval("sub TASK_SWITCH_GATE () { 3; }") unless defined(&TASK_SWITCH_GATE);
    eval 'sub KVMTRACE_5D {
        my($evt, $vcpu, $d1, $d2, $d3, $d4, $d5, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 5, $d1, $d2, $d3, $d4, $d5));
    }' unless defined(&KVMTRACE_5D);
    eval 'sub KVMTRACE_4D {
        my($evt, $vcpu, $d1, $d2, $d3, $d4, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 4, $d1, $d2, $d3, $d4, 0));
    }' unless defined(&KVMTRACE_4D);
    eval 'sub KVMTRACE_3D {
        my($evt, $vcpu, $d1, $d2, $d3, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 3, $d1, $d2, $d3, 0, 0));
    }' unless defined(&KVMTRACE_3D);
    eval 'sub KVMTRACE_2D {
        my($evt, $vcpu, $d1, $d2, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 2, $d1, $d2, 0, 0, 0));
    }' unless defined(&KVMTRACE_2D);
    eval 'sub KVMTRACE_1D {
        my($evt, $vcpu, $d1, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 1, $d1, 0, 0, 0, 0));
    }' unless defined(&KVMTRACE_1D);
    eval 'sub KVMTRACE_0D {
        my($evt, $vcpu, $name) = @_;
	    eval q( &trace_mark( &kvm_trace_$name, \\"%u %p %u %u %u %u %u %u\\",  &KVM_TRC_$evt, $vcpu, 0, 0, 0, 0, 0, 0));
    }' unless defined(&KVMTRACE_0D);
    if(defined(&CONFIG_64BIT)) {
	eval 'sub KVM_EX_ENTRY () {".quad";}' unless defined(&KVM_EX_ENTRY);
	eval 'sub KVM_EX_PUSH () {"pushq";}' unless defined(&KVM_EX_PUSH);
    } else {
	eval 'sub KVM_EX_ENTRY () {".long";}' unless defined(&KVM_EX_ENTRY);
	eval 'sub KVM_EX_PUSH () {"pushl";}' unless defined(&KVM_EX_PUSH);
    }
    eval 'sub __kvm_handle_fault_on_reboot {
        my($insn) = @_;
	    eval q(\\"666: \\" $insn \\"\\\\n\\\\t\\" \\".pushsection .fixup, \\\\\\"ax\\\\\\" \\\\n\\" \\"667: \\\\n\\\\t\\"  &KVM_EX_PUSH \\" $666b \\\\n\\\\t\\" \\"jmp kvm_handle_fault_on_reboot \\\\n\\\\t\\" \\".popsection \\\\n\\\\t\\" \\".pushsection __ex_table, \\\\\\"a\\\\\\" \\\\n\\\\t\\"  &KVM_EX_ENTRY \\" 666b, 667b \\\\n\\\\t\\" \\".popsection\\");
    }' unless defined(&__kvm_handle_fault_on_reboot);
    eval 'sub KVM_ARCH_WANT_MMU_NOTIFIER () {1;}' unless defined(&KVM_ARCH_WANT_MMU_NOTIFIER);
}
1;
