require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__X86_KVM_PARA_H)) {
    eval 'sub __X86_KVM_PARA_H () {1;}' unless defined(&__X86_KVM_PARA_H);
    eval 'sub KVM_CPUID_SIGNATURE () {0x40000000;}' unless defined(&KVM_CPUID_SIGNATURE);
    eval 'sub KVM_CPUID_FEATURES () {0x40000001;}' unless defined(&KVM_CPUID_FEATURES);
    eval 'sub KVM_FEATURE_CLOCKSOURCE () {0;}' unless defined(&KVM_FEATURE_CLOCKSOURCE);
    eval 'sub KVM_FEATURE_NOP_IO_DELAY () {1;}' unless defined(&KVM_FEATURE_NOP_IO_DELAY);
    eval 'sub KVM_FEATURE_MMU_OP () {2;}' unless defined(&KVM_FEATURE_MMU_OP);
    eval 'sub MSR_KVM_WALL_CLOCK () {0x11;}' unless defined(&MSR_KVM_WALL_CLOCK);
    eval 'sub MSR_KVM_SYSTEM_TIME () {0x12;}' unless defined(&MSR_KVM_SYSTEM_TIME);
    eval 'sub KVM_MAX_MMU_OP_BATCH () {32;}' unless defined(&KVM_MAX_MMU_OP_BATCH);
    eval 'sub KVM_MMU_OP_WRITE_PTE () {1;}' unless defined(&KVM_MMU_OP_WRITE_PTE);
    eval 'sub KVM_MMU_OP_FLUSH_TLB () {2;}' unless defined(&KVM_MMU_OP_FLUSH_TLB);
    eval 'sub KVM_MMU_OP_RELEASE_PT () {3;}' unless defined(&KVM_MMU_OP_RELEASE_PT);
    if(defined(&__KERNEL__)) {
	require 'asm/processor.ph';
	eval 'sub KVM_HYPERCALL () {".byte 0x0f,0x01,0xc1";}' unless defined(&KVM_HYPERCALL);
	eval 'sub kvm_hypercall1 {
	    my($nr,$p1) = @_;
    	    eval q({ my $ret;  &asm  &volatile( &KVM_HYPERCALL : \\"=a\\"( $ret) : \\"a\\"($nr), \\"b\\"($p1) : \\"memory\\");  $ret; });
	}' unless defined(&kvm_hypercall1);
	eval 'sub kvm_hypercall2 {
	    my($nr,$p1,$p2) = @_;
    	    eval q({ my $ret;  &asm  &volatile( &KVM_HYPERCALL : \\"=a\\"( $ret) : \\"a\\"($nr), \\"b\\"($p1), \\"c\\"($p2) : \\"memory\\");  $ret; });
	}' unless defined(&kvm_hypercall2);
	eval 'sub kvm_hypercall3 {
	    my($nr,$p1,$p2,$p3) = @_;
    	    eval q({ my $ret;  &asm  &volatile( &KVM_HYPERCALL : \\"=a\\"( $ret) : \\"a\\"($nr), \\"b\\"($p1), \\"c\\"($p2), \\"d\\"($p3) : \\"memory\\");  $ret; });
	}' unless defined(&kvm_hypercall3);
	eval 'sub kvm_hypercall4 {
	    my($nr,$p1,$p2,$p3,$p4) = @_;
    	    eval q({ my $ret;  &asm  &volatile( &KVM_HYPERCALL : \\"=a\\"( $ret) : \\"a\\"($nr), \\"b\\"($p1), \\"c\\"($p2), \\"d\\"($p3), \\"S\\"($p4) : \\"memory\\");  $ret; });
	}' unless defined(&kvm_hypercall4);
	eval 'sub kvm_para_available {
	    my($void) = @_;
    	    eval q({ my $eax,  &ebx,  &ecx,  &edx; \'char\'  $signature[13];  &cpuid( &KVM_CPUID_SIGNATURE,  $eax,  &ebx,  &ecx,  &edx);  &memcpy( &signature + 0,  &ebx, 4);  &memcpy( &signature + 4,  &ecx, 4);  &memcpy( &signature + 8,  &edx, 4);  $signature[12] = 0;  &if ( &strcmp( &signature, \\"KVMKVMKVM\\") == 0) 1; 0; });
	}' unless defined(&kvm_para_available);
	eval 'sub kvm_arch_para_features {
	    my($void) = @_;
    	    eval q({  &cpuid_eax( &KVM_CPUID_FEATURES); });
	}' unless defined(&kvm_arch_para_features);
    }
}
1;
