require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_MSR_H_)) {
    eval 'sub __ASM_X86_MSR_H_ () {1;}' unless defined(&__ASM_X86_MSR_H_);
    require 'asm/msr-index.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/types.ph';
    }
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/asm.ph';
	    require 'asm/errno.ph';
	    eval 'sub native_read_tscp {
	        my($aux) = @_;
    		eval q({ my $low,  &high;  &asm  &volatile(\\".byte 0x0f,0x01,0xf9\\" : \\"=a\\" ( $low), \\"=d\\" ( &high), \\"=c\\" (*$aux));  $low | (( &u64) &high << 32); });
	    }' unless defined(&native_read_tscp);
	    if(defined(&CONFIG_X86_64)) {
		eval 'sub DECLARE_ARGS {
		    my($val, $low, $high) = @_;
    		    eval q(\'unsigned low\', $high);
		}' unless defined(&DECLARE_ARGS);
		eval 'sub EAX_EDX_VAL {
		    my($val, $low, $high) = @_;
    		    eval q((($low) | (( &u64)($high) << 32)));
		}' unless defined(&EAX_EDX_VAL);
		eval 'sub EAX_EDX_ARGS {
		    my($val, $low, $high) = @_;
    		    eval q(\\"a\\" ($low), \\"d\\" ($high));
		}' unless defined(&EAX_EDX_ARGS);
		eval 'sub EAX_EDX_RET {
		    my($val, $low, $high) = @_;
    		    eval q(\\"=a\\" ($low), \\"=d\\" ($high));
		}' unless defined(&EAX_EDX_RET);
	    } else {
		eval 'sub DECLARE_ARGS {
		    my($val, $low, $high) = @_;
    		    eval q(\'unsigned long long val\');
		}' unless defined(&DECLARE_ARGS);
		eval 'sub EAX_EDX_VAL {
		    my($val, $low, $high) = @_;
    		    eval q(($val));
		}' unless defined(&EAX_EDX_VAL);
		eval 'sub EAX_EDX_ARGS {
		    my($val, $low, $high) = @_;
    		    eval q(\\"A\\" ($val));
		}' unless defined(&EAX_EDX_ARGS);
		eval 'sub EAX_EDX_RET {
		    my($val, $low, $high) = @_;
    		    eval q(\\"=A\\" ($val));
		}' unless defined(&EAX_EDX_RET);
	    }
	    eval 'sub native_read_msr {
	        my($msr) = @_;
    		eval q({  &DECLARE_ARGS( &val,  &low,  &high);  &asm  &volatile(\\"rdmsr\\" :  &EAX_EDX_RET( &val,  &low,  &high) : \\"c\\" ($msr));  &EAX_EDX_VAL( &val,  &low,  &high); });
	    }' unless defined(&native_read_msr);
	    eval 'sub native_read_msr_safe {
	        my($msr,$err) = @_;
    		eval q({  &DECLARE_ARGS( &val,  &low,  &high);  &asm  &volatile(\\"2: rdmsr ; xor %[err],%[err]\\\\n\\" \\"1:\\\\n\\\\t\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\\\t\\" \\"3:  mov %[fault],%[err] ; jmp 1b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\"  &_ASM_EXTABLE(2 &b, 3 &b) : [$err] \\"=r\\" (*$err),  &EAX_EDX_RET( &val,  &low,  &high) : \\"c\\" ($msr), [ &fault] \\"i\\" (- &EFAULT));  &EAX_EDX_VAL( &val,  &low,  &high); });
	    }' unless defined(&native_read_msr_safe);
	    eval 'sub native_write_msr {
	        my($msr,$low,$high) = @_;
    		eval q({  &asm  &volatile(\\"wrmsr\\" : : \\"c\\" ($msr), \\"a\\"($low), \\"d\\" ($high) : \\"memory\\"); });
	    }' unless defined(&native_write_msr);
	    eval 'sub native_write_msr_safe {
	        my($msr,$low,$high) = @_;
    		eval q({ \'int\'  &err;  &asm  &volatile(\\"2: wrmsr ; xor %[err],%[err]\\\\n\\" \\"1:\\\\n\\\\t\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\\\t\\" \\"3:  mov %[fault],%[err] ; jmp 1b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\"  &_ASM_EXTABLE(2 &b, 3 &b) : [ &err] \\"=a\\" ( &err) : \\"c\\" ($msr), \\"0\\" ($low), \\"d\\" ($high), [ &fault] \\"i\\" (- &EFAULT) : \\"memory\\");  &err; });
	    }' unless defined(&native_write_msr_safe);
	    eval 'sub native_read_pmc {
	        my($counter) = @_;
    		eval q({  &DECLARE_ARGS( &val,  &low,  &high);  &asm  &volatile(\\"rdpmc\\" :  &EAX_EDX_RET( &val,  &low,  &high) : \\"c\\" ($counter));  &EAX_EDX_VAL( &val,  &low,  &high); });
	    }' unless defined(&native_read_pmc);
	    if(defined(&CONFIG_PARAVIRT)) {
		require 'asm/paravirt.ph';
	    } else {
		require 'linux/errno.ph';
		eval 'sub rdmsr {
		    my($msr, $val1, $val2) = @_;
    		    eval q( &do {  &u64  &__val =  &native_read_msr(($msr)); ($val1) = ( &u32) &__val; ($val2) = ( &u32)( &__val >> 32); }  &while (0));
		}' unless defined(&rdmsr);
		eval 'sub wrmsr {
		    my($msr,$low,$high) = @_;
    		    eval q({  &native_write_msr($msr, $low, $high); });
		}' unless defined(&wrmsr);
		eval 'sub rdmsrl {
		    my($msr, $val) = @_;
    		    eval q((($val) =  &native_read_msr(($msr))));
		}' unless defined(&rdmsrl);
		eval 'sub wrmsrl {
		    my($msr, $val) = @_;
    		    eval q( &native_write_msr(($msr), ( &u32)(( &u64)($val)), ( &u32)(( &u64)($val) >> 32)));
		}' unless defined(&wrmsrl);
		eval 'sub rdmsr_safe {
		    my($msr, $p1, $p2) = @_;
    		    eval q(({ \'int\'  &__err;  &u64  &__val =  &native_read_msr_safe(($msr), & &__err); (*$p1) = ( &u32) &__val; (*$p2) = ( &u32)( &__val >> 32);  &__err; }));
		}' unless defined(&rdmsr_safe);
		eval 'sub rdmsrl_safe {
		    my($msr,$p) = @_;
    		    eval q({ \'int\'  &err; *$p =  &native_read_msr_safe($msr,  &err);  &err; });
		}' unless defined(&rdmsrl_safe);
		eval 'sub rdtscl {
		    my($low) = @_;
    		    eval q((($low) = ( &u32) &native_read_tsc()));
		}' unless defined(&rdtscl);
		eval 'sub rdtscll {
		    my($val) = @_;
    		    eval q((($val) =  &native_read_tsc()));
		}' unless defined(&rdtscll);
		eval 'sub rdpmc {
		    my($counter, $low, $high) = @_;
    		    eval q( &do {  &u64  &_l =  &native_read_pmc(($counter)); ($low) = ( &u32) &_l; ($high) = ( &u32)( &_l >> 32); }  &while (0));
		}' unless defined(&rdpmc);
		eval 'sub rdtscp {
		    my($low, $high, $aux) = @_;
    		    eval q( &do { \'unsigned long long _val\' =  &native_read_tscp(($aux)); ($low) = ( &u32) &_val; ($high) = ( &u32)( &_val >> 32); }  &while (0));
		}' unless defined(&rdtscp);
		eval 'sub rdtscpll {
		    my($val, $aux) = @_;
    		    eval q(($val) =  &native_read_tscp(($aux)));
		}' unless defined(&rdtscpll);
	    }
	    eval 'sub checking_wrmsrl {
	        my($msr, $val) = @_;
    		eval q( &wrmsr_safe(($msr), ( &u32)($val), ( &u32)(($val) >> 32)));
	    }' unless defined(&checking_wrmsrl);
	    eval 'sub write_tsc {
	        my($val1, $val2) = @_;
    		eval q( &wrmsr(0x10, ($val1), ($val2)));
	    }' unless defined(&write_tsc);
	    eval 'sub write_rdtscp_aux {
	        my($val) = @_;
    		eval q( &wrmsr(0xc0000103, ($val), 0));
	    }' unless defined(&write_rdtscp_aux);
	    if(defined(&CONFIG_SMP)) {
	    } else {
		eval 'sub rdmsr_on_cpu {
		    my($cpu,$msr_no,$l,$h) = @_;
    		    eval q({  &rdmsr($msr_no, *$l, *$h); 0; });
		}' unless defined(&rdmsr_on_cpu);
		eval 'sub wrmsr_on_cpu {
		    my($cpu,$msr_no,$l,$h) = @_;
    		    eval q({  &wrmsr($msr_no, $l, $h); 0; });
		}' unless defined(&wrmsr_on_cpu);
		eval 'sub rdmsr_safe_on_cpu {
		    my($cpu,$msr_no,$l,$h) = @_;
    		    eval q({  &rdmsr_safe($msr_no, $l, $h); });
		}' unless defined(&rdmsr_safe_on_cpu);
		eval 'sub wrmsr_safe_on_cpu {
		    my($cpu,$msr_no,$l,$h) = @_;
    		    eval q({  &wrmsr_safe($msr_no, $l, $h); });
		}' unless defined(&wrmsr_safe_on_cpu);
	    }
	}
    }
}
1;
