require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_PAGE_H)) {
    eval 'sub _ASM_X86_PAGE_H () {1;}' unless defined(&_ASM_X86_PAGE_H);
    require 'linux/const.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {( &_AC(1, &UL) <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	eval 'sub __PHYSICAL_MASK () {(( &phys_addr_t)(1 <<  &__PHYSICAL_MASK_SHIFT) - 1);}' unless defined(&__PHYSICAL_MASK);
	eval 'sub __VIRTUAL_MASK () {((1 <<  &__VIRTUAL_MASK_SHIFT) - 1);}' unless defined(&__VIRTUAL_MASK);
	eval 'sub PHYSICAL_PAGE_MASK () {(( &PAGE_MASK) &  &__PHYSICAL_MASK);}' unless defined(&PHYSICAL_PAGE_MASK);
	eval 'sub PTE_PFN_MASK () {(( &pteval_t) &PHYSICAL_PAGE_MASK);}' unless defined(&PTE_PFN_MASK);
	eval 'sub PTE_FLAGS_MASK () {(~ &PTE_PFN_MASK);}' unless defined(&PTE_FLAGS_MASK);
	eval 'sub PMD_PAGE_SIZE () {( &_AC(1,  &UL) <<  &PMD_SHIFT);}' unless defined(&PMD_PAGE_SIZE);
	eval 'sub PMD_PAGE_MASK () {(~( &PMD_PAGE_SIZE-1));}' unless defined(&PMD_PAGE_MASK);
	eval 'sub HPAGE_SHIFT () { &PMD_SHIFT;}' unless defined(&HPAGE_SHIFT);
	eval 'sub HPAGE_SIZE () {( &_AC(1, &UL) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
	eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
	eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
	eval 'sub HUGE_MAX_HSTATE () {2;}' unless defined(&HUGE_MAX_HSTATE);
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/types.ph';
	}
	if(defined(&CONFIG_X86_64)) {
	    require 'asm/page_64.ph';
	} else {
	    require 'asm/page_32.ph';
	}
	eval 'sub PAGE_OFFSET () {( &__PAGE_OFFSET);}' unless defined(&PAGE_OFFSET);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {((( ($current->{personality}) &  &READ_IMPLIES_EXEC) ?  &VM_EXEC : 0) |  &VM_READ |  &VM_WRITE |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub clear_user_page {
	        my($page,$vaddr,$pg) = @_;
    		eval q({  &clear_page($page); });
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        my($to,$from,$vaddr,$topage) = @_;
    		eval q({  &copy_page($to, $from); });
	    }' unless defined(&copy_user_page);
	    eval 'sub __alloc_zeroed_user_highpage {
	        my($movableflags, $vma, $vaddr) = @_;
    		eval q( &alloc_page_vma( &GFP_HIGHUSER |  &__GFP_ZERO | $movableflags, $vma, $vaddr));
	    }' unless defined(&__alloc_zeroed_user_highpage);
	    eval 'sub __HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE () {1;}' unless defined(&__HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE);
	    eval 'sub native_make_pgd {
	        my($val) = @_;
    		eval q({ ( &pgd_t) { $val }; });
	    }' unless defined(&native_make_pgd);
	    eval 'sub native_pgd_val {
	        my($pgd) = @_;
    		eval q({  ($pgd->{pgd}); });
	    }' unless defined(&native_pgd_val);
	    if((defined(&PAGETABLE_LEVELS) ? &PAGETABLE_LEVELS : undef) >= 3) {
		if((defined(&PAGETABLE_LEVELS) ? &PAGETABLE_LEVELS : undef) == 4) {
		    eval 'sub native_make_pud {
		        my($val) = @_;
    			eval q({ ( &pud_t) { $val }; });
		    }' unless defined(&native_make_pud);
		    eval 'sub native_pud_val {
		        my($pud) = @_;
    			eval q({  ($pud->{pud}); });
		    }' unless defined(&native_pud_val);
		} else {
		    require 'asm-generic/pgtable-nopud.ph';
		    eval 'sub native_pud_val {
		        my($pud) = @_;
    			eval q({  &native_pgd_val( ($pud->{pgd})); });
		    }' unless defined(&native_pud_val);
		}
		eval 'sub native_make_pmd {
		    my($val) = @_;
    		    eval q({ ( &pmd_t) { $val }; });
		}' unless defined(&native_make_pmd);
		eval 'sub native_pmd_val {
		    my($pmd) = @_;
    		    eval q({  ($pmd->{pmd}); });
		}' unless defined(&native_pmd_val);
	    } else {
		require 'asm-generic/pgtable-nopmd.ph';
		eval 'sub native_pmd_val {
		    my($pmd) = @_;
    		    eval q({  &native_pgd_val( ($pmd->{pud}->{pgd})); });
		}' unless defined(&native_pmd_val);
	    }
	    eval 'sub native_make_pte {
	        my($val) = @_;
    		eval q({ ( &pte_t) { . &pte = $val }; });
	    }' unless defined(&native_make_pte);
	    eval 'sub native_pte_val {
	        my($pte) = @_;
    		eval q({  ($pte->{pte}); });
	    }' unless defined(&native_pte_val);
	    eval 'sub native_pte_flags {
	        my($pte) = @_;
    		eval q({  &native_pte_val($pte) &  &PTE_FLAGS_MASK; });
	    }' unless defined(&native_pte_flags);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	    if(defined(&CONFIG_PARAVIRT)) {
		require 'asm/paravirt.ph';
	    } else {
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q( &native_pgd_val($x));
		}' unless defined(&pgd_val);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q( &native_make_pgd($x));
		}' unless defined(&__pgd);
		unless(defined(&__PAGETABLE_PUD_FOLDED)) {
		    eval 'sub pud_val {
		        my($x) = @_;
    			eval q( &native_pud_val($x));
		    }' unless defined(&pud_val);
		    eval 'sub __pud {
		        my($x) = @_;
    			eval q( &native_make_pud($x));
		    }' unless defined(&__pud);
		}
		unless(defined(&__PAGETABLE_PMD_FOLDED)) {
		    eval 'sub pmd_val {
		        my($x) = @_;
    			eval q( &native_pmd_val($x));
		    }' unless defined(&pmd_val);
		    eval 'sub __pmd {
		        my($x) = @_;
    			eval q( &native_make_pmd($x));
		    }' unless defined(&__pmd);
		}
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q( &native_pte_val($x));
		}' unless defined(&pte_val);
		eval 'sub pte_flags {
		    my($x) = @_;
    		    eval q( &native_pte_flags($x));
		}' unless defined(&pte_flags);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q( &native_make_pte($x));
		}' unless defined(&__pte);
	    }
	    eval 'sub __pa {
	        my($x) = @_;
    		eval q( &__phys_addr(($x)));
	    }' unless defined(&__pa);
	    eval 'sub __pa_symbol {
	        my($x) = @_;
    		eval q( &__pa( &__phys_reloc_hide(($x))));
	    }' unless defined(&__pa_symbol);
	    eval 'sub __va {
	        my($x) = @_;
    		eval q((( &void *)(($x)+ &PAGE_OFFSET)));
	    }' unless defined(&__va);
	    eval 'sub __boot_va {
	        my($x) = @_;
    		eval q( &__va($x));
	    }' unless defined(&__boot_va);
	    eval 'sub __boot_pa {
	        my($x) = @_;
    		eval q( &__pa($x));
	    }' unless defined(&__boot_pa);
	    eval 'sub virt_to_page {
	        my($kaddr) = @_;
    		eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_to_page);
	    eval 'sub pfn_to_kaddr {
	        my($pfn) = @_;
    		eval q( &__va(($pfn) <<  &PAGE_SHIFT));
	    }' unless defined(&pfn_to_kaddr);
	    eval 'sub virt_addr_valid {
	        my($kaddr) = @_;
    		eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_addr_valid);
	}
	require 'asm-generic/memory_model.ph';
	require 'asm-generic/page.ph';
	eval 'sub __HAVE_ARCH_GATE_AREA () {1;}' unless defined(&__HAVE_ARCH_GATE_AREA);
    }
}
1;
