require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_PERCPU_H_)) {
    eval 'sub _ASM_X86_PERCPU_H_ () {1;}' unless defined(&_ASM_X86_PERCPU_H_);
    if(defined(&CONFIG_X86_64)) {
	require 'linux/compiler.ph';
	if(defined(&CONFIG_SMP)) {
	    require 'asm/pda.ph';
	    eval 'sub __per_cpu_offset {
	        my($cpu) = @_;
    		eval q(( &cpu_pda($cpu)-> &data_offset));
	    }' unless defined(&__per_cpu_offset);
	    eval 'sub __my_cpu_offset () { &read_pda( &data_offset);}' unless defined(&__my_cpu_offset);
	    eval 'sub per_cpu_offset {
	        my($x) = @_;
    		eval q(( &__per_cpu_offset($x)));
	    }' unless defined(&per_cpu_offset);
	}
	require 'asm-generic/percpu.ph';
	eval 'sub x86_read_percpu {
	    my($var) = @_;
    	    eval q(({  &typeof( &per_cpu_var($var))  &__tmp;  &preempt_disable();  &__tmp =  &__get_cpu_var($var);  &preempt_enable();  &__tmp; }));
	}' unless defined(&x86_read_percpu);
	eval 'sub x86_write_percpu {
	    my($var, $val) = @_;
    	    eval q( &do {  &preempt_disable();  &__get_cpu_var($var) = ($val);  &preempt_enable(); }  &while(0));
	}' unless defined(&x86_write_percpu);
    } else {
	if(defined(&__ASSEMBLY__)) {
	    if(defined(&CONFIG_SMP)) {
		eval 'sub PER_CPU {
		    my($var, $reg) = @_;
    		    eval q( &movl % &fs: &per_cpu__ &this_cpu_off, $reg;  &lea  &per_cpu__$var($reg), $reg);
		}' unless defined(&PER_CPU);
		eval 'sub PER_CPU_VAR {
		    my($var) = @_;
    		    eval q(% &fs: &per_cpu__$var);
		}' unless defined(&PER_CPU_VAR);
	    } else {
		eval 'sub PER_CPU {
		    my($var, $reg) = @_;
    		    eval q( &movl $ &per_cpu__$var, $reg);
		}' unless defined(&PER_CPU);
		eval 'sub PER_CPU_VAR {
		    my($var) = @_;
    		    eval q( &per_cpu__$var);
		}' unless defined(&PER_CPU_VAR);
	    }
	} else {
	    if(defined(&CONFIG_SMP)) {
		eval 'sub __my_cpu_offset () { &x86_read_percpu( &this_cpu_off);}' unless defined(&__my_cpu_offset);
		eval 'sub __percpu_seg () {"%%fs:";}' unless defined(&__percpu_seg);
	    } else {
		eval 'sub __percpu_seg () {"";}' unless defined(&__percpu_seg);
	    }
	    require 'asm-generic/percpu.ph';
	    eval 'sub percpu_to_op {
	        my($op, $var, $val) = @_;
    		eval q( &do {  &typedef  &typeof($var)  &T__;  &if (0) {  &T__  &tmp__;  &tmp__ = ($val); }  &switch ($sizeof{$var}) {  &case 1:  &asm($op \\"b %1,\\" &__percpu_seg\\"%0\\" : \\"+m\\" ($var) : \\"ri\\" (( &T__)$val));  &break;  &case 2:  &asm($op \\"w %1,\\" &__percpu_seg\\"%0\\" : \\"+m\\" ($var) : \\"ri\\" (( &T__)$val));  &break;  &case 4:  &asm($op \\"l %1,\\" &__percpu_seg\\"%0\\" : \\"+m\\" ($var) : \\"ri\\" (( &T__)$val));  &break;  &default:  &__bad_percpu_size(); } }  &while (0));
	    }' unless defined(&percpu_to_op);
	    eval 'sub percpu_from_op {
	        my($op, $var) = @_;
    		eval q(({  &typeof($var)  &ret__;  &switch ($sizeof{$var}) {  &case 1:  &asm($op \\"b \\" &__percpu_seg\\"%1,%0\\" : \\"=r\\" ( &ret__) : \\"m\\" ($var));  &break;  &case 2:  &asm($op \\"w \\" &__percpu_seg\\"%1,%0\\" : \\"=r\\" ( &ret__) : \\"m\\" ($var));  &break;  &case 4:  &asm($op \\"l \\" &__percpu_seg\\"%1,%0\\" : \\"=r\\" ( &ret__) : \\"m\\" ($var));  &break;  &default:  &__bad_percpu_size(); }  &ret__; }));
	    }' unless defined(&percpu_from_op);
	    eval 'sub x86_read_percpu {
	        my($var) = @_;
    		eval q( &percpu_from_op(\\"mov\\",  &per_cpu__$var));
	    }' unless defined(&x86_read_percpu);
	    eval 'sub x86_write_percpu {
	        my($var, $val) = @_;
    		eval q( &percpu_to_op(\\"mov\\",  &per_cpu__$var, $val));
	    }' unless defined(&x86_write_percpu);
	    eval 'sub x86_add_percpu {
	        my($var, $val) = @_;
    		eval q( &percpu_to_op(\\"add\\",  &per_cpu__$var, $val));
	    }' unless defined(&x86_add_percpu);
	    eval 'sub x86_sub_percpu {
	        my($var, $val) = @_;
    		eval q( &percpu_to_op(\\"sub\\",  &per_cpu__$var, $val));
	    }' unless defined(&x86_sub_percpu);
	    eval 'sub x86_or_percpu {
	        my($var, $val) = @_;
    		eval q( &percpu_to_op(\\"or\\",  &per_cpu__$var, $val));
	    }' unless defined(&x86_or_percpu);
	}
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub DEFINE_EARLY_PER_CPU {
	    my($_type, $_name, $_initvalue) = @_;
    	    eval q( &DEFINE_PER_CPU($_type, $_name) = $_initvalue;  &__typeof__($_type) $_name $_early_map[ &NR_CPUS]  &__initdata = { [0...  &NR_CPUS-1] = $_initvalue };  &__typeof__($_type) *$_name &_early_ptr  &__refdata = $_name &_early_map);
	}' unless defined(&DEFINE_EARLY_PER_CPU);
	eval 'sub EXPORT_EARLY_PER_CPU_SYMBOL {
	    my($_name) = @_;
    	    eval q( &EXPORT_PER_CPU_SYMBOL($_name));
	}' unless defined(&EXPORT_EARLY_PER_CPU_SYMBOL);
	eval 'sub DECLARE_EARLY_PER_CPU {
	    my($_type, $_name) = @_;
    	    eval q( &DECLARE_PER_CPU($_type, $_name);  &extern  &__typeof__($_type) *$_name &_early_ptr;  &extern  &__typeof__($_type) $_name $_early_map[]);
	}' unless defined(&DECLARE_EARLY_PER_CPU);
	eval 'sub early_per_cpu_ptr {
	    my($_name) = @_;
    	    eval q(($_name &_early_ptr));
	}' unless defined(&early_per_cpu_ptr);
	eval 'sub early_per_cpu_map {
	    my($_name, $_idx) = @_;
    	    eval q(($_name $_early_map[$_idx]));
	}' unless defined(&early_per_cpu_map);
	eval 'sub early_per_cpu {
	    my($_name, $_cpu) = @_;
    	    eval q(( &early_per_cpu_ptr($_name) ?  &early_per_cpu_ptr($_name)[$_cpu] :  &per_cpu($_name, $_cpu)));
	}' unless defined(&early_per_cpu);
    } else {
	eval 'sub DEFINE_EARLY_PER_CPU {
	    my($_type, $_name, $_initvalue) = @_;
    	    eval q( &DEFINE_PER_CPU($_type, $_name) = $_initvalue);
	}' unless defined(&DEFINE_EARLY_PER_CPU);
	eval 'sub EXPORT_EARLY_PER_CPU_SYMBOL {
	    my($_name) = @_;
    	    eval q( &EXPORT_PER_CPU_SYMBOL($_name));
	}' unless defined(&EXPORT_EARLY_PER_CPU_SYMBOL);
	eval 'sub DECLARE_EARLY_PER_CPU {
	    my($_type, $_name) = @_;
    	    eval q( &DECLARE_PER_CPU($_type, $_name));
	}' unless defined(&DECLARE_EARLY_PER_CPU);
	eval 'sub early_per_cpu {
	    my($_name, $_cpu) = @_;
    	    eval q( &per_cpu($_name, $_cpu));
	}' unless defined(&early_per_cpu);
	eval 'sub early_per_cpu_ptr {
	    my($_name) = @_;
    	    eval q( &NULL);
	}' unless defined(&early_per_cpu_ptr);
    }
}
1;
