require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_PGALLOC_H)) {
    eval 'sub _ASM_X86_PGALLOC_H () {1;}' unless defined(&_ASM_X86_PGALLOC_H);
    require 'linux/threads.ph';
    require 'linux/mm.ph';
    require 'linux/pagemap.ph';
}
unless(defined(&pte_free)) {
    sub pte_free {
	my($mm,$pte) = @_;
	eval q({  &__free_page($pte); });
    }
}
unless(defined(&pmd_populate_kernel)) {
    sub pmd_populate_kernel {
	my($mm,$pmd,$pte) = @_;
	eval q({  &paravirt_alloc_pte($mm,  &__pa($pte) >>  &PAGE_SHIFT);  &set_pmd($pmd,  &__pmd( &__pa($pte) |  &_PAGE_TABLE)); });
    }
}
unless(defined(&pmd_populate)) {
    sub pmd_populate {
	my($mm,$pmd,$pte) = @_;
	eval q({ my $pfn =  &page_to_pfn($pte);  &paravirt_alloc_pte($mm,  $pfn);  &set_pmd($pmd,  &__pmd((( &pteval_t) $pfn <<  &PAGE_SHIFT) |  &_PAGE_TABLE)); });
    }
}
unless(defined(&pmd_pgtable)) {
    sub pmd_pgtable {
	my($pmd) = @_;
	eval q( &pmd_page($pmd));
    }
}
if((defined(&PAGETABLE_LEVELS) ? &PAGETABLE_LEVELS : undef) > 2) {
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one(\'struct mm_struct\' * &mm, my $addr) { ( &pmd_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pmd_t);
    eval 'sub pmd_free {
        my($mm,$pmd) = @_;
	    eval q({  &BUG_ON($pmd & ( &PAGE_SIZE-1));  &free_page($pmd); });
    }' unless defined(&pmd_free);
    if(defined(&CONFIG_X86_PAE)) {
    } else {
	eval 'sub pud_populate {
	    my($mm,$pud,$pmd) = @_;
    	    eval q({  &paravirt_alloc_pmd($mm,  &__pa($pmd) >>  &PAGE_SHIFT);  &set_pud($pud,  &__pud( &_PAGE_TABLE |  &__pa($pmd))); });
	}' unless defined(&pud_populate);
    }
    if((defined(&PAGETABLE_LEVELS) ? &PAGETABLE_LEVELS : undef) > 3) {
	eval 'sub pgd_populate {
	    my($mm,$pgd,$pud) = @_;
    	    eval q({  &paravirt_alloc_pud($mm,  &__pa($pud) >>  &PAGE_SHIFT);  &set_pgd($pgd,  &__pgd( &_PAGE_TABLE |  &__pa($pud))); });
	}' unless defined(&pgd_populate);
	eval 'sub pud_t {
	    eval q(* &pud_alloc_one(\'struct mm_struct\' * &mm, my $addr) { ( &pud_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
	}' unless defined(&pud_t);
	eval 'sub pud_free {
	    my($mm,$pud) = @_;
    	    eval q({  &BUG_ON($pud & ( &PAGE_SIZE-1));  &free_page($pud); });
	}' unless defined(&pud_free);
    }
}
    }
1;
