require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PGTABLE_H)) {
    eval 'sub _I386_PGTABLE_H () {1;}' unless defined(&_I386_PGTABLE_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/processor.ph';
	require 'asm/fixmap.ph';
	require 'linux/threads.ph';
	require 'asm/paravirt.ph';
	require 'linux/bitops.ph';
	require 'linux/slab.ph';
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	if(defined(&CONFIG_X86_PAE)) {
	    require 'asm/pgtable-3level-defs.ph';
	    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
	    eval 'sub PMD_MASK () {(~( &PMD_SIZE - 1));}' unless defined(&PMD_MASK);
	} else {
	    require 'asm/pgtable-2level-defs.ph';
	}
	eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
	eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE - 1));}' unless defined(&PGDIR_MASK);
	eval 'sub VMALLOC_OFFSET () {(8* 1024* 1024);}' unless defined(&VMALLOC_OFFSET);
	eval 'sub VMALLOC_START () {(( &high_memory + 2*  &VMALLOC_OFFSET - 1) & ~( &VMALLOC_OFFSET - 1));}' unless defined(&VMALLOC_START);
	if(defined(&CONFIG_X86_PAE)) {
	    eval 'sub LAST_PKMAP () {512;}' unless defined(&LAST_PKMAP);
	} else {
	    eval 'sub LAST_PKMAP () {1024;}' unless defined(&LAST_PKMAP);
	}
	eval 'sub PKMAP_BASE () {(( &FIXADDR_BOOT_START -  &PAGE_SIZE * ( &LAST_PKMAP + 1)) &  &PMD_MASK);}' unless defined(&PKMAP_BASE);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub VMALLOC_END () {( &PKMAP_BASE - 2*  &PAGE_SIZE);}' unless defined(&VMALLOC_END);
	} else {
	    eval 'sub VMALLOC_END () {( &FIXADDR_START - 2*  &PAGE_SIZE);}' unless defined(&VMALLOC_END);
	}
	undef(&TEST_ACCESS_OK) if defined(&TEST_ACCESS_OK);
	eval 'sub pte_present {
	    my($x) = @_;
    	    eval q((($x). &pte_low & ( &_PAGE_PRESENT |  &_PAGE_PROTNONE)));
	}' unless defined(&pte_present);
	eval 'sub pmd_none {
	    my($x) = @_;
    	    eval q((! &pmd_val(($x))));
	}' unless defined(&pmd_none);
	eval 'sub pmd_present {
	    my($x) = @_;
    	    eval q(( &pmd_val(($x)) &  &_PAGE_PRESENT));
	}' unless defined(&pmd_present);
	eval 'sub pmd_bad {
	    my($x) = @_;
    	    eval q((( &pmd_val($x) & ( &PTE_FLAGS_MASK & ~ &_PAGE_USER)) !=  &_KERNPG_TABLE));
	}' unless defined(&pmd_bad);
	eval 'sub pages_to_mb {
	    my($x) = @_;
    	    eval q((($x) >> (20- &PAGE_SHIFT)));
	}' unless defined(&pages_to_mb);
	if(defined(&CONFIG_X86_PAE)) {
	    require 'asm/pgtable-3level.ph';
	} else {
	    require 'asm/pgtable-2level.ph';
	}
	eval 'sub pgprot_noncached {
	    my($prot) = @_;
    	    eval q((( ($boot_cpu_data->{x86}) > 3) ? ( &__pgprot( &pgprot_val($prot) |  &_PAGE_PCD |  &_PAGE_PWT)) : ($prot)));
	}' unless defined(&pgprot_noncached);
	eval 'sub mk_pte {
	    my($page, $pgprot) = @_;
    	    eval q( &pfn_pte( &page_to_pfn($page), ($pgprot)));
	}' unless defined(&mk_pte);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pud_large {
	    my($pud) = @_;
    	    eval q({ 0; }  &define  &pmd_index( &address) ((( &address) >>  &PMD_SHIFT) & ( &PTRS_PER_PMD - 1))  &define  &pte_index( &address) ((( &address) >>  &PAGE_SHIFT) & ( &PTRS_PER_PTE - 1))  &define  &pte_offset_kernel( &dir,  &address) (( &pte_t *) &pmd_page_vaddr(*( &dir)) +  &pte_index(( &address)))  &define  &pmd_page( &pmd) ( &pfn_to_page( &pmd_val(( &pmd)) >>  &PAGE_SHIFT))  &define  &pmd_page_vaddr( &pmd) ( &__va( &pmd_val(( &pmd)) &  &PTE_PFN_MASK))  &define  &kpte_clear_flush( &ptep,  &vaddr)  &do {  &pte_clear( &init_mm, ( &vaddr), ( &ptep));  &__flush_tlb_one(( &vaddr)); }  &while (0)  &define  &update_mmu_cache( &vma,  &address,  &pte)  &do { }  &while (0)  &endif  &define  &io_remap_pfn_range( &vma,  &vaddr,  &pfn,  &size,  &prot)  &remap_pfn_range( &vma,  &vaddr,  &pfn,  &size,  &prot)  &endif );
	}' unless defined(&pud_large);
1;
