require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PGTABLE_H)) {
    eval 'sub _X86_64_PGTABLE_H () {1;}' unless defined(&_X86_64_PGTABLE_H);
    require 'linux/const.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/processor.ph';
	require 'linux/bitops.ph';
	require 'linux/threads.ph';
	require 'asm/pda.ph';
	eval 'sub swapper_pg_dir () { &init_level4_pgt;}' unless defined(&swapper_pg_dir);
    }
    eval 'sub SHARED_KERNEL_PMD () {0;}' unless defined(&SHARED_KERNEL_PMD);
    eval 'sub PGDIR_SHIFT () {39;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PTRS_PER_PGD () {512;}' unless defined(&PTRS_PER_PGD);
    eval 'sub PUD_SHIFT () {30;}' unless defined(&PUD_SHIFT);
    eval 'sub PTRS_PER_PUD () {512;}' unless defined(&PTRS_PER_PUD);
    eval 'sub PMD_SHIFT () {21;}' unless defined(&PMD_SHIFT);
    eval 'sub PTRS_PER_PMD () {512;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PTE () {512;}' unless defined(&PTRS_PER_PTE);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub pte_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pte %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pte_val($e)));
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pmd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
	}' unless defined(&pmd_ERROR);
	eval 'sub pud_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pud %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pud_val($e)));
	}' unless defined(&pud_ERROR);
	eval 'sub pgd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pgd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
	}' unless defined(&pgd_ERROR);
	eval 'sub pgd_none {
	    my($x) = @_;
    	    eval q((! &pgd_val($x)));
	}' unless defined(&pgd_none);
	eval 'sub pud_none {
	    my($x) = @_;
    	    eval q((! &pud_val($x)));
	}' unless defined(&pud_none);
	eval 'sub native_pte_clear {
	    my($mm,$addr,$ptep) = @_;
    	    eval q({ *$ptep =  &native_make_pte(0); });
	}' unless defined(&native_pte_clear);
	eval 'sub native_set_pte {
	    my($ptep,$pte) = @_;
    	    eval q({ *$ptep = $pte; });
	}' unless defined(&native_set_pte);
	eval 'sub native_set_pte_atomic {
	    my($ptep,$pte) = @_;
    	    eval q({  &native_set_pte($ptep, $pte); });
	}' unless defined(&native_set_pte_atomic);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub native_ptep_get_and_clear {
	    my($xp) = @_;
    	    eval q({ });
	}' unless defined(&native_ptep_get_and_clear);
	eval 'sub native_set_pmd {
	    my($pmdp,$pmd) = @_;
    	    eval q({ *$pmdp = $pmd; });
	}' unless defined(&native_set_pmd);
	eval 'sub native_pmd_clear {
	    my($pmd) = @_;
    	    eval q({  &native_set_pmd($pmd,  &native_make_pmd(0)); });
	}' unless defined(&native_pmd_clear);
	eval 'sub native_set_pud {
	    my($pudp,$pud) = @_;
    	    eval q({ *$pudp = $pud; });
	}' unless defined(&native_set_pud);
	eval 'sub native_pud_clear {
	    my($pud) = @_;
    	    eval q({  &native_set_pud($pud,  &native_make_pud(0)); });
	}' unless defined(&native_pud_clear);
	eval 'sub native_set_pgd {
	    my($pgdp,$pgd) = @_;
    	    eval q({ *$pgdp = $pgd; });
	}' unless defined(&native_set_pgd);
	eval 'sub native_pgd_clear {
	    my($pgd) = @_;
    	    eval q({  &native_set_pgd($pgd,  &native_make_pgd(0)); });
	}' unless defined(&native_pgd_clear);
	eval 'sub pte_same {
	    my($a, $b) = @_;
    	    eval q((($a). &pte == ($b). &pte));
	}' unless defined(&pte_same);
    }
    eval 'sub PMD_SIZE () {( &_AC(1,  &UL) <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE - 1));}' unless defined(&PMD_MASK);
    eval 'sub PUD_SIZE () {( &_AC(1,  &UL) <<  &PUD_SHIFT);}' unless defined(&PUD_SIZE);
    eval 'sub PUD_MASK () {(~( &PUD_SIZE - 1));}' unless defined(&PUD_MASK);
    eval 'sub PGDIR_SIZE () {( &_AC(1,  &UL) <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE - 1));}' unless defined(&PGDIR_MASK);
    eval 'sub MAXMEM () { &_AC(70368744177663,  &UL);}' unless defined(&MAXMEM);
    eval 'sub VMALLOC_START () { &_AC(1.84466759039886e+19,  &UL);}' unless defined(&VMALLOC_START);
    eval 'sub VMALLOC_END () { &_AC(1.84467110883607e+19,  &UL);}' unless defined(&VMALLOC_END);
    eval 'sub VMEMMAP_START () { &_AC(1.84467110883607e+19,  &UL);}' unless defined(&VMEMMAP_START);
    eval 'sub MODULES_VADDR () { &_AC(1.84467440720989e+19,  &UL);}' unless defined(&MODULES_VADDR);
    eval 'sub MODULES_END () { &_AC(1.84467440736928e+19,  &UL);}' unless defined(&MODULES_END);
    eval 'sub MODULES_LEN () {( &MODULES_END -  &MODULES_VADDR);}' unless defined(&MODULES_LEN);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub pgd_bad {
	    my($pgd) = @_;
    	    eval q({ ( &pgd_val($pgd) & ~( &PTE_PFN_MASK |  &_PAGE_USER)) !=  &_KERNPG_TABLE; });
	}' unless defined(&pgd_bad);
	eval 'sub pud_bad {
	    my($pud) = @_;
    	    eval q({ ( &pud_val($pud) & ~( &PTE_PFN_MASK |  &_PAGE_USER)) !=  &_KERNPG_TABLE; });
	}' unless defined(&pud_bad);
	eval 'sub pmd_bad {
	    my($pmd) = @_;
    	    eval q({ ( &pmd_val($pmd) & ~( &PTE_PFN_MASK |  &_PAGE_USER)) !=  &_KERNPG_TABLE; });
	}' unless defined(&pmd_bad);
	eval 'sub pte_none {
	    my($x) = @_;
    	    eval q((! &pte_val(($x))));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    my($x) = @_;
    	    eval q(( &pte_val(($x)) & ( &_PAGE_PRESENT |  &_PAGE_PROTNONE)));
	}' unless defined(&pte_present);
	eval 'sub pages_to_mb {
	    my($x) = @_;
    	    eval q((($x) >> (20-  &PAGE_SHIFT)));
	}' unless defined(&pages_to_mb);
	eval 'sub pte_page {
	    my($x) = @_;
    	    eval q( &pfn_to_page( &pte_pfn(($x))));
	}' unless defined(&pte_page);
	eval 'sub pte_pfn {
	    my($x) = @_;
    	    eval q((( &pte_val(($x)) &  &__PHYSICAL_MASK) >>  &PAGE_SHIFT));
	}' unless defined(&pte_pfn);
	eval 'sub pgprot_noncached {
	    my($prot) = @_;
    	    eval q(( &__pgprot( &pgprot_val(($prot)) |  &_PAGE_PCD |  &_PAGE_PWT)));
	}' unless defined(&pgprot_noncached);
	eval 'sub pgd_page_vaddr {
	    my($pgd) = @_;
    	    eval q(( &__va( &pgd_val(($pgd)) &  &PTE_PFN_MASK)));
	}' unless defined(&pgd_page_vaddr);
	eval 'sub pgd_page {
	    my($pgd) = @_;
    	    eval q(( &pfn_to_page( &pgd_val(($pgd)) >>  &PAGE_SHIFT)));
	}' unless defined(&pgd_page);
	eval 'sub pgd_present {
	    my($pgd) = @_;
    	    eval q(( &pgd_val($pgd) &  &_PAGE_PRESENT));
	}' unless defined(&pgd_present);
	eval 'sub pmd_page_vaddr {
	    my($pmd) = @_;
    	    eval q((  &__va( &pmd_val(($pmd)) &  &PTE_PFN_MASK)));
	}' unless defined(&pmd_page_vaddr);
	eval 'sub pmd_page {
	    my($pmd) = @_;
    	    eval q(( &pfn_to_page( &pmd_val(($pmd)) >>  &PAGE_SHIFT)));
	}' unless defined(&pmd_page);
	eval 'sub pmd_index {
	    my($address) = @_;
    	    eval q(((($address) >>  &PMD_SHIFT) & ( &PTRS_PER_PMD - 1)));
	}' unless defined(&pmd_index);
	eval 'sub pmd_offset {
	    my($dir, $address) = @_;
    	    eval q((( &pmd_t *) &pud_page_vaddr(*($dir)) +  &pmd_index($address)));
	}' unless defined(&pmd_offset);
	eval 'sub pmd_none {
	    my($x) = @_;
    	    eval q((! &pmd_val(($x))));
	}' unless defined(&pmd_none);
	eval 'sub pmd_present {
	    my($x) = @_;
    	    eval q(( &pmd_val(($x)) &  &_PAGE_PRESENT));
	}' unless defined(&pmd_present);
	eval 'sub pfn_pmd {
	    my($nr, $prot) = @_;
    	    eval q(( &__pmd((($nr) <<  &PAGE_SHIFT) |  &pgprot_val(($prot)))));
	}' unless defined(&pfn_pmd);
	eval 'sub pmd_pfn {
	    my($x) = @_;
    	    eval q((( &pmd_val(($x)) &  &__PHYSICAL_MASK) >>  &PAGE_SHIFT));
	}' unless defined(&pmd_pfn);
	eval 'sub pte_to_pgoff {
	    my($pte) = @_;
    	    eval q((( &pte_val(($pte)) &  &PHYSICAL_PAGE_MASK) >>  &PAGE_SHIFT));
	}' unless defined(&pte_to_pgoff);
	eval 'sub pgoff_to_pte {
	    my($off) = @_;
    	    eval q((( &pte_t) { . &pte = (($off) <<  &PAGE_SHIFT) |  &_PAGE_FILE }));
	}' unless defined(&pgoff_to_pte);
	eval 'sub PTE_FILE_MAX_BITS () { &__PHYSICAL_MASK_SHIFT;}' unless defined(&PTE_FILE_MAX_BITS);
	eval 'sub mk_pte {
	    my($page, $pgprot) = @_;
    	    eval q( &pfn_pte( &page_to_pfn(($page)), ($pgprot)));
	}' unless defined(&mk_pte);
	eval 'sub pte_index {
	    my($address) = @_;
    	    eval q(((($address) >>  &PAGE_SHIFT) & ( &PTRS_PER_PTE - 1)));
	}' unless defined(&pte_index);
	eval 'sub pte_offset_kernel {
	    my($dir, $address) = @_;
    	    eval q((( &pte_t *)  &pmd_page_vaddr(*($dir)) +  &pte_index(($address))));
	}' unless defined(&pte_offset_kernel);
	eval 'sub pte_offset_map {
	    my($dir, $address) = @_;
    	    eval q( &pte_offset_kernel(($dir), ($address)));
	}' unless defined(&pte_offset_map);
	eval 'sub pte_offset_map_nested {
	    my($dir, $address) = @_;
    	    eval q( &pte_offset_kernel(($dir), ($address)));
	}' unless defined(&pte_offset_map_nested);
	eval 'sub pte_unmap {
	    my($pte) = @_;
    	    eval q();
	}' unless defined(&pte_unmap);
	eval 'sub pte_unmap_nested {
	    my($pte) = @_;
    	    eval q();
	}' unless defined(&pte_unmap_nested);
	eval 'sub update_mmu_cache {
	    my($vma, $address, $pte) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&update_mmu_cache);
	eval 'sub __swp_type {
	    my($x) = @_;
    	    eval q(((($x). &val >> 1) & 0x3f));
	}' unless defined(&__swp_type);
	eval 'sub __swp_offset {
	    my($x) = @_;
    	    eval q((($x). &val >> 8));
	}' unless defined(&__swp_offset);
	eval 'sub __swp_entry {
	    my($type, $offset) = @_;
    	    eval q((( &swp_entry_t) { (($type) << 1) | (($offset) << 8) }));
	}' unless defined(&__swp_entry);
	eval 'sub __pte_to_swp_entry {
	    my($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val(($pte)) }));
	}' unless defined(&__pte_to_swp_entry);
	eval 'sub __swp_entry_to_pte {
	    my($x) = @_;
    	    eval q((( &pte_t) { . &pte = ($x). &val }));
	}' unless defined(&__swp_entry_to_pte);
	eval 'sub io_remap_pfn_range {
	    my($vma, $vaddr, $pfn, $size, $prot) = @_;
    	    eval q( &remap_pfn_range($vma, $vaddr, $pfn, $size, $prot));
	}' unless defined(&io_remap_pfn_range);
	eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
	eval 'sub HAVE_ARCH_UNMAPPED_AREA_TOPDOWN () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA_TOPDOWN);
	eval 'sub pgtable_cache_init () {
	    eval q( &do { }  &while (0));
	}' unless defined(&pgtable_cache_init);
	eval 'sub check_pgt_cache () {
	    eval q( &do { }  &while (0));
	}' unless defined(&check_pgt_cache);
	eval 'sub PAGE_AGP () { &PAGE_KERNEL_NOCACHE;}' unless defined(&PAGE_AGP);
	eval 'sub HAVE_PAGE_AGP () {1;}' unless defined(&HAVE_PAGE_AGP);
	eval 'sub kc_vaddr_to_offset {
	    my($v) = @_;
    	    eval q((($v) &  &__VIRTUAL_MASK));
	}' unless defined(&kc_vaddr_to_offset);
	eval 'sub kc_offset_to_vaddr {
	    my($o) = @_;
    	    eval q(((($o) & (1 << ( &__VIRTUAL_MASK_SHIFT - 1))) ? (($o) | ~ &__VIRTUAL_MASK) : ($o)));
	}' unless defined(&kc_offset_to_vaddr);
	eval 'sub __HAVE_ARCH_PTE_SAME () {1;}' unless defined(&__HAVE_ARCH_PTE_SAME);
    }
}
1;
