require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_PROCESSOR_H)) {
    eval 'sub __ASM_X86_PROCESSOR_H () {1;}' unless defined(&__ASM_X86_PROCESSOR_H);
    require 'asm/processor-flags.ph';
    require 'asm/vm86.ph';
    require 'asm/math_emu.ph';
    require 'asm/segment.ph';
    require 'asm/types.ph';
    require 'asm/sigcontext.ph';
    require 'asm/current.ph';
    require 'asm/cpufeature.ph';
    require 'asm/system.ph';
    require 'asm/page.ph';
    require 'asm/percpu.ph';
    require 'asm/msr.ph';
    require 'asm/desc_defs.ph';
    require 'asm/nops.ph';
    require 'linux/personality.ph';
    require 'linux/cpumask.ph';
    require 'linux/cache.ph';
    require 'linux/threads.ph';
    require 'linux/init.ph';
    if(defined(&CONFIG_X86_VSMP)) {
	eval 'sub ARCH_MIN_TASKALIGN () {(1<<  &INTERNODE_CACHE_SHIFT);}' unless defined(&ARCH_MIN_TASKALIGN);
	eval 'sub ARCH_MIN_MMSTRUCT_ALIGN () {(1<<  &INTERNODE_CACHE_SHIFT);}' unless defined(&ARCH_MIN_MMSTRUCT_ALIGN);
    } else {
	eval 'sub ARCH_MIN_TASKALIGN () {16;}' unless defined(&ARCH_MIN_TASKALIGN);
	eval 'sub ARCH_MIN_MMSTRUCT_ALIGN () {0;}' unless defined(&ARCH_MIN_MMSTRUCT_ALIGN);
    }
    if(defined(&CONFIG_X86_32)) {
    } else {
    }
    if(defined(&CONFIG_SMP)) {
    }
    if(defined(&CONFIG_SMP)) {
    }
    eval 'sub X86_VENDOR_INTEL () {0;}' unless defined(&X86_VENDOR_INTEL);
    eval 'sub X86_VENDOR_CYRIX () {1;}' unless defined(&X86_VENDOR_CYRIX);
    eval 'sub X86_VENDOR_AMD () {2;}' unless defined(&X86_VENDOR_AMD);
    eval 'sub X86_VENDOR_UMC () {3;}' unless defined(&X86_VENDOR_UMC);
    eval 'sub X86_VENDOR_CENTAUR () {5;}' unless defined(&X86_VENDOR_CENTAUR);
    eval 'sub X86_VENDOR_TRANSMETA () {7;}' unless defined(&X86_VENDOR_TRANSMETA);
    eval 'sub X86_VENDOR_NSC () {8;}' unless defined(&X86_VENDOR_NSC);
    eval 'sub X86_VENDOR_NUM () {9;}' unless defined(&X86_VENDOR_NUM);
    eval 'sub X86_VENDOR_UNKNOWN () {0xff;}' unless defined(&X86_VENDOR_UNKNOWN);
    if(defined(&CONFIG_SMP)) {
	eval 'sub cpu_data {
	    my($cpu) = @_;
    	    eval q( &per_cpu( &cpu_info, $cpu));
	}' unless defined(&cpu_data);
	eval 'sub current_cpu_data () { &__get_cpu_var( &cpu_info);}' unless defined(&current_cpu_data);
    } else {
	eval 'sub cpu_data {
	    my($cpu) = @_;
    	    eval q( &boot_cpu_data);
	}' unless defined(&cpu_data);
	eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub hlt_works {
        my($cpu) = @_;
	    eval q({ });
    }' unless defined(&hlt_works);
    eval 'sub cache_line_size () {
        eval q(( ($boot_cpu_data->{x86_cache_alignment})));
    }' unless defined(&cache_line_size);
    if(defined( &CONFIG_X86_HT) || defined( &CONFIG_X86_64)) {
    } else {
    }
    eval 'sub native_cpuid {
        my($eax,$ebx,$ecx,$edx) = @_;
	    eval q({  &asm(\\"cpuid\\" : \\"=a\\" (*$eax), \\"=b\\" (*$ebx), \\"=c\\" (*$ecx), \\"=d\\" (*$edx) : \\"0\\" (*$eax), \\"2\\" (*$ecx)); });
    }' unless defined(&native_cpuid);
    eval 'sub load_cr3 {
        my($pgdir) = @_;
	    eval q({  &write_cr3( &__pa($pgdir)); });
    }' unless defined(&load_cr3);
    if(defined(&CONFIG_X86_32)) {
    } else {
    }
    eval 'sub IO_BITMAP_BITS () {65536;}' unless defined(&IO_BITMAP_BITS);
    eval 'sub IO_BITMAP_BYTES () {( &IO_BITMAP_BITS/8);}' unless defined(&IO_BITMAP_BYTES);
    eval 'sub IO_BITMAP_LONGS () {( &IO_BITMAP_BYTES/$sizeof{\'long\'});}' unless defined(&IO_BITMAP_LONGS);
    eval 'sub IO_BITMAP_OFFSET () { &offsetof(\'struct tss_struct\',  &io_bitmap);}' unless defined(&IO_BITMAP_OFFSET);
    eval 'sub INVALID_IO_BITMAP_OFFSET () {0x8000;}' unless defined(&INVALID_IO_BITMAP_OFFSET);
    eval 'sub INVALID_IO_BITMAP_OFFSET_LAZY () {0x9000;}' unless defined(&INVALID_IO_BITMAP_OFFSET_LAZY);
    eval 'sub MXCSR_DEFAULT () {0x1f80;}' unless defined(&MXCSR_DEFAULT);
    if(defined(&CONFIG_X86_64)) {
    }
    if(defined(&CONFIG_X86_32)) {
    } else {
    }
    if(defined(&CONFIG_X86_32)) {
    }
    eval 'sub native_get_debugreg {
        my($regno) = @_;
	    eval q({ my $val = 0;  &switch ($regno) {  &case 0:  &asm(\\"mov %%db0, %0\\" :\\"=r\\" ( $val));  &break;  &case 1:  &asm(\\"mov %%db1, %0\\" :\\"=r\\" ( $val));  &break;  &case 2:  &asm(\\"mov %%db2, %0\\" :\\"=r\\" ( $val));  &break;  &case 3:  &asm(\\"mov %%db3, %0\\" :\\"=r\\" ( $val));  &break;  &case 6:  &asm(\\"mov %%db6, %0\\" :\\"=r\\" ( $val));  &break;  &case 7:  &asm(\\"mov %%db7, %0\\" :\\"=r\\" ( $val));  &break;  &default:  &BUG(); }  $val; });
    }' unless defined(&native_get_debugreg);
    eval 'sub native_set_debugreg {
        my($regno,$value) = @_;
	    eval q({  &switch ($regno) {  &case 0:  &asm(\\"mov %0, %%db0\\" ::\\"r\\" ($value));  &break;  &case 1:  &asm(\\"mov %0, %%db1\\" ::\\"r\\" ($value));  &break;  &case 2:  &asm(\\"mov %0, %%db2\\" ::\\"r\\" ($value));  &break;  &case 3:  &asm(\\"mov %0, %%db3\\" ::\\"r\\" ($value));  &break;  &case 6:  &asm(\\"mov %0, %%db6\\" ::\\"r\\" ($value));  &break;  &case 7:  &asm(\\"mov %0, %%db7\\" ::\\"r\\" ($value));  &break;  &default:  &BUG(); } });
    }' unless defined(&native_set_debugreg);
    if(defined(&CONFIG_X86_32)) {
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub native_load_sp0 {
        my($tss,$thread) = @_;
	    eval q({  ($tss->{x86_tss}->{sp0}) =  ($thread->{sp0}); });
    }' unless defined(&native_load_sp0);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub native_swapgs {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&native_swapgs);
    if(defined(&CONFIG_PARAVIRT)) {
	require 'asm/paravirt.ph';
    } else {
	eval 'sub __cpuid () { &native_cpuid;}' unless defined(&__cpuid);
	eval 'sub paravirt_enabled () {
	    eval q(0);
	}' unless defined(&paravirt_enabled);
	eval 'sub get_debugreg {
	    my($var, $register) = @_;
    	    eval q(($var) =  &native_get_debugreg($register));
	}' unless defined(&get_debugreg);
	eval 'sub set_debugreg {
	    my($value, $register) = @_;
    	    eval q( &native_set_debugreg($register, $value));
	}' unless defined(&set_debugreg);
	eval 'sub load_sp0 {
	    my($tss,$thread) = @_;
    	    eval q({  &native_load_sp0($tss, $thread); });
	}' unless defined(&load_sp0);
	eval 'sub set_iopl_mask () { &native_set_iopl_mask;}' unless defined(&set_iopl_mask);
    }
    eval 'sub set_in_cr4 {
        my($mask) = @_;
	    eval q({ my $cr4;  &mmu_cr4_features |= $mask;  $cr4 =  &read_cr4();  $cr4 |= $mask;  &write_cr4( $cr4); });
    }' unless defined(&set_in_cr4);
    eval 'sub clear_in_cr4 {
        my($mask) = @_;
	    eval q({ my $cr4;  &mmu_cr4_features &= ~$mask;  $cr4 =  &read_cr4();  $cr4 &= ~$mask;  &write_cr4( $cr4); });
    }' unless defined(&clear_in_cr4);
    eval 'sub cpuid_ebx {
        my($op) = @_;
	    eval q({ my $eax,  &ebx,  &ecx,  &edx;  &cpuid($op,  $eax,  &ebx,  &ecx,  &edx);  &ebx; });
    }' unless defined(&cpuid_ebx);
    eval 'sub cpuid_ecx {
        my($op) = @_;
	    eval q({ my $eax,  &ebx,  &ecx,  &edx;  &cpuid($op,  $eax,  &ebx,  &ecx,  &edx);  &ecx; });
    }' unless defined(&cpuid_ecx);
    eval 'sub cpuid_edx {
        my($op) = @_;
	    eval q({ my $eax,  &ebx,  &ecx,  &edx;  &cpuid($op,  $eax,  &ebx,  &ecx,  &edx);  &edx; });
    }' unless defined(&cpuid_edx);
    eval 'sub cpu_relax {
        my($void) = @_;
	    eval q({  &rep_nop(); });
    }' unless defined(&cpu_relax);
    eval 'sub __monitor {
        my($eax,$ecx,$edx) = @_;
	    eval q({  &asm  &volatile(\\".byte 0x0f, 0x01, 0xc8;\\" :: \\"a\\" ($eax), \\"c\\" ($ecx), \\"d\\"($edx)); });
    }' unless defined(&__monitor);
    eval 'sub __mwait {
        my($eax,$ecx) = @_;
	    eval q({  &asm  &volatile(\\".byte 0x0f, 0x01, 0xc9;\\" :: \\"a\\" ($eax), \\"c\\" ($ecx)); });
    }' unless defined(&__mwait);
    eval 'sub __sti_mwait {
        my($eax,$ecx) = @_;
	    eval q({  &trace_hardirqs_on();  &asm  &volatile(\\"sti; .byte 0x0f, 0x01, 0xc9;\\" :: \\"a\\" ($eax), \\"c\\" ($ecx)); });
    }' unless defined(&__sti_mwait);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub update_debugctlmsr {
        my($debugctlmsr) = @_;
	    eval q({  &wrmsrl( &MSR_IA32_DEBUGCTLMSR, $debugctlmsr); });
    }' unless defined(&update_debugctlmsr);
    eval 'sub HAVE_ARCH_PICK_MMAP_LAYOUT () {1;}' unless defined(&HAVE_ARCH_PICK_MMAP_LAYOUT);
    eval 'sub ARCH_HAS_PREFETCHW () {1;}' unless defined(&ARCH_HAS_PREFETCHW);
    eval 'sub ARCH_HAS_SPINLOCK_PREFETCH () {1;}' unless defined(&ARCH_HAS_SPINLOCK_PREFETCH);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub BASE_PREFETCH () { &ASM_NOP4;}' unless defined(&BASE_PREFETCH);
	eval 'sub ARCH_HAS_PREFETCH () {1;}' unless defined(&ARCH_HAS_PREFETCH);
    } else {
	eval 'sub BASE_PREFETCH () {"prefetcht0 (%1)";}' unless defined(&BASE_PREFETCH);
    }
    eval 'sub spin_lock_prefetch {
        my($x) = @_;
	    eval q({  &prefetchw($x); });
    }' unless defined(&spin_lock_prefetch);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub TASK_SIZE () { &PAGE_OFFSET;}' unless defined(&TASK_SIZE);
	eval 'sub STACK_TOP () { &TASK_SIZE;}' unless defined(&STACK_TOP);
	eval 'sub STACK_TOP_MAX () { &STACK_TOP;}' unless defined(&STACK_TOP_MAX);
	eval 'sub INIT_THREAD () {{ . &sp0 = $sizeof{ &init_stack} +  &init_stack, . &vm86_info =  &NULL, . &sysenter_cs =  &__KERNEL_CS, . &io_bitmap_ptr =  &NULL, . &fs =  &__KERNEL_PERCPU, };}' unless defined(&INIT_THREAD);
	eval 'sub INIT_TSS () {{ . &x86_tss = { . &sp0 = $sizeof{ &init_stack} +  &init_stack, . &ss0 =  &__KERNEL_DS, . &ss1 =  &__KERNEL_CS, . &io_bitmap_base =  &INVALID_IO_BITMAP_OFFSET, }, . &io_bitmap = { [0...  &IO_BITMAP_LONGS] = ~0}, };}' unless defined(&INIT_TSS);
	eval 'sub THREAD_SIZE_LONGS () {( &THREAD_SIZE/$sizeof{\'unsigned long\'});}' unless defined(&THREAD_SIZE_LONGS);
	eval 'sub KSTK_TOP {
	    my($info) = @_;
    	    eval q(({ \'unsigned long\' * &__ptr = ; (& $__ptr[ &THREAD_SIZE_LONGS]); }));
	}' unless defined(&KSTK_TOP);
	eval 'sub task_pt_regs {
	    my($task) = @_;
    	    eval q(({ \'struct pt_regs\' * &__regs__;  &__regs__ = ( &KSTK_TOP( &task_stack_page($task))-8);  &__regs__ - 1; }));
	}' unless defined(&task_pt_regs);
	eval 'sub KSTK_ESP {
	    my($task) = @_;
    	    eval q(( &task_pt_regs($task)-> &sp));
	}' unless defined(&KSTK_ESP);
    } else {
	eval 'sub TASK_SIZE64 () {((1 << 47) -  &PAGE_SIZE);}' unless defined(&TASK_SIZE64);
	eval 'sub IA32_PAGE_OFFSET () {(( ($current->{personality}) &  &ADDR_LIMIT_3GB) ? 0xc0000000 : 0xffffe000);}' unless defined(&IA32_PAGE_OFFSET);
	eval 'sub TASK_SIZE () {( &test_thread_flag( &TIF_IA32) ?  &IA32_PAGE_OFFSET :  &TASK_SIZE64);}' unless defined(&TASK_SIZE);
	eval 'sub TASK_SIZE_OF {
	    my($child) = @_;
    	    eval q((( &test_tsk_thread_flag($child,  &TIF_IA32)) ?  &IA32_PAGE_OFFSET :  &TASK_SIZE64));
	}' unless defined(&TASK_SIZE_OF);
	eval 'sub STACK_TOP () { &TASK_SIZE;}' unless defined(&STACK_TOP);
	eval 'sub STACK_TOP_MAX () { &TASK_SIZE64;}' unless defined(&STACK_TOP_MAX);
	eval 'sub INIT_THREAD () {{ . &sp0 =  &init_stack + $sizeof{ &init_stack} };}' unless defined(&INIT_THREAD);
	eval 'sub INIT_TSS () {{ . ($x86_tss->{sp0}) =  &init_stack + $sizeof{ &init_stack} };}' unless defined(&INIT_TSS);
	eval 'sub thread_saved_pc {
	    my($t) = @_;
    	    eval q((*(($t)-> ($thread->{sp}) - 8)));
	}' unless defined(&thread_saved_pc);
	eval 'sub task_pt_regs {
	    my($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{sp0}) - 1));
	}' unless defined(&task_pt_regs);
	eval 'sub KSTK_ESP {
	    my($tsk) = @_;
    	    eval q(-1);
	}' unless defined(&KSTK_ESP);
    }
    eval 'sub TASK_UNMAPPED_BASE () {( &PAGE_ALIGN( &TASK_SIZE / 3));}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub KSTK_EIP {
        my($task) = @_;
	    eval q(( &task_pt_regs($task)-> &ip));
    }' unless defined(&KSTK_EIP);
    eval 'sub GET_TSC_CTL {
        my($adr) = @_;
	    eval q( &get_tsc_mode(($adr)));
    }' unless defined(&GET_TSC_CTL);
    eval 'sub SET_TSC_CTL {
        my($val) = @_;
	    eval q( &set_tsc_mode(($val)));
    }' unless defined(&SET_TSC_CTL);
}
1;
