require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_SEGMENT_H_)) {
    eval 'sub _ASM_X86_SEGMENT_H_ () {1;}' unless defined(&_ASM_X86_SEGMENT_H_);
    eval 'sub GDT_ENTRY {
        my($flags, $base, $limit) = @_;
	    eval q((((($base) & 0xff000000) << (56-24)) | ((($flags) & 0xf0ff) << 40) | ((($limit) & 0xf0000) << (48-16)) | ((($base) & 0xffffff) << 16) | ((($limit) & 0xffff))));
    }' unless defined(&GDT_ENTRY);
    eval 'sub GDT_ENTRY_BOOT_CS () {2;}' unless defined(&GDT_ENTRY_BOOT_CS);
    eval 'sub __BOOT_CS () {( &GDT_ENTRY_BOOT_CS * 8);}' unless defined(&__BOOT_CS);
    eval 'sub GDT_ENTRY_BOOT_DS () {( &GDT_ENTRY_BOOT_CS + 1);}' unless defined(&GDT_ENTRY_BOOT_DS);
    eval 'sub __BOOT_DS () {( &GDT_ENTRY_BOOT_DS * 8);}' unless defined(&__BOOT_DS);
    eval 'sub GDT_ENTRY_BOOT_TSS () {( &GDT_ENTRY_BOOT_CS + 2);}' unless defined(&GDT_ENTRY_BOOT_TSS);
    eval 'sub __BOOT_TSS () {( &GDT_ENTRY_BOOT_TSS * 8);}' unless defined(&__BOOT_TSS);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub GDT_ENTRY_TLS_MIN () {6;}' unless defined(&GDT_ENTRY_TLS_MIN);
	eval 'sub GDT_ENTRY_TLS_MAX () {( &GDT_ENTRY_TLS_MIN +  &GDT_ENTRY_TLS_ENTRIES - 1);}' unless defined(&GDT_ENTRY_TLS_MAX);
	eval 'sub GDT_ENTRY_DEFAULT_USER_CS () {14;}' unless defined(&GDT_ENTRY_DEFAULT_USER_CS);
	eval 'sub GDT_ENTRY_DEFAULT_USER_DS () {15;}' unless defined(&GDT_ENTRY_DEFAULT_USER_DS);
	eval 'sub GDT_ENTRY_KERNEL_BASE () {12;}' unless defined(&GDT_ENTRY_KERNEL_BASE);
	eval 'sub GDT_ENTRY_KERNEL_CS () {( &GDT_ENTRY_KERNEL_BASE + 0);}' unless defined(&GDT_ENTRY_KERNEL_CS);
	eval 'sub GDT_ENTRY_KERNEL_DS () {( &GDT_ENTRY_KERNEL_BASE + 1);}' unless defined(&GDT_ENTRY_KERNEL_DS);
	eval 'sub GDT_ENTRY_TSS () {( &GDT_ENTRY_KERNEL_BASE + 4);}' unless defined(&GDT_ENTRY_TSS);
	eval 'sub GDT_ENTRY_LDT () {( &GDT_ENTRY_KERNEL_BASE + 5);}' unless defined(&GDT_ENTRY_LDT);
	eval 'sub GDT_ENTRY_PNPBIOS_BASE () {( &GDT_ENTRY_KERNEL_BASE + 6);}' unless defined(&GDT_ENTRY_PNPBIOS_BASE);
	eval 'sub GDT_ENTRY_APMBIOS_BASE () {( &GDT_ENTRY_KERNEL_BASE + 11);}' unless defined(&GDT_ENTRY_APMBIOS_BASE);
	eval 'sub GDT_ENTRY_ESPFIX_SS () {( &GDT_ENTRY_KERNEL_BASE + 14);}' unless defined(&GDT_ENTRY_ESPFIX_SS);
	eval 'sub __ESPFIX_SS () {( &GDT_ENTRY_ESPFIX_SS * 8);}' unless defined(&__ESPFIX_SS);
	eval 'sub GDT_ENTRY_PERCPU () {( &GDT_ENTRY_KERNEL_BASE + 15);}' unless defined(&GDT_ENTRY_PERCPU);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub __KERNEL_PERCPU () {( &GDT_ENTRY_PERCPU * 8);}' unless defined(&__KERNEL_PERCPU);
	} else {
	    eval 'sub __KERNEL_PERCPU () {0;}' unless defined(&__KERNEL_PERCPU);
	}
	eval 'sub GDT_ENTRY_DOUBLEFAULT_TSS () {31;}' unless defined(&GDT_ENTRY_DOUBLEFAULT_TSS);
	eval 'sub GDT_ENTRIES () {32;}' unless defined(&GDT_ENTRIES);
	eval 'sub GDT_ENTRY_PNPBIOS_CS32 () {( &GDT_ENTRY_PNPBIOS_BASE + 0);}' unless defined(&GDT_ENTRY_PNPBIOS_CS32);
	eval 'sub GDT_ENTRY_PNPBIOS_CS16 () {( &GDT_ENTRY_PNPBIOS_BASE + 1);}' unless defined(&GDT_ENTRY_PNPBIOS_CS16);
	eval 'sub GDT_ENTRY_PNPBIOS_DS () {( &GDT_ENTRY_PNPBIOS_BASE + 2);}' unless defined(&GDT_ENTRY_PNPBIOS_DS);
	eval 'sub GDT_ENTRY_PNPBIOS_TS1 () {( &GDT_ENTRY_PNPBIOS_BASE + 3);}' unless defined(&GDT_ENTRY_PNPBIOS_TS1);
	eval 'sub GDT_ENTRY_PNPBIOS_TS2 () {( &GDT_ENTRY_PNPBIOS_BASE + 4);}' unless defined(&GDT_ENTRY_PNPBIOS_TS2);
	eval 'sub PNP_CS32 () {( &GDT_ENTRY_PNPBIOS_CS32 * 8);}' unless defined(&PNP_CS32);
	eval 'sub PNP_CS16 () {( &GDT_ENTRY_PNPBIOS_CS16 * 8);}' unless defined(&PNP_CS16);
	eval 'sub PNP_DS () {( &GDT_ENTRY_PNPBIOS_DS * 8);}' unless defined(&PNP_DS);
	eval 'sub PNP_TS1 () {( &GDT_ENTRY_PNPBIOS_TS1 * 8);}' unless defined(&PNP_TS1);
	eval 'sub PNP_TS2 () {( &GDT_ENTRY_PNPBIOS_TS2 * 8);}' unless defined(&PNP_TS2);
	eval 'sub SEGMENT_RPL_MASK () {0x3;}' unless defined(&SEGMENT_RPL_MASK);
	eval 'sub SEGMENT_TI_MASK () {0x4;}' unless defined(&SEGMENT_TI_MASK);
	eval 'sub USER_RPL () {0x3;}' unless defined(&USER_RPL);
	eval 'sub SEGMENT_LDT () {0x4;}' unless defined(&SEGMENT_LDT);
	eval 'sub SEGMENT_GDT () {0x;}' unless defined(&SEGMENT_GDT);
	eval 'sub SEGMENT_IS_KERNEL_CODE {
	    my($x) = @_;
    	    eval q(((($x) & 0xfc) ==  &GDT_ENTRY_KERNEL_CS * 8));
	}' unless defined(&SEGMENT_IS_KERNEL_CODE);
	eval 'sub SEGMENT_IS_FLAT_CODE {
	    my($x) = @_;
    	    eval q(((($x) & 0xec) ==  &GDT_ENTRY_KERNEL_CS * 8));
	}' unless defined(&SEGMENT_IS_FLAT_CODE);
	eval 'sub SEGMENT_IS_PNP_CODE {
	    my($x) = @_;
    	    eval q(((($x) & 0xf4) ==  &GDT_ENTRY_PNPBIOS_BASE * 8));
	}' unless defined(&SEGMENT_IS_PNP_CODE);
    } else {
	require 'asm/cache.ph';
	eval 'sub GDT_ENTRY_KERNEL32_CS () {1;}' unless defined(&GDT_ENTRY_KERNEL32_CS);
	eval 'sub GDT_ENTRY_KERNEL_CS () {2;}' unless defined(&GDT_ENTRY_KERNEL_CS);
	eval 'sub GDT_ENTRY_KERNEL_DS () {3;}' unless defined(&GDT_ENTRY_KERNEL_DS);
	eval 'sub __KERNEL32_CS () {( &GDT_ENTRY_KERNEL32_CS * 8);}' unless defined(&__KERNEL32_CS);
	eval 'sub GDT_ENTRY_DEFAULT_USER32_CS () {4;}' unless defined(&GDT_ENTRY_DEFAULT_USER32_CS);
	eval 'sub GDT_ENTRY_DEFAULT_USER_DS () {5;}' unless defined(&GDT_ENTRY_DEFAULT_USER_DS);
	eval 'sub GDT_ENTRY_DEFAULT_USER_CS () {6;}' unless defined(&GDT_ENTRY_DEFAULT_USER_CS);
	eval 'sub __USER32_CS () {( &GDT_ENTRY_DEFAULT_USER32_CS * 8+ 3);}' unless defined(&__USER32_CS);
	eval 'sub __USER32_DS () { &__USER_DS;}' unless defined(&__USER32_DS);
	eval 'sub GDT_ENTRY_TSS () {8;}' unless defined(&GDT_ENTRY_TSS);
	eval 'sub GDT_ENTRY_LDT () {10;}' unless defined(&GDT_ENTRY_LDT);
	eval 'sub GDT_ENTRY_TLS_MIN () {12;}' unless defined(&GDT_ENTRY_TLS_MIN);
	eval 'sub GDT_ENTRY_TLS_MAX () {14;}' unless defined(&GDT_ENTRY_TLS_MAX);
	eval 'sub GDT_ENTRY_PER_CPU () {15;}' unless defined(&GDT_ENTRY_PER_CPU);
	eval 'sub __PER_CPU_SEG () {( &GDT_ENTRY_PER_CPU * 8+ 3);}' unless defined(&__PER_CPU_SEG);
	eval 'sub FS_TLS () {0;}' unless defined(&FS_TLS);
	eval 'sub GS_TLS () {1;}' unless defined(&GS_TLS);
	eval 'sub GS_TLS_SEL () {(( &GDT_ENTRY_TLS_MIN+ &GS_TLS)*8+ 3);}' unless defined(&GS_TLS_SEL);
	eval 'sub FS_TLS_SEL () {(( &GDT_ENTRY_TLS_MIN+ &FS_TLS)*8+ 3);}' unless defined(&FS_TLS_SEL);
	eval 'sub GDT_ENTRIES () {16;}' unless defined(&GDT_ENTRIES);
    }
    eval 'sub __KERNEL_CS () {( &GDT_ENTRY_KERNEL_CS * 8);}' unless defined(&__KERNEL_CS);
    eval 'sub __KERNEL_DS () {( &GDT_ENTRY_KERNEL_DS * 8);}' unless defined(&__KERNEL_DS);
    eval 'sub __USER_DS () {( &GDT_ENTRY_DEFAULT_USER_DS* 8+ 3);}' unless defined(&__USER_DS);
    eval 'sub __USER_CS () {( &GDT_ENTRY_DEFAULT_USER_CS* 8+ 3);}' unless defined(&__USER_CS);
    unless(defined(&CONFIG_PARAVIRT)) {
	eval 'sub get_kernel_rpl () {
	    eval q(0);
	}' unless defined(&get_kernel_rpl);
    }
    eval 'sub USER_RPL () {0x3;}' unless defined(&USER_RPL);
    eval 'sub SEGMENT_LDT () {0x4;}' unless defined(&SEGMENT_LDT);
    eval 'sub SEGMENT_GDT () {0x;}' unless defined(&SEGMENT_GDT);
    eval 'sub SEGMENT_RPL_MASK () {0x3;}' unless defined(&SEGMENT_RPL_MASK);
    eval 'sub SEGMENT_TI_MASK () {0x4;}' unless defined(&SEGMENT_TI_MASK);
    eval 'sub IDT_ENTRIES () {256;}' unless defined(&IDT_ENTRIES);
    eval 'sub NUM_EXCEPTION_VECTORS () {32;}' unless defined(&NUM_EXCEPTION_VECTORS);
    eval 'sub GDT_SIZE () {( &GDT_ENTRIES * 8);}' unless defined(&GDT_SIZE);
    eval 'sub GDT_ENTRY_TLS_ENTRIES () {3;}' unless defined(&GDT_ENTRY_TLS_ENTRIES);
    eval 'sub TLS_SIZE () {( &GDT_ENTRY_TLS_ENTRIES * 8);}' unless defined(&TLS_SIZE);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	}
    }
}
1;
