require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_SMP_H_)) {
    eval 'sub _ASM_X86_SMP_H_ () {1;}' unless defined(&_ASM_X86_SMP_H_);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/cpumask.ph';
	require 'linux/init.ph';
	require 'asm/percpu.ph';
	if(defined(&CONFIG_X86_LOCAL_APIC)) {
	    require 'asm/mpspec.ph';
	    require 'asm/apic.ph';
	    if(defined(&CONFIG_X86_IO_APIC)) {
		require 'asm/io_apic.ph';
	    }
	}
	require 'asm/pda.ph';
	require 'asm/thread_info.ph';
	if(defined(&CONFIG_SMP)) {
	    unless(defined(&CONFIG_PARAVIRT)) {
		eval 'sub startup_ipi_hook {
		    my($phys_apicid, $start_eip, $start_esp) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&startup_ipi_hook);
	    }
	    eval 'sub smp_send_stop {
	        my($void) = @_;
    		eval q({  ($smp_ops->{smp_send_stop})(); });
	    }' unless defined(&smp_send_stop);
	    eval 'sub smp_prepare_boot_cpu {
	        my($void) = @_;
    		eval q({  ($smp_ops->{smp_prepare_boot_cpu})(); });
	    }' unless defined(&smp_prepare_boot_cpu);
	    eval 'sub smp_prepare_cpus {
	        my($max_cpus) = @_;
    		eval q({  ($smp_ops->{smp_prepare_cpus})($max_cpus); });
	    }' unless defined(&smp_prepare_cpus);
	    eval 'sub smp_cpus_done {
	        my($max_cpus) = @_;
    		eval q({  ($smp_ops->{smp_cpus_done})($max_cpus); });
	    }' unless defined(&smp_cpus_done);
	    eval 'sub __cpu_up {
	        my($cpu) = @_;
    		eval q({  ($smp_ops->{cpu_up})($cpu); });
	    }' unless defined(&__cpu_up);
	    eval 'sub smp_send_reschedule {
	        my($cpu) = @_;
    		eval q({  ($smp_ops->{smp_send_reschedule})($cpu); });
	    }' unless defined(&smp_send_reschedule);
	    eval 'sub arch_send_call_function_single_ipi {
	        my($cpu) = @_;
    		eval q({  ($smp_ops->{send_call_func_single_ipi})($cpu); });
	    }' unless defined(&arch_send_call_function_single_ipi);
	    eval 'sub arch_send_call_function_ipi {
	        my($mask) = @_;
    		eval q({  ($smp_ops->{send_call_func_ipi})($mask); });
	    }' unless defined(&arch_send_call_function_ipi);
	    eval 'sub cpu_physical_id {
	        my($cpu) = @_;
    		eval q( &per_cpu( &x86_cpu_to_apicid, $cpu));
	    }' unless defined(&cpu_physical_id);
	}
	if(defined( &CONFIG_SMP)  && defined( &CONFIG_HOTPLUG_CPU)) {
	} else {
	    eval 'sub prefill_possible_map {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&prefill_possible_map);
	}
	if(defined(&CONFIG_X86_32_SMP)) {
	    eval 'sub raw_smp_processor_id () {
	        eval q(( &x86_read_percpu( &cpu_number)));
	    }' unless defined(&raw_smp_processor_id);
	}
 elsif(defined( &CONFIG_X86_64_SMP)) {
	    eval 'sub raw_smp_processor_id () {
	        eval q( &read_pda( &cpunumber));
	    }' unless defined(&raw_smp_processor_id);
	    eval 'sub stack_smp_processor_id () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&stack_smp_processor_id);
	    eval 'sub safe_smp_processor_id () {
	        eval q( &smp_processor_id());
	    }' unless defined(&safe_smp_processor_id);
	} else {
	    eval 'sub cpu_physical_id {
	        my($cpu) = @_;
    		eval q( &boot_cpu_physical_apicid);
	    }' unless defined(&cpu_physical_id);
	    eval 'sub safe_smp_processor_id () {
	        eval q(0);
	    }' unless defined(&safe_smp_processor_id);
	    eval 'sub stack_smp_processor_id () {
	        eval q(0);
	    }' unless defined(&stack_smp_processor_id);
	}
	if(defined(&CONFIG_X86_LOCAL_APIC)) {
	    eval 'sub logical_smp_processor_id {
	        my($void) = @_;
    		eval q({  &GET_APIC_LOGICAL_ID(*( &u32 *)( &APIC_BASE +  &APIC_LDR)); });
	    }' unless defined(&logical_smp_processor_id);
	    unless(defined(&CONFIG_X86_64)) {
		eval 'sub read_apic_id {
		    my($void) = @_;
    		    eval q({ *( &u32 *)( &APIC_BASE +  &APIC_ID); });
		}' unless defined(&read_apic_id);
	    } else {
	    }
	    if(defined(&APIC_DEFINITION)) {
	    } else {
		require 'mach_apicdef.ph';
		eval 'sub hard_smp_processor_id {
		    my($void) = @_;
    		    eval q({  &GET_APIC_ID( &read_apic_id()); });
		}' unless defined(&hard_smp_processor_id);
	    }
	} else {
	    unless(defined(&CONFIG_SMP)) {
		eval 'sub hard_smp_processor_id () {
		    eval q(0);
		}' unless defined(&hard_smp_processor_id);
	    }
	}
	if(defined(&CONFIG_HOTPLUG_CPU)) {
	}
    }
}
1;
