require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_SYSTEM_H_)) {
    eval 'sub _ASM_X86_SYSTEM_H_ () {1;}' unless defined(&_ASM_X86_SYSTEM_H_);
    require 'asm/asm.ph';
    require 'asm/segment.ph';
    require 'asm/cpufeature.ph';
    require 'asm/cmpxchg.ph';
    require 'asm/nops.ph';
    require 'linux/kernel.ph';
    require 'linux/irqflags.ph';
    if(defined(&CONFIG_IA32_EMULATION)) {
	eval 'sub AT_VECTOR_SIZE_ARCH () {2;}' unless defined(&AT_VECTOR_SIZE_ARCH);
    } else {
	eval 'sub AT_VECTOR_SIZE_ARCH () {1;}' unless defined(&AT_VECTOR_SIZE_ARCH);
    }
    if(defined(&CONFIG_X86_32)) {
	eval 'sub switch_to {
	    my($prev, $next, $last) = @_;
    	    eval q( &do { \'unsigned long ebx\',  &ecx,  &edx,  &esi,  &edi;  &asm  &volatile(\\"pushfl\\\\n\\\\t\\" \\"pushl %%ebp\\\\n\\\\t\\" \\"movl %%esp,%[prev_sp]\\\\n\\\\t\\" \\"movl %[next_sp],%%esp\\\\n\\\\t\\" \\"movl $1f,%[prev_ip]\\\\n\\\\t\\" \\"pushl %[next_ip]\\\\n\\\\t\\" \\"jmp __switch_to\\\\n\\" \\"1:\\\\t\\" \\"popl %%ebp\\\\n\\\\t\\" \\"popfl\\\\n\\" : [ &prev_sp] \\"=m\\" ( ($prev->{thread}->{sp})), [ &prev_ip] \\"=m\\" ( ($prev->{thread}->{ip})), \\"=a\\" ($last), \\"=b\\" ( &ebx), \\"=c\\" ( &ecx), \\"=d\\" ( &edx), \\"=S\\" ( &esi), \\"=D\\" ( &edi) : [ &next_sp] \\"m\\" ( ($next->{thread}->{sp})), [ &next_ip] \\"m\\" ( ($next->{thread}->{ip})), [$prev] \\"a\\" ($prev), [$next] \\"d\\" ($next)); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub HAVE_DISABLE_HLT () {1;}' unless defined(&HAVE_DISABLE_HLT);
    } else {
	eval 'sub __SAVE {
	    my($reg, $offset) = @_;
    	    eval q(\\"movq %%\\" $reg \\",(14-\\" $offset \\")*8(%%rsp)\\\\n\\\\t\\");
	}' unless defined(&__SAVE);
	eval 'sub __RESTORE {
	    my($reg, $offset) = @_;
    	    eval q(\\"movq (14-\\" $offset \\")*8(%%rsp),%%\\" $reg \\"\\\\n\\\\t\\");
	}' unless defined(&__RESTORE);
	eval 'sub SAVE_CONTEXT () {"pushf ; pushq %%rbp ; movq %%rsi,%%rbp\\n\\t";}' unless defined(&SAVE_CONTEXT);
	eval 'sub RESTORE_CONTEXT () {"movq %%rbp,%%rsi ; popq %%rbp ; popf\\t";}' unless defined(&RESTORE_CONTEXT);
	eval 'sub __EXTRA_CLOBBER () {, "rcx", "rbx", "rdx", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15";}' unless defined(&__EXTRA_CLOBBER);
	eval 'sub switch_to {
	    my($prev, $next, $last) = @_;
    	    eval q( &asm  &volatile( &SAVE_CONTEXT \\"movq %%rsp,%P[threadrsp](%[prev])\\\\n\\\\t\\" \\"movq %P[threadrsp](%[next]),%%rsp\\\\n\\\\t\\" \\"call __switch_to\\\\n\\\\t\\" \\".globl thread_return\\\\n\\" \\"thread_return:\\\\n\\\\t\\" \\"movq %%gs:%P[pda_pcurrent],%%rsi\\\\n\\\\t\\" \\"movq %P[thread_info](%%rsi),%%r8\\\\n\\\\t\\"  &LOCK_PREFIX \\"btr  %[tif_fork],%P[ti_flags](%%r8)\\\\n\\\\t\\" \\"movq %%rax,%%rdi\\\\n\\\\t\\" \\"jc   ret_from_fork\\\\n\\\\t\\"  &RESTORE_CONTEXT : \\"=a\\" ($last) : [$next] \\"S\\" ($next), [$prev] \\"D\\" ($prev), [ &threadrsp] \\"i\\" ( &offsetof(\'struct task_struct\',  ($thread->{sp}))), [ &ti_flags] \\"i\\" ( &offsetof(\'struct thread_info\',  &flags)), [ &tif_fork] \\"i\\" ( &TIF_FORK), [ &thread_info] \\"i\\" ( &offsetof(\'struct task_struct\',  &stack)), [ &pda_pcurrent] \\"i\\" ( &offsetof(\'struct x8664_pda\',  &pcurrent)) : \\"memory\\", \\"cc\\"  &__EXTRA_CLOBBER));
	}' unless defined(&switch_to);
    }
    if(defined(&__KERNEL__)) {
	eval 'sub _set_base {
	    my($addr, $base) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_set_base);
	eval 'sub _set_limit {
	    my($addr, $limit) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&_set_limit);
	eval 'sub set_base {
	    my($ldt, $base) = @_;
    	    eval q( &_set_base((($ldt)) , ($base)));
	}' unless defined(&set_base);
	eval 'sub set_limit {
	    my($ldt, $limit) = @_;
    	    eval q( &_set_limit((($ldt)) , (($limit)-1)));
	}' unless defined(&set_limit);
	eval 'sub loadsegment {
	    my($seg, $value) = @_;
    	    eval q( &asm  &volatile(\\"\\\\n\\" \\"1:\\\\t\\" \\"movl %k0,%%\\" $seg \\"\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\t\\" \\"movl %k1, %%\\" $seg \\"\\\\n\\\\t\\" \\"jmp 2b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b,3 &b) : :\\"r\\" ($value), \\"r\\" (0) : \\"memory\\"));
	}' unless defined(&loadsegment);
	eval 'sub savesegment {
	    my($seg, $value) = @_;
    	    eval q( &asm(\\"mov %%\\" $seg \\",%0\\":\\"=r\\" ($value) : : \\"memory\\"));
	}' unless defined(&savesegment);
	eval 'sub get_limit {
	    my($segment) = @_;
    	    eval q({ my $__limit;  &asm(\\"lsll %1,%0\\" : \\"=r\\" ( $__limit) : \\"r\\" ($segment));  $__limit + 1; });
	}' unless defined(&get_limit);
	eval 'sub native_clts {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"clts\\"); });
	}' unless defined(&native_clts);
	eval 'sub native_read_cr0 {
	    my($void) = @_;
    	    eval q({ my $val;  &asm  &volatile(\\"mov %%cr0,%0\\\\n\\\\t\\" : \\"=r\\" ( $val), \\"=m\\" ( &__force_order));  $val; });
	}' unless defined(&native_read_cr0);
	eval 'sub native_write_cr0 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov %0,%%cr0\\": : \\"r\\" ($val), \\"m\\" ( &__force_order)); });
	}' unless defined(&native_write_cr0);
	eval 'sub native_read_cr2 {
	    my($void) = @_;
    	    eval q({ my $val;  &asm  &volatile(\\"mov %%cr2,%0\\\\n\\\\t\\" : \\"=r\\" ( $val), \\"=m\\" ( &__force_order));  $val; });
	}' unless defined(&native_read_cr2);
	eval 'sub native_write_cr2 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov %0,%%cr2\\": : \\"r\\" ($val), \\"m\\" ( &__force_order)); });
	}' unless defined(&native_write_cr2);
	eval 'sub native_read_cr3 {
	    my($void) = @_;
    	    eval q({ my $val;  &asm  &volatile(\\"mov %%cr3,%0\\\\n\\\\t\\" : \\"=r\\" ( $val), \\"=m\\" ( &__force_order));  $val; });
	}' unless defined(&native_read_cr3);
	eval 'sub native_write_cr3 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov %0,%%cr3\\": : \\"r\\" ($val), \\"m\\" ( &__force_order)); });
	}' unless defined(&native_write_cr3);
	eval 'sub native_read_cr4 {
	    my($void) = @_;
    	    eval q({ my $val;  &asm  &volatile(\\"mov %%cr4,%0\\\\n\\\\t\\" : \\"=r\\" ( $val), \\"=m\\" ( &__force_order));  $val; });
	}' unless defined(&native_read_cr4);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub native_read_cr4_safe {
	    my($void) = @_;
    	    eval q({ my $val;  $val; });
	}' unless defined(&native_read_cr4_safe);
	eval 'sub native_write_cr4 {
	    my($val) = @_;
    	    eval q({  &asm  &volatile(\\"mov %0,%%cr4\\": : \\"r\\" ($val), \\"m\\" ( &__force_order)); });
	}' unless defined(&native_write_cr4);
	if(defined(&CONFIG_X86_64)) {
	    eval 'sub native_read_cr8 {
	        my($void) = @_;
    		eval q({ my $cr8;  &asm  &volatile(\\"movq %%cr8,%0\\" : \\"=r\\" ( $cr8));  $cr8; });
	    }' unless defined(&native_read_cr8);
	    eval 'sub native_write_cr8 {
	        my($val) = @_;
    		eval q({  &asm  &volatile(\\"movq %0,%%cr8\\" :: \\"r\\" ($val) : \\"memory\\"); });
	    }' unless defined(&native_write_cr8);
	}
	eval 'sub native_wbinvd {
	    my($void) = @_;
    	    eval q({  &asm  &volatile(\\"wbinvd\\": : :\\"memory\\"); });
	}' unless defined(&native_wbinvd);
	if(defined(&CONFIG_PARAVIRT)) {
	    require 'asm/paravirt.ph';
	} else {
	    eval 'sub read_cr0 () {
	        eval q(( &native_read_cr0()));
	    }' unless defined(&read_cr0);
	    eval 'sub write_cr0 {
	        my($x) = @_;
    		eval q(( &native_write_cr0($x)));
	    }' unless defined(&write_cr0);
	    eval 'sub read_cr2 () {
	        eval q(( &native_read_cr2()));
	    }' unless defined(&read_cr2);
	    eval 'sub write_cr2 {
	        my($x) = @_;
    		eval q(( &native_write_cr2($x)));
	    }' unless defined(&write_cr2);
	    eval 'sub read_cr3 () {
	        eval q(( &native_read_cr3()));
	    }' unless defined(&read_cr3);
	    eval 'sub write_cr3 {
	        my($x) = @_;
    		eval q(( &native_write_cr3($x)));
	    }' unless defined(&write_cr3);
	    eval 'sub read_cr4 () {
	        eval q(( &native_read_cr4()));
	    }' unless defined(&read_cr4);
	    eval 'sub read_cr4_safe () {
	        eval q(( &native_read_cr4_safe()));
	    }' unless defined(&read_cr4_safe);
	    eval 'sub write_cr4 {
	        my($x) = @_;
    		eval q(( &native_write_cr4($x)));
	    }' unless defined(&write_cr4);
	    eval 'sub wbinvd () {
	        eval q(( &native_wbinvd()));
	    }' unless defined(&wbinvd);
	    if(defined(&CONFIG_X86_64)) {
		eval 'sub read_cr8 () {
		    eval q(( &native_read_cr8()));
		}' unless defined(&read_cr8);
		eval 'sub write_cr8 {
		    my($x) = @_;
    		    eval q(( &native_write_cr8($x)));
		}' unless defined(&write_cr8);
		eval 'sub load_gs_index () { &native_load_gs_index;}' unless defined(&load_gs_index);
	    }
	    eval 'sub clts () {
	        eval q(( &native_clts()));
	    }' unless defined(&clts);
	}
	eval 'sub stts () {
	    eval q( &write_cr0( &read_cr0() |  &X86_CR0_TS));
	}' unless defined(&stts);
    }
    eval 'sub clflush {
        my($__p) = @_;
	    eval q({  &asm  &volatile(\\"clflush %0\\" : \\"+m\\" (*( &volatile \'char\'  &__force *)$__p)); });
    }' unless defined(&clflush);
    eval 'sub nop () {
        eval q( &asm  &volatile (\\"nop\\"));
    }' unless defined(&nop);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub mb () {
	    eval q( &alternative(\\"lock; addl $0,0(%%esp)\\", \\"mfence\\",  &X86_FEATURE_XMM2));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &alternative(\\"lock; addl $0,0(%%esp)\\", \\"lfence\\",  &X86_FEATURE_XMM2));
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &alternative(\\"lock; addl $0,0(%%esp)\\", \\"sfence\\",  &X86_FEATURE_XMM));
	}' unless defined(&wmb);
    } else {
	eval 'sub mb () {
	    eval q( &asm  &volatile(\\"mfence\\":::\\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &asm  &volatile(\\"lfence\\":::\\"memory\\"));
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &asm  &volatile(\\"sfence\\" ::: \\"memory\\"));
	}' unless defined(&wmb);
    }
    eval 'sub read_barrier_depends () {
        eval q( &do { }  &while (0));
    }' unless defined(&read_barrier_depends);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	if(defined(&CONFIG_X86_PPRO_FENCE)) {
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	} else {
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	}
	if(defined(&CONFIG_X86_OOSTORE)) {
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	} else {
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	}
	eval 'sub smp_read_barrier_depends () {
	    eval q( &read_barrier_depends());
	}' unless defined(&smp_read_barrier_depends);
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { ( &void) &xchg($var, $value); }  &while (0));
	}' unless defined(&set_mb);
    } else {
	eval 'sub smp_mb () {
	    eval q( &barrier());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &barrier());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &barrier());
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &do { }  &while (0));
	}' unless defined(&smp_read_barrier_depends);
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &barrier(); }  &while (0));
	}' unless defined(&set_mb);
    }
}
1;
