require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_UACCES_H_)) {
    eval 'sub _ASM_UACCES_H_ () {1;}' unless defined(&_ASM_UACCES_H_);
    require 'linux/errno.ph';
    require 'linux/compiler.ph';
    require 'linux/thread_info.ph';
    require 'linux/prefetch.ph';
    require 'linux/string.ph';
    require 'asm/asm.ph';
    require 'asm/page.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub MAKE_MM_SEG {
        my($s) = @_;
	    eval q((( &mm_segment_t) { ($s) }));
    }' unless defined(&MAKE_MM_SEG);
    eval 'sub KERNEL_DS () { &MAKE_MM_SEG(-1);}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () { &MAKE_MM_SEG( &PAGE_OFFSET);}' unless defined(&USER_DS);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a, $b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __addr_ok {
        my($addr) = @_;
	    eval q((($addr) < ( &current_thread_info()-> ($addr_limit->{seg}))));
    }' unless defined(&__addr_ok);
    eval 'sub __range_not_ok {
        my($addr, $size) = @_;
	    eval q(({ \'unsigned long flag\',  &roksum;  &__chk_user_ptr;  &asm(\\"add %3,%1 ; sbb %0,%0 ; cmp %1,%4 ; sbb $0,%0\\" : \\"=&r\\" , \\"=r\\" : \\"1\\" , \\"g\\" (($size)), \\"rm\\" ( &current_thread_info()-> ($addr_limit->{seg})));  &flag; }));
    }' unless defined(&__range_not_ok);
    eval 'sub access_ok {
        my($type, $addr, $size) = @_;
	    eval q(( &likely( &__range_not_ok($addr, $size) == 0)));
    }' unless defined(&access_ok);
    eval 'sub __get_user_x {
        my($size, $ret, $x, $ptr) = @_;
	    eval q( &asm  &volatile(\\"call __get_user_\\" $size : \\"=a\\" ($ret),\\"=d\\" ($x) : \\"0\\" ($ptr)));
    }' unless defined(&__get_user_x);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub __get_user_8 {
	    my($__ret_gu, $__val_gu, $ptr) = @_;
    	    eval q( &__get_user_x( &X, $__ret_gu, $__val_gu, $ptr));
	}' unless defined(&__get_user_8);
    } else {
	eval 'sub __get_user_8 {
	    my($__ret_gu, $__val_gu, $ptr) = @_;
    	    eval q( &__get_user_x(8, $__ret_gu, $__val_gu, $ptr));
	}' unless defined(&__get_user_8);
    }
    eval 'sub get_user {
        my($x, $ptr) = @_;
	    eval q(({ \'int\'  &__ret_gu; \'unsigned long __val_gu\';  &__chk_user_ptr($ptr);  &switch ($sizeof{($ptr)}) {  &case 1:  &__get_user_x(1,  &__ret_gu,  &__val_gu, $ptr);  &break;  &case 2:  &__get_user_x(2,  &__ret_gu,  &__val_gu, $ptr);  &break;  &case 4:  &__get_user_x(4,  &__ret_gu,  &__val_gu, $ptr);  &break;  &case 8:  &__get_user_8( &__ret_gu,  &__val_gu, $ptr);  &break;  &default:  &__get_user_x( &X,  &__ret_gu,  &__val_gu, $ptr);  &break; } ($x) = ( &__typeof__(*($ptr))) &__val_gu;  &__ret_gu; }));
    }' unless defined(&get_user);
    eval 'sub __put_user_x {
        my($size, $x, $ptr, $__ret_pu) = @_;
	    eval q( &asm  &volatile(\\"call __put_user_\\" $size : \\"=a\\" ($__ret_pu) :\\"0\\" (( &typeof(*($ptr)))($x)), \\"c\\" ($ptr) : \\"ebx\\"));
    }' unless defined(&__put_user_x);
    if(defined(&CONFIG_X86_32)) {
	eval 'sub __put_user_u64 {
	    my($x, $addr, $err) = @_;
    	    eval q( &asm  &volatile(\\"1:	movl %%eax,0(%2)\\\\n\\" \\"2:	movl %%edx,4(%2)\\\\n\\" \\"3:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"4:	movl %3,%0\\\\n\\" \\"	jmp 3b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b, 4 &b)  &_ASM_EXTABLE(2 &b, 4 &b) : \\"=r\\" ($err) : \\"A\\" ($x), \\"r\\" ($addr), \\"i\\" (- &EFAULT), \\"0\\" ($err)));
	}' unless defined(&__put_user_u64);
	eval 'sub __put_user_x8 {
	    my($x, $ptr, $__ret_pu) = @_;
    	    eval q( &asm  &volatile(\\"call __put_user_8\\" : \\"=a\\" ($__ret_pu) : \\"A\\" (( &typeof(*($ptr)))($x)), \\"c\\" ($ptr) : \\"ebx\\"));
	}' unless defined(&__put_user_x8);
    } else {
	eval 'sub __put_user_u64 {
	    my($x, $ptr, $retval) = @_;
    	    eval q( &__put_user_asm($x, $ptr, $retval, \\"q\\", \\"\\", \\"Zr\\", - &EFAULT));
	}' unless defined(&__put_user_u64);
	eval 'sub __put_user_x8 {
	    my($x, $ptr, $__ret_pu) = @_;
    	    eval q( &__put_user_x(8, $x, $ptr, $__ret_pu));
	}' unless defined(&__put_user_x8);
    }
    if(defined(&CONFIG_X86_WP_WORKS_OK)) {
	eval 'sub put_user {
	    my($x, $ptr) = @_;
    	    eval q(({ \'int\'  &__ret_pu;  &__typeof__(*($ptr))  &__pu_val;  &__chk_user_ptr($ptr);  &__pu_val = $x;  &switch ($sizeof{($ptr)}) {  &case 1:  &__put_user_x(1,  &__pu_val, $ptr,  &__ret_pu);  &break;  &case 2:  &__put_user_x(2,  &__pu_val, $ptr,  &__ret_pu);  &break;  &case 4:  &__put_user_x(4,  &__pu_val, $ptr,  &__ret_pu);  &break;  &case 8:  &__put_user_x8( &__pu_val, $ptr,  &__ret_pu);  &break;  &default:  &__put_user_x( &X,  &__pu_val, $ptr,  &__ret_pu);  &break; }  &__ret_pu; }));
	}' unless defined(&put_user);
	eval 'sub __put_user_size {
	    my($x, $ptr, $size, $retval, $errret) = @_;
    	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__put_user_asm($x, $ptr, $retval, \\"b\\", \\"b\\", \\"iq\\", $errret);  &break;  &case 2:  &__put_user_asm($x, $ptr, $retval, \\"w\\", \\"w\\", \\"ir\\", $errret);  &break;  &case 4:  &__put_user_asm($x, $ptr, $retval, \\"l\\", \\"k\\", \\"ir\\", $errret);  &break;  &case 8:  &__put_user_u64(( &__typeof__(*$ptr))($x), $ptr, $retval);  &break;  &default:  &__put_user_bad(); } }  &while (0));
	}' unless defined(&__put_user_size);
    } else {
	eval 'sub __put_user_size {
	    my($x, $ptr, $size, $retval, $errret) = @_;
    	    eval q( &do {  &__typeof__(*($ptr)) &__pus_tmp = $x; $retval = 0;  &if ( &unlikely( &__copy_to_user_ll($ptr, & &__pus_tmp, $size) != 0)) $retval = $errret; }  &while (0));
	}' unless defined(&__put_user_size);
	eval 'sub put_user {
	    my($x, $ptr) = @_;
    	    eval q(({ \'int\'  &__ret_pu;  &__typeof__(*($ptr)) &__pus_tmp = $x;  &__ret_pu = 0;  &if ( &unlikely( &__copy_to_user_ll($ptr, & &__pus_tmp, $sizeof{($ptr)}) != 0))  &__ret_pu = - &EFAULT;  &__ret_pu; }));
	}' unless defined(&put_user);
    }
    if(defined(&CONFIG_X86_32)) {
	eval 'sub __get_user_asm_u64 {
	    my($x, $ptr, $retval, $errret) = @_;
    	    eval q(($x) =  &__get_user_bad());
	}' unless defined(&__get_user_asm_u64);
    } else {
	eval 'sub __get_user_asm_u64 {
	    my($x, $ptr, $retval, $errret) = @_;
    	    eval q( &__get_user_asm($x, $ptr, $retval, \\"q\\", \\"\\", \\"=r\\", $errret));
	}' unless defined(&__get_user_asm_u64);
    }
    eval 'sub __get_user_size {
        my($x, $ptr, $size, $retval, $errret) = @_;
	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__get_user_asm($x, $ptr, $retval, \\"b\\", \\"b\\", \\"=q\\", $errret);  &break;  &case 2:  &__get_user_asm($x, $ptr, $retval, \\"w\\", \\"w\\", \\"=r\\", $errret);  &break;  &case 4:  &__get_user_asm($x, $ptr, $retval, \\"l\\", \\"k\\", \\"=r\\", $errret);  &break;  &case 8:  &__get_user_asm_u64($x, $ptr, $retval, $errret);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user_size);
    eval 'sub __get_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errret) = @_;
	    eval q( &asm  &volatile(\\"1:	mov\\"$itype\\" %2,%\\"$rtype\\"1\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	mov %3,%0\\\\n\\" \\"	xor\\"$itype\\" %\\"$rtype\\"1,%\\"$rtype\\"1\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b, 3 &b) : \\"=r\\" ($err), $ltype($x) : \\"m\\" ( &__m($addr)), \\"i\\" ($errret), \\"0\\" ($err)));
    }' unless defined(&__get_user_asm);
    eval 'sub __put_user_nocheck {
        my($x, $ptr, $size) = @_;
	    eval q(({ \'long __pu_err\';  &__put_user_size(($x), ($ptr), ($size),  &__pu_err, - &EFAULT);  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __get_user_nocheck {
        my($x, $ptr, $size) = @_;
	    eval q(({ \'long __gu_err\'; \'unsigned long __gu_val\';  &__get_user_size( &__gu_val, ($ptr), ($size),  &__gu_err, - &EFAULT); ($x) = ( &__force  &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __m {
        my($x) = @_;
	    eval q((*(\'struct __large_struct\'  &__user *)($x)));
    }' unless defined(&__m);
    eval 'sub __put_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errret) = @_;
	    eval q( &asm  &volatile(\\"1:	mov\\"$itype\\" %\\"$rtype\\"1,%2\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:	mov %3,%0\\\\n\\" \\"	jmp 2b\\\\n\\" \\".previous\\\\n\\"  &_ASM_EXTABLE(1 &b, 3 &b) : \\"=r\\"($err) : $ltype($x), \\"m\\" ( &__m($addr)), \\"i\\" ($errret), \\"0\\" ($err)));
    }' unless defined(&__put_user_asm);
    eval 'sub __get_user {
        my($x, $ptr) = @_;
	    eval q( &__get_user_nocheck(($x), ($ptr), $sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub __put_user {
        my($x, $ptr) = @_;
	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x), ($ptr), $sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user_unaligned () { &__get_user;}' unless defined(&__get_user_unaligned);
    eval 'sub __put_user_unaligned () { &__put_user;}' unless defined(&__put_user_unaligned);
    if(defined(&CONFIG_X86_INTEL_USERCOPY)) {
    }
    eval 'sub ARCH_HAS_NOCACHE_UACCESS () {1;}' unless defined(&ARCH_HAS_NOCACHE_UACCESS);
    if(defined(&CONFIG_X86_32)) {
	require 'uaccess_32.ph';
    } else {
	eval 'sub ARCH_HAS_SEARCH_EXTABLE () {1;}' unless defined(&ARCH_HAS_SEARCH_EXTABLE);
	require 'uaccess_64.ph';
    }
}
1;
