require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_BACKING_DEV_H)) {
    eval 'sub _LINUX_BACKING_DEV_H () {1;}' unless defined(&_LINUX_BACKING_DEV_H);
    require 'linux/percpu_counter.ph';
    require 'linux/log2.ph';
    require 'linux/proportions.ph';
    require 'linux/kernel.ph';
    require 'linux/fs.ph';
    require 'asm/atomic.ph';
    eval("sub BDI_pdflush () { 0; }") unless defined(&BDI_pdflush);
    eval("sub BDI_write_congested () { 1; }") unless defined(&BDI_write_congested);
    eval("sub BDI_read_congested () { 2; }") unless defined(&BDI_read_congested);
    eval("sub BDI_unused () { 3; }") unless defined(&BDI_unused);
    eval("sub BDI_RECLAIMABLE () { 0; }") unless defined(&BDI_RECLAIMABLE);
    eval("sub BDI_WRITEBACK () { 1; }") unless defined(&BDI_WRITEBACK);
    eval("sub NR_BDI_STAT_ITEMS () { 2; }") unless defined(&NR_BDI_STAT_ITEMS);
    eval 'sub BDI_STAT_BATCH () {(8*(1+ &ilog2( &nr_cpu_ids)));}' unless defined(&BDI_STAT_BATCH);
    if(defined(&CONFIG_DEBUG_FS)) {
    }
    eval 'sub __add_bdi_stat {
        my($bdi,$item,$amount) = @_;
	    eval q({  &__percpu_counter_add( ($bdi->{bdi_stat[$item]}), $amount,  &BDI_STAT_BATCH); });
    }' unless defined(&__add_bdi_stat);
    eval 'sub __inc_bdi_stat {
        my($bdi,$item) = @_;
	    eval q({  &__add_bdi_stat($bdi, $item, 1); });
    }' unless defined(&__inc_bdi_stat);
    eval 'sub inc_bdi_stat {
        my($bdi,$item) = @_;
	    eval q({ my $flags;  &local_irq_save( $flags);  &__inc_bdi_stat($bdi, $item);  &local_irq_restore( $flags); });
    }' unless defined(&inc_bdi_stat);
    eval 'sub __dec_bdi_stat {
        my($bdi,$item) = @_;
	    eval q({  &__add_bdi_stat($bdi, $item, -1); });
    }' unless defined(&__dec_bdi_stat);
    eval 'sub dec_bdi_stat {
        my($bdi,$item) = @_;
	    eval q({ my $flags;  &local_irq_save( $flags);  &__dec_bdi_stat($bdi, $item);  &local_irq_restore( $flags); });
    }' unless defined(&dec_bdi_stat);
    eval 'sub bdi_stat {
        my($bdi,$item) = @_;
	    eval q({  &percpu_counter_read_positive( ($bdi->{bdi_stat[$item]})); });
    }' unless defined(&bdi_stat);
    eval 'sub __bdi_stat_sum {
        my($bdi,$item) = @_;
	    eval q({  &percpu_counter_sum_positive( ($bdi->{bdi_stat[$item]})); });
    }' unless defined(&__bdi_stat_sum);
    eval 'sub bdi_stat_sum {
        my($bdi,$item) = @_;
	    eval q({  &s64  &sum; my $flags;  &local_irq_save( $flags);  &sum =  &__bdi_stat_sum($bdi, $item);  &local_irq_restore( $flags);  &sum; });
    }' unless defined(&bdi_stat_sum);
    if(defined(&CONFIG_SMP)) {
    } else {
    }
    eval 'sub BDI_CAP_NO_ACCT_DIRTY () {0x1;}' unless defined(&BDI_CAP_NO_ACCT_DIRTY);
    eval 'sub BDI_CAP_NO_WRITEBACK () {0x2;}' unless defined(&BDI_CAP_NO_WRITEBACK);
    eval 'sub BDI_CAP_MAP_COPY () {0x4;}' unless defined(&BDI_CAP_MAP_COPY);
    eval 'sub BDI_CAP_MAP_DIRECT () {0x8;}' unless defined(&BDI_CAP_MAP_DIRECT);
    eval 'sub BDI_CAP_READ_MAP () {0x10;}' unless defined(&BDI_CAP_READ_MAP);
    eval 'sub BDI_CAP_WRITE_MAP () {0x20;}' unless defined(&BDI_CAP_WRITE_MAP);
    eval 'sub BDI_CAP_EXEC_MAP () {0x40;}' unless defined(&BDI_CAP_EXEC_MAP);
    eval 'sub BDI_CAP_NO_ACCT_WB () {0x80;}' unless defined(&BDI_CAP_NO_ACCT_WB);
    eval 'sub BDI_CAP_VMFLAGS () {( &BDI_CAP_READ_MAP |  &BDI_CAP_WRITE_MAP |  &BDI_CAP_EXEC_MAP);}' unless defined(&BDI_CAP_VMFLAGS);
    eval 'sub BDI_CAP_NO_ACCT_AND_WRITEBACK () {( &BDI_CAP_NO_WRITEBACK |  &BDI_CAP_NO_ACCT_DIRTY |  &BDI_CAP_NO_ACCT_WB);}' unless defined(&BDI_CAP_NO_ACCT_AND_WRITEBACK);
    if(defined( &VM_MAYREAD)  && ((defined(&BDI_CAP_READ_MAP) ? &BDI_CAP_READ_MAP : undef) != (defined(&VM_MAYREAD) ? &VM_MAYREAD : undef) || (defined(&BDI_CAP_WRITE_MAP) ? &BDI_CAP_WRITE_MAP : undef) != (defined(&VM_MAYWRITE) ? &VM_MAYWRITE : undef) || (defined(&BDI_CAP_EXEC_MAP) ? &BDI_CAP_EXEC_MAP : undef) != (defined(&VM_MAYEXEC) ? &VM_MAYEXEC : undef))) {
	die("please\ change\ backing_dev_info\:\:capabilities\ flags");
    }
    eval 'sub bdi_congested {
        my($bdi,$bdi_bits) = @_;
	    eval q({  &if ( ($bdi->{congested_fn}))  ($bdi->{congested_fn})( ($bdi->{congested_data}), $bdi_bits); ( ($bdi->{state}) & $bdi_bits); });
    }' unless defined(&bdi_congested);
    eval 'sub bdi_read_congested {
        my($bdi) = @_;
	    eval q({  &bdi_congested($bdi, 1<<  &BDI_read_congested); });
    }' unless defined(&bdi_read_congested);
    eval 'sub bdi_write_congested {
        my($bdi) = @_;
	    eval q({  &bdi_congested($bdi, 1<<  &BDI_write_congested); });
    }' unless defined(&bdi_write_congested);
    eval 'sub bdi_rw_congested {
        my($bdi) = @_;
	    eval q({  &bdi_congested($bdi, (1<<  &BDI_read_congested)| (1<<  &BDI_write_congested)); });
    }' unless defined(&bdi_rw_congested);
    eval 'sub bdi_cap_writeback_dirty {
        my($bdi) = @_;
	    eval q({ !( ($bdi->{capabilities}) &  &BDI_CAP_NO_WRITEBACK); });
    }' unless defined(&bdi_cap_writeback_dirty);
    eval 'sub bdi_cap_account_dirty {
        my($bdi) = @_;
	    eval q({ !( ($bdi->{capabilities}) &  &BDI_CAP_NO_ACCT_DIRTY); });
    }' unless defined(&bdi_cap_account_dirty);
    eval 'sub bdi_cap_account_writeback {
        my($bdi) = @_;
	    eval q({ !( ($bdi->{capabilities}) & ( &BDI_CAP_NO_ACCT_WB |  &BDI_CAP_NO_WRITEBACK)); });
    }' unless defined(&bdi_cap_account_writeback);
    eval 'sub mapping_cap_writeback_dirty {
        my($mapping) = @_;
	    eval q({  &bdi_cap_writeback_dirty( ($mapping->{backing_dev_info})); });
    }' unless defined(&mapping_cap_writeback_dirty);
    eval 'sub mapping_cap_account_dirty {
        my($mapping) = @_;
	    eval q({  &bdi_cap_account_dirty( ($mapping->{backing_dev_info})); });
    }' unless defined(&mapping_cap_account_dirty);
}
1;
