require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_BITOPS_H)) {
    eval 'sub _LINUX_BITOPS_H () {1;}' unless defined(&_LINUX_BITOPS_H);
    require 'asm/types.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub BIT {
	    my($nr) = @_;
    	    eval q((1 << ($nr)));
	}' unless defined(&BIT);
	eval 'sub BIT_MASK {
	    my($nr) = @_;
    	    eval q((1 << (($nr) %  &BITS_PER_LONG)));
	}' unless defined(&BIT_MASK);
	eval 'sub BIT_WORD {
	    my($nr) = @_;
    	    eval q((($nr) /  &BITS_PER_LONG));
	}' unless defined(&BIT_WORD);
	eval 'sub BITS_PER_BYTE () {8;}' unless defined(&BITS_PER_BYTE);
	eval 'sub BITS_TO_LONGS {
	    my($nr) = @_;
    	    eval q( &DIV_ROUND_UP($nr,  &BITS_PER_BYTE * $sizeof{\'long\'}));
	}' unless defined(&BITS_TO_LONGS);
    }
    require 'asm/bitops.ph';
    eval 'sub for_each_bit {
        my($bit, $addr, $size) = @_;
	    eval q( &for (($bit) =  &find_first_bit(($addr), ($size)); ($bit) < ($size); ($bit) =  &find_next_bit(($addr), ($size), ($bit) + 1)));
    }' unless defined(&for_each_bit);
    eval 'sub get_bitmask_order {
        my($count) = @_;
	    eval q({ \'int\'  &order;  &order =  &fls($count);  &order; });
    }' unless defined(&get_bitmask_order);
    eval 'sub get_count_order {
        my($count) = @_;
	    eval q({ \'int\'  &order;  &order =  &fls($count) - 1;  &if ($count & ($count - 1))  &order++;  &order; });
    }' unless defined(&get_count_order);
    eval 'sub hweight_long {
        my($w) = @_;
	    eval q({ $sizeof{$w} == 4?  &hweight32($w) :  &hweight64($w); });
    }' unless defined(&hweight_long);
    eval 'sub fls_long {
        my($l) = @_;
	    eval q({  &if ($sizeof{$l} == 4)  &fls($l);  &fls64($l); });
    }' unless defined(&fls_long);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_GENERIC_FIND_FIRST_BIT)) {
	}
	if(defined(&CONFIG_GENERIC_FIND_NEXT_BIT)) {
	}
    }
}
1;
