require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_BYTEORDER_H)) {
    eval 'sub _LINUX_BYTEORDER_H () {1;}' unless defined(&_LINUX_BYTEORDER_H);
    require 'linux/types.ph';
    require 'linux/swab.ph';
    if(defined( &__LITTLE_ENDIAN)  && defined( &__BIG_ENDIAN)) {
	die("Fix\ asm\/byteorder\.h\ to\ define\ one\ endianness");
    }
    if(!defined( &__LITTLE_ENDIAN)  && !defined( &__BIG_ENDIAN)) {
	die("Fix\ asm\/byteorder\.h\ to\ define\ arch\ endianness");
    }
    if(defined(&__LITTLE_ENDIAN)) {
	undef(&__LITTLE_ENDIAN) if defined(&__LITTLE_ENDIAN);
	eval 'sub __LITTLE_ENDIAN () {1234;}' unless defined(&__LITTLE_ENDIAN);
    }
    if(defined(&__BIG_ENDIAN)) {
	undef(&__BIG_ENDIAN) if defined(&__BIG_ENDIAN);
	eval 'sub __BIG_ENDIAN () {4321;}' unless defined(&__BIG_ENDIAN);
    }
    if(defined( &__LITTLE_ENDIAN)  && !defined( &__LITTLE_ENDIAN_BITFIELD)) {
	eval 'sub __LITTLE_ENDIAN_BITFIELD () {1;}' unless defined(&__LITTLE_ENDIAN_BITFIELD);
    }
    if(defined( &__BIG_ENDIAN)  && !defined( &__BIG_ENDIAN_BITFIELD)) {
	eval 'sub __BIG_ENDIAN_BITFIELD () {1;}' unless defined(&__BIG_ENDIAN_BITFIELD);
    }
    if(defined(&__LITTLE_ENDIAN)) {
	eval 'sub __le16_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u16)( &__le16)($x)));
	}' unless defined(&__le16_to_cpu);
	eval 'sub __le32_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u32)( &__le32)($x)));
	}' unless defined(&__le32_to_cpu);
	eval 'sub __le64_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u64)( &__le64)($x)));
	}' unless defined(&__le64_to_cpu);
	eval 'sub __cpu_to_le16 {
	    my($x) = @_;
    	    eval q((( &__force  &__le16)( &__u16)($x)));
	}' unless defined(&__cpu_to_le16);
	eval 'sub __cpu_to_le32 {
	    my($x) = @_;
    	    eval q((( &__force  &__le32)( &__u32)($x)));
	}' unless defined(&__cpu_to_le32);
	eval 'sub __cpu_to_le64 {
	    my($x) = @_;
    	    eval q((( &__force  &__le64)( &__u64)($x)));
	}' unless defined(&__cpu_to_le64);
	eval 'sub __be16_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab16(( &__force  &__u16)( &__be16)($x)));
	}' unless defined(&__be16_to_cpu);
	eval 'sub __be32_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab32(( &__force  &__u32)( &__be32)($x)));
	}' unless defined(&__be32_to_cpu);
	eval 'sub __be64_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab64(( &__force  &__u64)( &__be64)($x)));
	}' unless defined(&__be64_to_cpu);
	eval 'sub __cpu_to_be16 {
	    my($x) = @_;
    	    eval q((( &__force  &__be16) &__swab16($x)));
	}' unless defined(&__cpu_to_be16);
	eval 'sub __cpu_to_be32 {
	    my($x) = @_;
    	    eval q((( &__force  &__be32) &__swab32($x)));
	}' unless defined(&__cpu_to_be32);
	eval 'sub __cpu_to_be64 {
	    my($x) = @_;
    	    eval q((( &__force  &__be64) &__swab64($x)));
	}' unless defined(&__cpu_to_be64);
    }
    if(defined(&__BIG_ENDIAN)) {
	eval 'sub __be16_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u16)( &__be16)($x)));
	}' unless defined(&__be16_to_cpu);
	eval 'sub __be32_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u32)( &__be32)($x)));
	}' unless defined(&__be32_to_cpu);
	eval 'sub __be64_to_cpu {
	    my($x) = @_;
    	    eval q((( &__force  &__u64)( &__be64)($x)));
	}' unless defined(&__be64_to_cpu);
	eval 'sub __cpu_to_be16 {
	    my($x) = @_;
    	    eval q((( &__force  &__be16)( &__u16)($x)));
	}' unless defined(&__cpu_to_be16);
	eval 'sub __cpu_to_be32 {
	    my($x) = @_;
    	    eval q((( &__force  &__be32)( &__u32)($x)));
	}' unless defined(&__cpu_to_be32);
	eval 'sub __cpu_to_be64 {
	    my($x) = @_;
    	    eval q((( &__force  &__be64)( &__u64)($x)));
	}' unless defined(&__cpu_to_be64);
	eval 'sub __le16_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab16(( &__force  &__u16)( &__le16)($x)));
	}' unless defined(&__le16_to_cpu);
	eval 'sub __le32_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab32(( &__force  &__u32)( &__le32)($x)));
	}' unless defined(&__le32_to_cpu);
	eval 'sub __le64_to_cpu {
	    my($x) = @_;
    	    eval q( &__swab64(( &__force  &__u64)( &__le64)($x)));
	}' unless defined(&__le64_to_cpu);
	eval 'sub __cpu_to_le16 {
	    my($x) = @_;
    	    eval q((( &__force  &__le16) &__swab16($x)));
	}' unless defined(&__cpu_to_le16);
	eval 'sub __cpu_to_le32 {
	    my($x) = @_;
    	    eval q((( &__force  &__le32) &__swab32($x)));
	}' unless defined(&__cpu_to_le32);
	eval 'sub __cpu_to_le64 {
	    my($x) = @_;
    	    eval q((( &__force  &__le64) &__swab64($x)));
	}' unless defined(&__cpu_to_le64);
    }
    eval 'sub __constant_htonl {
        my($x) = @_;
	    eval q( &__cpu_to_be32($x));
    }' unless defined(&__constant_htonl);
    eval 'sub __constant_ntohl {
        my($x) = @_;
	    eval q( &__be32_to_cpu($x));
    }' unless defined(&__constant_ntohl);
    eval 'sub __constant_htons {
        my($x) = @_;
	    eval q( &__cpu_to_be16($x));
    }' unless defined(&__constant_htons);
    eval 'sub __constant_ntohs {
        my($x) = @_;
	    eval q( &__be16_to_cpu($x));
    }' unless defined(&__constant_ntohs);
    eval 'sub __constant_le16_to_cpu {
        my($x) = @_;
	    eval q( &__le16_to_cpu($x));
    }' unless defined(&__constant_le16_to_cpu);
    eval 'sub __constant_le32_to_cpu {
        my($x) = @_;
	    eval q( &__le32_to_cpu($x));
    }' unless defined(&__constant_le32_to_cpu);
    eval 'sub __constant_le64_to_cpu {
        my($x) = @_;
	    eval q( &__le64_to_cpu($x));
    }' unless defined(&__constant_le64_to_cpu);
    eval 'sub __constant_be16_to_cpu {
        my($x) = @_;
	    eval q( &__be16_to_cpu($x));
    }' unless defined(&__constant_be16_to_cpu);
    eval 'sub __constant_be32_to_cpu {
        my($x) = @_;
	    eval q( &__be32_to_cpu($x));
    }' unless defined(&__constant_be32_to_cpu);
    eval 'sub __constant_be64_to_cpu {
        my($x) = @_;
	    eval q( &__be64_to_cpu($x));
    }' unless defined(&__constant_be64_to_cpu);
    eval 'sub __constant_cpu_to_le16 {
        my($x) = @_;
	    eval q( &__cpu_to_le16($x));
    }' unless defined(&__constant_cpu_to_le16);
    eval 'sub __constant_cpu_to_le32 {
        my($x) = @_;
	    eval q( &__cpu_to_le32($x));
    }' unless defined(&__constant_cpu_to_le32);
    eval 'sub __constant_cpu_to_le64 {
        my($x) = @_;
	    eval q( &__cpu_to_le64($x));
    }' unless defined(&__constant_cpu_to_le64);
    eval 'sub __constant_cpu_to_be16 {
        my($x) = @_;
	    eval q( &__cpu_to_be16($x));
    }' unless defined(&__constant_cpu_to_be16);
    eval 'sub __constant_cpu_to_be32 {
        my($x) = @_;
	    eval q( &__cpu_to_be32($x));
    }' unless defined(&__constant_cpu_to_be32);
    eval 'sub __constant_cpu_to_be64 {
        my($x) = @_;
	    eval q( &__cpu_to_be64($x));
    }' unless defined(&__constant_cpu_to_be64);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le16_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le16_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le16s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le16s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le32_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le32_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le32s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le32s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le64_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le64_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le64s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le64s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be16_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be16_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be16s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be16s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be32_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be32_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be32s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be32s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be64_to_cpus {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be64_to_cpus);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be64s {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be64s);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le16_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le16_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le32_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le32_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __le64_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__le64_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le16p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le16p);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le32p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le32p);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_le64p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_le64p);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be16_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be16_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be32_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be32_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __be64_to_cpup {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__be64_to_cpup);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be16p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be16p);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be32p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be32p);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __cpu_to_be64p {
        my($p) = @_;
	    eval q({ });
    }' unless defined(&__cpu_to_be64p);
    if(defined(&__KERNEL__)) {
	eval 'sub le16_to_cpu () { &__le16_to_cpu;}' unless defined(&le16_to_cpu);
	eval 'sub le32_to_cpu () { &__le32_to_cpu;}' unless defined(&le32_to_cpu);
	eval 'sub le64_to_cpu () { &__le64_to_cpu;}' unless defined(&le64_to_cpu);
	eval 'sub be16_to_cpu () { &__be16_to_cpu;}' unless defined(&be16_to_cpu);
	eval 'sub be32_to_cpu () { &__be32_to_cpu;}' unless defined(&be32_to_cpu);
	eval 'sub be64_to_cpu () { &__be64_to_cpu;}' unless defined(&be64_to_cpu);
	eval 'sub cpu_to_le16 () { &__cpu_to_le16;}' unless defined(&cpu_to_le16);
	eval 'sub cpu_to_le32 () { &__cpu_to_le32;}' unless defined(&cpu_to_le32);
	eval 'sub cpu_to_le64 () { &__cpu_to_le64;}' unless defined(&cpu_to_le64);
	eval 'sub cpu_to_be16 () { &__cpu_to_be16;}' unless defined(&cpu_to_be16);
	eval 'sub cpu_to_be32 () { &__cpu_to_be32;}' unless defined(&cpu_to_be32);
	eval 'sub cpu_to_be64 () { &__cpu_to_be64;}' unless defined(&cpu_to_be64);
	eval 'sub le16_to_cpup () { &__le16_to_cpup;}' unless defined(&le16_to_cpup);
	eval 'sub le32_to_cpup () { &__le32_to_cpup;}' unless defined(&le32_to_cpup);
	eval 'sub le64_to_cpup () { &__le64_to_cpup;}' unless defined(&le64_to_cpup);
	eval 'sub be16_to_cpup () { &__be16_to_cpup;}' unless defined(&be16_to_cpup);
	eval 'sub be32_to_cpup () { &__be32_to_cpup;}' unless defined(&be32_to_cpup);
	eval 'sub be64_to_cpup () { &__be64_to_cpup;}' unless defined(&be64_to_cpup);
	eval 'sub cpu_to_le16p () { &__cpu_to_le16p;}' unless defined(&cpu_to_le16p);
	eval 'sub cpu_to_le32p () { &__cpu_to_le32p;}' unless defined(&cpu_to_le32p);
	eval 'sub cpu_to_le64p () { &__cpu_to_le64p;}' unless defined(&cpu_to_le64p);
	eval 'sub cpu_to_be16p () { &__cpu_to_be16p;}' unless defined(&cpu_to_be16p);
	eval 'sub cpu_to_be32p () { &__cpu_to_be32p;}' unless defined(&cpu_to_be32p);
	eval 'sub cpu_to_be64p () { &__cpu_to_be64p;}' unless defined(&cpu_to_be64p);
	eval 'sub le16_to_cpus () { &__le16_to_cpus;}' unless defined(&le16_to_cpus);
	eval 'sub le32_to_cpus () { &__le32_to_cpus;}' unless defined(&le32_to_cpus);
	eval 'sub le64_to_cpus () { &__le64_to_cpus;}' unless defined(&le64_to_cpus);
	eval 'sub be16_to_cpus () { &__be16_to_cpus;}' unless defined(&be16_to_cpus);
	eval 'sub be32_to_cpus () { &__be32_to_cpus;}' unless defined(&be32_to_cpus);
	eval 'sub be64_to_cpus () { &__be64_to_cpus;}' unless defined(&be64_to_cpus);
	eval 'sub cpu_to_le16s () { &__cpu_to_le16s;}' unless defined(&cpu_to_le16s);
	eval 'sub cpu_to_le32s () { &__cpu_to_le32s;}' unless defined(&cpu_to_le32s);
	eval 'sub cpu_to_le64s () { &__cpu_to_le64s;}' unless defined(&cpu_to_le64s);
	eval 'sub cpu_to_be16s () { &__cpu_to_be16s;}' unless defined(&cpu_to_be16s);
	eval 'sub cpu_to_be32s () { &__cpu_to_be32s;}' unless defined(&cpu_to_be32s);
	eval 'sub cpu_to_be64s () { &__cpu_to_be64s;}' unless defined(&cpu_to_be64s);
	undef(&ntohl) if defined(&ntohl);
	undef(&ntohs) if defined(&ntohs);
	undef(&htonl) if defined(&htonl);
	undef(&htons) if defined(&htons);
	eval 'sub ___htonl {
	    my($x) = @_;
    	    eval q( &__cpu_to_be32($x));
	}' unless defined(&___htonl);
	eval 'sub ___htons {
	    my($x) = @_;
    	    eval q( &__cpu_to_be16($x));
	}' unless defined(&___htons);
	eval 'sub ___ntohl {
	    my($x) = @_;
    	    eval q( &__be32_to_cpu($x));
	}' unless defined(&___ntohl);
	eval 'sub ___ntohs {
	    my($x) = @_;
    	    eval q( &__be16_to_cpu($x));
	}' unless defined(&___ntohs);
	eval 'sub htonl {
	    my($x) = @_;
    	    eval q( &___htonl($x));
	}' unless defined(&htonl);
	eval 'sub ntohl {
	    my($x) = @_;
    	    eval q( &___ntohl($x));
	}' unless defined(&ntohl);
	eval 'sub htons {
	    my($x) = @_;
    	    eval q( &___htons($x));
	}' unless defined(&htons);
	eval 'sub ntohs {
	    my($x) = @_;
    	    eval q( &___ntohs($x));
	}' unless defined(&ntohs);
	eval 'sub le16_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_le16( &le16_to_cpup($var) + $val); });
	}' unless defined(&le16_add_cpu);
	eval 'sub le32_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_le32( &le32_to_cpup($var) + $val); });
	}' unless defined(&le32_add_cpu);
	eval 'sub le64_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_le64( &le64_to_cpup($var) + $val); });
	}' unless defined(&le64_add_cpu);
	eval 'sub be16_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_be16( &be16_to_cpup($var) + $val); });
	}' unless defined(&be16_add_cpu);
	eval 'sub be32_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_be32( &be32_to_cpup($var) + $val); });
	}' unless defined(&be32_add_cpu);
	eval 'sub be64_add_cpu {
	    my($var,$val) = @_;
    	    eval q({ *$var =  &cpu_to_be64( &be64_to_cpup($var) + $val); });
	}' unless defined(&be64_add_cpu);
    }
}
1;
