require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_COMPILER_H)) {
    die("Please don't include <linux/compiler-gcc.h> directly, include <linux/compiler.h> instead.");
}
unless(defined(&barrier)) {
    sub barrier () {
	eval q(\"(assembly code)\");
    }
}
unless(defined(&RELOC_HIDE)) {
    sub RELOC_HIDE {
	my($ptr, $off) = @_;
	eval q(\"(assembly code)\");
    }
}
unless(defined(&__must_be_array)) {
    sub __must_be_array {
	my($a) = @_;
	eval q( &BUILD_BUG_ON_ZERO( &__builtin_types_compatible_p( &typeof($a),  &typeof($a->[0]))));
    }
}
if(!defined( &CONFIG_ARCH_SUPPORTS_OPTIMIZED_INLINING) || !defined( &CONFIG_OPTIMIZE_INLINING) || ((defined(&__GNUC__) ? &__GNUC__ : undef) < 4)) {
    eval 'sub inline () { &inline  &__attribute__(( &always_inline));}' unless defined(&inline);
    eval 'sub __inline__ () { &__inline__  &__attribute__(( &always_inline));}' unless defined(&__inline__);
    eval 'sub __inline () { &__inline  &__attribute__(( &always_inline));}' unless defined(&__inline);
}
unless(defined(&__deprecated)) {
    sub __deprecated () {	 &__attribute__(( &deprecated));}
}
unless(defined(&__packed)) {
    sub __packed () {	 &__attribute__(( &packed));}
}
unless(defined(&__weak)) {
    sub __weak () {	 &__attribute__(( &weak));}
}
unless(defined(&__naked)) {
    sub __naked () {	 &__attribute__(( &naked));}
}
unless(defined(&__noreturn)) {
    sub __noreturn () {	 &__attribute__(( &noreturn));}
}
unless(defined(&__pure)) {
    sub __pure () {	 &__attribute__(( &pure));}
}
unless(defined(&__aligned)) {
    sub __aligned {
	my($x) = @_;
	eval q( &__attribute__(( &aligned($x))));
    }
}
unless(defined(&__printf)) {
    sub __printf {
	my($a,$b) = @_;
	eval q( &__attribute__(( &format( &printf,$a,$b))));
    }
}
unless(defined(&noinline)) {
    sub noinline () {	 &__attribute__(( &noinline));}
}
unless(defined(&__attribute_const__)) {
    sub __attribute_const__ () {	 &__attribute__(( &__const__));}
}
unless(defined(&__maybe_unused)) {
    sub __maybe_unused () {	 &__attribute__(( &unused));}
}
1;
