require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_COMPILER_H)) {
    eval 'sub __LINUX_COMPILER_H () {1;}' unless defined(&__LINUX_COMPILER_H);
    unless(defined(&__ASSEMBLY__)) {
	if(defined(&__CHECKER__)) {
	    eval 'sub __user () { &__attribute__(( &noderef,  &address_space(1)));}' unless defined(&__user);
	    eval 'sub __kernel () {1;}' unless defined(&__kernel);
	    eval 'sub __safe () { &__attribute__(( &safe));}' unless defined(&__safe);
	    eval 'sub __force () { &__attribute__(( &force));}' unless defined(&__force);
	    eval 'sub __nocast () { &__attribute__(( &nocast));}' unless defined(&__nocast);
	    eval 'sub __iomem () { &__attribute__(( &noderef,  &address_space(2)));}' unless defined(&__iomem);
	    eval 'sub __acquires {
	        my($x) = @_;
    		eval q( &__attribute__(( &context($x,0,1))));
	    }' unless defined(&__acquires);
	    eval 'sub __releases {
	        my($x) = @_;
    		eval q( &__attribute__(( &context($x,1,0))));
	    }' unless defined(&__releases);
	    eval 'sub __acquire {
	        my($x) = @_;
    		eval q( &__context__($x,1));
	    }' unless defined(&__acquire);
	    eval 'sub __release {
	        my($x) = @_;
    		eval q( &__context__($x,-1));
	    }' unless defined(&__release);
	    eval 'sub __cond_lock {
	        my($x,$c) = @_;
    		eval q((($c) ? ({  &__acquire($x); 1; }) : 0));
	    }' unless defined(&__cond_lock);
	} else {
	    eval 'sub __user () {1;}' unless defined(&__user);
	    eval 'sub __kernel () {1;}' unless defined(&__kernel);
	    eval 'sub __safe () {1;}' unless defined(&__safe);
	    eval 'sub __force () {1;}' unless defined(&__force);
	    eval 'sub __nocast () {1;}' unless defined(&__nocast);
	    eval 'sub __iomem () {1;}' unless defined(&__iomem);
	    eval 'sub __chk_user_ptr {
	        my($x) = @_;
    		eval q(( &void)0);
	    }' unless defined(&__chk_user_ptr);
	    eval 'sub __chk_io_ptr {
	        my($x) = @_;
    		eval q(( &void)0);
	    }' unless defined(&__chk_io_ptr);
	    eval 'sub __builtin_warning () {( &x,  &y...) (1);}' unless defined(&__builtin_warning);
	    eval 'sub __acquires {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&__acquires);
	    eval 'sub __releases {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&__releases);
	    eval 'sub __acquire {
	        my($x) = @_;
    		eval q(( &void)0);
	    }' unless defined(&__acquire);
	    eval 'sub __release {
	        my($x) = @_;
    		eval q(( &void)0);
	    }' unless defined(&__release);
	    eval 'sub __cond_lock {
	        my($x,$c) = @_;
    		eval q(($c));
	    }' unless defined(&__cond_lock);
	}
	if(defined(&__KERNEL__)) {
	    if((defined(&__GNUC__) ? &__GNUC__ : undef) >= 4) {
		require 'linux/compiler-gcc4.ph';
	    }
 elsif((defined(&__GNUC__) ? &__GNUC__ : undef) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) >= 2) {
		require 'linux/compiler-gcc3.ph';
	    } else {
		die("Sorry\,\ your\ compiler\ is\ too\ old\/not\ recognized\.");
	    }
	    if(defined(&__INTEL_COMPILER)) {
		require 'linux/compiler-intel.ph';
	    }
	    eval 'sub likely {
	        my($x) = @_;
    		eval q( &__builtin_expect(!!($x), 1));
	    }' unless defined(&likely);
	    eval 'sub unlikely {
	        my($x) = @_;
    		eval q( &__builtin_expect(!!($x), 0));
	    }' unless defined(&unlikely);
	    unless(defined(&barrier)) {
		eval 'sub barrier () {
		    eval q( &__memory_barrier());
		}' unless defined(&barrier);
	    }
	    unless(defined(&RELOC_HIDE)) {
		eval 'sub RELOC_HIDE {
		    my($ptr, $off) = @_;
    		    eval q(({ \'unsigned long __ptr\';  &__ptr = ($ptr); ( &typeof($ptr)) ( &__ptr + ($off)); }));
		}' unless defined(&RELOC_HIDE);
	    }
	}
    }
    if(defined(&__KERNEL__)) {
	unless(defined(&__deprecated)) {
	    eval 'sub __deprecated () {1;}' unless defined(&__deprecated);
	}
	if(defined(&MODULE)) {
	    eval 'sub __deprecated_for_modules () { &__deprecated;}' unless defined(&__deprecated_for_modules);
	} else {
	    eval 'sub __deprecated_for_modules () {1;}' unless defined(&__deprecated_for_modules);
	}
	unless(defined(&__must_check)) {
	    eval 'sub __must_check () {1;}' unless defined(&__must_check);
	}
	unless(defined(&CONFIG_ENABLE_MUST_CHECK)) {
	    undef(&__must_check) if defined(&__must_check);
	    eval 'sub __must_check () {1;}' unless defined(&__must_check);
	}
	unless(defined(&CONFIG_ENABLE_WARN_DEPRECATED)) {
	    undef(&__deprecated) if defined(&__deprecated);
	    undef(&__deprecated_for_modules) if defined(&__deprecated_for_modules);
	    eval 'sub __deprecated () {1;}' unless defined(&__deprecated);
	    eval 'sub __deprecated_for_modules () {1;}' unless defined(&__deprecated_for_modules);
	}
	unless(defined(&__used)) {
	    eval 'sub __used () {1;}' unless defined(&__used);
	}
	unless(defined(&__maybe_unused)) {
	    eval 'sub __maybe_unused () {1;}' unless defined(&__maybe_unused);
	}
	unless(defined(&noinline)) {
	    eval 'sub noinline () {1;}' unless defined(&noinline);
	}
	eval 'sub noinline_for_stack () { &noinline;}' unless defined(&noinline_for_stack);
	unless(defined(&__always_inline)) {
	    eval 'sub __always_inline () { &inline;}' unless defined(&__always_inline);
	}
    }
    unless(defined(&__attribute_const__)) {
	eval 'sub __attribute_const__ () {1;}' unless defined(&__attribute_const__);
    }
    unless(defined(&__cold)) {
	eval 'sub __cold () {1;}' unless defined(&__cold);
    }
    unless(defined(&__section)) {
	eval 'sub __section {
	    my($S) = @_;
    	    eval q( &__attribute__ (( &__section__($S))));
	}' unless defined(&__section);
    }
    eval 'sub ACCESS_ONCE {
        my($x) = @_;
	    eval q((*( &volatile  &typeof($x) *)($x)));
    }' unless defined(&ACCESS_ONCE);
}
1;
