require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_CPUSET_H)) {
    eval 'sub _LINUX_CPUSET_H () {1;}' unless defined(&_LINUX_CPUSET_H);
    require 'linux/sched.ph';
    require 'linux/cpumask.ph';
    require 'linux/nodemask.ph';
    require 'linux/cgroup.ph';
    if(defined(&CONFIG_CPUSETS)) {
	eval 'sub cpuset_current_mems_allowed () {( ($current->{mems_allowed}));}' unless defined(&cpuset_current_mems_allowed);
	eval 'sub cpuset_memory_pressure_bump () {
	    eval q( &do {  &if ( &cpuset_memory_pressure_enabled)  &__cpuset_memory_pressure_bump(); }  &while (0));
	}' unless defined(&cpuset_memory_pressure_bump);
	eval 'sub cpuset_do_page_mem_spread {
	    my($void) = @_;
    	    eval q({  ($current->{flags}) &  &PF_SPREAD_PAGE; });
	}' unless defined(&cpuset_do_page_mem_spread);
	eval 'sub cpuset_do_slab_mem_spread {
	    my($void) = @_;
    	    eval q({  ($current->{flags}) &  &PF_SPREAD_SLAB; });
	}' unless defined(&cpuset_do_slab_mem_spread);
    } else {
	eval 'sub cpuset_cpus_allowed {
	    my($p,$mask) = @_;
    	    eval q({ *$mask =  &cpu_possible_map; });
	}' unless defined(&cpuset_cpus_allowed);
	eval 'sub cpuset_cpus_allowed_locked {
	    my($p,$mask) = @_;
    	    eval q({ *$mask =  &cpu_possible_map; });
	}' unless defined(&cpuset_cpus_allowed_locked);
	eval 'sub cpuset_mems_allowed {
	    my($p) = @_;
    	    eval q({  &node_possible_map; });
	}' unless defined(&cpuset_mems_allowed);
	eval 'sub cpuset_current_mems_allowed () {( $node_states[ &N_HIGH_MEMORY]);}' unless defined(&cpuset_current_mems_allowed);
	eval 'sub cpuset_nodemask_valid_mems_allowed {
	    my($nodemask) = @_;
    	    eval q({ 1; });
	}' unless defined(&cpuset_nodemask_valid_mems_allowed);
	eval 'sub cpuset_zone_allowed_softwall {
	    my($z,$gfp_mask) = @_;
    	    eval q({ 1; });
	}' unless defined(&cpuset_zone_allowed_softwall);
	eval 'sub cpuset_zone_allowed_hardwall {
	    my($z,$gfp_mask) = @_;
    	    eval q({ 1; });
	}' unless defined(&cpuset_zone_allowed_hardwall);
	eval 'sub cpuset_mems_allowed_intersects {
	    my($tsk1,$tsk2) = @_;
    	    eval q({ 1; });
	}' unless defined(&cpuset_mems_allowed_intersects);
	eval 'sub cpuset_task_status_allowed {
	    my($m,$task) = @_;
    	    eval q({ });
	}' unless defined(&cpuset_task_status_allowed);
	eval 'sub cpuset_mem_spread_node {
	    my($void) = @_;
    	    eval q({ 0; });
	}' unless defined(&cpuset_mem_spread_node);
	eval 'sub cpuset_do_page_mem_spread {
	    my($void) = @_;
    	    eval q({ 0; });
	}' unless defined(&cpuset_do_page_mem_spread);
	eval 'sub cpuset_do_slab_mem_spread {
	    my($void) = @_;
    	    eval q({ 0; });
	}' unless defined(&cpuset_do_slab_mem_spread);
	eval 'sub current_cpuset_is_being_rebound {
	    my($void) = @_;
    	    eval q({ 0; });
	}' unless defined(&current_cpuset_is_being_rebound);
	eval 'sub rebuild_sched_domains {
	    my($void) = @_;
    	    eval q({  &partition_sched_domains(1,  &NULL,  &NULL); });
	}' unless defined(&rebuild_sched_domains);
    }
}
1;
