require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_DELAYACCT_H)) {
    eval 'sub _LINUX_DELAYACCT_H () {1;}' unless defined(&_LINUX_DELAYACCT_H);
    require 'linux/sched.ph';
    require 'linux/taskstats_kern.ph';
    eval 'sub DELAYACCT_PF_SWAPIN () {0x1;}' unless defined(&DELAYACCT_PF_SWAPIN);
    eval 'sub DELAYACCT_PF_BLKIO () {0x2;}' unless defined(&DELAYACCT_PF_BLKIO);
    if(defined(&CONFIG_TASK_DELAY_ACCT)) {
	eval 'sub delayacct_is_task_waiting_on_io {
	    my($p) = @_;
    	    eval q({  &if ( ($p->{delays})) ( ($p->{delays}->{flags}) &  &DELAYACCT_PF_BLKIO);  &else 0; });
	}' unless defined(&delayacct_is_task_waiting_on_io);
	eval 'sub delayacct_set_flag {
	    my($flag) = @_;
    	    eval q({  &if ( ($current->{delays}))  ($current->{delays}->{flags}) |= $flag; });
	}' unless defined(&delayacct_set_flag);
	eval 'sub delayacct_clear_flag {
	    my($flag) = @_;
    	    eval q({  &if ( ($current->{delays}))  ($current->{delays}->{flags}) &= ~$flag; });
	}' unless defined(&delayacct_clear_flag);
	eval 'sub delayacct_tsk_init {
	    my($tsk) = @_;
    	    eval q({  ($tsk->{delays}) =  &NULL;  &if ( &delayacct_on)  &__delayacct_tsk_init($tsk); });
	}' unless defined(&delayacct_tsk_init);
	eval 'sub delayacct_blkio_start {
	    my($void) = @_;
    	    eval q({  &delayacct_set_flag( &DELAYACCT_PF_BLKIO);  &if ( ($current->{delays}))  &__delayacct_blkio_start(); });
	}' unless defined(&delayacct_blkio_start);
	eval 'sub delayacct_blkio_end {
	    my($void) = @_;
    	    eval q({  &if ( ($current->{delays}))  &__delayacct_blkio_end();  &delayacct_clear_flag( &DELAYACCT_PF_BLKIO); });
	}' unless defined(&delayacct_blkio_end);
	eval 'sub delayacct_add_tsk {
	    my($d,$tsk) = @_;
    	    eval q({  &if (! &delayacct_on || ! ($tsk->{delays})) 0;  &__delayacct_add_tsk($d, $tsk); });
	}' unless defined(&delayacct_add_tsk);
	eval 'sub delayacct_blkio_ticks {
	    my($tsk) = @_;
    	    eval q({  &if ( ($tsk->{delays}))  &__delayacct_blkio_ticks($tsk); 0; });
	}' unless defined(&delayacct_blkio_ticks);
	eval 'sub delayacct_freepages_start {
	    my($void) = @_;
    	    eval q({  &if ( ($current->{delays}))  &__delayacct_freepages_start(); });
	}' unless defined(&delayacct_freepages_start);
	eval 'sub delayacct_freepages_end {
	    my($void) = @_;
    	    eval q({  &if ( ($current->{delays}))  &__delayacct_freepages_end(); });
	}' unless defined(&delayacct_freepages_end);
    } else {
	eval 'sub delayacct_set_flag {
	    my($flag) = @_;
    	    eval q({});
	}' unless defined(&delayacct_set_flag);
	eval 'sub delayacct_clear_flag {
	    my($flag) = @_;
    	    eval q({});
	}' unless defined(&delayacct_clear_flag);
	eval 'sub delayacct_init {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&delayacct_init);
	eval 'sub delayacct_tsk_init {
	    my($tsk) = @_;
    	    eval q({});
	}' unless defined(&delayacct_tsk_init);
	eval 'sub delayacct_tsk_free {
	    my($tsk) = @_;
    	    eval q({});
	}' unless defined(&delayacct_tsk_free);
	eval 'sub delayacct_blkio_start {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&delayacct_blkio_start);
	eval 'sub delayacct_blkio_end {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&delayacct_blkio_end);
	eval 'sub delayacct_add_tsk {
	    my($d,$tsk) = @_;
    	    eval q({ 0; });
	}' unless defined(&delayacct_add_tsk);
	eval 'sub delayacct_blkio_ticks {
	    my($tsk) = @_;
    	    eval q({ 0; });
	}' unless defined(&delayacct_blkio_ticks);
	eval 'sub delayacct_is_task_waiting_on_io {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&delayacct_is_task_waiting_on_io);
	eval 'sub delayacct_freepages_start {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&delayacct_freepages_start);
	eval 'sub delayacct_freepages_end {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&delayacct_freepages_end);
    }
}
1;
