require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_DEVICE_MAPPER_H)) {
    eval 'sub _LINUX_DEVICE_MAPPER_H () {1;}' unless defined(&_LINUX_DEVICE_MAPPER_H);
    require 'linux/bio.ph';
    require 'linux/blkdev.ph';
    eval("sub STATUSTYPE_INFO () { 0; }") unless defined(&STATUSTYPE_INFO);
    eval("sub STATUSTYPE_TABLE () { 1; }") unless defined(&STATUSTYPE_TABLE);
    eval 'sub DM_ANY_MINOR () {(-1);}' unless defined(&DM_ANY_MINOR);
    eval 'sub DM_NAME () {"device-mapper";}' unless defined(&DM_NAME);
    eval 'sub DMERR () {( &f,  &arg...)  &printk( &KERN_ERR  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg);}' unless defined(&DMERR);
    eval 'sub DMERR_LIMIT () {( &f,  &arg...)  &do {  &if ( &printk_ratelimit())  &printk( &KERN_ERR  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg); }  &while (0);}' unless defined(&DMERR_LIMIT);
    eval 'sub DMWARN () {( &f,  &arg...)  &printk( &KERN_WARNING  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg);}' unless defined(&DMWARN);
    eval 'sub DMWARN_LIMIT () {( &f,  &arg...)  &do {  &if ( &printk_ratelimit())  &printk( &KERN_WARNING  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg); }  &while (0);}' unless defined(&DMWARN_LIMIT);
    eval 'sub DMINFO () {( &f,  &arg...)  &printk( &KERN_INFO  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg);}' unless defined(&DMINFO);
    eval 'sub DMINFO_LIMIT () {( &f,  &arg...)  &do {  &if ( &printk_ratelimit())  &printk( &KERN_INFO  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg); }  &while (0);}' unless defined(&DMINFO_LIMIT);
    if(defined(&CONFIG_DM_DEBUG)) {
	eval 'sub DMDEBUG () {( &f,  &arg...)  &printk( &KERN_DEBUG  &DM_NAME ": "  &DM_MSG_PREFIX " DEBUG: "  &f "\\n",   &arg);}' unless defined(&DMDEBUG);
	eval 'sub DMDEBUG_LIMIT () {( &f,  &arg...)  &do {  &if ( &printk_ratelimit())  &printk( &KERN_DEBUG  &DM_NAME ": "  &DM_MSG_PREFIX ": "  &f "\\n",   &arg); }  &while (0);}' unless defined(&DMDEBUG_LIMIT);
    } else {
	eval 'sub DMDEBUG () {( &f,  &arg...)  &do {}  &while (0);}' unless defined(&DMDEBUG);
	eval 'sub DMDEBUG_LIMIT () {( &f,  &arg...)  &do {}  &while (0);}' unless defined(&DMDEBUG_LIMIT);
    }
    eval 'sub DMEMIT () {( &x...)  &sz += (( &sz >=  &maxlen) ? 0:  &scnprintf( &result +  &sz,  &maxlen -  &sz,  &x));}' unless defined(&DMEMIT);
    eval 'sub SECTOR_SHIFT () {9;}' unless defined(&SECTOR_SHIFT);
    eval 'sub DM_ENDIO_INCOMPLETE () {1;}' unless defined(&DM_ENDIO_INCOMPLETE);
    eval 'sub DM_ENDIO_REQUEUE () {2;}' unless defined(&DM_ENDIO_REQUEUE);
    eval 'sub DM_MAPIO_SUBMITTED () {0;}' unless defined(&DM_MAPIO_SUBMITTED);
    eval 'sub DM_MAPIO_REMAPPED () {1;}' unless defined(&DM_MAPIO_REMAPPED);
    eval 'sub DM_MAPIO_REQUEUE () { &DM_ENDIO_REQUEUE;}' unless defined(&DM_MAPIO_REQUEUE);
    eval 'sub dm_div_up {
        my($n, $sz) = @_;
	    eval q(((($n) + ($sz) - 1) / ($sz)));
    }' unless defined(&dm_div_up);
    eval 'sub dm_sector_div_up {
        my($n, $sz) = @_;
	    eval q(( {  &sector_t  &_r = (($n) + ($sz) - 1);  &sector_div( &_r, ($sz));  &_r; } ));
    }' unless defined(&dm_sector_div_up);
    eval 'sub dm_round_up {
        my($n, $sz) = @_;
	    eval q(( &dm_div_up(($n), ($sz)) * ($sz)));
    }' unless defined(&dm_round_up);
    eval 'sub to_sector {
        my($n) = @_;
	    eval q({ ($n >>  &SECTOR_SHIFT); });
    }' unless defined(&to_sector);
    eval 'sub to_bytes {
        my($n) = @_;
	    eval q({ ($n <<  &SECTOR_SHIFT); });
    }' unless defined(&to_bytes);
}
1;
