require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_DEVICE_H_)) {
    eval 'sub _DEVICE_H_ () {1;}' unless defined(&_DEVICE_H_);
    require 'linux/ioport.ph';
    require 'linux/kobject.ph';
    require 'linux/klist.ph';
    require 'linux/list.ph';
    require 'linux/lockdep.ph';
    require 'linux/compiler.ph';
    require 'linux/types.ph';
    require 'linux/module.ph';
    require 'linux/pm.ph';
    require 'linux/semaphore.ph';
    require 'asm/atomic.ph';
    require 'asm/device.ph';
    eval 'sub BUS_ID_SIZE () {20;}' unless defined(&BUS_ID_SIZE);
    eval 'sub BUS_ATTR {
        my($_name, $_mode, $_show, $_store) = @_;
	    eval q(\'struct bus_attribute\'  &bus_attr_$_name =  &__ATTR($_name, $_mode, $_show, $_store));
    }' unless defined(&BUS_ATTR);
    eval 'sub BUS_NOTIFY_ADD_DEVICE () {0x1;}' unless defined(&BUS_NOTIFY_ADD_DEVICE);
    eval 'sub BUS_NOTIFY_DEL_DEVICE () {0x2;}' unless defined(&BUS_NOTIFY_DEL_DEVICE);
    eval 'sub BUS_NOTIFY_BOUND_DRIVER () {0x3;}' unless defined(&BUS_NOTIFY_BOUND_DRIVER);
    eval 'sub BUS_NOTIFY_UNBIND_DRIVER () {0x4;}' unless defined(&BUS_NOTIFY_UNBIND_DRIVER);
    eval 'sub DRIVER_ATTR {
        my($_name, $_mode, $_show, $_store) = @_;
	    eval q(\'struct driver_attribute\'  &driver_attr_$_name =  &__ATTR($_name, $_mode, $_show, $_store));
    }' unless defined(&DRIVER_ATTR);
    eval 'sub class_register {
        my($class) = @_;
	    eval q(({  &static \'struct lock_class_key\'  &__key;  &__class_register($class, & &__key); }));
    }' unless defined(&class_register);
    eval 'sub CLASS_ATTR {
        my($_name, $_mode, $_show, $_store) = @_;
	    eval q(\'struct class_attribute\'  &class_attr_$_name =  &__ATTR($_name, $_mode, $_show, $_store));
    }' unless defined(&CLASS_ATTR);
    eval 'sub class_create {
        my($owner, $name) = @_;
	    eval q(({  &static \'struct lock_class_key\'  &__key;  &__class_create($owner, $name, & &__key); }));
    }' unless defined(&class_create);
    eval 'sub DEVICE_ATTR {
        my($_name, $_mode, $_show, $_store) = @_;
	    eval q(\'struct device_attribute\'  &dev_attr_$_name =  &__ATTR($_name, $_mode, $_show, $_store));
    }' unless defined(&DEVICE_ATTR);
    eval 'sub device_schedule_callback {
        my($dev, $func) = @_;
	    eval q( &device_schedule_callback_owner($dev, $func,  &THIS_MODULE));
    }' unless defined(&device_schedule_callback);
    if(defined(&CONFIG_DEBUG_DEVRES)) {
	eval 'sub devres_alloc {
	    my($release, $size, $gfp) = @_;
    	    eval q( &__devres_alloc($release, $size, $gfp, $release));
	}' unless defined(&devres_alloc);
    } else {
    }
    if(defined(&CONFIG_NUMA)) {
    }
    require 'linux/pm_wakeup.ph';
    eval 'sub char {
        eval q(* &dev_name( &const \'struct device\' * &dev) {  ($dev->{bus_id}); });
    }' unless defined(&char);
    if(defined(&CONFIG_NUMA)) {
	eval 'sub dev_to_node {
	    my($dev) = @_;
    	    eval q({  ($dev->{numa_node}); });
	}' unless defined(&dev_to_node);
	eval 'sub set_dev_node {
	    my($dev,$node) = @_;
    	    eval q({  ($dev->{numa_node}) = $node; });
	}' unless defined(&set_dev_node);
    } else {
	eval 'sub dev_to_node {
	    my($dev) = @_;
    	    eval q({ -1; });
	}' unless defined(&dev_to_node);
	eval 'sub set_dev_node {
	    my($dev,$node) = @_;
    	    eval q({ });
	}' unless defined(&set_dev_node);
    }
    eval 'sub void {
        eval q(* &dev_get_drvdata(\'struct device\' * &dev) {  ($dev->{driver_data}); });
    }' unless defined(&void);
    eval 'sub dev_set_drvdata {
        my($dev,$data) = @_;
	    eval q({  ($dev->{driver_data}) = $data; });
    }' unless defined(&dev_set_drvdata);
    eval 'sub device_is_registered {
        my($dev) = @_;
	    eval q({  ($dev->{kobj}->{state_in_sysfs}); });
    }' unless defined(&device_is_registered);
    eval 'sub device_create_drvdata () { &device_create;}' unless defined(&device_create_drvdata);
    eval 'sub dev_printk () {( &level,  &dev,  &format,  &arg...)  &printk( &level "%s %s: "  &format ,  &dev_driver_string( &dev) ,  &dev_name( &dev) ,   &arg);}' unless defined(&dev_printk);
    eval 'sub dev_emerg () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_EMERG ,  &dev ,  &format ,   &arg);}' unless defined(&dev_emerg);
    eval 'sub dev_alert () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_ALERT ,  &dev ,  &format ,   &arg);}' unless defined(&dev_alert);
    eval 'sub dev_crit () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_CRIT ,  &dev ,  &format ,   &arg);}' unless defined(&dev_crit);
    eval 'sub dev_err () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_ERR ,  &dev ,  &format ,   &arg);}' unless defined(&dev_err);
    eval 'sub dev_warn () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_WARNING ,  &dev ,  &format ,   &arg);}' unless defined(&dev_warn);
    eval 'sub dev_notice () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_NOTICE ,  &dev ,  &format ,   &arg);}' unless defined(&dev_notice);
    eval 'sub dev_info () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_INFO ,  &dev ,  &format ,   &arg);}' unless defined(&dev_info);
    if(defined(&DEBUG)) {
	eval 'sub dev_dbg () {( &dev,  &format,  &arg...)  &dev_printk( &KERN_DEBUG ,  &dev ,  &format ,   &arg);}' unless defined(&dev_dbg);
    } else {
	eval 'sub dev_dbg () {( &dev,  &format,  &arg...) ({  &if (0)  &dev_printk( &KERN_DEBUG,  &dev,  &format,  &arg); 0; });}' unless defined(&dev_dbg);
    }
    if(defined(&VERBOSE_DEBUG)) {
	eval 'sub dev_vdbg () { &dev_dbg;}' unless defined(&dev_vdbg);
    } else {
	eval 'sub dev_vdbg () {( &dev,  &format,  &arg...) ({  &if (0)  &dev_printk( &KERN_DEBUG,  &dev,  &format,  &arg); 0; });}' unless defined(&dev_vdbg);
    }
    eval 'sub MODULE_ALIAS_CHARDEV {
        my($major,$minor) = @_;
	    eval q( &MODULE_ALIAS(\\"char-major-\\"  &__stringify($major) \\"-\\"  &__stringify($minor)));
    }' unless defined(&MODULE_ALIAS_CHARDEV);
    eval 'sub MODULE_ALIAS_CHARDEV_MAJOR {
        my($major) = @_;
	    eval q( &MODULE_ALIAS(\\"char-major-\\"  &__stringify($major) \\"-*\\"));
    }' unless defined(&MODULE_ALIAS_CHARDEV_MAJOR);
}
1;
