require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_DMA_MAPPING_H)) {
    eval 'sub _LINUX_DMA_MAPPING_H () {1;}' unless defined(&_LINUX_DMA_MAPPING_H);
    require 'linux/device.ph';
    require 'linux/err.ph';
    eval("sub DMA_BIDIRECTIONAL () { 0; }") unless defined(&DMA_BIDIRECTIONAL);
    eval("sub DMA_TO_DEVICE () { 1; }") unless defined(&DMA_TO_DEVICE);
    eval("sub DMA_FROM_DEVICE () { 2; }") unless defined(&DMA_FROM_DEVICE);
    eval("sub DMA_NONE () { 3; }") unless defined(&DMA_NONE);
    eval 'sub DMA_BIT_MASK {
        my($n) = @_;
	    eval q(((($n) == 64) ? ~0 : ((1<<($n))-1)));
    }' unless defined(&DMA_BIT_MASK);
    eval 'sub DMA_64BIT_MASK () { &DMA_BIT_MASK(64);}' unless defined(&DMA_64BIT_MASK);
    eval 'sub DMA_48BIT_MASK () { &DMA_BIT_MASK(48);}' unless defined(&DMA_48BIT_MASK);
    eval 'sub DMA_47BIT_MASK () { &DMA_BIT_MASK(47);}' unless defined(&DMA_47BIT_MASK);
    eval 'sub DMA_40BIT_MASK () { &DMA_BIT_MASK(40);}' unless defined(&DMA_40BIT_MASK);
    eval 'sub DMA_39BIT_MASK () { &DMA_BIT_MASK(39);}' unless defined(&DMA_39BIT_MASK);
    eval 'sub DMA_35BIT_MASK () { &DMA_BIT_MASK(35);}' unless defined(&DMA_35BIT_MASK);
    eval 'sub DMA_32BIT_MASK () { &DMA_BIT_MASK(32);}' unless defined(&DMA_32BIT_MASK);
    eval 'sub DMA_31BIT_MASK () { &DMA_BIT_MASK(31);}' unless defined(&DMA_31BIT_MASK);
    eval 'sub DMA_30BIT_MASK () { &DMA_BIT_MASK(30);}' unless defined(&DMA_30BIT_MASK);
    eval 'sub DMA_29BIT_MASK () { &DMA_BIT_MASK(29);}' unless defined(&DMA_29BIT_MASK);
    eval 'sub DMA_28BIT_MASK () { &DMA_BIT_MASK(28);}' unless defined(&DMA_28BIT_MASK);
    eval 'sub DMA_24BIT_MASK () { &DMA_BIT_MASK(24);}' unless defined(&DMA_24BIT_MASK);
    eval 'sub DMA_MASK_NONE () {0x;}' unless defined(&DMA_MASK_NONE);
    eval 'sub valid_dma_direction {
        my($dma_direction) = @_;
	    eval q({ (($dma_direction ==  &DMA_BIDIRECTIONAL) || ($dma_direction ==  &DMA_TO_DEVICE) || ($dma_direction ==  &DMA_FROM_DEVICE)); });
    }' unless defined(&valid_dma_direction);
    eval 'sub is_device_dma_capable {
        my($dev) = @_;
	    eval q({  ($dev->{dma_mask}) !=  &NULL  && * ($dev->{dma_mask}) !=  &DMA_MASK_NONE; });
    }' unless defined(&is_device_dma_capable);
    if(defined(&CONFIG_HAS_DMA)) {
	require 'asm/dma-mapping.ph';
    } else {
	require 'asm-generic/dma-mapping-broken.ph';
    }
    eval 'sub dma_sync_single () { &dma_sync_single_for_cpu;}' unless defined(&dma_sync_single);
    eval 'sub dma_sync_sg () { &dma_sync_sg_for_cpu;}' unless defined(&dma_sync_sg);
    eval 'sub dma_get_max_seg_size {
        my($dev) = @_;
	    eval q({  ($dev->{dma_parms}) ?  ($dev->{dma_parms}->{max_segment_size}) : 65536; });
    }' unless defined(&dma_get_max_seg_size);
    eval 'sub dma_set_max_seg_size {
        my($dev,$size) = @_;
	    eval q({  &if ( ($dev->{dma_parms})) {  ($dev->{dma_parms}->{max_segment_size}) = $size; 0; }  &else - &EIO; });
    }' unless defined(&dma_set_max_seg_size);
    eval 'sub dma_get_seg_boundary {
        my($dev) = @_;
	    eval q({  ($dev->{dma_parms}) ?  ($dev->{dma_parms}->{segment_boundary_mask}) : 0xffffffff; });
    }' unless defined(&dma_get_seg_boundary);
    eval 'sub dma_set_seg_boundary {
        my($dev,$mask) = @_;
	    eval q({  &if ( ($dev->{dma_parms})) {  ($dev->{dma_parms}->{segment_boundary_mask}) = $mask; 0; }  &else - &EIO; });
    }' unless defined(&dma_set_seg_boundary);
    eval 'sub DMA_MEMORY_MAP () {0x1;}' unless defined(&DMA_MEMORY_MAP);
    eval 'sub DMA_MEMORY_IO () {0x2;}' unless defined(&DMA_MEMORY_IO);
    eval 'sub DMA_MEMORY_INCLUDES_CHILDREN () {0x4;}' unless defined(&DMA_MEMORY_INCLUDES_CHILDREN);
    eval 'sub DMA_MEMORY_EXCLUSIVE () {0x8;}' unless defined(&DMA_MEMORY_EXCLUSIVE);
    unless(defined(&ARCH_HAS_DMA_DECLARE_COHERENT_MEMORY)) {
	eval 'sub dma_declare_coherent_memory {
	    my($dev,$bus_addr,$device_addr,$size,$flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&dma_declare_coherent_memory);
	eval 'sub dma_release_declared_memory {
	    my($dev) = @_;
    	    eval q({ });
	}' unless defined(&dma_release_declared_memory);
	eval 'sub dma_mark_declared_memory_occupied {
	    my($dev,$device_addr,$size) = @_;
    	    eval q({  &ERR_PTR(- &EBUSY); });
	}' unless defined(&dma_mark_declared_memory_occupied);
    }
    if(defined(&ARCH_HAS_DMA_DECLARE_COHERENT_MEMORY)) {
    } else {
	eval 'sub dmam_declare_coherent_memory {
	    my($dev,$bus_addr,$device_addr,$size,$gfp) = @_;
    	    eval q({ 0; });
	}' unless defined(&dmam_declare_coherent_memory);
	eval 'sub dmam_release_declared_memory {
	    my($dev) = @_;
    	    eval q({ });
	}' unless defined(&dmam_release_declared_memory);
    }
    unless(defined(&CONFIG_HAVE_DMA_ATTRS)) {
	eval 'sub dma_map_single_attrs {
	    my($dev, $cpu_addr, $size, $dir, $attrs) = @_;
    	    eval q( &dma_map_single($dev, $cpu_addr, $size, $dir));
	}' unless defined(&dma_map_single_attrs);
	eval 'sub dma_unmap_single_attrs {
	    my($dev, $dma_addr, $size, $dir, $attrs) = @_;
    	    eval q( &dma_unmap_single($dev, $dma_addr, $size, $dir));
	}' unless defined(&dma_unmap_single_attrs);
	eval 'sub dma_map_sg_attrs {
	    my($dev, $sgl, $nents, $dir, $attrs) = @_;
    	    eval q( &dma_map_sg($dev, $sgl, $nents, $dir));
	}' unless defined(&dma_map_sg_attrs);
	eval 'sub dma_unmap_sg_attrs {
	    my($dev, $sgl, $nents, $dir, $attrs) = @_;
    	    eval q( &dma_unmap_sg($dev, $sgl, $nents, $dir));
	}' unless defined(&dma_unmap_sg_attrs);
    }
}
1;
