require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_ELEVATOR_H)) {
    eval 'sub _LINUX_ELEVATOR_H () {1;}' unless defined(&_LINUX_ELEVATOR_H);
    require 'linux/percpu.ph';
    if(defined(&CONFIG_BLOCK)) {
	eval 'sub ELV_NAME_MAX () {(16);}' unless defined(&ELV_NAME_MAX);
	eval 'sub ELEVATOR_NO_MERGE () {0;}' unless defined(&ELEVATOR_NO_MERGE);
	eval 'sub ELEVATOR_FRONT_MERGE () {1;}' unless defined(&ELEVATOR_FRONT_MERGE);
	eval 'sub ELEVATOR_BACK_MERGE () {2;}' unless defined(&ELEVATOR_BACK_MERGE);
	eval 'sub ELEVATOR_INSERT_FRONT () {1;}' unless defined(&ELEVATOR_INSERT_FRONT);
	eval 'sub ELEVATOR_INSERT_BACK () {2;}' unless defined(&ELEVATOR_INSERT_BACK);
	eval 'sub ELEVATOR_INSERT_SORT () {3;}' unless defined(&ELEVATOR_INSERT_SORT);
	eval 'sub ELEVATOR_INSERT_REQUEUE () {4;}' unless defined(&ELEVATOR_INSERT_REQUEUE);
	eval("sub ELV_MQUEUE_MAY () { 0; }") unless defined(&ELV_MQUEUE_MAY);
	eval("sub ELV_MQUEUE_NO () { 1; }") unless defined(&ELV_MQUEUE_NO);
	eval("sub ELV_MQUEUE_MUST () { 2; }") unless defined(&ELV_MQUEUE_MUST);
	eval 'sub rq_end_sector {
	    my($rq) = @_;
    	    eval q((($rq)-> &sector + ($rq)-> &nr_sectors));
	}' unless defined(&rq_end_sector);
	eval 'sub rb_entry_rq {
	    my($node) = @_;
    	    eval q( &rb_entry(($node), \'struct request\',  &rb_node));
	}' unless defined(&rb_entry_rq);
	eval 'sub rq_fifo_time {
	    my($rq) = @_;
    	    eval q(( ($rq)-> ($donelist->{next})));
	}' unless defined(&rq_fifo_time);
	eval 'sub rq_set_fifo_time {
	    my($rq,$exp) = @_;
    	    eval q((($rq)-> ($donelist->{next}) = ( &void *) ($exp)));
	}' unless defined(&rq_set_fifo_time);
	eval 'sub rq_entry_fifo {
	    my($ptr) = @_;
    	    eval q( &list_entry(($ptr), \'struct request\',  &queuelist));
	}' unless defined(&rq_entry_fifo);
	eval 'sub rq_fifo_clear {
	    my($rq) = @_;
    	    eval q( &do {  &list_del_init(($rq)-> &queuelist);  &INIT_LIST_HEAD(($rq)-> &donelist); }  &while (0));
	}' unless defined(&rq_fifo_clear);
	eval 'sub elv_ioc_count_mod {
	    my($name, $__val) = @_;
    	    eval q( &do {  &preempt_disable();  &__get_cpu_var($name) += ($__val);  &preempt_enable(); }  &while (0));
	}' unless defined(&elv_ioc_count_mod);
	eval 'sub elv_ioc_count_inc {
	    my($name) = @_;
    	    eval q( &elv_ioc_count_mod($name, 1));
	}' unless defined(&elv_ioc_count_inc);
	eval 'sub elv_ioc_count_dec {
	    my($name) = @_;
    	    eval q( &elv_ioc_count_mod($name, -1));
	}' unless defined(&elv_ioc_count_dec);
	eval 'sub elv_ioc_count_read {
	    my($name) = @_;
    	    eval q(({ \'unsigned long __val\' = 0; \'int\'  &__cpu;  &smp_wmb();  &for_each_possible_cpu( &__cpu)  &__val +=  &per_cpu($name,  &__cpu);  &__val; }));
	}' unless defined(&elv_ioc_count_read);
    }
}
1;
