require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_FTRACE_H)) {
    eval 'sub _LINUX_FTRACE_H () {1;}' unless defined(&_LINUX_FTRACE_H);
    if(defined(&CONFIG_FTRACE)) {
	require 'linux/linkage.ph';
	require 'linux/fs.ph';
    } else {
	eval 'sub register_ftrace_function {
	    my($ops) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&register_ftrace_function);
	eval 'sub unregister_ftrace_function {
	    my($ops) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&unregister_ftrace_function);
	eval 'sub clear_ftrace_function {
	    my($ops) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&clear_ftrace_function);
    }
    if(defined(&CONFIG_DYNAMIC_FTRACE)) {
	eval 'sub FTRACE_HASHBITS () {10;}' unless defined(&FTRACE_HASHBITS);
	eval 'sub FTRACE_HASHSIZE () {(1<< &FTRACE_HASHBITS);}' unless defined(&FTRACE_HASHSIZE);
	eval("sub FTRACE_FL_FREE () { (1<<0); }") unless defined(&FTRACE_FL_FREE);
	eval("sub FTRACE_FL_FAILED () { (1<<1); }") unless defined(&FTRACE_FL_FAILED);
	eval("sub FTRACE_FL_FILTER () { (1<<2); }") unless defined(&FTRACE_FL_FILTER);
	eval("sub FTRACE_FL_ENABLED () { (1<<3); }") unless defined(&FTRACE_FL_ENABLED);
	eval("sub FTRACE_FL_NOTRACE () { (1<<4); }") unless defined(&FTRACE_FL_NOTRACE);
	eval("sub FTRACE_FL_CONVERTED () { (1<<5); }") unless defined(&FTRACE_FL_CONVERTED);
	eval("sub FTRACE_FL_FROZEN () { (1<<6); }") unless defined(&FTRACE_FL_FROZEN);
    } else {
	eval 'sub skip_trace {
	    my($ip) = @_;
    	    eval q(({ 0; }));
	}' unless defined(&skip_trace);
	eval 'sub ftrace_force_update () {
	    eval q(({ 0; }));
	}' unless defined(&ftrace_force_update);
	eval 'sub ftrace_set_filter {
	    my($buf, $len, $reset) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&ftrace_set_filter);
	eval 'sub ftrace_disable_daemon () {
	    eval q( &do { }  &while (0));
	}' unless defined(&ftrace_disable_daemon);
	eval 'sub ftrace_enable_daemon () {
	    eval q( &do { }  &while (0));
	}' unless defined(&ftrace_enable_daemon);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub tracer_disable {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&tracer_disable);
    if(defined(&CONFIG_FTRACE)) {
    } else {
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __ftrace_enabled_restore {
        my($enabled) = @_;
	    eval q({ });
    }' unless defined(&__ftrace_enabled_restore);
    if(defined(&CONFIG_FRAME_POINTER)) {
	eval 'sub CALLER_ADDR0 () {( &__builtin_return_address(0));}' unless defined(&CALLER_ADDR0);
	eval 'sub CALLER_ADDR1 () {( &__builtin_return_address(1));}' unless defined(&CALLER_ADDR1);
	eval 'sub CALLER_ADDR2 () {( &__builtin_return_address(2));}' unless defined(&CALLER_ADDR2);
	eval 'sub CALLER_ADDR3 () {( &__builtin_return_address(3));}' unless defined(&CALLER_ADDR3);
	eval 'sub CALLER_ADDR4 () {( &__builtin_return_address(4));}' unless defined(&CALLER_ADDR4);
	eval 'sub CALLER_ADDR5 () {( &__builtin_return_address(5));}' unless defined(&CALLER_ADDR5);
	eval 'sub CALLER_ADDR6 () {( &__builtin_return_address(6));}' unless defined(&CALLER_ADDR6);
    } else {
	eval 'sub CALLER_ADDR0 () {( &__builtin_return_address(0));}' unless defined(&CALLER_ADDR0);
	eval 'sub CALLER_ADDR1 () {0;}' unless defined(&CALLER_ADDR1);
	eval 'sub CALLER_ADDR2 () {0;}' unless defined(&CALLER_ADDR2);
	eval 'sub CALLER_ADDR3 () {0;}' unless defined(&CALLER_ADDR3);
	eval 'sub CALLER_ADDR4 () {0;}' unless defined(&CALLER_ADDR4);
	eval 'sub CALLER_ADDR5 () {0;}' unless defined(&CALLER_ADDR5);
	eval 'sub CALLER_ADDR6 () {0;}' unless defined(&CALLER_ADDR6);
    }
    if(defined(&CONFIG_IRQSOFF_TRACER)) {
    } else {
	eval 'sub time_hardirqs_on {
	    my($a0, $a1) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&time_hardirqs_on);
	eval 'sub time_hardirqs_off {
	    my($a0, $a1) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&time_hardirqs_off);
    }
    if(defined(&CONFIG_PREEMPT_TRACER)) {
    } else {
	eval 'sub trace_preempt_on {
	    my($a0, $a1) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&trace_preempt_on);
	eval 'sub trace_preempt_off {
	    my($a0, $a1) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&trace_preempt_off);
    }
    if(defined(&CONFIG_TRACING)) {
    } else {
	eval 'sub ftrace_special {
	    my($arg1,$arg2,$arg3) = @_;
    	    eval q({ }  &endif  &endif );
	}' unless defined(&ftrace_special);
1;
