require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_GFP_H)) {
    eval 'sub __LINUX_GFP_H () {1;}' unless defined(&__LINUX_GFP_H);
    require 'linux/mmzone.ph';
    require 'linux/stddef.ph';
    require 'linux/linkage.ph';
    eval 'sub __GFP_DMA () {(( &__force  &gfp_t)0x1);}' unless defined(&__GFP_DMA);
    eval 'sub __GFP_HIGHMEM () {(( &__force  &gfp_t)0x2);}' unless defined(&__GFP_HIGHMEM);
    eval 'sub __GFP_DMA32 () {(( &__force  &gfp_t)0x4);}' unless defined(&__GFP_DMA32);
    eval 'sub __GFP_WAIT () {(( &__force  &gfp_t)0x10);}' unless defined(&__GFP_WAIT);
    eval 'sub __GFP_HIGH () {(( &__force  &gfp_t)0x20);}' unless defined(&__GFP_HIGH);
    eval 'sub __GFP_IO () {(( &__force  &gfp_t)0x40);}' unless defined(&__GFP_IO);
    eval 'sub __GFP_FS () {(( &__force  &gfp_t)0x80);}' unless defined(&__GFP_FS);
    eval 'sub __GFP_COLD () {(( &__force  &gfp_t)0x100);}' unless defined(&__GFP_COLD);
    eval 'sub __GFP_NOWARN () {(( &__force  &gfp_t)0x200);}' unless defined(&__GFP_NOWARN);
    eval 'sub __GFP_REPEAT () {(( &__force  &gfp_t)0x400);}' unless defined(&__GFP_REPEAT);
    eval 'sub __GFP_NOFAIL () {(( &__force  &gfp_t)0x800);}' unless defined(&__GFP_NOFAIL);
    eval 'sub __GFP_NORETRY () {(( &__force  &gfp_t)0x1000);}' unless defined(&__GFP_NORETRY);
    eval 'sub __GFP_COMP () {(( &__force  &gfp_t)0x4000);}' unless defined(&__GFP_COMP);
    eval 'sub __GFP_ZERO () {(( &__force  &gfp_t)0x8000);}' unless defined(&__GFP_ZERO);
    eval 'sub __GFP_NOMEMALLOC () {(( &__force  &gfp_t)0x10000);}' unless defined(&__GFP_NOMEMALLOC);
    eval 'sub __GFP_HARDWALL () {(( &__force  &gfp_t)0x20000);}' unless defined(&__GFP_HARDWALL);
    eval 'sub __GFP_THISNODE () {(( &__force  &gfp_t)0x40000);}' unless defined(&__GFP_THISNODE);
    eval 'sub __GFP_RECLAIMABLE () {(( &__force  &gfp_t)0x80000);}' unless defined(&__GFP_RECLAIMABLE);
    eval 'sub __GFP_MOVABLE () {(( &__force  &gfp_t)0x100000);}' unless defined(&__GFP_MOVABLE);
    eval 'sub __GFP_BITS_SHIFT () {21;}' unless defined(&__GFP_BITS_SHIFT);
    eval 'sub __GFP_BITS_MASK () {(( &__force  &gfp_t)((1<<  &__GFP_BITS_SHIFT) - 1));}' unless defined(&__GFP_BITS_MASK);
    eval 'sub GFP_NOWAIT () {( &GFP_ATOMIC & ~ &__GFP_HIGH);}' unless defined(&GFP_NOWAIT);
    eval 'sub GFP_ATOMIC () {( &__GFP_HIGH);}' unless defined(&GFP_ATOMIC);
    eval 'sub GFP_NOIO () {( &__GFP_WAIT);}' unless defined(&GFP_NOIO);
    eval 'sub GFP_NOFS () {( &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_NOFS);
    eval 'sub GFP_KERNEL () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS);}' unless defined(&GFP_KERNEL);
    eval 'sub GFP_TEMPORARY () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_RECLAIMABLE);}' unless defined(&GFP_TEMPORARY);
    eval 'sub GFP_USER () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HARDWALL);}' unless defined(&GFP_USER);
    eval 'sub GFP_HIGHUSER () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HARDWALL |  &__GFP_HIGHMEM);}' unless defined(&GFP_HIGHUSER);
    eval 'sub GFP_HIGHUSER_MOVABLE () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HARDWALL |  &__GFP_HIGHMEM |  &__GFP_MOVABLE);}' unless defined(&GFP_HIGHUSER_MOVABLE);
    eval 'sub GFP_NOFS_PAGECACHE () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_MOVABLE);}' unless defined(&GFP_NOFS_PAGECACHE);
    eval 'sub GFP_USER_PAGECACHE () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HARDWALL |  &__GFP_MOVABLE);}' unless defined(&GFP_USER_PAGECACHE);
    eval 'sub GFP_HIGHUSER_PAGECACHE () {( &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HARDWALL |  &__GFP_HIGHMEM |  &__GFP_MOVABLE);}' unless defined(&GFP_HIGHUSER_PAGECACHE);
    if(defined(&CONFIG_NUMA)) {
	eval 'sub GFP_THISNODE () {( &__GFP_THISNODE |  &__GFP_NOWARN |  &__GFP_NORETRY);}' unless defined(&GFP_THISNODE);
    } else {
	eval 'sub GFP_THISNODE () {(( &__force  &gfp_t)0);}' unless defined(&GFP_THISNODE);
    }
    eval 'sub GFP_MOVABLE_MASK () {( &__GFP_RECLAIMABLE| &__GFP_MOVABLE);}' unless defined(&GFP_MOVABLE_MASK);
    eval 'sub GFP_RECLAIM_MASK () {( &__GFP_WAIT| &__GFP_HIGH| &__GFP_IO| &__GFP_FS|  &__GFP_NOWARN| &__GFP_REPEAT| &__GFP_NOFAIL|  &__GFP_NORETRY| &__GFP_NOMEMALLOC);}' unless defined(&GFP_RECLAIM_MASK);
    eval 'sub GFP_CONSTRAINT_MASK () {( &__GFP_HARDWALL| &__GFP_THISNODE);}' unless defined(&GFP_CONSTRAINT_MASK);
    eval 'sub GFP_SLAB_BUG_MASK () {( &__GFP_DMA32| &__GFP_HIGHMEM|~ &__GFP_BITS_MASK);}' unless defined(&GFP_SLAB_BUG_MASK);
    eval 'sub GFP_DMA () { &__GFP_DMA;}' unless defined(&GFP_DMA);
    eval 'sub GFP_DMA32 () { &__GFP_DMA32;}' unless defined(&GFP_DMA32);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub gfp_zone {
        my($flags) = @_;
	    eval q({  &if (($flags & ( &__GFP_HIGHMEM |  &__GFP_MOVABLE)) == ( &__GFP_HIGHMEM |  &__GFP_MOVABLE))  &ZONE_MOVABLE;  &ZONE_NORMAL; });
    }' unless defined(&gfp_zone);
    unless(defined(&HAVE_ARCH_FREE_PAGE)) {
    }
    unless(defined(&HAVE_ARCH_ALLOC_PAGE)) {
    }
    eval 'sub __alloc_pages {
        my($gfp_mask,$order,$zonelist) = @_;
	    eval q({  &__alloc_pages_internal($gfp_mask, $order, $zonelist,  &NULL); });
    }' unless defined(&__alloc_pages);
    eval 'sub __alloc_pages_nodemask {
        my($gfp_mask,$order,$zonelist,$nodemask) = @_;
	    eval q({  &__alloc_pages_internal($gfp_mask, $order, $zonelist, $nodemask); });
    }' unless defined(&__alloc_pages_nodemask);
    eval 'sub page {
        eval q(* &alloc_pages_node(\'int\'  &nid,  &gfp_t  &gfp_mask, my $order) {  &if ( &unlikely( $order >=  &MAX_ORDER))  &NULL;  &if ( &nid < 0)  &nid =  &numa_node_id();  &__alloc_pages( &gfp_mask,  $order,  &node_zonelist( &nid,  &gfp_mask)); });
    }' unless defined(&page);
    if(defined(&CONFIG_NUMA)) {
	eval 'sub alloc_pages {
	    my($gfp_mask,$order) = @_;
    	    eval q({  &if ( &unlikely($order >=  &MAX_ORDER))  &NULL;  &alloc_pages_current($gfp_mask, $order); });
	}' unless defined(&alloc_pages);
    } else {
	eval 'sub alloc_pages {
	    my($gfp_mask, $order) = @_;
    	    eval q( &alloc_pages_node( &numa_node_id(), $gfp_mask, $order));
	}' unless defined(&alloc_pages);
	eval 'sub alloc_page_vma {
	    my($gfp_mask, $vma, $addr) = @_;
    	    eval q( &alloc_pages($gfp_mask, 0));
	}' unless defined(&alloc_page_vma);
    }
    eval 'sub alloc_page {
        my($gfp_mask) = @_;
	    eval q( &alloc_pages($gfp_mask, 0));
    }' unless defined(&alloc_page);
    eval 'sub __get_free_page {
        my($gfp_mask) = @_;
	    eval q( &__get_free_pages(($gfp_mask),0));
    }' unless defined(&__get_free_page);
    eval 'sub __get_dma_pages {
        my($gfp_mask, $order) = @_;
	    eval q( &__get_free_pages(($gfp_mask) |  &GFP_DMA,($order)));
    }' unless defined(&__get_dma_pages);
    eval 'sub __free_page {
        my($page) = @_;
	    eval q( &__free_pages(($page), 0));
    }' unless defined(&__free_page);
    eval 'sub free_page {
        my($addr) = @_;
	    eval q( &free_pages(($addr),0));
    }' unless defined(&free_page);
}
1;
