require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LINUX_HARDIRQ_H)) {
    eval 'sub LINUX_HARDIRQ_H () {1;}' unless defined(&LINUX_HARDIRQ_H);
    require 'linux/preempt.ph';
    require 'linux/smp_lock.ph';
    require 'linux/lockdep.ph';
    require 'asm/hardirq.ph';
    require 'asm/system.ph';
    eval 'sub PREEMPT_BITS () {8;}' unless defined(&PREEMPT_BITS);
    eval 'sub SOFTIRQ_BITS () {8;}' unless defined(&SOFTIRQ_BITS);
    unless(defined(&HARDIRQ_BITS)) {
	eval 'sub HARDIRQ_BITS () {12;}' unless defined(&HARDIRQ_BITS);
	unless(defined(&MAX_HARDIRQS_PER_CPU)) {
	    eval 'sub MAX_HARDIRQS_PER_CPU () { &NR_IRQS;}' unless defined(&MAX_HARDIRQS_PER_CPU);
	}
	if((1<< (defined(&HARDIRQ_BITS) ? &HARDIRQ_BITS : undef)) < (defined(&MAX_HARDIRQS_PER_CPU) ? &MAX_HARDIRQS_PER_CPU : undef)) {
	    die("HARDIRQ_BITS\ is\ too\ low\!");
	}
    }
    eval 'sub PREEMPT_SHIFT () {0;}' unless defined(&PREEMPT_SHIFT);
    eval 'sub SOFTIRQ_SHIFT () {( &PREEMPT_SHIFT +  &PREEMPT_BITS);}' unless defined(&SOFTIRQ_SHIFT);
    eval 'sub HARDIRQ_SHIFT () {( &SOFTIRQ_SHIFT +  &SOFTIRQ_BITS);}' unless defined(&HARDIRQ_SHIFT);
    eval 'sub __IRQ_MASK {
        my($x) = @_;
	    eval q(((1 << ($x))-1));
    }' unless defined(&__IRQ_MASK);
    eval 'sub PREEMPT_MASK () {( &__IRQ_MASK( &PREEMPT_BITS) <<  &PREEMPT_SHIFT);}' unless defined(&PREEMPT_MASK);
    eval 'sub SOFTIRQ_MASK () {( &__IRQ_MASK( &SOFTIRQ_BITS) <<  &SOFTIRQ_SHIFT);}' unless defined(&SOFTIRQ_MASK);
    eval 'sub HARDIRQ_MASK () {( &__IRQ_MASK( &HARDIRQ_BITS) <<  &HARDIRQ_SHIFT);}' unless defined(&HARDIRQ_MASK);
    eval 'sub PREEMPT_OFFSET () {(1 <<  &PREEMPT_SHIFT);}' unless defined(&PREEMPT_OFFSET);
    eval 'sub SOFTIRQ_OFFSET () {(1 <<  &SOFTIRQ_SHIFT);}' unless defined(&SOFTIRQ_OFFSET);
    eval 'sub HARDIRQ_OFFSET () {(1 <<  &HARDIRQ_SHIFT);}' unless defined(&HARDIRQ_OFFSET);
    if((defined(&PREEMPT_ACTIVE) ? &PREEMPT_ACTIVE : undef) < (1<< ((defined(&HARDIRQ_SHIFT) ? &HARDIRQ_SHIFT : undef) + (defined(&HARDIRQ_BITS) ? &HARDIRQ_BITS : undef)))) {
	die("PREEMPT_ACTIVE\ is\ too\ low\!");
    }
    eval 'sub hardirq_count () {
        eval q(( &preempt_count() &  &HARDIRQ_MASK));
    }' unless defined(&hardirq_count);
    eval 'sub softirq_count () {
        eval q(( &preempt_count() &  &SOFTIRQ_MASK));
    }' unless defined(&softirq_count);
    eval 'sub irq_count () {
        eval q(( &preempt_count() & ( &HARDIRQ_MASK |  &SOFTIRQ_MASK)));
    }' unless defined(&irq_count);
    eval 'sub in_irq () {
        eval q(( &hardirq_count()));
    }' unless defined(&in_irq);
    eval 'sub in_softirq () {
        eval q(( &softirq_count()));
    }' unless defined(&in_softirq);
    eval 'sub in_interrupt () {
        eval q(( &irq_count()));
    }' unless defined(&in_interrupt);
    if(defined( &CONFIG_PREEMPT)) {
	eval 'sub PREEMPT_INATOMIC_BASE () { &kernel_locked();}' unless defined(&PREEMPT_INATOMIC_BASE);
	eval 'sub PREEMPT_CHECK_OFFSET () {1;}' unless defined(&PREEMPT_CHECK_OFFSET);
    } else {
	eval 'sub PREEMPT_INATOMIC_BASE () {0;}' unless defined(&PREEMPT_INATOMIC_BASE);
	eval 'sub PREEMPT_CHECK_OFFSET () {0;}' unless defined(&PREEMPT_CHECK_OFFSET);
    }
    eval 'sub in_atomic () {
        eval q((( &preempt_count() & ~ &PREEMPT_ACTIVE) !=  &PREEMPT_INATOMIC_BASE));
    }' unless defined(&in_atomic);
    eval 'sub in_atomic_preempt_off () {
        eval q((( &preempt_count() & ~ &PREEMPT_ACTIVE) !=  &PREEMPT_CHECK_OFFSET));
    }' unless defined(&in_atomic_preempt_off);
    if(defined(&CONFIG_PREEMPT)) {
	eval 'sub preemptible () {
	    eval q(( &preempt_count() == 0 && ! &irqs_disabled()));
	}' unless defined(&preemptible);
	eval 'sub IRQ_EXIT_OFFSET () {( &HARDIRQ_OFFSET-1);}' unless defined(&IRQ_EXIT_OFFSET);
    } else {
	eval 'sub preemptible () {
	    eval q(0);
	}' unless defined(&preemptible);
	eval 'sub IRQ_EXIT_OFFSET () { &HARDIRQ_OFFSET;}' unless defined(&IRQ_EXIT_OFFSET);
    }
    if(defined(&CONFIG_SMP)) {
    } else {
	eval 'sub synchronize_irq {
	    my($irq) = @_;
    	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    }
    unless(defined(&CONFIG_VIRT_CPU_ACCOUNTING)) {
	eval 'sub account_system_vtime {
	    my($tsk) = @_;
    	    eval q({ });
	}' unless defined(&account_system_vtime);
    }
    if(defined( &CONFIG_PREEMPT_RCU)  && defined( &CONFIG_NO_HZ)) {
    } else {
	eval 'sub rcu_irq_enter () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_irq_enter);
	eval 'sub rcu_irq_exit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_irq_exit);
    }
    eval 'sub __irq_enter () {
        eval q( &do {  &rcu_irq_enter();  &account_system_vtime( &current);  &add_preempt_count( &HARDIRQ_OFFSET);  &trace_hardirq_enter(); }  &while (0));
    }' unless defined(&__irq_enter);
    eval 'sub __irq_exit () {
        eval q( &do {  &trace_hardirq_exit();  &account_system_vtime( &current);  &sub_preempt_count( &HARDIRQ_OFFSET);  &rcu_irq_exit(); }  &while (0));
    }' unless defined(&__irq_exit);
    eval 'sub nmi_enter () {
        eval q( &do {  &lockdep_off();  &__irq_enter(); }  &while (0));
    }' unless defined(&nmi_enter);
    eval 'sub nmi_exit () {
        eval q( &do {  &__irq_exit();  &lockdep_on(); }  &while (0));
    }' unless defined(&nmi_exit);
}
1;
