require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HASH_H)) {
    eval 'sub _LINUX_HASH_H () {1;}' unless defined(&_LINUX_HASH_H);
    require 'asm/types.ph';
    eval 'sub GOLDEN_RATIO_PRIME_32 () {0x9e370001;}' unless defined(&GOLDEN_RATIO_PRIME_32);
    eval 'sub GOLDEN_RATIO_PRIME_64 () {1.14008624566881e+19;}' unless defined(&GOLDEN_RATIO_PRIME_64);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 32) {
	eval 'sub GOLDEN_RATIO_PRIME () { &GOLDEN_RATIO_PRIME_32;}' unless defined(&GOLDEN_RATIO_PRIME);
	eval 'sub hash_long {
	    my($val, $bits) = @_;
    	    eval q( &hash_32($val, $bits));
	}' unless defined(&hash_long);
    }
 elsif((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 64) {
	eval 'sub hash_long {
	    my($val, $bits) = @_;
    	    eval q( &hash_64($val, $bits));
	}' unless defined(&hash_long);
	eval 'sub GOLDEN_RATIO_PRIME () { &GOLDEN_RATIO_PRIME_64;}' unless defined(&GOLDEN_RATIO_PRIME);
    } else {
	die("Wordsize\ not\ 32\ or\ 64");
    }
    eval 'sub hash_64 {
        my($val,$bits) = @_;
	    eval q({  &u64  &hash = $val;  &u64  &n =  &hash;  &n <<= 18;  &hash -=  &n;  &n <<= 33;  &hash -=  &n;  &n <<= 3;  &hash +=  &n;  &n <<= 3;  &hash -=  &n;  &n <<= 4;  &hash +=  &n;  &n <<= 2;  &hash +=  &n;  &hash >> (64- $bits); });
    }' unless defined(&hash_64);
    eval 'sub hash_32 {
        my($val,$bits) = @_;
	    eval q({  &u32  &hash = $val *  &GOLDEN_RATIO_PRIME_32;  &hash >> (32- $bits); });
    }' unless defined(&hash_32);
    eval 'sub hash_ptr {
        my($ptr,$bits) = @_;
	    eval q({  &hash_long($ptr, $bits); });
    }' unless defined(&hash_ptr);
}
1;
