require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HIGHMEM_H)) {
    eval 'sub _LINUX_HIGHMEM_H () {1;}' unless defined(&_LINUX_HIGHMEM_H);
    require 'linux/fs.ph';
    require 'linux/mm.ph';
    require 'linux/uaccess.ph';
    require 'asm/cacheflush.ph';
    unless(defined(&ARCH_HAS_FLUSH_ANON_PAGE)) {
	eval 'sub flush_anon_page {
	    my($vma,$page,$vmaddr) = @_;
    	    eval q({ });
	}' unless defined(&flush_anon_page);
    }
    unless(defined(&ARCH_HAS_FLUSH_KERNEL_DCACHE_PAGE)) {
	eval 'sub flush_kernel_dcache_page {
	    my($page) = @_;
    	    eval q({ });
	}' unless defined(&flush_kernel_dcache_page);
    }
    if(defined(&CONFIG_HIGHMEM)) {
	require 'asm/highmem.ph';
    } else {
	eval 'sub kunmap {
	    my($page) = @_;
    	    eval q( &do { ( &void) ($page); }  &while (0));
	}' unless defined(&kunmap);
	require 'asm/kmap_types.ph';
	eval 'sub void {
	    eval q(* &kmap_atomic(\'struct page\' * &page,  &enum  &km_type  &idx) {  &pagefault_disable();  &page_address( &page); });
	}' unless defined(&void);
	eval 'sub kmap_atomic_prot {
	    my($page, $idx, $prot) = @_;
    	    eval q( &kmap_atomic($page, $idx));
	}' unless defined(&kmap_atomic_prot);
	eval 'sub kunmap_atomic {
	    my($addr, $idx) = @_;
    	    eval q( &do {  &pagefault_enable(); }  &while (0));
	}' unless defined(&kunmap_atomic);
	eval 'sub kmap_atomic_pfn {
	    my($pfn, $idx) = @_;
    	    eval q( &kmap_atomic( &pfn_to_page($pfn), ($idx)));
	}' unless defined(&kmap_atomic_pfn);
	eval 'sub kmap_atomic_to_page {
	    my($ptr) = @_;
    	    eval q( &virt_to_page($ptr));
	}' unless defined(&kmap_atomic_to_page);
	eval 'sub kmap_flush_unused () {
	    eval q( &do {}  &while(0));
	}' unless defined(&kmap_flush_unused);
    }
}
unless(defined(&__HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE)) {
}
unless(defined(&clear_highpage)) {
    sub clear_highpage {
	my($page) = @_;
	eval q({  &void * &kaddr =  &kmap_atomic($page,  &KM_USER0);  &clear_page( &kaddr);  &kunmap_atomic( &kaddr,  &KM_USER0); });
    }
}
unless(defined(&zero_user_segments)) {
    sub zero_user_segments {
	my($page,$start1,$end1,$start2,$end2) = @_;
	eval q({  &void * &kaddr =  &kmap_atomic($page,  &KM_USER0);  &BUG_ON($end1 >  &PAGE_SIZE || $end2 >  &PAGE_SIZE);  &if ($end1 > $start1)  &memset( &kaddr + $start1, 0, $end1 - $start1);  &if ($end2 > $start2)  &memset( &kaddr + $start2, 0, $end2 - $start2);  &kunmap_atomic( &kaddr,  &KM_USER0);  &flush_dcache_page($page); });
    }
}
unless(defined(&zero_user_segment)) {
    sub zero_user_segment {
	my($page,$start,$end) = @_;
	eval q({  &zero_user_segments($page, $start, $end, 0, 0); });
    }
}
unless(defined(&zero_user)) {
    sub zero_user {
	my($page,$start,$size) = @_;
	eval q({  &zero_user_segments($page, $start, $start + $size, 0, 0); });
    }
}
unless(defined(&memclear_highpage_flush)) {
    sub memclear_highpage_flush {
	my($page,$offset,$size) = @_;
	eval q({  &zero_user($page, $offset, $size); });
    }
}
unless(defined(&__HAVE_ARCH_COPY_USER_HIGHPAGE)) {
    eval 'sub copy_user_highpage {
        my($to,$from,$vaddr,$vma) = @_;
	    eval q({ \'char\' * &vfrom, * &vto;  &vfrom =  &kmap_atomic($from,  &KM_USER0);  &vto =  &kmap_atomic($to,  &KM_USER1);  &copy_user_page( &vto,  &vfrom, $vaddr, $to);  &kunmap_atomic( &vfrom,  &KM_USER0);  &kunmap_atomic( &vto,  &KM_USER1); });
    }' unless defined(&copy_user_highpage);
}
unless(defined(&copy_highpage)) {
    sub copy_highpage {
	my($to,$from) = @_;
	eval q({ 'char' * &vfrom, * &vto;  &vfrom =  &kmap_atomic($from,  &KM_USER0);  &vto =  &kmap_atomic($to,  &KM_USER1);  &copy_page( &vto,  &vfrom);  &kunmap_atomic( &vfrom,  &KM_USER0);  &kunmap_atomic( &vto,  &KM_USER1); });
    }
}
    }
1;
