require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HRTIMER_H)) {
    eval 'sub _LINUX_HRTIMER_H () {1;}' unless defined(&_LINUX_HRTIMER_H);
    require 'linux/rbtree.ph';
    require 'linux/ktime.ph';
    require 'linux/init.ph';
    require 'linux/list.ph';
    require 'linux/wait.ph';
    eval("sub HRTIMER_MODE_ABS () { 0; }") unless defined(&HRTIMER_MODE_ABS);
    eval("sub HRTIMER_MODE_REL () { 1; }") unless defined(&HRTIMER_MODE_REL);
    eval("sub HRTIMER_NORESTART () { 0; }") unless defined(&HRTIMER_NORESTART);
    eval("sub HRTIMER_RESTART () { 1; }") unless defined(&HRTIMER_RESTART);
    eval("sub HRTIMER_CB_SOFTIRQ () { 0; }") unless defined(&HRTIMER_CB_SOFTIRQ);
    eval("sub HRTIMER_CB_IRQSAFE () { 1; }") unless defined(&HRTIMER_CB_IRQSAFE);
    eval("sub HRTIMER_CB_IRQSAFE_NO_RESTART () { 2; }") unless defined(&HRTIMER_CB_IRQSAFE_NO_RESTART);
    eval("sub HRTIMER_CB_IRQSAFE_PERCPU () { 3; }") unless defined(&HRTIMER_CB_IRQSAFE_PERCPU);
    eval("sub HRTIMER_CB_IRQSAFE_UNLOCKED () { 4; }") unless defined(&HRTIMER_CB_IRQSAFE_UNLOCKED);
    eval 'sub HRTIMER_STATE_INACTIVE () {0x;}' unless defined(&HRTIMER_STATE_INACTIVE);
    eval 'sub HRTIMER_STATE_ENQUEUED () {0x1;}' unless defined(&HRTIMER_STATE_ENQUEUED);
    eval 'sub HRTIMER_STATE_CALLBACK () {0x2;}' unless defined(&HRTIMER_STATE_CALLBACK);
    eval 'sub HRTIMER_STATE_PENDING () {0x4;}' unless defined(&HRTIMER_STATE_PENDING);
    eval 'sub HRTIMER_STATE_MIGRATE () {0x8;}' unless defined(&HRTIMER_STATE_MIGRATE);
    if(defined(&CONFIG_TIMER_STATS)) {
    }
    if(defined(&CONFIG_HIGH_RES_TIMERS)) {
    }
    eval 'sub HRTIMER_MAX_CLOCK_BASES () {2;}' unless defined(&HRTIMER_MAX_CLOCK_BASES);
    if(defined(&CONFIG_HIGH_RES_TIMERS)) {
    }
    if(defined(&CONFIG_HIGH_RES_TIMERS)) {
	eval 'sub hrtimer_is_hres_active {
	    my($timer) = @_;
    	    eval q({  ($timer->{base}->{cpu_base}->{hres_active}); });
	}' unless defined(&hrtimer_is_hres_active);
	eval 'sub HIGH_RES_NSEC () {1;}' unless defined(&HIGH_RES_NSEC);
	eval 'sub KTIME_HIGH_RES () {( &ktime_t) { . &tv64 =  &HIGH_RES_NSEC };}' unless defined(&KTIME_HIGH_RES);
	eval 'sub MONOTONIC_RES_NSEC () { &HIGH_RES_NSEC;}' unless defined(&MONOTONIC_RES_NSEC);
	eval 'sub KTIME_MONOTONIC_RES () { &KTIME_HIGH_RES;}' unless defined(&KTIME_MONOTONIC_RES);
    } else {
	eval 'sub MONOTONIC_RES_NSEC () { &LOW_RES_NSEC;}' unless defined(&MONOTONIC_RES_NSEC);
	eval 'sub KTIME_MONOTONIC_RES () { &KTIME_LOW_RES;}' unless defined(&KTIME_MONOTONIC_RES);
	eval 'sub hrtimer_is_hres_active {
	    my($timer) = @_;
    	    eval q({ 0; });
	}' unless defined(&hrtimer_is_hres_active);
    }
    if(defined(&CONFIG_DEBUG_OBJECTS_TIMERS)) {
    } else {
	eval 'sub hrtimer_init_on_stack {
	    my($timer,$which_clock,$mode) = @_;
    	    eval q({  &hrtimer_init($timer, $which_clock, $mode); });
	}' unless defined(&hrtimer_init_on_stack);
    }
    eval 'sub hrtimer_restart {
        my($timer) = @_;
	    eval q({  &hrtimer_start($timer,  ($timer->{expires}),  &HRTIMER_MODE_ABS); });
    }' unless defined(&hrtimer_restart);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) < 64) {
    } else {
	eval 'sub ktime_divns {
	    my($kt, $div) = @_;
    	    eval q(( &u64)(($kt). &tv64 / ($div)));
	}' unless defined(&ktime_divns);
    }
    if(defined(&CONFIG_TIMER_STATS)) {
	eval 'sub timer_stats_account_hrtimer {
	    my($timer) = @_;
    	    eval q({  &timer_stats_update_stats($timer,  ($timer->{start_pid}),  ($timer->{start_site}),  ($timer->{function}),  ($timer->{start_comm}), 0); });
	}' unless defined(&timer_stats_account_hrtimer);
	eval 'sub timer_stats_hrtimer_set_start_info {
	    my($timer) = @_;
    	    eval q({  &__timer_stats_hrtimer_set_start_info($timer,  &__builtin_return_address(0)); });
	}' unless defined(&timer_stats_hrtimer_set_start_info);
	eval 'sub timer_stats_hrtimer_clear_start_info {
	    my($timer) = @_;
    	    eval q({  ($timer->{start_site}) =  &NULL; });
	}' unless defined(&timer_stats_hrtimer_clear_start_info);
    } else {
	eval 'sub timer_stats_account_hrtimer {
	    my($timer) = @_;
    	    eval q({ });
	}' unless defined(&timer_stats_account_hrtimer);
	eval 'sub timer_stats_hrtimer_set_start_info {
	    my($timer) = @_;
    	    eval q({ });
	}' unless defined(&timer_stats_hrtimer_set_start_info);
	eval 'sub timer_stats_hrtimer_clear_start_info {
	    my($timer) = @_;
    	    eval q({ });
	}' unless defined(&timer_stats_hrtimer_clear_start_info);
    }
}
1;
