require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HUGETLB_H)) {
    eval 'sub _LINUX_HUGETLB_H () {1;}' unless defined(&_LINUX_HUGETLB_H);
    require 'linux/fs.ph';
    if(defined(&CONFIG_HUGETLB_PAGE)) {
	require 'linux/mempolicy.ph';
	require 'linux/shm.ph';
	require 'asm/tlbflush.ph';
	eval 'sub is_vm_hugetlb_page {
	    my($vma) = @_;
    	    eval q({  ($vma->{vm_flags}) &  &VM_HUGETLB; });
	}' unless defined(&is_vm_hugetlb_page);
    } else {
	eval 'sub is_vm_hugetlb_page {
	    my($vma) = @_;
    	    eval q({ 0; });
	}' unless defined(&is_vm_hugetlb_page);
	eval 'sub reset_vma_resv_huge_pages {
	    my($vma) = @_;
    	    eval q({ });
	}' unless defined(&reset_vma_resv_huge_pages);
	eval 'sub hugetlb_total_pages {
	    my($void) = @_;
    	    eval q({ 0; });
	}' unless defined(&hugetlb_total_pages);
	eval 'sub follow_hugetlb_page {
	    my($m,$v,$p,$vs,$a,$b,$i,$w) = @_;
    	    eval q(({  &BUG(); 0; }));
	}' unless defined(&follow_hugetlb_page);
	eval 'sub follow_huge_addr {
	    my($mm, $addr, $write) = @_;
    	    eval q( &ERR_PTR(- &EINVAL));
	}' unless defined(&follow_huge_addr);
	eval 'sub copy_hugetlb_page_range {
	    my($src, $dst, $vma) = @_;
    	    eval q(({  &BUG(); 0; }));
	}' unless defined(&copy_hugetlb_page_range);
	eval 'sub hugetlb_prefault {
	    my($mapping, $vma) = @_;
    	    eval q(({  &BUG(); 0; }));
	}' unless defined(&hugetlb_prefault);
	eval 'sub unmap_hugepage_range {
	    my($vma, $start, $end, $page) = @_;
    	    eval q( &BUG());
	}' unless defined(&unmap_hugepage_range);
	eval 'sub hugetlb_report_meminfo {
	    my($buf) = @_;
    	    eval q(0);
	}' unless defined(&hugetlb_report_meminfo);
	eval 'sub hugetlb_report_node_meminfo {
	    my($n, $buf) = @_;
    	    eval q(0);
	}' unless defined(&hugetlb_report_node_meminfo);
	eval 'sub follow_huge_pmd {
	    my($mm, $addr, $pmd, $write) = @_;
    	    eval q( &NULL);
	}' unless defined(&follow_huge_pmd);
	eval 'sub follow_huge_pud {
	    my($mm, $addr, $pud, $write) = @_;
    	    eval q( &NULL);
	}' unless defined(&follow_huge_pud);
	eval 'sub prepare_hugepage_range {
	    my($file, $addr, $len) = @_;
    	    eval q((- &EINVAL));
	}' unless defined(&prepare_hugepage_range);
	eval 'sub pmd_huge {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&pmd_huge);
	eval 'sub pud_huge {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&pud_huge);
	eval 'sub is_hugepage_only_range {
	    my($mm, $addr, $len) = @_;
    	    eval q(0);
	}' unless defined(&is_hugepage_only_range);
	eval 'sub hugetlb_free_pgd_range {
	    my($tlb, $addr, $end, $floor, $ceiling) = @_;
    	    eval q(({ &BUG(); 0; }));
	}' unless defined(&hugetlb_free_pgd_range);
	eval 'sub hugetlb_fault {
	    my($mm, $vma, $addr, $write) = @_;
    	    eval q(({  &BUG(); 0; }));
	}' unless defined(&hugetlb_fault);
	eval 'sub hugetlb_change_protection {
	    my($vma, $address, $end, $newprot) = @_;
    	    eval q();
	}' unless defined(&hugetlb_change_protection);
	unless(defined(&HPAGE_MASK)) {
	    eval 'sub HPAGE_MASK () { &PAGE_MASK;}' unless defined(&HPAGE_MASK);
	    eval 'sub HPAGE_SIZE () { &PAGE_SIZE;}' unless defined(&HPAGE_SIZE);
	}
    }
    if(defined(&CONFIG_HUGETLBFS)) {
	eval 'sub hugetlbfs_inode_info {
	    eval q(* &HUGETLBFS_I(\'struct inode\' * &inode) {  &container_of( &inode, \'struct hugetlbfs_inode_info\',  &vfs_inode); });
	}' unless defined(&hugetlbfs_inode_info);
	eval 'sub hugetlbfs_sb_info {
	    eval q(* &HUGETLBFS_SB(\'struct super_block\' * &sb) {  ($sb->{s_fs_info}); });
	}' unless defined(&hugetlbfs_sb_info);
	eval 'sub is_file_hugepages {
	    my($file) = @_;
    	    eval q({  &if ( ($file->{f_op}) ==  &hugetlbfs_file_operations) 1;  &if ( &is_file_shm_hugepages($file)) 1; 0; });
	}' unless defined(&is_file_hugepages);
	eval 'sub set_file_hugepages {
	    my($file) = @_;
    	    eval q({  ($file->{f_op}) =  &hugetlbfs_file_operations; });
	}' unless defined(&set_file_hugepages);
    } else {
	eval 'sub is_file_hugepages {
	    my($file) = @_;
    	    eval q(0);
	}' unless defined(&is_file_hugepages);
	eval 'sub set_file_hugepages {
	    my($file) = @_;
    	    eval q( &BUG());
	}' unless defined(&set_file_hugepages);
	eval 'sub hugetlb_file_setup {
	    my($name,$size) = @_;
    	    eval q( &ERR_PTR(- &ENOSYS));
	}' unless defined(&hugetlb_file_setup);
    }
    if(defined(&HAVE_ARCH_HUGETLB_UNMAPPED_AREA)) {
    }
    if(defined(&CONFIG_HUGETLB_PAGE)) {
	eval 'sub HSTATE_NAME_LEN () {32;}' unless defined(&HSTATE_NAME_LEN);
	unless(defined(&HUGE_MAX_HSTATE)) {
	    eval 'sub HUGE_MAX_HSTATE () {1;}' unless defined(&HUGE_MAX_HSTATE);
	}
	eval 'sub default_hstate () {( $hstates[ &default_hstate_idx]);}' unless defined(&default_hstate);
	eval 'sub hstate {
	    eval q(* &hstate_inode(\'struct inode\' * &i) { \'struct hugetlbfs_sb_info\' * &hsb;  &hsb =  &HUGETLBFS_SB( ($i->{i_sb}));  ($hsb->{hstate}); });
	}' unless defined(&hstate);
	eval 'sub hstate {
	    eval q(* &hstate_file(\'struct file\' * &f) {  &hstate_inode( ($f->{f_dentry}->{d_inode})); });
	}' unless defined(&hstate);
	eval 'sub hstate {
	    eval q(* &hstate_vma(\'struct vm_area_struct\' * &vma) {  &hstate_file( ($vma->{vm_file})); });
	}' unless defined(&hstate);
	eval 'sub huge_page_size {
	    my($h) = @_;
    	    eval q({  &PAGE_SIZE <<  ($h->{order}); });
	}' unless defined(&huge_page_size);
	eval 'sub huge_page_mask {
	    my($h) = @_;
    	    eval q({  ($h->{mask}); });
	}' unless defined(&huge_page_mask);
	eval 'sub huge_page_order {
	    my($h) = @_;
    	    eval q({  ($h->{order}); });
	}' unless defined(&huge_page_order);
	eval 'sub huge_page_shift {
	    my($h) = @_;
    	    eval q({  ($h->{order}) +  &PAGE_SHIFT; });
	}' unless defined(&huge_page_shift);
	eval 'sub pages_per_huge_page {
	    my($h) = @_;
    	    eval q({ 1<<  ($h->{order}); });
	}' unless defined(&pages_per_huge_page);
	eval 'sub blocks_per_huge_page {
	    my($h) = @_;
    	    eval q({  &huge_page_size($h) / 512; });
	}' unless defined(&blocks_per_huge_page);
	require 'asm/hugetlb.ph';
	eval 'sub hstate {
	    eval q(* &page_hstate(\'struct page\' * &page) {  &size_to_hstate( &PAGE_SIZE <<  &compound_order( &page)); });
	}' unless defined(&hstate);
    } else {
	eval 'sub alloc_bootmem_huge_page {
	    my($h) = @_;
    	    eval q( &NULL);
	}' unless defined(&alloc_bootmem_huge_page);
	eval 'sub hstate_file {
	    my($f) = @_;
    	    eval q( &NULL);
	}' unless defined(&hstate_file);
	eval 'sub hstate_vma {
	    my($v) = @_;
    	    eval q( &NULL);
	}' unless defined(&hstate_vma);
	eval 'sub hstate_inode {
	    my($i) = @_;
    	    eval q( &NULL);
	}' unless defined(&hstate_inode);
	eval 'sub huge_page_size {
	    my($h) = @_;
    	    eval q( &PAGE_SIZE);
	}' unless defined(&huge_page_size);
	eval 'sub huge_page_mask {
	    my($h) = @_;
    	    eval q( &PAGE_MASK);
	}' unless defined(&huge_page_mask);
	eval 'sub huge_page_order {
	    my($h) = @_;
    	    eval q(0);
	}' unless defined(&huge_page_order);
	eval 'sub huge_page_shift {
	    my($h) = @_;
    	    eval q( &PAGE_SHIFT);
	}' unless defined(&huge_page_shift);
	eval 'sub pages_per_huge_page {
	    my($h) = @_;
    	    eval q({ 1; });
	}' unless defined(&pages_per_huge_page);
    }
}
1;
