require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IDE_H)) {
    eval 'sub _IDE_H () {1;}' unless defined(&_IDE_H);
    require 'linux/init.ph';
    require 'linux/ioport.ph';
    require 'linux/hdreg.ph';
    require 'linux/blkdev.ph';
    require 'linux/proc_fs.ph';
    require 'linux/interrupt.ph';
    require 'linux/bitops.ph';
    require 'linux/bio.ph';
    require 'linux/device.ph';
    require 'linux/pci.ph';
    require 'linux/completion.ph';
    if(defined(&CONFIG_BLK_DEV_IDEACPI)) {
	require 'acpi/acpi.ph';
    }
    require 'asm/byteorder.ph';
    require 'asm/system.ph';
    require 'asm/io.ph';
    require 'asm/mutex.ph';
    if(defined( &CONFIG_CRIS) || defined( &CONFIG_FRV)) {
	eval 'sub SUPPORT_VLB_SYNC () {0;}' unless defined(&SUPPORT_VLB_SYNC);
    } else {
	eval 'sub SUPPORT_VLB_SYNC () {1;}' unless defined(&SUPPORT_VLB_SYNC);
    }
    eval 'sub IDE_NO_IRQ () {(-1);}' unless defined(&IDE_NO_IRQ);
    eval 'sub ERROR_MAX () {8;}' unless defined(&ERROR_MAX);
    eval 'sub ERROR_RESET () {3;}' unless defined(&ERROR_RESET);
    eval 'sub ERROR_RECAL () {1;}' unless defined(&ERROR_RECAL);
    eval 'sub DMA_PIO_RETRY () {1;}' unless defined(&DMA_PIO_RETRY);
    eval 'sub HWIF {
        my($drive) = @_;
	    eval q((( &ide_hwif_t *)(($drive)-> &hwif)));
    }' unless defined(&HWIF);
    eval 'sub HWGROUP {
        my($drive) = @_;
	    eval q((( &ide_hwgroup_t *)( &HWIF($drive)-> &hwgroup)));
    }' unless defined(&HWGROUP);
    eval 'sub IDE_NR_PORTS () {(10);}' unless defined(&IDE_NR_PORTS);
    eval 'sub OK_STAT {
        my($stat,$good,$bad) = @_;
	    eval q(((($stat)(($good)|($bad)))==($good)));
    }' unless defined(&OK_STAT);
    eval 'sub BAD_R_STAT () {( &BUSY_STAT |  &ERR_STAT);}' unless defined(&BAD_R_STAT);
    eval 'sub BAD_W_STAT () {( &BAD_R_STAT |  &WRERR_STAT);}' unless defined(&BAD_W_STAT);
    eval 'sub BAD_STAT () {( &BAD_R_STAT |  &DRQ_STAT);}' unless defined(&BAD_STAT);
    eval 'sub DRIVE_READY () {( &READY_STAT |  &SEEK_STAT);}' unless defined(&DRIVE_READY);
    eval 'sub BAD_CRC () {( &ABRT_ERR |  &ICRC_ERR);}' unless defined(&BAD_CRC);
    eval 'sub SATA_NR_PORTS () {(3);}' unless defined(&SATA_NR_PORTS);
    eval 'sub SATA_STATUS_OFFSET () {(0);}' unless defined(&SATA_STATUS_OFFSET);
    eval 'sub SATA_ERROR_OFFSET () {(1);}' unless defined(&SATA_ERROR_OFFSET);
    eval 'sub SATA_CONTROL_OFFSET () {(2);}' unless defined(&SATA_CONTROL_OFFSET);
    eval 'sub PRD_BYTES () {8;}' unless defined(&PRD_BYTES);
    eval 'sub PRD_ENTRIES () {256;}' unless defined(&PRD_ENTRIES);
    eval 'sub PARTN_BITS () {6;}' unless defined(&PARTN_BITS);
    eval 'sub MAX_DRIVES () {2;}' unless defined(&MAX_DRIVES);
    eval 'sub SECTOR_SIZE () {512;}' unless defined(&SECTOR_SIZE);
    eval 'sub SECTOR_WORDS () {( &SECTOR_SIZE / 4);}' unless defined(&SECTOR_WORDS);
    eval 'sub IDE_LARGE_SEEK {
        my($b1,$b2,$t) = @_;
	    eval q(((($b1) > ($b2) + ($t)) || (($b2) > ($b1) + ($t))));
    }' unless defined(&IDE_LARGE_SEEK);
    eval 'sub WAIT_DRQ () {( &HZ/10);}' unless defined(&WAIT_DRQ);
    eval 'sub WAIT_READY () {(5* &HZ);}' unless defined(&WAIT_READY);
    eval 'sub WAIT_PIDENTIFY () {(10* &HZ);}' unless defined(&WAIT_PIDENTIFY);
    eval 'sub WAIT_WORSTCASE () {(30* &HZ);}' unless defined(&WAIT_WORSTCASE);
    eval 'sub WAIT_CMD () {(10* &HZ);}' unless defined(&WAIT_CMD);
    eval 'sub WAIT_MIN_SLEEP () {(2* &HZ/100);}' unless defined(&WAIT_MIN_SLEEP);
    eval 'sub REQ_DRIVE_RESET () {0x20;}' unless defined(&REQ_DRIVE_RESET);
    eval("sub ide_unknown () { 0; }") unless defined(&ide_unknown);
    eval("sub ide_generic () { 1; }") unless defined(&ide_generic);
    eval("sub ide_pci () { 2; }") unless defined(&ide_pci);
    eval("sub ide_cmd640 () { 3; }") unless defined(&ide_cmd640);
    eval("sub ide_dtc2278 () { 4; }") unless defined(&ide_dtc2278);
    eval("sub ide_ali14xx () { 5; }") unless defined(&ide_ali14xx);
    eval("sub ide_qd65xx () { 6; }") unless defined(&ide_qd65xx);
    eval("sub ide_umc8672 () { 7; }") unless defined(&ide_umc8672);
    eval("sub ide_ht6560b () { 8; }") unless defined(&ide_ht6560b);
    eval("sub ide_rz1000 () { 9; }") unless defined(&ide_rz1000);
    eval("sub ide_trm290 () { 10; }") unless defined(&ide_trm290);
    eval("sub ide_cmd646 () { 11; }") unless defined(&ide_cmd646);
    eval("sub ide_cy82c693 () { 12; }") unless defined(&ide_cy82c693);
    eval("sub ide_4drives () { 13; }") unless defined(&ide_4drives);
    eval("sub ide_pmac () { 14; }") unless defined(&ide_pmac);
    eval("sub ide_acorn () { 15; }") unless defined(&ide_acorn);
    eval("sub ide_au1xxx () { 16; }") unless defined(&ide_au1xxx);
    eval("sub ide_palm3710 () { 17; }") unless defined(&ide_palm3710);
    eval 'sub ide_std_init_ports {
        my($hw,$io_addr,$ctl_addr) = @_;
	    eval q({ my $i;  &for ( $i = 0;  $i <= 7;  $i++)  ($hw->{io_ports_array[$i]}) = $io_addr++;  ($hw->{io_ports}->{ctl_addr}) = $ctl_addr; });
    }' unless defined(&ide_std_init_ports);
    if(defined(&CONFIG_IA64)) {
    } else {
    }
    if(defined( &CONFIG_ARM) || defined( &CONFIG_FRV) || defined( &CONFIG_M68K) || defined( &CONFIG_MIPS) || defined( &CONFIG_MN10300) || defined( &CONFIG_PARISC) || defined( &CONFIG_PPC) || defined( &CONFIG_SPARC) || defined( &CONFIG_SPARC64)) {
	require 'asm/ide.ph';
    } else {
	require 'asm-generic/ide_iops.ph';
    }
    eval 'sub MAX_HWIFS () {10;}' unless defined(&MAX_HWIFS);
    unless(defined(&IDE_ARCH_ACK_INTR)) {
	eval 'sub ide_ack_intr {
	    my($hwif) = @_;
    	    eval q((1));
	}' unless defined(&ide_ack_intr);
    }
    unless(defined(&IDE_ARCH_LOCK)) {
	eval 'sub ide_release_lock () {
	    eval q( &do {}  &while (0));
	}' unless defined(&ide_release_lock);
	eval 'sub ide_get_lock {
	    my($hdlr, $data) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&ide_get_lock);
    }
    eval 'sub ide_scsi () {0x21;}' unless defined(&ide_scsi);
    eval 'sub ide_disk () {0x20;}' unless defined(&ide_disk);
    eval 'sub ide_optical () {0x7;}' unless defined(&ide_optical);
    eval 'sub ide_cdrom () {0x5;}' unless defined(&ide_cdrom);
    eval 'sub ide_tape () {0x1;}' unless defined(&ide_tape);
    eval 'sub ide_floppy () {0x;}' unless defined(&ide_floppy);
    if(defined( &__LITTLE_ENDIAN_BITFIELD)) {
    }
 elsif(defined( &__BIG_ENDIAN_BITFIELD)) {
    } else {
	die("Please fix <asm/byteorder.h>");
    }
    eval("sub ide_stopped () { 0; }") unless defined(&ide_stopped);
    eval("sub ide_started () { 1; }") unless defined(&ide_started);
    if(defined(&CONFIG_BLK_DEV_IDEACPI)) {
    }
    eval("sub IDE_AFLAG_DRQ_INTERRUPT () { (1<<0); }") unless defined(&IDE_AFLAG_DRQ_INTERRUPT);
    eval("sub IDE_AFLAG_MEDIA_CHANGED () { (1<<1); }") unless defined(&IDE_AFLAG_MEDIA_CHANGED);
    eval("sub IDE_AFLAG_NO_DOORLOCK () { (1<<2); }") unless defined(&IDE_AFLAG_NO_DOORLOCK);
    eval("sub IDE_AFLAG_NO_EJECT () { (1<<3); }") unless defined(&IDE_AFLAG_NO_EJECT);
    eval("sub IDE_AFLAG_PRE_ATAPI12 () { (1<<4); }") unless defined(&IDE_AFLAG_PRE_ATAPI12);
    eval("sub IDE_AFLAG_TOCADDR_AS_BCD () { (1<<5); }") unless defined(&IDE_AFLAG_TOCADDR_AS_BCD);
    eval("sub IDE_AFLAG_TOCTRACKS_AS_BCD () { (1<<6); }") unless defined(&IDE_AFLAG_TOCTRACKS_AS_BCD);
    eval("sub IDE_AFLAG_LIMIT_NFRAMES () { (1<<7); }") unless defined(&IDE_AFLAG_LIMIT_NFRAMES);
    eval("sub IDE_AFLAG_SEEKING () { (1<<8); }") unless defined(&IDE_AFLAG_SEEKING);
    eval("sub IDE_AFLAG_TOC_VALID () { (1<<9); }") unless defined(&IDE_AFLAG_TOC_VALID);
    eval("sub IDE_AFLAG_DOOR_LOCKED () { (1<<10); }") unless defined(&IDE_AFLAG_DOOR_LOCKED);
    eval("sub IDE_AFLAG_NO_SPEED_SELECT () { (1<<11); }") unless defined(&IDE_AFLAG_NO_SPEED_SELECT);
    eval("sub IDE_AFLAG_VERTOS_300_SSD () { (1<<12); }") unless defined(&IDE_AFLAG_VERTOS_300_SSD);
    eval("sub IDE_AFLAG_VERTOS_600_ESD () { (1<<13); }") unless defined(&IDE_AFLAG_VERTOS_600_ESD);
    eval("sub IDE_AFLAG_SANYO_3CD () { (1<<14); }") unless defined(&IDE_AFLAG_SANYO_3CD);
    eval("sub IDE_AFLAG_FULL_CAPS_PAGE () { (1<<15); }") unless defined(&IDE_AFLAG_FULL_CAPS_PAGE);
    eval("sub IDE_AFLAG_PLAY_AUDIO_OK () { (1<<16); }") unless defined(&IDE_AFLAG_PLAY_AUDIO_OK);
    eval("sub IDE_AFLAG_LE_SPEED_FIELDS () { (1<<17); }") unless defined(&IDE_AFLAG_LE_SPEED_FIELDS);
    eval("sub IDE_AFLAG_FORMAT_IN_PROGRESS () { (1<<18); }") unless defined(&IDE_AFLAG_FORMAT_IN_PROGRESS);
    eval("sub IDE_AFLAG_CLIK_DRIVE () { (1<<19); }") unless defined(&IDE_AFLAG_CLIK_DRIVE);
    eval("sub IDE_AFLAG_ZIP_DRIVE () { (1<<20); }") unless defined(&IDE_AFLAG_ZIP_DRIVE);
    eval("sub IDE_AFLAG_IGNORE_DSC () { (1<<21); }") unless defined(&IDE_AFLAG_IGNORE_DSC);
    eval("sub IDE_AFLAG_ADDRESS_VALID () { (1<<22); }") unless defined(&IDE_AFLAG_ADDRESS_VALID);
    eval("sub IDE_AFLAG_BUSY () { (1<<23); }") unless defined(&IDE_AFLAG_BUSY);
    eval("sub IDE_AFLAG_DETECT_BS () { (1<<24); }") unless defined(&IDE_AFLAG_DETECT_BS);
    eval("sub IDE_AFLAG_FILEMARK () { (1<<25); }") unless defined(&IDE_AFLAG_FILEMARK);
    eval("sub IDE_AFLAG_MEDIUM_PRESENT () { (1<<26); }") unless defined(&IDE_AFLAG_MEDIUM_PRESENT);
    eval("sub IDE_AFLAG_NO_AUTOCLOSE () { (1<<27); }") unless defined(&IDE_AFLAG_NO_AUTOCLOSE);
    if(defined(&CONFIG_IDE_PROC_FS)) {
    }
    if(defined(&CONFIG_BLK_DEV_IDEACPI)) {
    }
    eval 'sub to_ide_device {
        my($dev) = @_;
	    eval q( &container_of($dev,  &ide_drive_t,  &gendev));
    }' unless defined(&to_ide_device);
    eval 'sub IDE_CHIPSET_PCI_MASK () {((1<< &ide_pci)|(1<< &ide_cmd646)|(1<< &ide_ali14xx));}' unless defined(&IDE_CHIPSET_PCI_MASK);
    eval 'sub IDE_CHIPSET_IS_PCI {
        my($c) = @_;
	    eval q((( &IDE_CHIPSET_PCI_MASK >> ($c)) & 1));
    }' unless defined(&IDE_CHIPSET_IS_PCI);
    if(defined(&CONFIG_BLK_DEV_IDEACPI)) {
    }
    eval("sub PC_FLAG_ABORT () { (1<<0); }") unless defined(&PC_FLAG_ABORT);
    eval("sub PC_FLAG_SUPPRESS_ERROR () { (1<<1); }") unless defined(&PC_FLAG_SUPPRESS_ERROR);
    eval("sub PC_FLAG_WAIT_FOR_DSC () { (1<<2); }") unless defined(&PC_FLAG_WAIT_FOR_DSC);
    eval("sub PC_FLAG_DMA_OK () { (1<<3); }") unless defined(&PC_FLAG_DMA_OK);
    eval("sub PC_FLAG_DMA_IN_PROGRESS () { (1<<4); }") unless defined(&PC_FLAG_DMA_IN_PROGRESS);
    eval("sub PC_FLAG_DMA_ERROR () { (1<<5); }") unless defined(&PC_FLAG_DMA_ERROR);
    eval("sub PC_FLAG_WRITING () { (1<<6); }") unless defined(&PC_FLAG_WRITING);
    eval("sub PC_FLAG_TIMEDOUT () { (1<<7); }") unless defined(&PC_FLAG_TIMEDOUT);
    if(defined(&CONFIG_IDE_PROC_FS)) {
	eval 'sub TYPE_INT () {0;}' unless defined(&TYPE_INT);
	eval 'sub TYPE_BYTE () {1;}' unless defined(&TYPE_BYTE);
	eval 'sub TYPE_SHORT () {2;}' unless defined(&TYPE_SHORT);
	eval 'sub SETTING_READ () {(1<< 0);}' unless defined(&SETTING_READ);
	eval 'sub SETTING_WRITE () {(1<< 1);}' unless defined(&SETTING_WRITE);
	eval 'sub SETTING_RW () {( &SETTING_READ |  &SETTING_WRITE);}' unless defined(&SETTING_RW);
	eval 'sub PROC_IDE_READ_RETURN {
	    my($page,$start,$off,$count,$eof,$len) = @_;
    	    eval q({ $len -= $off;  &if ($len < $count) { *$eof = 1;  &if ($len <= 0)  &return 0; }  &else $len = $count; *$start = $page + $off;  &return $len; });
	}' unless defined(&PROC_IDE_READ_RETURN);
    } else {
	eval 'sub ide_add_generic_settings {
	    my($drive) = @_;
    	    eval q({ ; }  &define  &PROC_IDE_READ_RETURN( &page, &start, &off, &count, &eof, &len) 0;  &endif  &enum {  &ide_pm_state_completed = -1,  &ide_pm_state_start_suspend = 0,  &ide_pm_state_start_resume = 1000, };);
	}' unless defined(&ide_add_generic_settings);
	if(defined(&CONFIG_IDE_PROC_FS)) {
	}
	eval 'sub to_ide_driver {
	    my($drv) = @_;
    	    eval q( &container_of($drv,  &ide_driver_t,  &gen_driver));
	}' unless defined(&to_ide_driver);
	eval("sub IDE_TFLAG_LBA48 () { (1<<0); }") unless defined(&IDE_TFLAG_LBA48);
	eval("sub IDE_TFLAG_FLAGGED () { (1<<2); }") unless defined(&IDE_TFLAG_FLAGGED);
	eval("sub IDE_TFLAG_OUT_DATA () { (1<<3); }") unless defined(&IDE_TFLAG_OUT_DATA);
	eval("sub IDE_TFLAG_OUT_HOB_FEATURE () { (1<<4); }") unless defined(&IDE_TFLAG_OUT_HOB_FEATURE);
	eval("sub IDE_TFLAG_OUT_HOB_NSECT () { (1<<5); }") unless defined(&IDE_TFLAG_OUT_HOB_NSECT);
	eval("sub IDE_TFLAG_OUT_HOB_LBAL () { (1<<6); }") unless defined(&IDE_TFLAG_OUT_HOB_LBAL);
	eval("sub IDE_TFLAG_OUT_HOB_LBAM () { (1<<7); }") unless defined(&IDE_TFLAG_OUT_HOB_LBAM);
	eval("sub IDE_TFLAG_OUT_HOB_LBAH () { (1<<8); }") unless defined(&IDE_TFLAG_OUT_HOB_LBAH);
	eval("sub IDE_TFLAG_OUT_HOB () { IDE_TFLAG_OUT_HOB_FEATURE|IDE_TFLAG_OUT_HOB_NSECT|IDE_TFLAG_OUT_HOB_LBAL|IDE_TFLAG_OUT_HOB_LBAM|IDE_TFLAG_OUT_HOB_LBAH; }") unless defined(&IDE_TFLAG_OUT_HOB);
	eval("sub IDE_TFLAG_OUT_FEATURE () { (1<<9); }") unless defined(&IDE_TFLAG_OUT_FEATURE);
	eval("sub IDE_TFLAG_OUT_NSECT () { (1<<10); }") unless defined(&IDE_TFLAG_OUT_NSECT);
	eval("sub IDE_TFLAG_OUT_LBAL () { (1<<11); }") unless defined(&IDE_TFLAG_OUT_LBAL);
	eval("sub IDE_TFLAG_OUT_LBAM () { (1<<12); }") unless defined(&IDE_TFLAG_OUT_LBAM);
	eval("sub IDE_TFLAG_OUT_LBAH () { (1<<13); }") unless defined(&IDE_TFLAG_OUT_LBAH);
	eval("sub IDE_TFLAG_OUT_TF () { IDE_TFLAG_OUT_FEATURE|IDE_TFLAG_OUT_NSECT|IDE_TFLAG_OUT_LBAL|IDE_TFLAG_OUT_LBAM|IDE_TFLAG_OUT_LBAH; }") unless defined(&IDE_TFLAG_OUT_TF);
	eval("sub IDE_TFLAG_OUT_DEVICE () { (1<<14); }") unless defined(&IDE_TFLAG_OUT_DEVICE);
	eval("sub IDE_TFLAG_WRITE () { (1<<15); }") unless defined(&IDE_TFLAG_WRITE);
	eval("sub IDE_TFLAG_FLAGGED_SET_IN_FLAGS () { (1<<16); }") unless defined(&IDE_TFLAG_FLAGGED_SET_IN_FLAGS);
	eval("sub IDE_TFLAG_IN_DATA () { (1<<17); }") unless defined(&IDE_TFLAG_IN_DATA);
	eval("sub IDE_TFLAG_CUSTOM_HANDLER () { (1<<18); }") unless defined(&IDE_TFLAG_CUSTOM_HANDLER);
	eval("sub IDE_TFLAG_DMA_PIO_FALLBACK () { (1<<19); }") unless defined(&IDE_TFLAG_DMA_PIO_FALLBACK);
	eval("sub IDE_TFLAG_IN_HOB_FEATURE () { (1<<20); }") unless defined(&IDE_TFLAG_IN_HOB_FEATURE);
	eval("sub IDE_TFLAG_IN_HOB_NSECT () { (1<<21); }") unless defined(&IDE_TFLAG_IN_HOB_NSECT);
	eval("sub IDE_TFLAG_IN_HOB_LBAL () { (1<<22); }") unless defined(&IDE_TFLAG_IN_HOB_LBAL);
	eval("sub IDE_TFLAG_IN_HOB_LBAM () { (1<<23); }") unless defined(&IDE_TFLAG_IN_HOB_LBAM);
	eval("sub IDE_TFLAG_IN_HOB_LBAH () { (1<<24); }") unless defined(&IDE_TFLAG_IN_HOB_LBAH);
	eval("sub IDE_TFLAG_IN_HOB_LBA () { IDE_TFLAG_IN_HOB_LBAL|IDE_TFLAG_IN_HOB_LBAM|IDE_TFLAG_IN_HOB_LBAH; }") unless defined(&IDE_TFLAG_IN_HOB_LBA);
	eval("sub IDE_TFLAG_IN_HOB () { IDE_TFLAG_IN_HOB_FEATURE|IDE_TFLAG_IN_HOB_NSECT|IDE_TFLAG_IN_HOB_LBA; }") unless defined(&IDE_TFLAG_IN_HOB);
	eval("sub IDE_TFLAG_IN_FEATURE () { (1<<1); }") unless defined(&IDE_TFLAG_IN_FEATURE);
	eval("sub IDE_TFLAG_IN_NSECT () { (1<<25); }") unless defined(&IDE_TFLAG_IN_NSECT);
	eval("sub IDE_TFLAG_IN_LBAL () { (1<<26); }") unless defined(&IDE_TFLAG_IN_LBAL);
	eval("sub IDE_TFLAG_IN_LBAM () { (1<<27); }") unless defined(&IDE_TFLAG_IN_LBAM);
	eval("sub IDE_TFLAG_IN_LBAH () { (1<<28); }") unless defined(&IDE_TFLAG_IN_LBAH);
	eval("sub IDE_TFLAG_IN_LBA () { IDE_TFLAG_IN_LBAL|IDE_TFLAG_IN_LBAM|IDE_TFLAG_IN_LBAH; }") unless defined(&IDE_TFLAG_IN_LBA);
	eval("sub IDE_TFLAG_IN_TF () { IDE_TFLAG_IN_NSECT|IDE_TFLAG_IN_LBA; }") unless defined(&IDE_TFLAG_IN_TF);
	eval("sub IDE_TFLAG_IN_DEVICE () { (1<<29); }") unless defined(&IDE_TFLAG_IN_DEVICE);
	eval("sub IDE_TFLAG_HOB () { IDE_TFLAG_OUT_HOB|IDE_TFLAG_IN_HOB; }") unless defined(&IDE_TFLAG_HOB);
	eval("sub IDE_TFLAG_TF () { IDE_TFLAG_OUT_TF|IDE_TFLAG_IN_TF; }") unless defined(&IDE_TFLAG_TF);
	eval("sub IDE_TFLAG_DEVICE () { IDE_TFLAG_OUT_DEVICE|IDE_TFLAG_IN_DEVICE; }") unless defined(&IDE_TFLAG_DEVICE);
	eval("sub IDE_TFLAG_IO_16BIT () { (1<<30); }") unless defined(&IDE_TFLAG_IO_16BIT);
	eval("sub IDE_TFLAG_DYN () { (1<<31); }") unless defined(&IDE_TFLAG_DYN);
	if(defined(&CONFIG_IDEPCI_PCIBUS_ORDER)) {
	    eval 'sub ide_pci_register_driver {
	        my($d) = @_;
    		eval q( &__ide_pci_register_driver($d,  &THIS_MODULE,  &KBUILD_MODNAME));
	    }' unless defined(&ide_pci_register_driver);
	} else {
	    eval 'sub ide_pci_register_driver {
	        my($d) = @_;
    		eval q( &pci_register_driver($d));
	    }' unless defined(&ide_pci_register_driver);
	}
	if(defined(&CONFIG_BLK_DEV_IDEDMA_PCI)) {
	} else {
	    eval 'sub ide_hwif_setup_dma {
	        my($hwif,$d) = @_;
    		eval q({ - &EINVAL; });
	    }' unless defined(&ide_hwif_setup_dma);
	}
	eval("sub IDE_HFLAG_ISA_PORTS () { (1<<0); }") unless defined(&IDE_HFLAG_ISA_PORTS);
	eval("sub IDE_HFLAG_SINGLE () { (1<<1); }") unless defined(&IDE_HFLAG_SINGLE);
	eval("sub IDE_HFLAG_PIO_NO_BLACKLIST () { (1<<2); }") unless defined(&IDE_HFLAG_PIO_NO_BLACKLIST);
	eval("sub IDE_HFLAG_QD_2ND_PORT () { (1<<3); }") unless defined(&IDE_HFLAG_QD_2ND_PORT);
	eval("sub IDE_HFLAG_ABUSE_PREFETCH () { (1<<4); }") unless defined(&IDE_HFLAG_ABUSE_PREFETCH);
	eval("sub IDE_HFLAG_ABUSE_FAST_DEVSEL () { (1<<5); }") unless defined(&IDE_HFLAG_ABUSE_FAST_DEVSEL);
	eval("sub IDE_HFLAG_ABUSE_DMA_MODES () { (1<<6); }") unless defined(&IDE_HFLAG_ABUSE_DMA_MODES);
	eval("sub IDE_HFLAG_SET_PIO_MODE_KEEP_DMA () { (1<<7); }") unless defined(&IDE_HFLAG_SET_PIO_MODE_KEEP_DMA);
	eval("sub IDE_HFLAG_POST_SET_MODE () { (1<<8); }") unless defined(&IDE_HFLAG_POST_SET_MODE);
	eval("sub IDE_HFLAG_NO_SET_MODE () { (1<<9); }") unless defined(&IDE_HFLAG_NO_SET_MODE);
	eval("sub IDE_HFLAG_TRUST_BIOS_FOR_DMA () { (1<<10); }") unless defined(&IDE_HFLAG_TRUST_BIOS_FOR_DMA);
	eval("sub IDE_HFLAG_CS5520 () { (1<<11); }") unless defined(&IDE_HFLAG_CS5520);
	eval("sub IDE_HFLAG_NO_ATAPI_DMA () { (1<<12); }") unless defined(&IDE_HFLAG_NO_ATAPI_DMA);
	eval("sub IDE_HFLAG_NON_BOOTABLE () { (1<<13); }") unless defined(&IDE_HFLAG_NON_BOOTABLE);
	eval("sub IDE_HFLAG_NO_DMA () { (1<<14); }") unless defined(&IDE_HFLAG_NO_DMA);
	eval("sub IDE_HFLAG_NO_AUTODMA () { (1<<15); }") unless defined(&IDE_HFLAG_NO_AUTODMA);
	eval("sub IDE_HFLAG_MMIO () { (1<<16); }") unless defined(&IDE_HFLAG_MMIO);
	eval("sub IDE_HFLAG_NO_LBA48 () { (1<<17); }") unless defined(&IDE_HFLAG_NO_LBA48);
	eval("sub IDE_HFLAG_NO_LBA48_DMA () { (1<<18); }") unless defined(&IDE_HFLAG_NO_LBA48_DMA);
	eval("sub IDE_HFLAG_ERROR_STOPS_FIFO () { (1<<19); }") unless defined(&IDE_HFLAG_ERROR_STOPS_FIFO);
	eval("sub IDE_HFLAG_SERIALIZE () { (1<<20); }") unless defined(&IDE_HFLAG_SERIALIZE);
	eval("sub IDE_HFLAG_LEGACY_IRQS () { (1<<21); }") unless defined(&IDE_HFLAG_LEGACY_IRQS);
	eval("sub IDE_HFLAG_FORCE_LEGACY_IRQS () { (1<<22); }") unless defined(&IDE_HFLAG_FORCE_LEGACY_IRQS);
	eval("sub IDE_HFLAG_RQSIZE_256 () { (1<<23); }") unless defined(&IDE_HFLAG_RQSIZE_256);
	eval("sub IDE_HFLAG_IO_32BIT () { (1<<24); }") unless defined(&IDE_HFLAG_IO_32BIT);
	eval("sub IDE_HFLAG_UNMASK_IRQS () { (1<<25); }") unless defined(&IDE_HFLAG_UNMASK_IRQS);
	eval("sub IDE_HFLAG_SERIALIZE_DMA () { (1<<27); }") unless defined(&IDE_HFLAG_SERIALIZE_DMA);
	eval("sub IDE_HFLAG_CLEAR_SIMPLEX () { (1<<28); }") unless defined(&IDE_HFLAG_CLEAR_SIMPLEX);
	eval("sub IDE_HFLAG_NO_DSC () { (1<<29); }") unless defined(&IDE_HFLAG_NO_DSC);
	eval("sub IDE_HFLAG_NO_IO_32BIT () { (1<<30); }") unless defined(&IDE_HFLAG_NO_IO_32BIT);
	eval("sub IDE_HFLAG_NO_UNMASK_IRQS () { (1<<31); }") unless defined(&IDE_HFLAG_NO_UNMASK_IRQS);
	if(defined(&CONFIG_BLK_DEV_OFFBOARD)) {
	    eval 'sub IDE_HFLAG_OFF_BOARD () {0;}' unless defined(&IDE_HFLAG_OFF_BOARD);
	} else {
	    eval 'sub IDE_HFLAG_OFF_BOARD () { &IDE_HFLAG_NON_BOOTABLE;}' unless defined(&IDE_HFLAG_OFF_BOARD);
	}
	eval 'sub BAD_DMA_DRIVE () {0;}' unless defined(&BAD_DMA_DRIVE);
	eval 'sub GOOD_DMA_DRIVE () {1;}' unless defined(&GOOD_DMA_DRIVE);
	if(defined(&CONFIG_BLK_DEV_IDEDMA)) {
	    eval 'sub ide_max_dma_mode {
	        my($drive) = @_;
    		eval q({  &ide_find_dma_mode($drive,  &XFER_UDMA_6); });
	    }' unless defined(&ide_max_dma_mode);
	    if(defined(&CONFIG_BLK_DEV_IDEDMA_SFF)) {
	    }
	} else {
	}
	if(defined(&CONFIG_BLK_DEV_IDEACPI)) {
	} else {
	}
	eval 'sub void {
	    eval q(* &ide_get_hwifdata ( &ide_hwif_t *  &hwif) {  ($hwif->{hwif_data}); });
	}' unless defined(&void);
	eval 'sub ide_set_hwifdata {
	    my($hwif,$data) = @_;
    	    eval q({  ($hwif->{hwif_data}) = $data; });
	}' unless defined(&ide_set_hwifdata);
	eval 'sub ide_dev_has_iordy {
	    my($id) = @_;
    	    eval q({ (( ($id->{field_valid}) & 2)  && ( ($id->{capability}) & 8)) ? 1: 0; });
	}' unless defined(&ide_dev_has_iordy);
	eval 'sub ide_dev_is_sata {
	    my($id) = @_;
    	    eval q({  &if ( ($id->{hw_config}) == 0 &&  ($id->{major_rev_num}) >= 0x20) 1; 0; });
	}' unless defined(&ide_dev_is_sata);
	eval("sub IDE_TIMING_SETUP () { (1<<0); }") unless defined(&IDE_TIMING_SETUP);
	eval("sub IDE_TIMING_ACT8B () { (1<<1); }") unless defined(&IDE_TIMING_ACT8B);
	eval("sub IDE_TIMING_REC8B () { (1<<2); }") unless defined(&IDE_TIMING_REC8B);
	eval("sub IDE_TIMING_CYC8B () { (1<<3); }") unless defined(&IDE_TIMING_CYC8B);
	eval("sub IDE_TIMING_8BIT () { IDE_TIMING_ACT8B|IDE_TIMING_REC8B|IDE_TIMING_CYC8B; }") unless defined(&IDE_TIMING_8BIT);
	eval("sub IDE_TIMING_ACTIVE () { (1<<4); }") unless defined(&IDE_TIMING_ACTIVE);
	eval("sub IDE_TIMING_RECOVER () { (1<<5); }") unless defined(&IDE_TIMING_RECOVER);
	eval("sub IDE_TIMING_CYCLE () { (1<<6); }") unless defined(&IDE_TIMING_CYCLE);
	eval("sub IDE_TIMING_UDMA () { (1<<7); }") unless defined(&IDE_TIMING_UDMA);
	eval("sub IDE_TIMING_ALL () { IDE_TIMING_SETUP|IDE_TIMING_8BIT|IDE_TIMING_ACTIVE|IDE_TIMING_RECOVER|IDE_TIMING_CYCLE|IDE_TIMING_UDMA; }") unless defined(&IDE_TIMING_ALL);
	eval 'sub ide_set_max_pio {
	    my($drive) = @_;
    	    eval q({  &ide_set_pio($drive, 255); });
	}' unless defined(&ide_set_max_pio);
	eval 'sub local_irq_set {
	    my($flags) = @_;
    	    eval q( &do {  &local_save_flags(($flags));  &local_irq_enable_in_hardirq(); }  &while (0));
	}' unless defined(&local_irq_set);
	eval 'sub ide_id_has_flush_cache {
	    my($id) = @_;
    	    eval q((($id)-> &cfs_enable_2 & 0x3000));
	}' unless defined(&ide_id_has_flush_cache);
	eval 'sub ide_id_has_flush_cache_ext {
	    my($id) = @_;
    	    eval q(((($id)-> &cfs_enable_2 & 0x2400) == 0x2400));
	}' unless defined(&ide_id_has_flush_cache_ext);
	eval 'sub ide_dump_identify {
	    my($id) = @_;
    	    eval q({  &print_hex_dump( &KERN_INFO, \\"\\",  &DUMP_PREFIX_NONE, 16, 2, $id, 512, 0); });
	}' unless defined(&ide_dump_identify);
	eval 'sub hwif_to_node {
	    my($hwif) = @_;
    	    eval q({  ($hwif->{dev}) ?  &dev_to_node( ($hwif->{dev})) : -1; });
	}' unless defined(&hwif_to_node);
	eval 'sub ide_drive_t {
	    eval q(* &ide_get_paired_drive( &ide_drive_t * &drive) {  &ide_hwif_t * &hwif =  &HWIF( &drive);  ($hwif->{drives[(drive}->{dn ^ 1) & 1]}); });
	}' unless defined(&ide_drive_t);
    }
1;
