require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__IDR_H__)) {
    eval 'sub __IDR_H__ () {1;}' unless defined(&__IDR_H__);
    require 'linux/types.ph';
    require 'linux/bitops.ph';
    require 'linux/init.ph';
    require 'linux/rcupdate.ph';
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 32) {
	eval 'sub IDR_BITS () {5;}' unless defined(&IDR_BITS);
	eval 'sub IDR_FULL () {0xffffffff;}' unless defined(&IDR_FULL);
	eval 'sub TOP_LEVEL_FULL () {( &IDR_FULL >> 30);}' unless defined(&TOP_LEVEL_FULL);
    }
 elsif((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 64) {
	eval 'sub IDR_BITS () {6;}' unless defined(&IDR_BITS);
	eval 'sub IDR_FULL () {1.84467440737096e+19;}' unless defined(&IDR_FULL);
	eval 'sub TOP_LEVEL_FULL () {( &IDR_FULL >> 62);}' unless defined(&TOP_LEVEL_FULL);
    } else {
	die("BITS_PER_LONG is not 32 or 64");
    }
    eval 'sub IDR_SIZE () {(1<<  &IDR_BITS);}' unless defined(&IDR_SIZE);
    eval 'sub IDR_MASK () {((1<<  &IDR_BITS)-1);}' unless defined(&IDR_MASK);
    eval 'sub MAX_ID_SHIFT () {($sizeof{\'int\'}*8- 1);}' unless defined(&MAX_ID_SHIFT);
    eval 'sub MAX_ID_BIT () {(1 <<  &MAX_ID_SHIFT);}' unless defined(&MAX_ID_BIT);
    eval 'sub MAX_ID_MASK () {( &MAX_ID_BIT - 1);}' unless defined(&MAX_ID_MASK);
    eval 'sub MAX_LEVEL () {( &MAX_ID_SHIFT +  &IDR_BITS - 1) /  &IDR_BITS;}' unless defined(&MAX_LEVEL);
    eval 'sub IDR_FREE_MAX () { &MAX_LEVEL +  &MAX_LEVEL;}' unless defined(&IDR_FREE_MAX);
    eval 'sub IDR_INIT {
        my($name) = @_;
	    eval q({ . &top =  &NULL, . &id_free =  &NULL, . &layers = 0, . &id_free_cnt = 0, . &lock =  &__SPIN_LOCK_UNLOCKED( ($name->{lock})), });
    }' unless defined(&IDR_INIT);
    eval 'sub DEFINE_IDR {
        my($name) = @_;
	    eval q(\'struct idr\' $name =  &IDR_INIT($name));
    }' unless defined(&DEFINE_IDR);
    eval 'sub IDR_NEED_TO_GROW () {-2;}' unless defined(&IDR_NEED_TO_GROW);
    eval 'sub IDR_NOMORE_SPACE () {-3;}' unless defined(&IDR_NOMORE_SPACE);
    eval 'sub _idr_rc_to_errno {
        my($rc) = @_;
	    eval q((($rc) == -1? - &EAGAIN : - &ENOSPC));
    }' unless defined(&_idr_rc_to_errno);
    eval 'sub IDA_CHUNK_SIZE () {128;}' unless defined(&IDA_CHUNK_SIZE);
    eval 'sub IDA_BITMAP_LONGS () {(128/ $sizeof{\'long\'} - 1);}' unless defined(&IDA_BITMAP_LONGS);
    eval 'sub IDA_BITMAP_BITS () {( &IDA_BITMAP_LONGS * $sizeof{\'long\'} * 8);}' unless defined(&IDA_BITMAP_BITS);
    eval 'sub IDA_INIT {
        my($name) = @_;
	    eval q({ . &idr =  &IDR_INIT($name), . &free_bitmap =  &NULL, });
    }' unless defined(&IDA_INIT);
    eval 'sub DEFINE_IDA {
        my($name) = @_;
	    eval q(\'struct ida\' $name =  &IDA_INIT($name));
    }' unless defined(&DEFINE_IDA);
}
1;
