require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_IF_VLAN_H_)) {
    eval 'sub _LINUX_IF_VLAN_H_ () {1;}' unless defined(&_LINUX_IF_VLAN_H_);
    if(defined(&__KERNEL__)) {
	require 'linux/netdevice.ph';
	require 'linux/etherdevice.ph';
	eval 'sub VLAN_HLEN () {4;}' unless defined(&VLAN_HLEN);
	eval 'sub VLAN_ETH_ALEN () {6;}' unless defined(&VLAN_ETH_ALEN);
	eval 'sub VLAN_ETH_HLEN () {18;}' unless defined(&VLAN_ETH_HLEN);
	eval 'sub VLAN_ETH_ZLEN () {64;}' unless defined(&VLAN_ETH_ZLEN);
	eval 'sub VLAN_ETH_DATA_LEN () {1500;}' unless defined(&VLAN_ETH_DATA_LEN);
	eval 'sub VLAN_ETH_FRAME_LEN () {1518;}' unless defined(&VLAN_ETH_FRAME_LEN);
	require 'linux/skbuff.ph';
	eval 'sub vlan_ethhdr {
	    eval q(* &vlan_eth_hdr( &const \'struct sk_buff\' * &skb) {  &skb_mac_header( &skb); });
	}' unless defined(&vlan_ethhdr);
	eval 'sub VLAN_VID_MASK () {0xfff;}' unless defined(&VLAN_VID_MASK);
	eval 'sub VLAN_GROUP_ARRAY_LEN () {4096;}' unless defined(&VLAN_GROUP_ARRAY_LEN);
	eval 'sub VLAN_GROUP_ARRAY_SPLIT_PARTS () {8;}' unless defined(&VLAN_GROUP_ARRAY_SPLIT_PARTS);
	eval 'sub VLAN_GROUP_ARRAY_PART_LEN () {( &VLAN_GROUP_ARRAY_LEN/ &VLAN_GROUP_ARRAY_SPLIT_PARTS);}' unless defined(&VLAN_GROUP_ARRAY_PART_LEN);
	eval 'sub net_device {
	    eval q(* &vlan_group_get_device(\'struct vlan_group\' * &vg,  &u16  &vlan_id) { \'struct net_device\' ** &array;  &array =  ($vg->{vlan_devices_arrays[&vlan_id/VLAN_GROUP_ARRAY_PART_LEN]});  &array ?  $array[ &vlan_id %  &VLAN_GROUP_ARRAY_PART_LEN] :  &NULL; });
	}' unless defined(&net_device);
	eval 'sub vlan_group_set_device {
	    my($vg,$vlan_id,$dev) = @_;
    	    eval q({ \'struct net_device\' ** &array;  &if (!$vg) ;  &array =  ($vg->{vlan_devices_arrays[$vlan_id / VLAN_GROUP_ARRAY_PART_LEN]});  $array[$vlan_id %  &VLAN_GROUP_ARRAY_PART_LEN] = $dev; });
	}' unless defined(&vlan_group_set_device);
	eval 'sub vlan_tx_tag_present {
	    my($__skb) = @_;
    	    eval q((($__skb)-> &vlan_tci));
	}' unless defined(&vlan_tx_tag_present);
	eval 'sub vlan_tx_tag_get {
	    my($__skb) = @_;
    	    eval q((($__skb)-> &vlan_tci));
	}' unless defined(&vlan_tx_tag_get);
	if(defined( &CONFIG_VLAN_8021Q) || defined( &CONFIG_VLAN_8021Q_MODULE)) {
	} else {
	    eval 'sub net_device {
	        eval q(* &vlan_dev_real_dev( &const \'struct net_device\' * &dev) {  &BUG();  &NULL; });
	    }' unless defined(&net_device);
	    eval 'sub vlan_dev_vlan_id {
	        my($dev) = @_;
    		eval q({  &BUG(); 0; });
	    }' unless defined(&vlan_dev_vlan_id);
	    eval 'sub __vlan_hwaccel_rx {
	        my($skb,$grp,$vlan_tci,$polling) = @_;
    		eval q({  &BUG();  &NET_XMIT_SUCCESS; });
	    }' unless defined(&__vlan_hwaccel_rx);
	}
	eval 'sub HAVE_VLAN_PUT_TAG () {1;}' unless defined(&HAVE_VLAN_PUT_TAG);
	eval 'sub HAVE_VLAN_GET_TAG () {1;}' unless defined(&HAVE_VLAN_GET_TAG);
    }
    eval("sub ADD_VLAN_CMD () { 0; }") unless defined(&ADD_VLAN_CMD);
    eval("sub DEL_VLAN_CMD () { 1; }") unless defined(&DEL_VLAN_CMD);
    eval("sub SET_VLAN_INGRESS_PRIORITY_CMD () { 2; }") unless defined(&SET_VLAN_INGRESS_PRIORITY_CMD);
    eval("sub SET_VLAN_EGRESS_PRIORITY_CMD () { 3; }") unless defined(&SET_VLAN_EGRESS_PRIORITY_CMD);
    eval("sub GET_VLAN_INGRESS_PRIORITY_CMD () { 4; }") unless defined(&GET_VLAN_INGRESS_PRIORITY_CMD);
    eval("sub GET_VLAN_EGRESS_PRIORITY_CMD () { 5; }") unless defined(&GET_VLAN_EGRESS_PRIORITY_CMD);
    eval("sub SET_VLAN_NAME_TYPE_CMD () { 6; }") unless defined(&SET_VLAN_NAME_TYPE_CMD);
    eval("sub SET_VLAN_FLAG_CMD () { 7; }") unless defined(&SET_VLAN_FLAG_CMD);
    eval("sub GET_VLAN_REALDEV_NAME_CMD () { 8; }") unless defined(&GET_VLAN_REALDEV_NAME_CMD);
    eval("sub GET_VLAN_VID_CMD () { 9; }") unless defined(&GET_VLAN_VID_CMD);
    eval("sub VLAN_FLAG_REORDER_HDR () { 0x1; }") unless defined(&VLAN_FLAG_REORDER_HDR);
    eval("sub VLAN_FLAG_GVRP () { 0x2; }") unless defined(&VLAN_FLAG_GVRP);
    eval("sub VLAN_NAME_TYPE_PLUS_VID () { 0; }") unless defined(&VLAN_NAME_TYPE_PLUS_VID);
    eval("sub VLAN_NAME_TYPE_RAW_PLUS_VID () { 1; }") unless defined(&VLAN_NAME_TYPE_RAW_PLUS_VID);
    eval("sub VLAN_NAME_TYPE_PLUS_VID_NO_PAD () { 2; }") unless defined(&VLAN_NAME_TYPE_PLUS_VID_NO_PAD);
    eval("sub VLAN_NAME_TYPE_RAW_PLUS_VID_NO_PAD () { 3; }") unless defined(&VLAN_NAME_TYPE_RAW_PLUS_VID_NO_PAD);
    eval("sub VLAN_NAME_TYPE_HIGHEST () { 4; }") unless defined(&VLAN_NAME_TYPE_HIGHEST);
}
1;
