require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_INETDEVICE_H)) {
    eval 'sub _LINUX_INETDEVICE_H () {1;}' unless defined(&_LINUX_INETDEVICE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/bitmap.ph';
	require 'linux/if.ph';
	require 'linux/netdevice.ph';
	require 'linux/rcupdate.ph';
	require 'linux/timer.ph';
	require 'linux/sysctl.ph';
	eval 'sub IPV4_DEVCONF {
	    my($cnf, $attr) = @_;
    	    eval q((($cnf). $data[ &NET_IPV4_CONF_  $attr - 1]));
	}' unless defined(&IPV4_DEVCONF);
	eval 'sub IPV4_DEVCONF_ALL {
	    my($net, $attr) = @_;
    	    eval q( &IPV4_DEVCONF((*($net)-> ($ipv4->{devconf_all})), $attr));
	}' unless defined(&IPV4_DEVCONF_ALL);
	eval 'sub ipv4_devconf_get {
	    my($in_dev,$index) = @_;
    	    eval q({ $index--;  ($in_dev->{cnf}->{data[$index]}); });
	}' unless defined(&ipv4_devconf_get);
	eval 'sub ipv4_devconf_set {
	    my($in_dev,$index,$val) = @_;
    	    eval q({ $index--;  &set_bit($index,  ($in_dev->{cnf}->{state}));  ($in_dev->{cnf}->{data[$index]}) = $val; });
	}' unless defined(&ipv4_devconf_set);
	eval 'sub ipv4_devconf_setall {
	    my($in_dev) = @_;
    	    eval q({  &bitmap_fill( ($in_dev->{cnf}->{state}),  &__NET_IPV4_CONF_MAX - 1); });
	}' unless defined(&ipv4_devconf_setall);
	eval 'sub IN_DEV_CONF_GET {
	    my($in_dev, $attr) = @_;
    	    eval q( &ipv4_devconf_get(($in_dev),  &NET_IPV4_CONF_  $attr));
	}' unless defined(&IN_DEV_CONF_GET);
	eval 'sub IN_DEV_CONF_SET {
	    my($in_dev, $attr, $val) = @_;
    	    eval q( &ipv4_devconf_set(($in_dev),  &NET_IPV4_CONF_  $attr, ($val)));
	}' unless defined(&IN_DEV_CONF_SET);
	eval 'sub IN_DEV_ANDCONF {
	    my($in_dev, $attr) = @_;
    	    eval q(( &IPV4_DEVCONF_ALL( &dev_net( ($in_dev->{dev})), $attr)  &&  &IN_DEV_CONF_GET(($in_dev), $attr)));
	}' unless defined(&IN_DEV_ANDCONF);
	eval 'sub IN_DEV_ORCONF {
	    my($in_dev, $attr) = @_;
    	    eval q(( &IPV4_DEVCONF_ALL( &dev_net( ($in_dev->{dev})), $attr) ||  &IN_DEV_CONF_GET(($in_dev), $attr)));
	}' unless defined(&IN_DEV_ORCONF);
	eval 'sub IN_DEV_MAXCONF {
	    my($in_dev, $attr) = @_;
    	    eval q(( &max( &IPV4_DEVCONF_ALL( &dev_net( ($in_dev->{dev})), $attr),  &IN_DEV_CONF_GET(($in_dev), $attr))));
	}' unless defined(&IN_DEV_MAXCONF);
	eval 'sub IN_DEV_FORWARD {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_CONF_GET(($in_dev),  &FORWARDING));
	}' unless defined(&IN_DEV_FORWARD);
	eval 'sub IN_DEV_MFORWARD {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ANDCONF(($in_dev),  &MC_FORWARDING));
	}' unless defined(&IN_DEV_MFORWARD);
	eval 'sub IN_DEV_RPFILTER {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ANDCONF(($in_dev),  &RP_FILTER));
	}' unless defined(&IN_DEV_RPFILTER);
	eval 'sub IN_DEV_SOURCE_ROUTE {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ANDCONF(($in_dev),  &ACCEPT_SOURCE_ROUTE));
	}' unless defined(&IN_DEV_SOURCE_ROUTE);
	eval 'sub IN_DEV_BOOTP_RELAY {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ANDCONF(($in_dev),  &BOOTP_RELAY));
	}' unless defined(&IN_DEV_BOOTP_RELAY);
	eval 'sub IN_DEV_LOG_MARTIANS {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &LOG_MARTIANS));
	}' unless defined(&IN_DEV_LOG_MARTIANS);
	eval 'sub IN_DEV_PROXY_ARP {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &PROXY_ARP));
	}' unless defined(&IN_DEV_PROXY_ARP);
	eval 'sub IN_DEV_SHARED_MEDIA {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &SHARED_MEDIA));
	}' unless defined(&IN_DEV_SHARED_MEDIA);
	eval 'sub IN_DEV_TX_REDIRECTS {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &SEND_REDIRECTS));
	}' unless defined(&IN_DEV_TX_REDIRECTS);
	eval 'sub IN_DEV_SEC_REDIRECTS {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &SECURE_REDIRECTS));
	}' unless defined(&IN_DEV_SEC_REDIRECTS);
	eval 'sub IN_DEV_IDTAG {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_CONF_GET($in_dev,  &TAG));
	}' unless defined(&IN_DEV_IDTAG);
	eval 'sub IN_DEV_MEDIUM_ID {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_CONF_GET($in_dev,  &MEDIUM_ID));
	}' unless defined(&IN_DEV_MEDIUM_ID);
	eval 'sub IN_DEV_PROMOTE_SECONDARIES {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &PROMOTE_SECONDARIES));
	}' unless defined(&IN_DEV_PROMOTE_SECONDARIES);
	eval 'sub IN_DEV_RX_REDIRECTS {
	    my($in_dev) = @_;
    	    eval q((( &IN_DEV_FORWARD($in_dev)  &&  &IN_DEV_ANDCONF(($in_dev),  &ACCEPT_REDIRECTS)) || (! &IN_DEV_FORWARD($in_dev)  &&  &IN_DEV_ORCONF(($in_dev),  &ACCEPT_REDIRECTS))));
	}' unless defined(&IN_DEV_RX_REDIRECTS);
	eval 'sub IN_DEV_ARPFILTER {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_ORCONF(($in_dev),  &ARPFILTER));
	}' unless defined(&IN_DEV_ARPFILTER);
	eval 'sub IN_DEV_ARP_ANNOUNCE {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_MAXCONF(($in_dev),  &ARP_ANNOUNCE));
	}' unless defined(&IN_DEV_ARP_ANNOUNCE);
	eval 'sub IN_DEV_ARP_IGNORE {
	    my($in_dev) = @_;
    	    eval q( &IN_DEV_MAXCONF(($in_dev),  &ARP_IGNORE));
	}' unless defined(&IN_DEV_ARP_IGNORE);
	eval 'sub inet_ifa_match {
	    my($addr,$ifa) = @_;
    	    eval q({ !(($addr^ ($ifa->{ifa_address})) ($ifa->{ifa_mask})); });
	}' unless defined(&inet_ifa_match);
	eval 'sub for_primary_ifa {
	    my($in_dev) = @_;
    	    eval q({ \'struct in_ifaddr\' * &ifa;  &for ( &ifa = ($in_dev)-> &ifa_list;  &ifa  && !( ($ifa->{ifa_flags})& &IFA_F_SECONDARY);  &ifa =  ($ifa->{ifa_next})));
	}' unless defined(&for_primary_ifa);
	eval 'sub for_ifa {
	    my($in_dev) = @_;
    	    eval q({ \'struct in_ifaddr\' * &ifa;  &for ( &ifa = ($in_dev)-> &ifa_list;  &ifa;  &ifa =  ($ifa->{ifa_next})));
	}' unless defined(&for_ifa);
	eval 'sub endfor_ifa {
	    my($in_dev) = @_;
    	    eval q(});
	}' unless defined(&endfor_ifa);
	eval 'sub in_device {
	    eval q(* &__in_dev_get_rcu( &const \'struct net_device\' * &dev) { \'struct in_device\' * &in_dev =  ($dev->{ip_ptr});  &if ( &in_dev)  &in_dev =  &rcu_dereference( &in_dev);  &in_dev; });
	}' unless defined(&in_device);
	eval 'sub in_dev_get {
	    my($dev) = @_;
    	    eval q({ \'struct in_device\' * &in_dev;  &rcu_read_lock();  &in_dev =  &__in_dev_get_rcu($dev);  &if ( &in_dev)  &atomic_inc( ($in_dev->{refcnt}));  &rcu_read_unlock();  &in_dev; });
	}' unless defined(&in_dev_get);
	eval 'sub __in_dev_get_rtnl {
	    my($dev) = @_;
    	    eval q({  ($dev->{ip_ptr}); });
	}' unless defined(&__in_dev_get_rtnl);
	eval 'sub in_dev_put {
	    my($idev) = @_;
    	    eval q({  &if ( &atomic_dec_and_test( ($idev->{refcnt})))  &in_dev_finish_destroy($idev); });
	}' unless defined(&in_dev_put);
	eval 'sub __in_dev_put {
	    my($idev) = @_;
    	    eval q( &atomic_dec(($idev)-> &refcnt));
	}' unless defined(&__in_dev_put);
	eval 'sub in_dev_hold {
	    my($idev) = @_;
    	    eval q( &atomic_inc(($idev)-> &refcnt));
	}' unless defined(&in_dev_hold);
    }
    eval 'sub inet_make_mask {
        my($logmask) = @_;
	    eval q({  &if ($logmask)  &htonl(~((1<<(32-$logmask))-1)); 0; });
    }' unless defined(&inet_make_mask);
    eval 'sub inet_mask_len {
        my($mask) = @_;
	    eval q({  &__u32  &hmask =  &ntohl($mask);  &if (! &hmask) 0; 32-  &ffz(~ &hmask); });
    }' unless defined(&inet_mask_len);
}
1;
