require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX__INIT_TASK_H)) {
    eval 'sub _LINUX__INIT_TASK_H () {1;}' unless defined(&_LINUX__INIT_TASK_H);
    require 'linux/rcupdate.ph';
    require 'linux/irqflags.ph';
    require 'linux/utsname.ph';
    require 'linux/lockdep.ph';
    require 'linux/ipc.ph';
    require 'linux/pid_namespace.ph';
    require 'linux/user_namespace.ph';
    require 'linux/securebits.ph';
    require 'net/net_namespace.ph';
    eval 'sub INIT_KIOCTX {
        my($name, $which_mm) = @_;
	    eval q({ . &users =  &ATOMIC_INIT(1), . &dead = 0, . &mm = $which_mm, . &user_id = 0, . &next =  &NULL, . &wait =  &__WAIT_QUEUE_HEAD_INITIALIZER( ($name->{wait})), . &ctx_lock =  &__SPIN_LOCK_UNLOCKED( ($name->{ctx_lock})), . &reqs_active = 0, . &max_reqs = ~0, });
    }' unless defined(&INIT_KIOCTX);
    eval 'sub INIT_MM {
        my($name) = @_;
	    eval q({ . &mm_rb =  &RB_ROOT, . &pgd =  &swapper_pg_dir, . &mm_users =  &ATOMIC_INIT(2), . &mm_count =  &ATOMIC_INIT(1), . &mmap_sem =  &__RWSEM_INITIALIZER( ($name->{mmap_sem})), . &page_table_lock =  &__SPIN_LOCK_UNLOCKED( ($name->{page_table_lock})), . &mmlist =  &LIST_HEAD_INIT( ($name->{mmlist})), . &cpu_vm_mask =  &CPU_MASK_ALL, });
    }' unless defined(&INIT_MM);
    eval 'sub INIT_SIGNALS {
        my($sig) = @_;
	    eval q({ . &count =  &ATOMIC_INIT(1), . &wait_chldexit =  &__WAIT_QUEUE_HEAD_INITIALIZER( ($sig->{wait_chldexit})), . &shared_pending = { . &list =  &LIST_HEAD_INIT( ($sig->{shared_pending}->{list})), . &signal = {{0}}}, . &posix_timers =  &LIST_HEAD_INIT( ($sig->{posix_timers})), . &cpu_timers =  &INIT_CPU_TIMERS( ($sig->{cpu_timers})), . &rlim =  &INIT_RLIMITS, });
    }' unless defined(&INIT_SIGNALS);
    eval 'sub INIT_NSPROXY {
        my($nsproxy) = @_;
	    eval q({ . &pid_ns =  &init_pid_ns, . &count =  &ATOMIC_INIT(1), . &uts_ns =  &init_uts_ns, . &mnt_ns =  &NULL,  &INIT_NET_NS( &net_ns)  &INIT_IPC_NS( &ipc_ns) . &user_ns =  &init_user_ns, });
    }' unless defined(&INIT_NSPROXY);
    eval 'sub INIT_SIGHAND {
        my($sighand) = @_;
	    eval q({ . &count =  &ATOMIC_INIT(1), . &action = { { { . &sa_handler =  &NULL, } }, }, . &siglock =  &__SPIN_LOCK_UNLOCKED( ($sighand->{siglock})), . &signalfd_wqh =  &__WAIT_QUEUE_HEAD_INITIALIZER( ($sighand->{signalfd_wqh})), });
    }' unless defined(&INIT_SIGHAND);
    eval 'sub INIT_STRUCT_PID () {{ . &count =  &ATOMIC_INIT(1), . &tasks = { { . &first =  ($init_task->{pids[&PIDTYPE_PID]}->{node}) }, { . &first =  ($init_task->{pids[&PIDTYPE_PGID]}->{node}) }, { . &first =  ($init_task->{pids[&PIDTYPE_SID]}->{node}) }, }, . &rcu =  &RCU_HEAD_INIT, . &level = 0, . &numbers = { { . &nr = 0, . &ns =  &init_pid_ns, . &pid_chain = { . &next =  &NULL, . &pprev =  &NULL }, }, } };}' unless defined(&INIT_STRUCT_PID);
    eval 'sub INIT_PID_LINK {
        my($type) = @_;
	    eval q({ . &node = { . &next =  &NULL, . &pprev =  ($init_struct_pid->{tasks[$type]}->{first}), }, . &pid =  &init_struct_pid, });
    }' unless defined(&INIT_PID_LINK);
    if(defined(&CONFIG_AUDITSYSCALL)) {
	eval 'sub INIT_IDS () {. &loginuid = -1, . &sessionid = -1,;}' unless defined(&INIT_IDS);
    } else {
	eval 'sub INIT_IDS () {1;}' unless defined(&INIT_IDS);
    }
    if(defined(&CONFIG_SECURITY_FILE_CAPABILITIES)) {
	eval 'sub CAP_INIT_BSET () { &CAP_FULL_SET;}' unless defined(&CAP_INIT_BSET);
    } else {
	eval 'sub CAP_INIT_BSET () { &CAP_INIT_EFF_SET;}' unless defined(&CAP_INIT_BSET);
    }
    eval 'sub INIT_TASK {
        my($tsk) = @_;
	    eval q({ . &state = 0, . &stack =  &init_thread_info, . &usage =  &ATOMIC_INIT(2), . &flags =  &PF_KTHREAD, . &lock_depth = -1, . &prio =  &MAX_PRIO-20, . &static_prio =  &MAX_PRIO-20, . &normal_prio =  &MAX_PRIO-20, . &policy =  &SCHED_NORMAL, . &cpus_allowed =  &CPU_MASK_ALL, . &mm =  &NULL, . &active_mm =  &init_mm, . &se = { . &group_node =  &LIST_HEAD_INIT( ($tsk->{se}->{group_node})), }, . &rt = { . &run_list =  &LIST_HEAD_INIT( ($tsk->{rt}->{run_list})), . &time_slice =  &HZ, . &nr_cpus_allowed =  &NR_CPUS, }, . &tasks =  &LIST_HEAD_INIT( ($tsk->{tasks})), . &ptraced =  &LIST_HEAD_INIT( ($tsk->{ptraced})), . &ptrace_entry =  &LIST_HEAD_INIT( ($tsk->{ptrace_entry})), . &real_parent = $tsk, . &parent = $tsk, . &children =  &LIST_HEAD_INIT( ($tsk->{children})), . &sibling =  &LIST_HEAD_INIT( ($tsk->{sibling})), . &group_leader = $tsk, . &group_info =  &init_groups, . &cap_effective =  &CAP_INIT_EFF_SET, . &cap_inheritable =  &CAP_INIT_INH_SET, . &cap_permitted =  &CAP_FULL_SET, . &cap_bset =  &CAP_INIT_BSET, . &securebits =  &SECUREBITS_DEFAULT, . &user =  &INIT_USER, . &comm = \\"swapper\\", . &thread =  &INIT_THREAD, . &fs =  &init_fs, . &files =  &init_files, . &signal =  &init_signals, . &sighand =  &init_sighand, . &nsproxy =  &init_nsproxy, . &pending = { . &list =  &LIST_HEAD_INIT( ($tsk->{pending}->{list})), . &signal = {{0}}}, . &blocked = {{0}}, . &alloc_lock =  &__SPIN_LOCK_UNLOCKED( ($tsk->{alloc_lock})), . &journal_info =  &NULL, . &cpu_timers =  &INIT_CPU_TIMERS( ($tsk->{cpu_timers})), . &fs_excl =  &ATOMIC_INIT(0), . &pi_lock =  &__SPIN_LOCK_UNLOCKED( ($tsk->{pi_lock})), . &pids = { [ &PIDTYPE_PID] =  &INIT_PID_LINK( &PIDTYPE_PID), [ &PIDTYPE_PGID] =  &INIT_PID_LINK( &PIDTYPE_PGID), [ &PIDTYPE_SID] =  &INIT_PID_LINK( &PIDTYPE_SID), }, . &dirties =  &INIT_PROP_LOCAL_SINGLE( &dirties),  &INIT_IDS  &INIT_TRACE_IRQFLAGS  &INIT_LOCKDEP });
    }' unless defined(&INIT_TASK);
    eval 'sub INIT_CPU_TIMERS {
        my($cpu_timers) = @_;
	    eval q({  &LIST_HEAD_INIT($cpu_timers->[0]),  &LIST_HEAD_INIT($cpu_timers->[1]),  &LIST_HEAD_INIT($cpu_timers->[2]), });
    }' unless defined(&INIT_CPU_TIMERS);
}
1;
