require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_JBD2_H)) {
    eval 'sub _LINUX_JBD2_H () {1;}' unless defined(&_LINUX_JBD2_H);
    unless(defined(&__KERNEL__)) {
	require 'jfs_compat.ph';
	eval 'sub JBD2_DEBUG () {1;}' unless defined(&JBD2_DEBUG);
	eval 'sub jfs_debug () { &jbd_debug;}' unless defined(&jfs_debug);
    } else {
	require 'linux/types.ph';
	require 'linux/buffer_head.ph';
	require 'linux/journal-head.ph';
	require 'linux/stddef.ph';
	require 'linux/bit_spinlock.ph';
	require 'linux/mutex.ph';
	require 'linux/timer.ph';
    }
    eval 'sub journal_oom_retry () {1;}' unless defined(&journal_oom_retry);
    undef(&JBD2_PARANOID_IOFAIL) if defined(&JBD2_PARANOID_IOFAIL);
    eval 'sub JBD2_DEFAULT_MAX_COMMIT_AGE () {5;}' unless defined(&JBD2_DEFAULT_MAX_COMMIT_AGE);
    if(defined(&CONFIG_JBD2_DEBUG)) {
	eval 'sub JBD2_EXPENSIVE_CHECKING () {1;}' unless defined(&JBD2_EXPENSIVE_CHECKING);
	eval 'sub jbd_debug () {( &n,  &f,  &a...)  &do {  &if (( &n) <=  &jbd2_journal_enable_debug) {  &printk ( &KERN_DEBUG "(%s, %d): %s: ",  &__FILE__,  &__LINE__,  &__FUNCTION__);  &printk ( &f,   &a); } }  &while (0);}' unless defined(&jbd_debug);
    } else {
	eval 'sub jbd_debug () {( &f,  &a...);}' unless defined(&jbd_debug);
    }
    eval 'sub void {
        eval q(* &jbd2_alloc(\'size_t\'  &size,  &gfp_t  &flags) { ( &void *) &__get_free_pages( &flags,  &get_order( &size)); });
    }' unless defined(&void);
    eval 'sub jbd2_free {
        my($ptr,$size) = @_;
	    eval q({  &free_pages($ptr,  &get_order($size)); };);
    }' unless defined(&jbd2_free);
    eval 'sub JBD2_MIN_JOURNAL_BLOCKS () {1024;}' unless defined(&JBD2_MIN_JOURNAL_BLOCKS);
    if(defined(&__KERNEL__)) {
    }
    eval 'sub JBD2_MAGIC_NUMBER () {0xc03b3998;}' unless defined(&JBD2_MAGIC_NUMBER);
    eval 'sub JBD2_DESCRIPTOR_BLOCK () {1;}' unless defined(&JBD2_DESCRIPTOR_BLOCK);
    eval 'sub JBD2_COMMIT_BLOCK () {2;}' unless defined(&JBD2_COMMIT_BLOCK);
    eval 'sub JBD2_SUPERBLOCK_V1 () {3;}' unless defined(&JBD2_SUPERBLOCK_V1);
    eval 'sub JBD2_SUPERBLOCK_V2 () {4;}' unless defined(&JBD2_SUPERBLOCK_V2);
    eval 'sub JBD2_REVOKE_BLOCK () {5;}' unless defined(&JBD2_REVOKE_BLOCK);
    eval 'sub JBD2_CRC32_CHKSUM () {1;}' unless defined(&JBD2_CRC32_CHKSUM);
    eval 'sub JBD2_MD5_CHKSUM () {2;}' unless defined(&JBD2_MD5_CHKSUM);
    eval 'sub JBD2_SHA1_CHKSUM () {3;}' unless defined(&JBD2_SHA1_CHKSUM);
    eval 'sub JBD2_CRC32_CHKSUM_SIZE () {4;}' unless defined(&JBD2_CRC32_CHKSUM_SIZE);
    eval 'sub JBD2_CHECKSUM_BYTES () {(32/ $sizeof{ &u32});}' unless defined(&JBD2_CHECKSUM_BYTES);
    eval 'sub JBD2_TAG_SIZE32 () {( &offsetof( &journal_block_tag_t,  &t_blocknr_high));}' unless defined(&JBD2_TAG_SIZE32);
    eval 'sub JBD2_TAG_SIZE64 () {($sizeof{ &journal_block_tag_t});}' unless defined(&JBD2_TAG_SIZE64);
    eval 'sub JBD2_FLAG_ESCAPE () {1;}' unless defined(&JBD2_FLAG_ESCAPE);
    eval 'sub JBD2_FLAG_SAME_UUID () {2;}' unless defined(&JBD2_FLAG_SAME_UUID);
    eval 'sub JBD2_FLAG_DELETED () {4;}' unless defined(&JBD2_FLAG_DELETED);
    eval 'sub JBD2_FLAG_LAST_TAG () {8;}' unless defined(&JBD2_FLAG_LAST_TAG);
    eval 'sub JBD2_HAS_COMPAT_FEATURE {
        my($j,$mask) = @_;
	    eval q((($j)-> &j_format_version >= 2 && (($j)-> ($j_superblock->{s_feature_compat}) &  &cpu_to_be32(($mask)))));
    }' unless defined(&JBD2_HAS_COMPAT_FEATURE);
    eval 'sub JBD2_HAS_RO_COMPAT_FEATURE {
        my($j,$mask) = @_;
	    eval q((($j)-> &j_format_version >= 2 && (($j)-> ($j_superblock->{s_feature_ro_compat}) &  &cpu_to_be32(($mask)))));
    }' unless defined(&JBD2_HAS_RO_COMPAT_FEATURE);
    eval 'sub JBD2_HAS_INCOMPAT_FEATURE {
        my($j,$mask) = @_;
	    eval q((($j)-> &j_format_version >= 2 && (($j)-> ($j_superblock->{s_feature_incompat}) &  &cpu_to_be32(($mask)))));
    }' unless defined(&JBD2_HAS_INCOMPAT_FEATURE);
    eval 'sub JBD2_FEATURE_COMPAT_CHECKSUM () {0x1;}' unless defined(&JBD2_FEATURE_COMPAT_CHECKSUM);
    eval 'sub JBD2_FEATURE_INCOMPAT_REVOKE () {0x1;}' unless defined(&JBD2_FEATURE_INCOMPAT_REVOKE);
    eval 'sub JBD2_FEATURE_INCOMPAT_64BIT () {0x2;}' unless defined(&JBD2_FEATURE_INCOMPAT_64BIT);
    eval 'sub JBD2_FEATURE_INCOMPAT_ASYNC_COMMIT () {0x4;}' unless defined(&JBD2_FEATURE_INCOMPAT_ASYNC_COMMIT);
    eval 'sub JBD2_KNOWN_COMPAT_FEATURES () { &JBD2_FEATURE_COMPAT_CHECKSUM;}' unless defined(&JBD2_KNOWN_COMPAT_FEATURES);
    eval 'sub JBD2_KNOWN_ROCOMPAT_FEATURES () {0;}' unless defined(&JBD2_KNOWN_ROCOMPAT_FEATURES);
    eval 'sub JBD2_KNOWN_INCOMPAT_FEATURES () {( &JBD2_FEATURE_INCOMPAT_REVOKE |  &JBD2_FEATURE_INCOMPAT_64BIT |  &JBD2_FEATURE_INCOMPAT_ASYNC_COMMIT);}' unless defined(&JBD2_KNOWN_INCOMPAT_FEATURES);
    if(defined(&__KERNEL__)) {
	require 'linux/fs.ph';
	require 'linux/sched.ph';
	eval 'sub J_ASSERT {
	    my($assert) = @_;
    	    eval q( &BUG_ON(!($assert)));
	}' unless defined(&J_ASSERT);
	if(defined( &CONFIG_BUFFER_DEBUG)) {
	    eval 'sub J_ASSERT_BH {
	        my($bh, $expr) = @_;
    		eval q( &do {  &if (!($expr))  &buffer_assertion_failure($bh);  &J_ASSERT($expr); }  &while (0));
	    }' unless defined(&J_ASSERT_BH);
	    eval 'sub J_ASSERT_JH {
	        my($jh, $expr) = @_;
    		eval q( &J_ASSERT_BH( &jh2bh($jh), $expr));
	    }' unless defined(&J_ASSERT_JH);
	} else {
	    eval 'sub J_ASSERT_BH {
	        my($bh, $expr) = @_;
    		eval q( &J_ASSERT($expr));
	    }' unless defined(&J_ASSERT_BH);
	    eval 'sub J_ASSERT_JH {
	        my($jh, $expr) = @_;
    		eval q( &J_ASSERT($expr));
	    }' unless defined(&J_ASSERT_JH);
	}
	if(defined( &JBD2_PARANOID_IOFAIL)) {
	    eval 'sub J_EXPECT () {( &expr,  &why...)  &J_ASSERT( &expr);}' unless defined(&J_EXPECT);
	    eval 'sub J_EXPECT_BH () {( &bh,  &expr,  &why...)  &J_ASSERT_BH( &bh,  &expr);}' unless defined(&J_EXPECT_BH);
	    eval 'sub J_EXPECT_JH () {( &jh,  &expr,  &why...)  &J_ASSERT_JH( &jh,  &expr);}' unless defined(&J_EXPECT_JH);
	} else {
	    eval 'sub __journal_expect () {( &expr,  &why...) ({ \'int\'  &val = ( &expr);  &if (! &val) {  &printk( &KERN_ERR "EXT3-fs unexpected failure: %s;\\n",  &expr);  &printk( &KERN_ERR  &why "\\n"); }  &val; });}' unless defined(&__journal_expect);
	    eval 'sub J_EXPECT () {( &expr,  &why...)  &__journal_expect( &expr,   &why);}' unless defined(&J_EXPECT);
	    eval 'sub J_EXPECT_BH () {( &bh,  &expr,  &why...)  &__journal_expect( &expr,   &why);}' unless defined(&J_EXPECT_BH);
	    eval 'sub J_EXPECT_JH () {( &jh,  &expr,  &why...)  &__journal_expect( &expr,   &why);}' unless defined(&J_EXPECT_JH);
	}
	eval("sub BH_JBD () { BH_PrivateStart; }") unless defined(&BH_JBD);
	eval("sub BH_JWrite () { 1; }") unless defined(&BH_JWrite);
	eval("sub BH_Freed () { 2; }") unless defined(&BH_Freed);
	eval("sub BH_Revoked () { 3; }") unless defined(&BH_Revoked);
	eval("sub BH_RevokeValid () { 4; }") unless defined(&BH_RevokeValid);
	eval("sub BH_JBDDirty () { 5; }") unless defined(&BH_JBDDirty);
	eval("sub BH_State () { 6; }") unless defined(&BH_State);
	eval("sub BH_JournalHead () { 7; }") unless defined(&BH_JournalHead);
	eval("sub BH_Unshadow () { 8; }") unless defined(&BH_Unshadow);
	eval 'sub buffer_head {
	    eval q(* &jh2bh(\'struct journal_head\' * &jh) {  ($jh->{b_bh}); });
	}' unless defined(&buffer_head);
	eval 'sub journal_head {
	    eval q(* &bh2jh(\'struct buffer_head\' * &bh) {  ($bh->{b_private}); });
	}' unless defined(&journal_head);
	eval 'sub jbd_lock_bh_state {
	    my($bh) = @_;
    	    eval q({  &bit_spin_lock( &BH_State,  ($bh->{b_state})); });
	}' unless defined(&jbd_lock_bh_state);
	eval 'sub jbd_trylock_bh_state {
	    my($bh) = @_;
    	    eval q({  &bit_spin_trylock( &BH_State,  ($bh->{b_state})); });
	}' unless defined(&jbd_trylock_bh_state);
	eval 'sub jbd_is_locked_bh_state {
	    my($bh) = @_;
    	    eval q({  &bit_spin_is_locked( &BH_State,  ($bh->{b_state})); });
	}' unless defined(&jbd_is_locked_bh_state);
	eval 'sub jbd_unlock_bh_state {
	    my($bh) = @_;
    	    eval q({  &bit_spin_unlock( &BH_State,  ($bh->{b_state})); });
	}' unless defined(&jbd_unlock_bh_state);
	eval 'sub jbd_lock_bh_journal_head {
	    my($bh) = @_;
    	    eval q({  &bit_spin_lock( &BH_JournalHead,  ($bh->{b_state})); });
	}' unless defined(&jbd_lock_bh_journal_head);
	eval 'sub jbd_unlock_bh_journal_head {
	    my($bh) = @_;
    	    eval q({  &bit_spin_unlock( &BH_JournalHead,  ($bh->{b_state})); });
	}' unless defined(&jbd_unlock_bh_journal_head);
	eval 'sub __JI_COMMIT_RUNNING () {0;}' unless defined(&__JI_COMMIT_RUNNING);
	eval 'sub JI_COMMIT_RUNNING () {(1<<  &__JI_COMMIT_RUNNING);}' unless defined(&JI_COMMIT_RUNNING);
	if(defined(&CONFIG_DEBUG_LOCK_ALLOC)) {
	}
	eval("sub T_RUNNING () { 0; }") unless defined(&T_RUNNING);
	eval("sub T_LOCKED () { 1; }") unless defined(&T_LOCKED);
	eval("sub T_RUNDOWN () { 2; }") unless defined(&T_RUNDOWN);
	eval("sub T_FLUSH () { 3; }") unless defined(&T_FLUSH);
	eval("sub T_COMMIT () { 4; }") unless defined(&T_COMMIT);
	eval("sub T_FINISHED () { 5; }") unless defined(&T_FINISHED);
	eval 'sub JBD2_STATS_RUN () {1;}' unless defined(&JBD2_STATS_RUN);
	eval 'sub JBD2_STATS_CHECKPOINT () {2;}' unless defined(&JBD2_STATS_CHECKPOINT);
	eval 'sub jbd2_time_diff {
	    my($start,$end) = @_;
    	    eval q({  &if ($end >= $start) $end - $start; $end + ( &MAX_JIFFY_OFFSET - $start); });
	}' unless defined(&jbd2_time_diff);
	eval 'sub JBD2_UNMOUNT () {0x1;}' unless defined(&JBD2_UNMOUNT);
	eval 'sub JBD2_ABORT () {0x2;}' unless defined(&JBD2_ABORT);
	eval 'sub JBD2_ACK_ERR () {0x4;}' unless defined(&JBD2_ACK_ERR);
	eval 'sub JBD2_FLUSHED () {0x8;}' unless defined(&JBD2_FLUSHED);
	eval 'sub JBD2_LOADED () {0x10;}' unless defined(&JBD2_LOADED);
	eval 'sub JBD2_BARRIER () {0x20;}' unless defined(&JBD2_BARRIER);
	eval 'sub handle_t {
	    eval q(* &jbd2_alloc_handle( &gfp_t  &gfp_flags) {  &kmem_cache_alloc( &jbd2_handle_cache,  &gfp_flags); });
	}' unless defined(&handle_t);
	eval 'sub jbd2_free_handle {
	    my($handle) = @_;
    	    eval q({  &kmem_cache_free( &jbd2_handle_cache, $handle); });
	}' unless defined(&jbd2_free_handle);
	eval 'sub JOURNAL_REVOKE_DEFAULT_HASH () {256;}' unless defined(&JOURNAL_REVOKE_DEFAULT_HASH);
	eval 'sub jbd_ENOSYS () {
	    eval q( &do {  &printk ( &KERN_ERR \\"JBD unimplemented function %s\\\\n\\",  &__FUNCTION__);  ($current->{state}) =  &TASK_UNINTERRUPTIBLE;  &schedule(); }  &while (1));
	}' unless defined(&jbd_ENOSYS);
	eval 'sub is_handle_aborted {
	    my($handle) = @_;
    	    eval q({  &if ( ($handle->{h_aborted})) 1;  &is_journal_aborted( ($handle->{h_transaction}->{t_journal})); });
	}' unless defined(&is_handle_aborted);
	eval 'sub jbd2_journal_abort_handle {
	    my($handle) = @_;
    	    eval q({  ($handle->{h_aborted}) = 1; });
	}' unless defined(&jbd2_journal_abort_handle);
    }
    eval 'sub tid_geq {
        my($x,$y) = @_;
	    eval q({ \'int\'  &difference = ($x - $y); ( &difference >= 0); });
    }' unless defined(&tid_geq);
    eval 'sub BJ_None () {0;}' unless defined(&BJ_None);
    eval 'sub BJ_Metadata () {1;}' unless defined(&BJ_Metadata);
    eval 'sub BJ_Forget () {2;}' unless defined(&BJ_Forget);
    eval 'sub BJ_IO () {3;}' unless defined(&BJ_IO);
    eval 'sub BJ_Shadow () {4;}' unless defined(&BJ_Shadow);
    eval 'sub BJ_LogCtl () {5;}' unless defined(&BJ_LogCtl);
    eval 'sub BJ_Reserved () {6;}' unless defined(&BJ_Reserved);
    eval 'sub BJ_Types () {7;}' unless defined(&BJ_Types);
    if(defined(&__KERNEL__)) {
	eval 'sub buffer_trace_init {
	    my($bh) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&buffer_trace_init);
	eval 'sub print_buffer_fields {
	    my($bh) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&print_buffer_fields);
	eval 'sub print_buffer_trace {
	    my($bh) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&print_buffer_trace);
	eval 'sub BUFFER_TRACE {
	    my($bh, $info) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&BUFFER_TRACE);
	eval 'sub BUFFER_TRACE2 {
	    my($bh, $bh2, $info) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&BUFFER_TRACE2);
	eval 'sub JBUFFER_TRACE {
	    my($jh, $info) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&JBUFFER_TRACE);
    }
}
1;
