require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_JIFFIES_H)) {
    eval 'sub _LINUX_JIFFIES_H () {1;}' unless defined(&_LINUX_JIFFIES_H);
    require 'linux/math64.ph';
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/time.ph';
    require 'linux/timex.ph';
    require 'asm/param.ph';
    if((defined(&HZ) ? &HZ : undef) >= 12 && (defined(&HZ) ? &HZ : undef) < 24) {
	eval 'sub SHIFT_HZ () {4;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 24 && (defined(&HZ) ? &HZ : undef) < 48) {
	eval 'sub SHIFT_HZ () {5;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 48 && (defined(&HZ) ? &HZ : undef) < 96) {
	eval 'sub SHIFT_HZ () {6;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 96 && (defined(&HZ) ? &HZ : undef) < 192) {
	eval 'sub SHIFT_HZ () {7;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 192 && (defined(&HZ) ? &HZ : undef) < 384) {
	eval 'sub SHIFT_HZ () {8;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 384 && (defined(&HZ) ? &HZ : undef) < 768) {
	eval 'sub SHIFT_HZ () {9;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 768 && (defined(&HZ) ? &HZ : undef) < 1536) {
	eval 'sub SHIFT_HZ () {10;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 1536 && (defined(&HZ) ? &HZ : undef) < 3072) {
	eval 'sub SHIFT_HZ () {11;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 3072 && (defined(&HZ) ? &HZ : undef) < 6144) {
	eval 'sub SHIFT_HZ () {12;}' unless defined(&SHIFT_HZ);
    }
 elsif((defined(&HZ) ? &HZ : undef) >= 6144 && (defined(&HZ) ? &HZ : undef) < 12288) {
	eval 'sub SHIFT_HZ () {13;}' unless defined(&SHIFT_HZ);
    } else {
	die("Invalid\ value\ of\ HZ\.");
    }
    eval 'sub LATCH () {(( &CLOCK_TICK_RATE +  &HZ/2) /  &HZ);}' unless defined(&LATCH);
    eval 'sub SH_DIV {
        my($NOM,$DEN,$LSH) = @_;
	    eval q(( ((($NOM) / ($DEN)) << ($LSH)) + (((($NOM) % ($DEN)) << ($LSH)) + ($DEN) / 2) / ($DEN)));
    }' unless defined(&SH_DIV);
    eval 'sub ACTHZ () {( &SH_DIV ( &CLOCK_TICK_RATE,  &LATCH, 8));}' unless defined(&ACTHZ);
    eval 'sub TICK_NSEC () {( &SH_DIV (1000000 * 1000,  &ACTHZ, 8));}' unless defined(&TICK_NSEC);
    eval 'sub TICK_USEC () {((1000000 +  &USER_HZ/2) /  &USER_HZ);}' unless defined(&TICK_USEC);
    eval 'sub TICK_USEC_TO_NSEC {
        my($TUSEC) = @_;
	    eval q(( &SH_DIV ($TUSEC *  &USER_HZ * 1000,  &ACTHZ, 8)));
    }' unless defined(&TICK_USEC_TO_NSEC);
    eval 'sub __jiffy_data () { &__attribute__(( &section(".data")));}' unless defined(&__jiffy_data);
    if(((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) < 64)) {
    } else {
	eval 'sub get_jiffies_64 {
	    my($void) = @_;
    	    eval q({ ( &u64) &jiffies; });
	}' unless defined(&get_jiffies_64);
    }
    eval 'sub time_after {
        my($a,$b) = @_;
	    eval q(( &typecheck(\'unsigned long\', $a)  &&  &typecheck(\'unsigned long\', $b)  && ( - ($a) < 0)));
    }' unless defined(&time_after);
    eval 'sub time_before {
        my($a,$b) = @_;
	    eval q( &time_after($b,$a));
    }' unless defined(&time_before);
    eval 'sub time_after_eq {
        my($a,$b) = @_;
	    eval q(( &typecheck(\'unsigned long\', $a)  &&  &typecheck(\'unsigned long\', $b)  && ( - ($b) >= 0)));
    }' unless defined(&time_after_eq);
    eval 'sub time_before_eq {
        my($a,$b) = @_;
	    eval q( &time_after_eq($b,$a));
    }' unless defined(&time_before_eq);
    eval 'sub time_in_range {
        my($a,$b,$c) = @_;
	    eval q(( &time_after_eq($a,$b)  &&  &time_before_eq($a,$c)));
    }' unless defined(&time_in_range);
    eval 'sub time_after64 {
        my($a,$b) = @_;
	    eval q(( &typecheck( &__u64, $a)  &&  &typecheck( &__u64, $b)  && (( &__s64)($b) - ( &__s64)($a) < 0)));
    }' unless defined(&time_after64);
    eval 'sub time_before64 {
        my($a,$b) = @_;
	    eval q( &time_after64($b,$a));
    }' unless defined(&time_before64);
    eval 'sub time_after_eq64 {
        my($a,$b) = @_;
	    eval q(( &typecheck( &__u64, $a)  &&  &typecheck( &__u64, $b)  && (( &__s64)($a) - ( &__s64)($b) >= 0)));
    }' unless defined(&time_after_eq64);
    eval 'sub time_before_eq64 {
        my($a,$b) = @_;
	    eval q( &time_after_eq64($b,$a));
    }' unless defined(&time_before_eq64);
    eval 'sub time_is_before_jiffies {
        my($a) = @_;
	    eval q( &time_after( &jiffies, $a));
    }' unless defined(&time_is_before_jiffies);
    eval 'sub time_is_after_jiffies {
        my($a) = @_;
	    eval q( &time_before( &jiffies, $a));
    }' unless defined(&time_is_after_jiffies);
    eval 'sub time_is_before_eq_jiffies {
        my($a) = @_;
	    eval q( &time_after_eq( &jiffies, $a));
    }' unless defined(&time_is_before_eq_jiffies);
    eval 'sub time_is_after_eq_jiffies {
        my($a) = @_;
	    eval q( &time_before_eq( &jiffies, $a));
    }' unless defined(&time_is_after_eq_jiffies);
    eval 'sub INITIAL_JIFFIES () {( (-300* &HZ));}' unless defined(&INITIAL_JIFFIES);
    eval 'sub MAX_JIFFY_OFFSET () {(( &LONG_MAX >> 1)-1);}' unless defined(&MAX_JIFFY_OFFSET);
    eval 'sub SEC_JIFFIE_SC () {(31-  &SHIFT_HZ);}' unless defined(&SEC_JIFFIE_SC);
    if(!(((((defined(&NSEC_PER_SEC) ? &NSEC_PER_SEC : undef) << 2) / (defined(&TICK_NSEC) ? &TICK_NSEC : undef)) << ((defined(&SEC_JIFFIE_SC) ? &SEC_JIFFIE_SC : undef) - 2)) & 0x80000000)) {
	undef(&SEC_JIFFIE_SC) if defined(&SEC_JIFFIE_SC);
	eval 'sub SEC_JIFFIE_SC () {(32-  &SHIFT_HZ);}' unless defined(&SEC_JIFFIE_SC);
    }
    eval 'sub NSEC_JIFFIE_SC () {( &SEC_JIFFIE_SC + 29);}' unless defined(&NSEC_JIFFIE_SC);
    eval 'sub USEC_JIFFIE_SC () {( &SEC_JIFFIE_SC + 19);}' unless defined(&USEC_JIFFIE_SC);
    eval 'sub SEC_CONVERSION () {((((( &u64) &NSEC_PER_SEC <<  &SEC_JIFFIE_SC) +  &TICK_NSEC -1) / ( &u64) &TICK_NSEC));}' unless defined(&SEC_CONVERSION);
    eval 'sub NSEC_CONVERSION () {((((( &u64)1<<  &NSEC_JIFFIE_SC) +  &TICK_NSEC -1) / ( &u64) &TICK_NSEC));}' unless defined(&NSEC_CONVERSION);
    eval 'sub USEC_CONVERSION () {((((( &u64) &NSEC_PER_USEC <<  &USEC_JIFFIE_SC) +  &TICK_NSEC -1) / ( &u64) &TICK_NSEC));}' unless defined(&USEC_CONVERSION);
    eval 'sub USEC_ROUND () {( &u64)((( &u64)1<<  &USEC_JIFFIE_SC) - 1);}' unless defined(&USEC_ROUND);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) < 64) {
	eval 'sub MAX_SEC_IN_JIFFIES () {(( &u64)(( &u64) &MAX_JIFFY_OFFSET *  &TICK_NSEC) /  &NSEC_PER_SEC);}' unless defined(&MAX_SEC_IN_JIFFIES);
    } else {
	eval 'sub MAX_SEC_IN_JIFFIES () {( &SH_DIV(( &MAX_JIFFY_OFFSET >>  &SEC_JIFFIE_SC) *  &TICK_NSEC,  &NSEC_PER_SEC, 1) - 1);}' unless defined(&MAX_SEC_IN_JIFFIES);
    }
    eval 'sub TIMESTAMP_SIZE () {30;}' unless defined(&TIMESTAMP_SIZE);
}
1;
