require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_KALLSYMS_H)) {
    eval 'sub _LINUX_KALLSYMS_H () {1;}' unless defined(&_LINUX_KALLSYMS_H);
    require 'linux/errno.ph';
    require 'linux/kernel.ph';
    require 'linux/stddef.ph';
    eval 'sub KSYM_NAME_LEN () {128;}' unless defined(&KSYM_NAME_LEN);
    eval 'sub KSYM_SYMBOL_LEN () {($sizeof{"%s+%#lx/%#lx [%s]"} + ( &KSYM_NAME_LEN - 1) + 2*( &BITS_PER_LONG*3/10) + ( &MODULE_NAME_LEN - 1) + 1);}' unless defined(&KSYM_SYMBOL_LEN);
    if(defined(&CONFIG_KALLSYMS)) {
    } else {
	eval 'sub kallsyms_lookup_name {
	    my($name) = @_;
    	    eval q({ 0; });
	}' unless defined(&kallsyms_lookup_name);
	eval 'sub kallsyms_lookup_size_offset {
	    my($addr,$symbolsize,$offset) = @_;
    	    eval q({ 0; });
	}' unless defined(&kallsyms_lookup_size_offset);
	eval 'sub char {
	    eval q(* &kallsyms_lookup(my $addr, my $long * &symbolsize, my $long * &offset, \'char\' ** &modname, \'char\' * &namebuf) {  &NULL; });
	}' unless defined(&char);
	eval 'sub sprint_symbol {
	    my($buffer,$addr) = @_;
    	    eval q({ *$buffer = ord(\'\\\\0\'); 0; });
	}' unless defined(&sprint_symbol);
	eval 'sub lookup_symbol_name {
	    my($addr,$symname) = @_;
    	    eval q({ - &ERANGE; });
	}' unless defined(&lookup_symbol_name);
	eval 'sub lookup_symbol_attrs {
	    my($addr,$size,$offset,$modname,$name) = @_;
    	    eval q({ - &ERANGE; });
	}' unless defined(&lookup_symbol_attrs);
	eval 'sub __print_symbol {
	    my($fmt, $addr) = @_;
    	    eval q();
	}' unless defined(&__print_symbol);
    }
    eval 'sub __check_printsym_format {
        my($fmt) = @_;
	    eval q({ });
    }' unless defined(&__check_printsym_format);
    eval 'sub print_symbol {
        my($fmt,$addr) = @_;
	    eval q({  &__check_printsym_format($fmt, \\"\\");  &__print_symbol($fmt,  &__builtin_extract_return_addr(( &void *)$addr)); });
    }' unless defined(&print_symbol);
    if(defined( &CONFIG_IA64) || defined( &CONFIG_PPC64)) {
    }
    eval 'sub print_ip_sym {
        my($ip) = @_;
	    eval q({  &printk(\\"[<%p>] %pS\\\\n\\", ( &void *) $ip, ( &void *) $ip); });
    }' unless defined(&print_ip_sym);
}
1;
