require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_KERNEL_H)) {
    eval 'sub _LINUX_KERNEL_H () {1;}' unless defined(&_LINUX_KERNEL_H);
    if(defined(&__KERNEL__)) {
	require 'stdarg.ph';
	require 'linux/linkage.ph';
	require 'linux/stddef.ph';
	require 'linux/types.ph';
	require 'linux/compiler.ph';
	require 'linux/bitops.ph';
	require 'linux/log2.ph';
	require 'linux/typecheck.ph';
	require 'linux/ratelimit.ph';
	require 'asm/byteorder.ph';
	require 'asm/bug.ph';
	eval 'sub USHORT_MAX () {(( &u16)(~0));}' unless defined(&USHORT_MAX);
	eval 'sub SHORT_MAX () {(( &s16)( &USHORT_MAX>>1));}' unless defined(&SHORT_MAX);
	eval 'sub SHORT_MIN () {(- &SHORT_MAX - 1);}' unless defined(&SHORT_MIN);
	eval 'sub INT_MAX () {((~0>>1));}' unless defined(&INT_MAX);
	eval 'sub INT_MIN () {(- &INT_MAX - 1);}' unless defined(&INT_MIN);
	eval 'sub UINT_MAX () {(~0);}' unless defined(&UINT_MAX);
	eval 'sub LONG_MAX () {((~0>>1));}' unless defined(&LONG_MAX);
	eval 'sub LONG_MIN () {(- &LONG_MAX - 1);}' unless defined(&LONG_MIN);
	eval 'sub ULONG_MAX () {(~0);}' unless defined(&ULONG_MAX);
	eval 'sub LLONG_MAX () {((~0>>1));}' unless defined(&LLONG_MAX);
	eval 'sub LLONG_MIN () {(- &LLONG_MAX - 1);}' unless defined(&LLONG_MIN);
	eval 'sub ULLONG_MAX () {(~0);}' unless defined(&ULLONG_MAX);
	eval 'sub STACK_MAGIC () {0xdeadbeef;}' unless defined(&STACK_MAGIC);
	eval 'sub ALIGN {
	    my($x,$a) = @_;
    	    eval q( &__ALIGN_MASK($x,( &typeof($x))($a)-1));
	}' unless defined(&ALIGN);
	eval 'sub __ALIGN_MASK {
	    my($x,$mask) = @_;
    	    eval q(((($x)+($mask))&~($mask)));
	}' unless defined(&__ALIGN_MASK);
	eval 'sub PTR_ALIGN {
	    my($p, $a) = @_;
    	    eval q((( &typeof) &ALIGN(($p), ($a))));
	}' unless defined(&PTR_ALIGN);
	eval 'sub IS_ALIGNED {
	    my($x, $a) = @_;
    	    eval q(((($x) & (( &typeof($x))($a) - 1)) == 0));
	}' unless defined(&IS_ALIGNED);
	eval 'sub ARRAY_SIZE {
	    my($arr) = @_;
    	    eval q(($sizeof{$arr} / $sizeof{($arr)[0]} +  &__must_be_array($arr)));
	}' unless defined(&ARRAY_SIZE);
	eval 'sub FIELD_SIZEOF {
	    my($t, $f) = @_;
    	    eval q(($sizeof{(($t)0)->$f}));
	}' unless defined(&FIELD_SIZEOF);
	eval 'sub DIV_ROUND_UP {
	    my($n,$d) = @_;
    	    eval q(((($n) + ($d) - 1) / ($d)));
	}' unless defined(&DIV_ROUND_UP);
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q((((($x) + (($y) - 1)) / ($y)) * ($y)));
	}' unless defined(&roundup);
	eval 'sub _RET_IP_ () { &__builtin_return_address(0);}' unless defined(&_RET_IP_);
	eval 'sub _THIS_IP_ () {({  &__label__  &__here;  &__here:  && &__here; });}' unless defined(&_THIS_IP_);
	if(defined(&CONFIG_LBD)) {
	    require 'asm/div64.ph';
	    eval 'sub sector_div {
	        my($a, $b) = @_;
    		eval q( &do_div($a, $b));
	    }' unless defined(&sector_div);
	} else {
	    eval 'sub sector_div {
	        my($n, $b) = @_;
    		eval q(( { \'int\'  &_res;  &_res = ($n) % ($b); ($n) /= ($b);  &_res; } ));
	    }' unless defined(&sector_div);
	}
	eval 'sub upper_32_bits {
	    my($n) = @_;
    	    eval q((( &u32)((($n) >> 16) >> 16)));
	}' unless defined(&upper_32_bits);
	eval 'sub lower_32_bits {
	    my($n) = @_;
    	    eval q((( &u32)($n)));
	}' unless defined(&lower_32_bits);
	eval 'sub KERN_EMERG () {"<0>";}' unless defined(&KERN_EMERG);
	eval 'sub KERN_ALERT () {"<1>";}' unless defined(&KERN_ALERT);
	eval 'sub KERN_CRIT () {"<2>";}' unless defined(&KERN_CRIT);
	eval 'sub KERN_ERR () {"<3>";}' unless defined(&KERN_ERR);
	eval 'sub KERN_WARNING () {"<4>";}' unless defined(&KERN_WARNING);
	eval 'sub KERN_NOTICE () {"<5>";}' unless defined(&KERN_NOTICE);
	eval 'sub KERN_INFO () {"<6>";}' unless defined(&KERN_INFO);
	eval 'sub KERN_DEBUG () {"<7>";}' unless defined(&KERN_DEBUG);
	eval 'sub KERN_CONT () {"";}' unless defined(&KERN_CONT);
	eval 'sub console_loglevel () {( $console_printk[0]);}' unless defined(&console_loglevel);
	eval 'sub default_message_loglevel () {( $console_printk[1]);}' unless defined(&default_message_loglevel);
	eval 'sub minimum_console_loglevel () {( $console_printk[2]);}' unless defined(&minimum_console_loglevel);
	eval 'sub default_console_loglevel () {( $console_printk[3]);}' unless defined(&default_console_loglevel);
	if(defined(&CONFIG_PREEMPT_VOLUNTARY)) {
	    eval 'sub might_resched () {
	        eval q( &_cond_resched());
	    }' unless defined(&might_resched);
	} else {
	    eval 'sub might_resched () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&might_resched);
	}
	if(defined(&CONFIG_DEBUG_SPINLOCK_SLEEP)) {
	    eval 'sub might_sleep () {
	        eval q( &do {  &__might_sleep( &__FILE__,  &__LINE__);  &might_resched(); }  &while (0));
	    }' unless defined(&might_sleep);
	} else {
	    eval 'sub might_sleep () {
	        eval q( &do {  &might_resched(); }  &while (0));
	    }' unless defined(&might_sleep);
	}
	eval 'sub might_sleep_if {
	    my($cond) = @_;
    	    eval q( &do {  &if ($cond)  &might_sleep(); }  &while (0));
	}' unless defined(&might_sleep_if);
	eval 'sub abs {
	    my($x) = @_;
    	    eval q(({ \'int\'  &__x = ($x); ( &__x < 0) ? - &__x :  &__x; }));
	}' unless defined(&abs);
	if(defined(&CONFIG_PRINTK)) {
	} else {
	    eval 'sub console_silent {
	        my($void) = @_;
    		eval q({  &console_loglevel = 0; });
	    }' unless defined(&console_silent);
	    eval 'sub console_verbose {
	        my($void) = @_;
    		eval q({  &if ( &console_loglevel)  &console_loglevel = 15; });
	    }' unless defined(&console_verbose);
	    eval 'sub TAINT_PROPRIETARY_MODULE () {(1<<0);}' unless defined(&TAINT_PROPRIETARY_MODULE);
	    eval 'sub TAINT_FORCED_MODULE () {(1<<1);}' unless defined(&TAINT_FORCED_MODULE);
	    eval 'sub TAINT_UNSAFE_SMP () {(1<<2);}' unless defined(&TAINT_UNSAFE_SMP);
	    eval 'sub TAINT_FORCED_RMMOD () {(1<<3);}' unless defined(&TAINT_FORCED_RMMOD);
	    eval 'sub TAINT_MACHINE_CHECK () {(1<<4);}' unless defined(&TAINT_MACHINE_CHECK);
	    eval 'sub TAINT_BAD_PAGE () {(1<<5);}' unless defined(&TAINT_BAD_PAGE);
	    eval 'sub TAINT_USER () {(1<<6);}' unless defined(&TAINT_USER);
	    eval 'sub TAINT_DIE () {(1<<7);}' unless defined(&TAINT_DIE);
	    eval 'sub TAINT_OVERRIDDEN_ACPI_TABLE () {(1<<8);}' unless defined(&TAINT_OVERRIDDEN_ACPI_TABLE);
	    eval 'sub TAINT_WARN () {(1<<9);}' unless defined(&TAINT_WARN);
	    eval("sub DUMP_PREFIX_NONE () { 0; }") unless defined(&DUMP_PREFIX_NONE);
	    eval("sub DUMP_PREFIX_ADDRESS () { 1; }") unless defined(&DUMP_PREFIX_ADDRESS);
	    eval("sub DUMP_PREFIX_OFFSET () { 2; }") unless defined(&DUMP_PREFIX_OFFSET);
	    eval 'sub hex_asc_lo {
	        my($x) = @_;
    		eval q( $hex_asc[(($x) & 0xf)]);
	    }' unless defined(&hex_asc_lo);
	    eval 'sub hex_asc_hi {
	        my($x) = @_;
    		eval q( $hex_asc[(($x) & 0xf0) >> 4]);
	    }' unless defined(&hex_asc_hi);
	    eval 'sub char {
	        eval q(* &pack_hex_byte(\'char\' * &buf,  &u8  &byte) { * &buf++ =  &hex_asc_hi( &byte); * &buf++ =  &hex_asc_lo( &byte);  &buf; });
	    }' unless defined(&char);
	    eval 'sub pr_emerg () {( &fmt,  &arg...)  &printk( &KERN_EMERG  &fmt,  &arg);}' unless defined(&pr_emerg);
	    eval 'sub pr_alert () {( &fmt,  &arg...)  &printk( &KERN_ALERT  &fmt,  &arg);}' unless defined(&pr_alert);
	    eval 'sub pr_crit () {( &fmt,  &arg...)  &printk( &KERN_CRIT  &fmt,  &arg);}' unless defined(&pr_crit);
	    eval 'sub pr_err () {( &fmt,  &arg...)  &printk( &KERN_ERR  &fmt,  &arg);}' unless defined(&pr_err);
	    eval 'sub pr_warning () {( &fmt,  &arg...)  &printk( &KERN_WARNING  &fmt,  &arg);}' unless defined(&pr_warning);
	    eval 'sub pr_notice () {( &fmt,  &arg...)  &printk( &KERN_NOTICE  &fmt,  &arg);}' unless defined(&pr_notice);
	    eval 'sub pr_info () {( &fmt,  &arg...)  &printk( &KERN_INFO  &fmt,  &arg);}' unless defined(&pr_info);
	    if(defined(&DEBUG)) {
		eval 'sub pr_debug () {( &fmt,  &arg...)  &printk( &KERN_DEBUG  &fmt,  &arg);}' unless defined(&pr_debug);
	    } else {
		eval 'sub pr_debug () {( &fmt,  &arg...) ({  &if (0)  &printk( &KERN_DEBUG  &fmt,  &arg); 0; });}' unless defined(&pr_debug);
	    }
	    eval 'sub NIPQUAD {
	        my($addr) = @_;
    		eval q(($addr)[0], ($addr)[1], ($addr)[2], ($addr)[3]);
	    }' unless defined(&NIPQUAD);
	    eval 'sub NIPQUAD_FMT () {"%u.%u.%u.%u";}' unless defined(&NIPQUAD_FMT);
	    eval 'sub NIP6 {
	        my($addr) = @_;
    		eval q( &ntohs(($addr). $s6_addr16[0]),  &ntohs(($addr). $s6_addr16[1]),  &ntohs(($addr). $s6_addr16[2]),  &ntohs(($addr). $s6_addr16[3]),  &ntohs(($addr). $s6_addr16[4]),  &ntohs(($addr). $s6_addr16[5]),  &ntohs(($addr). $s6_addr16[6]),  &ntohs(($addr). $s6_addr16[7]));
	    }' unless defined(&NIP6);
	    eval 'sub NIP6_FMT () {"%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x";}' unless defined(&NIP6_FMT);
	    eval 'sub NIP6_SEQFMT () {"%04x%04x%04x%04x%04x%04x%04x%04x";}' unless defined(&NIP6_SEQFMT);
	    if(defined( &__LITTLE_ENDIAN)) {
		eval 'sub HIPQUAD {
		    my($addr) = @_;
    		    eval q(($addr)[3], ($addr)[2], ($addr)[1], ($addr)[0]);
		}' unless defined(&HIPQUAD);
	    }
 elsif(defined( &__BIG_ENDIAN)) {
		eval 'sub HIPQUAD () { &NIPQUAD;}' unless defined(&HIPQUAD);
	    } else {
		die("Please fix asm/byteorder.h");
	    }
	    eval 'sub min {
	        my($x, $y) = @_;
    		eval q(({  &typeof($x)  &_min1 = ($x);  &typeof($y)  &_min2 = ($y); ( &void) (& &_min1 == & &_min2);  &_min1 <  &_min2 ?  &_min1 :  &_min2; }));
	    }' unless defined(&min);
	    eval 'sub max {
	        my($x, $y) = @_;
    		eval q(({  &typeof($x)  &_max1 = ($x);  &typeof($y)  &_max2 = ($y); ( &void) (& &_max1 == & &_max2);  &_max1 >  &_max2 ?  &_max1 :  &_max2; }));
	    }' unless defined(&max);
	    eval 'sub clamp {
	        my($val, $min, $max) = @_;
    		eval q(({  &typeof($val)  &__val = ($val);  &typeof($min)  &__min = ($min);  &typeof($max)  &__max = ($max); ( &void) (& &__val == & &__min); ( &void) (& &__val == & &__max);  &__val =  &__val <  &__min ?  &__min:  &__val;  &__val >  &__max ?  &__max:  &__val; }));
	    }' unless defined(&clamp);
	    eval 'sub min_t {
	        my($type, $x, $y) = @_;
    		eval q(({ $type  &__min1 = ($x); $type  &__min2 = ($y);  &__min1 <  &__min2 ?  &__min1:  &__min2; }));
	    }' unless defined(&min_t);
	    eval 'sub max_t {
	        my($type, $x, $y) = @_;
    		eval q(({ $type  &__max1 = ($x); $type  &__max2 = ($y);  &__max1 >  &__max2 ?  &__max1:  &__max2; }));
	    }' unless defined(&max_t);
	    eval 'sub clamp_t {
	        my($type, $val, $min, $max) = @_;
    		eval q(({ $type  &__val = ($val); $type  &__min = ($min); $type  &__max = ($max);  &__val =  &__val <  &__min ?  &__min:  &__val;  &__val >  &__max ?  &__max:  &__val; }));
	    }' unless defined(&clamp_t);
	    eval 'sub clamp_val {
	        my($val, $min, $max) = @_;
    		eval q(({  &typeof($val)  &__val = ($val);  &typeof($val)  &__min = ($min);  &typeof($val)  &__max = ($max);  &__val =  &__val <  &__min ?  &__min:  &__val;  &__val >  &__max ?  &__max:  &__val; }));
	    }' unless defined(&clamp_val);
	    eval 'sub container_of {
	        my($ptr, $type, $member) = @_;
    		eval q(({  &const  &typeof( (($type *)0)->$member ) * &__mptr = ($ptr); ($type *)(  &__mptr -  &offsetof($type,$member) );}));
	    }' unless defined(&container_of);
	}
	eval 'sub SI_LOAD_SHIFT () {16;}' unless defined(&SI_LOAD_SHIFT);
	eval 'sub BUILD_BUG_ON {
	    my($condition) = @_;
    	    eval q((( &void)$sizeof{\'char\'[1- 2!!($condition)]}));
	}' unless defined(&BUILD_BUG_ON);
	eval 'sub BUILD_BUG_ON_ZERO {
	    my($e) = @_;
    	    eval q(($sizeof{\'char\'[1- 2!!($e)]} - 1));
	}' unless defined(&BUILD_BUG_ON_ZERO);
	eval 'sub __FUNCTION__ () {( &__func__);}' unless defined(&__FUNCTION__);
	if(defined(&CONFIG_NUMA)) {
	    eval 'sub NUMA_BUILD () {1;}' unless defined(&NUMA_BUILD);
	} else {
	    eval 'sub NUMA_BUILD () {0;}' unless defined(&NUMA_BUILD);
	}
    }
1;
