require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LINUX_KEXEC_H)) {
    eval 'sub LINUX_KEXEC_H () {1;}' unless defined(&LINUX_KEXEC_H);
    if(defined(&CONFIG_KEXEC)) {
	require 'linux/types.ph';
	require 'linux/list.ph';
	require 'linux/linkage.ph';
	require 'linux/compat.ph';
	require 'linux/ioport.ph';
	require 'linux/elfcore.ph';
	require 'linux/elf.ph';
	require 'asm/kexec.ph';
	unless(defined(&KEXEC_SOURCE_MEMORY_LIMIT)) {
	    die("KEXEC_SOURCE_MEMORY_LIMIT\ not\ defined");
	}
	unless(defined(&KEXEC_DESTINATION_MEMORY_LIMIT)) {
	    die("KEXEC_DESTINATION_MEMORY_LIMIT\ not\ defined");
	}
	unless(defined(&KEXEC_CONTROL_MEMORY_LIMIT)) {
	    die("KEXEC_CONTROL_MEMORY_LIMIT\ not\ defined");
	}
	unless(defined(&KEXEC_CONTROL_PAGE_SIZE)) {
	    die("KEXEC_CONTROL_PAGE_SIZE\ not\ defined");
	}
	unless(defined(&KEXEC_ARCH)) {
	    die("KEXEC_ARCH\ not\ defined");
	}
	eval 'sub KEXEC_NOTE_HEAD_BYTES () { &ALIGN($sizeof{\'struct elf_note\'}, 4);}' unless defined(&KEXEC_NOTE_HEAD_BYTES);
	eval 'sub KEXEC_CORE_NOTE_NAME () {"CORE";}' unless defined(&KEXEC_CORE_NOTE_NAME);
	eval 'sub KEXEC_CORE_NOTE_NAME_BYTES () { &ALIGN($sizeof{ &KEXEC_CORE_NOTE_NAME}, 4);}' unless defined(&KEXEC_CORE_NOTE_NAME_BYTES);
	eval 'sub KEXEC_CORE_NOTE_DESC_BYTES () { &ALIGN($sizeof{\'struct elf_prstatus\'}, 4);}' unless defined(&KEXEC_CORE_NOTE_DESC_BYTES);
	eval 'sub KEXEC_NOTE_BYTES () {( ( &KEXEC_NOTE_HEAD_BYTES * 2) +  &KEXEC_CORE_NOTE_NAME_BYTES +  &KEXEC_CORE_NOTE_DESC_BYTES );}' unless defined(&KEXEC_NOTE_BYTES);
	eval 'sub IND_DESTINATION () {0x1;}' unless defined(&IND_DESTINATION);
	eval 'sub IND_INDIRECTION () {0x2;}' unless defined(&IND_INDIRECTION);
	eval 'sub IND_DONE () {0x4;}' unless defined(&IND_DONE);
	eval 'sub IND_SOURCE () {0x8;}' unless defined(&IND_SOURCE);
	eval 'sub KEXEC_SEGMENT_MAX () {16;}' unless defined(&KEXEC_SEGMENT_MAX);
	if(defined(&CONFIG_COMPAT)) {
	}
	eval 'sub KEXEC_TYPE_DEFAULT () {0;}' unless defined(&KEXEC_TYPE_DEFAULT);
	eval 'sub KEXEC_TYPE_CRASH () {1;}' unless defined(&KEXEC_TYPE_CRASH);
	if(defined(&CONFIG_COMPAT)) {
	}
	eval 'sub VMCOREINFO_OSRELEASE {
	    my($value) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"OSRELEASE=%s\\\\n\\", $value));
	}' unless defined(&VMCOREINFO_OSRELEASE);
	eval 'sub VMCOREINFO_PAGESIZE {
	    my($value) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"PAGESIZE=%ld\\\\n\\", $value));
	}' unless defined(&VMCOREINFO_PAGESIZE);
	eval 'sub VMCOREINFO_SYMBOL {
	    my($name) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"SYMBOL(%s)=%lx\\\\n\\", $name, $name));
	}' unless defined(&VMCOREINFO_SYMBOL);
	eval 'sub VMCOREINFO_SIZE {
	    my($name) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"SIZE(%s)=%lu\\\\n\\", $name, $sizeof{$name}));
	}' unless defined(&VMCOREINFO_SIZE);
	eval 'sub VMCOREINFO_STRUCT_SIZE {
	    my($name) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"SIZE(%s)=%lu\\\\n\\", $name, $sizeof{\'struct name\'}));
	}' unless defined(&VMCOREINFO_STRUCT_SIZE);
	eval 'sub VMCOREINFO_OFFSET {
	    my($name, $field) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"OFFSET(%s.%s)=%lu\\\\n\\", $name, $field,  &offsetof(\'struct name\', $field)));
	}' unless defined(&VMCOREINFO_OFFSET);
	eval 'sub VMCOREINFO_LENGTH {
	    my($name, $value) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"LENGTH(%s)=%lu\\\\n\\", $name, $value));
	}' unless defined(&VMCOREINFO_LENGTH);
	eval 'sub VMCOREINFO_NUMBER {
	    my($name) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"NUMBER(%s)=%ld\\\\n\\", $name, $name));
	}' unless defined(&VMCOREINFO_NUMBER);
	eval 'sub VMCOREINFO_CONFIG {
	    my($name) = @_;
    	    eval q( &vmcoreinfo_append_str(\\"CONFIG_%s=y\\\\n\\", $name));
	}' unless defined(&VMCOREINFO_CONFIG);
	unless(defined(&kexec_flush_icache_page)) {
	    eval 'sub kexec_flush_icache_page {
	        my($page) = @_;
    		eval q();
	    }' unless defined(&kexec_flush_icache_page);
	}
	eval 'sub KEXEC_ON_CRASH () {0x1;}' unless defined(&KEXEC_ON_CRASH);
	eval 'sub KEXEC_PRESERVE_CONTEXT () {0x2;}' unless defined(&KEXEC_PRESERVE_CONTEXT);
	eval 'sub KEXEC_ARCH_MASK () {0xffff0000;}' unless defined(&KEXEC_ARCH_MASK);
	eval 'sub KEXEC_ARCH_DEFAULT () {( 0<< 16);}' unless defined(&KEXEC_ARCH_DEFAULT);
	eval 'sub KEXEC_ARCH_386 () {( 3<< 16);}' unless defined(&KEXEC_ARCH_386);
	eval 'sub KEXEC_ARCH_X86_64 () {(62<< 16);}' unless defined(&KEXEC_ARCH_X86_64);
	eval 'sub KEXEC_ARCH_PPC () {(20<< 16);}' unless defined(&KEXEC_ARCH_PPC);
	eval 'sub KEXEC_ARCH_PPC64 () {(21<< 16);}' unless defined(&KEXEC_ARCH_PPC64);
	eval 'sub KEXEC_ARCH_IA_64 () {(50<< 16);}' unless defined(&KEXEC_ARCH_IA_64);
	eval 'sub KEXEC_ARCH_ARM () {(40<< 16);}' unless defined(&KEXEC_ARCH_ARM);
	eval 'sub KEXEC_ARCH_S390 () {(22<< 16);}' unless defined(&KEXEC_ARCH_S390);
	eval 'sub KEXEC_ARCH_SH () {(42<< 16);}' unless defined(&KEXEC_ARCH_SH);
	eval 'sub KEXEC_ARCH_MIPS_LE () {(10<< 16);}' unless defined(&KEXEC_ARCH_MIPS_LE);
	eval 'sub KEXEC_ARCH_MIPS () {( 8<< 16);}' unless defined(&KEXEC_ARCH_MIPS);
	unless(defined(&CONFIG_KEXEC_JUMP)) {
	    eval 'sub KEXEC_FLAGS () { &KEXEC_ON_CRASH;}' unless defined(&KEXEC_FLAGS);
	} else {
	    eval 'sub KEXEC_FLAGS () {( &KEXEC_ON_CRASH |  &KEXEC_PRESERVE_CONTEXT);}' unless defined(&KEXEC_FLAGS);
	}
	eval 'sub VMCOREINFO_BYTES () {(4096);}' unless defined(&VMCOREINFO_BYTES);
	eval 'sub VMCOREINFO_NOTE_NAME () {"VMCOREINFO";}' unless defined(&VMCOREINFO_NOTE_NAME);
	eval 'sub VMCOREINFO_NOTE_NAME_BYTES () { &ALIGN($sizeof{ &VMCOREINFO_NOTE_NAME}, 4);}' unless defined(&VMCOREINFO_NOTE_NAME_BYTES);
	eval 'sub VMCOREINFO_NOTE_SIZE () {( &KEXEC_NOTE_HEAD_BYTES*2+  &VMCOREINFO_BYTES +  &VMCOREINFO_NOTE_NAME_BYTES);}' unless defined(&VMCOREINFO_NOTE_SIZE);
    } else {
	eval 'sub kexec_should_crash {
	    my($p) = @_;
    	    eval q({ 0; }  &endif  &endif );
	}' unless defined(&kexec_should_crash);
1;
