require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_KTIME_H)) {
    eval 'sub _LINUX_KTIME_H () {1;}' unless defined(&_LINUX_KTIME_H);
    require 'linux/time.ph';
    require 'linux/jiffies.ph';
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) != 64 && !defined( &CONFIG_KTIME_SCALAR)) {
	if(defined(&__BIG_ENDIAN)) {
	} else {
	}
    }
    eval 'sub KTIME_MAX () {(( &s64)~(( &u64)1<< 63));}' unless defined(&KTIME_MAX);
    if(((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 64)) {
	eval 'sub KTIME_SEC_MAX () {( &KTIME_MAX /  &NSEC_PER_SEC);}' unless defined(&KTIME_SEC_MAX);
    } else {
	eval 'sub KTIME_SEC_MAX () { &LONG_MAX;}' unless defined(&KTIME_SEC_MAX);
    }
    if(((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 64) || defined( &CONFIG_KTIME_SCALAR)) {
	if(((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) == 64)) {
	}
	eval 'sub ktime_sub {
	    my($lhs, $rhs) = @_;
    	    eval q(({ ( &ktime_t){ . &tv64 = ($lhs). &tv64 - ($rhs). &tv64 }; }));
	}' unless defined(&ktime_sub);
	eval 'sub ktime_add {
	    my($lhs, $rhs) = @_;
    	    eval q(({ ( &ktime_t){ . &tv64 = ($lhs). &tv64 + ($rhs). &tv64 }; }));
	}' unless defined(&ktime_add);
	eval 'sub ktime_add_ns {
	    my($kt, $nsval) = @_;
    	    eval q(({ ( &ktime_t){ . &tv64 = ($kt). &tv64 + ($nsval) }; }));
	}' unless defined(&ktime_add_ns);
	eval 'sub ktime_sub_ns {
	    my($kt, $nsval) = @_;
    	    eval q(({ ( &ktime_t){ . &tv64 = ($kt). &tv64 - ($nsval) }; }));
	}' unless defined(&ktime_sub_ns);
	eval 'sub ktime_to_timespec {
	    my($kt) = @_;
    	    eval q( &ns_to_timespec(($kt). &tv64));
	}' unless defined(&ktime_to_timespec);
	eval 'sub ktime_to_timeval {
	    my($kt) = @_;
    	    eval q( &ns_to_timeval(($kt). &tv64));
	}' unless defined(&ktime_to_timeval);
	eval 'sub ktime_to_ns {
	    my($kt) = @_;
    	    eval q((($kt). &tv64));
	}' unless defined(&ktime_to_ns);
    } else {
    }
    eval 'sub ktime_to_us {
        my($kt) = @_;
	    eval q({ \'struct timeval\'  &tv =  &ktime_to_timeval($kt); ( &s64)  ($tv->{tv_sec}) *  &USEC_PER_SEC +  ($tv->{tv_usec}); });
    }' unless defined(&ktime_to_us);
    eval 'sub ktime_us_delta {
        my($later,$earlier) = @_;
	    eval q({  &ktime_to_us( &ktime_sub($later, $earlier)); });
    }' unless defined(&ktime_us_delta);
    eval 'sub ktime_add_us {
        my($kt,$usec) = @_;
	    eval q({  &ktime_add_ns($kt, $usec * 1000); });
    }' unless defined(&ktime_add_us);
    eval 'sub ktime_sub_us {
        my($kt,$usec) = @_;
	    eval q({  &ktime_sub_ns($kt, $usec * 1000); });
    }' unless defined(&ktime_sub_us);
    eval 'sub LOW_RES_NSEC () { &TICK_NSEC;}' unless defined(&LOW_RES_NSEC);
    eval 'sub KTIME_LOW_RES () {( &ktime_t){ . &tv64 =  &LOW_RES_NSEC };}' unless defined(&KTIME_LOW_RES);
    eval 'sub ktime_get_real_ts {
        my($ts) = @_;
	    eval q( &getnstimeofday($ts));
    }' unless defined(&ktime_get_real_ts);
    eval 'sub ns_to_ktime {
        my($ns) = @_;
	    eval q({  &const  &ktime_t  &ktime_zero = { . &tv64 = 0};  &ktime_add_ns( &ktime_zero, $ns); });
    }' unless defined(&ns_to_ktime);
}
1;
