require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__KVM_HOST_H)) {
    eval 'sub __KVM_HOST_H () {1;}' unless defined(&__KVM_HOST_H);
    require 'linux/types.ph';
    require 'linux/hardirq.ph';
    require 'linux/list.ph';
    require 'linux/mutex.ph';
    require 'linux/spinlock.ph';
    require 'linux/signal.ph';
    require 'linux/sched.ph';
    require 'linux/mm.ph';
    require 'linux/preempt.ph';
    require 'linux/marker.ph';
    require 'asm/signal.ph';
    require 'linux/kvm.ph';
    require 'linux/kvm_para.ph';
    require 'linux/kvm_types.ph';
    require 'asm/kvm_host.ph';
    eval 'sub KVM_REQ_TLB_FLUSH () {0;}' unless defined(&KVM_REQ_TLB_FLUSH);
    eval 'sub KVM_REQ_MIGRATE_TIMER () {1;}' unless defined(&KVM_REQ_MIGRATE_TIMER);
    eval 'sub KVM_REQ_REPORT_TPR_ACCESS () {2;}' unless defined(&KVM_REQ_REPORT_TPR_ACCESS);
    eval 'sub KVM_REQ_MMU_RELOAD () {3;}' unless defined(&KVM_REQ_MMU_RELOAD);
    eval 'sub KVM_REQ_TRIPLE_FAULT () {4;}' unless defined(&KVM_REQ_TRIPLE_FAULT);
    eval 'sub KVM_REQ_PENDING_TIMER () {5;}' unless defined(&KVM_REQ_PENDING_TIMER);
    eval 'sub NR_IOBUS_DEVS () {6;}' unless defined(&NR_IOBUS_DEVS);
    if(defined(&CONFIG_PREEMPT_NOTIFIERS)) {
    }
    if(defined(&CONFIG_HAS_IOMEM)) {
    }
    if(defined(&KVM_COALESCED_MMIO_PAGE_OFFSET)) {
    }
    if(defined(&KVM_ARCH_WANT_MMU_NOTIFIER)) {
    }
    eval 'sub pr_unimpl () {( &vcpu,  &fmt, ...)  &do {  &if ( &printk_ratelimit())  &printk( &KERN_ERR "kvm: %i: cpu%i "  &fmt,  ($current->{tgid}), ( &vcpu)-> &vcpu_id ,   &__VA_ARGS__); }  &while (0);}' unless defined(&pr_unimpl);
    eval 'sub kvm_printf () {( &kvm,  &fmt ...)  &printk( &KERN_DEBUG  &fmt);}' unless defined(&kvm_printf);
    eval 'sub vcpu_printf () {( &vcpu,  &fmt...)  &kvm_printf( ($vcpu->{kvm}),  &fmt);}' unless defined(&vcpu_printf);
    eval 'sub HPA_MSB () {(($sizeof{ &hpa_t} * 8) - 1);}' unless defined(&HPA_MSB);
    eval 'sub HPA_ERR_MASK () {(( &hpa_t)1<<  &HPA_MSB);}' unless defined(&HPA_ERR_MASK);
    eval 'sub kvm_guest_enter {
        my($void) = @_;
	    eval q({  &account_system_vtime( &current);  ($current->{flags}) |=  &PF_VCPU; });
    }' unless defined(&kvm_guest_enter);
    eval 'sub kvm_guest_exit {
        my($void) = @_;
	    eval q({  &account_system_vtime( &current);  ($current->{flags}) &= ~ &PF_VCPU; });
    }' unless defined(&kvm_guest_exit);
    eval 'sub memslot_id {
        my($kvm,$slot) = @_;
	    eval q({ $slot -  ($kvm->{memslots}); });
    }' unless defined(&memslot_id);
    eval 'sub gfn_to_gpa {
        my($gfn) = @_;
	    eval q({ ( &gpa_t)$gfn <<  &PAGE_SHIFT; });
    }' unless defined(&gfn_to_gpa);
    eval 'sub kvm_migrate_timers {
        my($vcpu) = @_;
	    eval q({  &set_bit( &KVM_REQ_MIGRATE_TIMER,  ($vcpu->{requests})); });
    }' unless defined(&kvm_migrate_timers);
    eval("sub KVM_STAT_VM () { 0; }") unless defined(&KVM_STAT_VM);
    eval("sub KVM_STAT_VCPU () { 1; }") unless defined(&KVM_STAT_VCPU);
    if(defined(&CONFIG_KVM_TRACE)) {
    } else {
	eval 'sub kvm_trace_cleanup () {
	    eval q((( &void)0));
	}' unless defined(&kvm_trace_cleanup);
    }
    if(defined(&KVM_ARCH_WANT_MMU_NOTIFIER)) {
	eval 'sub mmu_notifier_retry {
	    my($vcpu,$mmu_seq) = @_;
    	    eval q({  &if ( &unlikely( ($vcpu->{kvm}->{mmu_notifier_count}))) 1;  &if ( ($vcpu->{kvm}->{mmu_notifier_seq}) != $mmu_seq) 1; 0; });
	}' unless defined(&mmu_notifier_retry);
    }
}
1;
