require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_LIBATA_H__)) {
    eval 'sub __LINUX_LIBATA_H__ () {1;}' unless defined(&__LINUX_LIBATA_H__);
    require 'linux/delay.ph';
    require 'linux/jiffies.ph';
    require 'linux/interrupt.ph';
    require 'linux/dma-mapping.ph';
    require 'linux/scatterlist.ph';
    require 'linux/io.ph';
    require 'linux/ata.ph';
    require 'linux/workqueue.ph';
    require 'scsi/scsi_host.ph';
    require 'linux/acpi.ph';
    require 'linux/cdrom.ph';
    if(defined(&CONFIG_ATA_NONSTANDARD)) {
	require 'asm/libata-portmap.ph';
    } else {
	require 'asm-generic/libata-portmap.ph';
    }
    undef(&ATA_DEBUG) if defined(&ATA_DEBUG);
    undef(&ATA_VERBOSE_DEBUG) if defined(&ATA_VERBOSE_DEBUG);
    undef(&ATA_IRQ_TRAP) if defined(&ATA_IRQ_TRAP);
    undef(&ATA_NDEBUG) if defined(&ATA_NDEBUG);
    if(defined(&ATA_DEBUG)) {
	eval 'sub DPRINTK () {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__func__,   &args);}' unless defined(&DPRINTK);
	if(defined(&ATA_VERBOSE_DEBUG)) {
	    eval 'sub VPRINTK () {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__func__,   &args);}' unless defined(&VPRINTK);
	} else {
	    eval 'sub VPRINTK () {( &fmt,  &args...);}' unless defined(&VPRINTK);
	}
    } else {
	eval 'sub DPRINTK () {( &fmt,  &args...);}' unless defined(&DPRINTK);
	eval 'sub VPRINTK () {( &fmt,  &args...);}' unless defined(&VPRINTK);
    }
    eval 'sub BPRINTK () {( &fmt,  &args...)  &if ( ($ap->{flags}) &  &ATA_FLAG_DEBUGMSG)  &printk( &KERN_ERR "%s: "  &fmt,  &__func__,   &args);}' unless defined(&BPRINTK);
    eval 'sub HAVE_LIBATA_MSG () {1;}' unless defined(&HAVE_LIBATA_MSG);
    eval("sub ATA_MSG_DRV () { 0x0001; }") unless defined(&ATA_MSG_DRV);
    eval("sub ATA_MSG_INFO () { 0x0002; }") unless defined(&ATA_MSG_INFO);
    eval("sub ATA_MSG_PROBE () { 0x0004; }") unless defined(&ATA_MSG_PROBE);
    eval("sub ATA_MSG_WARN () { 0x0008; }") unless defined(&ATA_MSG_WARN);
    eval("sub ATA_MSG_MALLOC () { 0x0010; }") unless defined(&ATA_MSG_MALLOC);
    eval("sub ATA_MSG_CTL () { 0x0020; }") unless defined(&ATA_MSG_CTL);
    eval("sub ATA_MSG_INTR () { 0x0040; }") unless defined(&ATA_MSG_INTR);
    eval("sub ATA_MSG_ERR () { 0x0080; }") unless defined(&ATA_MSG_ERR);
    eval 'sub ata_msg_drv {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_DRV));
    }' unless defined(&ata_msg_drv);
    eval 'sub ata_msg_info {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_INFO));
    }' unless defined(&ata_msg_info);
    eval 'sub ata_msg_probe {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_PROBE));
    }' unless defined(&ata_msg_probe);
    eval 'sub ata_msg_warn {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_WARN));
    }' unless defined(&ata_msg_warn);
    eval 'sub ata_msg_malloc {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_MALLOC));
    }' unless defined(&ata_msg_malloc);
    eval 'sub ata_msg_ctl {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_CTL));
    }' unless defined(&ata_msg_ctl);
    eval 'sub ata_msg_intr {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_INTR));
    }' unless defined(&ata_msg_intr);
    eval 'sub ata_msg_err {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_ERR));
    }' unless defined(&ata_msg_err);
    eval 'sub ata_msg_init {
        my($dval,$default_msg_enable_bits) = @_;
	    eval q({  &if ($dval < 0|| $dval >= ($sizeof{ &u32} * 8)) $default_msg_enable_bits;  &if (!$dval) 0; (1<< $dval) - 1; });
    }' unless defined(&ata_msg_init);
    eval 'sub ATA_TAG_POISON () {0xfafbfcfd;}' unless defined(&ATA_TAG_POISON);
    eval("sub LIBATA_MAX_PRD () { ATA_MAX_PRD/2; }") unless defined(&LIBATA_MAX_PRD);
    eval("sub LIBATA_DUMB_MAX_PRD () { ATA_MAX_PRD/4; }") unless defined(&LIBATA_DUMB_MAX_PRD);
    eval("sub ATA_DEF_QUEUE () { 1; }") unless defined(&ATA_DEF_QUEUE);
    eval("sub ATA_MAX_QUEUE () { 32; }") unless defined(&ATA_MAX_QUEUE);
    eval("sub ATA_TAG_INTERNAL () { ATA_MAX_QUEUE-1; }") unless defined(&ATA_TAG_INTERNAL);
    eval("sub ATA_SHORT_PAUSE () { 16; }") unless defined(&ATA_SHORT_PAUSE);
    eval("sub ATAPI_MAX_DRAIN () { 16<<10; }") unless defined(&ATAPI_MAX_DRAIN);
    eval("sub ATA_ALL_DEVICES () { (1<<ATA_MAX_DEVICES)-1; }") unless defined(&ATA_ALL_DEVICES);
    eval("sub ATA_SHT_EMULATED () { 1; }") unless defined(&ATA_SHT_EMULATED);
    eval("sub ATA_SHT_CMD_PER_LUN () { 1; }") unless defined(&ATA_SHT_CMD_PER_LUN);
    eval("sub ATA_SHT_THIS_ID () { -1; }") unless defined(&ATA_SHT_THIS_ID);
    eval("sub ATA_SHT_USE_CLUSTERING () { 1; }") unless defined(&ATA_SHT_USE_CLUSTERING);
    eval("sub ATA_DFLAG_LBA () { (1<<0); }") unless defined(&ATA_DFLAG_LBA);
    eval("sub ATA_DFLAG_LBA48 () { (1<<1); }") unless defined(&ATA_DFLAG_LBA48);
    eval("sub ATA_DFLAG_CDB_INTR () { (1<<2); }") unless defined(&ATA_DFLAG_CDB_INTR);
    eval("sub ATA_DFLAG_NCQ () { (1<<3); }") unless defined(&ATA_DFLAG_NCQ);
    eval("sub ATA_DFLAG_FLUSH_EXT () { (1<<4); }") unless defined(&ATA_DFLAG_FLUSH_EXT);
    eval("sub ATA_DFLAG_ACPI_PENDING () { (1<<5); }") unless defined(&ATA_DFLAG_ACPI_PENDING);
    eval("sub ATA_DFLAG_ACPI_FAILED () { (1<<6); }") unless defined(&ATA_DFLAG_ACPI_FAILED);
    eval("sub ATA_DFLAG_AN () { (1<<7); }") unless defined(&ATA_DFLAG_AN);
    eval("sub ATA_DFLAG_HIPM () { (1<<8); }") unless defined(&ATA_DFLAG_HIPM);
    eval("sub ATA_DFLAG_DIPM () { (1<<9); }") unless defined(&ATA_DFLAG_DIPM);
    eval("sub ATA_DFLAG_DMADIR () { (1<<10); }") unless defined(&ATA_DFLAG_DMADIR);
    eval("sub ATA_DFLAG_CFG_MASK () { (1<<12)-1; }") unless defined(&ATA_DFLAG_CFG_MASK);
    eval("sub ATA_DFLAG_PIO () { (1<<12); }") unless defined(&ATA_DFLAG_PIO);
    eval("sub ATA_DFLAG_NCQ_OFF () { (1<<13); }") unless defined(&ATA_DFLAG_NCQ_OFF);
    eval("sub ATA_DFLAG_SPUNDOWN () { (1<<14); }") unless defined(&ATA_DFLAG_SPUNDOWN);
    eval("sub ATA_DFLAG_SLEEPING () { (1<<15); }") unless defined(&ATA_DFLAG_SLEEPING);
    eval("sub ATA_DFLAG_DUBIOUS_XFER () { (1<<16); }") unless defined(&ATA_DFLAG_DUBIOUS_XFER);
    eval("sub ATA_DFLAG_INIT_MASK () { (1<<24)-1; }") unless defined(&ATA_DFLAG_INIT_MASK);
    eval("sub ATA_DFLAG_DETACH () { (1<<24); }") unless defined(&ATA_DFLAG_DETACH);
    eval("sub ATA_DFLAG_DETACHED () { (1<<25); }") unless defined(&ATA_DFLAG_DETACHED);
    eval("sub ATA_DEV_UNKNOWN () { 0; }") unless defined(&ATA_DEV_UNKNOWN);
    eval("sub ATA_DEV_ATA () { 1; }") unless defined(&ATA_DEV_ATA);
    eval("sub ATA_DEV_ATA_UNSUP () { 2; }") unless defined(&ATA_DEV_ATA_UNSUP);
    eval("sub ATA_DEV_ATAPI () { 3; }") unless defined(&ATA_DEV_ATAPI);
    eval("sub ATA_DEV_ATAPI_UNSUP () { 4; }") unless defined(&ATA_DEV_ATAPI_UNSUP);
    eval("sub ATA_DEV_PMP () { 5; }") unless defined(&ATA_DEV_PMP);
    eval("sub ATA_DEV_PMP_UNSUP () { 6; }") unless defined(&ATA_DEV_PMP_UNSUP);
    eval("sub ATA_DEV_SEMB () { 7; }") unless defined(&ATA_DEV_SEMB);
    eval("sub ATA_DEV_SEMB_UNSUP () { 8; }") unless defined(&ATA_DEV_SEMB_UNSUP);
    eval("sub ATA_DEV_NONE () { 9; }") unless defined(&ATA_DEV_NONE);
    eval("sub ATA_LFLAG_NO_HRST () { (1<<1); }") unless defined(&ATA_LFLAG_NO_HRST);
    eval("sub ATA_LFLAG_NO_SRST () { (1<<2); }") unless defined(&ATA_LFLAG_NO_SRST);
    eval("sub ATA_LFLAG_ASSUME_ATA () { (1<<3); }") unless defined(&ATA_LFLAG_ASSUME_ATA);
    eval("sub ATA_LFLAG_ASSUME_SEMB () { (1<<4); }") unless defined(&ATA_LFLAG_ASSUME_SEMB);
    eval("sub ATA_LFLAG_ASSUME_CLASS () { ATA_LFLAG_ASSUME_ATA|ATA_LFLAG_ASSUME_SEMB; }") unless defined(&ATA_LFLAG_ASSUME_CLASS);
    eval("sub ATA_LFLAG_NO_RETRY () { (1<<5); }") unless defined(&ATA_LFLAG_NO_RETRY);
    eval("sub ATA_LFLAG_DISABLED () { (1<<6); }") unless defined(&ATA_LFLAG_DISABLED);
    eval("sub ATA_LFLAG_SW_ACTIVITY () { (1<<7); }") unless defined(&ATA_LFLAG_SW_ACTIVITY);
    eval("sub ATA_FLAG_SLAVE_POSS () { (1<<0); }") unless defined(&ATA_FLAG_SLAVE_POSS);
    eval("sub ATA_FLAG_SATA () { (1<<1); }") unless defined(&ATA_FLAG_SATA);
    eval("sub ATA_FLAG_NO_LEGACY () { (1<<2); }") unless defined(&ATA_FLAG_NO_LEGACY);
    eval("sub ATA_FLAG_MMIO () { (1<<3); }") unless defined(&ATA_FLAG_MMIO);
    eval("sub ATA_FLAG_SRST () { (1<<4); }") unless defined(&ATA_FLAG_SRST);
    eval("sub ATA_FLAG_SATA_RESET () { (1<<5); }") unless defined(&ATA_FLAG_SATA_RESET);
    eval("sub ATA_FLAG_NO_ATAPI () { (1<<6); }") unless defined(&ATA_FLAG_NO_ATAPI);
    eval("sub ATA_FLAG_PIO_DMA () { (1<<7); }") unless defined(&ATA_FLAG_PIO_DMA);
    eval("sub ATA_FLAG_PIO_LBA48 () { (1<<8); }") unless defined(&ATA_FLAG_PIO_LBA48);
    eval("sub ATA_FLAG_PIO_POLLING () { (1<<9); }") unless defined(&ATA_FLAG_PIO_POLLING);
    eval("sub ATA_FLAG_NCQ () { (1<<10); }") unless defined(&ATA_FLAG_NCQ);
    eval("sub ATA_FLAG_DEBUGMSG () { (1<<13); }") unless defined(&ATA_FLAG_DEBUGMSG);
    eval("sub ATA_FLAG_IGN_SIMPLEX () { (1<<15); }") unless defined(&ATA_FLAG_IGN_SIMPLEX);
    eval("sub ATA_FLAG_NO_IORDY () { (1<<16); }") unless defined(&ATA_FLAG_NO_IORDY);
    eval("sub ATA_FLAG_ACPI_SATA () { (1<<17); }") unless defined(&ATA_FLAG_ACPI_SATA);
    eval("sub ATA_FLAG_AN () { (1<<18); }") unless defined(&ATA_FLAG_AN);
    eval("sub ATA_FLAG_PMP () { (1<<19); }") unless defined(&ATA_FLAG_PMP);
    eval("sub ATA_FLAG_IPM () { (1<<20); }") unless defined(&ATA_FLAG_IPM);
    eval("sub ATA_FLAG_EM () { (1<<21); }") unless defined(&ATA_FLAG_EM);
    eval("sub ATA_FLAG_SW_ACTIVITY () { (1<<22); }") unless defined(&ATA_FLAG_SW_ACTIVITY);
    eval("sub ATA_FLAG_DISABLED () { (1<<23); }") unless defined(&ATA_FLAG_DISABLED);
    eval("sub ATA_PFLAG_EH_PENDING () { (1<<0); }") unless defined(&ATA_PFLAG_EH_PENDING);
    eval("sub ATA_PFLAG_EH_IN_PROGRESS () { (1<<1); }") unless defined(&ATA_PFLAG_EH_IN_PROGRESS);
    eval("sub ATA_PFLAG_FROZEN () { (1<<2); }") unless defined(&ATA_PFLAG_FROZEN);
    eval("sub ATA_PFLAG_RECOVERED () { (1<<3); }") unless defined(&ATA_PFLAG_RECOVERED);
    eval("sub ATA_PFLAG_LOADING () { (1<<4); }") unless defined(&ATA_PFLAG_LOADING);
    eval("sub ATA_PFLAG_UNLOADING () { (1<<5); }") unless defined(&ATA_PFLAG_UNLOADING);
    eval("sub ATA_PFLAG_SCSI_HOTPLUG () { (1<<6); }") unless defined(&ATA_PFLAG_SCSI_HOTPLUG);
    eval("sub ATA_PFLAG_INITIALIZING () { (1<<7); }") unless defined(&ATA_PFLAG_INITIALIZING);
    eval("sub ATA_PFLAG_RESETTING () { (1<<8); }") unless defined(&ATA_PFLAG_RESETTING);
    eval("sub ATA_PFLAG_SUSPENDED () { (1<<17); }") unless defined(&ATA_PFLAG_SUSPENDED);
    eval("sub ATA_PFLAG_PM_PENDING () { (1<<18); }") unless defined(&ATA_PFLAG_PM_PENDING);
    eval("sub ATA_PFLAG_INIT_GTM_VALID () { (1<<19); }") unless defined(&ATA_PFLAG_INIT_GTM_VALID);
    eval("sub ATA_QCFLAG_ACTIVE () { (1<<0); }") unless defined(&ATA_QCFLAG_ACTIVE);
    eval("sub ATA_QCFLAG_DMAMAP () { (1<<1); }") unless defined(&ATA_QCFLAG_DMAMAP);
    eval("sub ATA_QCFLAG_IO () { (1<<3); }") unless defined(&ATA_QCFLAG_IO);
    eval("sub ATA_QCFLAG_RESULT_TF () { (1<<4); }") unless defined(&ATA_QCFLAG_RESULT_TF);
    eval("sub ATA_QCFLAG_CLEAR_EXCL () { (1<<5); }") unless defined(&ATA_QCFLAG_CLEAR_EXCL);
    eval("sub ATA_QCFLAG_QUIET () { (1<<6); }") unless defined(&ATA_QCFLAG_QUIET);
    eval("sub ATA_QCFLAG_RETRY () { (1<<7); }") unless defined(&ATA_QCFLAG_RETRY);
    eval("sub ATA_QCFLAG_FAILED () { (1<<16); }") unless defined(&ATA_QCFLAG_FAILED);
    eval("sub ATA_QCFLAG_SENSE_VALID () { (1<<17); }") unless defined(&ATA_QCFLAG_SENSE_VALID);
    eval("sub ATA_QCFLAG_EH_SCHEDULED () { (1<<18); }") unless defined(&ATA_QCFLAG_EH_SCHEDULED);
    eval("sub ATA_HOST_SIMPLEX () { (1<<0); }") unless defined(&ATA_HOST_SIMPLEX);
    eval("sub ATA_HOST_STARTED () { (1<<1); }") unless defined(&ATA_HOST_STARTED);
    eval("sub ATA_TMOUT_BOOT () { 30000; }") unless defined(&ATA_TMOUT_BOOT);
    eval("sub ATA_TMOUT_BOOT_QUICK () { 7000; }") unless defined(&ATA_TMOUT_BOOT_QUICK);
    eval("sub ATA_TMOUT_INTERNAL_QUICK () { 5000; }") unless defined(&ATA_TMOUT_INTERNAL_QUICK);
    eval("sub ATA_TMOUT_FF_WAIT () { 800; }") unless defined(&ATA_TMOUT_FF_WAIT);
    eval("sub ATA_WAIT_AFTER_RESET () { 150; }") unless defined(&ATA_WAIT_AFTER_RESET);
    eval("sub ATA_TMOUT_PMP_SRST_WAIT () { 1000; }") unless defined(&ATA_TMOUT_PMP_SRST_WAIT);
    eval("sub BUS_UNKNOWN () { 0; }") unless defined(&BUS_UNKNOWN);
    eval("sub BUS_DMA () { 1; }") unless defined(&BUS_DMA);
    eval("sub BUS_IDLE () { 2; }") unless defined(&BUS_IDLE);
    eval("sub BUS_NOINTR () { 3; }") unless defined(&BUS_NOINTR);
    eval("sub BUS_NODATA () { 4; }") unless defined(&BUS_NODATA);
    eval("sub BUS_TIMER () { 5; }") unless defined(&BUS_TIMER);
    eval("sub BUS_PIO () { 6; }") unless defined(&BUS_PIO);
    eval("sub BUS_EDD () { 7; }") unless defined(&BUS_EDD);
    eval("sub BUS_IDENTIFY () { 8; }") unless defined(&BUS_IDENTIFY);
    eval("sub BUS_PACKET () { 9; }") unless defined(&BUS_PACKET);
    eval("sub PORT_UNKNOWN () { 0; }") unless defined(&PORT_UNKNOWN);
    eval("sub PORT_ENABLED () { 1; }") unless defined(&PORT_ENABLED);
    eval("sub PORT_DISABLED () { 2; }") unless defined(&PORT_DISABLED);
    eval("sub ATA_NR_PIO_MODES () { 7; }") unless defined(&ATA_NR_PIO_MODES);
    eval("sub ATA_NR_MWDMA_MODES () { 5; }") unless defined(&ATA_NR_MWDMA_MODES);
    eval("sub ATA_NR_UDMA_MODES () { 8; }") unless defined(&ATA_NR_UDMA_MODES);
    eval("sub ATA_SHIFT_PIO () { 0; }") unless defined(&ATA_SHIFT_PIO);
    eval("sub ATA_SHIFT_MWDMA () { ATA_SHIFT_PIO+ATA_NR_PIO_MODES; }") unless defined(&ATA_SHIFT_MWDMA);
    eval("sub ATA_SHIFT_UDMA () { ATA_SHIFT_MWDMA+ATA_NR_MWDMA_MODES; }") unless defined(&ATA_SHIFT_UDMA);
    eval("sub ATA_DMA_PAD_SZ () { 4; }") unless defined(&ATA_DMA_PAD_SZ);
    eval("sub ATA_ERING_SIZE () { 32; }") unless defined(&ATA_ERING_SIZE);
    eval("sub ATA_DEFER_LINK () { 1; }") unless defined(&ATA_DEFER_LINK);
    eval("sub ATA_DEFER_PORT () { 2; }") unless defined(&ATA_DEFER_PORT);
    eval("sub ATA_EH_DESC_LEN () { 80; }") unless defined(&ATA_EH_DESC_LEN);
    eval("sub ATA_EH_REVALIDATE () { (1<<0); }") unless defined(&ATA_EH_REVALIDATE);
    eval("sub ATA_EH_SOFTRESET () { (1<<1); }") unless defined(&ATA_EH_SOFTRESET);
    eval("sub ATA_EH_HARDRESET () { (1<<2); }") unless defined(&ATA_EH_HARDRESET);
    eval("sub ATA_EH_RESET () { ATA_EH_SOFTRESET|ATA_EH_HARDRESET; }") unless defined(&ATA_EH_RESET);
    eval("sub ATA_EH_ENABLE_LINK () { (1<<3); }") unless defined(&ATA_EH_ENABLE_LINK);
    eval("sub ATA_EH_LPM () { (1<<4); }") unless defined(&ATA_EH_LPM);
    eval("sub ATA_EH_PERDEV_MASK () { ATA_EH_REVALIDATE; }") unless defined(&ATA_EH_PERDEV_MASK);
    eval("sub ATA_EHI_HOTPLUGGED () { (1<<0); }") unless defined(&ATA_EHI_HOTPLUGGED);
    eval("sub ATA_EHI_NO_AUTOPSY () { (1<<2); }") unless defined(&ATA_EHI_NO_AUTOPSY);
    eval("sub ATA_EHI_QUIET () { (1<<3); }") unless defined(&ATA_EHI_QUIET);
    eval("sub ATA_EHI_DID_SOFTRESET () { (1<<16); }") unless defined(&ATA_EHI_DID_SOFTRESET);
    eval("sub ATA_EHI_DID_HARDRESET () { (1<<17); }") unless defined(&ATA_EHI_DID_HARDRESET);
    eval("sub ATA_EHI_PRINTINFO () { (1<<18); }") unless defined(&ATA_EHI_PRINTINFO);
    eval("sub ATA_EHI_SETMODE () { (1<<19); }") unless defined(&ATA_EHI_SETMODE);
    eval("sub ATA_EHI_POST_SETMODE () { (1<<20); }") unless defined(&ATA_EHI_POST_SETMODE);
    eval("sub ATA_EHI_DID_RESET () { ATA_EHI_DID_SOFTRESET|ATA_EHI_DID_HARDRESET; }") unless defined(&ATA_EHI_DID_RESET);
    eval("sub ATA_EH_MAX_TRIES () { 5; }") unless defined(&ATA_EH_MAX_TRIES);
    eval("sub ATA_PROBE_MAX_TRIES () { 3; }") unless defined(&ATA_PROBE_MAX_TRIES);
    eval("sub ATA_EH_DEV_TRIES () { 3; }") unless defined(&ATA_EH_DEV_TRIES);
    eval("sub ATA_EH_PMP_TRIES () { 5; }") unless defined(&ATA_EH_PMP_TRIES);
    eval("sub ATA_EH_PMP_LINK_TRIES () { 3; }") unless defined(&ATA_EH_PMP_LINK_TRIES);
    eval("sub SATA_PMP_RW_TIMEOUT () { 3000; }") unless defined(&SATA_PMP_RW_TIMEOUT);
    eval("sub ATA_EH_CMD_TIMEOUT_TABLE_SIZE () { 5; }") unless defined(&ATA_EH_CMD_TIMEOUT_TABLE_SIZE);
    eval("sub ATA_HORKAGE_DIAGNOSTIC () { (1<<0); }") unless defined(&ATA_HORKAGE_DIAGNOSTIC);
    eval("sub ATA_HORKAGE_NODMA () { (1<<1); }") unless defined(&ATA_HORKAGE_NODMA);
    eval("sub ATA_HORKAGE_NONCQ () { (1<<2); }") unless defined(&ATA_HORKAGE_NONCQ);
    eval("sub ATA_HORKAGE_MAX_SEC_128 () { (1<<3); }") unless defined(&ATA_HORKAGE_MAX_SEC_128);
    eval("sub ATA_HORKAGE_BROKEN_HPA () { (1<<4); }") unless defined(&ATA_HORKAGE_BROKEN_HPA);
    eval("sub ATA_HORKAGE_DISABLE () { (1<<5); }") unless defined(&ATA_HORKAGE_DISABLE);
    eval("sub ATA_HORKAGE_HPA_SIZE () { (1<<6); }") unless defined(&ATA_HORKAGE_HPA_SIZE);
    eval("sub ATA_HORKAGE_IPM () { (1<<7); }") unless defined(&ATA_HORKAGE_IPM);
    eval("sub ATA_HORKAGE_IVB () { (1<<8); }") unless defined(&ATA_HORKAGE_IVB);
    eval("sub ATA_HORKAGE_STUCK_ERR () { (1<<9); }") unless defined(&ATA_HORKAGE_STUCK_ERR);
    eval("sub ATA_DMA_MASK_ATA () { (1<<0); }") unless defined(&ATA_DMA_MASK_ATA);
    eval("sub ATA_DMA_MASK_ATAPI () { (1<<1); }") unless defined(&ATA_DMA_MASK_ATAPI);
    eval("sub ATA_DMA_MASK_CFA () { (1<<2); }") unless defined(&ATA_DMA_MASK_CFA);
    eval("sub ATAPI_READ () { 0; }") unless defined(&ATAPI_READ);
    eval("sub ATAPI_WRITE () { 1; }") unless defined(&ATAPI_WRITE);
    eval("sub ATAPI_READ_CD () { 2; }") unless defined(&ATAPI_READ_CD);
    eval("sub ATAPI_PASS_THRU () { 3; }") unless defined(&ATAPI_PASS_THRU);
    eval("sub ATAPI_MISC () { 4; }") unless defined(&ATAPI_MISC);
    eval("sub ATA_TIMING_SETUP () { (1<<0); }") unless defined(&ATA_TIMING_SETUP);
    eval("sub ATA_TIMING_ACT8B () { (1<<1); }") unless defined(&ATA_TIMING_ACT8B);
    eval("sub ATA_TIMING_REC8B () { (1<<2); }") unless defined(&ATA_TIMING_REC8B);
    eval("sub ATA_TIMING_CYC8B () { (1<<3); }") unless defined(&ATA_TIMING_CYC8B);
    eval("sub ATA_TIMING_8BIT () { ATA_TIMING_ACT8B|ATA_TIMING_REC8B|ATA_TIMING_CYC8B; }") unless defined(&ATA_TIMING_8BIT);
    eval("sub ATA_TIMING_ACTIVE () { (1<<4); }") unless defined(&ATA_TIMING_ACTIVE);
    eval("sub ATA_TIMING_RECOVER () { (1<<5); }") unless defined(&ATA_TIMING_RECOVER);
    eval("sub ATA_TIMING_CYCLE () { (1<<6); }") unless defined(&ATA_TIMING_CYCLE);
    eval("sub ATA_TIMING_UDMA () { (1<<7); }") unless defined(&ATA_TIMING_UDMA);
    eval("sub ATA_TIMING_ALL () { ATA_TIMING_SETUP|ATA_TIMING_ACT8B|ATA_TIMING_REC8B|ATA_TIMING_CYC8B|ATA_TIMING_ACTIVE|ATA_TIMING_RECOVER|ATA_TIMING_CYCLE|ATA_TIMING_UDMA; }") unless defined(&ATA_TIMING_ALL);
    eval("sub ATA_MASK_PIO () { ((1LU<<ATA_NR_PIO_MODES)-1)<<ATA_SHIFT_PIO; }") unless defined(&ATA_MASK_PIO);
    eval("sub ATA_MASK_MWDMA () { ((1LU<<ATA_NR_MWDMA_MODES)-1)<<ATA_SHIFT_MWDMA; }") unless defined(&ATA_MASK_MWDMA);
    eval("sub ATA_MASK_UDMA () { ((1LU<<ATA_NR_UDMA_MODES)-1)<<ATA_SHIFT_UDMA; }") unless defined(&ATA_MASK_UDMA);
    eval("sub HSM_ST_IDLE () { 0; }") unless defined(&HSM_ST_IDLE);
    eval("sub HSM_ST_FIRST () { 1; }") unless defined(&HSM_ST_FIRST);
    eval("sub HSM_ST () { 2; }") unless defined(&HSM_ST);
    eval("sub HSM_ST_LAST () { 3; }") unless defined(&HSM_ST_LAST);
    eval("sub HSM_ST_ERR () { 4; }") unless defined(&HSM_ST_ERR);
    eval("sub AC_ERR_DEV () { (1<<0); }") unless defined(&AC_ERR_DEV);
    eval("sub AC_ERR_HSM () { (1<<1); }") unless defined(&AC_ERR_HSM);
    eval("sub AC_ERR_TIMEOUT () { (1<<2); }") unless defined(&AC_ERR_TIMEOUT);
    eval("sub AC_ERR_MEDIA () { (1<<3); }") unless defined(&AC_ERR_MEDIA);
    eval("sub AC_ERR_ATA_BUS () { (1<<4); }") unless defined(&AC_ERR_ATA_BUS);
    eval("sub AC_ERR_HOST_BUS () { (1<<5); }") unless defined(&AC_ERR_HOST_BUS);
    eval("sub AC_ERR_SYSTEM () { (1<<6); }") unless defined(&AC_ERR_SYSTEM);
    eval("sub AC_ERR_INVALID () { (1<<7); }") unless defined(&AC_ERR_INVALID);
    eval("sub AC_ERR_OTHER () { (1<<8); }") unless defined(&AC_ERR_OTHER);
    eval("sub AC_ERR_NODEV_HINT () { (1<<9); }") unless defined(&AC_ERR_NODEV_HINT);
    eval("sub AC_ERR_NCQ () { (1<<10); }") unless defined(&AC_ERR_NCQ);
    eval("sub NOT_AVAILABLE () { 0; }") unless defined(&NOT_AVAILABLE);
    eval("sub MIN_POWER () { 1; }") unless defined(&MIN_POWER);
    eval("sub MAX_PERFORMANCE () { 2; }") unless defined(&MAX_PERFORMANCE);
    eval("sub MEDIUM_POWER () { 3; }") unless defined(&MEDIUM_POWER);
    eval("sub OFF () { 0; }") unless defined(&OFF);
    eval("sub BLINK_ON () { 1; }") unless defined(&BLINK_ON);
    eval("sub BLINK_OFF () { 2; }") unless defined(&BLINK_OFF);
    if(defined(&CONFIG_ATA_SFF)) {
    }
    if(defined(&CONFIG_ATA_ACPI)) {
    }
    if(defined(&CONFIG_ATA_ACPI)) {
    }
    eval 'sub ATA_DEVICE_CLEAR_OFFSET () { &offsetof(\'struct ata_device\',  &n_sectors);}' unless defined(&ATA_DEVICE_CLEAR_OFFSET);
    if(defined(&CONFIG_ATA_SFF)) {
    }
    if(defined(&CONFIG_ATA_ACPI)) {
    }
    eval 'sub ATA_OP_NULL () {( &void *)(- &ENOENT);}' unless defined(&ATA_OP_NULL);
    if(defined(&CONFIG_ATA_SFF)) {
    }
    eval 'sub sata_ehc_deb_timing {
        my($ehc) = @_;
	    eval q({  &if ( ($ehc->{i}->{flags}) &  &ATA_EHI_HOTPLUGGED)  &sata_deb_timing_hotplug;  &else  &sata_deb_timing_normal; });
    }' unless defined(&sata_ehc_deb_timing);
    eval 'sub ata_port_is_dummy {
        my($ap) = @_;
	    eval q({  ($ap->{ops}) ==  &ata_dummy_port_ops; });
    }' unless defined(&ata_port_is_dummy);
    if(defined(&CONFIG_PM)) {
    }
    if(defined(&CONFIG_PCI)) {
	if(defined(&CONFIG_PM)) {
	}
    }
    if(defined(&CONFIG_ATA_ACPI)) {
	eval 'sub ata_acpi_gtm {
	    eval q(* &ata_acpi_init_gtm(\'struct ata_port\' * &ap) {  &if ( ($ap->{pflags}) &  &ATA_PFLAG_INIT_GTM_VALID)  ($ap->{__acpi_init_gtm});  &NULL; });
	}' unless defined(&ata_acpi_gtm);
    } else {
	eval 'sub ata_acpi_gtm {
	    eval q(* &ata_acpi_init_gtm(\'struct ata_port\' * &ap) {  &NULL; });
	}' unless defined(&ata_acpi_gtm);
	eval 'sub ata_acpi_stm {
	    my($ap,$stm) = @_;
    	    eval q({ - &ENOSYS; });
	}' unless defined(&ata_acpi_stm);
	eval 'sub ata_acpi_gtm {
	    my($ap,$stm) = @_;
    	    eval q({ - &ENOSYS; });
	}' unless defined(&ata_acpi_gtm);
	eval 'sub ata_acpi_gtm_xfermask {
	    my($dev,$gtm) = @_;
    	    eval q({ 0; });
	}' unless defined(&ata_acpi_gtm_xfermask);
	eval 'sub ata_acpi_cbl_80wire {
	    my($ap,$gtm) = @_;
    	    eval q({ 0; });
	}' unless defined(&ata_acpi_cbl_80wire);
    }
    eval 'sub ATA_BASE_SHT {
        my($drv_name) = @_;
	    eval q(. &module =  &THIS_MODULE, . &name = $drv_name, . &ioctl =  &ata_scsi_ioctl, . &queuecommand =  &ata_scsi_queuecmd, . &can_queue =  &ATA_DEF_QUEUE, . &this_id =  &ATA_SHT_THIS_ID, . &cmd_per_lun =  &ATA_SHT_CMD_PER_LUN, . &emulated =  &ATA_SHT_EMULATED, . &use_clustering =  &ATA_SHT_USE_CLUSTERING, . &proc_name = $drv_name, . &slave_configure =  &ata_scsi_slave_config, . &slave_destroy =  &ata_scsi_slave_destroy, . &bios_param =  &ata_std_bios_param);
    }' unless defined(&ATA_BASE_SHT);
    eval 'sub ATA_NCQ_SHT {
        my($drv_name) = @_;
	    eval q( &ATA_BASE_SHT($drv_name), . &change_queue_depth =  &ata_scsi_change_queue_depth);
    }' unless defined(&ATA_NCQ_SHT);
    if(defined(&CONFIG_SATA_PMP)) {
	eval 'sub sata_pmp_supported {
	    my($ap) = @_;
    	    eval q({  ($ap->{flags}) &  &ATA_FLAG_PMP; });
	}' unless defined(&sata_pmp_supported);
	eval 'sub sata_pmp_attached {
	    my($ap) = @_;
    	    eval q({  ($ap->{nr_pmp_links}) != 0; });
	}' unless defined(&sata_pmp_attached);
	eval 'sub ata_is_host_link {
	    my($link) = @_;
    	    eval q({ $link ==  ($link->{ap}->{link}); });
	}' unless defined(&ata_is_host_link);
    } else {
	eval 'sub sata_pmp_supported {
	    my($ap) = @_;
    	    eval q({  &false; });
	}' unless defined(&sata_pmp_supported);
	eval 'sub sata_pmp_attached {
	    my($ap) = @_;
    	    eval q({  &false; });
	}' unless defined(&sata_pmp_attached);
	eval 'sub ata_is_host_link {
	    my($link) = @_;
    	    eval q({ 1; });
	}' unless defined(&ata_is_host_link);
    }
    eval 'sub sata_srst_pmp {
        my($link) = @_;
	    eval q({  &if ( &sata_pmp_supported( ($link->{ap}))  &&  &ata_is_host_link($link))  &SATA_PMP_CTRL_PORT;  ($link->{pmp}); });
    }' unless defined(&sata_srst_pmp);
    eval 'sub ata_port_printk () {( &ap,  &lv,  &fmt,  &args...)  &printk("%sata%u: " &fmt,  &lv, ( &ap)-> &print_id ,  &args);}' unless defined(&ata_port_printk);
    eval 'sub ata_link_printk () {( &link,  &lv,  &fmt,  &args...)  &do {  &if ( &sata_pmp_attached(( &link)-> &ap))  &printk("%sata%u.%02u: " &fmt,  &lv, ( &link)-> ($ap->{print_id}), ( &link)-> &pmp ,  &args);  &else  &printk("%sata%u: " &fmt,  &lv, ( &link)-> ($ap->{print_id}) ,  &args); }  &while(0);}' unless defined(&ata_link_printk);
    eval 'sub ata_dev_printk () {( &dev,  &lv,  &fmt,  &args...)  &printk("%sata%u.%02u: " &fmt,  &lv, ( &dev)-> ($link->{ap}->{print_id}), ( &dev)-> ($link->{pmp}) + ( &dev)-> &devno ,  &args);}' unless defined(&ata_dev_printk);
    eval 'sub ata_ehi_hotplugged {
        my($ehi) = @_;
	    eval q({  ($ehi->{probe_mask}) |= (1<<  &ATA_MAX_DEVICES) - 1;  ($ehi->{flags}) |=  &ATA_EHI_HOTPLUGGED;  ($ehi->{action}) |=  &ATA_EH_RESET |  &ATA_EH_ENABLE_LINK;  ($ehi->{err_mask}) |=  &AC_ERR_ATA_BUS; });
    }' unless defined(&ata_ehi_hotplugged);
    if(defined(&CONFIG_PCI)) {
    }
    eval 'sub ata_tag_valid {
        my($tag) = @_;
	    eval q({ ($tag <  &ATA_MAX_QUEUE) ? 1: 0; });
    }' unless defined(&ata_tag_valid);
    eval 'sub ata_tag_internal {
        my($tag) = @_;
	    eval q({ $tag ==  &ATA_TAG_INTERNAL; });
    }' unless defined(&ata_tag_internal);
    eval 'sub ata_class_disabled {
        my($class) = @_;
	    eval q({ $class ==  &ATA_DEV_ATA_UNSUP || $class ==  &ATA_DEV_ATAPI_UNSUP || $class ==  &ATA_DEV_PMP_UNSUP || $class ==  &ATA_DEV_SEMB_UNSUP; });
    }' unless defined(&ata_class_disabled);
    eval 'sub ata_class_absent {
        my($class) = @_;
	    eval q({ ! &ata_class_enabled($class)  && ! &ata_class_disabled($class); });
    }' unless defined(&ata_class_absent);
    eval 'sub ata_dev_enabled {
        my($dev) = @_;
	    eval q({  &ata_class_enabled( ($dev->{class})); });
    }' unless defined(&ata_dev_enabled);
    eval 'sub ata_dev_disabled {
        my($dev) = @_;
	    eval q({  &ata_class_disabled( ($dev->{class})); });
    }' unless defined(&ata_dev_disabled);
    eval 'sub ata_dev_absent {
        my($dev) = @_;
	    eval q({  &ata_class_absent( ($dev->{class})); });
    }' unless defined(&ata_dev_absent);
    eval 'sub ata_link_active {
        my($link) = @_;
	    eval q({  &ata_tag_valid( ($link->{active_tag})) ||  ($link->{sactive}); });
    }' unless defined(&ata_link_active);
    eval 'sub ata_link {
        eval q(* &ata_port_first_link(\'struct ata_port\' * &ap) {  &if ( &sata_pmp_attached( &ap))  ($ap->{pmp_link});  ($ap->{link}); });
    }' unless defined(&ata_link);
    eval 'sub ata_link {
        eval q(* &ata_port_next_link(\'struct ata_link\' * &link) { \'struct ata_port\' * &ap =  ($link->{ap});  &if ( &ata_is_host_link( &link)) {  &if (! &sata_pmp_attached( &ap))  &NULL;  ($ap->{pmp_link}); }  &if (++ &link <  ($ap->{nr_pmp_links}) +  ($ap->{pmp_link}))  &link;  &NULL; });
    }' unless defined(&ata_link);
    eval 'sub __ata_port_for_each_link {
        my($lk, $ap) = @_;
	    eval q( &for (($lk) = ($ap)-> &link; ($lk); ($lk) =  &ata_port_next_link($lk)));
    }' unless defined(&__ata_port_for_each_link);
    eval 'sub ata_port_for_each_link {
        my($link, $ap) = @_;
	    eval q( &for (($link) =  &ata_port_first_link($ap); ($link); ($link) =  &ata_port_next_link($link)));
    }' unless defined(&ata_port_for_each_link);
    eval 'sub ata_link_for_each_dev {
        my($dev, $link) = @_;
	    eval q( &for (($dev) = ($link)-> &device; ($dev) < ($link)-> &device +  &ata_link_max_devices($link) || (($dev) =  &NULL); ($dev)++));
    }' unless defined(&ata_link_for_each_dev);
    eval 'sub ata_link_for_each_dev_reverse {
        my($dev, $link) = @_;
	    eval q( &for (($dev) = ($link)-> &device +  &ata_link_max_devices($link) - 1; ($dev) >= ($link)-> &device || (($dev) =  &NULL); ($dev)--));
    }' unless defined(&ata_link_for_each_dev_reverse);
    eval 'sub ata_qc_set_polling {
        my($qc) = @_;
	    eval q({  ($qc->{tf}->{ctl}) |=  &ATA_NIEN; });
    }' unless defined(&ata_qc_set_polling);
    eval 'sub ata_queued_cmd {
        eval q(* &__ata_qc_from_tag(\'struct ata_port\' * &ap, my $tag) {  &if ( &likely( &ata_tag_valid( $tag)))  ($ap->{qcmd[$tag]});  &NULL; });
    }' unless defined(&ata_queued_cmd);
    eval 'sub ata_queued_cmd {
        eval q(* &ata_qc_from_tag(\'struct ata_port\' * &ap, my $tag) { \'struct ata_queued_cmd\' * &qc =  &__ata_qc_from_tag( &ap,  $tag);  &if ( &unlikely(! &qc) || ! ($ap->{ops}->{error_handler}))  &qc;  &if (( ($qc->{flags}) & ( &ATA_QCFLAG_ACTIVE |  &ATA_QCFLAG_FAILED)) ==  &ATA_QCFLAG_ACTIVE)  &qc;  &NULL; });
    }' unless defined(&ata_queued_cmd);
    eval 'sub ata_qc_raw_nbytes {
        my($qc) = @_;
	    eval q({  ($qc->{nbytes}) -  &min( ($qc->{extrabytes}),  ($qc->{nbytes})); });
    }' unless defined(&ata_qc_raw_nbytes);
    eval 'sub ata_tf_init {
        my($dev,$tf) = @_;
	    eval q({  &memset($tf, 0, $sizeof{$tf});  ($tf->{ctl}) =  ($dev->{link}->{ap}->{ctl});  &if ( ($dev->{devno}) == 0)  ($tf->{device}) =  &ATA_DEVICE_OBS;  &else  ($tf->{device}) =  &ATA_DEVICE_OBS |  &ATA_DEV1; });
    }' unless defined(&ata_tf_init);
    eval 'sub ata_qc_reinit {
        my($qc) = @_;
	    eval q({  ($qc->{dma_dir}) =  &DMA_NONE;  ($qc->{sg}) =  &NULL;  ($qc->{flags}) = 0;  ($qc->{cursg}) =  &NULL;  ($qc->{cursg_ofs}) = 0;  ($qc->{nbytes}) =  ($qc->{extrabytes}) =  ($qc->{curbytes}) = 0;  ($qc->{n_elem}) = 0;  ($qc->{err_mask}) = 0;  ($qc->{sect_size}) =  &ATA_SECT_SIZE;  &ata_tf_init( ($qc->{dev}),  ($qc->{tf}));  ($qc->{result_tf}->{command}) =  &ATA_DRDY;  ($qc->{result_tf}->{feature}) = 0; });
    }' unless defined(&ata_qc_reinit);
    eval 'sub ata_try_flush_cache {
        my($dev) = @_;
	    eval q({  &ata_id_wcache_enabled( ($dev->{id})) ||  &ata_id_has_flush( ($dev->{id})) ||  &ata_id_has_flush_ext( ($dev->{id})); });
    }' unless defined(&ata_try_flush_cache);
    eval 'sub ac_err_mask {
        my($status) = @_;
	    eval q({  &if ($status & ( &ATA_BUSY |  &ATA_DRQ))  &AC_ERR_HSM;  &if ($status & ( &ATA_ERR |  &ATA_DF))  &AC_ERR_DEV; 0; });
    }' unless defined(&ac_err_mask);
    eval 'sub __ac_err_mask {
        my($status) = @_;
	    eval q({ my $mask =  &ac_err_mask($status);  &if ( $mask == 0)  &AC_ERR_OTHER;  $mask; });
    }' unless defined(&__ac_err_mask);
    eval 'sub ata_port {
        eval q(* &ata_shost_to_port(\'struct Scsi_Host\' * &host) { * ($host->{hostdata[0]}); });
    }' unless defined(&ata_port);
    eval 'sub ata_check_ready {
        my($status) = @_;
	    eval q({  &if (!($status &  &ATA_BUSY)) 1;  &if ($status == 0xff) - &ENODEV; 0; });
    }' unless defined(&ata_check_ready);
    eval 'sub ata_deadline {
        my($from_jiffies,$timeout_msecs) = @_;
	    eval q({ $from_jiffies +  &msecs_to_jiffies($timeout_msecs); });
    }' unless defined(&ata_deadline);
    eval 'sub ata_using_udma {
        my($adev) = @_;
	    eval q({  &if ( ($adev->{dma_mode}) >=  &XFER_UDMA_0  &&  ($adev->{dma_mode}) <=  &XFER_UDMA_7) 1; 0; });
    }' unless defined(&ata_using_udma);
    eval 'sub ata_dma_enabled {
        my($adev) = @_;
	    eval q({ ( ($adev->{dma_mode}) == 0xff ? 0: 1); });
    }' unless defined(&ata_dma_enabled);
    if(defined(&CONFIG_SATA_PMP)) {
    } else {
	eval 'sub sata_pmp_port_ops () { &sata_port_ops;}' unless defined(&sata_pmp_port_ops);
	eval 'sub sata_pmp_qc_defer_cmd_switch () { &ata_std_qc_defer;}' unless defined(&sata_pmp_qc_defer_cmd_switch);
	eval 'sub sata_pmp_error_handler () { &ata_std_error_handler;}' unless defined(&sata_pmp_error_handler);
    }
    if(defined(&CONFIG_ATA_SFF)) {
	eval 'sub ATA_PIO_SHT {
	    my($drv_name) = @_;
    	    eval q( &ATA_BASE_SHT($drv_name), . &sg_tablesize =  &LIBATA_MAX_PRD, . &dma_boundary =  &ATA_DMA_BOUNDARY);
	}' unless defined(&ATA_PIO_SHT);
	eval 'sub ATA_BMDMA_SHT {
	    my($drv_name) = @_;
    	    eval q( &ATA_BASE_SHT($drv_name), . &sg_tablesize =  &LIBATA_MAX_PRD, . &dma_boundary =  &ATA_DMA_BOUNDARY);
	}' unless defined(&ATA_BMDMA_SHT);
	if(defined(&CONFIG_PCI)) {
	}
	if(defined(&ATA_DEBUG)) {
	}
    }
}
1;
