require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_LINKAGE_H)) {
    eval 'sub _LINUX_LINKAGE_H () {1;}' unless defined(&_LINUX_LINKAGE_H);
    require 'linux/compiler.ph';
    require 'asm/linkage.ph';
    eval 'sub notrace () { &__attribute__(( &no_instrument_function));}' unless defined(&notrace);
    if(defined(&__cplusplus)) {
	eval 'sub CPP_ASMLINKAGE () { &extern "C";}' unless defined(&CPP_ASMLINKAGE);
    } else {
	eval 'sub CPP_ASMLINKAGE () {1;}' unless defined(&CPP_ASMLINKAGE);
    }
    unless(defined(&asmlinkage)) {
	eval 'sub asmlinkage () { &CPP_ASMLINKAGE;}' unless defined(&asmlinkage);
    }
    unless(defined(&asmregparm)) {
	eval 'sub asmregparm () {1;}' unless defined(&asmregparm);
    }
    eval 'sub __page_aligned_data () { &__section(. ($data->{page_aligned}))  &__aligned( &PAGE_SIZE);}' unless defined(&__page_aligned_data);
    eval 'sub __page_aligned_bss () { &__section(. ($bss->{page_aligned}))  &__aligned( &PAGE_SIZE);}' unless defined(&__page_aligned_bss);
    unless(defined(&__ASSEMBLY__)) {
	unless(defined(&asmlinkage_protect)) {
	    eval 'sub asmlinkage_protect () {( &n,  &ret,  &args...)  &do { }  &while (0);}' unless defined(&asmlinkage_protect);
	}
    }
    unless(defined(&__ALIGN)) {
	eval 'sub __ALIGN () {. &align 4,0x90;}' unless defined(&__ALIGN);
	eval 'sub __ALIGN_STR () {".align 4,0x90";}' unless defined(&__ALIGN_STR);
    }
    if(defined(&__ASSEMBLY__)) {
	eval 'sub ALIGN () { &__ALIGN;}' unless defined(&ALIGN);
	eval 'sub ALIGN_STR () { &__ALIGN_STR;}' unless defined(&ALIGN_STR);
	unless(defined(&ENTRY)) {
	    eval 'sub ENTRY {
	        my($name) = @_;
    		eval q(. &globl $name;  &ALIGN; $name:);
	    }' unless defined(&ENTRY);
	}
	unless(defined(&WEAK)) {
	    eval 'sub WEAK {
	        my($name) = @_;
    		eval q(. &weak $name; $name:);
	    }' unless defined(&WEAK);
	}
	eval 'sub KPROBE_ENTRY {
	    my($name) = @_;
    	    eval q(. &pushsection . ($kprobes->{text}), \\"ax\\";  &ENTRY($name));
	}' unless defined(&KPROBE_ENTRY);
	eval 'sub KPROBE_END {
	    my($name) = @_;
    	    eval q( &END($name); . &popsection);
	}' unless defined(&KPROBE_END);
	unless(defined(&END)) {
	    eval 'sub END {
	        my($name) = @_;
    		eval q(. &size $name, .-$name);
	    }' unless defined(&END);
	}
	unless(defined(&ENDPROC)) {
	    eval 'sub ENDPROC {
	        my($name) = @_;
    		eval q(. &type $name, @ &function;  &END($name));
	    }' unless defined(&ENDPROC);
	}
    }
    eval 'sub NORET_TYPE () {1;}' unless defined(&NORET_TYPE);
    eval 'sub ATTRIB_NORET () { &__attribute__(( &noreturn));}' unless defined(&ATTRIB_NORET);
    eval 'sub NORET_AND () { &noreturn,;}' unless defined(&NORET_AND);
}
1;
