require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MEMORY_HOTPLUG_H)) {
    eval 'sub __LINUX_MEMORY_HOTPLUG_H () {1;}' unless defined(&__LINUX_MEMORY_HOTPLUG_H);
    require 'linux/mmzone.ph';
    require 'linux/spinlock.ph';
    require 'linux/notifier.ph';
    if(defined(&CONFIG_MEMORY_HOTPLUG)) {
	eval 'sub SECTION_INFO () {(-1- 1);}' unless defined(&SECTION_INFO);
	eval 'sub MIX_SECTION_INFO () {(-1- 2);}' unless defined(&MIX_SECTION_INFO);
	eval 'sub NODE_INFO () {(-1- 3);}' unless defined(&NODE_INFO);
	eval 'sub zone_span_seqretry {
	    my($zone,$iv) = @_;
    	    eval q({  &read_seqretry( ($zone->{span_seqlock}), $iv); });
	}' unless defined(&zone_span_seqretry);
	eval 'sub zone_span_writelock {
	    my($zone) = @_;
    	    eval q({  &write_seqlock( ($zone->{span_seqlock})); });
	}' unless defined(&zone_span_writelock);
	eval 'sub zone_span_writeunlock {
	    my($zone) = @_;
    	    eval q({  &write_sequnlock( ($zone->{span_seqlock})); });
	}' unless defined(&zone_span_writeunlock);
	eval 'sub zone_seqlock_init {
	    my($zone) = @_;
    	    eval q({  &seqlock_init( ($zone->{span_seqlock})); });
	}' unless defined(&zone_seqlock_init);
	if(defined(&CONFIG_NUMA)) {
	} else {
	    eval 'sub memory_add_physaddr_to_nid {
	        my($start) = @_;
    		eval q({ 0; });
	    }' unless defined(&memory_add_physaddr_to_nid);
	}
	if(defined(&CONFIG_HAVE_ARCH_NODEDATA_EXTENSION)) {
	} else {
	    eval 'sub arch_alloc_nodedata {
	        my($nid) = @_;
    		eval q( &generic_alloc_nodedata($nid));
	    }' unless defined(&arch_alloc_nodedata);
	    eval 'sub arch_free_nodedata {
	        my($pgdat) = @_;
    		eval q( &generic_free_nodedata($pgdat));
	    }' unless defined(&arch_free_nodedata);
	    if(defined(&CONFIG_NUMA)) {
		eval 'sub generic_alloc_nodedata {
		    my($nid) = @_;
    		    eval q(({  &kzalloc($sizeof{ &pg_data_t},  &GFP_KERNEL); }));
		}' unless defined(&generic_alloc_nodedata);
		eval 'sub generic_free_nodedata {
		    my($pgdat) = @_;
    		    eval q( &kfree($pgdat));
		}' unless defined(&generic_free_nodedata);
		eval 'sub arch_refresh_nodedata {
		    my($nid,$pgdat) = @_;
    		    eval q({  $node_data[$nid] = $pgdat; });
		}' unless defined(&arch_refresh_nodedata);
	    } else {
		eval 'sub generic_free_nodedata {
		    my($pgdat) = @_;
    		    eval q({ });
		}' unless defined(&generic_free_nodedata);
		eval 'sub arch_refresh_nodedata {
		    my($nid,$pgdat) = @_;
    		    eval q({ });
		}' unless defined(&arch_refresh_nodedata);
	    }
	}
	if(defined(&CONFIG_SPARSEMEM_VMEMMAP)) {
	    eval 'sub register_page_bootmem_info_node {
	        my($pgdat) = @_;
    		eval q({ });
	    }' unless defined(&register_page_bootmem_info_node);
	    eval 'sub put_page_bootmem {
	        my($page) = @_;
    		eval q({ });
	    }' unless defined(&put_page_bootmem);
	} else {
	}
    } else {
	eval 'sub zone_span_seqbegin {
	    my($zone) = @_;
    	    eval q({ 0; });
	}' unless defined(&zone_span_seqbegin);
	eval 'sub zone_span_seqretry {
	    my($zone,$iv) = @_;
    	    eval q({ 0; });
	}' unless defined(&zone_span_seqretry);
	eval 'sub mhp_notimplemented {
	    my($func) = @_;
    	    eval q({  &printk( &KERN_WARNING \\"%s() called, with CONFIG_MEMORY_HOTPLUG disabled\\\\n\\", $func);  &dump_stack(); - &ENOSYS; });
	}' unless defined(&mhp_notimplemented);
	eval 'sub register_page_bootmem_info_node {
	    my($pgdat) = @_;
    	    eval q({ });
	}' unless defined(&register_page_bootmem_info_node);
    }
    if(defined(&CONFIG_MEMORY_HOTREMOVE)) {
    } else {
	eval 'sub is_mem_section_removable {
	    my($pfn,$nr_pages) = @_;
    	    eval q({ 0; });
	}' unless defined(&is_mem_section_removable);
    }
}
1;
