require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MEMPOLICY_H)) {
    eval 'sub _LINUX_MEMPOLICY_H () {1;}' unless defined(&_LINUX_MEMPOLICY_H);
    require 'linux/errno.ph';
    eval("sub MPOL_DEFAULT () { 0; }") unless defined(&MPOL_DEFAULT);
    eval("sub MPOL_PREFERRED () { 1; }") unless defined(&MPOL_PREFERRED);
    eval("sub MPOL_BIND () { 2; }") unless defined(&MPOL_BIND);
    eval("sub MPOL_INTERLEAVE () { 3; }") unless defined(&MPOL_INTERLEAVE);
    eval("sub MPOL_MAX () { 4; }") unless defined(&MPOL_MAX);
    eval 'sub MPOL_F_STATIC_NODES () {(1<< 15);}' unless defined(&MPOL_F_STATIC_NODES);
    eval 'sub MPOL_F_RELATIVE_NODES () {(1<< 14);}' unless defined(&MPOL_F_RELATIVE_NODES);
    eval 'sub MPOL_MODE_FLAGS () {( &MPOL_F_STATIC_NODES |  &MPOL_F_RELATIVE_NODES);}' unless defined(&MPOL_MODE_FLAGS);
    eval 'sub MPOL_F_NODE () {(1<<0);}' unless defined(&MPOL_F_NODE);
    eval 'sub MPOL_F_ADDR () {(1<<1);}' unless defined(&MPOL_F_ADDR);
    eval 'sub MPOL_F_MEMS_ALLOWED () {(1<<2);}' unless defined(&MPOL_F_MEMS_ALLOWED);
    eval 'sub MPOL_MF_STRICT () {(1<<0);}' unless defined(&MPOL_MF_STRICT);
    eval 'sub MPOL_MF_MOVE () {(1<<1);}' unless defined(&MPOL_MF_MOVE);
    eval 'sub MPOL_MF_MOVE_ALL () {(1<<2);}' unless defined(&MPOL_MF_MOVE_ALL);
    eval 'sub MPOL_MF_INTERNAL () {(1<<3);}' unless defined(&MPOL_MF_INTERNAL);
    eval 'sub MPOL_F_SHARED () {(1<< 0);}' unless defined(&MPOL_F_SHARED);
    eval 'sub MPOL_F_LOCAL () {(1<< 1);}' unless defined(&MPOL_F_LOCAL);
    if(defined(&__KERNEL__)) {
	require 'linux/mmzone.ph';
	require 'linux/slab.ph';
	require 'linux/rbtree.ph';
	require 'linux/spinlock.ph';
	require 'linux/nodemask.ph';
	require 'linux/pagemap.ph';
	if(defined(&CONFIG_NUMA)) {
	    eval 'sub mpol_put {
	        my($pol) = @_;
    		eval q({  &if ($pol)  &__mpol_put($pol); });
	    }' unless defined(&mpol_put);
	    eval 'sub mpol_cond_put {
	        my($pol) = @_;
    		eval q({  &if ( &mpol_needs_cond_ref($pol))  &__mpol_put($pol); });
	    }' unless defined(&mpol_cond_put);
	    eval 'sub mempolicy {
	        eval q(* &mpol_cond_copy(\'struct mempolicy\' * &tompol, \'struct mempolicy\' * &frompol) {  &if (! &frompol)  &frompol;  &__mpol_cond_copy( &tompol,  &frompol); });
	    }' unless defined(&mempolicy);
	    eval 'sub mempolicy {
	        eval q(* &mpol_dup(\'struct mempolicy\' * &pol) {  &if ( &pol)  &pol =  &__mpol_dup( &pol);  &pol; });
	    }' unless defined(&mempolicy);
	    eval 'sub vma_policy {
	        my($vma) = @_;
    		eval q((($vma)-> &vm_policy));
	    }' unless defined(&vma_policy);
	    eval 'sub vma_set_policy {
	        my($vma, $pol) = @_;
    		eval q((($vma)-> &vm_policy = ($pol)));
	    }' unless defined(&vma_set_policy);
	    eval 'sub mpol_get {
	        my($pol) = @_;
    		eval q({  &if ($pol)  &atomic_inc( ($pol->{refcnt})); });
	    }' unless defined(&mpol_get);
	    eval 'sub mpol_equal {
	        my($a,$b) = @_;
    		eval q({  &if ($a == $b) 1;  &__mpol_equal($a, $b); });
	    }' unless defined(&mpol_equal);
	    eval 'sub check_highest_zone {
	        my($k) = @_;
    		eval q({  &if ($k >  &policy_zone  && $k !=  &ZONE_MOVABLE)  &policy_zone = $k; });
	    }' unless defined(&check_highest_zone);
	    if(defined(&CONFIG_TMPFS)) {
	    }
	} else {
	    eval 'sub mpol_equal {
	        my($a,$b) = @_;
    		eval q({ 1; });
	    }' unless defined(&mpol_equal);
	    eval 'sub mpol_put {
	        my($p) = @_;
    		eval q({ });
	    }' unless defined(&mpol_put);
	    eval 'sub mpol_cond_put {
	        my($pol) = @_;
    		eval q({ });
	    }' unless defined(&mpol_cond_put);
	    eval 'sub mempolicy {
	        eval q(* &mpol_cond_copy(\'struct mempolicy\' * &to, \'struct mempolicy\' * &from) {  &from; });
	    }' unless defined(&mempolicy);
	    eval 'sub mpol_get {
	        my($pol) = @_;
    		eval q({ });
	    }' unless defined(&mpol_get);
	    eval 'sub mempolicy {
	        eval q(* &mpol_dup(\'struct mempolicy\' * &old) {  &NULL; });
	    }' unless defined(&mempolicy);
	    eval 'sub mpol_set_shared_policy {
	        my($info,$vma,$new) = @_;
    		eval q({ - &EINVAL; });
	    }' unless defined(&mpol_set_shared_policy);
	    eval 'sub mpol_shared_policy_init {
	        my($sp,$mpol) = @_;
    		eval q({ });
	    }' unless defined(&mpol_shared_policy_init);
	    eval 'sub mpol_free_shared_policy {
	        my($p) = @_;
    		eval q({ });
	    }' unless defined(&mpol_free_shared_policy);
	    eval 'sub mpol_shared_policy_lookup {
	        my($sp,$idx) = @_;
    		eval q({  &NULL; });
	    }' unless defined(&mpol_shared_policy_lookup);
	    eval 'sub vma_policy {
	        my($vma) = @_;
    		eval q( &NULL);
	    }' unless defined(&vma_policy);
	    eval 'sub vma_set_policy {
	        my($vma, $pol) = @_;
    		eval q( &do {}  &while(0));
	    }' unless defined(&vma_set_policy);
	    eval 'sub numa_policy_init {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&numa_policy_init);
	    eval 'sub numa_default_policy {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&numa_default_policy);
	    eval 'sub mpol_rebind_task {
	        my($tsk,$new) = @_;
    		eval q({ });
	    }' unless defined(&mpol_rebind_task);
	    eval 'sub mpol_rebind_mm {
	        my($mm,$new) = @_;
    		eval q({ });
	    }' unless defined(&mpol_rebind_mm);
	    eval 'sub mpol_fix_fork_child_flag {
	        my($p) = @_;
    		eval q({ });
	    }' unless defined(&mpol_fix_fork_child_flag);
	    eval 'sub zonelist {
	        eval q(* &huge_zonelist(\'struct vm_area_struct\' * &vma, my $addr,  &gfp_t  &gfp_flags, \'struct mempolicy\' ** &mpol,  &nodemask_t ** &nodemask) { * &mpol =  &NULL; * &nodemask =  &NULL;  &node_zonelist(0,  &gfp_flags); });
	    }' unless defined(&zonelist);
	    eval 'sub do_migrate_pages {
	        my($mm,$from_nodes,$to_nodes,$flags) = @_;
    		eval q({ 0; });
	    }' unless defined(&do_migrate_pages);
	    eval 'sub check_highest_zone {
	        my($k) = @_;
    		eval q({ });
	    }' unless defined(&check_highest_zone);
	    if(defined(&CONFIG_TMPFS)) {
		eval 'sub mpol_parse_str {
		    my($str,$mpol,$no_context) = @_;
    		    eval q({ 1; });
		}' unless defined(&mpol_parse_str);
		eval 'sub mpol_to_str {
		    my($buffer,$maxlen,$pol,$no_context) = @_;
    		    eval q({ 0; });
		}' unless defined(&mpol_to_str);
	    }
	}
    }
}
1;
