require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MMU_NOTIFIER_H)) {
    eval 'sub _LINUX_MMU_NOTIFIER_H () {1;}' unless defined(&_LINUX_MMU_NOTIFIER_H);
    require 'linux/list.ph';
    require 'linux/spinlock.ph';
    require 'linux/mm_types.ph';
    if(defined(&CONFIG_MMU_NOTIFIER)) {
	eval 'sub mm_has_notifiers {
	    my($mm) = @_;
    	    eval q({  &unlikely( ($mm->{mmu_notifier_mm})); });
	}' unless defined(&mm_has_notifiers);
	eval 'sub mmu_notifier_release {
	    my($mm) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_release($mm); });
	}' unless defined(&mmu_notifier_release);
	eval 'sub mmu_notifier_clear_flush_young {
	    my($mm,$address) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_clear_flush_young($mm, $address); 0; });
	}' unless defined(&mmu_notifier_clear_flush_young);
	eval 'sub mmu_notifier_invalidate_page {
	    my($mm,$address) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_invalidate_page($mm, $address); });
	}' unless defined(&mmu_notifier_invalidate_page);
	eval 'sub mmu_notifier_invalidate_range_start {
	    my($mm,$start,$end) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_invalidate_range_start($mm, $start, $end); });
	}' unless defined(&mmu_notifier_invalidate_range_start);
	eval 'sub mmu_notifier_invalidate_range_end {
	    my($mm,$start,$end) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_invalidate_range_end($mm, $start, $end); });
	}' unless defined(&mmu_notifier_invalidate_range_end);
	eval 'sub mmu_notifier_mm_init {
	    my($mm) = @_;
    	    eval q({  ($mm->{mmu_notifier_mm}) =  &NULL; });
	}' unless defined(&mmu_notifier_mm_init);
	eval 'sub mmu_notifier_mm_destroy {
	    my($mm) = @_;
    	    eval q({  &if ( &mm_has_notifiers($mm))  &__mmu_notifier_mm_destroy($mm); });
	}' unless defined(&mmu_notifier_mm_destroy);
	eval 'sub ptep_clear_flush_notify {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte; \'struct vm_area_struct\' * &___vma = $__vma; \'unsigned long ___address\' = $__address;  &__pte =  &ptep_clear_flush( &___vma,  &___address, $__ptep);  &mmu_notifier_invalidate_page( ($_$__vma->{vm_mm}),  &___address);  &__pte; }));
	}' unless defined(&ptep_clear_flush_notify);
	eval 'sub ptep_clear_flush_young_notify {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({ \'int\'  &__young; \'struct vm_area_struct\' * &___vma = $__vma; \'unsigned long ___address\' = $__address;  &__young =  &ptep_clear_flush_young( &___vma,  &___address, $__ptep);  &__young |=  &mmu_notifier_clear_flush_young( ($_$__vma->{vm_mm}),  &___address);  &__young; }));
	}' unless defined(&ptep_clear_flush_young_notify);
    } else {
	eval 'sub mmu_notifier_release {
	    my($mm) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_release);
	eval 'sub mmu_notifier_clear_flush_young {
	    my($mm,$address) = @_;
    	    eval q({ 0; });
	}' unless defined(&mmu_notifier_clear_flush_young);
	eval 'sub mmu_notifier_invalidate_page {
	    my($mm,$address) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_invalidate_page);
	eval 'sub mmu_notifier_invalidate_range_start {
	    my($mm,$start,$end) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_invalidate_range_start);
	eval 'sub mmu_notifier_invalidate_range_end {
	    my($mm,$start,$end) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_invalidate_range_end);
	eval 'sub mmu_notifier_mm_init {
	    my($mm) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_mm_init);
	eval 'sub mmu_notifier_mm_destroy {
	    my($mm) = @_;
    	    eval q({ });
	}' unless defined(&mmu_notifier_mm_destroy);
	eval 'sub ptep_clear_flush_young_notify () { &ptep_clear_flush_young;}' unless defined(&ptep_clear_flush_young_notify);
	eval 'sub ptep_clear_flush_notify () { &ptep_clear_flush;}' unless defined(&ptep_clear_flush_notify);
    }
}
1;
