require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MMZONE_H)) {
    eval 'sub _LINUX_MMZONE_H () {1;}' unless defined(&_LINUX_MMZONE_H);
    unless(defined(&__ASSEMBLY__)) {
	unless(defined(&__GENERATING_BOUNDS_H)) {
	    require 'linux/spinlock.ph';
	    require 'linux/list.ph';
	    require 'linux/wait.ph';
	    require 'linux/bitops.ph';
	    require 'linux/cache.ph';
	    require 'linux/threads.ph';
	    require 'linux/numa.ph';
	    require 'linux/init.ph';
	    require 'linux/seqlock.ph';
	    require 'linux/nodemask.ph';
	    require 'linux/pageblock-flags.ph';
	    require 'linux/bounds.ph';
	    require 'asm/atomic.ph';
	    require 'asm/page.ph';
	    unless(defined(&CONFIG_FORCE_MAX_ZONEORDER)) {
		eval 'sub MAX_ORDER () {11;}' unless defined(&MAX_ORDER);
	    } else {
		eval 'sub MAX_ORDER () { &CONFIG_FORCE_MAX_ZONEORDER;}' unless defined(&MAX_ORDER);
	    }
	    eval 'sub MAX_ORDER_NR_PAGES () {(1<< ( &MAX_ORDER - 1));}' unless defined(&MAX_ORDER_NR_PAGES);
	    eval 'sub PAGE_ALLOC_COSTLY_ORDER () {3;}' unless defined(&PAGE_ALLOC_COSTLY_ORDER);
	    eval 'sub MIGRATE_UNMOVABLE () {0;}' unless defined(&MIGRATE_UNMOVABLE);
	    eval 'sub MIGRATE_RECLAIMABLE () {1;}' unless defined(&MIGRATE_RECLAIMABLE);
	    eval 'sub MIGRATE_MOVABLE () {2;}' unless defined(&MIGRATE_MOVABLE);
	    eval 'sub MIGRATE_RESERVE () {3;}' unless defined(&MIGRATE_RESERVE);
	    eval 'sub MIGRATE_ISOLATE () {4;}' unless defined(&MIGRATE_ISOLATE);
	    eval 'sub MIGRATE_TYPES () {5;}' unless defined(&MIGRATE_TYPES);
	    eval 'sub for_each_migratetype_order {
	        my($order, $type) = @_;
    		eval q( &for ($order = 0; $order <  &MAX_ORDER; $order++)  &for ($type = 0; $type <  &MIGRATE_TYPES; $type++));
	    }' unless defined(&for_each_migratetype_order);
	    eval 'sub get_pageblock_migratetype {
	        my($page) = @_;
    		eval q({  &if ( &unlikely( &page_group_by_mobility_disabled))  &MIGRATE_UNMOVABLE;  &get_pageblock_flags_group($page,  &PB_migrate,  &PB_migrate_end); });
	    }' unless defined(&get_pageblock_migratetype);
	    if(defined( &CONFIG_SMP)) {
		eval 'sub ZONE_PADDING {
		    my($name) = @_;
    		    eval q(\'struct zone_padding\' $name;);
		}' unless defined(&ZONE_PADDING);
	    } else {
		eval 'sub ZONE_PADDING {
		    my($name) = @_;
    		    eval q();
		}' unless defined(&ZONE_PADDING);
	    }
	    eval("sub NR_FREE_PAGES () { 0; }") unless defined(&NR_FREE_PAGES);
	    eval("sub NR_INACTIVE () { 1; }") unless defined(&NR_INACTIVE);
	    eval("sub NR_ACTIVE () { 2; }") unless defined(&NR_ACTIVE);
	    eval("sub NR_ANON_PAGES () { 3; }") unless defined(&NR_ANON_PAGES);
	    eval("sub NR_FILE_MAPPED () { 4; }") unless defined(&NR_FILE_MAPPED);
	    eval("sub NR_FILE_PAGES () { 5; }") unless defined(&NR_FILE_PAGES);
	    eval("sub NR_FILE_DIRTY () { 6; }") unless defined(&NR_FILE_DIRTY);
	    eval("sub NR_WRITEBACK () { 7; }") unless defined(&NR_WRITEBACK);
	    eval("sub NR_SLAB_RECLAIMABLE () { 8; }") unless defined(&NR_SLAB_RECLAIMABLE);
	    eval("sub NR_SLAB_UNRECLAIMABLE () { 9; }") unless defined(&NR_SLAB_UNRECLAIMABLE);
	    eval("sub NR_PAGETABLE () { 10; }") unless defined(&NR_PAGETABLE);
	    eval("sub NR_UNSTABLE_NFS () { 11; }") unless defined(&NR_UNSTABLE_NFS);
	    eval("sub NR_BOUNCE () { 12; }") unless defined(&NR_BOUNCE);
	    eval("sub NR_VMSCAN_WRITE () { 13; }") unless defined(&NR_VMSCAN_WRITE);
	    eval("sub NR_WRITEBACK_TEMP () { 14; }") unless defined(&NR_WRITEBACK_TEMP);
	    eval("sub NR_VM_ZONE_STAT_ITEMS () { 15; }") unless defined(&NR_VM_ZONE_STAT_ITEMS);
	    if(defined(&CONFIG_NUMA)) {
	    }
	    if(defined(&CONFIG_SMP)) {
	    }
	    if(defined(&CONFIG_NUMA)) {
		eval 'sub zone_pcp {
		    my($__z, $__cpu) = @_;
    		    eval q((($__z)-> $pageset[($__cpu)]));
		}' unless defined(&zone_pcp);
	    } else {
		eval 'sub zone_pcp {
		    my($__z, $__cpu) = @_;
    		    eval q((($__z)-> $pageset[($__cpu)]));
		}' unless defined(&zone_pcp);
	    }
	}
	eval("sub ZONE_NORMAL () { 0; }") unless defined(&ZONE_NORMAL);
	eval("sub ZONE_MOVABLE () { 1; }") unless defined(&ZONE_MOVABLE);
	eval("sub __MAX_NR_ZONES () { 2; }") unless defined(&__MAX_NR_ZONES);
	unless(defined(&__GENERATING_BOUNDS_H)) {
	    if((defined(&MAX_NR_ZONES) ? &MAX_NR_ZONES : undef) < 2) {
		eval 'sub ZONES_SHIFT () {0;}' unless defined(&ZONES_SHIFT);
	    }
 elsif((defined(&MAX_NR_ZONES) ? &MAX_NR_ZONES : undef) <= 2) {
		eval 'sub ZONES_SHIFT () {1;}' unless defined(&ZONES_SHIFT);
	    }
 elsif((defined(&MAX_NR_ZONES) ? &MAX_NR_ZONES : undef) <= 4) {
		eval 'sub ZONES_SHIFT () {2;}' unless defined(&ZONES_SHIFT);
	    } else {
		die("ZONES_SHIFT\ \-\-\ too\ many\ zones\ configured\ adjust\ calculation");
	    }
	    if(defined(&CONFIG_NUMA)) {
	    } else {
	    }
	    if(defined(&CONFIG_MEMORY_HOTPLUG)) {
	    }
	    unless(defined(&CONFIG_SPARSEMEM)) {
	    }
	    eval("sub ZONE_ALL_UNRECLAIMABLE () { 0; }") unless defined(&ZONE_ALL_UNRECLAIMABLE);
	    eval("sub ZONE_RECLAIM_LOCKED () { 1; }") unless defined(&ZONE_RECLAIM_LOCKED);
	    eval("sub ZONE_OOM_LOCKED () { 2; }") unless defined(&ZONE_OOM_LOCKED);
	    eval 'sub zone_set_flag {
	        my($zone,$flag) = @_;
    		eval q({  &set_bit($flag,  ($zone->{flags})); });
	    }' unless defined(&zone_set_flag);
	    eval 'sub zone_test_and_set_flag {
	        my($zone,$flag) = @_;
    		eval q({  &test_and_set_bit($flag,  ($zone->{flags})); });
	    }' unless defined(&zone_test_and_set_flag);
	    eval 'sub zone_clear_flag {
	        my($zone,$flag) = @_;
    		eval q({  &clear_bit($flag,  ($zone->{flags})); });
	    }' unless defined(&zone_clear_flag);
	    eval 'sub zone_is_all_unreclaimable {
	        my($zone) = @_;
    		eval q({  &test_bit( &ZONE_ALL_UNRECLAIMABLE,  ($zone->{flags})); });
	    }' unless defined(&zone_is_all_unreclaimable);
	    eval 'sub zone_is_reclaim_locked {
	        my($zone) = @_;
    		eval q({  &test_bit( &ZONE_RECLAIM_LOCKED,  ($zone->{flags})); });
	    }' unless defined(&zone_is_reclaim_locked);
	    eval 'sub zone_is_oom_locked {
	        my($zone) = @_;
    		eval q({  &test_bit( &ZONE_OOM_LOCKED,  ($zone->{flags})); });
	    }' unless defined(&zone_is_oom_locked);
	    eval 'sub DEF_PRIORITY () {12;}' unless defined(&DEF_PRIORITY);
	    eval 'sub MAX_ZONES_PER_ZONELIST () {( &MAX_NUMNODES *  &MAX_NR_ZONES);}' unless defined(&MAX_ZONES_PER_ZONELIST);
	    if(defined(&CONFIG_NUMA)) {
		eval 'sub MAX_ZONELISTS () {2;}' unless defined(&MAX_ZONELISTS);
	    } else {
		eval 'sub MAX_ZONELISTS () {1;}' unless defined(&MAX_ZONELISTS);
	    }
	    if(defined(&CONFIG_NUMA)) {
	    }
	    if(defined(&CONFIG_ARCH_POPULATES_NODE_MAP)) {
	    }
	    unless(defined(&CONFIG_DISCONTIGMEM)) {
	    }
	    if(defined(&CONFIG_FLAT_NODE_MEM_MAP)) {
	    }
	    if(defined(&CONFIG_MEMORY_HOTPLUG)) {
	    }
	    eval 'sub node_present_pages {
	        my($nid) = @_;
    		eval q(( &NODE_DATA($nid)-> &node_present_pages));
	    }' unless defined(&node_present_pages);
	    eval 'sub node_spanned_pages {
	        my($nid) = @_;
    		eval q(( &NODE_DATA($nid)-> &node_spanned_pages));
	    }' unless defined(&node_spanned_pages);
	    if(defined(&CONFIG_FLAT_NODE_MEM_MAP)) {
		eval 'sub pgdat_page_nr {
		    my($pgdat, $pagenr) = @_;
    		    eval q((($pgdat)-> &node_mem_map + ($pagenr)));
		}' unless defined(&pgdat_page_nr);
	    } else {
		eval 'sub pgdat_page_nr {
		    my($pgdat, $pagenr) = @_;
    		    eval q( &pfn_to_page(($pgdat)-> &node_start_pfn + ($pagenr)));
		}' unless defined(&pgdat_page_nr);
	    }
	    eval 'sub nid_page_nr {
	        my($nid, $pagenr) = @_;
    		eval q( &pgdat_page_nr( &NODE_DATA($nid),($pagenr)));
	    }' unless defined(&nid_page_nr);
	    require 'linux/memory_hotplug.ph';
	    eval("sub MEMMAP_EARLY () { 0; }") unless defined(&MEMMAP_EARLY);
	    eval("sub MEMMAP_HOTPLUG () { 1; }") unless defined(&MEMMAP_HOTPLUG);
	    if(defined(&CONFIG_HAVE_MEMORY_PRESENT)) {
	    } else {
	    }
	    if(defined(&CONFIG_NEED_NODE_MEMMAP_SIZE)) {
	    }
	    eval 'sub zone_idx {
	        my($zone) = @_;
    		eval q((($zone) - ($zone)-> ($zone_pgdat->{node_zones})));
	    }' unless defined(&zone_idx);
	    eval 'sub populated_zone {
	        my($zone) = @_;
    		eval q({ (!! ($zone->{present_pages})); });
	    }' unless defined(&populated_zone);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub zone_movable_is_highmem {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&zone_movable_is_highmem);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub is_highmem_idx {
	        my($idx) = @_;
    		eval q({ });
	    }' unless defined(&is_highmem_idx);
	    eval 'sub is_normal_idx {
	        my($idx) = @_;
    		eval q({ ($idx ==  &ZONE_NORMAL); });
	    }' unless defined(&is_normal_idx);
	    if(defined(&CONFIG_HIGHMEM)) {
	    } else {
	    }
	    eval 'sub is_normal {
	        my($zone) = @_;
    		eval q({ $zone ==  ($zone->{zone_pgdat}->{node_zones}) +  &ZONE_NORMAL; });
	    }' unless defined(&is_normal);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub is_dma32 {
	        my($zone) = @_;
    		eval q({ });
	    }' unless defined(&is_dma32);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub is_dma {
	        my($zone) = @_;
    		eval q({ });
	    }' unless defined(&is_dma);
	    eval 'sub NUMA_ZONELIST_ORDER_LEN () {16;}' unless defined(&NUMA_ZONELIST_ORDER_LEN);
	    require 'linux/topology.ph';
	    unless(defined(&numa_node_id)) {
		eval 'sub numa_node_id () {
		    eval q(( &cpu_to_node( &raw_smp_processor_id())));
		}' unless defined(&numa_node_id);
	    }
	    unless(defined(&CONFIG_NEED_MULTIPLE_NODES)) {
		eval 'sub NODE_DATA {
		    my($nid) = @_;
    		    eval q(( &contig_page_data));
		}' unless defined(&NODE_DATA);
		eval 'sub NODE_MEM_MAP {
		    my($nid) = @_;
    		    eval q( &mem_map);
		}' unless defined(&NODE_MEM_MAP);
	    } else {
		require 'asm/mmzone.ph';
	    }
	    eval 'sub for_each_online_pgdat {
	        my($pgdat) = @_;
    		eval q( &for ($pgdat =  &first_online_pgdat(); $pgdat; $pgdat =  &next_online_pgdat($pgdat)));
	    }' unless defined(&for_each_online_pgdat);
	    eval 'sub for_each_zone {
	        my($zone) = @_;
    		eval q( &for ($zone = ( &first_online_pgdat())-> &node_zones; $zone; $zone =  &next_zone($zone)));
	    }' unless defined(&for_each_zone);
	    eval 'sub zone {
	        eval q(* &zonelist_zone(\'struct zoneref\' * &zoneref) {  ($zoneref->{zone}); });
	    }' unless defined(&zone);
	    eval 'sub zonelist_zone_idx {
	        my($zoneref) = @_;
    		eval q({  ($zoneref->{zone_idx}); });
	    }' unless defined(&zonelist_zone_idx);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub zonelist_node_idx {
	        my($zoneref) = @_;
    		eval q({ });
	    }' unless defined(&zonelist_node_idx);
	    eval 'sub for_each_zone_zonelist_nodemask {
	        my($zone, $z, $zlist, $highidx, $nodemask) = @_;
    		eval q( &for ($z =  &first_zones_zonelist($zlist, $highidx, $nodemask, $zone); $zone; $z =  &next_zones_zonelist(++$z, $highidx, $nodemask, $zone)));
	    }' unless defined(&for_each_zone_zonelist_nodemask);
	    eval 'sub for_each_zone_zonelist {
	        my($zone, $z, $zlist, $highidx) = @_;
    		eval q( &for_each_zone_zonelist_nodemask($zone, $z, $zlist, $highidx,  &NULL));
	    }' unless defined(&for_each_zone_zonelist);
	    if(defined(&CONFIG_SPARSEMEM)) {
		require 'asm/sparsemem.ph';
	    }
	    if(!defined( &CONFIG_HAVE_ARCH_EARLY_PFN_TO_NID)  && !defined( &CONFIG_ARCH_POPULATES_NODE_MAP)) {
		eval 'sub early_pfn_to_nid {
		    my($pfn) = @_;
    		    eval q({ 0; });
		}' unless defined(&early_pfn_to_nid);
	    }
	    if(defined(&CONFIG_FLATMEM)) {
		eval 'sub pfn_to_nid {
		    my($pfn) = @_;
    		    eval q((0));
		}' unless defined(&pfn_to_nid);
	    }
	    eval 'sub pfn_to_section_nr {
	        my($pfn) = @_;
    		eval q((($pfn) >>  &PFN_SECTION_SHIFT));
	    }' unless defined(&pfn_to_section_nr);
	    eval 'sub section_nr_to_pfn {
	        my($sec) = @_;
    		eval q((($sec) <<  &PFN_SECTION_SHIFT));
	    }' unless defined(&section_nr_to_pfn);
	    if(defined(&CONFIG_SPARSEMEM)) {
		eval 'sub SECTIONS_SHIFT () {( &MAX_PHYSMEM_BITS -  &SECTION_SIZE_BITS);}' unless defined(&SECTIONS_SHIFT);
		eval 'sub PA_SECTION_SHIFT () {( &SECTION_SIZE_BITS);}' unless defined(&PA_SECTION_SHIFT);
		eval 'sub PFN_SECTION_SHIFT () {( &SECTION_SIZE_BITS -  &PAGE_SHIFT);}' unless defined(&PFN_SECTION_SHIFT);
		eval 'sub NR_MEM_SECTIONS () {(1 <<  &SECTIONS_SHIFT);}' unless defined(&NR_MEM_SECTIONS);
		eval 'sub PAGES_PER_SECTION () {(1 <<  &PFN_SECTION_SHIFT);}' unless defined(&PAGES_PER_SECTION);
		eval 'sub PAGE_SECTION_MASK () {(~( &PAGES_PER_SECTION-1));}' unless defined(&PAGE_SECTION_MASK);
		eval 'sub SECTION_BLOCKFLAGS_BITS () {((1 << ( &PFN_SECTION_SHIFT -  &pageblock_order)) *  &NR_PAGEBLOCK_BITS);}' unless defined(&SECTION_BLOCKFLAGS_BITS);
		if(((defined(&MAX_ORDER) ? &MAX_ORDER : undef) - 1+ (defined(&PAGE_SHIFT) ? &PAGE_SHIFT : undef)) > (defined(&SECTION_SIZE_BITS) ? &SECTION_SIZE_BITS : undef)) {
		    die("Allocator\ MAX_ORDER\ exceeds\ SECTION_SIZE");
		}
		if(defined(&CONFIG_SPARSEMEM_EXTREME)) {
		    eval 'sub SECTIONS_PER_ROOT () {( &PAGE_SIZE / $sizeof{\'struct mem_section\'});}' unless defined(&SECTIONS_PER_ROOT);
		} else {
		    eval 'sub SECTIONS_PER_ROOT () {1;}' unless defined(&SECTIONS_PER_ROOT);
		}
		eval 'sub SECTION_NR_TO_ROOT {
		    my($sec) = @_;
    		    eval q((($sec) /  &SECTIONS_PER_ROOT));
		}' unless defined(&SECTION_NR_TO_ROOT);
		eval 'sub NR_SECTION_ROOTS () {( &NR_MEM_SECTIONS /  &SECTIONS_PER_ROOT);}' unless defined(&NR_SECTION_ROOTS);
		eval 'sub SECTION_ROOT_MASK () {( &SECTIONS_PER_ROOT - 1);}' unless defined(&SECTION_ROOT_MASK);
		if(defined(&CONFIG_SPARSEMEM_EXTREME)) {
		} else {
		}
		eval 'sub mem_section {
		    eval q(* &__nr_to_section {  &if (! $mem_section[ &SECTION_NR_TO_ROOT( &nr)])  &NULL;  $mem_section[ &SECTION_NR_TO_ROOT( &nr)][ &nr &  &SECTION_ROOT_MASK]; });
		}' unless defined(&mem_section);
		eval 'sub SECTION_MARKED_PRESENT () {(1<<0);}' unless defined(&SECTION_MARKED_PRESENT);
		eval 'sub SECTION_HAS_MEM_MAP () {(1<<1);}' unless defined(&SECTION_HAS_MEM_MAP);
		eval 'sub SECTION_MAP_LAST_BIT () {(1<<2);}' unless defined(&SECTION_MAP_LAST_BIT);
		eval 'sub SECTION_MAP_MASK () {(~( &SECTION_MAP_LAST_BIT-1));}' unless defined(&SECTION_MAP_MASK);
		eval 'sub SECTION_NID_SHIFT () {2;}' unless defined(&SECTION_NID_SHIFT);
		eval 'sub page {
		    eval q(* &__section_mem_map_addr(\'struct mem_section\' * &section) { my $map =  ($section->{section_mem_map});  $map &=  &SECTION_MAP_MASK;  $map; });
		}' unless defined(&page);
		eval 'sub present_section {
		    my($section) = @_;
    		    eval q({ ($section  && ( ($section->{section_mem_map}) &  &SECTION_MARKED_PRESENT)); });
		}' unless defined(&present_section);
		eval 'sub present_section_nr {
		    my($nr) = @_;
    		    eval q({  &present_section( &__nr_to_section($nr)); });
		}' unless defined(&present_section_nr);
		eval 'sub valid_section {
		    my($section) = @_;
    		    eval q({ ($section  && ( ($section->{section_mem_map}) &  &SECTION_HAS_MEM_MAP)); });
		}' unless defined(&valid_section);
		eval 'sub valid_section_nr {
		    my($nr) = @_;
    		    eval q({  &valid_section( &__nr_to_section($nr)); });
		}' unless defined(&valid_section_nr);
		eval 'sub mem_section {
		    eval q(* &__pfn_to_section {  &__nr_to_section( &pfn_to_section_nr( &pfn)); });
		}' unless defined(&mem_section);
		eval 'sub pfn_valid {
		    my($pfn) = @_;
    		    eval q({  &if ( &pfn_to_section_nr($pfn) >=  &NR_MEM_SECTIONS) 0;  &valid_section( &__nr_to_section( &pfn_to_section_nr($pfn))); });
		}' unless defined(&pfn_valid);
		eval 'sub pfn_present {
		    my($pfn) = @_;
    		    eval q({  &if ( &pfn_to_section_nr($pfn) >=  &NR_MEM_SECTIONS) 0;  &present_section( &__nr_to_section( &pfn_to_section_nr($pfn))); });
		}' unless defined(&pfn_present);
		if(defined(&CONFIG_NUMA)) {
		    eval 'sub pfn_to_nid {
		        my($pfn) = @_;
    			eval q(({ \'unsigned long __pfn_to_nid_pfn\' = ($pfn);  &page_to_nid( &pfn_to_page( &__pfn_to_nid_pfn)); }));
		    }' unless defined(&pfn_to_nid);
		} else {
		    eval 'sub pfn_to_nid {
		        my($pfn) = @_;
    			eval q((0));
		    }' unless defined(&pfn_to_nid);
		}
		eval 'sub early_pfn_valid {
		    my($pfn) = @_;
    		    eval q( &pfn_valid($pfn));
		}' unless defined(&early_pfn_valid);
	    } else {
		eval 'sub sparse_init () {
		    eval q( &do {}  &while (0));
		}' unless defined(&sparse_init);
		eval 'sub sparse_index_init {
		    my($_sec, $_nid) = @_;
    		    eval q( &do {}  &while (0));
		}' unless defined(&sparse_index_init);
	    }
	    if(defined(&CONFIG_NODES_SPAN_OTHER_NODES)) {
		eval 'sub early_pfn_in_nid {
		    my($pfn, $nid) = @_;
    		    eval q(( &early_pfn_to_nid($pfn) == ($nid)));
		}' unless defined(&early_pfn_in_nid);
	    } else {
		eval 'sub early_pfn_in_nid {
		    my($pfn, $nid) = @_;
    		    eval q((1));
		}' unless defined(&early_pfn_in_nid);
	    }
	    unless(defined(&early_pfn_valid)) {
		eval 'sub early_pfn_valid {
		    my($pfn) = @_;
    		    eval q((1));
		}' unless defined(&early_pfn_valid);
	    }
	    if(defined(&CONFIG_HOLES_IN_ZONE)) {
		eval 'sub pfn_valid_within {
		    my($pfn) = @_;
    		    eval q( &pfn_valid($pfn));
		}' unless defined(&pfn_valid_within);
	    } else {
		eval 'sub pfn_valid_within {
		    my($pfn) = @_;
    		    eval q((1));
		}' unless defined(&pfn_valid_within);
	    }
	}
    }
}
1;
