require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MROUTE6_H)) {
    eval 'sub __LINUX_MROUTE6_H () {1;}' unless defined(&__LINUX_MROUTE6_H);
    require 'linux/types.ph';
    require 'linux/sockios.ph';
    eval 'sub MRT6_BASE () {200;}' unless defined(&MRT6_BASE);
    eval 'sub MRT6_INIT () {( &MRT6_BASE);}' unless defined(&MRT6_INIT);
    eval 'sub MRT6_DONE () {( &MRT6_BASE+1);}' unless defined(&MRT6_DONE);
    eval 'sub MRT6_ADD_MIF () {( &MRT6_BASE+2);}' unless defined(&MRT6_ADD_MIF);
    eval 'sub MRT6_DEL_MIF () {( &MRT6_BASE+3);}' unless defined(&MRT6_DEL_MIF);
    eval 'sub MRT6_ADD_MFC () {( &MRT6_BASE+4);}' unless defined(&MRT6_ADD_MFC);
    eval 'sub MRT6_DEL_MFC () {( &MRT6_BASE+5);}' unless defined(&MRT6_DEL_MFC);
    eval 'sub MRT6_VERSION () {( &MRT6_BASE+6);}' unless defined(&MRT6_VERSION);
    eval 'sub MRT6_ASSERT () {( &MRT6_BASE+7);}' unless defined(&MRT6_ASSERT);
    eval 'sub MRT6_PIM () {( &MRT6_BASE+8);}' unless defined(&MRT6_PIM);
    eval 'sub SIOCGETMIFCNT_IN6 () { &SIOCPROTOPRIVATE;}' unless defined(&SIOCGETMIFCNT_IN6);
    eval 'sub SIOCGETSGCNT_IN6 () {( &SIOCPROTOPRIVATE+1);}' unless defined(&SIOCGETSGCNT_IN6);
    eval 'sub SIOCGETRPF () {( &SIOCPROTOPRIVATE+2);}' unless defined(&SIOCGETRPF);
    eval 'sub MAXMIFS () {32;}' unless defined(&MAXMIFS);
    eval 'sub ALL_MIFS () {(( &mifi_t)(-1));}' unless defined(&ALL_MIFS);
    unless(defined(&IF_SETSIZE)) {
	eval 'sub IF_SETSIZE () {256;}' unless defined(&IF_SETSIZE);
    }
    eval 'sub NIFBITS () {($sizeof{ &if_mask} * 8);}' unless defined(&NIFBITS);
    if(!defined( &__KERNEL__)  && !defined( &DIV_ROUND_UP)) {
	eval 'sub DIV_ROUND_UP {
	    my($x,$y) = @_;
    	    eval q(((($x) + (($y) - 1)) / ($y)));
	}' unless defined(&DIV_ROUND_UP);
    }
    eval 'sub IF_SET {
        my($n, $p) = @_;
	    eval q((($p)-> $ifs_bits[($n)/ &NIFBITS] |= (1<< (($n) %  &NIFBITS))));
    }' unless defined(&IF_SET);
    eval 'sub IF_CLR {
        my($n, $p) = @_;
	    eval q((($p)-> $ifs_bits[($n)/ &NIFBITS] &= ~(1<< (($n) %  &NIFBITS))));
    }' unless defined(&IF_CLR);
    eval 'sub IF_ISSET {
        my($n, $p) = @_;
	    eval q((($p)-> $ifs_bits[($n)/ &NIFBITS] & (1<< (($n) %  &NIFBITS))));
    }' unless defined(&IF_ISSET);
    eval 'sub IF_COPY {
        my($f, $t) = @_;
	    eval q( &bcopy($f, $t, $sizeof{($f)}));
    }' unless defined(&IF_COPY);
    eval 'sub IF_ZERO {
        my($p) = @_;
	    eval q( &bzero($p, $sizeof{($p)}));
    }' unless defined(&IF_ZERO);
    eval 'sub MIFF_REGISTER () {0x1;}' unless defined(&MIFF_REGISTER);
    if(defined(&__KERNEL__)) {
	require 'linux/pim.ph';
	require 'linux/skbuff.ph';
	if(defined(&CONFIG_IPV6_MROUTE)) {
	    eval 'sub ip6_mroute_opt {
	        my($opt) = @_;
    		eval q({ ($opt >=  &MRT6_BASE)  && ($opt <=  &MRT6_BASE + 10); });
	    }' unless defined(&ip6_mroute_opt);
	} else {
	    eval 'sub ip6_mroute_opt {
	        my($opt) = @_;
    		eval q({ 0; });
	    }' unless defined(&ip6_mroute_opt);
	}
	if(defined(&CONFIG_IPV6_MROUTE)) {
	} else {
	    eval 'sub ip6_mr_init {
	        my($void) = @_;
    		eval q({ 0; });
	    }' unless defined(&ip6_mr_init);
	    eval 'sub ip6_mr_cleanup {
	        my($void) = @_;
    		eval q({ ; });
	    }' unless defined(&ip6_mr_cleanup);
	}
	eval 'sub VIFF_STATIC () {0x8000;}' unless defined(&VIFF_STATIC);
	eval 'sub MFC_STATIC () {1;}' unless defined(&MFC_STATIC);
	eval 'sub MFC_NOTIFY () {2;}' unless defined(&MFC_NOTIFY);
	eval 'sub MFC6_LINES () {64;}' unless defined(&MFC6_LINES);
	eval 'sub MFC6_HASH {
	    my($a, $g) = @_;
    	    eval q(((( &__force  &u32)($a)-> $s6_addr32[0] ^ ( &__force  &u32)($a)-> $s6_addr32[1] ^ ( &__force  &u32)($a)-> $s6_addr32[2] ^ ( &__force  &u32)($a)-> $s6_addr32[3] ^ ( &__force  &u32)($g)-> $s6_addr32[0] ^ ( &__force  &u32)($g)-> $s6_addr32[1] ^ ( &__force  &u32)($g)-> $s6_addr32[2] ^ ( &__force  &u32)($g)-> $s6_addr32[3]) %  &MFC6_LINES));
	}' unless defined(&MFC6_HASH);
	eval 'sub MFC_ASSERT_THRESH () {(3* &HZ);}' unless defined(&MFC_ASSERT_THRESH);
    }
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_IPV6_MROUTE)) {
	} else {
	    eval 'sub mroute6_socket () { &NULL;}' unless defined(&mroute6_socket);
	    eval 'sub ip6mr_sk_done {
	        my($sk) = @_;
    		eval q({ 0; }  &endif  &endif \'struct mrt6msg\' {  &define  &MRT6MSG_NOCACHE 1 &define  &MRT6MSG_WRONGMIF 2 &define  &MRT6MSG_WHOLEPKT 3 &__u8  &im6_mbz;  &__u8  &im6_msgtype;  &__u16  &im6_mif;  &__u32  &im6_pad; \'struct in6_addr\'  &im6_src,  &im6_dst; };);
	    }' unless defined(&ip6mr_sk_done);
	}
1;
