require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NETDEVICE_H)) {
    eval 'sub _LINUX_NETDEVICE_H () {1;}' unless defined(&_LINUX_NETDEVICE_H);
    require 'linux/if.ph';
    require 'linux/if_ether.ph';
    require 'linux/if_packet.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/timer.ph';
	require 'linux/delay.ph';
	require 'asm/atomic.ph';
	require 'asm/cache.ph';
	require 'asm/byteorder.ph';
	require 'linux/device.ph';
	require 'linux/percpu.ph';
	require 'linux/dmaengine.ph';
	require 'linux/workqueue.ph';
	require 'net/net_namespace.ph';
	eval 'sub SET_ETHTOOL_OPS {
	    my($netdev,$ops) = @_;
    	    eval q(( ($netdev)-> &ethtool_ops = ($ops) ));
	}' unless defined(&SET_ETHTOOL_OPS);
	eval 'sub HAVE_ALLOC_NETDEV () {1;}' unless defined(&HAVE_ALLOC_NETDEV);
	eval 'sub HAVE_FREE_NETDEV () {1;}' unless defined(&HAVE_FREE_NETDEV);
	eval 'sub HAVE_NETDEV_PRIV () {1;}' unless defined(&HAVE_NETDEV_PRIV);
	eval 'sub NET_XMIT_SUCCESS () {0;}' unless defined(&NET_XMIT_SUCCESS);
	eval 'sub NET_XMIT_DROP () {1;}' unless defined(&NET_XMIT_DROP);
	eval 'sub NET_XMIT_CN () {2;}' unless defined(&NET_XMIT_CN);
	eval 'sub NET_XMIT_POLICED () {3;}' unless defined(&NET_XMIT_POLICED);
	eval 'sub NET_XMIT_MASK () {0xffff;}' unless defined(&NET_XMIT_MASK);
	eval 'sub NET_RX_SUCCESS () {0;}' unless defined(&NET_RX_SUCCESS);
	eval 'sub NET_RX_DROP () {1;}' unless defined(&NET_RX_DROP);
	eval 'sub NET_RX_CN_LOW () {2;}' unless defined(&NET_RX_CN_LOW);
	eval 'sub NET_RX_CN_MOD () {3;}' unless defined(&NET_RX_CN_MOD);
	eval 'sub NET_RX_CN_HIGH () {4;}' unless defined(&NET_RX_CN_HIGH);
	eval 'sub NET_RX_BAD () {5;}' unless defined(&NET_RX_BAD);
	eval 'sub net_xmit_eval {
	    my($e) = @_;
    	    eval q((($e) ==  &NET_XMIT_CN? 0: ($e)));
	}' unless defined(&net_xmit_eval);
	eval 'sub net_xmit_errno {
	    my($e) = @_;
    	    eval q((($e) !=  &NET_XMIT_CN ? - &ENOBUFS : 0));
	}' unless defined(&net_xmit_errno);
    }
    eval 'sub MAX_ADDR_LEN () {32;}' unless defined(&MAX_ADDR_LEN);
    eval 'sub NETDEV_TX_OK () {0;}' unless defined(&NETDEV_TX_OK);
    eval 'sub NETDEV_TX_BUSY () {1;}' unless defined(&NETDEV_TX_BUSY);
    eval 'sub NETDEV_TX_LOCKED () {-1;}' unless defined(&NETDEV_TX_LOCKED);
    if(defined(&__KERNEL__)) {
	if(defined( &CONFIG_WLAN_80211) || defined( &CONFIG_AX25) || defined( &CONFIG_AX25_MODULE)) {
	    if(defined( &CONFIG_MAC80211_MESH)) {
		eval 'sub LL_MAX_HEADER () {128;}' unless defined(&LL_MAX_HEADER);
	    } else {
		eval 'sub LL_MAX_HEADER () {96;}' unless defined(&LL_MAX_HEADER);
	    }
	}
 elsif(defined( &CONFIG_TR)) {
	    eval 'sub LL_MAX_HEADER () {48;}' unless defined(&LL_MAX_HEADER);
	} else {
	    eval 'sub LL_MAX_HEADER () {32;}' unless defined(&LL_MAX_HEADER);
	}
	if(!defined( &CONFIG_NET_IPIP)  && !defined( &CONFIG_NET_IPIP_MODULE)  && !defined( &CONFIG_NET_IPGRE)  && !defined( &CONFIG_NET_IPGRE_MODULE)  && !defined( &CONFIG_IPV6_SIT)  && !defined( &CONFIG_IPV6_SIT_MODULE)  && !defined( &CONFIG_IPV6_TUNNEL)  && !defined( &CONFIG_IPV6_TUNNEL_MODULE)) {
	    eval 'sub MAX_HEADER () { &LL_MAX_HEADER;}' unless defined(&MAX_HEADER);
	} else {
	    eval 'sub MAX_HEADER () {( &LL_MAX_HEADER + 48);}' unless defined(&MAX_HEADER);
	}
    }
    eval("sub IF_PORT_UNKNOWN () { 0; }") unless defined(&IF_PORT_UNKNOWN);
    eval("sub IF_PORT_10BASE2 () { 1; }") unless defined(&IF_PORT_10BASE2);
    eval("sub IF_PORT_10BASET () { 2; }") unless defined(&IF_PORT_10BASET);
    eval("sub IF_PORT_AUI () { 3; }") unless defined(&IF_PORT_AUI);
    eval("sub IF_PORT_100BASET () { 4; }") unless defined(&IF_PORT_100BASET);
    eval("sub IF_PORT_100BASETX () { 5; }") unless defined(&IF_PORT_100BASETX);
    eval("sub IF_PORT_100BASEFX () { 6; }") unless defined(&IF_PORT_100BASEFX);
    if(defined(&__KERNEL__)) {
	require 'linux/cache.ph';
	require 'linux/skbuff.ph';
	eval 'sub dev_mc_list () { &dev_addr_list;}' unless defined(&dev_mc_list);
	eval 'sub dmi_addr () { &da_addr;}' unless defined(&dmi_addr);
	eval 'sub dmi_addrlen () { &da_addrlen;}' unless defined(&dmi_addrlen);
	eval 'sub dmi_users () { &da_users;}' unless defined(&dmi_users);
	eval 'sub dmi_gusers () { &da_gusers;}' unless defined(&dmi_gusers);
	eval 'sub HH_DATA_MOD () {16;}' unless defined(&HH_DATA_MOD);
	eval 'sub HH_DATA_OFF {
	    my($__len) = @_;
    	    eval q(( &HH_DATA_MOD - ((($__len - 1) & ( &HH_DATA_MOD - 1)) + 1)));
	}' unless defined(&HH_DATA_OFF);
	eval 'sub HH_DATA_ALIGN {
	    my($__len) = @_;
    	    eval q(((($__len)+( &HH_DATA_MOD-1))&~( &HH_DATA_MOD - 1)));
	}' unless defined(&HH_DATA_ALIGN);
	eval 'sub LL_RESERVED_SPACE {
	    my($dev) = @_;
    	    eval q((((($dev)-> &hard_header_len+($dev)-> &needed_headroom)&~( &HH_DATA_MOD - 1)) +  &HH_DATA_MOD));
	}' unless defined(&LL_RESERVED_SPACE);
	eval 'sub LL_RESERVED_SPACE_EXTRA {
	    my($dev,$extra) = @_;
    	    eval q((((($dev)-> &hard_header_len+($dev)-> &needed_headroom+($extra))&~( &HH_DATA_MOD - 1)) +  &HH_DATA_MOD));
	}' unless defined(&LL_RESERVED_SPACE_EXTRA);
	eval 'sub LL_ALLOCATED_SPACE {
	    my($dev) = @_;
    	    eval q((((($dev)-> &hard_header_len+($dev)-> &needed_headroom+($dev)-> &needed_tailroom)&~( &HH_DATA_MOD - 1)) +  &HH_DATA_MOD));
	}' unless defined(&LL_ALLOCATED_SPACE);
	eval 'sub HAVE_HEADER_CACHE () {1;}' unless defined(&HAVE_HEADER_CACHE);
	eval("sub __LINK_STATE_START () { 0; }") unless defined(&__LINK_STATE_START);
	eval("sub __LINK_STATE_PRESENT () { 1; }") unless defined(&__LINK_STATE_PRESENT);
	eval("sub __LINK_STATE_NOCARRIER () { 2; }") unless defined(&__LINK_STATE_NOCARRIER);
	eval("sub __LINK_STATE_LINKWATCH_PENDING () { 3; }") unless defined(&__LINK_STATE_LINKWATCH_PENDING);
	eval("sub __LINK_STATE_DORMANT () { 4; }") unless defined(&__LINK_STATE_DORMANT);
	eval 'sub NETDEV_BOOT_SETUP_MAX () {8;}' unless defined(&NETDEV_BOOT_SETUP_MAX);
	if(defined(&CONFIG_NETPOLL)) {
	}
	eval("sub NAPI_STATE_SCHED () { 0; }") unless defined(&NAPI_STATE_SCHED);
	eval("sub NAPI_STATE_DISABLE () { 1; }") unless defined(&NAPI_STATE_DISABLE);
	eval 'sub napi_disable_pending {
	    my($n) = @_;
    	    eval q({  &test_bit( &NAPI_STATE_DISABLE,  ($n->{state})); });
	}' unless defined(&napi_disable_pending);
	eval 'sub napi_complete {
	    my($n) = @_;
    	    eval q({ my $flags;  &local_irq_save( $flags);  &__napi_complete($n);  &local_irq_restore( $flags); });
	}' unless defined(&napi_complete);
	if(defined(&CONFIG_SMP)) {
	} else {
	    eval 'sub napi_synchronize {
	        my($n) = @_;
    		eval q( &barrier());
	    }' unless defined(&napi_synchronize);
	}
	eval("sub __QUEUE_STATE_XOFF () { 0; }") unless defined(&__QUEUE_STATE_XOFF);
	eval("sub __QUEUE_STATE_FROZEN () { 1; }") unless defined(&__QUEUE_STATE_FROZEN);
	if(defined(&CONFIG_NETPOLL)) {
	}
	eval 'sub NETIF_F_SG () {1;}' unless defined(&NETIF_F_SG);
	eval 'sub NETIF_F_IP_CSUM () {2;}' unless defined(&NETIF_F_IP_CSUM);
	eval 'sub NETIF_F_NO_CSUM () {4;}' unless defined(&NETIF_F_NO_CSUM);
	eval 'sub NETIF_F_HW_CSUM () {8;}' unless defined(&NETIF_F_HW_CSUM);
	eval 'sub NETIF_F_IPV6_CSUM () {16;}' unless defined(&NETIF_F_IPV6_CSUM);
	eval 'sub NETIF_F_HIGHDMA () {32;}' unless defined(&NETIF_F_HIGHDMA);
	eval 'sub NETIF_F_FRAGLIST () {64;}' unless defined(&NETIF_F_FRAGLIST);
	eval 'sub NETIF_F_HW_VLAN_TX () {128;}' unless defined(&NETIF_F_HW_VLAN_TX);
	eval 'sub NETIF_F_HW_VLAN_RX () {256;}' unless defined(&NETIF_F_HW_VLAN_RX);
	eval 'sub NETIF_F_HW_VLAN_FILTER () {512;}' unless defined(&NETIF_F_HW_VLAN_FILTER);
	eval 'sub NETIF_F_VLAN_CHALLENGED () {1024;}' unless defined(&NETIF_F_VLAN_CHALLENGED);
	eval 'sub NETIF_F_GSO () {2048;}' unless defined(&NETIF_F_GSO);
	eval 'sub NETIF_F_LLTX () {4096;}' unless defined(&NETIF_F_LLTX);
	eval 'sub NETIF_F_NETNS_LOCAL () {8192;}' unless defined(&NETIF_F_NETNS_LOCAL);
	eval 'sub NETIF_F_LRO () {32768;}' unless defined(&NETIF_F_LRO);
	eval 'sub NETIF_F_GSO_SHIFT () {16;}' unless defined(&NETIF_F_GSO_SHIFT);
	eval 'sub NETIF_F_GSO_MASK () {0xffff0000;}' unless defined(&NETIF_F_GSO_MASK);
	eval 'sub NETIF_F_TSO () {( &SKB_GSO_TCPV4 <<  &NETIF_F_GSO_SHIFT);}' unless defined(&NETIF_F_TSO);
	eval 'sub NETIF_F_UFO () {( &SKB_GSO_UDP <<  &NETIF_F_GSO_SHIFT);}' unless defined(&NETIF_F_UFO);
	eval 'sub NETIF_F_GSO_ROBUST () {( &SKB_GSO_DODGY <<  &NETIF_F_GSO_SHIFT);}' unless defined(&NETIF_F_GSO_ROBUST);
	eval 'sub NETIF_F_TSO_ECN () {( &SKB_GSO_TCP_ECN <<  &NETIF_F_GSO_SHIFT);}' unless defined(&NETIF_F_TSO_ECN);
	eval 'sub NETIF_F_TSO6 () {( &SKB_GSO_TCPV6 <<  &NETIF_F_GSO_SHIFT);}' unless defined(&NETIF_F_TSO6);
	eval 'sub NETIF_F_GSO_SOFTWARE () {( &NETIF_F_TSO |  &NETIF_F_TSO_ECN |  &NETIF_F_TSO6);}' unless defined(&NETIF_F_GSO_SOFTWARE);
	eval 'sub NETIF_F_GEN_CSUM () {( &NETIF_F_NO_CSUM |  &NETIF_F_HW_CSUM);}' unless defined(&NETIF_F_GEN_CSUM);
	eval 'sub NETIF_F_V4_CSUM () {( &NETIF_F_GEN_CSUM |  &NETIF_F_IP_CSUM);}' unless defined(&NETIF_F_V4_CSUM);
	eval 'sub NETIF_F_V6_CSUM () {( &NETIF_F_GEN_CSUM |  &NETIF_F_IPV6_CSUM);}' unless defined(&NETIF_F_V6_CSUM);
	eval 'sub NETIF_F_ALL_CSUM () {( &NETIF_F_V4_CSUM |  &NETIF_F_V6_CSUM);}' unless defined(&NETIF_F_ALL_CSUM);
	if(defined(&CONFIG_WIRELESS_EXT)) {
	}
	eval("sub NETREG_UNINITIALIZED () { 0; }") unless defined(&NETREG_UNINITIALIZED);
	eval("sub NETREG_REGISTERED () { 1; }") unless defined(&NETREG_REGISTERED);
	eval("sub NETREG_UNREGISTERING () { 2; }") unless defined(&NETREG_UNREGISTERING);
	eval("sub NETREG_UNREGISTERED () { 3; }") unless defined(&NETREG_UNREGISTERED);
	eval("sub NETREG_RELEASED () { 4; }") unless defined(&NETREG_RELEASED);
	eval 'sub HAVE_NETDEV_POLL () {1;}' unless defined(&HAVE_NETDEV_POLL);
	eval 'sub HAVE_CHANGE_RX_FLAGS () {1;}' unless defined(&HAVE_CHANGE_RX_FLAGS);
	eval 'sub HAVE_SET_RX_MODE () {1;}' unless defined(&HAVE_SET_RX_MODE);
	eval 'sub HAVE_MULTICAST () {1;}' unless defined(&HAVE_MULTICAST);
	eval 'sub HAVE_SET_MAC_ADDR () {1;}' unless defined(&HAVE_SET_MAC_ADDR);
	eval 'sub HAVE_VALIDATE_ADDR () {1;}' unless defined(&HAVE_VALIDATE_ADDR);
	eval 'sub HAVE_PRIVATE_IOCTL () {1;}' unless defined(&HAVE_PRIVATE_IOCTL);
	eval 'sub HAVE_SET_CONFIG () {1;}' unless defined(&HAVE_SET_CONFIG);
	eval 'sub HAVE_CHANGE_MTU () {1;}' unless defined(&HAVE_CHANGE_MTU);
	eval 'sub HAVE_TX_TIMEOUT () {1;}' unless defined(&HAVE_TX_TIMEOUT);
	if(defined(&CONFIG_NETPOLL)) {
	}
	if(defined(&CONFIG_NET_POLL_CONTROLLER)) {
	}
	if(defined(&CONFIG_NET_NS)) {
	}
	eval 'sub GSO_MAX_SIZE () {65536;}' unless defined(&GSO_MAX_SIZE);
	eval 'sub to_net_dev {
	    my($d) = @_;
    	    eval q( &container_of($d, \'struct net_device\',  &dev));
	}' unless defined(&to_net_dev);
	eval 'sub NETDEV_ALIGN () {32;}' unless defined(&NETDEV_ALIGN);
	eval 'sub NETDEV_ALIGN_CONST () {( &NETDEV_ALIGN - 1);}' unless defined(&NETDEV_ALIGN_CONST);
	eval 'sub netdev_for_each_tx_queue {
	    eval q((\'struct net_device\' * &dev,  &void (* &f)(\'struct net_device\' *, \'struct netdev_queue\' *,  &void *),  &void * &arg) { my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++)  &f( &dev,  ($dev->{_tx[$i]}),  &arg); });
	}' unless defined(&netdev_for_each_tx_queue);
	if(defined(&CONFIG_NET_NS)) {
	} else {
	}
	if(defined(&CONFIG_NET_NS)) {
	}
	eval 'sub SET_NETDEV_DEV {
	    my($net, $pdev) = @_;
    	    eval q((($net)-> ($dev->{parent}) = ($pdev)));
	}' unless defined(&SET_NETDEV_DEV);
	if(defined(&CONFIG_NETPOLL)) {
	}
	if(defined(&CONFIG_NETPOLL)) {
	}
	require 'linux/interrupt.ph';
	require 'linux/notifier.ph';
	eval 'sub for_each_netdev {
	    my($net, $d) = @_;
    	    eval q( &list_for_each_entry($d, ($net)-> &dev_base_head,  &dev_list));
	}' unless defined(&for_each_netdev);
	eval 'sub for_each_netdev_safe {
	    my($net, $d, $n) = @_;
    	    eval q( &list_for_each_entry_safe($d, $n, ($net)-> &dev_base_head,  &dev_list));
	}' unless defined(&for_each_netdev_safe);
	eval 'sub for_each_netdev_continue {
	    my($net, $d) = @_;
    	    eval q( &list_for_each_entry_continue($d, ($net)-> &dev_base_head,  &dev_list));
	}' unless defined(&for_each_netdev_continue);
	eval 'sub net_device_entry {
	    my($lh) = @_;
    	    eval q( &list_entry($lh, \'struct net_device\',  &dev_list));
	}' unless defined(&net_device_entry);
	eval 'sub net_device {
	    eval q(* &next_net_device(\'struct net_device\' * &dev) { \'struct list_head\' * &lh; \'struct net\' * &net;  &net =  &dev_net( &dev);  &lh =  ($dev->{dev_list}->{next});  &lh ==  ($net->{dev_base_head}) ?  &NULL :  &net_device_entry( &lh); });
	}' unless defined(&net_device);
	eval 'sub net_device {
	    eval q(* &first_net_device(\'struct net\' * &net) {  &list_empty( ($net->{dev_base_head})) ?  &NULL :  &net_device_entry( ($net->{dev_base_head}->{next})); });
	}' unless defined(&net_device);
	if(defined(&CONFIG_NETPOLL_TRAP)) {
	}
	eval 'sub dev_hard_header {
	    my($skb,$dev,$type,$daddr,$saddr,$len) = @_;
    	    eval q({  &if (! ($dev->{header_ops}) || ! ($dev->{header_ops}->{create})) 0;  ($dev->{header_ops}->{create})($skb, $dev, $type, $daddr, $saddr, $len); });
	}' unless defined(&dev_hard_header);
	eval 'sub dev_parse_header {
	    my($skb,$haddr) = @_;
    	    eval q({  &const \'struct net_device\' * &dev =  ($skb->{dev});  &if (! ($dev->{header_ops}) || ! ($dev->{header_ops}->{parse})) 0;  ($dev->{header_ops}->{parse})($skb, $haddr); });
	}' unless defined(&dev_parse_header);
	eval 'sub unregister_gifconf {
	    my($family) = @_;
    	    eval q({  &register_gifconf($family,  &NULL); });
	}' unless defined(&unregister_gifconf);
	if(defined(&CONFIG_NET_DMA)) {
	}
	eval 'sub HAVE_NETIF_QUEUE () {1;}' unless defined(&HAVE_NETIF_QUEUE);
	eval 'sub netif_schedule_queue {
	    my($txq) = @_;
    	    eval q({  &if (! &test_bit( &__QUEUE_STATE_XOFF,  ($txq->{state})))  &__netif_schedule( ($txq->{qdisc})); });
	}' unless defined(&netif_schedule_queue);
	eval 'sub netif_tx_schedule_all {
	    my($dev) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++)  &netif_schedule_queue( &netdev_get_tx_queue($dev,  $i)); });
	}' unless defined(&netif_tx_schedule_all);
	eval 'sub netif_tx_start_queue {
	    my($dev_queue) = @_;
    	    eval q({  &clear_bit( &__QUEUE_STATE_XOFF,  ($dev_queue->{state})); });
	}' unless defined(&netif_tx_start_queue);
	eval 'sub netif_tx_start_all_queues {
	    my($dev) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++) { \'struct netdev_queue\' * &txq =  &netdev_get_tx_queue($dev,  $i);  &netif_tx_start_queue( &txq); } });
	}' unless defined(&netif_tx_start_all_queues);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub netif_tx_wake_queue {
	    my($dev_queue) = @_;
    	    eval q({  &if ( &test_and_clear_bit( &__QUEUE_STATE_XOFF,  ($dev_queue->{state})))  &__netif_schedule( ($dev_queue->{qdisc})); });
	}' unless defined(&netif_tx_wake_queue);
	eval 'sub netif_tx_wake_all_queues {
	    my($dev) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++) { \'struct netdev_queue\' * &txq =  &netdev_get_tx_queue($dev,  $i);  &netif_tx_wake_queue( &txq); } });
	}' unless defined(&netif_tx_wake_all_queues);
	eval 'sub netif_tx_stop_queue {
	    my($dev_queue) = @_;
    	    eval q({  &set_bit( &__QUEUE_STATE_XOFF,  ($dev_queue->{state})); });
	}' unless defined(&netif_tx_stop_queue);
	eval 'sub netif_tx_stop_all_queues {
	    my($dev) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++) { \'struct netdev_queue\' * &txq =  &netdev_get_tx_queue($dev,  $i);  &netif_tx_stop_queue( &txq); } });
	}' unless defined(&netif_tx_stop_all_queues);
	eval 'sub netif_tx_queue_stopped {
	    my($dev_queue) = @_;
    	    eval q({  &test_bit( &__QUEUE_STATE_XOFF,  ($dev_queue->{state})); });
	}' unless defined(&netif_tx_queue_stopped);
	eval 'sub netif_tx_queue_frozen {
	    my($dev_queue) = @_;
    	    eval q({  &test_bit( &__QUEUE_STATE_FROZEN,  ($dev_queue->{state})); });
	}' unless defined(&netif_tx_queue_frozen);
	if(defined(&CONFIG_NETPOLL_TRAP)) {
	}
	eval 'sub netif_subqueue_stopped {
	    my($dev,$skb) = @_;
    	    eval q({  &__netif_subqueue_stopped($dev,  &skb_get_queue_mapping($skb)); });
	}' unless defined(&netif_subqueue_stopped);
	if(defined(&CONFIG_NETPOLL_TRAP)) {
	}
	eval 'sub HAVE_NETIF_RX () {1;}' unless defined(&HAVE_NETIF_RX);
	eval 'sub HAVE_NETIF_RECEIVE_SKB () {1;}' unless defined(&HAVE_NETIF_RECEIVE_SKB);
	eval 'sub HAVE_NETIF_MSG () {1;}' unless defined(&HAVE_NETIF_MSG);
	eval("sub NETIF_MSG_DRV () { 0x0001; }") unless defined(&NETIF_MSG_DRV);
	eval("sub NETIF_MSG_PROBE () { 0x0002; }") unless defined(&NETIF_MSG_PROBE);
	eval("sub NETIF_MSG_LINK () { 0x0004; }") unless defined(&NETIF_MSG_LINK);
	eval("sub NETIF_MSG_TIMER () { 0x0008; }") unless defined(&NETIF_MSG_TIMER);
	eval("sub NETIF_MSG_IFDOWN () { 0x0010; }") unless defined(&NETIF_MSG_IFDOWN);
	eval("sub NETIF_MSG_IFUP () { 0x0020; }") unless defined(&NETIF_MSG_IFUP);
	eval("sub NETIF_MSG_RX_ERR () { 0x0040; }") unless defined(&NETIF_MSG_RX_ERR);
	eval("sub NETIF_MSG_TX_ERR () { 0x0080; }") unless defined(&NETIF_MSG_TX_ERR);
	eval("sub NETIF_MSG_TX_QUEUED () { 0x0100; }") unless defined(&NETIF_MSG_TX_QUEUED);
	eval("sub NETIF_MSG_INTR () { 0x0200; }") unless defined(&NETIF_MSG_INTR);
	eval("sub NETIF_MSG_TX_DONE () { 0x0400; }") unless defined(&NETIF_MSG_TX_DONE);
	eval("sub NETIF_MSG_RX_STATUS () { 0x0800; }") unless defined(&NETIF_MSG_RX_STATUS);
	eval("sub NETIF_MSG_PKTDATA () { 0x1000; }") unless defined(&NETIF_MSG_PKTDATA);
	eval("sub NETIF_MSG_HW () { 0x2000; }") unless defined(&NETIF_MSG_HW);
	eval("sub NETIF_MSG_WOL () { 0x4000; }") unless defined(&NETIF_MSG_WOL);
	eval 'sub netif_msg_drv {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_DRV));
	}' unless defined(&netif_msg_drv);
	eval 'sub netif_msg_probe {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_PROBE));
	}' unless defined(&netif_msg_probe);
	eval 'sub netif_msg_link {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_LINK));
	}' unless defined(&netif_msg_link);
	eval 'sub netif_msg_timer {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_TIMER));
	}' unless defined(&netif_msg_timer);
	eval 'sub netif_msg_ifdown {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_IFDOWN));
	}' unless defined(&netif_msg_ifdown);
	eval 'sub netif_msg_ifup {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_IFUP));
	}' unless defined(&netif_msg_ifup);
	eval 'sub netif_msg_rx_err {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_RX_ERR));
	}' unless defined(&netif_msg_rx_err);
	eval 'sub netif_msg_tx_err {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_TX_ERR));
	}' unless defined(&netif_msg_tx_err);
	eval 'sub netif_msg_tx_queued {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_TX_QUEUED));
	}' unless defined(&netif_msg_tx_queued);
	eval 'sub netif_msg_intr {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_INTR));
	}' unless defined(&netif_msg_intr);
	eval 'sub netif_msg_tx_done {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_TX_DONE));
	}' unless defined(&netif_msg_tx_done);
	eval 'sub netif_msg_rx_status {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_RX_STATUS));
	}' unless defined(&netif_msg_rx_status);
	eval 'sub netif_msg_pktdata {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_PKTDATA));
	}' unless defined(&netif_msg_pktdata);
	eval 'sub netif_msg_hw {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_HW));
	}' unless defined(&netif_msg_hw);
	eval 'sub netif_msg_wol {
	    my($p) = @_;
    	    eval q((($p)-> &msg_enable &  &NETIF_MSG_WOL));
	}' unless defined(&netif_msg_wol);
	eval 'sub netif_msg_init {
	    my($debug_value,$default_msg_enable_bits) = @_;
    	    eval q({  &if ($debug_value < 0|| $debug_value >= ($sizeof{ &u32} * 8)) $default_msg_enable_bits;  &if ($debug_value == 0) 0; (1<< $debug_value) - 1; });
	}' unless defined(&netif_msg_init);
	eval 'sub __netif_tx_lock {
	    my($txq,$cpu) = @_;
    	    eval q({  &spin_lock( ($txq->{_xmit_lock}));  ($txq->{xmit_lock_owner}) = $cpu; });
	}' unless defined(&__netif_tx_lock);
	eval 'sub __netif_tx_lock_bh {
	    my($txq) = @_;
    	    eval q({  &spin_lock_bh( ($txq->{_xmit_lock}));  ($txq->{xmit_lock_owner}) =  &smp_processor_id(); });
	}' unless defined(&__netif_tx_lock_bh);
	eval 'sub __netif_tx_trylock {
	    my($txq) = @_;
    	    eval q({ \'int\'  &ok =  &spin_trylock( ($txq->{_xmit_lock}));  &if ( &likely( &ok))  ($txq->{xmit_lock_owner}) =  &smp_processor_id();  &ok; });
	}' unless defined(&__netif_tx_trylock);
	eval 'sub __netif_tx_unlock {
	    my($txq) = @_;
    	    eval q({  ($txq->{xmit_lock_owner}) = -1;  &spin_unlock( ($txq->{_xmit_lock})); });
	}' unless defined(&__netif_tx_unlock);
	eval 'sub __netif_tx_unlock_bh {
	    my($txq) = @_;
    	    eval q({  ($txq->{xmit_lock_owner}) = -1;  &spin_unlock_bh( ($txq->{_xmit_lock})); });
	}' unless defined(&__netif_tx_unlock_bh);
	eval 'sub netif_tx_lock_bh {
	    my($dev) = @_;
    	    eval q({  &local_bh_disable();  &netif_tx_lock($dev); });
	}' unless defined(&netif_tx_lock_bh);
	eval 'sub netif_tx_unlock {
	    my($dev) = @_;
    	    eval q({ my $i;  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++) { \'struct netdev_queue\' * &txq =  &netdev_get_tx_queue($dev,  $i);  &clear_bit( &__QUEUE_STATE_FROZEN,  ($txq->{state}));  &if (! &test_bit( &__QUEUE_STATE_XOFF,  ($txq->{state})))  &__netif_schedule( ($txq->{qdisc})); }  &spin_unlock( ($dev->{tx_global_lock})); });
	}' unless defined(&netif_tx_unlock);
	eval 'sub netif_tx_unlock_bh {
	    my($dev) = @_;
    	    eval q({  &netif_tx_unlock($dev);  &local_bh_enable(); });
	}' unless defined(&netif_tx_unlock_bh);
	eval 'sub HARD_TX_LOCK {
	    my($dev, $txq, $cpu) = @_;
    	    eval q({  &if (( ($dev->{features}) &  &NETIF_F_LLTX) == 0) {  &__netif_tx_lock($txq, $cpu); } });
	}' unless defined(&HARD_TX_LOCK);
	eval 'sub HARD_TX_UNLOCK {
	    my($dev, $txq) = @_;
    	    eval q({  &if (( ($dev->{features}) &  &NETIF_F_LLTX) == 0) {  &__netif_tx_unlock($txq); } });
	}' unless defined(&HARD_TX_UNLOCK);
	eval 'sub netif_tx_disable {
	    my($dev) = @_;
    	    eval q({ my $i; \'int\'  &cpu;  &local_bh_disable();  &cpu =  &smp_processor_id();  &for ( $i = 0;  $i <  ($dev->{num_tx_queues});  $i++) { \'struct netdev_queue\' * &txq =  &netdev_get_tx_queue($dev,  $i);  &__netif_tx_lock( &txq,  &cpu);  &netif_tx_stop_queue( &txq);  &__netif_tx_unlock( &txq); }  &local_bh_enable(); });
	}' unless defined(&netif_tx_disable);
	eval 'sub netif_addr_lock {
	    my($dev) = @_;
    	    eval q({  &spin_lock( ($dev->{addr_list_lock})); });
	}' unless defined(&netif_addr_lock);
	eval 'sub netif_addr_lock_bh {
	    my($dev) = @_;
    	    eval q({  &spin_lock_bh( ($dev->{addr_list_lock})); });
	}' unless defined(&netif_addr_lock_bh);
	eval 'sub netif_addr_unlock {
	    my($dev) = @_;
    	    eval q({  &spin_unlock( ($dev->{addr_list_lock})); });
	}' unless defined(&netif_addr_unlock);
	eval 'sub netif_addr_unlock_bh {
	    my($dev) = @_;
    	    eval q({  &spin_unlock_bh( ($dev->{addr_list_lock})); });
	}' unless defined(&netif_addr_unlock_bh);
	eval 'sub alloc_netdev {
	    my($sizeof_priv, $name, $setup) = @_;
    	    eval q( &alloc_netdev_mq($sizeof_priv, $name, $setup, 1));
	}' unless defined(&alloc_netdev);
	if(defined(&CONFIG_BUG)) {
	} else {
	    eval 'sub netdev_rx_csum_fault {
	        my($dev) = @_;
    		eval q({ });
	    }' unless defined(&netdev_rx_csum_fault);
	}
	if(defined(&CONFIG_PROC_FS)) {
	}
	eval 'sub net_gso_ok {
	    my($features,$gso_type) = @_;
    	    eval q({ \'int\'  &feature = $gso_type <<  &NETIF_F_GSO_SHIFT; ($features &  &feature) ==  &feature; });
	}' unless defined(&net_gso_ok);
	eval 'sub skb_gso_ok {
	    my($skb,$features) = @_;
    	    eval q({  &net_gso_ok($features,  &skb_shinfo($skb)-> &gso_type); });
	}' unless defined(&skb_gso_ok);
	eval 'sub netif_needs_gso {
	    my($dev,$skb) = @_;
    	    eval q({  &skb_is_gso($skb)  && (! &skb_gso_ok($skb,  ($dev->{features})) ||  &unlikely( ($skb->{ip_summed}) !=  &CHECKSUM_PARTIAL)); });
	}' unless defined(&netif_needs_gso);
	eval 'sub netif_set_gso_max_size {
	    my($dev,$size) = @_;
    	    eval q({  ($dev->{gso_max_size}) = $size; });
	}' unless defined(&netif_set_gso_max_size);
    }
}
1;
