require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_NETFILTER_H)) {
    eval 'sub __LINUX_NETFILTER_H () {1;}' unless defined(&__LINUX_NETFILTER_H);
    if(defined(&__KERNEL__)) {
	require 'linux/init.ph';
	require 'linux/skbuff.ph';
	require 'linux/net.ph';
	require 'linux/netdevice.ph';
	require 'linux/if.ph';
	require 'linux/in.ph';
	require 'linux/in6.ph';
	require 'linux/wait.ph';
	require 'linux/list.ph';
	require 'net/net_namespace.ph';
    }
    require 'linux/types.ph';
    require 'linux/compiler.ph';
    eval 'sub NF_DROP () {0;}' unless defined(&NF_DROP);
    eval 'sub NF_ACCEPT () {1;}' unless defined(&NF_ACCEPT);
    eval 'sub NF_STOLEN () {2;}' unless defined(&NF_STOLEN);
    eval 'sub NF_QUEUE () {3;}' unless defined(&NF_QUEUE);
    eval 'sub NF_REPEAT () {4;}' unless defined(&NF_REPEAT);
    eval 'sub NF_STOP () {5;}' unless defined(&NF_STOP);
    eval 'sub NF_MAX_VERDICT () { &NF_STOP;}' unless defined(&NF_MAX_VERDICT);
    eval 'sub NF_VERDICT_MASK () {0xffff;}' unless defined(&NF_VERDICT_MASK);
    eval 'sub NF_VERDICT_BITS () {16;}' unless defined(&NF_VERDICT_BITS);
    eval 'sub NF_VERDICT_QMASK () {0xffff0000;}' unless defined(&NF_VERDICT_QMASK);
    eval 'sub NF_VERDICT_QBITS () {16;}' unless defined(&NF_VERDICT_QBITS);
    eval 'sub NF_QUEUE_NR {
        my($x) = @_;
	    eval q((((($x) <<  &NF_VERDICT_BITS) &  &NF_VERDICT_QMASK) |  &NF_QUEUE));
    }' unless defined(&NF_QUEUE_NR);
    unless(defined(&__KERNEL__)) {
	eval 'sub NFC_UNKNOWN () {0x4000;}' unless defined(&NFC_UNKNOWN);
	eval 'sub NFC_ALTERED () {0x8000;}' unless defined(&NFC_ALTERED);
    }
    eval("sub NF_INET_PRE_ROUTING () { 0; }") unless defined(&NF_INET_PRE_ROUTING);
    eval("sub NF_INET_LOCAL_IN () { 1; }") unless defined(&NF_INET_LOCAL_IN);
    eval("sub NF_INET_FORWARD () { 2; }") unless defined(&NF_INET_FORWARD);
    eval("sub NF_INET_LOCAL_OUT () { 3; }") unless defined(&NF_INET_LOCAL_OUT);
    eval("sub NF_INET_POST_ROUTING () { 4; }") unless defined(&NF_INET_POST_ROUTING);
    eval("sub NF_INET_NUMHOOKS () { 5; }") unless defined(&NF_INET_NUMHOOKS);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_NETFILTER)) {
	    eval 'sub nf_inet_addr_cmp {
	        my($a1,$a2) = @_;
    		eval q({  ($a1->{all[0]}) ==  ($a2->{all[0]})  &&  ($a1->{all[1]}) ==  ($a2->{all[1]})  &&  ($a1->{all[2]}) ==  ($a2->{all[2]})  &&  ($a1->{all[3]}) ==  ($a2->{all[3]}); });
	    }' unless defined(&nf_inet_addr_cmp);
	    eval 'sub NF_MAX_HOOKS () {8;}' unless defined(&NF_MAX_HOOKS);
	    if(defined(&CONFIG_SYSCTL)) {
	    }
	    unless(defined(&CONFIG_NETFILTER_DEBUG)) {
	    }
	    eval 'sub nf_hook {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' * &skb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn)) {  &nf_hook_thresh( &pf,  $hook,  &skb,  &indev,  &outdev,  &okfn,  &INT_MIN, 1); });
	    }' unless defined(&nf_hook);
	    eval 'sub NF_HOOK_THRESH {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $thresh) = @_;
    		eval q(({\'int\'  &__ret;  &if (( &__ret= &nf_hook_thresh($pf, $hook, ($skb), $indev, $outdev, $okfn, $thresh, 1)) == 1)  &__ret = ($okfn)($skb);  &__ret;}));
	    }' unless defined(&NF_HOOK_THRESH);
	    eval 'sub NF_HOOK_COND {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $cond) = @_;
    		eval q(({\'int\'  &__ret;  &if (( &__ret= &nf_hook_thresh($pf, $hook, ($skb), $indev, $outdev, $okfn,  &INT_MIN, $cond)) == 1)  &__ret = ($okfn)($skb);  &__ret;}));
	    }' unless defined(&NF_HOOK_COND);
	    eval 'sub NF_HOOK {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn) = @_;
    		eval q( &NF_HOOK_THRESH($pf, $hook, $skb, $indev, $outdev, $okfn,  &INT_MIN));
	    }' unless defined(&NF_HOOK);
	    eval 'sub nf_afinfo {
	        eval q(* &nf_get_afinfo {  &rcu_dereference( $nf_afinfo[ &family]); });
	    }' unless defined(&nf_afinfo);
	    eval 'sub nf_checksum {
	        my($skb,$hook,$dataoff,$protocol,$family) = @_;
    		eval q({  &const \'struct nf_afinfo\' * &afinfo;  &__sum16  &csum = 0;  &rcu_read_lock();  &afinfo =  &nf_get_afinfo($family);  &if ( &afinfo)  &csum =  ($afinfo->{checksum})($skb, $hook, $dataoff, $protocol);  &rcu_read_unlock();  &csum; });
	    }' unless defined(&nf_checksum);
	    eval 'sub nf_checksum_partial {
	        my($skb,$hook,$dataoff,$len,$protocol,$family) = @_;
    		eval q({  &const \'struct nf_afinfo\' * &afinfo;  &__sum16  &csum = 0;  &rcu_read_lock();  &afinfo =  &nf_get_afinfo($family);  &if ( &afinfo)  &csum =  ($afinfo->{checksum_partial})($skb, $hook, $dataoff, $len, $protocol);  &rcu_read_unlock();  &csum; });
	    }' unless defined(&nf_checksum_partial);
	    require 'net/flow.ph';
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub nf_nat_decode_session {
	        my($skb,$fl,$family) = @_;
    		eval q({ });
	    }' unless defined(&nf_nat_decode_session);
	    if(defined(&CONFIG_PROC_FS)) {
		require 'linux/proc_fs.ph';
	    }
	} else {
	    eval 'sub NF_HOOK {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn) = @_;
    		eval q(($okfn)($skb));
	    }' unless defined(&NF_HOOK);
	    eval 'sub NF_HOOK_COND {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $cond) = @_;
    		eval q(($okfn)($skb));
	    }' unless defined(&NF_HOOK_COND);
	    eval 'sub nf_hook_thresh {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' * &skb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn), \'int\'  &thresh, \'int\'  &cond) {  &okfn( &skb); });
	    }' unless defined(&nf_hook_thresh);
	    eval 'sub nf_hook {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' * &skb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn)) { 1; });
	    }' unless defined(&nf_hook);
	} else {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub net {
	    eval q(* &nf_pre_routing_net( &const \'struct net_device\' * &in,  &const \'struct net_device\' * &out) { });
	}' unless defined(&net);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub net {
	    eval q(* &nf_local_in_net( &const \'struct net_device\' * &in,  &const \'struct net_device\' * &out) { });
	}' unless defined(&net);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub net {
	    eval q(* &nf_forward_net( &const \'struct net_device\' * &in,  &const \'struct net_device\' * &out) { });
	}' unless defined(&net);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub net {
	    eval q(* &nf_local_out_net( &const \'struct net_device\' * &in,  &const \'struct net_device\' * &out) { });
	}' unless defined(&net);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub net {
	    eval q(* &nf_post_routing_net( &const \'struct net_device\' * &in,  &const \'struct net_device\' * &out) { });
	}' unless defined(&net);
    }
}
1;
