require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NFS_FS_H)) {
    eval 'sub _LINUX_NFS_FS_H () {1;}' unless defined(&_LINUX_NFS_FS_H);
    require 'linux/magic.ph';
    eval 'sub NFS_DEF_UDP_TIMEO () {(11);}' unless defined(&NFS_DEF_UDP_TIMEO);
    eval 'sub NFS_DEF_UDP_RETRANS () {(3);}' unless defined(&NFS_DEF_UDP_RETRANS);
    eval 'sub NFS_DEF_TCP_TIMEO () {(600);}' unless defined(&NFS_DEF_TCP_TIMEO);
    eval 'sub NFS_DEF_TCP_RETRANS () {(2);}' unless defined(&NFS_DEF_TCP_RETRANS);
    eval 'sub NFS_MAX_UDP_TIMEOUT () {(60* &HZ);}' unless defined(&NFS_MAX_UDP_TIMEOUT);
    eval 'sub NFS_MAX_TCP_TIMEOUT () {(600* &HZ);}' unless defined(&NFS_MAX_TCP_TIMEOUT);
    eval 'sub NFS_DEF_ACREGMIN () {(3);}' unless defined(&NFS_DEF_ACREGMIN);
    eval 'sub NFS_DEF_ACREGMAX () {(60);}' unless defined(&NFS_DEF_ACREGMAX);
    eval 'sub NFS_DEF_ACDIRMIN () {(30);}' unless defined(&NFS_DEF_ACDIRMIN);
    eval 'sub NFS_DEF_ACDIRMAX () {(60);}' unless defined(&NFS_DEF_ACDIRMAX);
    eval 'sub FLUSH_SYNC () {1;}' unless defined(&FLUSH_SYNC);
    eval 'sub FLUSH_STABLE () {4;}' unless defined(&FLUSH_STABLE);
    eval 'sub FLUSH_LOWPRI () {8;}' unless defined(&FLUSH_LOWPRI);
    eval 'sub FLUSH_HIGHPRI () {16;}' unless defined(&FLUSH_HIGHPRI);
    eval 'sub FLUSH_NOCOMMIT () {32;}' unless defined(&FLUSH_NOCOMMIT);
    eval 'sub FLUSH_INVALIDATE () {64;}' unless defined(&FLUSH_INVALIDATE);
    eval 'sub FLUSH_NOWRITEPAGE () {128;}' unless defined(&FLUSH_NOWRITEPAGE);
    if(defined(&__KERNEL__)) {
	require 'linux/in.ph';
	require 'linux/kref.ph';
	require 'linux/mm.ph';
	require 'linux/pagemap.ph';
	require 'linux/rbtree.ph';
	require 'linux/rwsem.ph';
	require 'linux/wait.ph';
	require 'linux/sunrpc/debug.ph';
	require 'linux/sunrpc/auth.ph';
	require 'linux/sunrpc/clnt.ph';
	require 'linux/nfs.ph';
	require 'linux/nfs2.ph';
	require 'linux/nfs3.ph';
	require 'linux/nfs4.ph';
	require 'linux/nfs_xdr.ph';
	require 'linux/nfs_fs_sb.ph';
	require 'linux/mempool.ph';
	eval 'sub NFS_RPC_SWAPFLAGS () {( &RPC_TASK_SWAPPER| &RPC_TASK_ROOTCREDS);}' unless defined(&NFS_RPC_SWAPFLAGS);
	eval 'sub NFS_CONTEXT_ERROR_WRITE () {(0);}' unless defined(&NFS_CONTEXT_ERROR_WRITE);
	if(defined(&CONFIG_NFS_V3_ACL)) {
	}
	if(defined(&CONFIG_NFS_V4)) {
	}
	eval 'sub NFS_INO_INVALID_ATTR () {0x1;}' unless defined(&NFS_INO_INVALID_ATTR);
	eval 'sub NFS_INO_INVALID_DATA () {0x2;}' unless defined(&NFS_INO_INVALID_DATA);
	eval 'sub NFS_INO_INVALID_ATIME () {0x4;}' unless defined(&NFS_INO_INVALID_ATIME);
	eval 'sub NFS_INO_INVALID_ACCESS () {0x8;}' unless defined(&NFS_INO_INVALID_ACCESS);
	eval 'sub NFS_INO_INVALID_ACL () {0x10;}' unless defined(&NFS_INO_INVALID_ACL);
	eval 'sub NFS_INO_REVAL_PAGECACHE () {0x20;}' unless defined(&NFS_INO_REVAL_PAGECACHE);
	eval 'sub NFS_INO_REVAL_FORCED () {0x40;}' unless defined(&NFS_INO_REVAL_FORCED);
	eval 'sub NFS_INO_REVALIDATING () {(0);}' unless defined(&NFS_INO_REVALIDATING);
	eval 'sub NFS_INO_ADVISE_RDPLUS () {(1);}' unless defined(&NFS_INO_ADVISE_RDPLUS);
	eval 'sub NFS_INO_STALE () {(2);}' unless defined(&NFS_INO_STALE);
	eval 'sub NFS_INO_ACL_LRU_SET () {(3);}' unless defined(&NFS_INO_ACL_LRU_SET);
	eval 'sub NFS_INO_MOUNTPOINT () {(4);}' unless defined(&NFS_INO_MOUNTPOINT);
	eval 'sub nfs_inode {
	    eval q(* &NFS_I( &const \'struct inode\' * &inode) {  &container_of( &inode, \'struct nfs_inode\',  &vfs_inode); });
	}' unless defined(&nfs_inode);
	eval 'sub nfs_server {
	    eval q(* &NFS_SB( &const \'struct super_block\' * &s) { ( ($s->{s_fs_info})); });
	}' unless defined(&nfs_server);
	eval 'sub nfs_fh {
	    eval q(* &NFS_FH( &const \'struct inode\' * &inode) {  &NFS_I( &inode)-> &fh; });
	}' unless defined(&nfs_fh);
	eval 'sub nfs_server {
	    eval q(* &NFS_SERVER( &const \'struct inode\' * &inode) {  &NFS_SB( ($inode->{i_sb})); });
	}' unless defined(&nfs_server);
	eval 'sub rpc_clnt {
	    eval q(* &NFS_CLIENT( &const \'struct inode\' * &inode) {  &NFS_SERVER( &inode)-> &client; });
	}' unless defined(&rpc_clnt);
	eval 'sub nfs_rpc_ops {
	    eval q(* &NFS_PROTO( &const \'struct inode\' * &inode) {  &NFS_SERVER( &inode)-> ($nfs_client->{rpc_ops}); });
	}' unless defined(&nfs_rpc_ops);
	eval 'sub __be32 {
	    eval q(* &NFS_COOKIEVERF( &const \'struct inode\' * &inode) {  &NFS_I( &inode)-> &cookieverf; });
	}' unless defined(&__be32);
	eval 'sub NFS_MINATTRTIMEO {
	    my($inode) = @_;
    	    eval q({ \'struct nfs_server\' * &nfss =  &NFS_SERVER($inode);  &S_ISDIR( ($inode->{i_mode})) ?  ($nfss->{acdirmin}) :  ($nfss->{acregmin}); });
	}' unless defined(&NFS_MINATTRTIMEO);
	eval 'sub NFS_MAXATTRTIMEO {
	    my($inode) = @_;
    	    eval q({ \'struct nfs_server\' * &nfss =  &NFS_SERVER($inode);  &S_ISDIR( ($inode->{i_mode})) ?  ($nfss->{acdirmax}) :  ($nfss->{acregmax}); });
	}' unless defined(&NFS_MAXATTRTIMEO);
	eval 'sub NFS_STALE {
	    my($inode) = @_;
    	    eval q({  &test_bit( &NFS_INO_STALE,  &NFS_I($inode)-> &flags); });
	}' unless defined(&NFS_STALE);
	eval 'sub NFS_FILEID {
	    my($inode) = @_;
    	    eval q({  &NFS_I($inode)-> &fileid; });
	}' unless defined(&NFS_FILEID);
	eval 'sub set_nfs_fileid {
	    my($inode,$fileid) = @_;
    	    eval q({  &NFS_I($inode)->$fileid = $fileid; });
	}' unless defined(&set_nfs_fileid);
	eval 'sub nfs_mark_for_revalidate {
	    my($inode) = @_;
    	    eval q({ \'struct nfs_inode\' * &nfsi =  &NFS_I($inode);  &spin_lock( ($inode->{i_lock}));  ($nfsi->{cache_validity}) |=  &NFS_INO_INVALID_ATTR| &NFS_INO_INVALID_ACCESS;  &if ( &S_ISDIR( ($inode->{i_mode})))  ($nfsi->{cache_validity}) |=  &NFS_INO_REVAL_PAGECACHE| &NFS_INO_INVALID_DATA;  &spin_unlock( ($inode->{i_lock})); });
	}' unless defined(&nfs_mark_for_revalidate);
	eval 'sub nfs_server_capable {
	    my($inode,$cap) = @_;
    	    eval q({  &NFS_SERVER($inode)-> &caps & $cap; });
	}' unless defined(&nfs_server_capable);
	eval 'sub NFS_USE_READDIRPLUS {
	    my($inode) = @_;
    	    eval q({  &test_bit( &NFS_INO_ADVISE_RDPLUS,  &NFS_I($inode)-> &flags); });
	}' unless defined(&NFS_USE_READDIRPLUS);
	eval 'sub nfs_set_verifier {
	    my($dentry,$verf) = @_;
    	    eval q({  ($dentry->{d_time}) = $verf; });
	}' unless defined(&nfs_set_verifier);
	eval 'sub nfs_fattr_init {
	    my($fattr) = @_;
    	    eval q({  ($fattr->{valid}) = 0;  ($fattr->{time_start}) =  &jiffies; });
	}' unless defined(&nfs_fattr_init);
	if(defined(&CONFIG_NFS_V3)) {
	}
	eval 'sub nfs_open_context {
	    eval q(* &nfs_file_open_context(\'struct file\' * &filp) {  ($filp->{private_data}); });
	}' unless defined(&nfs_open_context);
	eval 'sub rpc_cred {
	    eval q(* &nfs_file_cred(\'struct file\' * &file) {  &if ( &file !=  &NULL)  &nfs_file_open_context( &file)-> &cred;  &NULL; });
	}' unless defined(&rpc_cred);
	if(defined(&CONFIG_NFS_V3_ACL)) {
	} else {
	    eval 'sub nfs3_listxattr () { &NULL;}' unless defined(&nfs3_listxattr);
	    eval 'sub nfs3_getxattr () { &NULL;}' unless defined(&nfs3_getxattr);
	    eval 'sub nfs3_setxattr () { &NULL;}' unless defined(&nfs3_setxattr);
	    eval 'sub nfs3_removexattr () { &NULL;}' unless defined(&nfs3_removexattr);
	}
	if(defined(&CONFIG_NFS_V3)) {
	}
	if(defined(&CONFIG_SYSCTL)) {
	} else {
	    eval 'sub nfs_register_sysctl () {
	        eval q(0);
	    }' unless defined(&nfs_register_sysctl);
	    eval 'sub nfs_unregister_sysctl () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&nfs_unregister_sysctl);
	}
	if(defined( &CONFIG_NFS_V3) || defined( &CONFIG_NFS_V4)) {
	} else {
	    eval 'sub nfs_commit_inode {
	        my($inode,$how) = @_;
    		eval q({ 0; });
	    }' unless defined(&nfs_commit_inode);
	}
	eval 'sub nfs_have_writebacks {
	    my($inode) = @_;
    	    eval q({  &NFS_I($inode)-> &npages != 0; });
	}' unless defined(&nfs_have_writebacks);
	if(defined(&CONFIG_NFS_V3_ACL)) {
	} else {
	    eval 'sub nfs3_proc_set_default_acl {
	        my($dir,$inode,$mode) = @_;
    		eval q({ 0; });
	    }' unless defined(&nfs3_proc_set_default_acl);
	    eval 'sub nfs3_forget_cached_acls {
	        my($inode) = @_;
    		eval q({ });
	    }' unless defined(&nfs3_forget_cached_acls);
	}
	eval 'sub nfs_fileid_to_ino_t {
	    my($fileid) = @_;
    	    eval q({  &ino_t  &ino = ( &ino_t) $fileid;  &if ($sizeof{ &ino_t} < $sizeof{ &u64})  &ino ^= $fileid >> ($sizeof{ &u64}-$sizeof{ &ino_t}) * 8;  &ino; });
	}' unless defined(&nfs_fileid_to_ino_t);
	eval 'sub nfs_wait_event {
	    my($clnt, $wq, $condition) = @_;
    	    eval q(({ \'int\'  &__retval =  &wait_event_killable($wq, $condition);  &__retval; }));
	}' unless defined(&nfs_wait_event);
	eval 'sub NFS_JUKEBOX_RETRY_TIME () {(5*  &HZ);}' unless defined(&NFS_JUKEBOX_RETRY_TIME);
    }
    eval 'sub NFSDBG_VFS () {0x1;}' unless defined(&NFSDBG_VFS);
    eval 'sub NFSDBG_DIRCACHE () {0x2;}' unless defined(&NFSDBG_DIRCACHE);
    eval 'sub NFSDBG_LOOKUPCACHE () {0x4;}' unless defined(&NFSDBG_LOOKUPCACHE);
    eval 'sub NFSDBG_PAGECACHE () {0x8;}' unless defined(&NFSDBG_PAGECACHE);
    eval 'sub NFSDBG_PROC () {0x10;}' unless defined(&NFSDBG_PROC);
    eval 'sub NFSDBG_XDR () {0x20;}' unless defined(&NFSDBG_XDR);
    eval 'sub NFSDBG_FILE () {0x40;}' unless defined(&NFSDBG_FILE);
    eval 'sub NFSDBG_ROOT () {0x80;}' unless defined(&NFSDBG_ROOT);
    eval 'sub NFSDBG_CALLBACK () {0x100;}' unless defined(&NFSDBG_CALLBACK);
    eval 'sub NFSDBG_CLIENT () {0x200;}' unless defined(&NFSDBG_CLIENT);
    eval 'sub NFSDBG_MOUNT () {0x400;}' unless defined(&NFSDBG_MOUNT);
    eval 'sub NFSDBG_ALL () {0xffff;}' unless defined(&NFSDBG_ALL);
    if(defined(&__KERNEL__)) {
	if(defined(&RPC_DEBUG)) {
	    eval 'sub NFS_DEBUG () {1;}' unless defined(&NFS_DEBUG);
	}
	undef(&ifdebug) if defined(&ifdebug);
	if(defined(&NFS_DEBUG)) {
	    eval 'sub ifdebug {
	        my($fac) = @_;
    		eval q( &if ( &unlikely( &nfs_debug &  &NFSDBG_$fac)));
	    }' unless defined(&ifdebug);
	} else {
	    eval 'sub ifdebug {
	        my($fac) = @_;
    		eval q( &if (0));
	    }' unless defined(&ifdebug);
	}
    }
}
1;
