require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PAGE_FLAGS_H)) {
    eval 'sub PAGE_FLAGS_H () {1;}' unless defined(&PAGE_FLAGS_H);
    require 'linux/types.ph';
    unless(defined(&__GENERATING_BOUNDS_H)) {
	require 'linux/mm_types.ph';
	require 'linux/bounds.ph';
    }
    eval("sub PG_locked () { 0; }") unless defined(&PG_locked);
    eval("sub PG_error () { 1; }") unless defined(&PG_error);
    eval("sub PG_referenced () { 2; }") unless defined(&PG_referenced);
    eval("sub PG_uptodate () { 3; }") unless defined(&PG_uptodate);
    eval("sub PG_dirty () { 4; }") unless defined(&PG_dirty);
    eval("sub PG_lru () { 5; }") unless defined(&PG_lru);
    eval("sub PG_active () { 6; }") unless defined(&PG_active);
    eval("sub PG_slab () { 7; }") unless defined(&PG_slab);
    eval("sub PG_owner_priv_1 () { 8; }") unless defined(&PG_owner_priv_1);
    eval("sub PG_arch_1 () { 9; }") unless defined(&PG_arch_1);
    eval("sub PG_reserved () { 10; }") unless defined(&PG_reserved);
    eval("sub PG_private () { 11; }") unless defined(&PG_private);
    eval("sub PG_writeback () { 12; }") unless defined(&PG_writeback);
    eval("sub PG_swapcache () { 13; }") unless defined(&PG_swapcache);
    eval("sub PG_mappedtodisk () { 14; }") unless defined(&PG_mappedtodisk);
    eval("sub PG_reclaim () { 15; }") unless defined(&PG_reclaim);
    eval("sub PG_buddy () { 16; }") unless defined(&PG_buddy);
    eval("sub __NR_PAGEFLAGS () { 17; }") unless defined(&__NR_PAGEFLAGS);
    eval("sub PG_checked () { PG_owner_priv_1; }") unless defined(&PG_checked);
    eval("sub PG_pinned () { PG_owner_priv_1; }") unless defined(&PG_pinned);
    eval("sub PG_savepinned () { PG_dirty; }") unless defined(&PG_savepinned);
    eval("sub PG_slob_page () { PG_active; }") unless defined(&PG_slob_page);
    eval("sub PG_slob_free () { PG_private; }") unless defined(&PG_slob_free);
    eval("sub PG_slub_frozen () { PG_active; }") unless defined(&PG_slub_frozen);
    eval("sub PG_slub_debug () { PG_error; }") unless defined(&PG_slub_debug);
    unless(defined(&__GENERATING_BOUNDS_H)) {
	eval 'sub TESTPAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline \'int\'  &Page$uname(\'struct page\' * &page) {  &return  &test_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&TESTPAGEFLAG);
	eval 'sub SETPAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline  &void  &SetPage$uname(\'struct page\' * &page) {  &set_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&SETPAGEFLAG);
	eval 'sub CLEARPAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline  &void  &ClearPage$uname(\'struct page\' * &page) {  &clear_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&CLEARPAGEFLAG);
	eval 'sub __SETPAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline  &void  &__SetPage$uname(\'struct page\' * &page) {  &__set_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&__SETPAGEFLAG);
	eval 'sub __CLEARPAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline  &void  &__ClearPage$uname(\'struct page\' * &page) {  &__clear_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&__CLEARPAGEFLAG);
	eval 'sub TESTSETFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline \'int\'  &TestSetPage$uname(\'struct page\' * &page) {  &return  &test_and_set_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&TESTSETFLAG);
	eval 'sub TESTCLEARFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &static  &inline \'int\'  &TestClearPage$uname(\'struct page\' * &page) {  &return  &test_and_clear_bit( &PG_$lname,  ($page->{flags})); });
	}' unless defined(&TESTCLEARFLAG);
	eval 'sub PAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &TESTPAGEFLAG($uname, $lname)  &SETPAGEFLAG($uname, $lname)  &CLEARPAGEFLAG($uname, $lname));
	}' unless defined(&PAGEFLAG);
	eval 'sub __PAGEFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &TESTPAGEFLAG($uname, $lname)  &__SETPAGEFLAG($uname, $lname)  &__CLEARPAGEFLAG($uname, $lname));
	}' unless defined(&__PAGEFLAG);
	eval 'sub PAGEFLAG_FALSE {
	    my($uname) = @_;
    	    eval q( &static  &inline \'int\'  &Page$uname(\'struct page\' * &page) {  &return 0; });
	}' unless defined(&PAGEFLAG_FALSE);
	eval 'sub TESTSCFLAG {
	    my($uname, $lname) = @_;
    	    eval q( &TESTSETFLAG($uname, $lname)  &TESTCLEARFLAG($uname, $lname));
	}' unless defined(&TESTSCFLAG);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub PageHighMem {
	        my($__p) = @_;
    		eval q( &is_highmem( &page_zone($__p)));
	    }' unless defined(&PageHighMem);
	} else {
	}
	if(defined(&CONFIG_SWAP)) {
	} else {
	}
	if(defined(&CONFIG_IA64_UNCACHED_ALLOCATOR)) {
	} else {
	}
	eval 'sub PageUptodate {
	    my($page) = @_;
    	    eval q({ \'int\'  &ret =  &test_bit( &PG_uptodate, ($page)-> &flags);  &if ( &ret)  &smp_rmb();  &ret; });
	}' unless defined(&PageUptodate);
	eval 'sub __SetPageUptodate {
	    my($page) = @_;
    	    eval q({  &smp_wmb();  &__set_bit( &PG_uptodate, ($page)-> &flags); });
	}' unless defined(&__SetPageUptodate);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub SetPageUptodate {
	    my($page) = @_;
    	    eval q({ });
	}' unless defined(&SetPageUptodate);
	eval 'sub set_page_writeback {
	    my($page) = @_;
    	    eval q({  &test_set_page_writeback($page); });
	}' unless defined(&set_page_writeback);
	if(defined(&CONFIG_PAGEFLAGS_EXTENDED)) {
	    eval 'sub PageCompound {
	        my($page) = @_;
    		eval q({  ($page->{flags}) & ((1 <<  &PG_head) | (1 <<  &PG_tail)); });
	    }' unless defined(&PageCompound);
	} else {
	    eval 'sub PG_head_tail_mask () {((1 <<  &PG_compound) | (1 <<  &PG_reclaim));}' unless defined(&PG_head_tail_mask);
	    eval 'sub PageTail {
	        my($page) = @_;
    		eval q({ (( ($page->{flags}) &  &PG_head_tail_mask) ==  &PG_head_tail_mask); });
	    }' unless defined(&PageTail);
	    eval 'sub __SetPageTail {
	        my($page) = @_;
    		eval q({  ($page->{flags}) |=  &PG_head_tail_mask; });
	    }' unless defined(&__SetPageTail);
	    eval 'sub __ClearPageTail {
	        my($page) = @_;
    		eval q({  ($page->{flags}) &= ~ &PG_head_tail_mask; });
	    }' unless defined(&__ClearPageTail);
	}
	eval 'sub PAGE_FLAGS () {(1<<  &PG_lru | 1<<  &PG_private | 1<<  &PG_locked | 1<<  &PG_buddy | 1<<  &PG_writeback | 1<<  &PG_slab | 1<<  &PG_swapcache | 1<<  &PG_active);}' unless defined(&PAGE_FLAGS);
	eval 'sub PAGE_FLAGS_CLEAR_WHEN_BAD () {( &PAGE_FLAGS | 1<<  &PG_reclaim | 1<<  &PG_dirty);}' unless defined(&PAGE_FLAGS_CLEAR_WHEN_BAD);
	eval 'sub PAGE_FLAGS_CHECK_AT_FREE () {( &PAGE_FLAGS | 1<<  &PG_reserved);}' unless defined(&PAGE_FLAGS_CHECK_AT_FREE);
	eval 'sub PAGE_FLAGS_CHECK_AT_PREP () {( &PAGE_FLAGS | 1<<  &PG_reserved | 1<<  &PG_dirty);}' unless defined(&PAGE_FLAGS_CHECK_AT_PREP);
    }
}
1;
