require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PAGEMAP_H)) {
    eval 'sub _LINUX_PAGEMAP_H () {1;}' unless defined(&_LINUX_PAGEMAP_H);
    require 'linux/mm.ph';
    require 'linux/fs.ph';
    require 'linux/list.ph';
    require 'linux/highmem.ph';
    require 'linux/compiler.ph';
    require 'asm/uaccess.ph';
    require 'linux/gfp.ph';
    require 'linux/bitops.ph';
    require 'linux/hardirq.ph';
    eval 'sub AS_EIO () {( &__GFP_BITS_SHIFT + 0);}' unless defined(&AS_EIO);
    eval 'sub AS_ENOSPC () {( &__GFP_BITS_SHIFT + 1);}' unless defined(&AS_ENOSPC);
    eval 'sub AS_MM_ALL_LOCKS () {( &__GFP_BITS_SHIFT + 2);}' unless defined(&AS_MM_ALL_LOCKS);
    eval 'sub mapping_set_error {
        my($mapping,$error) = @_;
	    eval q({  &if ( &unlikely($error)) {  &if ($error == - &ENOSPC)  &set_bit( &AS_ENOSPC,  ($mapping->{flags}));  &else  &set_bit( &AS_EIO,  ($mapping->{flags})); } });
    }' unless defined(&mapping_set_error);
    eval 'sub mapping_gfp_mask {
        my($mapping) = @_;
	    eval q({ ( &__force  &gfp_t) ($mapping->{flags}) &  &__GFP_BITS_MASK; });
    }' unless defined(&mapping_gfp_mask);
    eval 'sub PAGE_CACHE_SHIFT () { &PAGE_SHIFT;}' unless defined(&PAGE_CACHE_SHIFT);
    eval 'sub PAGE_CACHE_SIZE () { &PAGE_SIZE;}' unless defined(&PAGE_CACHE_SIZE);
    eval 'sub PAGE_CACHE_MASK () { &PAGE_MASK;}' unless defined(&PAGE_CACHE_MASK);
    eval 'sub PAGE_CACHE_ALIGN {
        my($addr) = @_;
	    eval q(((($addr)+ &PAGE_CACHE_SIZE-1) &PAGE_CACHE_MASK));
    }' unless defined(&PAGE_CACHE_ALIGN);
    eval 'sub page_cache_get {
        my($page) = @_;
	    eval q( &get_page($page));
    }' unless defined(&page_cache_get);
    eval 'sub page_cache_release {
        my($page) = @_;
	    eval q( &put_page($page));
    }' unless defined(&page_cache_release);
    if(!defined( &CONFIG_SMP)  && defined( &CONFIG_CLASSIC_RCU)) {
	if(defined(&CONFIG_PREEMPT)) {
	}
    } else {
    }
    if(!defined( &CONFIG_SMP)  && defined( &CONFIG_CLASSIC_RCU)) {
	if(defined(&CONFIG_PREEMPT)) {
	}
    } else {
    }
    eval 'sub page_freeze_refs {
        my($page,$count) = @_;
	    eval q({  &likely( &atomic_cmpxchg( ($page->{_$count}), $count, 0) == $count); });
    }' unless defined(&page_freeze_refs);
    eval 'sub page_unfreeze_refs {
        my($page,$count) = @_;
	    eval q({  &VM_BUG_ON( &page_count($page) != 0);  &VM_BUG_ON($count == 0);  &atomic_set( ($page->{_$count}), $count); });
    }' unless defined(&page_unfreeze_refs);
    if(defined(&CONFIG_NUMA)) {
    } else {
	eval 'sub page {
	    eval q(* &__page_cache_alloc( &gfp_t  &gfp) {  &alloc_pages( &gfp, 0); });
	}' unless defined(&page);
    }
    eval 'sub page {
        eval q(* &page_cache_alloc(\'struct address_space\' * &x) {  &__page_cache_alloc( &mapping_gfp_mask( &x)); });
    }' unless defined(&page);
    eval 'sub page {
        eval q(* &page_cache_alloc_cold(\'struct address_space\' * &x) {  &__page_cache_alloc( &mapping_gfp_mask( &x)| &__GFP_COLD); });
    }' unless defined(&page);
    eval 'sub page {
        eval q(* &read_mapping_page_async( \'struct address_space\' * &mapping,  &pgoff_t  &index,  &void * &data) {  &filler_t * &filler = ( &filler_t *) ($mapping->{a_ops}->{readpage});  &read_cache_page_async( &mapping,  &index,  &filler,  &data); });
    }' unless defined(&page);
    eval 'sub page {
        eval q(* &read_mapping_page(\'struct address_space\' * &mapping,  &pgoff_t  &index,  &void * &data) {  &filler_t * &filler = ( &filler_t *) ($mapping->{a_ops}->{readpage});  &read_cache_page( &mapping,  &index,  &filler,  &data); });
    }' unless defined(&page);
    eval 'sub linear_page_index {
        my($vma,$address) = @_;
	    eval q({  &pgoff_t  &pgoff = ($address -  ($vma->{vm_start})) >>  &PAGE_SHIFT;  &pgoff +=  ($vma->{vm_pgoff});  &pgoff >> ( &PAGE_CACHE_SHIFT -  &PAGE_SHIFT); });
    }' unless defined(&linear_page_index);
    eval 'sub set_page_locked {
        my($page) = @_;
	    eval q({  &set_bit( &PG_locked,  ($page->{flags})); });
    }' unless defined(&set_page_locked);
    eval 'sub clear_page_locked {
        my($page) = @_;
	    eval q({  &clear_bit( &PG_locked,  ($page->{flags})); });
    }' unless defined(&clear_page_locked);
    eval 'sub trylock_page {
        my($page) = @_;
	    eval q({ ! &test_and_set_bit( &PG_locked,  ($page->{flags})); });
    }' unless defined(&trylock_page);
    eval 'sub fault_in_pages_readable {
        my($uaddr,$size) = @_;
	    eval q({  &volatile \'char\'  &c; \'int\'  &ret;  &if ( &unlikely($size == 0)) 0;  &ret =  &__get_user( &c, $uaddr);  &if ( &ret == 0) {  &const \'char\'  &__user * &end = $uaddr + $size - 1;  &if (($uaddr &  &PAGE_MASK) != ( &end &  &PAGE_MASK))  &ret =  &__get_user( &c,  &end); }  &ret; });
    }' unless defined(&fault_in_pages_readable);
}
1;
