require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_PERCPU_H)) {
    eval 'sub __LINUX_PERCPU_H () {1;}' unless defined(&__LINUX_PERCPU_H);
    require 'linux/preempt.ph';
    require 'linux/slab.ph';
    require 'linux/smp.ph';
    require 'linux/cpumask.ph';
    require 'asm/percpu.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub DEFINE_PER_CPU {
	    my($type, $name) = @_;
    	    eval q( &__attribute__(( &__section__(\\".data.percpu\\")))  &PER_CPU_ATTRIBUTES  &__typeof__($type)  &per_cpu__$name);
	}' unless defined(&DEFINE_PER_CPU);
	if(defined(&MODULE)) {
	    eval 'sub SHARED_ALIGNED_SECTION () {".data.percpu";}' unless defined(&SHARED_ALIGNED_SECTION);
	} else {
	    eval 'sub SHARED_ALIGNED_SECTION () {".data.percpu.shared_aligned";}' unless defined(&SHARED_ALIGNED_SECTION);
	}
	eval 'sub DEFINE_PER_CPU_SHARED_ALIGNED {
	    my($type, $name) = @_;
    	    eval q( &__attribute__(( &__section__( &SHARED_ALIGNED_SECTION)))  &PER_CPU_ATTRIBUTES  &__typeof__($type)  &per_cpu__$name  &____cacheline_aligned_in_smp);
	}' unless defined(&DEFINE_PER_CPU_SHARED_ALIGNED);
    } else {
	eval 'sub DEFINE_PER_CPU {
	    my($type, $name) = @_;
    	    eval q( &PER_CPU_ATTRIBUTES  &__typeof__($type)  &per_cpu__$name);
	}' unless defined(&DEFINE_PER_CPU);
	eval 'sub DEFINE_PER_CPU_SHARED_ALIGNED {
	    my($type, $name) = @_;
    	    eval q( &DEFINE_PER_CPU($type, $name));
	}' unless defined(&DEFINE_PER_CPU_SHARED_ALIGNED);
    }
    eval 'sub EXPORT_PER_CPU_SYMBOL {
        my($var) = @_;
	    eval q( &EXPORT_SYMBOL( &per_cpu__$var));
    }' unless defined(&EXPORT_PER_CPU_SYMBOL);
    eval 'sub EXPORT_PER_CPU_SYMBOL_GPL {
        my($var) = @_;
	    eval q( &EXPORT_SYMBOL_GPL( &per_cpu__$var));
    }' unless defined(&EXPORT_PER_CPU_SYMBOL_GPL);
    unless(defined(&PERCPU_ENOUGH_ROOM)) {
	if(defined(&CONFIG_MODULES)) {
	    eval 'sub PERCPU_MODULE_RESERVE () {8192;}' unless defined(&PERCPU_MODULE_RESERVE);
	} else {
	    eval 'sub PERCPU_MODULE_RESERVE () {0;}' unless defined(&PERCPU_MODULE_RESERVE);
	}
	eval 'sub PERCPU_ENOUGH_ROOM () {( &__per_cpu_end -  &__per_cpu_start +  &PERCPU_MODULE_RESERVE);}' unless defined(&PERCPU_ENOUGH_ROOM);
    }
    eval 'sub get_cpu_var {
        my($var) = @_;
	    eval q((*({  &extern \'int\'  &simple_identifier_$var( &void);  &preempt_disable(); & &__get_cpu_var($var); })));
    }' unless defined(&get_cpu_var);
    eval 'sub put_cpu_var {
        my($var) = @_;
	    eval q( &preempt_enable());
    }' unless defined(&put_cpu_var);
    if(defined(&CONFIG_SMP)) {
	eval 'sub __percpu_disguise {
	    my($pdata) = @_;
    	    eval q(~($pdata));
	}' unless defined(&__percpu_disguise);
	eval 'sub percpu_ptr {
	    my($ptr, $cpu) = @_;
    	    eval q(({ \'struct percpu_data\' * &__p =  &__percpu_disguise($ptr); ( &__typeof__($ptr)) ($__p->{ptrs[&(cpu)]}); }));
	}' unless defined(&percpu_ptr);
    } else {
	eval 'sub percpu_ptr {
	    my($ptr, $cpu) = @_;
    	    eval q(({ ( &void)($cpu); ($ptr); }));
	}' unless defined(&percpu_ptr);
	eval 'sub percpu_free {
	    my($__pdata) = @_;
    	    eval q({  &kfree($__pdata); });
	}' unless defined(&percpu_free);
    }
    eval 'sub percpu_alloc_mask {
        my($size, $gfp, $mask) = @_;
	    eval q( &__percpu_alloc_mask(($size), ($gfp), ($mask)));
    }' unless defined(&percpu_alloc_mask);
    eval 'sub percpu_alloc {
        my($size, $gfp) = @_;
	    eval q( &percpu_alloc_mask(($size), ($gfp),  &cpu_online_map));
    }' unless defined(&percpu_alloc);
    eval 'sub __alloc_percpu {
        my($size) = @_;
	    eval q( &percpu_alloc_mask(($size),  &GFP_KERNEL,  &cpu_possible_map));
    }' unless defined(&__alloc_percpu);
    eval 'sub alloc_percpu {
        my($type) = @_;
	    eval q(($type *) &__alloc_percpu($sizeof{$type}));
    }' unless defined(&alloc_percpu);
    eval 'sub free_percpu {
        my($ptr) = @_;
	    eval q( &percpu_free(($ptr)));
    }' unless defined(&free_percpu);
    eval 'sub per_cpu_ptr {
        my($ptr, $cpu) = @_;
	    eval q( &percpu_ptr(($ptr), ($cpu)));
    }' unless defined(&per_cpu_ptr);
}
1;
