require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PERCPU_COUNTER_H)) {
    eval 'sub _LINUX_PERCPU_COUNTER_H () {1;}' unless defined(&_LINUX_PERCPU_COUNTER_H);
    require 'linux/spinlock.ph';
    require 'linux/smp.ph';
    require 'linux/list.ph';
    require 'linux/threads.ph';
    require 'linux/percpu.ph';
    require 'linux/types.ph';
    if(defined(&CONFIG_SMP)) {
	if(defined(&CONFIG_HOTPLUG_CPU)) {
	}
	if((defined(&NR_CPUS) ? &NR_CPUS : undef) >= 16) {
	    eval 'sub FBC_BATCH () {( &NR_CPUS*2);}' unless defined(&FBC_BATCH);
	} else {
	    eval 'sub FBC_BATCH () {( &NR_CPUS*4);}' unless defined(&FBC_BATCH);
	}
	eval 'sub percpu_counter_add {
	    my($fbc,$amount) = @_;
    	    eval q({  &__percpu_counter_add($fbc, $amount,  &FBC_BATCH); });
	}' unless defined(&percpu_counter_add);
	eval 'sub percpu_counter_sum_positive {
	    my($fbc) = @_;
    	    eval q({  &s64  &ret =  &__percpu_counter_sum($fbc, 0);  &ret < 0? 0:  &ret; });
	}' unless defined(&percpu_counter_sum_positive);
	eval 'sub percpu_counter_sum_and_set {
	    my($fbc) = @_;
    	    eval q({  &__percpu_counter_sum($fbc, 1); });
	}' unless defined(&percpu_counter_sum_and_set);
	eval 'sub percpu_counter_sum {
	    my($fbc) = @_;
    	    eval q({  &__percpu_counter_sum($fbc, 0); });
	}' unless defined(&percpu_counter_sum);
	eval 'sub percpu_counter_read {
	    my($fbc) = @_;
    	    eval q({  ($fbc->{count}); });
	}' unless defined(&percpu_counter_read);
    } else {
	eval 'sub percpu_counter_init {
	    my($fbc,$amount) = @_;
    	    eval q({  ($fbc->{count}) = $amount; 0; });
	}' unless defined(&percpu_counter_init);
	eval 'sub percpu_counter_init_irq () { &percpu_counter_init;}' unless defined(&percpu_counter_init_irq);
	eval 'sub percpu_counter_destroy {
	    my($fbc) = @_;
    	    eval q({ });
	}' unless defined(&percpu_counter_destroy);
	eval 'sub percpu_counter_set {
	    my($fbc,$amount) = @_;
    	    eval q({  ($fbc->{count}) = $amount; });
	}' unless defined(&percpu_counter_set);
	eval 'sub __percpu_counter_add {
	    my($fbc, $amount, $batch) = @_;
    	    eval q( &percpu_counter_add($fbc, $amount));
	}' unless defined(&__percpu_counter_add);
	eval 'sub percpu_counter_add {
	    my($fbc,$amount) = @_;
    	    eval q({  &preempt_disable();  ($fbc->{count}) += $amount;  &preempt_enable(); });
	}' unless defined(&percpu_counter_add);
	eval 'sub percpu_counter_read {
	    my($fbc) = @_;
    	    eval q({  ($fbc->{count}); });
	}' unless defined(&percpu_counter_read);
	eval 'sub percpu_counter_read_positive {
	    my($fbc) = @_;
    	    eval q({  ($fbc->{count}); });
	}' unless defined(&percpu_counter_read_positive);
	eval 'sub percpu_counter_sum_positive {
	    my($fbc) = @_;
    	    eval q({  &percpu_counter_read_positive($fbc); });
	}' unless defined(&percpu_counter_sum_positive);
	eval 'sub percpu_counter_sum {
	    my($fbc) = @_;
    	    eval q({  &percpu_counter_read($fbc); });
	}' unless defined(&percpu_counter_sum);
    }
    eval 'sub percpu_counter_inc {
        my($fbc) = @_;
	    eval q({  &percpu_counter_add($fbc, 1); });
    }' unless defined(&percpu_counter_inc);
    eval 'sub percpu_counter_dec {
        my($fbc) = @_;
	    eval q({  &percpu_counter_add($fbc, -1); });
    }' unless defined(&percpu_counter_dec);
    eval 'sub percpu_counter_sub {
        my($fbc,$amount) = @_;
	    eval q({  &percpu_counter_add($fbc, -$amount); });
    }' unless defined(&percpu_counter_sub);
}
1;
