require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PM_H)) {
    eval 'sub _LINUX_PM_H () {1;}' unless defined(&_LINUX_PM_H);
    require 'linux/list.ph';
    eval 'sub PM_EVENT_ON () {0x;}' unless defined(&PM_EVENT_ON);
    eval 'sub PM_EVENT_FREEZE () {0x1;}' unless defined(&PM_EVENT_FREEZE);
    eval 'sub PM_EVENT_SUSPEND () {0x2;}' unless defined(&PM_EVENT_SUSPEND);
    eval 'sub PM_EVENT_HIBERNATE () {0x4;}' unless defined(&PM_EVENT_HIBERNATE);
    eval 'sub PM_EVENT_QUIESCE () {0x8;}' unless defined(&PM_EVENT_QUIESCE);
    eval 'sub PM_EVENT_RESUME () {0x10;}' unless defined(&PM_EVENT_RESUME);
    eval 'sub PM_EVENT_THAW () {0x20;}' unless defined(&PM_EVENT_THAW);
    eval 'sub PM_EVENT_RESTORE () {0x40;}' unless defined(&PM_EVENT_RESTORE);
    eval 'sub PM_EVENT_RECOVER () {0x80;}' unless defined(&PM_EVENT_RECOVER);
    eval 'sub PM_EVENT_USER () {0x100;}' unless defined(&PM_EVENT_USER);
    eval 'sub PM_EVENT_REMOTE () {0x200;}' unless defined(&PM_EVENT_REMOTE);
    eval 'sub PM_EVENT_AUTO () {0x400;}' unless defined(&PM_EVENT_AUTO);
    eval 'sub PM_EVENT_SLEEP () {( &PM_EVENT_SUSPEND |  &PM_EVENT_HIBERNATE);}' unless defined(&PM_EVENT_SLEEP);
    eval 'sub PM_EVENT_USER_SUSPEND () {( &PM_EVENT_USER |  &PM_EVENT_SUSPEND);}' unless defined(&PM_EVENT_USER_SUSPEND);
    eval 'sub PM_EVENT_USER_RESUME () {( &PM_EVENT_USER |  &PM_EVENT_RESUME);}' unless defined(&PM_EVENT_USER_RESUME);
    eval 'sub PM_EVENT_REMOTE_WAKEUP () {( &PM_EVENT_REMOTE |  &PM_EVENT_RESUME);}' unless defined(&PM_EVENT_REMOTE_WAKEUP);
    eval 'sub PM_EVENT_AUTO_SUSPEND () {( &PM_EVENT_AUTO |  &PM_EVENT_SUSPEND);}' unless defined(&PM_EVENT_AUTO_SUSPEND);
    eval 'sub PM_EVENT_AUTO_RESUME () {( &PM_EVENT_AUTO |  &PM_EVENT_RESUME);}' unless defined(&PM_EVENT_AUTO_RESUME);
    eval 'sub PMSG_ON () {({ . &event =  &PM_EVENT_ON, });}' unless defined(&PMSG_ON);
    eval 'sub PMSG_FREEZE () {({ . &event =  &PM_EVENT_FREEZE, });}' unless defined(&PMSG_FREEZE);
    eval 'sub PMSG_QUIESCE () {({ . &event =  &PM_EVENT_QUIESCE, });}' unless defined(&PMSG_QUIESCE);
    eval 'sub PMSG_SUSPEND () {({ . &event =  &PM_EVENT_SUSPEND, });}' unless defined(&PMSG_SUSPEND);
    eval 'sub PMSG_HIBERNATE () {({ . &event =  &PM_EVENT_HIBERNATE, });}' unless defined(&PMSG_HIBERNATE);
    eval 'sub PMSG_RESUME () {({ . &event =  &PM_EVENT_RESUME, });}' unless defined(&PMSG_RESUME);
    eval 'sub PMSG_THAW () {({ . &event =  &PM_EVENT_THAW, });}' unless defined(&PMSG_THAW);
    eval 'sub PMSG_RESTORE () {({ . &event =  &PM_EVENT_RESTORE, });}' unless defined(&PMSG_RESTORE);
    eval 'sub PMSG_RECOVER () {({ . &event =  &PM_EVENT_RECOVER, });}' unless defined(&PMSG_RECOVER);
    eval 'sub PMSG_USER_SUSPEND () {( { . &event =  &PM_EVENT_USER_SUSPEND, });}' unless defined(&PMSG_USER_SUSPEND);
    eval 'sub PMSG_USER_RESUME () {( { . &event =  &PM_EVENT_USER_RESUME, });}' unless defined(&PMSG_USER_RESUME);
    eval 'sub PMSG_REMOTE_RESUME () {( { . &event =  &PM_EVENT_REMOTE_RESUME, });}' unless defined(&PMSG_REMOTE_RESUME);
    eval 'sub PMSG_AUTO_SUSPEND () {( { . &event =  &PM_EVENT_AUTO_SUSPEND, });}' unless defined(&PMSG_AUTO_SUSPEND);
    eval 'sub PMSG_AUTO_RESUME () {( { . &event =  &PM_EVENT_AUTO_RESUME, });}' unless defined(&PMSG_AUTO_RESUME);
    eval("sub DPM_INVALID () { 0; }") unless defined(&DPM_INVALID);
    eval("sub DPM_ON () { 1; }") unless defined(&DPM_ON);
    eval("sub DPM_PREPARING () { 2; }") unless defined(&DPM_PREPARING);
    eval("sub DPM_RESUMING () { 3; }") unless defined(&DPM_RESUMING);
    eval("sub DPM_SUSPENDING () { 4; }") unless defined(&DPM_SUSPENDING);
    eval("sub DPM_OFF () { 5; }") unless defined(&DPM_OFF);
    eval("sub DPM_OFF_IRQ () { 6; }") unless defined(&DPM_OFF_IRQ);
    if(defined(&CONFIG_PM_SLEEP)) {
    }
    eval 'sub PM_EVENT_PRETHAW () { &PM_EVENT_QUIESCE;}' unless defined(&PM_EVENT_PRETHAW);
    if(defined(&CONFIG_PM_SLEEP)) {
	eval 'sub suspend_report_result {
	    my($fn, $ret) = @_;
    	    eval q( &do {  &__suspend_report_result( &__FUNCTION__, $fn, $ret); }  &while (0));
	}' unless defined(&suspend_report_result);
    } else {
	eval 'sub device_suspend {
	    my($state) = @_;
    	    eval q({ 0; });
	}' unless defined(&device_suspend);
	eval 'sub suspend_report_result {
	    my($fn, $ret) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&suspend_report_result);
    }
    eval 'sub PM_APM () {1;}' unless defined(&PM_APM);
    eval 'sub PM_ACPI () {2;}' unless defined(&PM_ACPI);
}
1;
