require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_PREEMPT_H)) {
    eval 'sub __LINUX_PREEMPT_H () {1;}' unless defined(&__LINUX_PREEMPT_H);
    require 'linux/thread_info.ph';
    require 'linux/linkage.ph';
    require 'linux/list.ph';
    if(defined( &CONFIG_DEBUG_PREEMPT) || defined( &CONFIG_PREEMPT_TRACER)) {
    } else {
	eval 'sub add_preempt_count {
	    my($val) = @_;
    	    eval q( &do {  &preempt_count() += ($val); }  &while (0));
	}' unless defined(&add_preempt_count);
	eval 'sub sub_preempt_count {
	    my($val) = @_;
    	    eval q( &do {  &preempt_count() -= ($val); }  &while (0));
	}' unless defined(&sub_preempt_count);
    }
    eval 'sub inc_preempt_count () {
        eval q( &add_preempt_count(1));
    }' unless defined(&inc_preempt_count);
    eval 'sub dec_preempt_count () {
        eval q( &sub_preempt_count(1));
    }' unless defined(&dec_preempt_count);
    eval 'sub preempt_count () {
        eval q(( &current_thread_info()-> &preempt_count));
    }' unless defined(&preempt_count);
    if(defined(&CONFIG_PREEMPT)) {
	eval 'sub preempt_disable () {
	    eval q( &do {  &inc_preempt_count();  &barrier(); }  &while (0));
	}' unless defined(&preempt_disable);
	eval 'sub preempt_enable_no_resched () {
	    eval q( &do {  &barrier();  &dec_preempt_count(); }  &while (0));
	}' unless defined(&preempt_enable_no_resched);
	eval 'sub preempt_check_resched () {
	    eval q( &do {  &if ( &unlikely( &test_thread_flag( &TIF_NEED_RESCHED)))  &preempt_schedule(); }  &while (0));
	}' unless defined(&preempt_check_resched);
	eval 'sub preempt_enable () {
	    eval q( &do {  &preempt_enable_no_resched();  &barrier();  &preempt_check_resched(); }  &while (0));
	}' unless defined(&preempt_enable);
	eval 'sub add_preempt_count_notrace {
	    my($val) = @_;
    	    eval q( &do {  &preempt_count() += ($val); }  &while (0));
	}' unless defined(&add_preempt_count_notrace);
	eval 'sub sub_preempt_count_notrace {
	    my($val) = @_;
    	    eval q( &do {  &preempt_count() -= ($val); }  &while (0));
	}' unless defined(&sub_preempt_count_notrace);
	eval 'sub inc_preempt_count_notrace () {
	    eval q( &add_preempt_count_notrace(1));
	}' unless defined(&inc_preempt_count_notrace);
	eval 'sub dec_preempt_count_notrace () {
	    eval q( &sub_preempt_count_notrace(1));
	}' unless defined(&dec_preempt_count_notrace);
	eval 'sub preempt_disable_notrace () {
	    eval q( &do {  &inc_preempt_count_notrace();  &barrier(); }  &while (0));
	}' unless defined(&preempt_disable_notrace);
	eval 'sub preempt_enable_no_resched_notrace () {
	    eval q( &do {  &barrier();  &dec_preempt_count_notrace(); }  &while (0));
	}' unless defined(&preempt_enable_no_resched_notrace);
	eval 'sub preempt_enable_notrace () {
	    eval q( &do {  &preempt_enable_no_resched_notrace();  &barrier();  &preempt_check_resched(); }  &while (0));
	}' unless defined(&preempt_enable_notrace);
    } else {
	eval 'sub preempt_disable () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_disable);
	eval 'sub preempt_enable_no_resched () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_enable_no_resched);
	eval 'sub preempt_enable () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_enable);
	eval 'sub preempt_check_resched () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_check_resched);
	eval 'sub preempt_disable_notrace () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_disable_notrace);
	eval 'sub preempt_enable_no_resched_notrace () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_enable_no_resched_notrace);
	eval 'sub preempt_enable_notrace () {
	    eval q( &do { }  &while (0));
	}' unless defined(&preempt_enable_notrace);
    }
    if(defined(&CONFIG_PREEMPT_NOTIFIERS)) {
	eval 'sub preempt_notifier_init {
	    my($notifier,$ops) = @_;
    	    eval q({  &INIT_HLIST_NODE( ($notifier->{link}));  ($notifier->{ops}) = $ops; });
	}' unless defined(&preempt_notifier_init);
    }
}
1;
