require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_QUOTAOPS_)) {
    eval 'sub _LINUX_QUOTAOPS_ () {1;}' unless defined(&_LINUX_QUOTAOPS_);
    require 'linux/smp_lock.ph';
    require 'linux/fs.ph';
    eval 'sub quota_info {
        eval q(* &sb_dqopt(\'struct super_block\' * &sb) {  ($sb->{s_dquot}); });
    }' unless defined(&quota_info);
    if(defined( &CONFIG_QUOTA)) {
	eval 'sub mem_dqinfo {
	    eval q(* &sb_dqinfo(\'struct super_block\' * &sb, \'int\'  &type) {  &sb_dqopt( &sb)-> &info +  &type; });
	}' unless defined(&mem_dqinfo);
	eval 'sub sb_any_quota_enabled {
	    my($sb) = @_;
    	    eval q({  &sb_has_quota_enabled($sb,  &USRQUOTA) ||  &sb_has_quota_enabled($sb,  &GRPQUOTA); });
	}' unless defined(&sb_any_quota_enabled);
	eval 'sub sb_has_quota_suspended {
	    my($sb,$type) = @_;
    	    eval q({  &if ($type ==  &USRQUOTA)  &sb_dqopt($sb)-> &flags &  &DQUOT_USR_SUSPENDED;  &sb_dqopt($sb)-> &flags &  &DQUOT_GRP_SUSPENDED; });
	}' unless defined(&sb_has_quota_suspended);
	eval 'sub sb_any_quota_suspended {
	    my($sb) = @_;
    	    eval q({  &sb_has_quota_suspended($sb,  &USRQUOTA) ||  &sb_has_quota_suspended($sb,  &GRPQUOTA); });
	}' unless defined(&sb_any_quota_suspended);
	eval 'sub sb_dquot_ops () {( &dquot_operations);}' unless defined(&sb_dquot_ops);
	eval 'sub sb_quotactl_ops () {( &vfs_quotactl_ops);}' unless defined(&sb_quotactl_ops);
	eval 'sub vfs_dq_prealloc_space {
	    my($inode,$nr) = @_;
    	    eval q({ \'int\'  &ret;  &if (!( &ret =  &vfs_dq_prealloc_space_nodirty($inode, $nr)))  &mark_inode_dirty($inode);  &ret; });
	}' unless defined(&vfs_dq_prealloc_space);
	eval 'sub vfs_dq_alloc_space_nodirty {
	    my($inode,$nr) = @_;
    	    eval q({  &if ( &sb_any_quota_enabled( ($inode->{i_sb}))) {  &if ( ($inode->{i_sb}->{dq_op}->{alloc_space})($inode, $nr, 0) ==  &NO_QUOTA) 1; }  &else  &inode_add_bytes($inode, $nr); 0; });
	}' unless defined(&vfs_dq_alloc_space_nodirty);
	eval 'sub vfs_dq_alloc_space {
	    my($inode,$nr) = @_;
    	    eval q({ \'int\'  &ret;  &if (!( &ret =  &vfs_dq_alloc_space_nodirty($inode, $nr)))  &mark_inode_dirty($inode);  &ret; });
	}' unless defined(&vfs_dq_alloc_space);
	eval 'sub vfs_dq_alloc_inode {
	    my($inode) = @_;
    	    eval q({  &if ( &sb_any_quota_enabled( ($inode->{i_sb}))) {  &vfs_dq_init($inode);  &if ( ($inode->{i_sb}->{dq_op}->{alloc_inode})($inode, 1) ==  &NO_QUOTA) 1; } 0; });
	}' unless defined(&vfs_dq_alloc_inode);
	eval 'sub vfs_dq_free_space_nodirty {
	    my($inode,$nr) = @_;
    	    eval q({  &if ( &sb_any_quota_enabled( ($inode->{i_sb})))  ($inode->{i_sb}->{dq_op}->{free_space})($inode, $nr);  &else  &inode_sub_bytes($inode, $nr); });
	}' unless defined(&vfs_dq_free_space_nodirty);
	eval 'sub vfs_dq_free_space {
	    my($inode,$nr) = @_;
    	    eval q({  &vfs_dq_free_space_nodirty($inode, $nr);  &mark_inode_dirty($inode); });
	}' unless defined(&vfs_dq_free_space);
	eval 'sub vfs_dq_free_inode {
	    my($inode) = @_;
    	    eval q({  &if ( &sb_any_quota_enabled( ($inode->{i_sb})))  ($inode->{i_sb}->{dq_op}->{free_inode})($inode, 1); });
	}' unless defined(&vfs_dq_free_inode);
	eval 'sub vfs_dq_off {
	    my($sb,$remount) = @_;
    	    eval q({ \'int\'  &ret = - &ENOSYS;  &if ( ($sb->{s_qcop})  &&  ($sb->{s_qcop}->{quota_off}))  &ret =  ($sb->{s_qcop}->{quota_off})($sb, -1, $remount);  &ret; });
	}' unless defined(&vfs_dq_off);
    } else {
	eval 'sub sb_has_quota_enabled {
	    my($sb,$type) = @_;
    	    eval q({ 0; });
	}' unless defined(&sb_has_quota_enabled);
	eval 'sub sb_any_quota_enabled {
	    my($sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&sb_any_quota_enabled);
	eval 'sub sb_has_quota_suspended {
	    my($sb,$type) = @_;
    	    eval q({ 0; });
	}' unless defined(&sb_has_quota_suspended);
	eval 'sub sb_any_quota_suspended {
	    my($sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&sb_any_quota_suspended);
	eval 'sub sb_dquot_ops () {( &NULL);}' unless defined(&sb_dquot_ops);
	eval 'sub sb_quotactl_ops () {( &NULL);}' unless defined(&sb_quotactl_ops);
	eval 'sub vfs_dq_init {
	    my($inode) = @_;
    	    eval q({ });
	}' unless defined(&vfs_dq_init);
	eval 'sub vfs_dq_drop {
	    my($inode) = @_;
    	    eval q({ });
	}' unless defined(&vfs_dq_drop);
	eval 'sub vfs_dq_alloc_inode {
	    my($inode) = @_;
    	    eval q({ 0; });
	}' unless defined(&vfs_dq_alloc_inode);
	eval 'sub vfs_dq_free_inode {
	    my($inode) = @_;
    	    eval q({ });
	}' unless defined(&vfs_dq_free_inode);
	eval 'sub vfs_dq_sync {
	    my($sb) = @_;
    	    eval q({ });
	}' unless defined(&vfs_dq_sync);
	eval 'sub vfs_dq_off {
	    my($sb,$remount) = @_;
    	    eval q({ 0; });
	}' unless defined(&vfs_dq_off);
	eval 'sub vfs_dq_quota_on_remount {
	    my($sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&vfs_dq_quota_on_remount);
	eval 'sub vfs_dq_transfer {
	    my($inode,$iattr) = @_;
    	    eval q({ 0; });
	}' unless defined(&vfs_dq_transfer);
	eval 'sub vfs_dq_prealloc_space_nodirty {
	    my($inode,$nr) = @_;
    	    eval q({  &inode_add_bytes($inode, $nr); 0; });
	}' unless defined(&vfs_dq_prealloc_space_nodirty);
	eval 'sub vfs_dq_prealloc_space {
	    my($inode,$nr) = @_;
    	    eval q({  &vfs_dq_prealloc_space_nodirty($inode, $nr);  &mark_inode_dirty($inode); 0; });
	}' unless defined(&vfs_dq_prealloc_space);
	eval 'sub vfs_dq_alloc_space_nodirty {
	    my($inode,$nr) = @_;
    	    eval q({  &inode_add_bytes($inode, $nr); 0; });
	}' unless defined(&vfs_dq_alloc_space_nodirty);
	eval 'sub vfs_dq_alloc_space {
	    my($inode,$nr) = @_;
    	    eval q({  &vfs_dq_alloc_space_nodirty($inode, $nr);  &mark_inode_dirty($inode); 0; });
	}' unless defined(&vfs_dq_alloc_space);
	eval 'sub vfs_dq_free_space_nodirty {
	    my($inode,$nr) = @_;
    	    eval q({  &inode_sub_bytes($inode, $nr); });
	}' unless defined(&vfs_dq_free_space_nodirty);
	eval 'sub vfs_dq_free_space {
	    my($inode,$nr) = @_;
    	    eval q({  &vfs_dq_free_space_nodirty($inode, $nr);  &mark_inode_dirty($inode); } );
	}' unless defined(&vfs_dq_free_space);
    }
    eval 'sub vfs_dq_prealloc_block_nodirty {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_prealloc_space_nodirty($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_prealloc_block_nodirty);
    eval 'sub vfs_dq_prealloc_block {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_prealloc_space($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_prealloc_block);
    eval 'sub vfs_dq_alloc_block_nodirty {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_alloc_space_nodirty($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_alloc_block_nodirty);
    eval 'sub vfs_dq_alloc_block {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_alloc_space($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_alloc_block);
    eval 'sub vfs_dq_free_block_nodirty {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_free_space_nodirty($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_free_block_nodirty);
    eval 'sub vfs_dq_free_block {
        my($inode,$nr) = @_;
	    eval q({  &vfs_dq_free_space($inode, $nr <<  ($inode->{i_sb}->{s_blocksize_bits})); });
    }' unless defined(&vfs_dq_free_block);
    eval 'sub DQUOT_INIT {
        my($inode) = @_;
	    eval q( &vfs_dq_init($inode));
    }' unless defined(&DQUOT_INIT);
    eval 'sub DQUOT_DROP {
        my($inode) = @_;
	    eval q( &vfs_dq_drop($inode));
    }' unless defined(&DQUOT_DROP);
    eval 'sub DQUOT_PREALLOC_SPACE_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_prealloc_space_nodirty($inode, $nr));
    }' unless defined(&DQUOT_PREALLOC_SPACE_NODIRTY);
    eval 'sub DQUOT_PREALLOC_SPACE {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_prealloc_space($inode, $nr));
    }' unless defined(&DQUOT_PREALLOC_SPACE);
    eval 'sub DQUOT_ALLOC_SPACE_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_alloc_space_nodirty($inode, $nr));
    }' unless defined(&DQUOT_ALLOC_SPACE_NODIRTY);
    eval 'sub DQUOT_ALLOC_SPACE {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_alloc_space($inode, $nr));
    }' unless defined(&DQUOT_ALLOC_SPACE);
    eval 'sub DQUOT_PREALLOC_BLOCK_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_prealloc_block_nodirty($inode, $nr));
    }' unless defined(&DQUOT_PREALLOC_BLOCK_NODIRTY);
    eval 'sub DQUOT_PREALLOC_BLOCK {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_prealloc_block($inode, $nr));
    }' unless defined(&DQUOT_PREALLOC_BLOCK);
    eval 'sub DQUOT_ALLOC_BLOCK_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_alloc_block_nodirty($inode, $nr));
    }' unless defined(&DQUOT_ALLOC_BLOCK_NODIRTY);
    eval 'sub DQUOT_ALLOC_BLOCK {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_alloc_block($inode, $nr));
    }' unless defined(&DQUOT_ALLOC_BLOCK);
    eval 'sub DQUOT_ALLOC_INODE {
        my($inode) = @_;
	    eval q( &vfs_dq_alloc_inode($inode));
    }' unless defined(&DQUOT_ALLOC_INODE);
    eval 'sub DQUOT_FREE_SPACE_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_free_space_nodirty($inode, $nr));
    }' unless defined(&DQUOT_FREE_SPACE_NODIRTY);
    eval 'sub DQUOT_FREE_SPACE {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_free_space($inode, $nr));
    }' unless defined(&DQUOT_FREE_SPACE);
    eval 'sub DQUOT_FREE_BLOCK_NODIRTY {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_free_block_nodirty($inode, $nr));
    }' unless defined(&DQUOT_FREE_BLOCK_NODIRTY);
    eval 'sub DQUOT_FREE_BLOCK {
        my($inode, $nr) = @_;
	    eval q( &vfs_dq_free_block($inode, $nr));
    }' unless defined(&DQUOT_FREE_BLOCK);
    eval 'sub DQUOT_FREE_INODE {
        my($inode) = @_;
	    eval q( &vfs_dq_free_inode($inode));
    }' unless defined(&DQUOT_FREE_INODE);
    eval 'sub DQUOT_TRANSFER {
        my($inode, $iattr) = @_;
	    eval q( &vfs_dq_transfer($inode, $iattr));
    }' unless defined(&DQUOT_TRANSFER);
    eval 'sub DQUOT_SYNC {
        my($sb) = @_;
	    eval q( &vfs_dq_sync($sb));
    }' unless defined(&DQUOT_SYNC);
    eval 'sub DQUOT_OFF {
        my($sb, $remount) = @_;
	    eval q( &vfs_dq_off($sb, $remount));
    }' unless defined(&DQUOT_OFF);
    eval 'sub DQUOT_ON_REMOUNT {
        my($sb) = @_;
	    eval q( &vfs_dq_quota_on_remount($sb));
    }' unless defined(&DQUOT_ON_REMOUNT);
}
1;
