require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_RADIX_TREE_H)) {
    eval 'sub _LINUX_RADIX_TREE_H () {1;}' unless defined(&_LINUX_RADIX_TREE_H);
    require 'linux/preempt.ph';
    require 'linux/types.ph';
    require 'linux/kernel.ph';
    require 'linux/rcupdate.ph';
    eval 'sub RADIX_TREE_INDIRECT_PTR () {1;}' unless defined(&RADIX_TREE_INDIRECT_PTR);
    eval 'sub RADIX_TREE_RETRY () {(( &void *)-1);}' unless defined(&RADIX_TREE_RETRY);
    eval 'sub void {
        eval q(* &radix_tree_ptr_to_indirect( &void * &ptr) { ( &void *)( &ptr |  &RADIX_TREE_INDIRECT_PTR); });
    }' unless defined(&void);
    eval 'sub void {
        eval q(* &radix_tree_indirect_to_ptr( &void * &ptr) { ( &void *)( &ptr & ~ &RADIX_TREE_INDIRECT_PTR); });
    }' unless defined(&void);
    eval 'sub radix_tree_is_indirect_ptr {
        my($ptr) = @_;
	    eval q({ ($ptr &  &RADIX_TREE_INDIRECT_PTR); });
    }' unless defined(&radix_tree_is_indirect_ptr);
    eval 'sub RADIX_TREE_MAX_TAGS () {2;}' unless defined(&RADIX_TREE_MAX_TAGS);
    eval 'sub RADIX_TREE_INIT {
        my($mask) = @_;
	    eval q({ . &height = 0, . &gfp_mask = ($mask), . &rnode =  &NULL, });
    }' unless defined(&RADIX_TREE_INIT);
    eval 'sub RADIX_TREE {
        my($name, $mask) = @_;
	    eval q(\'struct radix_tree_root\' $name =  &RADIX_TREE_INIT($mask));
    }' unless defined(&RADIX_TREE);
    eval 'sub INIT_RADIX_TREE {
        my($root, $mask) = @_;
	    eval q( &do { ($root)-> &height = 0; ($root)-> &gfp_mask = ($mask); ($root)-> &rnode =  &NULL; }  &while (0));
    }' unless defined(&INIT_RADIX_TREE);
    eval 'sub radix_tree_preload_end {
        my($void) = @_;
	    eval q({  &preempt_enable(); });
    }' unless defined(&radix_tree_preload_end);
}
1;
