require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUCLASSIC_H)) {
    eval 'sub __LINUX_RCUCLASSIC_H () {1;}' unless defined(&__LINUX_RCUCLASSIC_H);
    require 'linux/cache.ph';
    require 'linux/spinlock.ph';
    require 'linux/threads.ph';
    require 'linux/percpu.ph';
    require 'linux/cpumask.ph';
    require 'linux/seqlock.ph';
    eval 'sub rcu_bh_qsctr_inc {
        my($cpu) = @_;
	    eval q({ \'struct rcu_data\' * &rdp =  &per_cpu( &rcu_bh_data, $cpu);  ($rdp->{passed_quiesc}) = 1; });
    }' unless defined(&rcu_bh_qsctr_inc);
    if(defined(&CONFIG_DEBUG_LOCK_ALLOC)) {
	eval 'sub rcu_read_acquire () {
	    eval q( &lock_acquire( &rcu_lock_map, 0, 0, 2, 1,  &NULL,  &_THIS_IP_));
	}' unless defined(&rcu_read_acquire);
	eval 'sub rcu_read_release () {
	    eval q( &lock_release( &rcu_lock_map, 1,  &_THIS_IP_));
	}' unless defined(&rcu_read_release);
    } else {
	eval 'sub rcu_read_acquire () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_read_acquire);
	eval 'sub rcu_read_release () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_read_release);
    }
    eval 'sub __rcu_read_lock () {
        eval q( &do {  &preempt_disable();  &__acquire( &RCU);  &rcu_read_acquire(); }  &while (0));
    }' unless defined(&__rcu_read_lock);
    eval 'sub __rcu_read_unlock () {
        eval q( &do {  &rcu_read_release();  &__release( &RCU);  &preempt_enable(); }  &while (0));
    }' unless defined(&__rcu_read_unlock);
    eval 'sub __rcu_read_lock_bh () {
        eval q( &do {  &local_bh_disable();  &__acquire( &RCU_BH);  &rcu_read_acquire(); }  &while (0));
    }' unless defined(&__rcu_read_lock_bh);
    eval 'sub __rcu_read_unlock_bh () {
        eval q( &do {  &rcu_read_release();  &__release( &RCU_BH);  &local_bh_enable(); }  &while (0));
    }' unless defined(&__rcu_read_unlock_bh);
    eval 'sub __synchronize_sched () {
        eval q( &synchronize_rcu());
    }' unless defined(&__synchronize_sched);
    eval 'sub call_rcu_sched {
        my($head, $func) = @_;
	    eval q( &call_rcu($head, $func));
    }' unless defined(&call_rcu_sched);
    eval 'sub rcu_init_sched () {
        eval q( &do { }  &while (0));
    }' unless defined(&rcu_init_sched);
    eval 'sub rcu_enter_nohz () {
        eval q( &do { }  &while (0));
    }' unless defined(&rcu_enter_nohz);
    eval 'sub rcu_exit_nohz () {
        eval q( &do { }  &while (0));
    }' unless defined(&rcu_exit_nohz);
}
1;
