require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUPDATE_H)) {
    eval 'sub __LINUX_RCUPDATE_H () {1;}' unless defined(&__LINUX_RCUPDATE_H);
    require 'linux/cache.ph';
    require 'linux/spinlock.ph';
    require 'linux/threads.ph';
    require 'linux/percpu.ph';
    require 'linux/cpumask.ph';
    require 'linux/seqlock.ph';
    require 'linux/lockdep.ph';
    require 'linux/completion.ph';
    if(defined(&CONFIG_CLASSIC_RCU)) {
	require 'linux/rcuclassic.ph';
    } else {
	require 'linux/rcupreempt.ph';
    }
    eval 'sub RCU_HEAD_INIT () {{ . &next =  &NULL, . &func =  &NULL };}' unless defined(&RCU_HEAD_INIT);
    eval 'sub RCU_HEAD {
        my($head) = @_;
	    eval q(\'struct rcu_head\' $head =  &RCU_HEAD_INIT);
    }' unless defined(&RCU_HEAD);
    eval 'sub INIT_RCU_HEAD {
        my($ptr) = @_;
	    eval q( &do { ($ptr)-> &next =  &NULL; ($ptr)-> &func =  &NULL; }  &while (0));
    }' unless defined(&INIT_RCU_HEAD);
    eval 'sub rcu_read_lock () {
        eval q( &__rcu_read_lock());
    }' unless defined(&rcu_read_lock);
    eval 'sub rcu_read_unlock () {
        eval q( &__rcu_read_unlock());
    }' unless defined(&rcu_read_unlock);
    eval 'sub rcu_read_lock_bh () {
        eval q( &__rcu_read_lock_bh());
    }' unless defined(&rcu_read_lock_bh);
    eval 'sub rcu_read_unlock_bh () {
        eval q( &__rcu_read_unlock_bh());
    }' unless defined(&rcu_read_unlock_bh);
    eval 'sub rcu_dereference {
        my($p) = @_;
	    eval q(({  &typeof($p)  &_________p1 =  &ACCESS_ONCE($p);  &smp_read_barrier_depends(); ( &_________p1); }));
    }' unless defined(&rcu_dereference);
    eval 'sub rcu_assign_pointer {
        my($p, $v) = @_;
	    eval q(({  &if (! &__builtin_constant_p($v) || (($v) !=  &NULL))  &smp_wmb(); ($p) = ($v); }));
    }' unless defined(&rcu_assign_pointer);
    eval 'sub synchronize_rcu_xxx {
        my($name, $func) = @_;
	    eval q( &void $name( &void) { \'struct rcu_synchronize\'  &rcu;  &init_completion( ($rcu->{completion})); $func( ($rcu->{head}),  &wakeme_after_rcu);  &wait_for_completion( ($rcu->{completion})); });
    }' unless defined(&synchronize_rcu_xxx);
    eval 'sub synchronize_sched () {
        eval q( &__synchronize_sched());
    }' unless defined(&synchronize_sched);
}
1;
