require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUPREEMPT_H)) {
    eval 'sub __LINUX_RCUPREEMPT_H () {1;}' unless defined(&__LINUX_RCUPREEMPT_H);
    require 'linux/cache.ph';
    require 'linux/spinlock.ph';
    require 'linux/threads.ph';
    require 'linux/percpu.ph';
    require 'linux/cpumask.ph';
    require 'linux/seqlock.ph';
    eval 'sub rcu_qsctr_inc {
        my($cpu) = @_;
	    eval q({ \'struct rcu_dyntick_sched\' * &rdssp =  &per_cpu( &rcu_dyntick_sched, $cpu);  ($rdssp->{sched_qs})++; });
    }' unless defined(&rcu_qsctr_inc);
    eval 'sub rcu_bh_qsctr_inc {
        my($cpu) = @_;
	    eval q();
    }' unless defined(&rcu_bh_qsctr_inc);
    eval 'sub call_rcu_bh {
        my($head, $rcu) = @_;
	    eval q( &call_rcu($head, $rcu));
    }' unless defined(&call_rcu_bh);
    eval 'sub __rcu_read_lock_bh () {
        eval q({  &rcu_read_lock();  &local_bh_disable(); });
    }' unless defined(&__rcu_read_lock_bh);
    eval 'sub __rcu_read_unlock_bh () {
        eval q({  &local_bh_enable();  &rcu_read_unlock(); });
    }' unless defined(&__rcu_read_unlock_bh);
    if(defined(&CONFIG_RCU_TRACE)) {
    }
    if(defined(&CONFIG_NO_HZ)) {
	eval 'sub rcu_enter_nohz {
	    my($void) = @_;
    	    eval q({  &DEFINE_RATELIMIT_STATE( &rs, 10*  &HZ, 1);  &smp_mb();  &__get_cpu_var( &rcu_dyntick_sched). &dynticks++;  &WARN_ON_RATELIMIT( &__get_cpu_var( &rcu_dyntick_sched). &dynticks & 0x1,  &rs); });
	}' unless defined(&rcu_enter_nohz);
	eval 'sub rcu_exit_nohz {
	    my($void) = @_;
    	    eval q({  &DEFINE_RATELIMIT_STATE( &rs, 10*  &HZ, 1);  &smp_mb();  &__get_cpu_var( &rcu_dyntick_sched). &dynticks++;  &WARN_ON_RATELIMIT(!( &__get_cpu_var( &rcu_dyntick_sched). &dynticks & 0x1),  &rs); });
	}' unless defined(&rcu_exit_nohz);
    } else {
	eval 'sub rcu_enter_nohz () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_enter_nohz);
	eval 'sub rcu_exit_nohz () {
	    eval q( &do { }  &while (0));
	}' unless defined(&rcu_exit_nohz);
    }
}
1;
