require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_SECURITY_H)) {
    eval 'sub __LINUX_SECURITY_H () {1;}' unless defined(&__LINUX_SECURITY_H);
    require 'linux/fs.ph';
    require 'linux/binfmts.ph';
    require 'linux/signal.ph';
    require 'linux/resource.ph';
    require 'linux/sem.ph';
    require 'linux/shm.ph';
    require 'linux/msg.ph';
    require 'linux/sched.ph';
    require 'linux/key.ph';
    require 'linux/xfrm.ph';
    require 'net/flow.ph';
    eval 'sub SECURITY_NAME_MAX () {10;}' unless defined(&SECURITY_NAME_MAX);
    eval 'sub LSM_SETID_ID () {1;}' unless defined(&LSM_SETID_ID);
    eval 'sub LSM_SETID_RE () {2;}' unless defined(&LSM_SETID_RE);
    eval 'sub LSM_SETID_RES () {4;}' unless defined(&LSM_SETID_RES);
    eval 'sub LSM_SETID_FS () {8;}' unless defined(&LSM_SETID_FS);
    eval 'sub LSM_UNSAFE_SHARE () {1;}' unless defined(&LSM_UNSAFE_SHARE);
    eval 'sub LSM_UNSAFE_PTRACE () {2;}' unless defined(&LSM_UNSAFE_PTRACE);
    eval 'sub LSM_UNSAFE_PTRACE_CAP () {4;}' unless defined(&LSM_UNSAFE_PTRACE_CAP);
    if(defined(&CONFIG_SECURITY)) {
	eval 'sub security_init_mnt_opts {
	    my($opts) = @_;
    	    eval q({  ($opts->{mnt_opts}) =  &NULL;  ($opts->{mnt_opts_flags}) =  &NULL;  ($opts->{num_mnt_opts}) = 0; });
	}' unless defined(&security_init_mnt_opts);
	eval 'sub security_free_mnt_opts {
	    my($opts) = @_;
    	    eval q({ \'int\'  &i;  &if ( ($opts->{mnt_opts}))  &for ( &i = 0;  &i <  ($opts->{num_mnt_opts});  &i++)  &kfree( ($opts->{mnt_opts[&i]}));  &kfree( ($opts->{mnt_opts}));  ($opts->{mnt_opts}) =  &NULL;  &kfree( ($opts->{mnt_opts_flags}));  ($opts->{mnt_opts_flags}) =  &NULL;  ($opts->{num_mnt_opts}) = 0; });
	}' unless defined(&security_free_mnt_opts);
	if(defined(&CONFIG_SECURITY_NETWORK)) {
	}
	if(defined(&CONFIG_SECURITY_NETWORK_XFRM)) {
	}
	if(defined(&CONFIG_KEYS)) {
	}
	if(defined(&CONFIG_AUDIT)) {
	}
    } else {
	eval 'sub security_init_mnt_opts {
	    my($opts) = @_;
    	    eval q({ });
	}' unless defined(&security_init_mnt_opts);
	eval 'sub security_free_mnt_opts {
	    my($opts) = @_;
    	    eval q({ });
	}' unless defined(&security_free_mnt_opts);
	eval 'sub security_ptrace_may_access {
	    my($child,$mode) = @_;
    	    eval q({  &cap_ptrace_may_access($child, $mode); });
	}' unless defined(&security_ptrace_may_access);
	eval 'sub security_ptrace_traceme {
	    my($parent) = @_;
    	    eval q({  &cap_ptrace_traceme($parent); });
	}' unless defined(&security_ptrace_traceme);
	eval 'sub security_capget {
	    my($target,$effective,$inheritable,$permitted) = @_;
    	    eval q({  &cap_capget($target, $effective, $inheritable, $permitted); });
	}' unless defined(&security_capget);
	eval 'sub security_capset_check {
	    my($target,$effective,$inheritable,$permitted) = @_;
    	    eval q({  &cap_capset_check($target, $effective, $inheritable, $permitted); });
	}' unless defined(&security_capset_check);
	eval 'sub security_capset_set {
	    my($target,$effective,$inheritable,$permitted) = @_;
    	    eval q({  &cap_capset_set($target, $effective, $inheritable, $permitted); });
	}' unless defined(&security_capset_set);
	eval 'sub security_capable {
	    my($tsk,$cap) = @_;
    	    eval q({  &cap_capable($tsk, $cap); });
	}' unless defined(&security_capable);
	eval 'sub security_acct {
	    my($file) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_acct);
	eval 'sub security_sysctl {
	    my($table,$op) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sysctl);
	eval 'sub security_quotactl {
	    my($cmds,$type,$id,$sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_quotactl);
	eval 'sub security_quota_on {
	    my($dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_quota_on);
	eval 'sub security_syslog {
	    my($type) = @_;
    	    eval q({  &cap_syslog($type); });
	}' unless defined(&security_syslog);
	eval 'sub security_settime {
	    my($ts,$tz) = @_;
    	    eval q({  &cap_settime($ts, $tz); });
	}' unless defined(&security_settime);
	eval 'sub security_vm_enough_memory {
	    my($pages) = @_;
    	    eval q({  &cap_vm_enough_memory( ($current->{mm}), $pages); });
	}' unless defined(&security_vm_enough_memory);
	eval 'sub security_vm_enough_memory_mm {
	    my($mm,$pages) = @_;
    	    eval q({  &cap_vm_enough_memory($mm, $pages); });
	}' unless defined(&security_vm_enough_memory_mm);
	eval 'sub security_bprm_alloc {
	    my($bprm) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_bprm_alloc);
	eval 'sub security_bprm_free {
	    my($bprm) = @_;
    	    eval q({ });
	}' unless defined(&security_bprm_free);
	eval 'sub security_bprm_apply_creds {
	    my($bprm,$unsafe) = @_;
    	    eval q({  &cap_bprm_apply_creds($bprm, $unsafe); });
	}' unless defined(&security_bprm_apply_creds);
	eval 'sub security_bprm_post_apply_creds {
	    my($bprm) = @_;
    	    eval q({ ; });
	}' unless defined(&security_bprm_post_apply_creds);
	eval 'sub security_bprm_set {
	    my($bprm) = @_;
    	    eval q({  &cap_bprm_set_security($bprm); });
	}' unless defined(&security_bprm_set);
	eval 'sub security_bprm_check {
	    my($bprm) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_bprm_check);
	eval 'sub security_bprm_secureexec {
	    my($bprm) = @_;
    	    eval q({  &cap_bprm_secureexec($bprm); });
	}' unless defined(&security_bprm_secureexec);
	eval 'sub security_sb_alloc {
	    my($sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_alloc);
	eval 'sub security_sb_free {
	    my($sb) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_free);
	eval 'sub security_sb_copy_data {
	    my($orig,$copy) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_copy_data);
	eval 'sub security_sb_kern_mount {
	    my($sb,$data) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_kern_mount);
	eval 'sub security_sb_show_options {
	    my($m,$sb) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_show_options);
	eval 'sub security_sb_statfs {
	    my($dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_statfs);
	eval 'sub security_sb_mount {
	    my($dev_name,$path,$type,$flags,$data) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_mount);
	eval 'sub security_sb_check_sb {
	    my($mnt,$path) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_check_sb);
	eval 'sub security_sb_umount {
	    my($mnt,$flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_umount);
	eval 'sub security_sb_umount_close {
	    my($mnt) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_umount_close);
	eval 'sub security_sb_umount_busy {
	    my($mnt) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_umount_busy);
	eval 'sub security_sb_post_remount {
	    my($mnt,$flags,$data) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_post_remount);
	eval 'sub security_sb_post_addmount {
	    my($mnt,$mountpoint) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_post_addmount);
	eval 'sub security_sb_pivotroot {
	    my($old_path,$new_path) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_pivotroot);
	eval 'sub security_sb_post_pivotroot {
	    my($old_path,$new_path) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_post_pivotroot);
	eval 'sub security_sb_set_mnt_opts {
	    my($sb,$opts) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_set_mnt_opts);
	eval 'sub security_sb_clone_mnt_opts {
	    my($oldsb,$newsb) = @_;
    	    eval q({ });
	}' unless defined(&security_sb_clone_mnt_opts);
	eval 'sub security_sb_parse_opts_str {
	    my($options,$opts) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sb_parse_opts_str);
	eval 'sub security_inode_alloc {
	    my($inode) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_alloc);
	eval 'sub security_inode_free {
	    my($inode) = @_;
    	    eval q({ });
	}' unless defined(&security_inode_free);
	eval 'sub security_inode_init_security {
	    my($inode,$dir,$name,$value,$len) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&security_inode_init_security);
	eval 'sub security_inode_create {
	    my($dir,$dentry,$mode) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_create);
	eval 'sub security_inode_link {
	    my($old_dentry,$dir,$new_dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_link);
	eval 'sub security_inode_unlink {
	    my($dir,$dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_unlink);
	eval 'sub security_inode_symlink {
	    my($dir,$dentry,$old_name) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_symlink);
	eval 'sub security_inode_mkdir {
	    my($dir,$dentry,$mode) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_mkdir);
	eval 'sub security_inode_rmdir {
	    my($dir,$dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_rmdir);
	eval 'sub security_inode_mknod {
	    my($dir,$dentry,$mode,$dev) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_mknod);
	eval 'sub security_inode_rename {
	    my($old_dir,$old_dentry,$new_dir,$new_dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_rename);
	eval 'sub security_inode_readlink {
	    my($dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_readlink);
	eval 'sub security_inode_follow_link {
	    my($dentry,$nd) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_follow_link);
	eval 'sub security_inode_permission {
	    my($inode,$mask) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_permission);
	eval 'sub security_inode_setattr {
	    my($dentry,$attr) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_setattr);
	eval 'sub security_inode_getattr {
	    my($mnt,$dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_getattr);
	eval 'sub security_inode_delete {
	    my($inode) = @_;
    	    eval q({ });
	}' unless defined(&security_inode_delete);
	eval 'sub security_inode_setxattr {
	    my($dentry,$name,$value,$size,$flags) = @_;
    	    eval q({  &cap_inode_setxattr($dentry, $name, $value, $size, $flags); });
	}' unless defined(&security_inode_setxattr);
	eval 'sub security_inode_post_setxattr {
	    my($dentry,$name,$value,$size,$flags) = @_;
    	    eval q({ });
	}' unless defined(&security_inode_post_setxattr);
	eval 'sub security_inode_getxattr {
	    my($dentry,$name) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_getxattr);
	eval 'sub security_inode_listxattr {
	    my($dentry) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_listxattr);
	eval 'sub security_inode_removexattr {
	    my($dentry,$name) = @_;
    	    eval q({  &cap_inode_removexattr($dentry, $name); });
	}' unless defined(&security_inode_removexattr);
	eval 'sub security_inode_need_killpriv {
	    my($dentry) = @_;
    	    eval q({  &cap_inode_need_killpriv($dentry); });
	}' unless defined(&security_inode_need_killpriv);
	eval 'sub security_inode_killpriv {
	    my($dentry) = @_;
    	    eval q({  &cap_inode_killpriv($dentry); });
	}' unless defined(&security_inode_killpriv);
	eval 'sub security_inode_getsecurity {
	    my($inode,$name,$buffer,$alloc) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&security_inode_getsecurity);
	eval 'sub security_inode_setsecurity {
	    my($inode,$name,$value,$size,$flags) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&security_inode_setsecurity);
	eval 'sub security_inode_listsecurity {
	    my($inode,$buffer,$buffer_size) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inode_listsecurity);
	eval 'sub security_inode_getsecid {
	    my($inode,$secid) = @_;
    	    eval q({ *$secid = 0; });
	}' unless defined(&security_inode_getsecid);
	eval 'sub security_file_permission {
	    my($file,$mask) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_permission);
	eval 'sub security_file_alloc {
	    my($file) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_alloc);
	eval 'sub security_file_free {
	    my($file) = @_;
    	    eval q({ });
	}' unless defined(&security_file_free);
	eval 'sub security_file_ioctl {
	    my($file,$cmd,$arg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_ioctl);
	eval 'sub security_file_mmap {
	    my($file,$reqprot,$prot,$flags,$addr,$addr_only) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_mmap);
	eval 'sub security_file_mprotect {
	    my($vma,$reqprot,$prot) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_mprotect);
	eval 'sub security_file_lock {
	    my($file,$cmd) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_lock);
	eval 'sub security_file_fcntl {
	    my($file,$cmd,$arg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_fcntl);
	eval 'sub security_file_set_fowner {
	    my($file) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_set_fowner);
	eval 'sub security_file_send_sigiotask {
	    my($tsk,$fown,$sig) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_send_sigiotask);
	eval 'sub security_file_receive {
	    my($file) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_file_receive);
	eval 'sub security_dentry_open {
	    my($file) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_dentry_open);
	eval 'sub security_task_create {
	    my($clone_flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_create);
	eval 'sub security_task_alloc {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_alloc);
	eval 'sub security_task_free {
	    my($p) = @_;
    	    eval q({ });
	}' unless defined(&security_task_free);
	eval 'sub security_task_setuid {
	    my($id0,$id1,$id2,$flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_setuid);
	eval 'sub security_task_post_setuid {
	    my($old_ruid,$old_euid,$old_suid,$flags) = @_;
    	    eval q({  &cap_task_post_setuid($old_ruid, $old_euid, $old_suid, $flags); });
	}' unless defined(&security_task_post_setuid);
	eval 'sub security_task_setgid {
	    my($id0,$id1,$id2,$flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_setgid);
	eval 'sub security_task_setpgid {
	    my($p,$pgid) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_setpgid);
	eval 'sub security_task_getpgid {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_getpgid);
	eval 'sub security_task_getsid {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_getsid);
	eval 'sub security_task_getsecid {
	    my($p,$secid) = @_;
    	    eval q({ *$secid = 0; });
	}' unless defined(&security_task_getsecid);
	eval 'sub security_task_setgroups {
	    my($group_info) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_setgroups);
	eval 'sub security_task_setnice {
	    my($p,$nice) = @_;
    	    eval q({  &cap_task_setnice($p, $nice); });
	}' unless defined(&security_task_setnice);
	eval 'sub security_task_setioprio {
	    my($p,$ioprio) = @_;
    	    eval q({  &cap_task_setioprio($p, $ioprio); });
	}' unless defined(&security_task_setioprio);
	eval 'sub security_task_getioprio {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_getioprio);
	eval 'sub security_task_setrlimit {
	    my($resource,$new_rlim) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_setrlimit);
	eval 'sub security_task_setscheduler {
	    my($p,$policy,$lp) = @_;
    	    eval q({  &cap_task_setscheduler($p, $policy, $lp); });
	}' unless defined(&security_task_setscheduler);
	eval 'sub security_task_getscheduler {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_getscheduler);
	eval 'sub security_task_movememory {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_movememory);
	eval 'sub security_task_kill {
	    my($p,$info,$sig,$secid) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_kill);
	eval 'sub security_task_wait {
	    my($p) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_task_wait);
	eval 'sub security_task_prctl {
	    my($option,$arg2,$arg3,$arg4,$arg5,$rc_p) = @_;
    	    eval q({  &cap_task_prctl($option, $arg2, $arg3, $arg3, $arg5, $rc_p); });
	}' unless defined(&security_task_prctl);
	eval 'sub security_task_reparent_to_init {
	    my($p) = @_;
    	    eval q({  &cap_task_reparent_to_init($p); });
	}' unless defined(&security_task_reparent_to_init);
	eval 'sub security_task_to_inode {
	    my($p,$inode) = @_;
    	    eval q({ });
	}' unless defined(&security_task_to_inode);
	eval 'sub security_ipc_permission {
	    my($ipcp,$flag) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_ipc_permission);
	eval 'sub security_ipc_getsecid {
	    my($ipcp,$secid) = @_;
    	    eval q({ *$secid = 0; });
	}' unless defined(&security_ipc_getsecid);
	eval 'sub security_msg_msg_alloc {
	    my($msg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_msg_alloc);
	eval 'sub security_msg_msg_free {
	    my($msg) = @_;
    	    eval q({ });
	}' unless defined(&security_msg_msg_free);
	eval 'sub security_msg_queue_alloc {
	    my($msq) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_queue_alloc);
	eval 'sub security_msg_queue_free {
	    my($msq) = @_;
    	    eval q({ });
	}' unless defined(&security_msg_queue_free);
	eval 'sub security_msg_queue_associate {
	    my($msq,$msqflg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_queue_associate);
	eval 'sub security_msg_queue_msgctl {
	    my($msq,$cmd) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_queue_msgctl);
	eval 'sub security_msg_queue_msgsnd {
	    my($msq,$msg,$msqflg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_queue_msgsnd);
	eval 'sub security_msg_queue_msgrcv {
	    my($msq,$msg,$target,$type,$mode) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_msg_queue_msgrcv);
	eval 'sub security_shm_alloc {
	    my($shp) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_shm_alloc);
	eval 'sub security_shm_free {
	    my($shp) = @_;
    	    eval q({ });
	}' unless defined(&security_shm_free);
	eval 'sub security_shm_associate {
	    my($shp,$shmflg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_shm_associate);
	eval 'sub security_shm_shmctl {
	    my($shp,$cmd) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_shm_shmctl);
	eval 'sub security_shm_shmat {
	    my($shp,$shmaddr,$shmflg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_shm_shmat);
	eval 'sub security_sem_alloc {
	    my($sma) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sem_alloc);
	eval 'sub security_sem_free {
	    my($sma) = @_;
    	    eval q({ });
	}' unless defined(&security_sem_free);
	eval 'sub security_sem_associate {
	    my($sma,$semflg) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sem_associate);
	eval 'sub security_sem_semctl {
	    my($sma,$cmd) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sem_semctl);
	eval 'sub security_sem_semop {
	    my($sma,$sops,$nsops,$alter) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sem_semop);
	eval 'sub security_d_instantiate {
	    my($dentry,$inode) = @_;
    	    eval q({ });
	}' unless defined(&security_d_instantiate);
	eval 'sub security_getprocattr {
	    my($p,$name,$value) = @_;
    	    eval q({ - &EINVAL; });
	}' unless defined(&security_getprocattr);
	eval 'sub security_setprocattr {
	    my($p,$name,$value,$size) = @_;
    	    eval q({ - &EINVAL; });
	}' unless defined(&security_setprocattr);
	eval 'sub security_netlink_send {
	    my($sk,$skb) = @_;
    	    eval q({  &cap_netlink_send($sk, $skb); });
	}' unless defined(&security_netlink_send);
	eval 'sub security_netlink_recv {
	    my($skb,$cap) = @_;
    	    eval q({  &cap_netlink_recv($skb, $cap); });
	}' unless defined(&security_netlink_recv);
	eval 'sub dentry {
	    eval q(* &securityfs_create_dir( &const \'char\' * &name, \'struct dentry\' * &parent) {  &ERR_PTR(- &ENODEV); });
	}' unless defined(&dentry);
	eval 'sub dentry {
	    eval q(* &securityfs_create_file( &const \'char\' * &name,  &mode_t  &mode, \'struct dentry\' * &parent,  &void * &data,  &const \'struct file_operations\' * &fops) {  &ERR_PTR(- &ENODEV); });
	}' unless defined(&dentry);
	eval 'sub securityfs_remove {
	    my($dentry) = @_;
    	    eval q({ });
	}' unless defined(&securityfs_remove);
	eval 'sub security_secid_to_secctx {
	    my($secid,$secdata,$seclen) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&security_secid_to_secctx);
	eval 'sub security_secctx_to_secid {
	    my($secdata,$seclen,$secid) = @_;
    	    eval q({ - &EOPNOTSUPP; });
	}' unless defined(&security_secctx_to_secid);
	eval 'sub security_release_secctx {
	    my($secdata,$seclen) = @_;
    	    eval q({ });
	}' unless defined(&security_release_secctx);
    }
    if(defined(&CONFIG_SECURITY_NETWORK)) {
    } else {
	eval 'sub security_unix_stream_connect {
	    my($sock,$other,$newsk) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_unix_stream_connect);
	eval 'sub security_unix_may_send {
	    my($sock,$other) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_unix_may_send);
	eval 'sub security_socket_create {
	    my($family,$type,$protocol,$kern) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_create);
	eval 'sub security_socket_post_create {
	    my($sock,$family,$type,$protocol,$kern) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_post_create);
	eval 'sub security_socket_bind {
	    my($sock,$address,$addrlen) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_bind);
	eval 'sub security_socket_connect {
	    my($sock,$address,$addrlen) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_connect);
	eval 'sub security_socket_listen {
	    my($sock,$backlog) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_listen);
	eval 'sub security_socket_accept {
	    my($sock,$newsock) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_accept);
	eval 'sub security_socket_post_accept {
	    my($sock,$newsock) = @_;
    	    eval q({ });
	}' unless defined(&security_socket_post_accept);
	eval 'sub security_socket_sendmsg {
	    my($sock,$msg,$size) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_sendmsg);
	eval 'sub security_socket_recvmsg {
	    my($sock,$msg,$size,$flags) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_recvmsg);
	eval 'sub security_socket_getsockname {
	    my($sock) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_getsockname);
	eval 'sub security_socket_getpeername {
	    my($sock) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_getpeername);
	eval 'sub security_socket_getsockopt {
	    my($sock,$level,$optname) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_getsockopt);
	eval 'sub security_socket_setsockopt {
	    my($sock,$level,$optname) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_setsockopt);
	eval 'sub security_socket_shutdown {
	    my($sock,$how) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_socket_shutdown);
	eval 'sub security_sock_rcv_skb {
	    my($sk,$skb) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sock_rcv_skb);
	eval 'sub security_socket_getpeersec_stream {
	    my($sock,$optval,$optlen,$len) = @_;
    	    eval q({ - &ENOPROTOOPT; });
	}' unless defined(&security_socket_getpeersec_stream);
	eval 'sub security_socket_getpeersec_dgram {
	    my($sock,$skb,$secid) = @_;
    	    eval q({ - &ENOPROTOOPT; });
	}' unless defined(&security_socket_getpeersec_dgram);
	eval 'sub security_sk_alloc {
	    my($sk,$family,$priority) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_sk_alloc);
	eval 'sub security_sk_free {
	    my($sk) = @_;
    	    eval q({ });
	}' unless defined(&security_sk_free);
	eval 'sub security_sk_clone {
	    my($sk,$newsk) = @_;
    	    eval q({ });
	}' unless defined(&security_sk_clone);
	eval 'sub security_sk_classify_flow {
	    my($sk,$fl) = @_;
    	    eval q({ });
	}' unless defined(&security_sk_classify_flow);
	eval 'sub security_req_classify_flow {
	    my($req,$fl) = @_;
    	    eval q({ });
	}' unless defined(&security_req_classify_flow);
	eval 'sub security_sock_graft {
	    my($sk,$parent) = @_;
    	    eval q({ });
	}' unless defined(&security_sock_graft);
	eval 'sub security_inet_conn_request {
	    my($sk,$skb,$req) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_inet_conn_request);
	eval 'sub security_inet_csk_clone {
	    my($newsk,$req) = @_;
    	    eval q({ });
	}' unless defined(&security_inet_csk_clone);
	eval 'sub security_inet_conn_established {
	    my($sk,$skb) = @_;
    	    eval q({ });
	}' unless defined(&security_inet_conn_established);
    }
    if(defined(&CONFIG_SECURITY_NETWORK_XFRM)) {
    } else {
	eval 'sub security_xfrm_policy_alloc {
	    my($ctxp,$sec_ctx) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_policy_alloc);
	eval 'sub security_xfrm_policy_clone {
	    my($old,$new_ctxp) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_policy_clone);
	eval 'sub security_xfrm_policy_free {
	    my($ctx) = @_;
    	    eval q({ });
	}' unless defined(&security_xfrm_policy_free);
	eval 'sub security_xfrm_policy_delete {
	    my($ctx) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_policy_delete);
	eval 'sub security_xfrm_state_alloc {
	    my($x,$sec_ctx) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_state_alloc);
	eval 'sub security_xfrm_state_alloc_acquire {
	    my($x,$polsec,$secid) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_state_alloc_acquire);
	eval 'sub security_xfrm_state_free {
	    my($x) = @_;
    	    eval q({ });
	}' unless defined(&security_xfrm_state_free);
	eval 'sub security_xfrm_state_delete {
	    my($x) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_state_delete);
	eval 'sub security_xfrm_policy_lookup {
	    my($ctx,$fl_secid,$dir) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_policy_lookup);
	eval 'sub security_xfrm_state_pol_flow_match {
	    my($x,$xp,$fl) = @_;
    	    eval q({ 1; });
	}' unless defined(&security_xfrm_state_pol_flow_match);
	eval 'sub security_xfrm_decode_session {
	    my($skb,$secid) = @_;
    	    eval q({ 0; });
	}' unless defined(&security_xfrm_decode_session);
	eval 'sub security_skb_classify_flow {
	    my($skb,$fl) = @_;
    	    eval q({ });
	}' unless defined(&security_skb_classify_flow);
    }
    if(defined(&CONFIG_KEYS)) {
	if(defined(&CONFIG_SECURITY)) {
	} else {
	    eval 'sub security_key_alloc {
	        my($key,$tsk,$flags) = @_;
    		eval q({ 0; });
	    }' unless defined(&security_key_alloc);
	    eval 'sub security_key_free {
	        my($key) = @_;
    		eval q({ });
	    }' unless defined(&security_key_free);
	    eval 'sub security_key_permission {
	        my($key_ref,$context,$perm) = @_;
    		eval q({ 0; });
	    }' unless defined(&security_key_permission);
	    eval 'sub security_key_getsecurity {
	        my($key,$_buffer) = @_;
    		eval q({ *$_buffer =  &NULL; 0; });
	    }' unless defined(&security_key_getsecurity);
	}
    }
    if(defined(&CONFIG_AUDIT)) {
	if(defined(&CONFIG_SECURITY)) {
	} else {
	    eval 'sub security_audit_rule_init {
	        my($field,$op,$rulestr,$lsmrule) = @_;
    		eval q({ 0; });
	    }' unless defined(&security_audit_rule_init);
	    eval 'sub security_audit_rule_known {
	        my($krule) = @_;
    		eval q({ 0; });
	    }' unless defined(&security_audit_rule_known);
	    eval 'sub security_audit_rule_match {
	        my($secid,$field,$op,$lsmrule,$actx) = @_;
    		eval q({ 0; });
	    }' unless defined(&security_audit_rule_match);
	    eval 'sub security_audit_rule_free {
	        my($lsmrule) = @_;
    		eval q({ });
	    }' unless defined(&security_audit_rule_free);
	}
    }
}
1;
