require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_SKBUFF_H)) {
    eval 'sub _LINUX_SKBUFF_H () {1;}' unless defined(&_LINUX_SKBUFF_H);
    require 'linux/kernel.ph';
    require 'linux/compiler.ph';
    require 'linux/time.ph';
    require 'linux/cache.ph';
    require 'asm/atomic.ph';
    require 'asm/types.ph';
    require 'linux/spinlock.ph';
    require 'linux/net.ph';
    require 'linux/textsearch.ph';
    require 'net/checksum.ph';
    require 'linux/rcupdate.ph';
    require 'linux/dmaengine.ph';
    require 'linux/hrtimer.ph';
    eval 'sub HAVE_ALLOC_SKB () {1;}' unless defined(&HAVE_ALLOC_SKB);
    eval 'sub HAVE_ALIGNABLE_SKB () {1;}' unless defined(&HAVE_ALIGNABLE_SKB);
    eval 'sub CHECKSUM_NONE () {0;}' unless defined(&CHECKSUM_NONE);
    eval 'sub CHECKSUM_UNNECESSARY () {1;}' unless defined(&CHECKSUM_UNNECESSARY);
    eval 'sub CHECKSUM_COMPLETE () {2;}' unless defined(&CHECKSUM_COMPLETE);
    eval 'sub CHECKSUM_PARTIAL () {3;}' unless defined(&CHECKSUM_PARTIAL);
    eval 'sub SKB_DATA_ALIGN {
        my($X) = @_;
	    eval q(((($X) + ( &SMP_CACHE_BYTES - 1)) & ~( &SMP_CACHE_BYTES - 1)));
    }' unless defined(&SKB_DATA_ALIGN);
    eval 'sub SKB_WITH_OVERHEAD {
        my($X) = @_;
	    eval q((($X) -  &SKB_DATA_ALIGN($sizeof{\'struct skb_shared_info\'})));
    }' unless defined(&SKB_WITH_OVERHEAD);
    eval 'sub SKB_MAX_ORDER {
        my($X, $ORDER) = @_;
	    eval q( &SKB_WITH_OVERHEAD(( &PAGE_SIZE << ($ORDER)) - ($X)));
    }' unless defined(&SKB_MAX_ORDER);
    eval 'sub SKB_MAX_HEAD {
        my($X) = @_;
	    eval q(( &SKB_MAX_ORDER(($X), 0)));
    }' unless defined(&SKB_MAX_HEAD);
    eval 'sub SKB_MAX_ALLOC () {( &SKB_MAX_ORDER(0, 2));}' unless defined(&SKB_MAX_ALLOC);
    if(defined( &CONFIG_NF_CONNTRACK) || defined( &CONFIG_NF_CONNTRACK_MODULE)) {
    }
    if(defined(&CONFIG_BRIDGE_NETFILTER)) {
    }
    eval 'sub MAX_SKB_FRAGS () {(65536/ &PAGE_SIZE + 2);}' unless defined(&MAX_SKB_FRAGS);
    eval 'sub SKB_DATAREF_SHIFT () {16;}' unless defined(&SKB_DATAREF_SHIFT);
    eval 'sub SKB_DATAREF_MASK () {((1<<  &SKB_DATAREF_SHIFT) - 1);}' unless defined(&SKB_DATAREF_MASK);
    eval("sub SKB_FCLONE_UNAVAILABLE () { 0; }") unless defined(&SKB_FCLONE_UNAVAILABLE);
    eval("sub SKB_FCLONE_ORIG () { 1; }") unless defined(&SKB_FCLONE_ORIG);
    eval("sub SKB_FCLONE_CLONE () { 2; }") unless defined(&SKB_FCLONE_CLONE);
    eval("sub SKB_GSO_TCPV4 () { 1<<0; }") unless defined(&SKB_GSO_TCPV4);
    eval("sub SKB_GSO_UDP () { 1<<1; }") unless defined(&SKB_GSO_UDP);
    eval("sub SKB_GSO_DODGY () { 1<<2; }") unless defined(&SKB_GSO_DODGY);
    eval("sub SKB_GSO_TCP_ECN () { 1<<3; }") unless defined(&SKB_GSO_TCP_ECN);
    eval("sub SKB_GSO_TCPV6 () { 1<<4; }") unless defined(&SKB_GSO_TCPV6);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : undef) > 32) {
	eval 'sub NET_SKBUFF_DATA_USES_OFFSET () {1;}' unless defined(&NET_SKBUFF_DATA_USES_OFFSET);
    }
    if(defined(&NET_SKBUFF_DATA_USES_OFFSET)) {
    } else {
    }
    if(defined( &CONFIG_NF_CONNTRACK) || defined( &CONFIG_NF_CONNTRACK_MODULE)) {
    }
    if(defined(&CONFIG_BRIDGE_NETFILTER)) {
    }
    if(defined(&CONFIG_NET_SCHED)) {
	if(defined(&CONFIG_NET_CLS_ACT)) {
	}
    }
    if(defined(&CONFIG_IPV6_NDISC_NODETYPE)) {
    }
    if(defined( &CONFIG_MAC80211) || defined( &CONFIG_MAC80211_MODULE)) {
    }
    if(defined(&CONFIG_NET_DMA)) {
    }
    if(defined(&CONFIG_NETWORK_SECMARK)) {
    }
    if(defined(&__KERNEL__)) {
	require 'linux/slab.ph';
	require 'asm/system.ph';
	eval 'sub sk_buff {
	    eval q(* &alloc_skb(my $size,  &gfp_t  &priority) {  &__alloc_skb( $size,  &priority, 0, -1); });
	}' unless defined(&sk_buff);
	eval 'sub sk_buff {
	    eval q(* &alloc_skb_fclone(my $size,  &gfp_t  &priority) {  &__alloc_skb( $size,  &priority, 1, -1); });
	}' unless defined(&sk_buff);
	eval 'sub dev_kfree_skb {
	    my($a) = @_;
    	    eval q( &kfree_skb($a));
	}' unless defined(&dev_kfree_skb);
	eval 'sub skb_truesize_check {
	    my($skb) = @_;
    	    eval q({ \'int\'  &len =  &sizeof +  ($skb->{len});  &if ( &unlikely( ($skb->{truesize}) <  &len))  &skb_truesize_bug($skb); });
	}' unless defined(&skb_truesize_check);
	if(defined(&NET_SKBUFF_DATA_USES_OFFSET)) {
	    eval 'sub char {
	        eval q(* &skb_end_pointer( &const \'struct sk_buff\' * &skb) {  ($skb->{head}) +  ($skb->{end}); });
	    }' unless defined(&char);
	} else {
	    eval 'sub char {
	        eval q(* &skb_end_pointer( &const \'struct sk_buff\' * &skb) {  ($skb->{end}); });
	    }' unless defined(&char);
	}
	eval 'sub skb_shinfo {
	    my($SKB) = @_;
    	    eval q((( &skb_end_pointer($SKB))));
	}' unless defined(&skb_shinfo);
	eval 'sub skb_queue_head_init_class {
	    my($list,$class) = @_;
    	    eval q({  &skb_queue_head_init($list);  &lockdep_set_class( ($list->{lock}), $class); });
	}' unless defined(&skb_queue_head_init_class);
	eval 'sub __skb_insert {
	    my($newsk,$prev,$next,$list) = @_;
    	    eval q({  ($newsk->{next}) = $next;  ($newsk->{prev}) = $prev;  ($next->{prev})  =  ($prev->{next}) = $newsk;  ($list->{qlen})++; });
	}' unless defined(&__skb_insert);
	eval 'sub __skb_queue_before {
	    my($list,$next,$newsk) = @_;
    	    eval q({  &__skb_insert($newsk,  ($next->{prev}), $next, $list); });
	}' unless defined(&__skb_queue_before);
	eval 'sub __skb_queue_head {
	    my($list,$newsk) = @_;
    	    eval q({  &__skb_queue_after($list, $list, $newsk); });
	}' unless defined(&__skb_queue_head);
	eval 'sub __skb_queue_tail {
	    my($list,$newsk) = @_;
    	    eval q({  &__skb_queue_before($list, $list, $newsk); });
	}' unless defined(&__skb_queue_tail);
	eval 'sub __skb_unlink {
	    my($skb,$list) = @_;
    	    eval q({ \'struct sk_buff\' * &next, * &prev;  ($list->{qlen})--;  &next =  ($skb->{next});  &prev =  ($skb->{prev});  ($skb->{next})  =  ($skb->{prev}) =  &NULL;  ($next->{prev}) =  &prev;  ($prev->{next}) =  &next; });
	}' unless defined(&__skb_unlink);
	eval 'sub sk_buff {
	    eval q(* &__skb_dequeue(\'struct sk_buff_head\' * &list) { \'struct sk_buff\' * &skb =  &skb_peek( &list);  &if ( &skb)  &__skb_unlink( &skb,  &list);  &skb; });
	}' unless defined(&sk_buff);
	eval 'sub sk_buff {
	    eval q(* &__skb_dequeue_tail(\'struct sk_buff_head\' * &list) { \'struct sk_buff\' * &skb =  &skb_peek_tail( &list);  &if ( &skb)  &__skb_unlink( &skb,  &list);  &skb; });
	}' unless defined(&sk_buff);
	eval 'sub skb_is_nonlinear {
	    my($skb) = @_;
    	    eval q({  ($skb->{data_len}); });
	}' unless defined(&skb_is_nonlinear);
	eval 'sub skb_headlen {
	    my($skb) = @_;
    	    eval q({  ($skb->{len}) -  ($skb->{data_len}); });
	}' unless defined(&skb_headlen);
	eval 'sub skb_pagelen {
	    my($skb) = @_;
    	    eval q({ \'int\'  &i,  &len = 0;  &for ( &i =  &skb_shinfo($skb)-> &nr_frags - 1;  &i >= 0;  &i--)  &len +=  &skb_shinfo($skb)-> ($frags[&i]->{size});  &len +  &skb_headlen($skb); });
	}' unless defined(&skb_pagelen);
	eval 'sub skb_fill_page_desc {
	    my($skb,$i,$page,$off,$size) = @_;
    	    eval q({  &skb_frag_t * &frag =  &skb_shinfo($skb)-> $frags[$i];  ($frag->{page})	 = $page;  ($frag->{page_offset})	 = $off;  ($frag->{s$ize})	 = $size;  &skb_shinfo($skb)-> &nr_frags = $i + 1; });
	}' unless defined(&skb_fill_page_desc);
	eval 'sub SKB_PAGE_ASSERT {
	    my($skb) = @_;
    	    eval q( &BUG_ON( &skb_shinfo($skb)-> &nr_frags));
	}' unless defined(&SKB_PAGE_ASSERT);
	eval 'sub SKB_FRAG_ASSERT {
	    my($skb) = @_;
    	    eval q( &BUG_ON( &skb_shinfo($skb)-> &frag_list));
	}' unless defined(&SKB_FRAG_ASSERT);
	eval 'sub SKB_LINEAR_ASSERT {
	    my($skb) = @_;
    	    eval q( &BUG_ON( &skb_is_nonlinear($skb)));
	}' unless defined(&SKB_LINEAR_ASSERT);
	if(defined(&NET_SKBUFF_DATA_USES_OFFSET)) {
	    eval 'sub char {
	        eval q(* &skb_tail_pointer( &const \'struct sk_buff\' * &skb) {  ($skb->{head}) +  ($skb->{tail}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_tail_pointer {
	        my($skb) = @_;
    		eval q({  ($skb->{tail}) =  ($skb->{data}) -  ($skb->{head}); });
	    }' unless defined(&skb_reset_tail_pointer);
	    eval 'sub skb_set_tail_pointer {
	        my($skb,$offset) = @_;
    		eval q({  &skb_reset_tail_pointer($skb);  ($skb->{tail}) += $offset; });
	    }' unless defined(&skb_set_tail_pointer);
	} else {
	    eval 'sub char {
	        eval q(* &skb_tail_pointer( &const \'struct sk_buff\' * &skb) {  ($skb->{tail}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_tail_pointer {
	        my($skb) = @_;
    		eval q({  ($skb->{tail}) =  ($skb->{data}); });
	    }' unless defined(&skb_reset_tail_pointer);
	    eval 'sub skb_set_tail_pointer {
	        my($skb,$offset) = @_;
    		eval q({  ($skb->{tail}) =  ($skb->{data}) + $offset; });
	    }' unless defined(&skb_set_tail_pointer);
	}
	eval 'sub char {
	    eval q(* &__skb_put(\'struct sk_buff\' * &skb, my $len) { my $char * &tmp =  &skb_tail_pointer( &skb);  &SKB_LINEAR_ASSERT( &skb);  ($skb->{tail}) +=  $len;  ($skb->{len})  +=  $len;  &tmp; });
	}' unless defined(&char);
	eval 'sub char {
	    eval q(* &__skb_push(\'struct sk_buff\' * &skb, my $len) {  ($skb->{data}) -=  $len;  ($skb->{len})  +=  $len;  ($skb->{data}); });
	}' unless defined(&char);
	eval 'sub char {
	    eval q(* &__skb_pull(\'struct sk_buff\' * &skb, my $len) {  ($skb->{len}) -=  $len;  &BUG_ON( ($skb->{len}) <  ($skb->{data_len}));  ($skb->{data}) +=  $len; });
	}' unless defined(&char);
	eval 'sub char {
	    eval q(* &__pskb_pull(\'struct sk_buff\' * &skb, my $len) {  &if ( $len >  &skb_headlen( &skb)  && ! &__pskb_pull_tail( &skb,  $len -  &skb_headlen( &skb)))  &NULL;  ($skb->{len}) -=  $len;  ($skb->{data}) +=  $len; });
	}' unless defined(&char);
	eval 'sub char {
	    eval q(* &pskb_pull(\'struct sk_buff\' * &skb, my $len) {  &unlikely( $len >  ($skb->{len})) ?  &NULL :  &__pskb_pull( &skb,  $len); });
	}' unless defined(&char);
	eval 'sub pskb_may_pull {
	    my($skb,$len) = @_;
    	    eval q({  &if ( &likely($len <=  &skb_headlen($skb))) 1;  &if ( &unlikely($len >  ($skb->{len}))) 0;  &__pskb_pull_tail($skb, $len -  &skb_headlen($skb)) !=  &NULL; });
	}' unless defined(&pskb_may_pull);
	if(defined(&NET_SKBUFF_DATA_USES_OFFSET)) {
	    eval 'sub char {
	        eval q(* &skb_transport_header( &const \'struct sk_buff\' * &skb) {  ($skb->{head}) +  ($skb->{transport_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_transport_header {
	        my($skb) = @_;
    		eval q({  ($skb->{transport_header}) =  ($skb->{data}) -  ($skb->{head}); });
	    }' unless defined(&skb_reset_transport_header);
	    eval 'sub skb_set_transport_header {
	        my($skb,$offset) = @_;
    		eval q({  &skb_reset_transport_header($skb);  ($skb->{transport_header}) += $offset; });
	    }' unless defined(&skb_set_transport_header);
	    eval 'sub char {
	        eval q(* &skb_network_header( &const \'struct sk_buff\' * &skb) {  ($skb->{head}) +  ($skb->{network_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_network_header {
	        my($skb) = @_;
    		eval q({  ($skb->{network_header}) =  ($skb->{data}) -  ($skb->{head}); });
	    }' unless defined(&skb_reset_network_header);
	    eval 'sub skb_set_network_header {
	        my($skb,$offset) = @_;
    		eval q({  &skb_reset_network_header($skb);  ($skb->{network_header}) += $offset; });
	    }' unless defined(&skb_set_network_header);
	    eval 'sub char {
	        eval q(* &skb_mac_header( &const \'struct sk_buff\' * &skb) {  ($skb->{head}) +  ($skb->{mac_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_mac_header_was_set {
	        my($skb) = @_;
    		eval q({  ($skb->{mac_header}) != ~0; });
	    }' unless defined(&skb_mac_header_was_set);
	    eval 'sub skb_reset_mac_header {
	        my($skb) = @_;
    		eval q({  ($skb->{mac_header}) =  ($skb->{data}) -  ($skb->{head}); });
	    }' unless defined(&skb_reset_mac_header);
	    eval 'sub skb_set_mac_header {
	        my($skb,$offset) = @_;
    		eval q({  &skb_reset_mac_header($skb);  ($skb->{mac_header}) += $offset; });
	    }' unless defined(&skb_set_mac_header);
	} else {
	    eval 'sub char {
	        eval q(* &skb_transport_header( &const \'struct sk_buff\' * &skb) {  ($skb->{transport_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_transport_header {
	        my($skb) = @_;
    		eval q({  ($skb->{transport_header}) =  ($skb->{data}); });
	    }' unless defined(&skb_reset_transport_header);
	    eval 'sub skb_set_transport_header {
	        my($skb,$offset) = @_;
    		eval q({  ($skb->{transport_header}) =  ($skb->{data}) + $offset; });
	    }' unless defined(&skb_set_transport_header);
	    eval 'sub char {
	        eval q(* &skb_network_header( &const \'struct sk_buff\' * &skb) {  ($skb->{network_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_reset_network_header {
	        my($skb) = @_;
    		eval q({  ($skb->{network_header}) =  ($skb->{data}); });
	    }' unless defined(&skb_reset_network_header);
	    eval 'sub skb_set_network_header {
	        my($skb,$offset) = @_;
    		eval q({  ($skb->{network_header}) =  ($skb->{data}) + $offset; });
	    }' unless defined(&skb_set_network_header);
	    eval 'sub char {
	        eval q(* &skb_mac_header( &const \'struct sk_buff\' * &skb) {  ($skb->{mac_header}); });
	    }' unless defined(&char);
	    eval 'sub skb_mac_header_was_set {
	        my($skb) = @_;
    		eval q({  ($skb->{mac_header}) !=  &NULL; });
	    }' unless defined(&skb_mac_header_was_set);
	    eval 'sub skb_reset_mac_header {
	        my($skb) = @_;
    		eval q({  ($skb->{mac_header}) =  ($skb->{data}); });
	    }' unless defined(&skb_reset_mac_header);
	    eval 'sub skb_set_mac_header {
	        my($skb,$offset) = @_;
    		eval q({  ($skb->{mac_header}) =  ($skb->{data}) + $offset; });
	    }' unless defined(&skb_set_mac_header);
	}
	eval 'sub skb_transport_offset {
	    my($skb) = @_;
    	    eval q({  &skb_transport_header($skb) -  ($skb->{data}); });
	}' unless defined(&skb_transport_offset);
	eval 'sub skb_network_header_len {
	    my($skb) = @_;
    	    eval q({  ($skb->{transport_header}) -  ($skb->{network_header}); });
	}' unless defined(&skb_network_header_len);
	eval 'sub skb_network_offset {
	    my($skb) = @_;
    	    eval q({  &skb_network_header($skb) -  ($skb->{data}); });
	}' unless defined(&skb_network_offset);
	unless(defined(&NET_IP_ALIGN)) {
	    eval 'sub NET_IP_ALIGN () {2;}' unless defined(&NET_IP_ALIGN);
	}
	unless(defined(&NET_SKB_PAD)) {
	    eval 'sub NET_SKB_PAD () {16;}' unless defined(&NET_SKB_PAD);
	}
	eval 'sub __skb_trim {
	    my($skb,$len) = @_;
    	    eval q({  &if ( &unlikely( ($skb->{data_len}))) {  &WARN_ON(1); ; }  ($skb->{len}) = $len;  &skb_set_tail_pointer($skb, $len); });
	}' unless defined(&__skb_trim);
	eval 'sub __pskb_trim {
	    my($skb,$len) = @_;
    	    eval q({  &if ( ($skb->{data_len}))  &___pskb_trim($skb, $len);  &__skb_trim($skb, $len); 0; });
	}' unless defined(&__pskb_trim);
	eval 'sub pskb_trim {
	    my($skb,$len) = @_;
    	    eval q({ ($len <  ($skb->{len})) ?  &__pskb_trim($skb, $len) : 0; });
	}' unless defined(&pskb_trim);
	eval 'sub __skb_queue_purge {
	    my($list) = @_;
    	    eval q({ \'struct sk_buff\' * &skb;  &while (( &skb =  &__skb_dequeue($list)) !=  &NULL)  &kfree_skb( &skb); });
	}' unless defined(&__skb_queue_purge);
	eval 'sub __skb_cow {
	    my($skb,$headroom,$cloned) = @_;
    	    eval q({ \'int\'  &delta = 0;  &if ($headroom <  &NET_SKB_PAD) $headroom =  &NET_SKB_PAD;  &if ($headroom >  &skb_headroom($skb))  &delta = $headroom -  &skb_headroom($skb);  &if ( &delta || $cloned)  &pskb_expand_head($skb,  &ALIGN( &delta,  &NET_SKB_PAD), 0,  &GFP_ATOMIC); 0; });
	}' unless defined(&__skb_cow);
	eval 'sub skb_add_data {
	    my($skb,$from,$copy) = @_;
    	    eval q({  &const \'int\'  &off =  ($skb->{len});  &if ( ($skb->{ip_summed}) ==  &CHECKSUM_NONE) { \'int\'  &err = 0;  &__wsum  &csum =  &csum_and_copy_from_user($from,  &skb_put($skb, $copy), $copy, 0,  &err);  &if (! &err) {  ($skb->{csum}) =  &csum_block_add( ($skb->{csum}),  &csum,  &off); 0; } }  &else  &if (! &copy_from_user( &skb_put($skb, $copy), $from, $copy)) 0;  &__skb_trim($skb,  &off); - &EFAULT; });
	}' unless defined(&skb_add_data);
	eval 'sub skb_can_coalesce {
	    my($skb,$i,$page,$off) = @_;
    	    eval q({  &if ($i) { \'struct skb_frag_struct\' * &frag =  &skb_shinfo($skb)-> $frags[$i - 1]; $page ==  ($frag->{page})  && $off ==  ($frag->{page_offset}) +  ($frag->{s$ize}); } 0; });
	}' unless defined(&skb_can_coalesce);
	eval 'sub __skb_linearize {
	    my($skb) = @_;
    	    eval q({  &__pskb_pull_tail($skb,  ($skb->{data_len})) ? 0: - &ENOMEM; });
	}' unless defined(&__skb_linearize);
	eval 'sub skb_queue_walk {
	    my($queue, $skb) = @_;
    	    eval q( &for ($skb = ($queue)-> &next;  &prefetch( ($skb->{next})), ($skb != ($queue)); $skb =  ($skb->{next})));
	}' unless defined(&skb_queue_walk);
	eval 'sub skb_queue_walk_safe {
	    my($queue, $skb, $tmp) = @_;
    	    eval q( &for ($skb = ($queue)-> &next, $tmp =  ($skb->{next}); $skb != ($queue); $skb = $tmp, $tmp =  ($skb->{next})));
	}' unless defined(&skb_queue_walk_safe);
	eval 'sub skb_queue_reverse_walk {
	    my($queue, $skb) = @_;
    	    eval q( &for ($skb = ($queue)-> &prev;  &prefetch( ($skb->{prev})), ($skb != ($queue)); $skb =  ($skb->{prev})));
	}' unless defined(&skb_queue_reverse_walk);
	eval 'sub void {
	    eval q(* &skb_header_pointer( &const \'struct sk_buff\' * &skb, \'int\'  &offset, \'int\'  &len,  &void * &buffer) { \'int\'  &hlen =  &skb_headlen( &skb);  &if ( &hlen -  &offset >=  &len)  ($skb->{data}) +  &offset;  &if ( &skb_copy_bits( &skb,  &offset,  &buffer,  &len) < 0)  &NULL;  &buffer; });
	}' unless defined(&void);
	eval 'sub skb_copy_from_linear_data {
	    my($skb,$to,$len) = @_;
    	    eval q({  &memcpy($to,  ($skb->{data}), $len); });
	}' unless defined(&skb_copy_from_linear_data);
	eval 'sub skb_copy_from_linear_data_offset {
	    my($skb,$offset,$to,$len) = @_;
    	    eval q({  &memcpy($to,  ($skb->{data}) + $offset, $len); });
	}' unless defined(&skb_copy_from_linear_data_offset);
	eval 'sub skb_copy_to_linear_data {
	    my($skb,$from,$len) = @_;
    	    eval q({  &memcpy( ($skb->{data}), $from, $len); });
	}' unless defined(&skb_copy_to_linear_data);
	eval 'sub skb_copy_to_linear_data_offset {
	    my($skb,$offset,$from,$len) = @_;
    	    eval q({  &memcpy( ($skb->{data}) + $offset, $from, $len); });
	}' unless defined(&skb_copy_to_linear_data_offset);
	eval 'sub __net_timestamp {
	    my($skb) = @_;
    	    eval q({  ($skb->{tstamp}) =  &ktime_get_real(); });
	}' unless defined(&__net_timestamp);
	eval 'sub net_timedelta {
	    my($t) = @_;
    	    eval q({  &ktime_sub( &ktime_get_real(), $t); });
	}' unless defined(&net_timedelta);
	eval 'sub net_invalid_timestamp {
	    my($void) = @_;
    	    eval q({  &ktime_set(0, 0); });
	}' unless defined(&net_invalid_timestamp);
	eval 'sub skb_csum_unnecessary {
	    my($skb) = @_;
    	    eval q({  ($skb->{ip_summed}) &  &CHECKSUM_UNNECESSARY; });
	}' unless defined(&skb_csum_unnecessary);
	if(defined( &CONFIG_NF_CONNTRACK) || defined( &CONFIG_NF_CONNTRACK_MODULE)) {
	    eval 'sub nf_conntrack_put {
	        my($nfct) = @_;
    		eval q({  &if ($nfct  &&  &atomic_dec_and_test( ($nfct->{use})))  &nf_conntrack_destroy($nfct); });
	    }' unless defined(&nf_conntrack_put);
	    eval 'sub nf_conntrack_get {
	        my($nfct) = @_;
    		eval q({  &if ($nfct)  &atomic_inc( ($nfct->{use})); });
	    }' unless defined(&nf_conntrack_get);
	    eval 'sub nf_conntrack_get_reasm {
	        my($skb) = @_;
    		eval q({  &if ($skb)  &atomic_inc( ($skb->{users})); });
	    }' unless defined(&nf_conntrack_get_reasm);
	    eval 'sub nf_conntrack_put_reasm {
	        my($skb) = @_;
    		eval q({  &if ($skb)  &kfree_skb($skb); });
	    }' unless defined(&nf_conntrack_put_reasm);
	}
	if(defined(&CONFIG_BRIDGE_NETFILTER)) {
	    eval 'sub nf_bridge_put {
	        my($nf_bridge) = @_;
    		eval q({  &if ($nf_bridge  &&  &atomic_dec_and_test( ($nf_bridge->{use})))  &kfree($nf_bridge); });
	    }' unless defined(&nf_bridge_put);
	    eval 'sub nf_bridge_get {
	        my($nf_bridge) = @_;
    		eval q({  &if ($nf_bridge)  &atomic_inc( ($nf_bridge->{use})); });
	    }' unless defined(&nf_bridge_get);
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub nf_reset {
	    my($skb) = @_;
    	    eval q({ });
	}' unless defined(&nf_reset);
	if(defined( &CONFIG_NF_CONNTRACK) || defined( &CONFIG_NF_CONNTRACK_MODULE)) {
	}
	if(defined(&CONFIG_BRIDGE_NETFILTER)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub nf_copy {
	    my($dst,$src) = @_;
    	    eval q({  &__nf_copy($dst, $src); });
	}' unless defined(&nf_copy);
	if(defined(&CONFIG_NETWORK_SECMARK)) {
	    eval 'sub skb_copy_secmark {
	        my($to,$from) = @_;
    		eval q({  ($to->{secmark}) =  ($from->{secmark}); });
	    }' unless defined(&skb_copy_secmark);
	    eval 'sub skb_init_secmark {
	        my($skb) = @_;
    		eval q({  ($skb->{secmark}) = 0; });
	    }' unless defined(&skb_init_secmark);
	} else {
	    eval 'sub skb_copy_secmark {
	        my($to,$from) = @_;
    		eval q({ });
	    }' unless defined(&skb_copy_secmark);
	    eval 'sub skb_init_secmark {
	        my($skb) = @_;
    		eval q({ });
	    }' unless defined(&skb_init_secmark);
	}
	eval 'sub skb_set_queue_mapping {
	    my($skb,$queue_mapping) = @_;
    	    eval q({  ($skb->{queue_mapping}) = $queue_mapping; });
	}' unless defined(&skb_set_queue_mapping);
	eval 'sub skb_get_queue_mapping {
	    my($skb) = @_;
    	    eval q({  ($skb->{queue_mapping}); });
	}' unless defined(&skb_get_queue_mapping);
	eval 'sub skb_copy_queue_mapping {
	    my($to,$from) = @_;
    	    eval q({  ($to->{queue_mapping}) =  ($from->{queue_mapping}); });
	}' unless defined(&skb_copy_queue_mapping);
	eval 'sub skb_is_gso {
	    my($skb) = @_;
    	    eval q({  &skb_shinfo($skb)-> &gso_size; });
	}' unless defined(&skb_is_gso);
	eval 'sub skb_is_gso_v6 {
	    my($skb) = @_;
    	    eval q({  &skb_shinfo($skb)-> &gso_type &  &SKB_GSO_TCPV6; });
	}' unless defined(&skb_is_gso_v6);
	eval 'sub skb_warn_if_lro {
	    my($skb) = @_;
    	    eval q({ \'struct skb_shared_info\' * &shinfo =  &skb_shinfo($skb);  &if ( ($shinfo->{gso_size}) != 0 &&  &unlikely( ($shinfo->{gso_type}) == 0)) {  &__skb_warn_lro_forwarding($skb);  &true; }  &false; });
	}' unless defined(&skb_warn_if_lro);
	eval 'sub skb_forward_csum {
	    my($skb) = @_;
    	    eval q({  &if ( ($skb->{ip_summed}) ==  &CHECKSUM_COMPLETE)  ($skb->{ip_summed}) =  &CHECKSUM_NONE; });
	}' unless defined(&skb_forward_csum);
    }
}
1;
