require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_SLAB_H)) {
    eval 'sub _LINUX_SLAB_H () {1;}' unless defined(&_LINUX_SLAB_H);
    require 'linux/gfp.ph';
    require 'linux/types.ph';
    eval 'sub SLAB_DEBUG_FREE () {0x100;}' unless defined(&SLAB_DEBUG_FREE);
    eval 'sub SLAB_RED_ZONE () {0x400;}' unless defined(&SLAB_RED_ZONE);
    eval 'sub SLAB_POISON () {0x800;}' unless defined(&SLAB_POISON);
    eval 'sub SLAB_HWCACHE_ALIGN () {0x2000;}' unless defined(&SLAB_HWCACHE_ALIGN);
    eval 'sub SLAB_CACHE_DMA () {0x4000;}' unless defined(&SLAB_CACHE_DMA);
    eval 'sub SLAB_STORE_USER () {0x10000;}' unless defined(&SLAB_STORE_USER);
    eval 'sub SLAB_PANIC () {0x40000;}' unless defined(&SLAB_PANIC);
    eval 'sub SLAB_DESTROY_BY_RCU () {0x80000;}' unless defined(&SLAB_DESTROY_BY_RCU);
    eval 'sub SLAB_MEM_SPREAD () {0x100000;}' unless defined(&SLAB_MEM_SPREAD);
    eval 'sub SLAB_TRACE () {0x200000;}' unless defined(&SLAB_TRACE);
    if(defined(&CONFIG_DEBUG_OBJECTS)) {
	eval 'sub SLAB_DEBUG_OBJECTS () {0x400000;}' unless defined(&SLAB_DEBUG_OBJECTS);
    } else {
	eval 'sub SLAB_DEBUG_OBJECTS () {0x;}' unless defined(&SLAB_DEBUG_OBJECTS);
    }
    eval 'sub SLAB_RECLAIM_ACCOUNT () {0x20000;}' unless defined(&SLAB_RECLAIM_ACCOUNT);
    eval 'sub SLAB_TEMPORARY () { &SLAB_RECLAIM_ACCOUNT;}' unless defined(&SLAB_TEMPORARY);
    eval 'sub ZERO_SIZE_PTR () {(( &void *)16);}' unless defined(&ZERO_SIZE_PTR);
    eval 'sub ZERO_OR_NULL_PTR {
        my($x) = @_;
	    eval q(( <=  &ZERO_SIZE_PTR));
    }' unless defined(&ZERO_OR_NULL_PTR);
    eval 'sub KMEM_CACHE {
        my($__struct, $__flags) = @_;
	    eval q( &kmem_cache_create($__struct, $sizeof{\'struct __struct\'},  &__alignof__, ($__flags),  &NULL));
    }' unless defined(&KMEM_CACHE);
    eval 'sub KMALLOC_SHIFT_HIGH () {(( &MAX_ORDER +  &PAGE_SHIFT - 1) <= 25? ( &MAX_ORDER +  &PAGE_SHIFT - 1) : 25);}' unless defined(&KMALLOC_SHIFT_HIGH);
    eval 'sub KMALLOC_MAX_SIZE () {(1 <<  &KMALLOC_SHIFT_HIGH);}' unless defined(&KMALLOC_MAX_SIZE);
    eval 'sub KMALLOC_MAX_ORDER () {( &KMALLOC_SHIFT_HIGH -  &PAGE_SHIFT);}' unless defined(&KMALLOC_MAX_ORDER);
    if(defined(&CONFIG_SLUB)) {
	require 'linux/slub_def.ph';
    }
 elsif(defined( &CONFIG_SLOB)) {
	require 'linux/slob_def.ph';
    } else {
	require 'linux/slab_def.ph';
    }
    if(!defined( &CONFIG_NUMA)  && !defined( &CONFIG_SLOB)) {
	eval 'sub void {
	    eval q(* &__kmalloc_node(\'size_t\'  &size,  &gfp_t  &flags, \'int\'  &node) {  &__kmalloc( &size,  &flags); });
	}' unless defined(&void);
	eval 'sub void {
	    eval q(* &kmem_cache_alloc_node(\'struct kmem_cache\' * &cachep,  &gfp_t  &flags, \'int\'  &node) {  &kmem_cache_alloc( &cachep,  &flags); });
	}' unless defined(&void);
    }
    if(defined( &CONFIG_DEBUG_SLAB) || defined( &CONFIG_SLUB)) {
	eval 'sub kmalloc_track_caller {
	    my($size, $flags) = @_;
    	    eval q( &__kmalloc_track_caller($size, $flags,  &__builtin_return_address(0)));
	}' unless defined(&kmalloc_track_caller);
    } else {
	eval 'sub kmalloc_track_caller {
	    my($size, $flags) = @_;
    	    eval q( &__kmalloc($size, $flags));
	}' unless defined(&kmalloc_track_caller);
    }
    if(defined(&CONFIG_NUMA)) {
	if(defined( &CONFIG_DEBUG_SLAB) || defined( &CONFIG_SLUB)) {
	    eval 'sub kmalloc_node_track_caller {
	        my($size, $flags, $node) = @_;
    		eval q( &__kmalloc_node_track_caller($size, $flags, $node,  &__builtin_return_address(0)));
	    }' unless defined(&kmalloc_node_track_caller);
	} else {
	    eval 'sub kmalloc_node_track_caller {
	        my($size, $flags, $node) = @_;
    		eval q( &__kmalloc_node($size, $flags, $node));
	    }' unless defined(&kmalloc_node_track_caller);
	}
    } else {
	eval 'sub kmalloc_node_track_caller {
	    my($size, $flags, $node) = @_;
    	    eval q( &kmalloc_track_caller($size, $flags));
	}' unless defined(&kmalloc_node_track_caller);
    }
    if(defined(&CONFIG_SLABINFO)) {
    }
}
1;
