require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SQUASHFS_FS)) {
    eval 'sub SQUASHFS_FS () {1;}' unless defined(&SQUASHFS_FS);
    unless(defined(&CONFIG_SQUASHFS_2_0_COMPATIBILITY)) {
	eval 'sub CONFIG_SQUASHFS_2_0_COMPATIBILITY () {1;}' unless defined(&CONFIG_SQUASHFS_2_0_COMPATIBILITY);
    }
    eval 'sub SQUASHFS_CACHED_FRAGMENTS () { &CONFIG_SQUASHFS_FRAGMENT_CACHE_SIZE;}' unless defined(&SQUASHFS_CACHED_FRAGMENTS);
    eval 'sub SQUASHFS_MAJOR () {3;}' unless defined(&SQUASHFS_MAJOR);
    eval 'sub SQUASHFS_MINOR () {1;}' unless defined(&SQUASHFS_MINOR);
    eval 'sub SQUASHFS_MAGIC () {0x73717368;}' unless defined(&SQUASHFS_MAGIC);
    eval 'sub SQUASHFS_MAGIC_SWAP () {0x68737173;}' unless defined(&SQUASHFS_MAGIC_SWAP);
    eval 'sub SQUASHFS_START () {0;}' unless defined(&SQUASHFS_START);
    eval 'sub SQUASHFS_METADATA_SIZE () {8192;}' unless defined(&SQUASHFS_METADATA_SIZE);
    eval 'sub SQUASHFS_METADATA_LOG () {13;}' unless defined(&SQUASHFS_METADATA_LOG);
    eval 'sub SQUASHFS_FILE_SIZE () {131072;}' unless defined(&SQUASHFS_FILE_SIZE);
    eval 'sub SQUASHFS_FILE_LOG () {17;}' unless defined(&SQUASHFS_FILE_LOG);
    eval 'sub SQUASHFS_FILE_MAX_SIZE () {1048576;}' unless defined(&SQUASHFS_FILE_MAX_SIZE);
    eval 'sub SQUASHFS_UIDS () {256;}' unless defined(&SQUASHFS_UIDS);
    eval 'sub SQUASHFS_GUIDS () {255;}' unless defined(&SQUASHFS_GUIDS);
    eval 'sub SQUASHFS_NAME_LEN () {256;}' unless defined(&SQUASHFS_NAME_LEN);
    eval 'sub SQUASHFS_INVALID () {( 281474976710655);}' unless defined(&SQUASHFS_INVALID);
    eval 'sub SQUASHFS_INVALID_FRAG () {( 0xffffffff);}' unless defined(&SQUASHFS_INVALID_FRAG);
    eval 'sub SQUASHFS_INVALID_BLK () {( -1);}' unless defined(&SQUASHFS_INVALID_BLK);
    eval 'sub SQUASHFS_USED_BLK () {( -2);}' unless defined(&SQUASHFS_USED_BLK);
    eval 'sub SQUASHFS_NOI () {0;}' unless defined(&SQUASHFS_NOI);
    eval 'sub SQUASHFS_NOD () {1;}' unless defined(&SQUASHFS_NOD);
    eval 'sub SQUASHFS_CHECK () {2;}' unless defined(&SQUASHFS_CHECK);
    eval 'sub SQUASHFS_NOF () {3;}' unless defined(&SQUASHFS_NOF);
    eval 'sub SQUASHFS_NO_FRAG () {4;}' unless defined(&SQUASHFS_NO_FRAG);
    eval 'sub SQUASHFS_ALWAYS_FRAG () {5;}' unless defined(&SQUASHFS_ALWAYS_FRAG);
    eval 'sub SQUASHFS_DUPLICATE () {6;}' unless defined(&SQUASHFS_DUPLICATE);
    eval 'sub SQUASHFS_EXPORT () {7;}' unless defined(&SQUASHFS_EXPORT);
    eval 'sub SQUASHFS_BIT {
        my($flag, $bit) = @_;
	    eval q((($flag >> $bit) & 1));
    }' unless defined(&SQUASHFS_BIT);
    eval 'sub SQUASHFS_UNCOMPRESSED_INODES {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_NOI));
    }' unless defined(&SQUASHFS_UNCOMPRESSED_INODES);
    eval 'sub SQUASHFS_UNCOMPRESSED_DATA {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_NOD));
    }' unless defined(&SQUASHFS_UNCOMPRESSED_DATA);
    eval 'sub SQUASHFS_UNCOMPRESSED_FRAGMENTS {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_NOF));
    }' unless defined(&SQUASHFS_UNCOMPRESSED_FRAGMENTS);
    eval 'sub SQUASHFS_NO_FRAGMENTS {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_NO_FRAG));
    }' unless defined(&SQUASHFS_NO_FRAGMENTS);
    eval 'sub SQUASHFS_ALWAYS_FRAGMENTS {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_ALWAYS_FRAG));
    }' unless defined(&SQUASHFS_ALWAYS_FRAGMENTS);
    eval 'sub SQUASHFS_DUPLICATES {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_DUPLICATE));
    }' unless defined(&SQUASHFS_DUPLICATES);
    eval 'sub SQUASHFS_EXPORTABLE {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_EXPORT));
    }' unless defined(&SQUASHFS_EXPORTABLE);
    eval 'sub SQUASHFS_CHECK_DATA {
        my($flags) = @_;
	    eval q( &SQUASHFS_BIT($flags,  &SQUASHFS_CHECK));
    }' unless defined(&SQUASHFS_CHECK_DATA);
    eval 'sub SQUASHFS_MKFLAGS {
        my($noi, $nod, $check_data, $nof, $no_frag, $always_frag, 		$duplicate_checking, $exportable) = @_;
	    eval q(($noi | ($nod << 1) | ($check_data << 2) | ($nof << 3) | ($no_frag << 4) | ($always_frag << 5) | ($duplicate_checking << 6) | ($exportable << 7)));
    }' unless defined(&SQUASHFS_MKFLAGS);
    eval 'sub SQUASHFS_DIR_TYPE () {1;}' unless defined(&SQUASHFS_DIR_TYPE);
    eval 'sub SQUASHFS_FILE_TYPE () {2;}' unless defined(&SQUASHFS_FILE_TYPE);
    eval 'sub SQUASHFS_SYMLINK_TYPE () {3;}' unless defined(&SQUASHFS_SYMLINK_TYPE);
    eval 'sub SQUASHFS_BLKDEV_TYPE () {4;}' unless defined(&SQUASHFS_BLKDEV_TYPE);
    eval 'sub SQUASHFS_CHRDEV_TYPE () {5;}' unless defined(&SQUASHFS_CHRDEV_TYPE);
    eval 'sub SQUASHFS_FIFO_TYPE () {6;}' unless defined(&SQUASHFS_FIFO_TYPE);
    eval 'sub SQUASHFS_SOCKET_TYPE () {7;}' unless defined(&SQUASHFS_SOCKET_TYPE);
    eval 'sub SQUASHFS_LDIR_TYPE () {8;}' unless defined(&SQUASHFS_LDIR_TYPE);
    eval 'sub SQUASHFS_LREG_TYPE () {9;}' unless defined(&SQUASHFS_LREG_TYPE);
    eval 'sub SQUASHFS_TYPES () {5;}' unless defined(&SQUASHFS_TYPES);
    eval 'sub SQUASHFS_IPC_TYPE () {0;}' unless defined(&SQUASHFS_IPC_TYPE);
    eval 'sub SQUASHFS_COMPRESSED_BIT () {(1<< 15);}' unless defined(&SQUASHFS_COMPRESSED_BIT);
    eval 'sub SQUASHFS_COMPRESSED_SIZE {
        my($B) = @_;
	    eval q(((($B) & ~ &SQUASHFS_COMPRESSED_BIT) ? ($B) & ~ &SQUASHFS_COMPRESSED_BIT :  &SQUASHFS_COMPRESSED_BIT));
    }' unless defined(&SQUASHFS_COMPRESSED_SIZE);
    eval 'sub SQUASHFS_COMPRESSED {
        my($B) = @_;
	    eval q((!(($B) &  &SQUASHFS_COMPRESSED_BIT)));
    }' unless defined(&SQUASHFS_COMPRESSED);
    eval 'sub SQUASHFS_COMPRESSED_BIT_BLOCK () {(1<< 24);}' unless defined(&SQUASHFS_COMPRESSED_BIT_BLOCK);
    eval 'sub SQUASHFS_COMPRESSED_SIZE_BLOCK {
        my($B) = @_;
	    eval q((($B) & ~ &SQUASHFS_COMPRESSED_BIT_BLOCK));
    }' unless defined(&SQUASHFS_COMPRESSED_SIZE_BLOCK);
    eval 'sub SQUASHFS_COMPRESSED_BLOCK {
        my($B) = @_;
	    eval q((!(($B) &  &SQUASHFS_COMPRESSED_BIT_BLOCK)));
    }' unless defined(&SQUASHFS_COMPRESSED_BLOCK);
    eval 'sub SQUASHFS_INODE_BLK {
        my($a) = @_;
	    eval q(( (($a) >> 16)));
    }' unless defined(&SQUASHFS_INODE_BLK);
    eval 'sub SQUASHFS_INODE_OFFSET {
        my($a) = @_;
	    eval q(( (($a) & 0xffff)));
    }' unless defined(&SQUASHFS_INODE_OFFSET);
    eval 'sub SQUASHFS_MKINODE {
        my($A, $B) = @_;
	    eval q((( &squashfs_inode_t)((( &squashfs_inode_t) ($A) << 16) + ($B))));
    }' unless defined(&SQUASHFS_MKINODE);
    eval 'sub SQUASHFS_MK_VFS_INODE {
        my($a, $b) = @_;
	    eval q(( ((($a) << 8) + (($b) >> 2) + 1)));
    }' unless defined(&SQUASHFS_MK_VFS_INODE);
    eval 'sub SQUASHFS_MODE {
        my($a) = @_;
	    eval q((($a) & 0xfff));
    }' unless defined(&SQUASHFS_MODE);
    eval 'sub SQUASHFS_FRAGMENT_BYTES {
        my($A) = @_;
	    eval q((($A) * $sizeof{\'struct squashfs_fragment_entry\'}));
    }' unless defined(&SQUASHFS_FRAGMENT_BYTES);
    eval 'sub SQUASHFS_FRAGMENT_INDEX {
        my($A) = @_;
	    eval q(( &SQUASHFS_FRAGMENT_BYTES($A) /  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_FRAGMENT_INDEX);
    eval 'sub SQUASHFS_FRAGMENT_INDEX_OFFSET {
        my($A) = @_;
	    eval q(( &SQUASHFS_FRAGMENT_BYTES($A) %  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_FRAGMENT_INDEX_OFFSET);
    eval 'sub SQUASHFS_FRAGMENT_INDEXES {
        my($A) = @_;
	    eval q((( &SQUASHFS_FRAGMENT_BYTES($A) +  &SQUASHFS_METADATA_SIZE - 1) /  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_FRAGMENT_INDEXES);
    eval 'sub SQUASHFS_FRAGMENT_INDEX_BYTES {
        my($A) = @_;
	    eval q(( &SQUASHFS_FRAGMENT_INDEXES($A) * $sizeof{\'long long\'}));
    }' unless defined(&SQUASHFS_FRAGMENT_INDEX_BYTES);
    eval 'sub SQUASHFS_LOOKUP_BYTES {
        my($A) = @_;
	    eval q((($A) * $sizeof{ &squashfs_inode_t}));
    }' unless defined(&SQUASHFS_LOOKUP_BYTES);
    eval 'sub SQUASHFS_LOOKUP_BLOCK {
        my($A) = @_;
	    eval q(( &SQUASHFS_LOOKUP_BYTES($A) /  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_LOOKUP_BLOCK);
    eval 'sub SQUASHFS_LOOKUP_BLOCK_OFFSET {
        my($A) = @_;
	    eval q(( &SQUASHFS_LOOKUP_BYTES($A) %  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_LOOKUP_BLOCK_OFFSET);
    eval 'sub SQUASHFS_LOOKUP_BLOCKS {
        my($A) = @_;
	    eval q((( &SQUASHFS_LOOKUP_BYTES($A) +  &SQUASHFS_METADATA_SIZE - 1) /  &SQUASHFS_METADATA_SIZE));
    }' unless defined(&SQUASHFS_LOOKUP_BLOCKS);
    eval 'sub SQUASHFS_LOOKUP_BLOCK_BYTES {
        my($A) = @_;
	    eval q(( &SQUASHFS_LOOKUP_BLOCKS($A) * $sizeof{\'long long\'}));
    }' unless defined(&SQUASHFS_LOOKUP_BLOCK_BYTES);
    eval 'sub SQUASHFS_CACHED_BLKS () {8;}' unless defined(&SQUASHFS_CACHED_BLKS);
    eval 'sub SQUASHFS_MAX_FILE_SIZE_LOG () {64;}' unless defined(&SQUASHFS_MAX_FILE_SIZE_LOG);
    eval 'sub SQUASHFS_MAX_FILE_SIZE () {( 1<< ( &SQUASHFS_MAX_FILE_SIZE_LOG - 2));}' unless defined(&SQUASHFS_MAX_FILE_SIZE);
    eval 'sub SQUASHFS_MARKER_BYTE () {0xff;}' unless defined(&SQUASHFS_MARKER_BYTE);
    eval 'sub SQUASHFS_META_INDEXES () {( &SQUASHFS_METADATA_SIZE / $sizeof{\'unsigned int\'});}' unless defined(&SQUASHFS_META_INDEXES);
    eval 'sub SQUASHFS_META_ENTRIES () {31;}' unless defined(&SQUASHFS_META_ENTRIES);
    eval 'sub SQUASHFS_META_NUMBER () {8;}' unless defined(&SQUASHFS_META_NUMBER);
    eval 'sub SQUASHFS_SLOTS () {4;}' unless defined(&SQUASHFS_SLOTS);
    eval 'sub SQUASHFS_BASE_INODE_HEADER () {\'unsigned int inode_type\':4; \'unsigned int mode\':12; \'unsigned int uid\':8; \'unsigned int guid\':8; \'unsigned int mtime\'; \'unsigned int inode_number\';;}' unless defined(&SQUASHFS_BASE_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_START () {\'int\'  &bits; \'int\'  &b_pos; \'unsigned long long val\'; \'unsigned char\' * &s; \'unsigned char\' * &d;;}' unless defined(&SQUASHFS_SWAP_START);
    eval 'sub SQUASHFS_SWAP_SUPER_BLOCK {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_super_block\'});  &SQUASHFS_SWAP(($s)-> &s_magic, $d, 0, 32);  &SQUASHFS_SWAP(($s)-> &inodes, $d, 32, 32);  &SQUASHFS_SWAP(($s)-> &bytes_used_2, $d, 64, 32);  &SQUASHFS_SWAP(($s)-> &uid_start_2, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &guid_start_2, $d, 128, 32);  &SQUASHFS_SWAP(($s)-> &inode_table_start_2, $d, 160, 32);  &SQUASHFS_SWAP(($s)-> &directory_table_start_2, $d, 192, 32);  &SQUASHFS_SWAP(($s)-> &s_major, $d, 224, 16);  &SQUASHFS_SWAP(($s)-> &s_minor, $d, 240, 16);  &SQUASHFS_SWAP(($s)-> &block_size_1, $d, 256, 16);  &SQUASHFS_SWAP(($s)-> &block_log, $d, 272, 16);  &SQUASHFS_SWAP(($s)-> &flags, $d, 288, 8);  &SQUASHFS_SWAP(($s)-> &no_uids, $d, 296, 8);  &SQUASHFS_SWAP(($s)-> &no_guids, $d, 304, 8);  &SQUASHFS_SWAP(($s)-> &mkfs_time, $d, 312, 32);  &SQUASHFS_SWAP(($s)-> &root_inode, $d, 344, 64);  &SQUASHFS_SWAP(($s)-> &block_size, $d, 408, 32);  &SQUASHFS_SWAP(($s)-> &fragments, $d, 440, 32);  &SQUASHFS_SWAP(($s)-> &fragment_table_start_2, $d, 472, 32);  &SQUASHFS_SWAP(($s)-> &bytes_used, $d, 504, 64);  &SQUASHFS_SWAP(($s)-> &uid_start, $d, 568, 64);  &SQUASHFS_SWAP(($s)-> &guid_start, $d, 632, 64);  &SQUASHFS_SWAP(($s)-> &inode_table_start, $d, 696, 64);  &SQUASHFS_SWAP(($s)-> &directory_table_start, $d, 760, 64);  &SQUASHFS_SWAP(($s)-> &fragment_table_start, $d, 824, 64);  &SQUASHFS_SWAP(($s)-> &lookup_table_start, $d, 888, 64);});
    }' unless defined(&SQUASHFS_SWAP_SUPER_BLOCK);
    eval 'sub SQUASHFS_SWAP_BASE_INODE_CORE {
        my($s, $d, $n) = @_;
	    eval q( &SQUASHFS_MEMSET($s, $d, $n);  &SQUASHFS_SWAP(($s)-> &inode_type, $d, 0, 4);  &SQUASHFS_SWAP(($s)-> &mode, $d, 4, 12);  &SQUASHFS_SWAP(($s)-> &uid, $d, 16, 8);  &SQUASHFS_SWAP(($s)-> &guid, $d, 24, 8);  &SQUASHFS_SWAP(($s)-> &mtime, $d, 32, 32);  &SQUASHFS_SWAP(($s)-> &inode_number, $d, 64, 32););
    }' unless defined(&SQUASHFS_SWAP_BASE_INODE_CORE);
    eval 'sub SQUASHFS_SWAP_BASE_INODE_HEADER {
        my($s, $d, $n) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $n)});
    }' unless defined(&SQUASHFS_SWAP_BASE_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_IPC_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_ipc_inode_header\'})  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);});
    }' unless defined(&SQUASHFS_SWAP_IPC_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_DEV_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_dev_inode_header\'});  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &rdev, $d, 128, 16);});
    }' unless defined(&SQUASHFS_SWAP_DEV_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_SYMLINK_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_symlink_inode_header\'});  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &symlink_size, $d, 128, 16);});
    }' unless defined(&SQUASHFS_SWAP_SYMLINK_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_REG_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_reg_inode_header\'});  &SQUASHFS_SWAP(($s)-> &start_block, $d, 96, 64);  &SQUASHFS_SWAP(($s)-> &fragment, $d, 160, 32);  &SQUASHFS_SWAP(($s)-> &offset, $d, 192, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 224, 32);});
    }' unless defined(&SQUASHFS_SWAP_REG_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_LREG_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_lreg_inode_header\'});  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 128, 64);  &SQUASHFS_SWAP(($s)-> &fragment, $d, 192, 32);  &SQUASHFS_SWAP(($s)-> &offset, $d, 224, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 256, 64);});
    }' unless defined(&SQUASHFS_SWAP_LREG_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_DIR_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_dir_inode_header\'});  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 128, 19);  &SQUASHFS_SWAP(($s)-> &offset, $d, 147, 13);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 160, 32);  &SQUASHFS_SWAP(($s)-> &parent_inode, $d, 192, 32);});
    }' unless defined(&SQUASHFS_SWAP_DIR_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_LDIR_INODE_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE($s, $d, $sizeof{\'struct squashfs_ldir_inode_header\'});  &SQUASHFS_SWAP(($s)-> &nlink, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 128, 27);  &SQUASHFS_SWAP(($s)-> &offset, $d, 155, 13);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 168, 32);  &SQUASHFS_SWAP(($s)-> &i_count, $d, 200, 16);  &SQUASHFS_SWAP(($s)-> &parent_inode, $d, 216, 32);});
    }' unless defined(&SQUASHFS_SWAP_LDIR_INODE_HEADER);
    eval 'sub SQUASHFS_SWAP_DIR_INDEX {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_index\'});  &SQUASHFS_SWAP(($s)-> &index, $d, 0, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 32, 32);  &SQUASHFS_SWAP(($s)-> &size, $d, 64, 8);});
    }' unless defined(&SQUASHFS_SWAP_DIR_INDEX);
    eval 'sub SQUASHFS_SWAP_DIR_HEADER {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_header\'});  &SQUASHFS_SWAP(($s)-> &count, $d, 0, 8);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 8, 32);  &SQUASHFS_SWAP(($s)-> &inode_number, $d, 40, 32);});
    }' unless defined(&SQUASHFS_SWAP_DIR_HEADER);
    eval 'sub SQUASHFS_SWAP_DIR_ENTRY {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_entry\'});  &SQUASHFS_SWAP(($s)-> &offset, $d, 0, 13);  &SQUASHFS_SWAP(($s)-> &type, $d, 13, 3);  &SQUASHFS_SWAP(($s)-> &size, $d, 16, 8);  &SQUASHFS_SWAP(($s)-> &inode_number, $d, 24, 16);});
    }' unless defined(&SQUASHFS_SWAP_DIR_ENTRY);
    eval 'sub SQUASHFS_SWAP_FRAGMENT_ENTRY {
        my($s, $d) = @_;
	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_fragment_entry\'});  &SQUASHFS_SWAP(($s)-> &start_block, $d, 0, 64);  &SQUASHFS_SWAP(($s)-> &size, $d, 64, 32);});
    }' unless defined(&SQUASHFS_SWAP_FRAGMENT_ENTRY);
    eval 'sub SQUASHFS_SWAP_INODE_T {
        my($s, $d) = @_;
	    eval q( &SQUASHFS_SWAP_LONG_LONGS($s, $d, 1));
    }' unless defined(&SQUASHFS_SWAP_INODE_T);
    eval 'sub SQUASHFS_SWAP_SHORTS {
        my($s, $d, $n) = @_;
	    eval q({ \'int\'  &entry; \'int\'  &bit_position;  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $n * 2);  &for( &entry = 0,  &bit_position = 0;  &entry < $n;  &entry++,  &bit_position += 16)  &SQUASHFS_SWAP($s->[ &entry], $d,  &bit_position, 16);});
    }' unless defined(&SQUASHFS_SWAP_SHORTS);
    eval 'sub SQUASHFS_SWAP_INTS {
        my($s, $d, $n) = @_;
	    eval q({ \'int\'  &entry; \'int\'  &bit_position;  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $n * 4);  &for( &entry = 0,  &bit_position = 0;  &entry < $n;  &entry++,  &bit_position += 32)  &SQUASHFS_SWAP($s->[ &entry], $d,  &bit_position, 32);});
    }' unless defined(&SQUASHFS_SWAP_INTS);
    eval 'sub SQUASHFS_SWAP_LONG_LONGS {
        my($s, $d, $n) = @_;
	    eval q({ \'int\'  &entry; \'int\'  &bit_position;  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $n * 8);  &for( &entry = 0,  &bit_position = 0;  &entry < $n;  &entry++,  &bit_position += 64)  &SQUASHFS_SWAP($s->[ &entry], $d,  &bit_position, 64);});
    }' unless defined(&SQUASHFS_SWAP_LONG_LONGS);
    eval 'sub SQUASHFS_SWAP_DATA {
        my($s, $d, $n, $bits) = @_;
	    eval q({ \'int\'  &entry; \'int\'  &bit_position;  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $n * $bits / 8);  &for( &entry = 0,  &bit_position = 0;  &entry < $n;  &entry++,  &bit_position += $bits)  &SQUASHFS_SWAP($s->[ &entry], $d,  &bit_position, $bits);});
    }' unless defined(&SQUASHFS_SWAP_DATA);
    eval 'sub SQUASHFS_SWAP_FRAGMENT_INDEXES {
        my($s, $d, $n) = @_;
	    eval q( &SQUASHFS_SWAP_LONG_LONGS($s, $d, $n));
    }' unless defined(&SQUASHFS_SWAP_FRAGMENT_INDEXES);
    eval 'sub SQUASHFS_SWAP_LOOKUP_BLOCKS {
        my($s, $d, $n) = @_;
	    eval q( &SQUASHFS_SWAP_LONG_LONGS($s, $d, $n));
    }' unless defined(&SQUASHFS_SWAP_LOOKUP_BLOCKS);
    if(defined(&CONFIG_SQUASHFS_1_0_COMPATIBILITY)) {
	eval 'sub SQUASHFS_SWAP_BASE_INODE_CORE_1 {
	    my($s, $d, $n) = @_;
    	    eval q( &SQUASHFS_MEMSET($s, $d, $n);  &SQUASHFS_SWAP(($s)-> &inode_type, $d, 0, 4);  &SQUASHFS_SWAP(($s)-> &mode, $d, 4, 12);  &SQUASHFS_SWAP(($s)-> &uid, $d, 16, 4);  &SQUASHFS_SWAP(($s)-> &guid, $d, 20, 4););
	}' unless defined(&SQUASHFS_SWAP_BASE_INODE_CORE_1);
	eval 'sub SQUASHFS_SWAP_BASE_INODE_HEADER_1 {
	    my($s, $d, $n) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $n)});
	}' unless defined(&SQUASHFS_SWAP_BASE_INODE_HEADER_1);
	eval 'sub SQUASHFS_SWAP_IPC_INODE_HEADER_1 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $sizeof{\'struct squashfs_ipc_inode_header_1\'});  &SQUASHFS_SWAP(($s)-> &type, $d, 24, 4);  &SQUASHFS_SWAP(($s)-> &offset, $d, 28, 4);});
	}' unless defined(&SQUASHFS_SWAP_IPC_INODE_HEADER_1);
	eval 'sub SQUASHFS_SWAP_DEV_INODE_HEADER_1 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $sizeof{\'struct squashfs_dev_inode_header_1\'});  &SQUASHFS_SWAP(($s)-> &rdev, $d, 24, 16);});
	}' unless defined(&SQUASHFS_SWAP_DEV_INODE_HEADER_1);
	eval 'sub SQUASHFS_SWAP_SYMLINK_INODE_HEADER_1 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $sizeof{\'struct squashfs_symlink_inode_header_1\'});  &SQUASHFS_SWAP(($s)-> &symlink_size, $d, 24, 16);});
	}' unless defined(&SQUASHFS_SWAP_SYMLINK_INODE_HEADER_1);
	eval 'sub SQUASHFS_SWAP_REG_INODE_HEADER_1 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $sizeof{\'struct squashfs_reg_inode_header_1\'});  &SQUASHFS_SWAP(($s)-> &mtime, $d, 24, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 56, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 88, 32);});
	}' unless defined(&SQUASHFS_SWAP_REG_INODE_HEADER_1);
	eval 'sub SQUASHFS_SWAP_DIR_INODE_HEADER_1 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_1($s, $d, $sizeof{\'struct squashfs_dir_inode_header_1\'});  &SQUASHFS_SWAP(($s)-> &file_size, $d, 24, 19);  &SQUASHFS_SWAP(($s)-> &offset, $d, 43, 13);  &SQUASHFS_SWAP(($s)-> &mtime, $d, 56, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 88, 24);});
	}' unless defined(&SQUASHFS_SWAP_DIR_INODE_HEADER_1);
    }
    if(defined(&CONFIG_SQUASHFS_2_0_COMPATIBILITY)) {
	eval 'sub SQUASHFS_SWAP_BASE_INODE_CORE_2 {
	    my($s, $d, $n) = @_;
    	    eval q( &SQUASHFS_MEMSET($s, $d, $n);  &SQUASHFS_SWAP(($s)-> &inode_type, $d, 0, 4);  &SQUASHFS_SWAP(($s)-> &mode, $d, 4, 12);  &SQUASHFS_SWAP(($s)-> &uid, $d, 16, 8);  &SQUASHFS_SWAP(($s)-> &guid, $d, 24, 8););
	}' unless defined(&SQUASHFS_SWAP_BASE_INODE_CORE_2);
	eval 'sub SQUASHFS_SWAP_BASE_INODE_HEADER_2 {
	    my($s, $d, $n) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $n)});
	}' unless defined(&SQUASHFS_SWAP_BASE_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_IPC_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q( &SQUASHFS_SWAP_BASE_INODE_HEADER_2($s, $d, $sizeof{\'struct squashfs_ipc_inode_header_2\'}));
	}' unless defined(&SQUASHFS_SWAP_IPC_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_DEV_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $sizeof{\'struct squashfs_dev_inode_header_2\'});  &SQUASHFS_SWAP(($s)-> &rdev, $d, 32, 16);});
	}' unless defined(&SQUASHFS_SWAP_DEV_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_SYMLINK_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $sizeof{\'struct squashfs_symlink_inode_header_2\'});  &SQUASHFS_SWAP(($s)-> &symlink_size, $d, 32, 16);});
	}' unless defined(&SQUASHFS_SWAP_SYMLINK_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_REG_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $sizeof{\'struct squashfs_reg_inode_header_2\'});  &SQUASHFS_SWAP(($s)-> &mtime, $d, 32, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 64, 32);  &SQUASHFS_SWAP(($s)-> &fragment, $d, 96, 32);  &SQUASHFS_SWAP(($s)-> &offset, $d, 128, 32);  &SQUASHFS_SWAP(($s)-> &file_size, $d, 160, 32);});
	}' unless defined(&SQUASHFS_SWAP_REG_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_DIR_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $sizeof{\'struct squashfs_dir_inode_header_2\'});  &SQUASHFS_SWAP(($s)-> &file_size, $d, 32, 19);  &SQUASHFS_SWAP(($s)-> &offset, $d, 51, 13);  &SQUASHFS_SWAP(($s)-> &mtime, $d, 64, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 96, 24);});
	}' unless defined(&SQUASHFS_SWAP_DIR_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_LDIR_INODE_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_SWAP_BASE_INODE_CORE_2($s, $d, $sizeof{\'struct squashfs_ldir_inode_header_2\'});  &SQUASHFS_SWAP(($s)-> &file_size, $d, 32, 27);  &SQUASHFS_SWAP(($s)-> &offset, $d, 59, 13);  &SQUASHFS_SWAP(($s)-> &mtime, $d, 72, 32);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 104, 24);  &SQUASHFS_SWAP(($s)-> &i_count, $d, 128, 16);});
	}' unless defined(&SQUASHFS_SWAP_LDIR_INODE_HEADER_2);
	eval 'sub SQUASHFS_SWAP_DIR_INDEX_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_index_2\'});  &SQUASHFS_SWAP(($s)-> &index, $d, 0, 27);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 27, 29);  &SQUASHFS_SWAP(($s)-> &size, $d, 56, 8);});
	}' unless defined(&SQUASHFS_SWAP_DIR_INDEX_2);
	eval 'sub SQUASHFS_SWAP_DIR_HEADER_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_header_2\'});  &SQUASHFS_SWAP(($s)-> &count, $d, 0, 8);  &SQUASHFS_SWAP(($s)-> &start_block, $d, 8, 24);});
	}' unless defined(&SQUASHFS_SWAP_DIR_HEADER_2);
	eval 'sub SQUASHFS_SWAP_DIR_ENTRY_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_dir_entry_2\'});  &SQUASHFS_SWAP(($s)-> &offset, $d, 0, 13);  &SQUASHFS_SWAP(($s)-> &type, $d, 13, 3);  &SQUASHFS_SWAP(($s)-> &size, $d, 16, 8);});
	}' unless defined(&SQUASHFS_SWAP_DIR_ENTRY_2);
	eval 'sub SQUASHFS_SWAP_FRAGMENT_ENTRY_2 {
	    my($s, $d) = @_;
    	    eval q({  &SQUASHFS_SWAP_START  &SQUASHFS_MEMSET($s, $d, $sizeof{\'struct squashfs_fragment_entry_2\'});  &SQUASHFS_SWAP(($s)-> &start_block, $d, 0, 32);  &SQUASHFS_SWAP(($s)-> &size, $d, 32, 32);});
	}' unless defined(&SQUASHFS_SWAP_FRAGMENT_ENTRY_2);
	eval 'sub SQUASHFS_SWAP_FRAGMENT_INDEXES_2 {
	    my($s, $d, $n) = @_;
    	    eval q( &SQUASHFS_SWAP_INTS($s, $d, $n));
	}' unless defined(&SQUASHFS_SWAP_FRAGMENT_INDEXES_2);
	eval 'sub SQUASHFS_FRAGMENT_BYTES_2 {
	    my($A) = @_;
    	    eval q(($A * $sizeof{\'struct squashfs_fragment_entry_2\'}));
	}' unless defined(&SQUASHFS_FRAGMENT_BYTES_2);
	eval 'sub SQUASHFS_FRAGMENT_INDEX_2 {
	    my($A) = @_;
    	    eval q(( &SQUASHFS_FRAGMENT_BYTES_2($A) /  &SQUASHFS_METADATA_SIZE));
	}' unless defined(&SQUASHFS_FRAGMENT_INDEX_2);
	eval 'sub SQUASHFS_FRAGMENT_INDEX_OFFSET_2 {
	    my($A) = @_;
    	    eval q(( &SQUASHFS_FRAGMENT_BYTES_2($A) %  &SQUASHFS_METADATA_SIZE));
	}' unless defined(&SQUASHFS_FRAGMENT_INDEX_OFFSET_2);
	eval 'sub SQUASHFS_FRAGMENT_INDEXES_2 {
	    my($A) = @_;
    	    eval q((( &SQUASHFS_FRAGMENT_BYTES_2($A) +  &SQUASHFS_METADATA_SIZE - 1) /  &SQUASHFS_METADATA_SIZE));
	}' unless defined(&SQUASHFS_FRAGMENT_INDEXES_2);
	eval 'sub SQUASHFS_FRAGMENT_INDEX_BYTES_2 {
	    my($A) = @_;
    	    eval q(( &SQUASHFS_FRAGMENT_INDEXES_2($A) * $sizeof{\'int\'}));
	}' unless defined(&SQUASHFS_FRAGMENT_INDEX_BYTES_2);
    }
    if(defined(&__KERNEL__)) {
	require 'asm/byteorder.ph';
	if(defined(&__BIG_ENDIAN)) {
	    eval 'sub SQUASHFS_SWAP {
	        my($value, $p, $pos, $tbits) = @_;
    		eval q( &_SQUASHFS_SWAP($value, $p, $pos, $tbits,  &b_pos));
	    }' unless defined(&SQUASHFS_SWAP);
	} else {
	    eval 'sub SQUASHFS_SWAP {
	        my($value, $p, $pos, $tbits) = @_;
    		eval q( &_SQUASHFS_SWAP($value, $p, $pos, $tbits, 64- $tbits -  &b_pos));
	    }' unless defined(&SQUASHFS_SWAP);
	}
	eval 'sub _SQUASHFS_SWAP {
	    my($value, $p, $pos, $tbits, $SHIFT) = @_;
    	    eval q({  &b_pos = $pos % 8;  &val = 0;  &s = $p + ($pos / 8);  &d = (  &val) + 7;  &for( &bits = 0;  &bits < ($tbits +  &b_pos);  &bits += 8) * &d-- = * &s++; $value = ( &val >> ($SHIFT)) ;});
	}' unless defined(&_SQUASHFS_SWAP);
	eval 'sub SQUASHFS_MEMSET {
	    my($s, $d, $n) = @_;
    	    eval q( &memset($s, 0, $n););
	}' unless defined(&SQUASHFS_MEMSET);
    }
}
1;
