require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_TOPOLOGY_H)) {
    eval 'sub _LINUX_TOPOLOGY_H () {1;}' unless defined(&_LINUX_TOPOLOGY_H);
    require 'linux/cpumask.ph';
    require 'linux/bitops.ph';
    require 'linux/mmzone.ph';
    require 'linux/smp.ph';
    require 'asm/topology.ph';
    unless(defined(&node_has_online_mem)) {
	eval 'sub node_has_online_mem {
	    my($nid) = @_;
    	    eval q((1));
	}' unless defined(&node_has_online_mem);
    }
    unless(defined(&nr_cpus_node)) {
	eval 'sub nr_cpus_node {
	    my($node) = @_;
    	    eval q(({  &node_to_cpumask_ptr( &__tmp__, $node);  &cpus_weight(* &__tmp__); }));
	}' unless defined(&nr_cpus_node);
    }
    eval 'sub for_each_node_with_cpus {
        my($node) = @_;
	    eval q( &for_each_online_node($node)  &if ( &nr_cpus_node($node)));
    }' unless defined(&for_each_node_with_cpus);
    eval 'sub LOCAL_DISTANCE () {10;}' unless defined(&LOCAL_DISTANCE);
    eval 'sub REMOTE_DISTANCE () {20;}' unless defined(&REMOTE_DISTANCE);
    unless(defined(&node_distance)) {
	eval 'sub node_distance {
	    my($from,$to) = @_;
    	    eval q((($from) == ($to) ?  &LOCAL_DISTANCE :  &REMOTE_DISTANCE));
	}' unless defined(&node_distance);
    }
    unless(defined(&RECLAIM_DISTANCE)) {
	eval 'sub RECLAIM_DISTANCE () {20;}' unless defined(&RECLAIM_DISTANCE);
    }
    unless(defined(&PENALTY_FOR_NODE_WITH_CPUS)) {
	eval 'sub PENALTY_FOR_NODE_WITH_CPUS () {(1);}' unless defined(&PENALTY_FOR_NODE_WITH_CPUS);
    }
    if(defined(&CONFIG_SCHED_SMT)) {
	eval 'sub ARCH_HAS_SCHED_WAKE_IDLE () {1;}' unless defined(&ARCH_HAS_SCHED_WAKE_IDLE);
	unless(defined(&SD_SIBLING_INIT)) {
	    eval 'sub SD_SIBLING_INIT () { { . &min_interval = 1, . &max_interval = 2, . &busy_factor = 64, . &imbalance_pct = 110, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_NEWIDLE |  &SD_BALANCE_FORK |  &SD_BALANCE_EXEC |  &SD_WAKE_AFFINE |  &SD_WAKE_IDLE |  &SD_SHARE_CPUPOWER, . &last_balance =  &jiffies, . &balance_interval = 1, };}' unless defined(&SD_SIBLING_INIT);
	}
    }
    if(defined(&CONFIG_SCHED_MC)) {
	unless(defined(&SD_MC_INIT)) {
	    eval 'sub SD_MC_INIT () { { . &min_interval = 1, . &max_interval = 4, . &busy_factor = 64, . &imbalance_pct = 125, . &cache_nice_tries = 1, . &busy_idx = 2, . &wake_idx = 1, . &forkexec_idx = 1, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_NEWIDLE |  &SD_BALANCE_FORK |  &SD_BALANCE_EXEC |  &SD_WAKE_AFFINE |  &SD_SHARE_PKG_RESOURCES |  &BALANCE_FOR_MC_POWER, . &last_balance =  &jiffies, . &balance_interval = 1, };}' unless defined(&SD_MC_INIT);
	}
    }
    unless(defined(&SD_CPU_INIT)) {
	eval 'sub SD_CPU_INIT () { { . &min_interval = 1, . &max_interval = 4, . &busy_factor = 64, . &imbalance_pct = 125, . &cache_nice_tries = 1, . &busy_idx = 2, . &idle_idx = 1, . &newidle_idx = 2, . &wake_idx = 1, . &forkexec_idx = 1, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_NEWIDLE |  &SD_BALANCE_FORK |  &SD_BALANCE_EXEC |  &SD_WAKE_AFFINE |  &BALANCE_FOR_PKG_POWER, . &last_balance =  &jiffies, . &balance_interval = 1, };}' unless defined(&SD_CPU_INIT);
    }
    eval 'sub SD_ALLNODES_INIT () { { . &min_interval = 64, . &max_interval = 64* &num_online_cpus(), . &busy_factor = 128, . &imbalance_pct = 133, . &cache_nice_tries = 1, . &busy_idx = 3, . &idle_idx = 3, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_NEWIDLE |  &SD_WAKE_AFFINE |  &SD_SERIALIZE, . &last_balance =  &jiffies, . &balance_interval = 64, };}' unless defined(&SD_ALLNODES_INIT);
    if(defined(&CONFIG_NUMA)) {
	unless(defined(&SD_NODE_INIT)) {
	    die("Please\ define\ an\ appropriate\ SD_NODE_INIT\ in\ include\/asm\/topology\.h\!\!\!");
	}
    }
    unless(defined(&topology_physical_package_id)) {
	eval 'sub topology_physical_package_id {
	    my($cpu) = @_;
    	    eval q((( &void)($cpu), -1));
	}' unless defined(&topology_physical_package_id);
    }
    unless(defined(&topology_core_id)) {
	eval 'sub topology_core_id {
	    my($cpu) = @_;
    	    eval q((( &void)($cpu), 0));
	}' unless defined(&topology_core_id);
    }
    unless(defined(&topology_thread_siblings)) {
	eval 'sub topology_thread_siblings {
	    my($cpu) = @_;
    	    eval q( &cpumask_of_cpu($cpu));
	}' unless defined(&topology_thread_siblings);
    }
    unless(defined(&topology_core_siblings)) {
	eval 'sub topology_core_siblings {
	    my($cpu) = @_;
    	    eval q( &cpumask_of_cpu($cpu));
	}' unless defined(&topology_core_siblings);
    }
}
1;
