require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VT_KERN_H)) {
    eval 'sub _VT_KERN_H () {1;}' unless defined(&_VT_KERN_H);
    require 'linux/vt.ph';
    require 'linux/kd.ph';
    require 'linux/tty.ph';
    require 'linux/mutex.ph';
    require 'linux/console_struct.ph';
    require 'linux/mm.ph';
    require 'linux/consolemap.ph';
    if(defined(&CONFIG_VGA_CONSOLE)) {
	eval 'sub BROKEN_GRAPHICS_PROGRAMS () {1;}' unless defined(&BROKEN_GRAPHICS_PROGRAMS);
    }
    eval 'sub update_screen {
        my($x) = @_;
	    eval q( &redraw_screen($x, 0));
    }' unless defined(&update_screen);
    eval 'sub switch_screen {
        my($x) = @_;
	    eval q( &redraw_screen($x, 1));
    }' unless defined(&switch_screen);
    if(defined(&CONFIG_CONSOLE_TRANSLATIONS)) {
	eval 'sub vc_translate {
	    my($vc, $c) = @_;
    	    eval q((($vc)-> $vc_translate[($c) | (($vc)-> &vc_toggle_meta ? 0x80 : 0)]));
	}' unless defined(&vc_translate);
    } else {
	eval 'sub con_set_trans_old {
	    my($arg) = @_;
    	    eval q((0));
	}' unless defined(&con_set_trans_old);
	eval 'sub con_get_trans_old {
	    my($arg) = @_;
    	    eval q((- &EINVAL));
	}' unless defined(&con_get_trans_old);
	eval 'sub con_set_trans_new {
	    my($arg) = @_;
    	    eval q((0));
	}' unless defined(&con_set_trans_new);
	eval 'sub con_get_trans_new {
	    my($arg) = @_;
    	    eval q((- &EINVAL));
	}' unless defined(&con_get_trans_new);
	eval 'sub con_clear_unimap {
	    my($vc, $ui) = @_;
    	    eval q((0));
	}' unless defined(&con_clear_unimap);
	eval 'sub con_set_unimap {
	    my($vc, $ct, $list) = @_;
    	    eval q((0));
	}' unless defined(&con_set_unimap);
	eval 'sub con_set_default_unimap {
	    my($vc) = @_;
    	    eval q((0));
	}' unless defined(&con_set_default_unimap);
	eval 'sub con_copy_unimap {
	    my($d, $s) = @_;
    	    eval q((0));
	}' unless defined(&con_copy_unimap);
	eval 'sub con_get_unimap {
	    my($vc, $ct, $uct, $list) = @_;
    	    eval q((- &EINVAL));
	}' unless defined(&con_get_unimap);
	eval 'sub con_free_unimap {
	    my($vc) = @_;
    	    eval q( &do { ; }  &while (0));
	}' unless defined(&con_free_unimap);
	eval 'sub con_protect_unimap {
	    my($vc, $rdonly) = @_;
    	    eval q( &do { ; }  &while (0));
	}' unless defined(&con_protect_unimap);
	eval 'sub vc_translate {
	    my($vc, $c) = @_;
    	    eval q(($c));
	}' unless defined(&vc_translate);
    }
    eval 'sub CON_BUF_SIZE () {( &CONFIG_BASE_SMALL ? 256:  &PAGE_SIZE);}' unless defined(&CON_BUF_SIZE);
}
1;
