require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_WORKQUEUE_H)) {
    eval 'sub _LINUX_WORKQUEUE_H () {1;}' unless defined(&_LINUX_WORKQUEUE_H);
    require 'linux/timer.ph';
    require 'linux/linkage.ph';
    require 'linux/bitops.ph';
    require 'linux/lockdep.ph';
    require 'asm/atomic.ph';
    eval 'sub work_data_bits {
        my($work) = @_;
	    eval q(((($work)-> &data)));
    }' unless defined(&work_data_bits);
    eval 'sub WORK_STRUCT_PENDING () {0;}' unless defined(&WORK_STRUCT_PENDING);
    eval 'sub WORK_STRUCT_FLAG_MASK () {(3);}' unless defined(&WORK_STRUCT_FLAG_MASK);
    eval 'sub WORK_STRUCT_WQ_DATA_MASK () {(~ &WORK_STRUCT_FLAG_MASK);}' unless defined(&WORK_STRUCT_WQ_DATA_MASK);
    if(defined(&CONFIG_LOCKDEP)) {
    }
    eval 'sub WORK_DATA_INIT () {
        eval q( &ATOMIC_LONG_INIT(0));
    }' unless defined(&WORK_DATA_INIT);
    if(defined(&CONFIG_LOCKDEP)) {
	eval 'sub __WORK_INIT_LOCKDEP_MAP {
	    my($n, $k) = @_;
    	    eval q(. &lockdep_map =  &STATIC_LOCKDEP_MAP_INIT($n, $k),);
	}' unless defined(&__WORK_INIT_LOCKDEP_MAP);
    } else {
	eval 'sub __WORK_INIT_LOCKDEP_MAP {
	    my($n, $k) = @_;
    	    eval q();
	}' unless defined(&__WORK_INIT_LOCKDEP_MAP);
    }
    eval 'sub __WORK_INITIALIZER {
        my($n, $f) = @_;
	    eval q({ . &data =  &WORK_DATA_INIT(), . &entry = { ($n). &entry, ($n). &entry }, . &func = ($f),  &__WORK_INIT_LOCKDEP_MAP($n, ($n)) });
    }' unless defined(&__WORK_INITIALIZER);
    eval 'sub __DELAYED_WORK_INITIALIZER {
        my($n, $f) = @_;
	    eval q({ . &work =  &__WORK_INITIALIZER(($n). &work, ($f)), . &timer =  &TIMER_INITIALIZER( &NULL, 0, 0), });
    }' unless defined(&__DELAYED_WORK_INITIALIZER);
    eval 'sub DECLARE_WORK {
        my($n, $f) = @_;
	    eval q(\'struct work_struct\' $n =  &__WORK_INITIALIZER($n, $f));
    }' unless defined(&DECLARE_WORK);
    eval 'sub DECLARE_DELAYED_WORK {
        my($n, $f) = @_;
	    eval q(\'struct delayed_work\' $n =  &__DELAYED_WORK_INITIALIZER($n, $f));
    }' unless defined(&DECLARE_DELAYED_WORK);
    eval 'sub PREPARE_WORK {
        my($_work, $_func) = @_;
	    eval q( &do { ($_work)-> &func = ($_func); }  &while (0));
    }' unless defined(&PREPARE_WORK);
    eval 'sub PREPARE_DELAYED_WORK {
        my($_work, $_func) = @_;
	    eval q( &PREPARE_WORK(($_work)-> &work, ($_func)));
    }' unless defined(&PREPARE_DELAYED_WORK);
    if(defined(&CONFIG_LOCKDEP)) {
	eval 'sub INIT_WORK {
	    my($_work, $_func) = @_;
    	    eval q( &do {  &static \'struct lock_class_key\'  &__key; ($_work)-> &data =   &WORK_DATA_INIT();  &lockdep_init_map(($_work)-> &lockdep_map, $_work, & &__key, 0);  &INIT_LIST_HEAD(($_work)-> &entry);  &PREPARE_WORK(($_work), ($_func)); }  &while (0));
	}' unless defined(&INIT_WORK);
    } else {
	eval 'sub INIT_WORK {
	    my($_work, $_func) = @_;
    	    eval q( &do { -> &data =  &WORK_DATA_INIT();  &INIT_LIST_HEAD(($_work)-> &entry);  &PREPARE_WORK(($_work), ($_func)); }  &while (0));
	}' unless defined(&INIT_WORK);
    }
    eval 'sub INIT_DELAYED_WORK {
        my($_work, $_func) = @_;
	    eval q( &do {  &INIT_WORK(($_work)-> &work, ($_func));  &init_timer(($_work)-> &timer); }  &while (0));
    }' unless defined(&INIT_DELAYED_WORK);
    eval 'sub INIT_DELAYED_WORK_DEFERRABLE {
        my($_work, $_func) = @_;
	    eval q( &do {  &INIT_WORK(($_work)-> &work, ($_func));  &init_timer_deferrable(($_work)-> &timer); }  &while (0));
    }' unless defined(&INIT_DELAYED_WORK_DEFERRABLE);
    eval 'sub work_pending {
        my($work) = @_;
	    eval q( &test_bit( &WORK_STRUCT_PENDING,  &work_data_bits($work)));
    }' unless defined(&work_pending);
    eval 'sub delayed_work_pending {
        my($w) = @_;
	    eval q( &work_pending(($w)-> &work));
    }' unless defined(&delayed_work_pending);
    eval 'sub work_clear_pending {
        my($work) = @_;
	    eval q( &clear_bit( &WORK_STRUCT_PENDING,  &work_data_bits($work)));
    }' unless defined(&work_clear_pending);
    if(defined(&CONFIG_LOCKDEP)) {
	eval 'sub __create_workqueue {
	    my($name, $singlethread, $freezeable) = @_;
    	    eval q(({  &static \'struct lock_class_key\'  &__key;  &const \'char\' * &__lock_name;  &if ( &__builtin_constant_p($name))  &__lock_name = ($name);  &else  &__lock_name = $name;  &__create_workqueue_key(($name), ($singlethread), ($freezeable), & &__key,  &__lock_name); }));
	}' unless defined(&__create_workqueue);
    } else {
	eval 'sub __create_workqueue {
	    my($name, $singlethread, $freezeable) = @_;
    	    eval q( &__create_workqueue_key(($name), ($singlethread), ($freezeable),  &NULL,  &NULL));
	}' unless defined(&__create_workqueue);
    }
    eval 'sub create_workqueue {
        my($name) = @_;
	    eval q( &__create_workqueue(($name), 0, 0));
    }' unless defined(&create_workqueue);
    eval 'sub create_freezeable_workqueue {
        my($name) = @_;
	    eval q( &__create_workqueue(($name), 1, 1));
    }' unless defined(&create_freezeable_workqueue);
    eval 'sub create_singlethread_workqueue {
        my($name) = @_;
	    eval q( &__create_workqueue(($name), 1, 0));
    }' unless defined(&create_singlethread_workqueue);
}
1;
